<?php

include 'name_value.php';

class Configure extends DOMDocument{

	function configureXml($clxFile,$idlist){
		$doc = new DOMDocument();
		$doc->load($clxFile);

		$options = $doc->getElementsByTagName("option");
		$post = array();
		$index = 0;

		foreach ($options as $option){
			$post[$index] = Configure::getNameValue($option,$idlist,'');
			$index++;
		}

		$doc = Configure::makeXml($post);
		return $doc->saveXml();
	}

	function getNameValue($option,$idlist,$sufix){
		$type = $option->getAttribute('type');
		switch($type){
			case 'array':
				$name = $option->getElementsByTagName("title")->item(0)->nodeValue;
				$arrayNum = (int)$idlist->getPOST($name.$sufix);

				$value = array();
				$index = 0;

				$atributes = $option->getElementsByTagName("atribute");
				for($i = 0; $i < $arrayNum; $i++){
					$tmp = array();
					foreach ($atributes as $atribute){
						$tmp[$index] = Configure::getNameValue($atribute,$idlist,$i);
						$index++;
					}
					$index = 0;
					$value[$i] = new name_value($i, $tmp,'index');
				}
				break;
			case 'option':
				$name = $option->getElementsByTagName("name")->item(0)->nodeValue;
				$value = $idlist->getPOST($name.$sufix);
				break;
			case 'int':
				$name = $option->nodeValue;
				$value =$idlist->getPOST($name.$sufix);
				break;
			case 'Boolean':
				$name = $option->nodeValue;
				$value = $idlist->getPOST($name.$sufix);
				if($value){
					$value = 'true';
				}else{
					$value = 'false';
				}
				break;
			case 'intBoolean':
				$name = $option->nodeValue;
				$value = $idlist->getPOST($name.$sufix);
				if($value){
					$value = 1;
				}else{
					$value = 0;
				}
				break;
			case 'radio':
				$name = $option->nodeValue;
				$value = $idlist->getPOST($name);
				break;
			case 'Path':
				$name = $option->nodeValue;
				$value = $idlist->getPOST($name);
				$value = Configure::checkSlash($value);
				break;
			default:
				$name = $option->nodeValue;
				$value = $idlist->getPOST($name.$sufix);
				break;
		}
		$result = new name_value($name,$value,$type);
		return $result;
	}

	function makeXml($post){
		$doc = new DomDocument('1.0');
		$root = $doc->createElement('constants');
		$root = $doc->appendChild($root);

		Configure::name_valueXml($post, $doc,$root,'constant','array');
		return $doc;
	}

	function name_valueXml($post,$doc,$root,$sub_label,$array_label){

		for($i=0; $i < count($post); $i++){
			if(!is_array($post[$i]->getValue())){
				$occ = $doc->createElement($sub_label);
				$occ = $root->appendChild($occ);
				$ooc = $occ->setAttribute('name',$post[$i]->getName());
				$ooc = $occ->setAttribute('type',$post[$i]->getType());

				$value = $doc->createTextNode($post[$i]->getValue());
				$value = $occ->appendChild($value);


			}else{
				$occ = $doc->createElement($array_label);
				$occ = $root->appendChild($occ);
				$ooc = $occ->setAttribute('name',$post[$i]->getName());
				$ooc = $occ->setAttribute('type',$post[$i]->getType());

				$value = $doc->createTextNode(Configure::name_valueXml($post[$i]->getValue(),$doc,$occ,'value','index'));
				$value = $occ->appendChild($value);
			}
		}
	}

	function checkSlash($string){
		$last = strripos($string, "/");		
		if(strlen($string) != $last+1){
			return $string.'/';
		}else{
			return $string;
		}		
	}
	
	function printThings($array,$handle,$prefix){
		for($i=0; $i < count($array);$i++){
			$name = $array[$i]->getName();
			$value = $array[$i]->getValue();

			if(is_array($value)){
				fwrite($handle,$prefix.$name."\n");
				Configure::printThings($value, $handle, "	".$prefix);
			}else{
				fwrite($handle,$prefix.$name." ".$value."\n");
			}
		}
	}
}

?>
