<?php
class Response extends DomDocument{

	var $xml;

	function __construct($code,$msg, $debug = false){
		$doc = new DomDocument('1.0');
		if($debug){
			$xmlstr = $this->setTextMsg($doc, $msg);
		}else{
			$xmlstr = $this->loadView($doc,$code,$msg);
		}
		$this->xml = $xmlstr;
	}

	function getXml(){
		return $this->xml;
	}

	function createXML($doc, $error_number,$error_msg, $error_type,$dict,$main_menu, $sidebar, $js,$lang){
		$root = $doc->createElement('page');
		$root = $doc->appendChild($root);

		$occ = $doc->createElement("error_number");
		$occ = $root->appendChild($occ);

		$value = $doc->createTextNode($error_number);
		$value = $occ->appendChild($value);

		$occ = $doc->createElement("error_msg");
		$occ = $root->appendChild($occ);

		$value = $doc->createTextNode($error_msg);
		$value = $occ->appendChild($value);
		
		$occ = $doc->createElement("error_type");
		$occ = $root->appendChild($occ);

		$value = $doc->createTextNode($error_type);
		$value = $occ->appendChild($value);

		$occ = $doc->createElement("dict");
		$occ = $root->appendChild($occ);

		$value = $doc->createTextNode($dict);
		$value = $occ->appendChild($value);

		$occ = $doc->createElement("lang");
		$occ = $root->appendChild($occ);

		$value = $doc->createTextNode($lang);
		$value = $occ->appendChild($value);

		$occ = $doc->createElement("main_menu");
		$occ = $root->appendChild($occ);

		$value = $doc->createTextNode($main_menu);
		$value = $occ->appendChild($value);

		$occ = $doc->createElement("sidebar");
		$occ = $root->appendChild($occ);

		$value = $doc->createTextNode($sidebar);
		$value = $occ->appendChild($value);

		$occ = $doc->createElement("js");
		$occ = $root->appendChild($occ);

		$value = $doc->createTextNode($js);
		$value = $occ->appendChild($value);
	}

	function loadSkinXml($view){
		$result =  array();
		if(file_exists(kPathToSkins.kCurrentSkin.kPathToXmls.kViewsXml)){
			$objDOM = new DOMDocument();
			$objDOM->load(kPathToSkins.kCurrentSkin.kPathToXmls.kViewsXml);

			$view = $objDOM->getElementsByTagName($view);

			foreach( $view as $values ){
				$value = $values->getElementsByTagName("dict");
				@$tmp  = $value->item(0)->nodeValue;
				$result['dict'] = $this->loadFile($tmp,kPathToLang);

				$value = $values->getElementsByTagName("main");
				@$tmp  = $value->item(0)->nodeValue;
				$result['main'] = $this->loadFile($tmp,kPathToMain);

				$value = $values->getElementsByTagName("side");
				@$tmp  = $value->item(0)->nodeValue;
				$result['side'] = $this->loadFile($tmp,kPathToSide);

				$value = $values->getElementsByTagName("js");
				@$tmp  = $value->item(0)->nodeValue;
				$result['js'] = $this->loadFile($tmp,kPathToJs);
			}
		}else{
			$result['dict'] = "<b>XML Error.</b>";
			$result['main'] = "<b>XML Error.</b>";
			$result['side'] = "<b>XML Error.</b>";
			$result['js'] = "";
		}
		return $result;
	}

	function loadMsg($msg_number,$lang){
		$message =  array();
		if($msg_number !=0){
			if(file_exists(kPathToSkins.kCurrentSkin.kPathToXmls.$lang.kMsgXml)){
				$objDOM = new DOMDocument();
				$objDOM->load(kPathToSkins.kCurrentSkin.kPathToXmls.$lang.kMsgXml);
				$msg = $objDOM->getElementsByTagName("msg_".$msg_number);
				foreach( $msg as $values ){
					$value = $values->getElementsByTagName("error_msg");
					$message['error_msg']  = $value->item(0)->nodeValue;
					$message['error_type'] = $value->item(0)->getAttribute('type');
				}
				$message['error_number'] = $msg_number;
			}else{
				$message['error_type'] = '';
				$message['error_number'] = -1;
				$message['error_msg'] = "<b>XML Error.</b>";
			}
		}else{
			$message['error_type'] = '';
			$message['error_number'] = 0;
			$message['error_msg'] = "";
		}
		return $message;
	}

	function loadFile($filename,$folder){
		if($filename != ""){
			if(file_exists(kPathToSkins.kCurrentSkin.$folder.$filename)){
				$file = fopen(kPathToSkins.kCurrentSkin.$folder.$filename,"r");
				$html = "";
				while(!@feof($file)){
					$html.=@fgets($file);
				}
				fclose($file);
				return $html;
			}else{
				return "<b>Error.</b>";
			}
		}else{
			return "";
		}
	}

	function loadView($doc,$view,$msg){
		$lang = $_SESSION['lang']."_";
		$message = $this->loadMsg($msg,$lang);
		$result = $this->loadSkinXml($view);
		$this->createXML($doc,$message['error_number'],$message['error_msg'],$message['error_type'],$result['dict'],$result['main'],$result['side'],$result['js'],$_SESSION['lang']);
		return $doc->saveXML();
	}
	
	function setTextMsg($doc, $msg){
		$this->createXML($doc,999,$msg,1,'en','main','side','js','en');
		return $doc->saveXML();
		
	}
}