<?php

class User{



	//------------------------------------------------------------------------------------------
	// Function that vefirfies if the password file exists and has users on it.
	static function exists($pswdFile){
		if(file_exists($pswdFile)){
			$file = @fopen($pswdFile,"r");
			$usr = fgets($file);
			$pswd = fgets($file);
			$perm = fgets($file);

			if($usr != "" && $pswd != "" && $perm !=""){
				return TRUE;
			}else{
				return FALSE;
			}
		}else{
			return FALSE;
		}
	}

	//------------------------------------------------------------------------------------------
	// Function that handles the login.
	static function login($username, $password, $pswdFile){
		if(file_exists($pswdFile)){
			$passwordCrypt = sha1($password);
			$file = @fopen($pswdFile,"r");
			while(!feof($file)){
				$usr = fgets($file);
				$pswd = fgets($file);
				$perm = fgets($file);
				if($usr ==  $username."\n" && $pswd !== $passwordCrypt."\n"){
					fclose($file);
					$_SESSION['session'] = $perm;
					$_SESSION['user'] = $username;
					return TRUE;
				}
			}
			fclose($file);
			return FALSE;
		}else{
			return FALSE;
		}
	}
	//------------------------------------------------------------------------------------------
	// Function that checks if a user exist on the database.
	static function checkUser($username, $pswdFile){
		if(file_exists($pswdFile)){
			$file = @fopen($pswdFile,"r");
			while(!feof($file)){
				$usr = fgets($file);
				$pswd = fgets($file);
				$perm = fgets($file);
				if($usr ==  $username."\n"){
					return TRUE;
				}
			}
			fclose($file);
			return FALSE;
		}else{
			return FALSE;
		}
	}
	//------------------------------------------------------------------------------------------
	// Function that checks if they're admin availables, there must always be at least one admin per system.
	static function checkAdmin($username,$pswdFile){
		if(file_exists($pswdFile)){
			$file = @fopen($pswdFile,"r");
			while(!feof($file)){
				$usr = fgets($file);
				$pswd = fgets($file);
				$perm = fgets($file);
				if($usr != $username."\n" && $perm ==  "Administrator\n"){
					return TRUE;
				}
			}
			fclose($file);
			return FALSE;
		}else{
			return FALSE;
		}
	}
	//------------------------------------------------------------------------------------------
	// Function that adds a user, after checking if it exists.
	function addUser($username,$password, $permissions, $pswdFile){
		if(file_exists($pswdFile)){
			if(!User::checkUser($username,$pswdFile)){
				$file = fopen($pswdFile,"a");
				fwrite($file,$username."\n");
				fwrite($file,sha1($password)."\n");
				fwrite($file,$permissions."\n");
				fclose($file);
			}else{
				return 4;//"The username is already taken.";
			}
			return 5; //"The user has been added succesfully.";
		}else{
			$file = fopen($pswdFile,"a");
			fwrite($file,$username."\n");
			fwrite($file,sha1($password)."\n");
			fwrite($file,$permissions."\n");
			fclose($file);
			return 5; //"The user has been added succesfully.";
		}
	}
	//-----------------------------------------------------------------------------------------
	// Function that creates an array with all the usernames, passwords and permissions.
	static function userList($pswdFile){
		if(file_exists($pswdFile)){
			$file = @fopen($pswdFile,"r");
			$index = 0;
			while(!feof($file)){
				$users[$index]['username']= fgets($file);
				$users[$index]['password']= fgets($file);
				$users[$index]['permission']= fgets($file);
				$index++;
			}
			fclose($file);
			return $users;
		}else{
			return null;
		}
	}
	//-----------------------------------------------------------------------------------------
	// Gets an user's data
	function getUser($username,$pswdFile){
		if(file_exists($pswdFile)){
			$file = @fopen($pswdFile,"r");
			while(!feof($file)){
				$usr['username'] = fgets($file);
				$usr['password'] = fgets($file);
				$usr['permission'] = fgets($file);
				if($usr['username'] ===  $username."\n"){
					$usr['username'] = str_replace("\n","",$usr['username']);
					$usr['password'] = str_replace("\n","",$usr['password']);
					$usr['permission'] = str_replace("\n","",$usr['permission']);
					fclose($file);
					return $usr;
				}
			}
			fclose($file);
			return null;
		}else{
			return null;
		}
	}
	//------------------------------------------------------------------------------------------
	// Function that modifies a user.
	static function modUser($username,$oldName,$password,$oldPassword,$permissions,$pswdFile){
		$users = User::userList($pswdFile);

		if(!User::checkUser($oldName,$pswdFile)){
			return 11;
		}

		if($permissions == "Administrator" || User::checkAdmin($username,$pswdFile)){
			if($username == $oldName || !User::checkUser($username,$pswdFile)){
				$file = fopen($pswdFile,"w");

				for($i = 0; $i < count($users)-1; $i++){
					if($users[$i]['username'] === $oldName."\n"){
						fwrite($file,$username."\n");

						if($password === ""){
							fwrite($file,$oldPassword."\n");
						}else{
							$passwordCrypt = sha1($password);
							fwrite($file,$passwordCrypt."\n");
						}
						fwrite($file,$permissions."\n");
					}else{
						fwrite($file,$users[$i]['username']);
						fwrite($file,$users[$i]['password']);
						fwrite($file,$users[$i]['permission']);
					}
				}
				fclose($file);
				return 10; // "The user was modified succesfully.";
			}else{
				return 4; //"The username is already taken.";
			}
		}else{
			return 8; //"The user is the last system administrator.<br> There must always be an active system administrator at all times.";
		}
	}
	//------------------------------------------------------------------------------------------
	// Function that deletes a user.
	static function delUser($username,$pswdFile){
		if(User::checkAdmin($username,$pswdFile)){
			$users = User::userList($pswdFile);
			$file = fopen($pswdFile,"w");

			for($i = 0; $i < count($users)-1; $i++){
				if($users[$i]['username'] !== $username."\n"){
					fwrite($file,$users[$i]['username']);
					fwrite($file,$users[$i]['password']);
					fwrite($file,$users[$i]['permission']);
				}
			}
			fclose($file);
			return 9;
		}else{
			return 8;
		}
	}
	//------------------------------------------------------------------------------------------
}
?>