<?php

/**
 * Report Page
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-10-11 11:58:25 +0000 (Tue, 11 Oct 2016) $
 * @version        $Rev: 8797 $
 * @package		Clientix.Classes.Report
 * @abstract		Abstract Class
 */
class clx_report_page {

    private $header;
    private $panels;
    private $footer;
    public $no_panels;
    private $ln_header = CLX_INIT_ZERO;
    private $ln_header_post = CLX_NUM_8;
    private $pageBreak_boolean = true;
    private $pageBreak_margin = CLX_NUM_20;
    private $marginL = CLX_NUM_15;
    private $marginR = CLX_NUM_15;
    private $marginLHeader = CLX_NUM_15;
    private $marginRHeader = CLX_NUM_15;
    private $marginLFooter = CLX_NUM_15;
    private $marginRFooter = CLX_NUM_15;
    private $marginT = CLX_NUM_ZERO;
    private $freeze;
    private $freeze_num;
    var $name;
    private $num_page;

    function __construct($name = 'Sheet') {
        $this->header = array();
        $this->footer = array();
        $this->panels = array();
        $this->no_panels = count($this->panels);
        $this->name = $name;
        $this->num_page = array('view' => false,
		  'word_before' => '',
		  'word_after' => '',
		  'nb' => false,
		  CLX_PROP_ALIGN => 'C',
		  'font' => 'Arial',
		  'style' => '',
		  'size' => '11',
		  'position' => -CLX_NUM_TEN);
    }

    function setNumPage($boolean, $word_before = '', $word_after = '', $nb = false, $align = 'C', $font = 'Arial', $style = '', $size = CLX_NUM_11, $position = -CLX_NUM_TEN) {
        $this->num_page = array('view' => $boolean,
		  'word_before' => $word_before,
		  'word_after' => $word_after,
		  'nb' => $nb,
		  CLX_PROP_ALIGN => $align,
		  'font' => $font,
		  'style' => $style,
		  'size' => $size,
		  'position' => $position
        );
    }

    function getNumPage() {
        return $this->num_page;
    }

    function setHeader(clx_report_data $header) {
        $this->header[] = $header;
    }

    function getHeader($header_no = CLX_NUM_ZERO) {
        return $this->header[$header_no];
    }

    function getHeaders() {
        return $this->header;
    }

    function getPanels() {
        return $this->panels;
    }

    function getFooter($footer_no = CLX_NUM_ZERO) {
        return $this->footer[$footer_no];
    }

    function getFooters() {
        return $this->footer;
    }

    function setFooterPage(clx_report_data $footer) {
        $this->footer[] = $footer;
    }

    function addPanel(clx_report_panel $panel) {
        $this->panels[] = $panel;
        $this->no_panels = count($this->panels);
    }

    function setLnHeader($ln = CLX_NUM_ZERO, $ln_post = CLX_NUM_8) {
        $this->ln_header = $ln;
        $this->ln_header_post = $ln_post;
    }

    function getLnHeader() {
        return array('ln_header' => $this->ln_header, 'ln_header_post' => $this->ln_header_post);
    }

    function setAutoPage($boolean = true, $margin = CLX_NUM_TWO) {
        $this->pageBreak_boolean = $boolean;
        $this->pageBreak_margin = $margin;
    }

    function getAutoPage() {
        return array('boolean' => $this->pageBreak_boolean, 'margin' => $this->pageBreak_margin);
    }

    function setMargin($data) {
        $seccion = $data[CLX_NUM_ZERO];
        $left = $data[CLX_NUM_ONE];
        $right = (empty($data[CLX_NUM_TWO])) ? 'C' : $data[CLX_NUM_TWO];
        switch ($seccion) {
		  case 'C'://Cuerpo
			 $this->marginL = $left;
			 $this->marginR = $right;
			 break;
		  case 'H'://Header
			 $this->marginLHeader = $left;
			 $this->marginRHeader = $right;
			 break;
		  case 'F'://Footer
			 $this->marginLFooter = $left;
			 $this->marginRFooter = $right;
			 break;
		  default:
			 break;
        }
    }
    function getMargin() {
        return array('margin_left' => $this->marginL, 'margin_right' => $this->marginR, 'margin_left_header' => $this->marginLHeader, 'margin_right_header' => $this->marginRHeader, 'margin_left_footer' => $this->marginLFooter, 'margin_right_footer' => $this->marginRFooter);
    }

    function setMarginLeft($margin){
         $this->marginL = $margin;
    }
    function setMarginTop($margin) {
	$this->marginT = $margin;
    }

    function getMarginTop() {
	return $this->marginT;
    }

    function freeze($freeze, $num) {
        //freeze permite 'row' 'col'
        if ($freeze === 'row')
		  $this->freeze = CLX_INIT_ZERO;
        elseif ($freeze === 'col')
		  $this->freeze = CLX_NUM_ONE;
        else
		  return;
        $this->freeze_num = $num;
    }

    function getFreeze() {
        return array('freeze' => $this->freeze, 'freeze_num' => $this->freeze_num);
    }

}
