<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-02-03 08:38:47 -0500 (Wed, 03 Feb 2016) $
 * @version        $Rev: 7778 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
/*
  Record of changes 			Desarrollo del cambio en la estructura del archivo de entrada y la nueva forma de procesar de acuerdo a los requerimientos del BT
 */
class fidu_investments_interfase extends fidu_investments {

    var $contents;
    var $sw_approve_activities = true;
    var $o_clx_file;
    var $import_folder = 'clxftp/inve/'; //INAT_INTERFASE_IMP_DIR
    var $a_process_parameters;
    var $inimname;
    var $batch_id;
    var $record_id;
    var $debug = false;
    var $username;
    var $lang;

    function __construct($parameters = null) {
        if (!empty($this->debug))
		  $this->echoLog('Investments Interfase started');
        define('INAT_IMPORT_ERRFILE_EXT', '.log');
        parent::fidu_investments();
        $this->import_folder = companyParameter('INAT_INTERFASE_IMP_DIR');
        if (empty($this->import_folder)) {
		  $this->import_folder = kPathToWebSite . 'temp/';
        }
        $this->inimname = TableName('INIM');
        if ($parameters != null) {
		  $this->a_process_parameters = $parameters;
		  if (!empty($this->debug)) {
			 echoLog(print_r($this->a_process_parameters, true) . '<br>BATCH_ID=' . $this->batch_id . '<br>');
		  }
        }
    }

    /**
     * SAP Interfase
     * Investments activities import - entry point method
     */
    function inat_import($filename = null) {
        if ($filename != null) {
		  // If the parameter has passed, executes the import process directly, assuming that it's an automatic process between systems
		  ClxFreeReturn($this->inat_import_doitnow($filename));
        } else {
		  // Ask the user for the import file location
		  $ac = UserRequest::$request['ac'];
		  $this->inat_import_action($ac);
        }
    }

    /**
     * SAP Interfase
     * Function will extract the flat file and load it into INAT
     */
    function inat_import_doitnow($filename) {
        if (!class_exists('inve_utilities'))
		  includeCodeLib('INUT');
        if (!function_exists('setCreationData'))
		  includeCodeLib('GEN_REC_UTIL');
        if (!class_exists('clx_file_delimited'))
		  require_once kPathToWebSite . 'classes/clx_file_delimited.php';
        // If the filename not found, takes it from the form
        $this->echoLog('<br><br>' . dict('GEN_LBL_LOT') . ':' . $this->batch_id . '<br>');
        // Verifies the input file existance
        $this->echoLog('File:' . $filename);
        if (file_exists($filename)) {
		  /*
		   * GEN_ERR_FILE_FOUND
		   * File found: ^1
		   * Archivo encontrado: ^1
		   */
		  $this->echoLog(dict('GEN_ERR_FILE_FOUND', $filename));
        } else {
		  /*
		   * GEN_ERR_FILE_NOTFOUND
		   * File not found: ^1
		   * Archivo no fue encontrado: ^1
		   */
		  $this->echoLog(dict('GEN_ERR_FILE_NOTFOUND', $filename));
		  return false;
        }
        $o_logfile_mngr = new clx_logfile_mngr($this->inat_import_log_filename($filename));
        if ($o_logfile_mngr->error) {
		  $this->echoLog($o_logfile_mngr->errorMsg);
		  return false;
        }
        $this->o_inut = new fidu_investments();
        $sw_error = false;
        if ($sw_error == false) {
		  $this->o_clx_file = new clx_file_delimited($filename, CLX_CHAR_NL, CLX_CHAR_TAB);
		  $i_line_counter = CLX_INIT_ZERO;
		  $b_header_line_read = false;
		  $record_first_line = null;
		  while ($line = $this->o_clx_file->getNextRecord()) {
			 $i_line_counter++;
			 if (!empty($this->debug))
			     $this->echoLog('<b>' . $i_line_counter . ' --&gt;' . $line . '&lt;--</b><br>');
			 // skips blank lines
			 $line = $this->o_clx_file->delete_ending_crlf($line);
			 if (trim($line) !== '') {
			     if (empty($b_header_line_read)) {
			         // Set the first line read flag
			         $b_header_line_read = true;
			         // Read the first line
			         $record_first_line = $this->inat_import_read_line_into_record_array_header($line);
			         // Initialices ending validations accumulators
			         $record_first_line['line_counter_noblanks'] = CLX_INIT_ZERO;
			         $record_first_line['n_total_invest_amt'] = CLX_INIT_ZERO;
			     } else {
			         // Read further lines
			         $record = $this->inat_import_read_line_into_record_array($line);
			         $record_first_line['line_counter_noblanks'] ++;
			         $record_first_line['n_total_invest_amt'] = bcadd($record_first_line['n_total_invest_amt'], $record['INVEST_AMT']);
			         /*
					* CODE_MSG_INATIMPRT_RECINFO
					* Line ^1) Deal Ticket # ^2 - Investment Activity: ^3.
					* L�nea ^1) Deal Ticket: ^2 - Tipo de Actividad: ^3.
					*/
			         $s_record_data_to_show = '<br>' . dict('CODE_MSG_INATIMPRT_RECINFO', $i_line_counter, $record['DEAL_TICKET_NO'], $record['INVEST_ACTIVITY']) . ' ';
			         
			         $record['TRANS_STATUS'] = 'PEND'; // PEND
			         // Aditional calculus NOT IMPLEMENTED
			         // Other field fixes
			         $this->inat_import_oth_fld_fix($record);
			         // INIM record creation
			         $record = $this->inat_import_inim_rec_creation($record);
			         // Validates the record
			         $ar_response = $this->inat_import_validations($record, $s_record_data_to_show);
			         if (!empty($ar_response['error'])) {
					   // Errors found...
					   if (!empty($this->debug))
						  $this->echoLog('CON ERRORES');
					   $o_logfile_mngr->write($ar_response['errormsg']);
					   if ($o_logfile_mngr->error) {
						  $this->echoLog($o_logfile_mngr->errorMsg);
					   }
					   $sw_error = true;
			         } else {
					   // Everything is Ok
					   if (!empty($this->debug))
						  $this->echoLog('SIN ERRORES');
					   /*
					    * CODE_MSG_INATIMPRT_RECSTATUS
					    * ^1 = OK. Assigned Code: ^2
					    * ^1 = OK. C�digo asignado: ^2
					    */
					   $this->echoLog(dict('CODE_MSG_INATIMPRT_RECSTATUS', $s_record_data_to_show, $this->record_id));
			         }
			     }
			 }
		  }
		  $this->o_clx_file->close();
		  // Ending validations
		  $ar_response = $this->inat_import_ending_validations($record_first_line);
		  if ($ar_response['error'] === true) {
			 // Errors found...
			 if (!empty($this->debug))
			     $this->echoLog('CON ERRORES');
			 $o_logfile_mngr->write($ar_response['errormsg']);
			 if ($o_logfile_mngr->error) {
			     $this->echoLog($o_logfile_mngr->errorMsg);
			 }
			 $sw_error = true;
		  }
		  if ($sw_error === true) {
			 // If there's any error, All lines must have error flag 'on' to identify header or lines error
			 $sql = 'UPDATE ' . $this->inimname . '  SET REC_STATUS = ' . singleQuote('ERRO') . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
			 ClxCommon::$db->executeQuery($sql);
			 /*
			  * CODE_MSG_INATIMPRT_ERRFOUND
			  * Errors found. Please check process exceptions section
			  * Se encontraron errores. Revise la secci�n de Excepciones de Procesos
			  */
			 $this->echoLog(dict('CODE_MSG_INATIMPRT_ERRFOUND'));
		  }
        }
        if (!empty($this->debug))
		  $this->echoLog('Investments endded');
        $o_logfile_mngr->close();
        // Removes the original file
        unlink($filename);
    }

    /*
     * Creates INIM record
     */

    function inat_import_inim_rec_creation($record) {
        // Creates record
        $this->record_id = ClxCommon::$db->createRecord($this->inimname, $record, false);
        return $record;
    }

    /*
     * Validates de whole file. Returns error flag and error messages
     */

    function inat_import_validate_whole_file($line) {
        //DE DONDE VIENE FIELNAME?
        $this->o_clx_file = new clx_file_delimited($filename, CLX_CHAR_NL, CLX_CHAR_TAB);
        $i_line_counter = CLX_INIT_ZERO;
        $sw_error = false;
        $contents = '';
        while ($line = $this->o_clx_file->getNextRecord()) {
		  $i_line_counter++;
		  if ($line === '')
			 continue; // skips blank lines
		  $record = $this->inat_import_read_line_into_record_array($line);
		  // Import Validations
		  $ar_response = $this->inat_import_validations($record, $i_line_counter);
		  if ($ar_response['error'] === true) {
			 $sw_error = true;
			 $contents .= $ar_response['errormsg'];
		  }
        }
        $this->o_clx_file->close();
        return array('error' => $sw_error,
		  'errormsg' => $contents
        );
    }

    /**
     * Returns record array from the FIRST line (HEADER)
     */
    function inat_import_read_line_into_record_array_header($line) {
        //e cho 'Line:' . $line.'<br>';
        $line = $this->o_clx_file->toArray($line);
        $record = array();
        $record['FILE_ID'] = trim($line[CLX_NUM_ZERO]);
        $record['EFFTDATE'] = $line[CLX_NUM_ONE];
        $record['TOTAL_AMT'] = $line[CLX_NUM_TWO];
        $record['TOTAL_RECS'] = $line[CLX_NUM_THREE];
        //FJSH - agregado el batch id de fuente
        if ($record['FILE_ID'] === '') {
		  $this->batch_id = $this->generate_batch_id();
        } else {
		  $this->batch_id = $record['FILE_ID'];
        }
        if (!empty($this->debug))
		  $this->contents .= debug_dump('Encabezado Registro', $record);
        return $record;
    }

    /**
     * Returns record array from the line
     */
    function inat_import_read_line_into_record_array($line) {
        //e cho 'Line:' . $line.'<br>';
        $line = $this->o_clx_file->toArray($line);
        $record = array();
        $record['DEAL_TICKET_NO'] = $line[CLX_NUM_ZERO];
        $record['EFFTDATE'] = $line[CLX_NUM_ONE];
        $record['INVESTPROD_CODE'] = $line[CLX_NUM_TWO];
        $record['SEC_ISSUER'] = $line[CLX_NUM_THREE];
        $record['INVEST_ACTIVITY'] = $line[CLX_NUM_FOUR];
        $record['CURRENCY_CODE'] = $line[CLX_NUM_FIVE];
        $record['UNIT_PRICE'] = $this->inat_import_cnv_number($line[CLX_NUM_SIX]);
        $record['INVESTMENT_CODE'] = $line[CLX_NUM_7];
        $record['ISSUE_DATE'] = $line[CLX_NUM_8];
        $record['MATURITY_DATE'] = $line[CLX_NUM_NINE];
        $record['INTEREST_TYPE'] = $line[CLX_NUM_TEN];
        $record['COUPON_RT'] = $this->inat_import_cnv_number($line[CLX_NUM_11]);
        $record['INTEREST_CALC'] = $line[CLX_NUM_12];
        $record['INV_PERIOD'] = $line[CLX_NUM_13];
        $record['PAYMENT_FREQ'] = $line[CLX_NUM_14];
        $record['TRANS_STATUS'] = $line[CLX_NUM_15];
        $record['SHARES'] = $this->inat_import_cnv_number($line[CLX_NUM_16]);
        $record['TAX_AMT'] = $this->inat_import_cnv_number($line[CLX_NUM_17]);
        $record['INVEST_AMT'] = $this->inat_import_cnv_number($line[CLX_NUM_18]);
        $record['TRANS_FEES'] = $this->inat_import_cnv_number($line[CLX_NUM_19]);
        $record['BASE_INVEST_AMT'] = $this->inat_import_cnv_number($line[CLX_NUM_20]);
        $record['FACE_VALUE'] = $this->inat_import_cnv_number($line[CLX_NUM_21]);
        $record['PURCHASE_PRICE'] = $this->inat_import_cnv_number($line[CLX_NUM_22]);
        $record['SELL_PRICE'] = $this->inat_import_cnv_number($line[CLX_NUM_23]);
        $record['PREMIUM_AMT'] = $this->inat_import_cnv_number($line[CLX_NUM_24]);
        $record['DISCOUNT_AMT'] = $this->inat_import_cnv_number($line[CLX_NUM_25]);
        $record['EMISSION_NO'] = $line[CLX_NUM_26];
        $record['EARNED_INTEREST_AMT'] = $this->inat_import_cnv_number($line[CLX_NUM_27]);
        $record['BOOK_VALUE'] = $this->inat_import_cnv_number($line[CLX_NUM_28]);
        $record['TRANS_SOURCE'] = 'IN'; // Interface (IN)
        $this->contents .= debug_dump('Registro', $record);
        return $record;
    }

    /**
     * Returns the form's especified filename
     */
    function inat_import_filename() {
        if (empty(UserRequest::$post['INAT_IMPORT_localfile'])) {
		  $filename_tmp = UserRequest::$files['INAT_IMPORT_uploadfile']['tmp_name'];
		  $filename = $this->import_folder . UserRequest::$files['INAT_IMPORT_uploadfile']['name'];
		  if (!move_uploaded_file($filename_tmp, $filename))
			 addMessage(dict('GEN_ERR_UPLOADFAIL'));
        } else {
		  $filename = UserRequest::$post['INAT_IMPORT_localfile'];
        }
        return $filename;
    }

    /**
     * Returns the log filename
     */
    function inat_import_log_filename($filename) {
        $s_response = $filename . '_' . adodb_date('Ymd') . '_' . adodb_date('hms') . INAT_IMPORT_ERRFILE_EXT;
        return $s_response;
    }

    /**
     * If the number comes with coma as decimal delimiter, converts it to '.'
     */
    function inat_import_cnv_number($s_chr) {
        $s_chr = str_replace(',', '.', $s_chr);
        $s_chr = str_replace('"', '', $s_chr);
        if ($s_chr === '') {
		  $s_chr = '0.00';
        }
        return $s_chr;
    }

    /**
     * Other field eventual fixes, just to correct missing data with default values
     */
    function inat_import_oth_fld_fix(&$record) {
        if ($record['INVEST_ACTIVITY'] === 'BY') {
		  // Estatus especial para las compras, mientras se asigna o distribuye el monto de la compra
		  // Cuando todo esta asignado se le pondr� estatus IDLE...
		  $record['REC_STATUS'] = 'NOT'; // Detenido
        } else {
		  $record['REC_STATUS'] = 'IDLE';
        }
        $record['BATCH_ID'] = $this->batch_id;
        $record['CREATEDBY'] = '';
        $record['MODIFIEDBY'] = '';
        $record['CDATE'] = '';
        $record['MDATE'] = '';
        $record = setCreationData($record);
        if (!isset($record['COUPON_RT']) || $record['COUPON_RT'] === '') {
		  $record['COUPON_RT'] = CLX_INIT_ZERO;
        }
        if (!isset($record['EARNED_INTEREST_AMT']) || $record['EARNED_INTEREST_AMT'] === '') {
		  $record['EARNED_INTEREST_AMT'] = CLX_INIT_ZERO;
        }
    }

    /**
     * Line validation
     */
    function inat_import_validations(&$record, $i_line_counter) {
        if (!empty($this->debug))
		  $this->echoLog('inat_import_validations');
        $ar_response = array('error' => false,
		  'errormsg' => ''
        );
        //Start Field Validations
        $record['COMMENTS'] = '';
        $record['REC_STATUS'] = 'RUN';
        $msg = array();
        foreach ($record as $field => $field_value) {
		  if (empty($this->file_fields[$field]))
			 $this->file_fields[$field] = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME = ' . singleQuote($field));
		  $fieldinstance = getToolObject('DBFT', $this->file_fields[$field]['FIELDTYPE']);
		  $fieldinstance->validateImportField($msg, $this->file_fields[$field], $field_value);
		  if (!empty($msg[$field])) {
			 /*
			  * GEN_LBL_LOTERRLN
			  * Err. Line
			  * Err. Linea
			  */
			 $emsg = dict('GEN_LBL_LOTERRLN') . ': ' . $i_line_counter . ', ' .
			         dict('GEN_LBL_LOT') . ':' . $record['BATCH_ID'] . ', ' .
			         $field . ':' . $field_value . ', ' . $msg[$field] . CLX_CHAR_CR;
			 $record['COMMENTS'] .= $emsg;
			 $record['REC_STATUS'] = 'ERRO';
			 $this->inat_import_log_write($record, $emsg);
			 $ar_response['error'] = true;
			 $ar_response['errormsg'] .= $emsg . CLX_CHAR_NL;
		  }
        }
        if (!empty($this->debug))
		  $this->echoLog(debug_dump(singleQuote($i_line_counter) . ' - record', $record));
        return $ar_response;
    }

    /**
     * Line validation
     */
    function inat_import_ending_validations($record_first_line) {
        if (!empty($this->debug))
		  $this->echoLog('inat_import_ending_validations');
        $ar_response = array('error' => false,
		  'errormsg' => ''
        );
        if (rounder($record_first_line['line_counter_noblanks'], CLX_NUM_TWO) != rounder($record_first_line['TOTAL_RECS'], CLX_NUM_TWO)) {
		  /*
		   * CODE_ERR_INATIMPRT_DIFRECCNT
		   * Incorrect specified header lines qty.: ^1 against ^2  that really has the input file
		   * Cantidad de l�neas especificadas en el encabezado son incorrectas: ^1 contra ^2  que realmente vienen en el archivo
		   */
		  $emsg = dict('GEN_LBL_LOT') . ':' . dict('CODE_ERR_INATIMPRT_DIFRECCNT', rounder($record_first_line['TOTAL_RECS'], CLX_NUM_ZERO), rounder($record_first_line['line_counter_noblanks'], CLX_NUM_ZERO)) .
			     CLX_CHAR_CR;
		  $this->inat_import_log_write($record_first_line, $emsg);
		  $ar_response['error'] = true;
		  $ar_response['errormsg'] .= $emsg . CLX_CHAR_NL;
        }
        if (bcadd($record_first_line['n_total_invest_amt'], CLX_NUM_ZERO, CLX_NUM_ZERO) != bcadd($record_first_line['TOTAL_AMT'], CLX_NUM_ZERO, CLX_NUM_ZERO)) {
		  /*
		   * CODE_ERR_INATIMPRT_DIFINVAMT
		   * Incorrect specified header investment total amount: ^1 against ^2  that really has the input file
		   * El total de inversiones especificadas en el encabezado es incorrecto: ^1 contra ^2  que suman en el archivo
		   */
		  $emsg = dict('GEN_LBL_LOT') . ':' . dict('CODE_ERR_INATIMPRT_DIFINVAMT', rounder($record_first_line['TOTAL_AMT'], CLX_NUM_ZERO), rounder($record_first_line['n_total_invest_amt'], CLX_NUM_ZERO)) .
			     CLX_CHAR_CR;
		  $this->inat_import_log_write($record_first_line, $emsg);
		  $ar_response['error'] = true;
		  $ar_response['errormsg'] .= $emsg . CLX_CHAR_NL;
        }
        return $ar_response;
    }

    /*
     * Write the error log file or records
     */

    function inat_import_log_write($record, $emsg) {
        $record = array();
        $record['EFFTDATE'] = getNow('Y-m-d H:i:s');
        $record['RECORDID'] = $this->record_id;
        $record['PROC_STATUS'] = 'ERRO';
        $record['DESCRIPTION'] = $emsg;
        $record['SCHEDULECODE'] = $this->a_process_parameters['SCHEDULECODE'];
        $record['LOG_RECID'] = $this->a_process_parameters['RUNID'];
        $record['TABLECODE'] = 'INIM';
        ClxCommon::$db->createRecordVoid('CLX_PR_EXCEPT_LOGS', $record, false);
    }

    /*
     * Generates lot number ID
     */

    function generate_batch_id() {
        return getNow('Ymd') . '_' . $this->a_process_parameters['RUNID'];
    }

    /**
     * Line error reporting
     */
    function inat_import_displayMessage() {
        $separador = '<LI>';
        $contents = '';
        foreach ($_SESSION['USMSG'] as $key => $value) {
		  switch ($value['type']) {
			 case CLX_CLASS_ALERT:
			     $contents .= $separador . dict('GEN_LBL_ALERT') . ' ' . $value['msg'];
			     break;
			 case 'note':
			     $contents .= $separador . dict('GEN_LBL_NOTE') . ' ' . $value['msg'];
			     break;
			 default:
			     $contents .= $separador . $value['msg'];
			     break;
		  }
		  $separador = '</LI><LI>';
        }
        if ($contents !== '')
		  $contents .= '</LI>';
        return $contents;
    }

    /**
     * Calculates PURCHASE_PRICE, SELL_PRICE, PREMIUM_AMT, DISCOUNT_AMT columns
     */
    function inat_import_inatTotal_v2($record) {
        return $record;
    }

    /**
     * Specific rounding routine used by inat_import_inatTotal_v2().
     * Maybe it's no necesarry unless the process involves implementation
     * of the special math library
     */
    function inat_import_numDec($num, $dig) {
        $n_response = rounder($num, $dig);
        if (!empty($this->debug))
		  $this->echoLog('inat_import_numDec(num=' . $num . ',dig=' . $dig . ',n_response=' . $n_response . ')');
        return $n_response;
    }

    /**
     * Form to get the import filespec, for those cases where it isn') . 't specified as entry point method parameter
     */
    function inat_import_upload_form($record, $msg) {
        // Setup de la forma y campos Hidden
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF'], CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);
        $form->addArgument('idlist', (array_key_exists('idlist', UserRequest::$request) ? UserRequest::$request['idlist'] : ''));
        $form->addArgument('it', (array_key_exists('it', UserRequest::$request)) ? UserRequest::$request['it'] : '');
        $form->addArgument('wind', '1');
        $form->addArgument('confirm', '1');
        $form->setProp('enctype', 'multipart/form-data');
        // Datos que se solicitan
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        /*
         * CODE_MSG_INATIMPRT_TITLE
         * Investments Activities Import
         * Importaci�n de Actividades de Inversi�n
         */
        $table->addCell(dict('CODE_MSG_INATIMPRT_TITLE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('TOOL_PACK_PROMPT_IMPORTEXPLAIN'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!array_key_exists('INAT_IMPORT_localfile', $record))
		  $record['INAT_IMPORT_localfile'] = '';
        if (!array_key_exists('INAT_IMPORT_uploadfile', $record))
		  $record['INAT_IMPORT_uploadfile'] = '';
        $table->addField($msg, dict('TOOL_PACK_PROMPT_FILEONSERVER') . ':', 'INAT_IMPORT_localfile', $record['INAT_IMPORT_localfile'], CLX_NUM_48, CLX_NUM_255);
        $table->addFile($msg, dict('TOOL_PACK_PROMPT_UPLOADFILE') . ':', 'INAT_IMPORT_uploadfile', $record['INAT_IMPORT_uploadfile']);
        // Botones y parte final
        $c = new htmlSubmit(dict('GEN_LBL_IMPORT'), 'PRINT_DIALOG');
        $buttons = $c->source();
        if (strpos(UserRequest::$server['PHP_SELF'], 'pop.php') !== false) {
		  $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
		  $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $this->contents .= $form->source();
    }

    /**
     * Form values validation
     */
    function inat_import_check_upload_form(&$msg) {
        $msg = array();
        if (empty(UserRequest::$post['INAT_IMPORT_localfile'])) {
		  if (UserRequest::$files['INAT_IMPORT_uploadfile']['error']) {
			 $msg['INAT_IMPORT_uploadfile'] = dict('ERR_PACK_FILETOOBIG');
		  }
        } elseif (!file_exists(UserRequest::$post['INAT_IMPORT_localfile'])) {
		  $msg['INAT_IMPORT_localfile'] = dict('GEN_ERR_FILE_NOTFOUND', UserRequest::$post['INAT_IMPORT_localfile']);
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    /**
     * takes action depending of form's values
     */
    function inat_import_action($ac, $filename = null) {
        if (!empty(UserRequest::$post['confirm'])) {
		  $msg = array();
		  if ($this->inat_import_check_upload_form($msg)) {
			 // If the filename not found, takes it from the form
			 $filename = $this->inat_import_filename();
			 $this->scheduleImport($filename);
		  } else {
			 $this->inat_import_upload_form(UserRequest::$post, $msg);
		  }
        } else {
		  if (empty($record))
			 $record = array();
		  if (empty($msg))
			 $msg = array();
		  $this->inat_import_upload_form($record, $msg);
        }
    }

    /**
     * Schedule import process to  inmediate excecution
     */
    function scheduleImport($filename) {
        $s_title = dict('CODE_MSG_INATIMPRT_TITLE');
        $s_process_code = 'IBS_INAT_IMP';
        $ar_pars_2_send = array();
        $ar_pars_2_send['ANYFILE'] = $filename;
        $this->contents = $this->create_proc_sched_sched($s_title, $s_process_code, $ar_pars_2_send);
    }

    /*
     * Schedule process engine program
     */

    function create_proc_sched_sched($s_title, $s_sched_process, $ar_pars, $s_recurrence = 'ONE') {
        $PRSP = getTool('PRSP');
        $PRSC = getTool('PRSC');
        if ($s_title === '')
		  $s_title = ClxCommon::$db->getField($PRSC->tablename, 'IDNAME', 'IDCODE =' . singleQuote($s_sched_process));
        // Parameters values
        foreach ($ar_pars as $s_name => $s_value) {
		  ClxCommon::$db->updateRecord($PRSP->tablename, array('PARAMETER_VALUE' => $s_value), 'FIELDNAME = ' . singleQuote($s_name) . ' AND SCHEDULECODE =' . singleQuote($s_sched_process));
        }
        // Schedule to execute inmediately
        $ar_sched_pars = array();
        if ($s_recurrence !== '')
		  $ar_sched_pars['PR_RECURRENCE'] = $s_recurrence;
        $ar_sched_pars['NEXT_RUN_DATE'] = date('Y-m-d');
        $ar_sched_pars['NEXT_RUN_TIME'] = date('H:i:s');
        ClxCommon::$db->updateRecord($PRSC->tablename, $ar_sched_pars, 'IDCODE =' . singleQuote($s_sched_process));
        // Show a screen telling the user that the process is about to run
        $contents = $this->done_dialog($s_title, dict('GEN_LBL_SCHED_ACTIVITY'));
        return $contents;
    }

    /*
     * End dialog
     */

    function done_dialog($title, $msg) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        $table->addCell($msg, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        return $table->source();
    }

// End method
    /**
     * Punto de entrada a la segunda fase del proceso de interfaz de inversiones
     */
    function inat_import_phase_2() {
        /*
         * CODE_INVEIMP2_LBL_TIT
         * INVESTMENTS INTERFASE: IMPORTED FILE PROCESS
         * INTERFASE DE INVERSIONES: PROCESAMIENTO DEL ARCHIVO IMPORTADO
         */
        return $this->inat_import_phase_2_gen_dialog_handle('IBS_INAT_IMP_2', dict('CODE_INVEIMP2_LBL_TIT'));
    }

    /*
     * Dialog Handler est�ndar para cuando se pide el nro. de lote previo a la ejecuci�n
     * de un item del motor de procesos
     */

    function inat_import_phase_2_gen_dialog_handle($s_process_code, $s_title = null) {
        $this->contents = '';
        $this->lang = clx_language_lower_upper(UserRequest::$request['lan']);
        $this->username = $_SESSION['user_record']['username']; // registered IBS username
        if ($s_title == null) {
		  $s_title = UserRequest::$request['clientix_MenuBar_option'];
        }
        if (!array_key_exists('confirm', UserRequest::$request)) {
		  // Si no se especificaron los par�metros, muestra la pantalla de dialogo que pide los parametros
		  $this->contents = $this->inat_import_phase_2_dialog($s_process_code, $s_title, UserRequest::$request);
        } else {
		  // Valida la forma
		  $msg = $this->inat_import_phase_2_dialog_validation($s_process_code, UserRequest::$request);
		  if (!empty($msg)) {
			 $this->contents = $this->inat_import_phase_2_dialog($s_process_code, $s_title, UserRequest::$request, $msg);
		  } else {
			 $s_lote = (isset(UserRequest::$request['RTBL_BATCH_ID'])) ? UserRequest::$request['RTBL_BATCH_ID'] : '';
			 //Create Process Schedule Schedule
			 $ar_pars_2_send = array();
			 $ar_pars_2_send['BATCH_ID'] = $s_lote;
			 $ar_pars_2_send['LANGUAGE'] = clx_language_lower_upper($this->lang);
			 $ar_pars_2_send['USERNAME'] = $this->username;
			 $this->contents = $this->create_proc_sched_sched($s_title, $s_process_code, $ar_pars_2_send);
		  }
        }
        return $this->contents;
    }

    /*
     * Valida los campos de la forma
     */

    function inat_import_phase_2_dialog_validation($s_process_code, $request) {
        $ar_response = array();
        if (isset($request['RTBL_BATCH_ID']) && $request['RTBL_BATCH_ID'] === '') {
		  /*
		   * GEN_ERR_LOT_FLD_MANDATORY
		   * Lot must be specified
		   * El Lote debe ser especificado
		   */
		  $ar_response['RTBL_BATCH_ID'] = dict('GEN_ERR_LOT_FLD_MANDATORY');
        }
        return $ar_response;
    }

    /*
     * Pantalla que pide el nro. de lote
     */

    function inat_import_phase_2_dialog($s_process_code, $s_title, $record, $msg = null) {
        if ($msg == null)
		  $msg = array();
        // Setup de la forma y campos Hidden
        $form = $this->dialog_form_set($s_title);
        // Datos que se solicitan
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($s_title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!array_key_exists('RTBL_BATCH_ID', $record))
		  $record['RTBL_BATCH_ID'] = '';
        // Lote
        $table->addField($msg, dict(ClxCommon::$db->getField('CLX_DB_FIELDS', 'FIELDFORMLABEL', 'FIELDNAME = ' . singleQuote('BATCH_ID') . '')) . ':', 'RTBL_BATCH_ID', $record['RTBL_BATCH_ID'], CLX_NUM_50, CLX_NUM_255);
        // Botones y parte final
        $c = new htmlSubmit(dict('GEN_LBL_EXECUTE'), 'PRINT_DIALOG');
        $buttons = $c->source();
        if (strpos(UserRequest::$server['PHP_SELF'], 'pop.php') !== false) {
		  $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
		  $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        return $form->source();
    }

    /*
     * Common part of forms generation. Returns the forms object prepared for the battle
     */

    function dialog_form_set($s_title) {
        if (!isset(UserRequest::$request['idlist']))
		  UserRequest::$request['idlist'] = '';
        // Setup de la forma y campos Hidden
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF'], CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);
        $form->addArgument('idlist', UserRequest::$request['idlist']);
        $form->addArgument('it', UserRequest::$request['it']);
        $form->addArgument('clientix_MenuBar_option', $s_title);
        $form->addArgument('wind', '1');
        $form->addArgument('confirm', '1');
        $form->setProp('enctype', 'multipart/form-data');
        return $form;
    }

    /**
     * Local Log
     * @param type $s_out_msg
     */
    function echoLog($s_out_msg) {
        $this->contents .= $s_out_msg . '<BR>';
    }

    /**
     *
     * @return type
     */
    function contents() {
        return $this->contents;
    }

    function source() {
        return $this->contents;
    }

}

define('INIM_PREFIX', 'INIM_');
\define('INAT_PREFIX', 'INAT_');

class fidu_investments_interfase_editor extends fidu_investments_interfase {

    var $inatname;
    var $inimname;
    var $infuname;
    var $debug = false;

    /*
     * Class constructor
     */

    function __construct() {
        // Table names
        multiTableName($this, array('INAT', 'INIM', 'INFU'));
        // For validations
        $this->o_inut = new fidu_investments();
    }

// Method end
    /*
     * INAT_DIST form (assigned as INIM form listing)  on-load event to copy the INIM record data at creation action
     */
    function inat_dist_form_init(&$record, &$msg) {
        if (UserRequest::$request['ac'] === 'CREATE') {
		  $callingpage = peekHistory();
		  $hasparent = (isset($callingpage['parentrecord']));
		  if ($hasparent === true) {
			 $parentrecord = $callingpage['parentrecord'];
			 if (!empty($this->debug)) {
			     $this->echoLog('<br>parentrecord:<br>' .
					   print_r($parentrecord, true));
			 }
			 $ar_response = $this->get_sum_flds(UserRequest::$request['ac'], $parentrecord[INIM_PREFIX . 'BATCH_ID'], $parentrecord[INIM_PREFIX . 'DEAL_TICKET_NO'], $record[INAT_PREFIX . 'IDCODE']
			 );
			 if (!empty($this->debug)) {
			     $this->echoLog('<br>get_sum_flds--ar_response:<br>' .
					   print_r($ar_response, true));
			 }
			 // default values: proposes still unassigned values
			 $inat_row = $ar_response['inat_row'];
			 $total_invest_amt = $parentrecord[INIM_PREFIX . 'INVEST_AMT'] - $inat_row['TOTAL_INVEST_AMT'];
			 $total_gain_amt = $parentrecord[INIM_PREFIX . 'GAIN_AMT'] - $inat_row['TOTAL_GAIN_AMT'];
			 $total_face_value = $parentrecord[INIM_PREFIX . 'FACE_VALUE'] - $inat_row['TOTAL_FACE_VALUE'];
			 $total_earned_interest_amt = $parentrecord[INIM_PREFIX . 'EARNED_INTEREST_AMT'] - $inat_row['TOTAL_EARNED_INTEREST_AMT'];
			 $total_shares = $parentrecord[INIM_PREFIX . 'SHARES'] - $inat_row['TOTAL_SHARES'];
			 $total_tax_amt = $parentrecord[INIM_PREFIX . 'TAX_AMT'] - $inat_row['TOTAL_TAX_AMT'];
			 $total_trans_fees = $parentrecord[INIM_PREFIX . 'TRANS_FEES'] - $inat_row['TOTAL_TRANS_FEES'];
			 // Copia los datos de INIM  en INAT (s�lo en creaci�n)
			 $record[INAT_PREFIX . 'INVESTPROD_CODE'] = $parentrecord[INIM_PREFIX . 'INVESTPROD_CODE'];
			 $record[INAT_PREFIX . 'INVESTPROD_CODE_prim'] = $parentrecord[INIM_PREFIX . 'INVESTPROD_CODE_prim'];
			 $record[INAT_PREFIX . 'INVESTMENT_CODE'] = $parentrecord[INIM_PREFIX . 'INVESTMENT_CODE'];
			 $record[INAT_PREFIX . 'EFFTDATE'] = $parentrecord[INIM_PREFIX . 'EFFTDATE'];
			 $record[INAT_PREFIX . 'ISSUE_DATE'] = $parentrecord[INIM_PREFIX . 'ISSUE_DATE'];
			 $record[INAT_PREFIX . 'MATURITY_DATE'] = $parentrecord[INIM_PREFIX . 'MATURITY_DATE'];
			 $record[INAT_PREFIX . 'INV_PERIOD'] = $parentrecord[INIM_PREFIX . 'INV_PERIOD'];
			 $record[INAT_PREFIX . 'PAYMENT_FREQ'] = $parentrecord[INIM_PREFIX . 'PAYMENT_FREQ'];
			 $record[INAT_PREFIX . 'INVEST_ACTIVITY'] = $parentrecord[INIM_PREFIX . 'INVEST_ACTIVITY'];
			 $record[INAT_PREFIX . 'INVEST_AMT'] = $total_invest_amt;
			 $record[INAT_PREFIX . 'BASE_INVEST_AMT'] = $parentrecord[INIM_PREFIX . 'BASE_INVEST_AMT'];
			 $record[INAT_PREFIX . 'COUPON_RT'] = $parentrecord[INIM_PREFIX . 'COUPON_RT'];
			 $record[INAT_PREFIX . 'SHARES'] = $total_shares;
			 $record[INAT_PREFIX . 'INTEREST_TYPE'] = $parentrecord[INIM_PREFIX . 'INTEREST_TYPE'];
			 $record[INAT_PREFIX . 'UNIT_PRICE'] = $parentrecord[INIM_PREFIX . 'UNIT_PRICE'];
			 $record[INAT_PREFIX . 'INTEREST_CALC'] = $parentrecord[INIM_PREFIX . 'INTEREST_CALC'];
			 $record[INAT_PREFIX . 'TRANS_FEES'] = $total_trans_fees;
			 $record[INAT_PREFIX . 'PREMIUM_AMT'] = $parentrecord[INIM_PREFIX . 'PREMIUM_AMT'];
			 $record[INAT_PREFIX . 'DISCOUNT_AMT'] = $parentrecord[INIM_PREFIX . 'DISCOUNT_AMT'];
			 $record[INAT_PREFIX . 'FACE_VALUE'] = $total_face_value;
			 $record[INAT_PREFIX . 'SERIES_FROM'] = $parentrecord[INIM_PREFIX . 'SERIES_FROM'];
			 $record[INAT_PREFIX . 'SERIES_TO'] = $parentrecord[INIM_PREFIX . 'SERIES_TO'];
			 $record[INAT_PREFIX . 'TAX_AMT'] = $total_tax_amt;
			 $record[INAT_PREFIX . 'CURRENCY_CODE'] = $parentrecord[INIM_PREFIX . 'CURRENCY_CODE'];
			 $record[INAT_PREFIX . 'GAIN_AMT'] = $total_gain_amt;
			 $record[INAT_PREFIX . 'BASE_GAIN_AMT'] = $parentrecord[INIM_PREFIX . 'BASE_GAIN_AMT'];
			 $record[INAT_PREFIX . 'SEC_ISSUER'] = $parentrecord[INIM_PREFIX . 'SEC_ISSUER'];
			 $record[INAT_PREFIX . 'SEC_ISSUER_prim'] = $parentrecord[INIM_PREFIX . 'SEC_ISSUER_prim'];
			 $record[INAT_PREFIX . 'SEC_ISSUER_secd'] = $parentrecord[INIM_PREFIX . 'SEC_ISSUER_secd'];
			 $record[INAT_PREFIX . 'SEC_ISSUER_terc'] = $parentrecord[INIM_PREFIX . 'SEC_ISSUER_terc'];
			 $record[INAT_PREFIX . 'PURCHASE_PRICE'] = $parentrecord[INIM_PREFIX . 'PURCHASE_PRICE'];
			 $record[INAT_PREFIX . 'SELL_PRICE'] = $parentrecord[INIM_PREFIX . 'SELL_PRICE'];
			 $record[INAT_PREFIX . 'EARNED_INTEREST_AMT'] = $total_earned_interest_amt;
			 $record[INAT_PREFIX . 'EMISSION_NO'] = $parentrecord[INIM_PREFIX . 'EMISSION_NO'];
			 $record[INAT_PREFIX . 'DEAL_TICKET_NO'] = $parentrecord[INIM_PREFIX . 'DEAL_TICKET_NO'];
			 $record[INAT_PREFIX . 'REALIZED_EARNINGS'] = $parentrecord[INIM_PREFIX . 'REALIZED_EARNINGS'];
			 $record[INAT_PREFIX . 'UNREALIZED_EARNINGS'] = $parentrecord[INIM_PREFIX . 'UNREALIZED_EARNINGS'];
			 $record[INAT_PREFIX . 'BOOK_VALUE'] = $parentrecord[INIM_PREFIX . 'BOOK_VALUE'];
			 $record[INAT_PREFIX . 'CAPITAL_GAIN'] = $parentrecord[INIM_PREFIX . 'CAPITAL_GAIN'];
			 $record[INAT_PREFIX . 'TRANS_SOURCE'] = $parentrecord[INIM_PREFIX . 'TRANS_SOURCE'];
			 $record[INAT_PREFIX . 'TRANS_STATUS'] = 'IMPE';
			 $record[INAT_PREFIX . 'BATCH_ID'] = $parentrecord[INIM_PREFIX . 'BATCH_ID'];
		  }
        }
        if ($record[INAT_PREFIX . 'INVEST_ACTIVITY'] !== 'BY') {
		  /*
		   * CODE_INVEIMP2_ERR_ONLY4BY
		   * Distribution records must be created for buy operations only
		   * Los registros de distribuci�n s�lo deben ser creados para las operaciones de compra
		   */
		  $msg[INAT_PREFIX . 'INVEST_ACTIVITY'] = dict('CODE_INVEIMP2_ERR_ONLY4BY');
        }
        if (!empty($this->debug)) {
		  $this->echoLog('<br><br>RECORD # 2:<br>' .
			     print_r($record, true));
        }
    }

// Method end
    /*
     * INAT_DIST form (assigned as INIM form listing)  on-save event
     */
    function inat_dist_form_validate(&$record, &$msg) {
        if (!empty($this->debug)) {
		  $this->echoLog('<br>msg_prev_step=' . ClxCommon::$cached['msg_prev_step'] . print_r(ClxCommon::$cached['msg_prev_step'], true));
        }
        if (count(ClxCommon::$cached['msg_prev_step']) > CLX_NUM_ZERO) {
		  $ar_response = array();
		  $ar_response['error'] = true;
		  $ar_response['errormsg'] = ClxCommon::$cached['msg_prev_step'];
        } else {
		  $ar_response = $this->inat_form_validations($record);
        }
        if ($ar_response['error'] === true) {
		  $msg = $ar_response['errormsg'];
        } else {
		  // Todo OK
		  $record = $this->inat_dist_form_update_status($record, $msg);
        }
    }

    /*
     * Get accomulated INAT fields for a lot #
     */

    function get_sum_flds($ac, $batch_id, $deal_ticket_no, $idcode) {
        $ar_response = array();
        $wwhere = 'BATCH_ID=' . singleQuote($batch_id) . ' AND DEAL_TICKET_NO=' . singleQuote($deal_ticket_no);
        if ($ac !== 'CREATE') {
		  // DO NOT INCLUDE ACTUAL ACTIVITY because we want to check totals w/o new values
		  $wwhere .= 'AND IDCODE <> ' . singleQuote($idcode);
        }
        $sql = 'SELECT SUM(INVEST_AMT) TOTAL_INVEST_AMT, SUM(GAIN_AMT) TOTAL_GAIN_AMT, SUM(FACE_VALUE) TOTAL_FACE_VALUE, SUM(EARNED_INTEREST_AMT) TOTAL_EARNED_INTEREST_AMT, SUM(SHARES) TOTAL_SHARES, SUM(TAX_AMT) TOTAL_TAX_AMT, SUM(TRANS_FEES) TOTAL_TRANS_FEES FROM ' . $this->inatname . '  WHERE ' . $wwhere;
        if (!empty($this->debug))
		  $this->echoLog('<br>get_sum_flds--SQL = ' . $sql);
        $inat_result = ClxCommon::$db->executeQuery($sql);
        $ar_response['error'] = true;
        if ($inat_row = ClxCommon::$db->getNextRecord($inat_result))
		  $ar_response['error'] = false;
		ClxCommon::$db->freeResult($inat_result);  
        if ($ar_response['error'] === true) {
		  // blank set because EOF condition has found
		  $inat_row = array();
		  $inat_row['TOTAL_INVEST_AMT'] = CLX_INIT_ZERO;
		  $inat_row['TOTAL_GAIN_AMT'] = CLX_INIT_ZERO;
		  $inat_row['TOTAL_FACE_VALUE'] = CLX_INIT_ZERO;
		  $inat_row['TOTAL_EARNED_INTEREST_AMT'] = CLX_INIT_ZERO;
		  $inat_row['TOTAL_SHARES'] = CLX_INIT_ZERO;
		  $inat_row['TOTAL_TAX_AMT'] = CLX_INIT_ZERO;
		  $inat_row['TOTAL_TRANS_FEES'] = CLX_INIT_ZERO;
        }
        $ar_response['inat_row'] = $inat_row;
        if (!empty($this->debug)) {
		  $this->echoLog('<br>get_sum_flds--ar_response:<br>' .
			     $tisprint_r($ar_response, true));
        }
        return $ar_response;
    }

    /*
     * INAT_DIST form (assigned as INIM form listing)  on-save event
     */

    function inat_dist_form_delete($record, &$msg) {
        if (!empty($this->debug))
		  $this->echoLog('<br>inat_dist_form_delete comienzo...<br>');
        return $this->inat_dist_form_update_status($record, $msg);
    }

    /*
     * INAT_DIST form (assigned as INIM form listing)  on-save event
     */

    function inat_dist_form_update_status($record, &$msg) {
        // just before saving, put the correct INAT record estatus
        $callingpage = peekHistory();
        $hasparent = (isset($callingpage['parentrecord']));
        if ($hasparent === true) {
		  $parentrecord = $callingpage['parentrecord'];
		  if (!empty($this->debug)) {
			 $this->echoLog('<br>parentrecord:<br>' .
			         print_r($parentrecord, true));
		  }
		  // Verifies if the total of all investment movements records sum is equal to the investment amount of
		  // imported movement parent record
		  $ar_response = $this->get_sum_flds(UserRequest::$request['ac'], $parentrecord[INIM_PREFIX . 'BATCH_ID'], $parentrecord[INIM_PREFIX . 'DEAL_TICKET_NO'], $record[INAT_PREFIX . 'IDCODE']
		  );
		  if ($ar_response['error'] == false) {
			 $inat_row = $ar_response['inat_row'];
			 // Calculates totals with existing child records summarized values plus current record values
			 $total_invest_amt = $inat_row['TOTAL_INVEST_AMT'] + $record[INAT_PREFIX . 'INVEST_AMT'];
			 $total_gain_amt = $inat_row['TOTAL_GAIN_AMT'] + $record[INAT_PREFIX . 'GAIN_AMT'];
			 $total_face_value = $inat_row['TOTAL_FACE_VALUE'] + $record[INAT_PREFIX . 'FACE_VALUE'];
			 $total_earned_interest_amt = $inat_row['TOTAL_EARNED_INTEREST_AMT'] + $record[INAT_PREFIX . 'EARNED_INTEREST_AMT'];
			 $total_shares = $inat_row['TOTAL_SHARES'] + $record[INAT_PREFIX . 'SHARES'];
			 $total_tax_amt = $inat_row['TOTAL_TAX_AMT'] + $record[INAT_PREFIX . 'TAX_AMT'];
			 $total_trans_fees = $inat_row['TOTAL_TRANS_FEES'] + $record[INAT_PREFIX . 'TRANS_FEES'];
			 // Default status: NOT ready to be processed, pending amount distribution assigment
			 $rec_status = 'NOT';
			 // If the sum of INAT records open fields is equal to corresponding INIM ones, marks INIM record as 'ready to be processed'
			 if (
			         $total_invest_amt == $parentrecord[INIM_PREFIX . 'INVEST_AMT'] && $total_gain_amt == $parentrecord[INIM_PREFIX . 'GAIN_AMT'] && $total_face_value == $parentrecord[INIM_PREFIX . 'FACE_VALUE'] && $total_earned_interest_amt == $parentrecord[INIM_PREFIX . 'EARNED_INTEREST_AMT'] && $total_shares == $parentrecord[INIM_PREFIX . 'SHARES'] && $total_tax_amt == $parentrecord[INIM_PREFIX . 'TAX_AMT'] && $total_trans_fees == $parentrecord[INIM_PREFIX . 'TRANS_FEES']) {
			     // Record is ready to be processed
			     $rec_status = 'IDLE';
			 }
			 if (!empty($this->debug))
			     $this->echoLog('<brREC_STATUS = ' . $rec_status . ' , ID = ' . $parentrecord[INIM_PREFIX . 'ID']);
			 // update INIM record status
			 ClxCommon::$db->updateRecord($this->inimname, array('REC_STATUS' => $rec_status), 'ID = ' . singleQuote($parentrecord[INIM_PREFIX . 'ID']));
		  }
        }
        return $record;
    }

// Method end
    /*
     * Performs one INAT record approval. Returns nothing because its suppose to previously called the the validation process
     */
    function inat_onerec_approval($record) {
        return $this->o_inut->approveStatusByTranscode($record['IDCODE']);
    }

    /*
     * Performs one INAT record validation and returns error flag and eventual error message
     */

    function inat_form_validations($record) {
        $ar_response = array('error' => false,
		  'errormsg' => array()
        );
        if (!isset($record[INAT_PREFIX . 'PORTFOLIO_CODE'])) {
		  $record[INAT_PREFIX . 'PORTFOLIO_CODE'] = $record[INAT_PREFIX . 'PORTFOLIO_CODE_prim'];
        }
        $this->o_inut->validateInatForm($record, $ar_response['errormsg']);
        $callingpage = peekHistory();
        $hasparent = (isset($callingpage['parentrecord']));
        if ($hasparent === true) {
		  $parentrecord = $callingpage['parentrecord'];
        }
        if ($record[INAT_PREFIX . 'PORTFOLIO_CODE'] !== '') {
		  $infu_curr_code = ClxCommon::$db->getField($this->infuname, 'CURRENCY_CODE', 'IDCODE = ' . singleQuote($record[INAT_PREFIX . 'PORTFOLIO_CODE']));
		  if ($infu_curr_code != $parentrecord[INIM_PREFIX . 'CURRENCY_CODE']) {
			 // portfolio Currency must be equal to INIM currency
			 /*
			  * CODE_INVEIMP2_ERR_INIMCURR
			  * Investment activity currency (^1) do not match Portfolio currency (^2). Please verify.
			  * Moneda del movimiento de inversi�n (^1) no coincide con la del Portafolio (^2).
			  */
			 $s_err_msg = dict('CODE_INVEIMP2_ERR_INIMCURR', $parentrecord[INIM_PREFIX . 'CURRENCY_CODE'], $infu_curr_code);
			 $ar_response['errormsg'][INAT_PREFIX . 'CURRENCY_CODE'] = $s_err_msg;
			 addMessage($s_err_msg);
		  }
        }
        if (count($ar_response['errormsg']) > CLX_NUM_ZERO) {
		  $ar_response['error'] = true;
        }
        return $ar_response;
    }

    /*
     * Performs one INAT record validation and returns error flag and eventual error message
     */

    function inat_onerec_validations($record, $i_line_counter = '', $ac = '') {
        if (!empty($this->debug))
		  $this->echoLog('old_inat_import_validations');
        $ar_response = array('error' => false,
		  'errormsg' => ''
        );
        // Do the official INVE_utilities validation
        clearMessage();
        if (!$this->o_inut->validate($record)) {
		  if (!empty($this->debug))
			 $this->echoLog(debug_dump('_SESSION', $_SESSION));
		  $ar_response['error'] = true;
		  $ar_response['errormsg'] .= $this->inat_import_displayMessage() . CLX_CHAR_NL;
        }
        clearMessage();
        // Verifies duplication of IDCODE
        if (UserRequest::$request['ac'] === 'CREATE') {
		  if (isset($record['IDCODE']) && $record['IDCODE'] !== 'AUTO' &&
			     ClxCommon::$db->getRecord($this->inatname, 'IDCODE = ' . singleQuote($record['IDCODE']))) {
			 $ar_response['error'] = true;
			 /*
			  * CODE_MSG_INATIMPRT_DUPLIDCODE
			  * Code: ^1 already exists
			  * Ya existe un registro con el c�digo: ^1
			  */
			 $ar_response['errormsg'] .= '<li>' .
			         dict('CODE_MSG_INATIMPRT_DUPLIDCODE', $record['IDCODE']) . '</li>' . CLX_CHAR_NL;
		  }
        }
        if (!empty($this->debug))
		  $this->echoLog(debug_dump(singleQuote($i_line_counter) . ' - record', $record));
        $ar_response['errormsg'] = $i_line_counter . ' . ' . $ar_response['errormsg'];
        return $ar_response;
    }

}

/// Class End
// OLD Invesment Interfase
class old_fidu_investments_interfase extends fidu_investments {

    var $contents;
    var $sw_approve_activities = true;
    var $o_clx_file;
    var $import_folder = 'clxftp/inve/'; //INAT_INTERFASE_IMP_DIR

    function __construct() {
        define('INAT_IMPORT_ERRFILE_EXT', '.log');
        if (!empty($this->debug))
		  $this->echoLog('Investments Interfase started');
        parent::fidu_investments();
        $this->import_folder = companyParameter('INAT_INTERFASE_IMP_DIR');
        if (empty($this->import_folder)) {
		  $this->import_folder = kPathToWebSite . 'temp/';
        }
    }

    /**
     * SAP Interfase
     * Investments activities import - entry point method
     */
    function old_inat_import($filename = null) {
        if ($filename != null) {
		  // If the parameter has passed, executes the import process directly, assuming that it's an automatic process between systems
		  ClxFreeReturn($this->old_inat_import_doitnow($filename));
        } else {
		  // Ask the user for the import file location
		  $ac = UserRequest::$request['ac'];
		  $this->old_inat_import_action($ac);
        }
    }

    /**
     * SAP Interfase
     * Function will extract the flat file and load it into INAT
     */
    function old_inat_import_doitnow($filename) {
        if (!class_exists('inve_utilities'))
		  includeCodeLib('INUT');
        if (!function_exists('setCreationData'))
		  includeCodeLib('GEN_REC_UTIL');
        if (!class_exists('clx_file_delimited'))
		  require_once kPathToWebSite . 'classes/clx_file_delimited.php';
        // Verifies the input file existance
        $this->echoLog('File:' . $filename);
        if (file_exists($filename)) {
		  /*
		   * GEN_ERR_FILE_FOUND
		   * File found: ^1
		   * Archivo encontrado: ^1
		   */
		  $this->echoLog(dict('GEN_ERR_FILE_FOUND', $filename));
        } else {
		  /*
		   * GEN_ERR_FILE_NOTFOUND
		   * File not found: ^1
		   * Archivo no fue encontrado: ^1
		   */
		  $this->echoLog(dict('GEN_ERR_FILE_NOTFOUND', $filename));
		  return false;
        }
        $o_logfile_mngr = new clx_logfile_mngr($this->old_inat_import_log_filename($filename));
        if ($o_logfile_mngr->error) {
		  $this->echoLog($o_logfile_mngr->errorMsg);
		  return false;
        }
        $this->o_inut = new fidu_investments();
        $sw_error = false;
        if ($sw_error == false) {
		  $this->o_clx_file = new clx_file_delimited($filename, CLX_CHAR_NL, CLX_CHAR_TAB);
		  $i_line_counter = CLX_INIT_ZERO;
		  while ($line = $this->o_clx_file->getNextRecord()) {
			 $i_line_counter++;
			 if (!empty($this->debug))
			     $this->echoLog('<b>' . $i_line_counter . ' --&gt;' . $line . '&lt;--</b><br>');
			 // skips blank lines
			 $line = $this->o_clx_file->delete_ending_crlf($line);
			 if (trim($line) !== '') {
			     $record = $this->old_inat_import_read_line_into_record_array($line);
			     /*
			      * CODE_MSG_INATIMPRT_RECINFO
			      * Line ^1) Deal Ticket # ^2 - Investment Activity: ^3.
			      * L�nea ^1) Deal Ticket: ^2 - Tipo de Actividad: ^3.
			      */
			     $s_record_data_to_show = '<br>' . dict('CODE_MSG_INATIMPRT_RECINFO', $i_line_counter, $record['DEAL_TICKET_NO'], $record['INVEST_ACTIVITY']
					   ) . ' ';
			     // Assigns Pending status bacause it�s necessary to do the validation by the system�s investment screen
			     $record['TRANS_STATUS'] = 'PEND'; // PEND
			     // Aditional calculus
			     $record = $this->old_inat_import_inatTotal_v2($record);
			     // Other field fixes
			     $record = $this->old_inat_import_oth_fld_fix($record);
			     // Validates the record
			     $ar_response = $this->old_inat_import_validations($record, $s_record_data_to_show);
			     if ($ar_response['error'] === true) {
			         // Errors found...
			         if (!empty($this->debug))
					   $this->echoLog('CON ERRORES');
			         $this->echoLog($ar_response['errormsg']);
			         $o_logfile_mngr->write($ar_response['errormsg']);
			         if ($o_logfile_mngr->error) {
					   $this->echoLog($o_logfile_mngr->errorMsg);
			         }
			         //$sw_error = true;
			     } else {
			         // Everything is Ok
			         if (!empty($this->debug))
					   $this->echoLog('SIN ERRORES');
			         // Add system information
			         $record['CREATEDBY'] = '';
			         $record['MODIFIEDBY'] = '';
			         $record['CDATE'] = '';
			         $record['MDATE'] = '';
			         $record = setCreationData($record);
			         if (!isset($record['IDCODE'])) {
					   $record['IDCODE'] = 'AUTO';
					   $record = setCreationIdCode($record, 'INAT');
			         }
			         // Creates record
			         $prev_debug_state = ClxCommon::$db->debug;
			         ClxCommon::$db->debug = $this->debug;
			         ClxCommon::$db->createRecordVoid($this->inatname, $record, false);
			         ClxCommon::$db->debug = $prev_debug_state;
			         /*
					* CODE_MSG_INATIMPRT_RECSTATUS
					* ^1 = OK. Assigned Code: ^2
					* ^1 = OK. C�digo asignado: ^2
					*/
			         $this->echoLog(dict('CODE_MSG_INATIMPRT_RECSTATUS', $s_record_data_to_show, $record['IDCODE']));
			         // Put the new INAT record ID in the list for approval
			         if ($this->sw_approve_activities) {
					   $this->o_inut->approveStatusByTranscode($record['IDCODE']);
			         }
			     }
			 }
		  }
		  $this->o_clx_file->close();
        }
        if (!empty($this->debug))
		  $this->echoLog('Investments endded');
        $o_logfile_mngr->close();
        // Removes the original file
        unlink($filename);
    }

    /**
     * Validates de whole file. Returns error flag and error messages
     */
    function old_inat_import_validate_whole_file($line) {
        $this->o_clx_file = new clx_file_delimited($filename, CLX_CHAR_NL, CLX_CHAR_TAB);
        $i_line_counter = CLX_INIT_ZERO;
        $sw_error = false;
        $contents = '';
        while ($line = $this->o_clx_file->getNextRecord()) {
		  $i_line_counter++;
		  if ($line === '')
			 continue; // skips blank lines
		  $record = $this->old_inat_import_read_line_into_record_array($line);
		  // Import Validations
		  $ar_response = $this->old_inat_import_validations($record, $i_line_counter);
		  if ($ar_response['error'] === true) {
			 $sw_error = true;
			 $contents .= $ar_response['errormsg'];
		  }
        }
        $this->o_clx_file->close();
        return array('error' => $sw_error,
		  'errormsg' => $contents
        );
    }

    /**
     * Returns record array from the line
     */
    function old_inat_import_read_line_into_record_array($line) {
        //e cho 'Line:' . $line.'<br>';
        $line = $this->o_clx_file->toArray($line);
        $record = array();
        $record['IDCODE'] = $line[CLX_NUM_ZERO]; // => 0000000000000009 //  antes iba para DEAL_TICKET_NO
        $record['DEAL_TICKET_NO'] = $line[CLX_NUM_ZERO]; // => 0000000000000009
        $record['EFFTDATE'] = $line[CLX_NUM_ONE];

        $record['PORTFOLIO_CODE'] = $line[CLX_NUM_TWO]; // 0003
        $record['INVESTPROD_CODE'] = $line[CLX_NUM_THREE]; // PI00004
        $record['SEC_ISSUER'] = $line[CLX_NUM_FOUR]; // CARONI
        $record['INVEST_ACTIVITY'] = $line[CLX_NUM_FIVE]; // BY
        $record['CURRENCY_CODE'] = $line[CLX_NUM_SIX]; // VEB
        $record['UNIT_PRICE'] = $this->old_inat_import_cnv_number($line[CLX_NUM_7]); // 150000000
        $record['INVESTMENT_CODE'] = $line[CLX_NUM_8]; // AAA //  antes iba para INVEFIX_CODE
        $record['IS_FIXINCOME'] = $line[CLX_NUM_NINE]; // 0
        $record['ISSUE_DATE'] = $line[CLX_NUM_TEN];

        $record['MATURITY_DATE'] = $line[CLX_NUM_11];

        $record['INTEREST_TYPE'] = $line[CLX_NUM_12]; // FIX
        $record['YIELD_RT'] = $this->old_inat_import_cnv_number($line[CLX_NUM_13]); // 12 (referido a 12%) o vacio para 0%
        $record['INTEREST_CALC'] = $line[CLX_NUM_14]; // 0,00000
        $record['INV_PERIOD'] = $line[CLX_NUM_15]; // 0000
        $record['PAYMENT_FREQ'] = $line[CLX_NUM_16]; // IM
        $record['TRANS_STATUS'] = $line[CLX_NUM_17]; // PEND
        $record['SHARES'] = $this->old_inat_import_cnv_number($line[CLX_NUM_18]); // 1
        $record['TAX_AMT'] = $this->old_inat_import_cnv_number($line[CLX_NUM_19]); // 0
        $record['INVEST_AMT'] = $this->old_inat_import_cnv_number($line[CLX_NUM_20]); // 1500000,00
        $record['TRANS_FEES'] = $this->old_inat_import_cnv_number($line[CLX_NUM_21]); // 0
        $record['BASE_INVEST_AMT'] = $this->old_inat_import_cnv_number($line[CLX_NUM_22]); // 0
        $record['FACE_VALUE'] = $this->old_inat_import_cnv_number($line[CLX_NUM_23]); // 1500000,00
        $record['PURCHASE_PRICE'] = $this->old_inat_import_cnv_number($line[CLX_NUM_24]); // 0
        $record['SELL_PRICE'] = $this->old_inat_import_cnv_number($line[CLX_NUM_25]); // 0
        $record['PREMIUM_AMT'] = $this->old_inat_import_cnv_number($line[CLX_NUM_26]); // 0
        $record['DISCOUNT_AMT'] = $this->old_inat_import_cnv_number($line[CLX_NUM_27]); // 0
        $record['EMISSION_NO'] = $line[CLX_NUM_28]; // 10,20,30xxxxx
        $record['EARNED_INTEREST_AMT'] = $this->old_inat_import_cnv_number($line[CLX_NUM_29]); // intereses caidos (agregado el 21/11/2006)
        // Ganancias (agregado el 21/11/2006)
        $record['BOOK_VALUE'] = $this->old_inat_import_cnv_number($line[CLX_NUM_30]);
        $record['CAPITAL_GAIN'] = $this->old_inat_import_cnv_number($line[CLX_NUM_31]);
        $record['REALIZED_EARNINGS'] = $this->old_inat_import_cnv_number($line[CLX_NUM_32]);
        $record['GAIN_AMT'] = $record['REALIZED_EARNINGS'];
        $record['UNREALIZED_EARNINGS'] = $this->old_inat_import_cnv_number($line[CLX_NUM_33]);
        $record['CONTRACT_CODE'] = $line[CLX_NUM_34];
        $record['PARTICIPANT_ID'] = $line[CLX_NUM_35];
        if (!empty($this->debug))
		  $this->contents .= debug_dump('Registro', $record);
        //print_r($record);
        return $record;
    }

    /**
     * Returns the form's especified filename
     */
    function old_inat_import_filename() {
        if (empty(UserRequest::$post['INAT_IMPORT_localfile'])) {
		  $filename_tmp = UserRequest::$files['INAT_IMPORT_uploadfile']['tmp_name'];
		  $filename = $this->import_folder . UserRequest::$files['INAT_IMPORT_uploadfile']['name'];
		  if (!move_uploaded_file($filename_tmp, $filename))
			 addMessage(dict('GEN_ERR_UPLOADFAIL'));
        } else {
		  $filename = UserRequest::$post['INAT_IMPORT_localfile'];
        }
        return $filename;
    }

    /**
     * Returns the log filename
     */
    function old_inat_import_log_filename($filename) {
        $s_response = $filename . '_' . adodb_date('Ymd') . '_' . adodb_date('hms') . INAT_IMPORT_ERRFILE_EXT;
        return $s_response;
    }

    /**
     * If the number comes with coma as decimal delimiter, converts it to '.'
     */
    function old_inat_import_cnv_number($s_chr) {
        $s_chr = str_replace(',', '.', $s_chr);
        $s_chr = str_replace('\"', '', $s_chr);
        $s_chr = CLX_NUM_ZERO + $s_chr;
        $s_chr = rounder($s_chr, $this->display_rounding);
        return $s_chr;
    }

    /**
     * Other field eventual fixes, just to correct missing data with default values
     */
    function old_inat_import_oth_fld_fix($record) {
        if (!isset($record['YIELD_RT']) || $record['YIELD_RT'] === '') {
		  $record['YIELD_RT'] = CLX_INIT_ZERO;
        }
        if (!isset($record['EARNED_INTEREST_AMT']) || $record['EARNED_INTEREST_AMT'] === '') {
		  $record['EARNED_INTEREST_AMT'] = CLX_INIT_ZERO;
        }
        //  dejarlo en blanco segun frank, no en cero como estaba antes...
        if (!isset($record['INVSECURITY_CODE']) || $record['INVSECURITY_CODE'] === '') {
		  $record['INVSECURITY_CODE'] = '';
        }
        return $record;
    }

    /**
     * Line validation
     */
    function old_inat_import_validations($record, $i_line_counter) {
        if (!empty($this->debug))
		  $this->echoLog('old_inat_import_validations');
        $ar_response = array('error' => false,
		  'errormsg' => ''
        );
        // Do the official INVE_utilities validation
        clearMessage();
        if (!$this->o_inut->validate($record)) {
		  if (!empty($this->debug))
			 $this->echoLog(debug_dump('_SESSION', $_SESSION));
		  $ar_response['error'] = true;
		  $ar_response['errormsg'] .= $this->old_inat_import_displayMessage() . CLX_CHAR_NL;
        }
        clearMessage();
        // Verifies duplication of IDCODE
        if (isset($record['IDCODE']) && $record['IDCODE'] !== 'AUTO' &&
			 ClxCommon::$db->getRecord($this->inatname, 'IDCODE = ' . singleQuote($record['IDCODE']))) {
		  $ar_response['error'] = true;
		  /*
		   * CODE_MSG_INATIMPRT_DUPLIDCODE
		   * Code: ^1 already exists
		   * Ya existe un registro con el c�digo: ^1
		   */
		  $ar_response['errormsg'] .= '<li>' .
			     dict('CODE_MSG_INATIMPRT_DUPLIDCODE', $record['IDCODE']) . '</li>' . CLX_CHAR_NL;
        }
        if (!empty($this->debug))
		  $this->echoLog(debug_dump(singleQuote($i_line_counter) . ' - record', $record));
        $ar_response['errormsg'] = $i_line_counter . ' ' . $ar_response['errormsg'];
        return $ar_response;
    }

    /**
     * Line error reporting
     */
    function old_inat_import_displayMessage() {
        $separador = '<LI>';
        $contents = '';
        foreach ($_SESSION['USMSG'] as $key => $value) {
		  switch ($value['type']) {
			 case CLX_CLASS_ALERT:
			     $contents .= $separador . dict('GEN_LBL_ALERT') . ' ' . $value['msg'];
			     break;
			 case 'note':
			     $contents .= $separador . dict('GEN_LBL_NOTE') . ' ' . $value['msg'];
			     break;
			 default:
			     $contents .= $separador . $value['msg'];
			     break;
		  }
		  $separador = '</LI><LI>';
        }
        if ($contents !== '')
		  $contents .= '</LI>';
        return $contents;
    }

    /**
     * Calculates PURCHASE_PRICE, SELL_PRICE, PREMIUM_AMT, DISCOUNT_AMT columns
     */
    function old_inat_import_inatTotal_v2($record) {
        return $record;
        if (!empty($this->debug)) {
		  $this->echoLog('old_inat_import_inatTotal_v2 / Antes:');
		  $this->echoLog('IS_FIXINCOME=' . $record['IS_FIXINCOME']);
		  $this->echoLog('INVEST_ACTIVITY=' . $record['INVEST_ACTIVITY']);
		  $this->echoLog('INVEST_AMT=' . $record['INVEST_AMT']);
		  $this->echoLog('FACE_VALUE=' . $record['FACE_VALUE']);
		  $this->echoLog('PURCHASE_PRICE=' . $record['PURCHASE_PRICE']);
		  $this->echoLog('SELL_PRICE=' . $record['SELL_PRICE']);
		  $this->echoLog('PREMIUM_AMT=' . $record['PREMIUM_AMT']);
		  $this->echoLog('DISCOUNT_AMT=' . $record['DISCOUNT_AMT']);
		  $this->echoLog('<hr>');
        }
        if ($record['IS_FIXINCOME'] == CLX_NUM_ONE) {
		  switch ($record['INVEST_ACTIVITY']) {
			 case 'BY':
			 case 'SL':
			 case 'CA':
			     if ($record['FACE_VALUE'] == CLX_NUM_ZERO && $record['INVEST_ACTIVITY'] === 'BY')
			         $record['FACE_VALUE'] = $record['INVEST_AMT'];
			     if ($record['FACE_VALUE'] == CLX_NUM_ZERO) {
			         $calculo = CLX_INIT_ZERO;
			     } else {
			         $calculo = bcmul(bcdiv((string) $record['INVEST_AMT'], (string) $record['FACE_VALUE']), CLX_NUM_HUNDRED);
			     }
			     $calculo = $this->old_inat_import_numDec($calculo, $this->display_rounding);
			     if ($record['INVEST_ACTIVITY'] === 'BY') {
			         $record['PURCHASE_PRICE'] = $calculo;
			         $record['SELL_PRICE'] = CLX_INIT_ZERO;
			     } else {
			         $record['SELL_PRICE'] = $calculo;
			         $record['PURCHASE_PRICE'] = CLX_INIT_ZERO;
			     }
			     break;
			 default:
			     break;
		  }
        }
        if (!empty($this->debug)) {
		  $this->echoLog('old_inat_import_inatTotal_v2 / Despues:');
		  $this->echoLog('INVEST_AMT=' . $record['INVEST_AMT']);
		  $this->echoLog('FACE_VALUE=' . $record['FACE_VALUE']);
		  $this->echoLog('PURCHASE_PRICE=' . $record['PURCHASE_PRICE']);
		  $this->echoLog('SELL_PRICE=' . $record['SELL_PRICE']);
		  $this->echoLog('PREMIUM_AMT=' . $record['PREMIUM_AMT']);
		  $this->echoLog('DISCOUNT_AMT=' . $record['DISCOUNT_AMT']);
		  $this->echoLog('<hr>');
        }
        return $record;
    }

    /**
     * Specific rounding routine used by old_inat_import_inatTotal_v2().
     * Maybe it's no necesarry unless the process involves implementation
     * of the special math library
     */
    function old_inat_import_numDec($num, $dig) {
        $n_response = rounder($num, $dig);
        if (!empty($this->debug))
		  $this->echoLog('old_inat_import_numDec(num=' . $num . ',dig=' . $dig . ',n_response=' . $n_response . ')');
        return $n_response;
    }

    /**
     * Form to get the import filespec, for those cases where it isn') . 't specified as entry point method parameter
     */
    function old_inat_import_upload_form($record, $msg) {
        // Setup de la forma y campos Hidden
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF'], CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);
        $form->addArgument('idlist', (array_key_exists('idlist', UserRequest::$request) ? UserRequest::$request['idlist'] : ''));
        $form->addArgument('it', (array_key_exists('it', UserRequest::$request)) ? UserRequest::$request['it'] : '');
        $form->addArgument('wind', '1');
        $form->addArgument('confirm', '1');
        $form->setProp('enctype', 'multipart/form-data');
        // Datos que se solicitan
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        /*
         * CODE_MSG_INATIMPRT_TITLE
         * Investments Activities Import
         * Importaci�n de Actividades de Inversi�n
         */
        $table->addCell(dict('CODE_MSG_INATIMPRT_TITLE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('TOOL_PACK_PROMPT_IMPORTEXPLAIN'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!array_key_exists('INAT_IMPORT_localfile', $record))
		  $record['INAT_IMPORT_localfile'] = '';
        if (!array_key_exists('INAT_IMPORT_uploadfile', $record))
		  $record['INAT_IMPORT_uploadfile'] = '';
        $table->addField($msg, dict('TOOL_PACK_PROMPT_FILEONSERVER') . ':', 'INAT_IMPORT_localfile', $record['INAT_IMPORT_localfile'], CLX_NUM_48, CLX_NUM_255);
        $table->addFile($msg, dict('TOOL_PACK_PROMPT_UPLOADFILE') . ':', 'INAT_IMPORT_uploadfile', $record['INAT_IMPORT_uploadfile']);
        // Botones y parte final
        $c = new htmlSubmit(dict('GEN_LBL_IMPORT'), 'PRINT_DIALOG');
        $buttons = $c->source();
        if (strpos(UserRequest::$server['PHP_SELF'], 'pop.php') !== false) {
		  $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
		  $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $this->contents .= $form->source();
    }

    /**
     * Form values validation
     */
    function old_inat_import_check_upload_form(&$msg) {
        $msg = array();
        if (empty(UserRequest::$post['INAT_IMPORT_localfile'])) {
		  if (UserRequest::$files['INAT_IMPORT_uploadfile']['error']) {
			 $msg['INAT_IMPORT_uploadfile'] = dict('ERR_PACK_FILETOOBIG');
		  }
        } elseif (!file_exists(UserRequest::$post['INAT_IMPORT_localfile'])) {
		  $msg['INAT_IMPORT_localfile'] = dict('GEN_ERR_FILE_NOTFOUND', UserRequest::$post['INAT_IMPORT_localfile']);
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    /**
     * takes action depending of form's values
     */
    function old_inat_import_action($ac, $filename = null) {
        if (!empty(UserRequest::$post['confirm'])) {
		  $msg = array();
		  if ($this->old_inat_import_check_upload_form($msg)) {
			 // If the filename not found, takes it from the form
			 $filename = $this->old_inat_import_filename();
			 $this->old_scheduleImport($filename);
		  } else {
			 $this->old_inat_import_upload_form(UserRequest::$post, $msg);
		  }
        } else {
		  if (empty($record))
			 $record = array();
		  if (empty($msg))
			 $msg = array();
		  $this->old_inat_import_upload_form($record, $msg);
        }
    }

    function old_scheduleImport($filename) {
        $schedule_code = 'IBS_INAT_IMP';
        $PRSC = getTool('PRSC');
        $PRSP = getTool('PRSP');
        //e cho 'aca: ' . $filename.'<br>';
        //set parameters
        ClxCommon::$db->updateRecord($PRSP->tablename, array('PARAMETER_VALUE' => $filename), 'FIELDNAME = ' . singleQuote('ANYFILE') . ' AND SCHEDULECODE = ' . singleQuote($schedule_code));
        //set next run date
        $values = array('PR_RECURRENCE' => 'ONE',
		  'NEXT_RUN_DATE' => getNow('Y-m-d'),
		  'NEXT_RUN_TIME' => getNow('H:i:s'));
        ClxCommon::$db->updateRecord($PRSC->tablename, $values, 'IDCODE = ' . singleQuote($schedule_code));
        $this->contents .= note(dict('GEN_LBL_SCHED_ACTIVITY'));
    }

    /**
     * Local echoLog method, witch sustitutes echoLog() global method because it does an echo while this one assigns the 'contents' property
     */
    function echoLog($s_out_msg) {
        $this->contents .= $s_out_msg . '<BR>';
    }

    function contents() {
        return $this->contents;
    }

}

/// Class End
