<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
* @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
* @since        $Date: 2015-09-18 13:47:21 -0500 (vie, 18 sep 2015) $
* @version        $Rev: 6937 $
 *
 * CHANGE LOG
* 2009/09/02 Included svn prop
* 2020/03/18: [SA] MEJORAS BNP. 
 */
class service_utitities {

    /**
     * Constructor
     */
    // 20200318-SA: MEJORAS BNP / SE AGREGA LA TABLA (SRRP) PARTICIPANTES DE ROLES
    function __construct() {
        multiTableName ( $this, array (
            'SRRQ',
            'SRRS',
            'SRAN',
            'SRRP'
        ) );
    } // end function

    /**
     * switch rejection
     */
    function switchSrrqRejectClose() {
        //global $db;

        $idlist = getIdList();
        foreach ($idlist as $key => $val) {

            $status = ClxCommon::$db->getField ( $this->srrqname, 'REQSTATUS', "ID = $val" );
		  switch ($status) {
			 case 'C' :
                    ClxCommon::$db->updateRecord ( $this->srrqname, array (
                        'REQSTATUS' => 'R' 
                    ), "ID = $val" );
			     break;
			 case 'R' :
                    ClxCommon::$db->updateRecord ( $this->srrqname, array (
                        'REQSTATUS' => 'C' 
                    ), "ID = $val" );
			     break;
		  }
        }
    } // end method

    /**
     * SRRQ Validation
     *
     * @param array $msg
     * @param array $record
     * @return boolean
     */
    function validateSrrq(&$msg, &$record) {
        //global $ac, $db;
        $ac= UserRequest::$request['ac'];
        $status = true;
        if ($ac != 'DELETE')
            $fm = 'SRRQ_';
        if ($ac != 'CREATE') {
            $rqstatus = ClxCommon::$db->getField ( $this->srrqname, 'REQSTATUS', "IDCODE = '" . $record ['SRRQ_IDCODE'] . "'" );
            if ($rqstatus == 'C' || $rqstatus == 'R') {
			 $msg ['SRRQ_REQSTATUS'] = dict('GEN_ERR_CANNOTMODIFY');
			 $status = false;
		  }
        }
        if($record['SRRQ_REQTYPE']=='PAY'){
            $sql = "SELECT COUNT(ID) FROM CRM_ACCOUNTS WHERE IDENTIFICATION = '".$record['SRRQ_IDENTIFICATION']."'";
            if(empty($record['SRRQ_IDENTIFICATION']) || ClxCommon::$db->getOne($sql)==0){
                // CJRD 2015-09-18 - Case 1002993 - BEGIN
                //$msg['SRRQ_IDENTIFICATION'] = encode_string('Número de identificacion invalida');
                $msg['SRRQ_IDENTIFICATION'] = dict('CODE_ERR_IDENT_INVAL');
                // CJRD 2015-09-18 - Case 1002993 - END
			 $status = false;
		  }

            $sql = "SELECT COUNT(ID) FROM FIDU_BANK_ACCOUNTS WHERE BANK_ACCOUNT_NO = '".$record['SRRQ_BANK_ACCOUNT_NO']."'";
            if(empty($record['SRRQ_BANK_ACCOUNT_NO']) || ClxCommon::$db->getOne($sql)==0){
                // CJRD 2015-09-18 - Case 1002993 - BEGIN
                //$msg['SRRQ_BANK_ACCOUNT_NO'] = encode_string('Número de cuenta bancaria invalida');
                $msg['SRRQ_BANK_ACCOUNT_NO'] = dict('CODE_ERR_CB_INVAL');
                // CJRD 2015-09-18 - Case 1002993 - END
			 $status = false;
		  }

            if(empty($record['SRRQ_PAYMENT_AMT']) || $record['SRRQ_PAYMENT_AMT']<=0){
                $msg['SRRQ_PAYMENT_AMT'] = dict('CODE_ERR_GREATERTHANCERO');
			 $status = false;
		  }
		  }

        // 2020-06-03 EC: VALIDAR QUE EL AREA RESOLUTORIA ESTE VINCULADA AL TIPO DE RECLAMO O MOTIVO
        $sql = "SELECT COUNT(*) FROM SERV_REQTYPES_TBL WHERE IDCODE = '" . $record['SRRQ_REQTYPE'] . "' AND SRAR_CODE = '". $record ['SRRQ_AREACODE'] ."'" ;
        if (ClxCommon::$db->getOne($sql)==0) {
            $msg['SRRQ_AREACODE'] = dict('CODE_ERR_VINC_REQTYPE');
            $status = false;
    }

        $user_initiator=$_SESSION['user_record']['username'];
        /*if ($ac == 'CREATE') {
            // 20200318-SA: MEJORAS BNP / 
            // SI EL USUARIO INICIADOR NO ESTA EN NINGUN ROL SE PERMITE VINCULAR 
            // PARA LA SELECCION DE LA TOTALIDAD DE LAS AREAS RESOLUTORIAS 

            $sql = "SELECT * FROM SERV_ROLE_PARTICIPANTS SRRP WHERE SRRP.USER_CODE = '" . $user_initiator . "'" ;

            if ($db->getOne($sql) > 0){
                // 20200318-SA: MEJORAS BNP
                // SI EL USUARIO INICIADOR ESTA EN UN ROL SE VALIDA QUE ESE ROL ESTA DENTRO DEL AREA RESOLUTORIA VINCULADA
                $sql = "SELECT COUNT(*) FROM SERV_AREA_NOTIFICATIONS SRAN, CLX_AC_USERS CLXU, SERV_ROLE_PARTICIPANTS SRRP WHERE SRRP.USER_CODE = CLXU.USERNAME AND CLXU.STATUS = 1 " . 
                    " AND SRAN.AREACODE = '" . $record ['SRRQ_AREACODE'] . "'" .
                    " AND SRRP.USER_CODE = '" . $user_initiator . "'" .
                    " AND SRRP.ROLE_CODE = SRAN.ROLE_CODE " ;

                if ($db->getOne($sql)==0) {
                    $msg['SRRQ_AREACODE'] = dict('CODE_ERR_VINC_ARESOL');
                    $status = false;
                }
            }  
        }*/

        //17-04-2020/EC valida si el caso a cerrar posee actividades aun pendientes
        if($record['SRRQ_REQSTATUS']=='CE' || $record['SRRQ_REQSTATUS']=='NP'){
            // 17-04-2020-EC: MEJORAS BNP
            // SE VERIFICA QUE NO EXISTAN ANTIVIDADES PENDIENTES 
            $sql = "SELECT COUNT(*) FROM CRM_ACTIVITIES ACTI WHERE ACTI.REQUESTCODE = '" . $record['SRRQ_IDCODE'] . "'" .
                " AND ACTI.ACTIVITY_STATUS <> 'F'";
            if (ClxCommon::$db->getOne($sql)>0) {
                $msg['SRRQ_REQSTATUS'] = dict('CODE_ERR_ACTI_PEND');	
                $status = false;
            }
        }


        // 2020-05-26 SA: CASO 1004103. REQUERIR MONTO RECLAMADO Y CALCULAR FECHA ESTIMADA DE RESOLUCION;
        if ($record['SRRQ_COMP_CODE'] == 'BNP' && $record['SRRQ_REQTYPE'] >= 101 && $record['SRRQ_REQTYPE'] <= 305) {
            if ($record['SRRQ_CLAIMED_AMT'] == 'NULL' || $record['SRRQ_CLAIMED_AMT'] <= 0){
                $msg['SRRQ_CLAIMED_AMT']=dict('CODE_ERR_CLAIMED_AMT_REQUIRED');
                $status = false;
            }
            // CALCULAR FECHA DE RESOLUCION SEGUN DIAS DEFINIDOS EN EL PARAMETRO SERV_BUSINESS_DAYS_RESOLUTION
            $days_resolution=companyParameter('SERV_BUSINESS_DAYS_RESOLUTION', $record['SRRQ_COMP_CODE']);
            if(!empty($days_resolution)){
                //CALCULA FECHA DE RESOLUCION TOMANDO EN CUENTA DIAS CONTINUOS
                $record['SRRQ_TGTRESOL_DTTM'] = date("Y-m-d", strtotime($record['SRRQ_EFFTDATETIME']."+ $days_resolution days"));

                //CALCULA FECHA DE RESOLUCION TOMANDO EN CUENTA DIAS HABILES DEL CALENDARIO
                //$record['SRRQ_TGTRESOL_DTTM']= $this->calcResolutionDays($record['SRRQ_COMP_CODE'],$record['SRRQ_EFFTDATETIME'], $days_resolution);
            }
        }

        //Validando los attachment cuando son cargados desde el importador 
        if ($ac != 'CREATE' && $ac != 'MODIFY' && $ac != 'DELETE'){ 
            $status = $this->validate_attachment_import($msg, $record);
            $status = false;
        }
        //01-06-2020 EC: CASO 1004105, COLOCA USUARIOS CREADOR DE LOS DOCUMENTOS ADJUNTOS AL CASO
        if ($ac == 'CREATE') {
            if (UserRequest::$files['SRRQ_ATTACHMENTS']['name'] != '') {
                $record['SRRQ_ATTACHMENTS_OWNER'] =   $user_initiator ;
            }else{
                $record['SRRQ_ATTACHMENTS_OWNER']= '';
            }
            if (UserRequest::$files['SRRQ_ATTACHMENTS2']['name'] != '') {
                $record['SRRQ_ATTACHMENTS2_OWNER'] =   $user_initiator ;
            }else{
                $record['SRRQ_ATTACHMENTS2_OWNER'] = '';
            }
            if (UserRequest::$files['SRRQ_ATTACHMENTS3']['name'] != '') {
                $record['SRRQ_ATTACHMENTS3_OWNER'] =   $user_initiator ;
            }else{
                $record['SRRQ_ATTACHMENTS3_OWNER'] = '';
            }
        }
        //07-07-2020 EC: CASO 1004105, SI LA ACCION ES MODIFICAR ESTARAN DESHABILITADOS ALGUNOS O TODOS LOS ATTACHMENTS Y NO SE ENVIARAN CON EL FORMULARIO. TENEMOS QUE COSTRUIR LA VARIABLE _FILES PARA QUE NO BORRE LOS ARCHIVOS YA ADJUNTADOS AL CASO
        if ($ac == 'MODIFY') {
            //$record=array_merge($record, $_SESSION['SRRQ_ATTACHMENTS_TMP']);
            $datos_archivo=array('name'=>'', 'type' => '', 'tmp_name'=>'', 'error'=> 4, 'size'=> 0);

            if ($record['SRRQ_ATTACHMENTS_LOAD_DISABLED']=='1'){
                UserRequest::$files['SRRQ_ATTACHMENTS']= $datos_archivo;  
            }else{
                if (UserRequest::$files['SRRQ_ATTACHMENTS']['name'] != '') {
                    $record['SRRQ_ATTACHMENTS_OWNER'] =   $user_initiator ;
                }else{
                    $record['SRRQ_ATTACHMENTS_OWNER']= '';
                }
            }
            if ($record['SRRQ_ATTACHMENTS2_LOAD_DISABLED']=='1'){
                UserRequest::$files['SRRQ_ATTACHMENTS2']=$datos_archivo;  
            }else{
                if (UserRequest::$files['SRRQ_ATTACHMENTS2']['name'] != '') {
                    $record['SRRQ_ATTACHMENTS2_OWNER'] =   $user_initiator ;
                }else{
                    $record['SRRQ_ATTACHMENTS2_OWNER'] = '';
                }
            }
            if ($record['SRRQ_ATTACHMENTS3_LOAD_DISABLED']=='1'){
                UserRequest::$files['SRRQ_ATTACHMENTS3']=$datos_archivo;  
            }else{
                if (UserRequest::$files['SRRQ_ATTACHMENTS3']['name'] != '') {
                    $record['SRRQ_ATTACHMENTS3_OWNER'] =   $user_initiator ;
                }else{
                    $record['SRRQ_ATTACHMENTS3_OWNER'] = '';
                }
            }
        }

        
        //03-06-2020 EC, SE VALIDA CODIGO DE CUENTA COMO REQUERIDA SI LA ACCION ES CREATE Y LA FORMA ES REQUEST. LA FORMA LM_REQUEST SE USA PARA CARGA MASIVA DE CASOS Y ALLI EL CODIGO DE CUENTA NO ES REQUERIDO. 
        if ($ac == 'CREATE' && $record['fm'] == 'REQUESTS'){
            if ($record['SRRQ_ACCOUNTCODE_prim']=='' || empty($record['SRRQ_ACCOUNTCODE_prim'])){
                $msg['SRRQ_ACCOUNTCODE_prim'] = dict('GEN_ERR_REQUIRED_FIELD');	
                $status = false;
            }
        }

        // 2020-06-02 SA: CASO 1004104 . REQUERIR CODIGO DE VALIJA (SERVBOX_CODE) SI EL MOTIVO LO REQUIERE;
        $sql = "SELECT COUNT(*) FROM SERV_REQTYPES_TBL WHERE IDCODE = '" . $record['SRRQ_REQTYPE'] . "' AND REQ_BOXCODE = '1'" ;
        if (ClxCommon::$db->getOne($sql)>0 && $record['SRRQ_SERVBOX_CODE']=='') {
            $msg['SRRQ_SERVBOX_CODE'] = dict('CODE_ERR_SERVBOX_CODE_REQ');
            $status = false;
        }

        // 2020/08/31 EC, Si el asunto se selecciona del listado se debe guardar en el segundo campo de asunto
        if ($ac == 'CREATE' || $ac == 'MODIFY'){ 
            if ($record['SRRQ_SUBJECT']=='' || empty($record['SRRQ_SUBJECT'])){
                $record['SRRQ_SUBJECT'] = $record['SRRQ_REQTYPE_terc'];	
            }
            if ($record['SRRQ_ACCOUNTPRODUCTCODE']==null || $record['SRRQ_ACCOUNTPRODUCTCODE']==0 || $record['SRRQ_ACCOUNTPRODUCTCODE']==''){
                $record['SRRQ_ACCOUNTPRODUCTCODE']=NULL;
            }    

        }


        return $status;

    } // end method

    /**
     * Initialice notes
     *
     * @param array $record
     */
    function initNotes(&$record) {
        // $record['SRRQ_NOTES']='';
        // $record['SRRQ_EFFTDATETIME']='now';
    } // end method

    /**
     * createSrrs
     *
     * @param array $record
     */
    function createSrrs(&$record) {
        //global $db;

        if (empty($record['DESCRIPTION']) && !empty($record['SUBJECT'])) {
		  $record['DESCRIPTION'] = $record['SUBJECT'];
        }
        $rec = array();
        $results = ClxCommon::$db->executeQuery ( "SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS 
										WHERE TABLECODE = 'SRRS' AND FIELDNAME <> 'ID'" );
        while ( ($result = ClxCommon::$db->getNextRecord ( $results )) == true ) {
            if ($result ['FIELDNAME'] == 'REQUESTCODE') {
			 $rec ['REQUESTCODE'] = $record ['IDCODE'];
			 continue;
		  }
		  if (array_key_exists($result ['FIELDNAME'], $record)) {
			 $rec [$result ['FIELDNAME']] = $record [$result ['FIELDNAME']];
		  }
        }
        if (!empty($rec))
            ClxCommon::$db->createRecord ( $this->srrsname, $rec );

        $msg = $record ['NOTES'];
        $fromrec = ClxCommon::$db->getOneRecord ( "SELECT EMAIL,FIRSTNAME,LASTNAME FROM CLX_AC_USERS WHERE USERNAME = '" . $record ['MODIFIEDBY'] . "'" );
        $createdby = ClxCommon::$db->getOneRecord ( "SELECT EMAIL,FIRSTNAME,LASTNAME FROM CLX_AC_USERS WHERE USERNAME = '" . $record ['CREATEDBY'] . "'" );
        $asignedfrom = ClxCommon::$db->getOneRecord ( "SELECT EMAIL,FIRSTNAME,LASTNAME FROM CLX_AC_USERS WHERE USERNAME = '" . $record ['ASSIGNEDTO_USER'] . "'" );
        $rol = ClxCommon::$db->getOneRecord ( "SELECT IDNAME FROM SERV_AREAS WHERE IDCODE = '" . $record ['AREACODE'] . "'" );
        $DBTL = getTool('DBLT');
        $reqstatus = $DBTL->getListItem('RQST', $record ['REQSTATUS']);
        // send notifications
        // 1. send to modified_by and 2. send to assigned to if exists
        $excludeemails = array();
        $excludetask = array();
        $excludealert = array();
        $subject = 'Ref#:' . $record ['IDCODE'];
        if($record ['SUBJECT']!='null'){
            $subject = 'Ref#:' . $record ['IDCODE'] . ' - ' . $record ['SUBJECT'];}
        $msg = '<b>' . dict('GEN_LBL_REFERENCE') . ':</b> ' . $record ['IDCODE'] . '<bR>';
        $msg .= '<b>' . dict('GEN_LBL_CREATEDBY') . ':</b> ' . $createdby ['LASTNAME'] . ', ' . $createdby ['FIRSTNAME'] . '<bR>';
        if ($asignedfrom){
        $msg .= '<b>' . dict('GEN_LBL_ASSIGNED_TO') . ':</b> ' . $asignedfrom ['LASTNAME'] . ', ' . $asignedfrom ['FIRSTNAME'] . '<bR>';
        }
        if ($rol){
            $msg .= '<b>' . dict ( '1DA267D2E916D006FF6615ED3A80B96C' ) . ':</b> ' . $rol ['IDNAME'] . '<bR>';
        }
        $msg .= '<b>' . dict ( 'GEN_LBL_STATUS' ) . ':</b> ' . $reqstatus . '<hr><b>' . dict ( 'GEN_LLB_notes' ) . '</b><br> ' . $record ['NOTES'] ;
        if($record ['DESCRIPTION']!='null'){$msg .= ' <br><br><b>' . dict ( 'GEN_LBL_DESCRIPTION' ) . '</b> <bR>' . $record ['DESCRIPTION'];}
        if($record ['RESOLUTION']!='null'){$msg .= ' <br><bR><b>' . dict ( 'B5A4B64B2AA505BD7C11F79B8A9F458D' ) . ':</b><bR>' . $record ['RESOLUTION'];}

        $sql = "SELECT EMAIL,FIRSTNAME,LASTNAME FROM CLX_AC_USERS 
				WHERE USERNAME IN ('" . $record ['CREATEDBY'] . "',
								'" . $record ['ASSIGNEDTO_USER'] . "') 
								AND USERNAME<>''";
        // CJRD 2015-09-18 - Case 1002993 - BEGIN
        $email_encoding = 'UTF-8';
        // CJRD 2015-09-18 - Case 1002993 - END

        $results = ClxCommon::$db->executeQuery($sql);
        while ( ($result = ClxCommon::$db->getNextRecord ( $results, ASSOCIATIVE )) == true ) {
            $excludeemails [$result ['EMAIL']] = 1;
            //clx_mail ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject );
            // CJRD 2015-09-18 - Case 1002993 - BEGIN
            //clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject );
            if (!empty ($result ['EMAIL'])||$result ['EMAIL']!=''){
                clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject,true, '', '', '', array(), '', false, $email_encoding );
            }            // CJRD 2015-09-18 - Case 1002993 - END
        }

        // 3. search services areas to see if exists mails and tasks
        if (!empty($record ['AREACODE'])) {
            // 20200318-SA: MEJORAS BNP / SE AGREGA ROL A LAS NOTIFICACION. NOTIFICAR A PARTICIPANTES DEL ROL. 
            $sql = "SELECT 
			            SRAN.SEND_EMAIL,
			            SRAN.CREATE_ALERT,
			            SRAN.CREATE_TASK, 
			            CLXU.EMAIL, 
			            CLXU.FIRSTNAME, 
			            CLXU.LASTNAME, 
			            CLXU.USERNAME
					FROM $this->sranname SRAN, CLX_AC_USERS CLXU, $this->srrpname SRRP
					WHERE SRRP.USER_CODE = CLXU.USERNAME AND CLXU.STATUS = 1 AND
					SRAN.AREACODE = '" . $record ['AREACODE'] . "' 
						AND SRRP.ROLE_CODE = SRAN.ROLE_CODE 
						AND (SRAN.SEND_EMAIL = 1 || SRAN.CREATE_ALERT = 1 || SRAN.CREATE_TASK = 1)";
            /* 20200318-SA: MEJORAS BNP / SE REEMPLAZA USUARIO ASIGNADO POR PARTICIPANTE DE ROL ASIGNADO
			$sql = "SELECT 
			            SRAN.SEND_EMAIL,
			            SRAN.CREATE_ALERT,
			            SRAN.CREATE_TASK, 
			            CLXU.EMAIL, 
			            CLXU.FIRSTNAME, 
			            CLXU.LASTNAME, 
			            CLXU.USERNAME
					FROM $this->sranname SRAN, CLX_AC_USERS CLXU
					WHERE SRAN.ASSIGNEDID = CLXU.USERNAME AND CLXU.STATUS = 1 AND
					SRAN.AREACODE = '" . $record ['AREACODE'] . "' 
						AND (SRAN.SEND_EMAIL = 1 || SRAN.CREATE_TASK = 1)";
			*/
		  $results = ClxCommon::$db->executeQuery($sql);
            while ( ($result = ClxCommon::$db->getNextRecord ( $results, ASSOCIATIVE )) == true ) {

                // Sending emails
                if ($result ['SEND_EMAIL'] == 1 && empty ( $excludeemails [$result ['EMAIL']] )) {
                    //clx_mail ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject );
                    // CJRD 2015-09-18 - Case 1002993 - BEGIN
                    // clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject );
                    if (!empty ($result ['EMAIL'])||$result ['EMAIL']!=''){
                        clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject,true, '', '', '', array(), '', false, $email_encoding );
			 }
                    // CJRD 2015-09-18 - Case 1002993 - END
                    $excludeemails [$result ['EMAIL']] = 1;
                }

			 // sending alert
                if ($result ['CREATE_ALERT'] == 1 && empty ( $excludealert [$result ['USERNAME']] )) {
			     alrt_send($msg, 'now', $result ['USERNAME']);
                    $excludealert [$result ['USERNAME']] = 1;
			 }
			 // creating tasks
                if ($result ['CREATE_TASK'] == 1 && empty ( $excludetask [$result ["USERNAME"]] )) {
			     // Create Tasks
			     $task = array();
                    $task ["STATUS"] = "IDLE";
                    $task ["TYPE"] = 'FIEK';
                    $task ["SUBJECT"] = $subject;
                    $task ["DESCRIPTION"] = strip_tags ( str_replace ( '<br>', "\n", $msg ) );
                    $task ["PERCENT_COMPLETE"] = "0";
                    $task ["COMPLETE_DATE"] = "NULL";
                    $task ["PRIORITY"] = $record ['PRIORITY'];
                    $task ["OWNERCODE"] = $record ['MODIFIEDBY'];
                    /* 20200318-SA: MEJORAS BNP / SE REEMPLAZA USUARIO ASIGNADO POR PARTICIPANTE DE ROL ASIGNADO
					$task ["ASSIGNEDTO"] = $record ["ASSIGNEDTO_USER"]; */
                    $task ["ASSIGNEDTO"] =  $result ['USERNAME'] ;
                    $task ["REMINDER_DATETIME"] = "NULL";
                    $task ["RECURRING"] = "NONE";
                    $task ["DEPENDS"] = "0";
                    $task ["START_DATE"] = $record ['MDATE'];
                    $task ["DUE_DATE"] = "";
                    $excludetask [$result ["USERNAME"]] = 1;
                    ClxCommon::$db->createRecord ( "CLX_US_TASKS", $task );
			 } // end if task
		  } // end while
    }
    } // end method

    // --------------------------------------------------------------------------
    // PROCESO DE ESCALAMIENTO
    // --------------------------------------------------------------------------

    /**
     * Performs service Escalation
     * Run on schedules for process SERV001 one at a time
     */
    public function escalation() {
        //global $db;

        //Verify that only one exchedule for process is runing at the time
        //Process for escalation  = SERV001
        $qty = ClxCommon::$db->countRecords('CLX_PR_SCHEDULES',"PROC_STATUS = 'RUN' AND PROCESSCODE = 'SERV001'");
        if($qty>1){
		  //Something running just return until nothing is running
		  //to prevent doing double escalation
		  return;
        }
        if (!class_exists('Srer')) {
		  includeCodeLib('SRER');
        }
        $SRER = new Srer();
        // Init Set Excalation Dati if null to now
        $sql = "UPDATE SERV_REQUESTS SRRQ
				SET SRRQ.LAST_ESCALATION = NOW()
				WHERE SRRQ.LAST_ESCALATION = NULL";
        ClxCommon::$db->executeQuery($sql);
        // Performing checks
        $sql = "SELECT SRER.*
				FROM SERV_ESCALATION_RULES SRER
				WHERE SRER.MODULECODE = 'SERV'
					AND SRER.STATUS = 'A'
					AND SRER.SCALE_AFTER > 0";
        $rs = ClxCommon::$db->executeQuery($sql);
        while ( ($r = ClxCommon::$db->getNextRecord ( $rs, ASSOCIATIVE )) == true ) {

		  $crit = array();
		  // Adding type criterias
            if ($r ['ALL_REQUESTS'] == 1) {
			 $crit [] = '1=1'; // just set pointer to allow all requests to be searched
		  }
            if ($r ['REQSTATUS'] != '') {
                $crit [] = "SRRQ.REQSTATUS  = '" . $r ['REQSTATUS'] . "'";
		  }
            if ($r ['AREACODE'] != '') {
                $crit [] = "SRRQ.AREACODE  = '" . $r ['AREACODE'] . "'";
		  }
            if ($r ['PRIORITY'] != '') {
                $crit [] = "SRRQ.PRIORITY  = '" . $r ['PRIORITY'] . "'";
		  }
            if ($r ['REQTYPE'] != '') {
                $crit [] = "SRRQ.REQTYPE  = '" . $r ['REQTYPE'] . "'";
		  }

            if (count ( $crit ) == 0) {
			 // no criteria to search
			 continue;
		  }

            // 2013-07-24 FS-CR: fix according "SREP" List changes 
		  // Adding time criterias
		  switch ($r ['SCALE_PERIOD']) {
			 case 'H' :
                    //$crit [] = 'ADDDATE(SRRQ.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' DAY) <= NOW()';
			     $crit [] = 'ADDDATE(SRRQ.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' HOUR) <= NOW()';
			     break;
			 case 'D' :
                    //$crit [] = 'ADDDATE(SRRQ.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' HOUR) <= NOW()';
			     $crit [] = 'ADDDATE(SRRQ.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' DAY) <= NOW()';
			     break;
			 case 'M' :
                    //$crit [] = 'ADDDATE(SRRQ.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' MINUTE) <= NOW()';
			     $crit [] = 'ADDDATE(SRRQ.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' MONTH) <= NOW()';
			     break;
			 case 'I' :
			     $crit [] = 'ADDDATE(SRRQ.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' MINUTE) <= NOW()';
			     break;
			 default :
                    continue 2;
			     break;
		  }
		  // Select activities in previous condition
            $sql = "SELECT SRRQ.ID, SRRQ.REQSTATUS SET_REQSTATUS, SRRQ.SUBJECT IDNAME
					FROM SERV_REQUESTS SRRQ
					WHERE " . implode ( $crit, " AND " );
		  $rs2 = ClxCommon::$db->executeQuery($sql);
            while ( ($r2 = ClxCommon::$db->getNextRecord ( $rs2, ASSOCIATIVE )) == true ) {

			 $subject = $r ['IDNAME'] . '. Ref: ' . $r2 ['ID'];
			 $msg = $r ['IDNAME'] . '. Ref: ' . $r2 ['ID'] . ' - ' . $r2 ['IDNAME'] . ' <br><a href="REPLACE_URL">' . kWebSite . '</a><br>';
			 $url = 'pop.php?to=EDIT&ac=DISPLAY&li=REQUESTS&qy=REQUESTS&relfm=&idlist=' . $r2 ['ID'];
			 // Perform action on each activity found
			 $skeepuser = array();
                if ($r ['NOTIFY_ROLE'] != '') {

                    $sql = "SELECT SRRP.USER_CODE
							FROM SERV_ROLE_PARTICIPANTS SRRP
							WHERE SRRP.ROLE_CODE = '" . $r ['NOTIFY_ROLE'] . "'";
			     $rs3 = ClxCommon::$db->executeQuery($sql);
                    // 2013-07-23 FS-CR: while condition correction... 
                    //while ( $r3 = $db->getNextRecord ( $rs3 ) == true ) {
                    while ( ($r3 = ClxCommon::$db->getNextRecord ( $rs3, ASSOCIATIVE )) == true ) {


			         // test if already sent something
			         if (!empty($skeepuser [$r3 ['USER_CODE']]))
					   continue;
			         // mark as sent
                        $skeepuser [$r3 ['USER_CODE']] = 1;
			         // send
			         $SRER->escalation_action($r, $r3 ['USER_CODE'], $subject, $msg, $url);
			     }
			 }
			 // sent to user if not sent already
                if ($r ['NOTIFY_USER'] != '' && empty ( $skeepuser [$r ['NOTIFY_USER']] )) {
			     $SRER->escalation_action($r, $r ['NOTIFY_USER'], $subject, $msg, $url);
			 }
			 // Set status if required from parameters
                if ($r ['SET_REQSTATUS'] != '') {
			     $r2 ['SET_REQSTATUS'] = $r ['SET_REQSTATUS'];
			 }

                // echo 'Completado excalamiento '.$subject.'<Br>';

			 // Set modification date to last check date
                $sql = "UPDATE
						  SERV_REQUESTS
						SET
						  REQSTATUS = '" . $r2 ['SET_REQSTATUS'] . "',
						  LAST_ESCALATION = NOW()
						WHERE
						  ID = " . $r2 ['ID'];
			 ClxCommon::$db->executeQuery($sql);
		  }
        }
    }

    function recievePayments() {
        //global $db, $ac;

        if (!class_exists('Fiat')) includeCodeLib('FIAT');

        $idlist = getIdlist();
        $idlist = toString($idlist);
        //check status
        $sql = "SELECT FIAT.IDCODE
				FROM FIDU_TRANSACTIONS FIAT, SERV_REQUESTS SRRQ
				WHERE FIAT.REFERENCE_NO = SRRQ.IDCODE
					AND FIAT.TRANSTBL_CODE = 'PAGO'
					AND SRRQ.ID IN ($idlist)";
        $trans_code = ClxCommon::$db->getOne($sql);
        if (!empty($trans_code)) {
            // CJRD 2015-09-18 - Case 1002993 - BEGIN
            //return note(string_encode('Registro ya fue procesado ver transacción en administracion de efectivo número: '.$trans_code));
            return note(string_encode('Registro ya fue procesado, ver transacción en administración de efectivo número: '.$trans_code));
            // CJRD 2015-09-18 - Case 1002993 - END
        }

        $sql = "SELECT 
					SRRQ.IDCODE ITEM_REF_NO,
					FICO.COMP_CODE, 
					FICO.IDCODE CHART_FIELD01, 
					FIPA.ACCOUNTCODE BENEFICIARY_CODE,
					FIPA.ACCOUNTCODE CHART_FIELD02, 
					SRRQ.BANK_ACCOUNT_NO FIDU_BANKACT_CODE,
					SRRQ.BANK_ACCOUNT_NO,
					CONCAT(SRRQ.FIRSTNAME,' ',SRRQ.LASTNAME) BENENFICIARY_NAME,
					(SELECT MAX(FIAS.IDCODE)
					FROM FIDU_ITEMS FIAS
					WHERE FIAS.FIDU_BANKACT_CODE = SRRQ.BANK_ACCOUNT_NO)CHART_FIELD03, 
					(SELECT MAX(FIBK.CURRENCY_CODE)
					FROM FIDU_BANK_ACCOUNTS FIBK
					WHERE FIBK.BANK_ACCOUNT_NO = SRRQ.BANK_ACCOUNT_NO) CURRENCY_CODE,
					'' CHART_FIELD04, 
					(SRRQ.PAYMENT_AMT) PAYMENT_AMT,
					(SRRQ.PAYMENT_DATE) PAYMENT_DATE, 
					(SRRQ.SUBJECT) IDNAME
				FROM 
			          SERV_REQUESTS SRRQ, 
			           CRM_ACCOUNTS ACCO, 
			           FIDU_PARTICIPANTS FIPA,
			           FIDU_CONTRACTS FICO
							WHERE 
			          ACCO.IDCODE = FIPA.ACCOUNTCODE
			          AND FIPA.CONTRACT_CODE = FICO.IDCODE
			          AND ACCO.IDENTIFICATION = SRRQ.IDENTIFICATION
			          AND SRRQ.REQTYPE = 'PAY'
			          AND SRRQ.ID IN ($idlist)
			          LIMIT 1";
        $r = ClxCommon::$db->getOneRecord($sql);
        if (empty($r)) {
		  return note(string_encode('Registro no puede ser procesado.'));
        }

        $_POST['FIAT_REFERENCE_NO'] = $r['ITEM_REF_NO'];
        $_POST['FIAT_COMP_CODE'] = $r['COMP_CODE'];
        $_POST['FIAT_CHART_FIELD01'] = $r['CHART_FIELD01'];
        $_POST['FIAT_CHART_FIELD02'] = $r['CHART_FIELD02'];
        $_POST['FIAT_CHART_FIELD03'] = $r['CHART_FIELD03'];
        $_POST['FIAT_CHART_FIELD04'] = $r['CHART_FIELD04'];
        $_POST['FIAT_CURRENCY_CODE'] = $r['CURRENCY_CODE'];
        $_POST['FIAT_BENENFICIARY_NAME'] = $r['BENENFICIARY_NAME'];
        $_POST['FIAT_TRANSTBL_CODE'] = 'PAGO';
        $_POST['FIAT_BANK_ACCOUNT_NO'] = $r['BANK_ACCOUNT_NO'];
        $_POST['FIAT_FIDU_BANKACT_CODE'] = $r['BANK_ACCOUNT_NO'];
        $_POST['FIAT_BANKAC_CODE']  = $r['BANK_ACCOUNT_NO'];
        $_POST['FIAT_TRANS_AMT'] = $r['PAYMENT_AMT'];
        $_POST['FIAT_DISBURSEMENT_TYPE'] = 'OT';
        $_POST['FIAT_BENEFICIARY_CODE'] = $r['BENEFICIARY_CODE'];
        $_POST['FIAT_BENEFICIARY_CODE_prim'] = $r['BENEFICIARY_CODE'];
        $_POST['FIAT_REAL_DATE'] = $r['INVOICE_DATE'];
        $_POST['FIAT_IDNAME'] = $r['IDNAME'];
        if (!class_exists('Comp')) includeCodeLib('COMP');
        if(!class_exists('Jehd')) includeCodeLib('JEHD');
        $comp = new Comp();
        $oper = $comp->comp_operation_parameters($r['COMP_CODE']);
        $rate = $comp->comp_current_exchange($oper['IDCODE'], $r['CURRENCY_CODE'], $oper['OPERATION_DATE']);
        $_POST['FIAT_EXCHANGE_RT'] = $rate['EXCHANGE_RT'];
        $_POST['FIAT_CUR_OPERATOR'] = $rate['CUR_OPERATOR'];
        $_POST['FIAT_BASE_TRANS_AMT'] = $r['PAYMENT_AMT'];

        if($rate['CUR_OPERATOR']==1){
            $_POST['FIAT_BASE_TRANS_AMT'] = rounder($r['PAYMENT_AMT']*$rate['EXCHANGE_RT'], 2);
        } else {
            $_POST['FIAT_BASE_TRANS_AMT'] = rounder($r['PAYMENT_AMT']/$rate['EXCHANGE_RT'], 2);
        }
        $ac = 'CREATE';
        $_POST['ac'] = $ac;
        $_GET['ac'] = $ac;
        //$_REQUEST['li'] = 'FIAT_CA_SRCH';//to enable list after save
        UserRequest::$request['li'] = 'FIAT_CA_SRCH';
        pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_CA_SRCH');
        $EDIT = &getTool('EDIT');
        return $EDIT->action('CREATE',0);

    }//end function

    //17-04-2020/EC Poder asignar y cambiar el estado de los casos desde la bandeja de entrada, de manera múltiple.
    //Función que permite mostrar una ventana de dialogo para que el usuario pueda cambiar el status de un caso y/o
    //el usuario asignado de manera multiple.
    function run_change_status_dialog() {
        //global $db, $idlist_req_status ;
        $idlist_req_status = array ();
        $ac = UserRequest::$request['ac'];
        $to = UserRequest::$request['to'];
        $it = '';
        $_POST['idlist'] = toString(getIdlist());

        // RTBL_REPCINV
        $EDIT = &getTool ( 'EDIT' );
        $record = array ();
        $msg = array ();
        $msg_oper = '';
        $formrec = ClxCommon::$db->getRecord ( 'CLX_UI_FORMS', "IDCODE = 'REQ_ASK_STATUS'" );
        $record = $_POST;

        if (! empty ( $record ['confirm'] )) {
            //$EDIT->checkForm ( $formrec, $msg);
            // si el usuario no seleccionó ningun valor en los campos, mostramos un mensaje y terminamos proceso
            if ($record['SRRQ_REQSTATUS']==''&&$record['SRRQ_ASSIGNEDTO_USER']==''){
                return note(dict('GEN_LBL_PROCESS_NOCHANGE'), dict('GEN_LBL_CONTINUE'));	
            }

            //Si hay valor en alguno de lo campos se verifica en cuál y se procesa
            if ($record['SRRQ_REQSTATUS']!=''){
                //ejecutamos el cambio de status en los casos seleccionados
                $this->run_request_change_status($record['SRRQ_REQSTATUS'],$msg_oper, $idlist_req_status);
            }
            if ($record['SRRQ_ASSIGNEDTO_USER']!=''){
                //verificamos que el valor indicado en usuario existe realmente
                $sql = "SELECT COUNT(CLXU.ID)
				FROM  CLX_AC_USERS CLXU 
				WHERE
				CLXU.USERNAME IN ('".$record['SRRQ_ASSIGNEDTO_USER']."')";
                if(ClxCommon::$db->getOne($sql)==0){
                    // si no existe ese usuario mostramos un mensaje
                    $msg['SRRQ_ASSIGNEDTO_USER'] = dict('TOOL_ACUS_ERR_NO_RECORD');
                }else{
                    //si el usuario existe entonces actualizo en los casos que fueron seleccionados
                    $this->run_request_change_assigned_user($record['SRRQ_ASSIGNEDTO_USER'], $idlist_req_status);
                }
            }

            //elimina idlist repetidos dentro del arreglo para obtener los id de registros modificados
            $idlist_req_status = array_unique($idlist_req_status);
            //guardo un nuevo estado del caso en REQUEST_STATUS por cada caso modificado
            $this->save_req_status($idlist_req_status);

            if((empty($msg)) && (!empty($_POST['idlist'])) && ($msg_oper=='')){
                //Si no hubo mensajes de alerta de validación y de resultado de la operación y hay items seleccionados entonces se ha completado el proceso satisfactoriamente
                return note(dict('GEN_LBL_PROCESS_COMPLETED'), dict('GEN_LBL_CONTINUE'));
            }

            if($msg_oper!=''){
                //si hubo casos en los que no se pudo aplicar el cambio de estado muestro al usuario cuales son
                $msg_oper.=dict('GEN_LBL_PROCESS_COMPLETED');
                return note($msg_oper, dict('GEN_LBL_CONTINUE'));
            }  
        }
        // mostramos el formulario de cambio de estatus y usuario asignado y sus mensajes de alerta si los hubiere
        $form = $EDIT->defaultForm ( $formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', dict('TOOL_ANOG_CHO_SEL_RECORD'), dict ( 'GEN_LBL_EXECUTE' ) );
        return $form->source (); 
    }//end method

    //17-04-2020/EC Función que permite actualizar el status de un caso de manera multiple y validar que
    // no existan actividades pendientes antes de cerrar un caso
    function run_request_change_status($status, &$msg_oper, &$idlist_req_status){
        //global $db, $idlist, $idlist_req_status;
        $idlist = getIdlist();
        if(empty($idlist)) return;

        //$idlist_string = toString($idlist);

        foreach ( $idlist as $key => $val ) {
            $actua_caso=true;

            $this->now = xFormat::getNow("Y-m-d H:i:s");
            $this->fin = NULL;
            //17-04-2020/EC valida si el caso a cerrar posee actividades aun pendientes
            if($status=='CE'|| $status=='NP'){
                $this->fin = $this->now;
                // 17-04-2020-EC: MEJORAS BNP
                //OBTENGO EL IDCODE DEL CASO
                $idcode = ClxCommon::$db->getField ( $this->srrqname, 'IDCODE', "ID = $val" );
                // SE VERIFICA QUE NO EXISTAN ANTIVIDADES PENDIENTES EN EL CASO PARA PODER CERRARLO
                $sql = "SELECT COUNT(*) FROM CRM_ACTIVITIES ACTI WHERE ACTI.REQUESTCODE = '" . $idcode . "'" . " AND ACTI.ACTIVITY_STATUS <> 'F'";
                if (ClxCommon::$db->getOne($sql)>0) {
                    $msg_oper.= "<p class='alert'>El caso " . $idcode . " no pudo cerrarse porque aún posee actividades que no han finalizado</p>";
                    $actua_caso=false;
                }
            }
            if ($actua_caso){
                // Set modification to status request
                if ($this->fin==NULL){
                    $complete_date='NULL';
                }else{
                    $complete_date="'".$this->fin."'";
                }                
                $sql = "UPDATE
					SERV_REQUESTS
					SET
					REQSTATUS = '" . $status . "',COMPLETE_DATE=".$complete_date." ,MDATE='".$this->now."', MODIFIEDBY='".$_SESSION['user_record']['username']."' 
					WHERE
					ID IN ($val)";
                ClxCommon::$db->executeQuery ( $sql );

                // guardo en un arreglo los id de los registros actualizados
                $idlist_req_status[]=$val;
            }
    }
		  }

    //15-04-2020/EC Función que permite actualizar el usuario asignado de un caso de manera multiple
    function run_request_change_assigned_user($user, &$idlist_req_status){
        //global $db, $idlist, $idlist_req_status;

        $this->now = xFormat::getNow("Y-m-d H:i:s");
        $idlist = getIdlist();
        if(empty($idlist)) return;

        $idlist_string = toString($idlist);

        // Set modification to ASSIGNEDTO_USER request
        $sql = "UPDATE
		 	    SERV_REQUESTS
				SET
 			    ASSIGNEDTO_USER = '" . $user . "', MDATE='".$this->now."', MODIFIEDBY='".$_SESSION['user_record']['username']."' 
				WHERE
				ID IN ($idlist_string)";
        ClxCommon::$db->executeQuery ( $sql );

        // guardo en un arreglo los id de los registros actualizados
        foreach ( $idlist as $key => $val ) {
            $idlist_req_status[]=$val;	
        }



    }

    //21-05-2020/EC 
    //Función que permite crear casos de manera masiva
    function load_massive_cases() {
        //global $db, $ac, $record ;

        $ac = UserRequest::$request ['ac']; 
        $to = UserRequest::$request ['to'];
        $it = UserRequest::$request ['it'];;

        //setting back in case or return
        //pushHistory($to, $ac, '','li',$it);

        $title = dict('TOOL_GEN_MASS_CASES');
        $botones = dict ('GEN_LBL_CREATE');

        $this->now = xFormat::getNow("Y-m-d H:i:s");

        //libreria para la creación de los IDCODES y colocar fechas de creación. modificacion, usuario creador y usuario modificador
        includeCodeLib('GEN_REC_UTIL');

        $EDIT = &getTool ('EDIT');

        //$record = array ();
        $msg = array ();
        $msg_oper = '';
        $formrec = ClxCommon::$db->getRecord ( 'CLX_UI_FORMS', "IDCODE = 'LM_REQUESTS'" );

        //asigno fecha efectiva para que se muestre en el formulario
        $_POST['SRRQ_EFFTDATETIME'] = $this->now;
        $_POST['SRRQ_CDATE'] = $this->now;
        $_POST['SRRQ_MDATE'] = $this->now;

        //Esto es para setear el campo cuando se carga por primera vez
        /*if(empty($_POST['confirm'])){
            $_POST['SRRQ_ASNT_CODE'] = 'SELECCIONE';
        }*/

        $record = $_POST;
        if(!empty($record['confirm'])){
            //$ac = 'REPORT_BUILD'; //esto es para que no me arroje  error de redeclaración de clase dentro de la función $UIFM->userCheckForm()

            $UIFM = &getTool("UIFM");

            //tenemos que ajustar los valores de algunos campos compuestos ya que que sequedan en blanco
            $record['SRRQ_AREACODE'] = $record['SRRQ_AREACODE_prim'];
            $record['SRRQ_REQTYPE'] = $record['SRRQ_REQTYPE_prim'];
            $record['SRRQ_COMPLOC_CODE'] = $record['SRRQ_COMPLOC_CODE_prim'];
            $record['SRRQ_ACCOUNTCODE'] = $record['SRRQ_ACCOUNTCODE_prim'];

            //Esto es para mover valores de un campo a otro para el asunto
            if ($record['SRRQ_SUBJECT']=='' || empty($record['SRRQ_SUBJECT'])){
                $record['SRRQ_SUBJECT'] = $record['SRRQ_REQTYPE_terc'];	
}

            //valida que los campos requeridos tengan valores
            $UIFM->userCheckForm($formrec, $record, $msg);

            //if (empty($msg)) {
            // $ac='CREATE' para que realice las validaciones de los datos del formulario
            //$ac = 'CREATE';
            UserRequest::$request['ac']='CREATE';

            if ($this->validateSrrq($msg, $record) && empty($msg)){
                //traigo los campos de la tabla para construir la data a guardar
                $tablerec = ClxCommon::$db->getRecord("CLX_DB_TABLES", "IDCODE='SRRQ'"); 
                //Hacemos el ciclo de creacion de casos masivos
                $i=1;
                $nro_casos=$record['SRRQ_NUM_CASE'];
                while ($i<=$nro_casos){
                    //preparo el registro a guardar y los archivos adjuntos si los hay
                    $rec = $EDIT->prepareRecord($formrec, $tablerec, 0);

                    //coloco la fecha de resolucion al caso
                    //$rec['TGTRESOL_DTTM']=$record['SRRQ_TGTRESOL_DTTM'];

                    // 2020-05-26 SA: CASO 1004103. REQUERIR MONTO RECLAMADO Y CALCULAR FECHA ESTIMADA DE RESOLUCION;
                    if ($record['SRRQ_COMP_CODE'] == 'BNP' && $record['SRRQ_REQTYPE'] >= 101 && $record['SRRQ_REQTYPE'] <= 305) {
                        if ($record['SRRQ_CLAIMED_AMT'] == 'NULL' || $record['SRRQ_CLAIMED_AMT'] <= 0){
                            $msg['SRRQ_CLAIMED_AMT']=dict('CODE_ERR_CLAIMED_AMT_REQUIRED');
                            $status = false;
                        }
                        // CALCULAR FECHA DE RESOLUCION SEGUN DIAS DEFINIDOS EN EL PARAMETRO SERV_BUSINESS_DAYS_RESOLUTION
                        $days_resolution=companyParameter('SERV_BUSINESS_DAYS_RESOLUTION', $record['SRRQ_COMP_CODE']);
                        if(!empty($days_resolution)){
                            //CALCULA FECHA DE RESOLUCION TOMANDO EN CUENTA DIAS CONTINUOS
                            $rec['TGTRESOL_DTTM'] = date("Y-m-d", strtotime($record['SRRQ_EFFTDATETIME']."+ $days_resolution days"));

                            //CALCULA FECHA DE RESOLUCION TOMANDO EN CUENTA DIAS HABILES DEL CALENDARIO
                            //$record['SRRQ_TGTRESOL_DTTM']= $this->calcResolutionDays($record['SRRQ_COMP_CODE'],$record['SRRQ_EFFTDATETIME'], $days_resolution);
                        }
                    }

                    //coloco el dueño del attachment 01
                    $rec['ATTACHMENTS_OWNER']=$record['SRRQ_ATTACHMENTS_OWNER'];
                    //coloco el dueño del attachment 02
                    $rec['ATTACHMENTS2_OWNER']=$record['SRRQ_ATTACHMENTS2_OWNER'];
                    //coloco el dueño del attachment 03
                    $rec['ATTACHMENTS3_OWNER']=$record['SRRQ_ATTACHMENTS3_OWNER'];

                    //Como el codigo de cuenta no es un dato requerido se me queda en NULL y genera error al momento de guardar, verifico y lo seteo en blanco
                    //echo $rec['ACCOUNTCODE'];
                    if ($rec['ACCOUNTCODE']=='null'){
                        $rec['ACCOUNTCODE']='';
                    }
                    //Se crea el número del caso
                    $rec = setCreationIdCode($rec, 'SRRQ'); 
                    //asigno fecha de creacion, modificación, creado por, modificado por, dueño y usuario creador del registro
                    $rec = setCreationData($rec);

                    if (! empty ( $rec )){
                        //guardo los datos en la tabla SERV_REQUEST
                        ClxCommon::$db->createRecord ( $this->srrqname, $rec );
                        //guardo en SRRS - REQUEST_STATUS
                        //evento Post Database Commit - envío de email, creación de alertas y status por caso
                        $this->createSrrs($rec);
                        //$this->get_clientName($rec);
                    }
                    $i++;
                }
                $li=$_SESSION['history']['main']['0']['li'];

                //realizado el proceso de creación de casos masivos retornamos al listado de donde partimos
                header('location: ' . 'tool.php?to=EDIT&ac=LIST&li='.$li);
                //$contents = $EDIT->makeList($li);
                //return $contents;
            }
            //todo bien
        }

        // mostramos el formulario de carga masiva de casos
        $form = $EDIT->defaultForm ( $formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title, $botones );
        return $form->source (); 
    }


    // 20200526 SA: CASO 1004103 - FUNCION PARA CALCULAR FECHA DE RESOLUCION POR DIAS HABILES;
    function calcResolutionDays($comp_code, $fromDate, $days) {
        //global $db;
        //AJUSTAMOS EL FORMATO DE FECHA PUES ME PUEDE VENIR DATETIME Y EN GL_CALENDARS ES SOLO DATE
        $date_tmp=date_create($fromDate);
        $fromDate=date_format($date_tmp, 'Y-m-d');

        //BUSCAMOS DIAS FERIADOS EN EL CALENDARIO
        $sql='SELECT EFFTDATE FROM GL_CALENDARS WHERE COMP_CODE =' . singlequote($comp_code) . ' AND EFFTDATE > ' . singlequote($fromDate) . ' AND HOLIDAY = 1 ORDER BY EFFTDATE ASC' ;

        $Holidays = ClxCommon::$db->executeQuery($sql);
        $Array_Holidays = array();

        //EL RESULTADO DEL QUERY LO LLEVAMOS A UN ARREGLO
        while ( ($Holiday = ClxCommon::$db->getNextRecord ( $Holidays, ASSOCIATIVE )) == true ) {
            foreach ($Holiday as $key => $val) 
                $Array_Holidays[]=$val;
        }

        //CICLO PARA ENCONTRAR LA FECHA DE RESOLUCION TOMANDO EN ENCUENTA DIAS HABILES
        $i = 0;
        while ($i < $days) {
            //INCREMENTAMOS EN UN DIA LA FECHA DE ENTRADA
            $fromDate = date("Y-m-d", strtotime($fromDate."+ 1 days"));
            //SE TOMA LA FECHA Y SE BUSCA EN EL ARREGLO DE DIAS FERIADOS 
            if (!in_array($fromDate, $Array_Holidays)) {
                //SI NO ESTA LA FECHA EN EL ARREGLO DE DIAS FERIADOS SE INCREMENTA $i PARA CONTABILIZAR UN DIA PARA LA FECHA DE RESOLUCION
                $i++;
            }
        }
        // SE RETORNA LA FECHA DE RESOLUCION
        return $fromDate;
    }

    //01-06-2020 EC: CASO 1004105, FUNCION QUE REALIZA EL CONTROL DE ACCESO PARA EDICION y VISUALIZACION DE LOS ARCHIVOS ADJUNTOS DE UN CASO. 
    function control_Access_Attachment(&$record){
        //global $ac ; 
        $ac = UserRequest::$request['ac'];
        //SI LA ACCION ES CREAR HABILITO PARA SU EDICION LOS ARCHIVOS ADJUNTOS
        if ($ac == 'CREATE'){
            $record['SRRQ_ATTACHMENT_EDIT']='1';
            $record['SRRQ_ATTACHMENT2_EDIT']='1';
            $record['SRRQ_ATTACHMENT3_EDIT']='1';

            $record['SRRQ_ATTACHMENTS_LOAD_DISABLED']='0';
            $record['SRRQ_ATTACHMENTS2_LOAD_DISABLED']='0';
            $record['SRRQ_ATTACHMENTS3_LOAD_DISABLED']='0';

        }

        //CASO 1004487: E.C 07-07-2021
        //SI LA ACCION ES MODIFICAR QUEDAN INHABILITADOS PARA SU EDICION LOS ARCHIVOS ADJUNTOS YA SUBIDOS Y 
        //SOLO SE PERMITIRA ACCESO EN AQUELLOS DISPONIBLES.
        //SOLO EL DUEÑO DEL ARCHIVO PODRÁ INHABILITARLOS LOS ARCHIVOS SUBIDOS
        //LA INHABILITACION DE LOS DOCUMENTOS SE REALIZA POR JAVASCRIPT EN LA FORMA REQUEST.

        if ($ac == 'MODIFY'){
            $temp=array();

            //SI EL DUEÑO DEL DOC ES DISTINTO AL USUARIO DE SESION INHABILITA LISTA
            if ($record['SRRQ_ATTACHMENTS_OWNER'] != $_SESSION['user_record']['username'] ){
                $record['SRRQ_ATTACHMENT_EDIT']='0';
            }else{
                $record['SRRQ_ATTACHMENT_EDIT']='1';
            }

            //SI EL DUEÑO DEL DOC ES DISTINTO AL USUARIO DE SESION INHABILITA LISTA
            if ($record['SRRQ_ATTACHMENTS2_OWNER'] != $_SESSION['user_record']['username']){
                $record['SRRQ_ATTACHMENT2_EDIT']='0';
            }else{
                $record['SRRQ_ATTACHMENT2_EDIT']='1';
            }
            //SI EL DUEÑO DEL DOC ES DISTINTO AL USUARIO DE SESION INHABILITA LISTA
            if ($record['SRRQ_ATTACHMENTS3_OWNER'] != $_SESSION['user_record']['username']){
                $record['SRRQ_ATTACHMENT3_EDIT']='0';
            }else{
                $record['SRRQ_ATTACHMENT3_EDIT']='1';
            }


            //SI HAY UN ARCHIVO CARGADO SE DEBE INHABILITAR QUE SE PUEDA CAMBIAR EL ARCHIVO
            if ($record['SRRQ_ATTACHMENTS'] == '0'){ 
                $record['SRRQ_ATTACHMENTS_LOAD_DISABLED']='0';
                //$temp['SRRQ_ATTACHMENTS']=$record['SRRQ_ATTACHMENTS'];
            }else{
                $record['SRRQ_ATTACHMENTS_LOAD_DISABLED']='1';
                $temp['SRRQ_ATTACHMENTS']=$record['SRRQ_ATTACHMENTS'];
            }

            //SI HAY UN ARCHIVO CARGADO SE DEBE INHABILITAR QUE SE PUEDA CAMBIAR EL ARCHIVO
            if ($record['SRRQ_ATTACHMENTS2'] == '0'){
                $record['SRRQ_ATTACHMENTS2_LOAD_DISABLED']='0';
                //$temp['SRRQ_ATTACHMENTS2']=$record['SRRQ_ATTACHMENTS2'];
            }else{
                $record['SRRQ_ATTACHMENTS2_LOAD_DISABLED']='1';
                $temp['SRRQ_ATTACHMENTS2']=$record['SRRQ_ATTACHMENTS2'];
            }

            //SI HAY UN ARCHIVO CARGADO SE DEBE INHABILITAR QUE SE PUEDA CAMBIAR EL ARCHIVO
            if ($record['SRRQ_ATTACHMENTS3'] == '0'){
                $record['SRRQ_ATTACHMENTS3_LOAD_DISABLED']='0';
                //$temp['SRRQ_ATTACHMENTS3']=$record['SRRQ_ATTACHMENTS3'];
            }else{
                $record['SRRQ_ATTACHMENTS3_LOAD_DISABLED']='1';
                $temp['SRRQ_ATTACHMENTS3']=$record['SRRQ_ATTACHMENTS3'];
            }
            //AL INHABILITAR LOS DOCS ESTOS NO SE ENVIAN CON EL FORMULARIO SI YA TENIA ASOCIADOS ARCHIVOS AL CASO. PARA EVITAR ESTO LLEVO LOS DOC REGISTRADOS A LA SESSION PARA LUEGO EVITAR QUE SEAN BORRADOS AL MODIFICAR EL CASO
            $_SESSION['SRRQ_ATTACHMENTS_TMP']=$temp;

        }
    }

    function print_case(){
        //global $ac, $idlist; 
        $idlist = getIdlist();
        UserRequest::$request["qy"]='REQUESTS';
        UserRequest::$request["li"]='REQUESTS';
        UserRequest::$request["ac"]='DISPLAY';
        UserRequest::$request["print"]='1';
        $ac=UserRequest::$request["ac"];
        $listingcode=UserRequest::$request ["li"];
        
        //pre($_SESSION);
        
        //El ajuste temporal del valor isadmin de la sesion es para que muestre los listados de casos al imprimir
        $bandera=0;
        if ($_SESSION['user_record']['isadmin']==0){
            $_SESSION['user_record']['isadmin']=1;
            $bandera=1;
        }


        $EDIT = &getTool ('EDIT');
        $contents = $EDIT->action($ac, $idlist);
        $contents.= "<script>$(document).ready(function () {
			window.focus();
			window.print();
		});
		</script>";

        //Si hubo ajuste del valor isadmin entonces reversamos a su estado original
        if ($bandera==1){
            $_SESSION['user_record']['isadmin']=0;
        }
        
        return $contents;
    }

    //Función que guarda un nuevo estado del caso en REQUEST_STATUS por cada caso modificado
    function save_req_status($idlist){
        //$rec = $EDIT->prepareRecord($formrec, $tablerec, 0);
        //global $db;
        $idlist_string = toString($idlist);
        if ($idlist_string!=''){
            $sql = "SELECT * FROM
				SERV_REQUESTS
				WHERE
				ID IN ($idlist_string)";
            $results = ClxCommon::$db->executeQuery ( $sql );

            while ( ($result = ClxCommon::$db->getNextRecord ( $results, ASSOCIATIVE )) == true ) {
                //pre ($result); 
                $this->createSrrs($result);
            }
        }
    }


    //Función para actualizar Nombre del Cliente  y Numero Externo (IBS CUSCUN)
    function get_clientName(&$record) {
        //		$recid_string = toString($srrq_id);
        $rec ['REQUESTCODE'] = $record ['IDCODE'];
        //global $db;
        $sql = "UPDATE SERV_REQUESTS SRRQ
				SET IBS_CUSCUN=(SELECT ACCO.IBS_CUSCUN FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE=SRRQ.ACCOUNTCODE)" .
            "WHERE SRRQ.IDCODE=" . singlequote($rec ['REQUESTCODE']) ; 
        
        /*$sql = "UPDATE SERV_REQUESTS SRRQ
				SET CLIENT_NAME=(SELECT  ACCO.LEGAL_NAME FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE=SRRQ.ACCOUNTCODE) 
				,IBS_CUSCUN=(SELECT ACCO.IBS_CUSCUN FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE=SRRQ.ACCOUNTCODE)" .
            "WHERE SRRQ.IDCODE=" . singlequote($rec ['REQUESTCODE']) ; */

        /*$sql = "UPDATE SERV_REQUESTS SRRQ
				SET CLIENT_NAME=(SELECT  IF(ACCO.ISINDIVIDUAL=1, CONCAT(ACCO.LASTNAME, 
				  IF(ACCO.SECOND_LASTNAME <> '',CONCAT(' ', ACCO.SECOND_LASTNAME),''), ',' ,ACCO.FIRSTNAME)
				  , ACCO.LEGAL_NAME) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE=SRRQ.ACCOUNTCODE) 
				,IBS_CUSCUN=(SELECT ACCO.IBS_CUSCUN FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE=SRRQ.ACCOUNTCODE)" .
				"WHERE SRRQ.IDCODE=" . singlequote($rec ['REQUESTCODE']) ; 
		$sql = "UPDATE CRM_ACCOUNTS
				SET LEGAL_NAME = IF(ISINDIVIDUAL=1, CONCAT(ACCO.FIRSTNAME,IF(SECOND_NAME <> '', CONCAT(' ', SECOND_NAME), '' ),
									CONCAT(' ',ACCO.LASTNAME),
									IF(MARRIED_LASTNAME <> '' AND  MARITAL_STATUS = 'MA',  CONCAT(' DE ', MARRIED_LASTNAME), ''), 
									IF(MARRIED_LASTNAME <> '' AND MARITAL_STATUS='WI',  CONCAT(' VIUDA DE ', MARRIED_LASTNAME), ''), 
									IF(SECOND_LASTNAME <> '', CONCAT(' ',SECOND_LASTNAME), '') ), 
									LEGAL_NAME)
				WHERE MARRIED_LASTNAME <> '' AND SRRQ.IDCODE=" . singlequote($rec ['REQUESTCODE']);*/

        $results = ClxCommon::$db->executeQuery ( $sql );

    }

    //Función para dar mantenimiento a la tabla SRAP
    function update_area_participant(&$record) {
        //global $db;
        $rec['AREACODE'] = $record ['AREACODE'];
        $rec['ROLE_CODE'] = $record ['ROLE_CODE'];

        if ($rec['AREACODE'] and $rec['ROLE_CODE']){	
            $condicion = "AREACODE = ".singlequote($rec['AREACODE']);
        }else{	
            $condicion = " AREACODE IN (SELECT AREACODE FROM SERV_AREA_NOTIFICATIONS SRAN WHERE ROLE_CODE = ".singlequote($rec['ROLE_CODE']).")";
        }

        $sqlD = "DELETE FROM SERV_AREA_PARTICIPANTS WHERE ". $condicion;
        $results = ClxCommon::$db->executeQuery ($sqlD);
        $sqlI = "INSERT INTO SERV_AREA_PARTICIPANTS (AREACODE, USER_CODE)
					SELECT DISTINCT 
					SRAN.AREACODE
					,SRRP.USER_CODE
					FROM SERV_AREA_NOTIFICATIONS SRAN
						 JOIN SERV_ROLE_PARTICIPANTS SRRP
						   ON SRAN.ROLE_CODE = SRRP.ROLE_CODE
					 WHERE SRRP.ROLE_CODE = SRAN.ROLE_CODE
					 AND ". $condicion;	 
        $results = ClxCommon::$db->executeQuery ($sqlI);	

    }

    function contruct_attachment_import(&$msg, &$record){
        $path_file_import=companyParameter('CRM_FILE_IMPORT', '');
        //path destino de los archivos importados
        $path='data/files/';
        $SDFL = &getTool('SDFL');
        $user_initiator=$record['OWNERCODE_IMPORT'];
        //MOVIENDO EL PRIMER ATTACHMENT
        if (array_key_exists ('ATTACHMENTS_NAME', $record )) {
            $path_file=$path_file_import.$record['ATTACHMENTS_NAME'];
            if (file_exists($path_file)){
                $name = $record['ATTACHMENTS_NAME'];
                $extension = pathinfo($path_file, PATHINFO_EXTENSION);
                $mime = ClxCommon::$db->getRecord('CLX_SD_MIMETYPES', 'EXTENSION=' . singleQuote($extension));
                $type= $mime['IDCODE'];
                $contents = file_get_contents($path_file);
                $record['ATTACHMENTS'] = $SDFL->saveFile($name, $type, $contents, 0, $path);
                $record['ATTACHMENTS_OWNER']=$user_initiator;
            }else{
                $record['ATTACHMENTS']=0;
            }    
        }

        //MOVIENDO EL SEGUNDO ATTACHMENT
        if (array_key_exists ('ATTACHMENTS2_NAME', $record )) {
            $path_file=$path_file_import.$record['ATTACHMENTS2_NAME'];
            //echo $path_file.': '.file_exists($path_file); 
            if (file_exists($path_file)){
                $name = $record['ATTACHMENTS2_NAME'];
                $extension = pathinfo($path_file, PATHINFO_EXTENSION);
                $mime = ClxCommon::$db->getRecord('CLX_SD_MIMETYPES', 'EXTENSION=' . singleQuote($extension));
                $type= $mime['IDCODE'];
                $contents = file_get_contents($path_file);
                $record['ATTACHMENTS2'] = $SDFL->saveFile($name, $type, $contents, 0, $path);
                $record['ATTACHMENTS2_OWNER']=$user_initiator;
            }else{
                $record['ATTACHMENTS2']=0;
            }    
        }

        //MOVIENDO EL TERCER ATTACHMENT
        if (array_key_exists ('ATTACHMENTS3_NAME', $record )) {
            $path_file=$path_file_import.$record['ATTACHMENTS3_NAME'];
            //echo $path_file.': '.file_exists($path_file); 
            if (file_exists($path_file)){
                $name = $record['ATTACHMENTS3_NAME'];
                $extension = pathinfo($path_file, PATHINFO_EXTENSION);
                $mime = ClxCommon::$db->getRecord('CLX_SD_MIMETYPES', 'EXTENSION=' . singleQuote($extension));
                $type= $mime['IDCODE'];
                $contents = file_get_contents($path_file);
                $record['ATTACHMENTS3'] = $SDFL->saveFile($name, $type, $contents, 0, $path);
                $record['ATTACHMENTS3_OWNER']=$user_initiator;
            }else{
                $record['ATTACHMENTS3']=0;
            }    
        }
        
        //OBTENIENDO CUENTA SEGUN  EL IBS_CUSCUN IMPORTADO
        if (array_key_exists ('IBS_CUSCUN_IMPORT', $record )) {
            $ibs_cuscun=trim($record['IBS_CUSCUN_IMPORT']);
            if ($ibs_cuscun!=''){
                $sql = 'SELECT ACCO.IDCODE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IBS_CUSCUN='.singleQuote($ibs_cuscun); 
                $r = ClxCommon::$db->getOneRecord($sql);
                if(!empty($r)){
                    $record['ACCOUNTCODE'] = $r['IDCODE'];
                }
            }    
        }
        
        //OBTENIENDO EL CAMPO ASUNTO SI ESTA PREDEFINIDO 
        $sql = "SELECT SUBJECT FROM SERV_REQTYPES_TBL WHERE IDCODE = '" . $record['REQTYPE'] . "' AND SRAR_CODE='".$record['AREACODE']."'" ;
        $r = ClxCommon::$db->getOneRecord($sql);
        if($r['SUBJECT']!=''){
            $record['SUBJECT'] = $r['SUBJECT']; 
        }

        //OBTENIENDO EL ID DEL  PRODUCTO DEL CLIENTE 
        if (array_key_exists ('ACCOUNTPRODUCTCODE_IMPORT', $record )) {
            if ($record['ACCOUNTPRODUCTCODE_IMPORT']!=''){
                //BUSCAMOS EL ID DEL PRODUCTO
                $sql = "SELECT ACPS.IDCODE, ACPS.ID FROM CRM_ACCOUNT_PRODUCTS ACPS WHERE
                    ACPS.ACCOUNTCODE = '".$record['ACCOUNTCODE']."' AND
                    ACPS.IDCODE = '".$record['ACCOUNTPRODUCTCODE_IMPORT']."'";
                $r = ClxCommon::$db->getOneRecord($sql);
                if(!empty($r)){
                    $record['ACCOUNTPRODUCTCODE'] = $r['ID'];
                }else{
                    $record['ACCOUNTPRODUCTCODE'] = NULL;
                }
            }
        }  
        
        // 2020-05-26 SA: CASO 1004103. CALCULAR FECHA ESTIMADA DE RESOLUCION;
        if (array_key_exists ('COMP_CODE', $record )&&array_key_exists ('REQTYPE', $record )) {
            if ($record['COMP_CODE'] == 'BNP' && $record['REQTYPE'] >= 101 && $record['REQTYPE'] <= 305) {
                 // CALCULAR FECHA DE RESOLUCION SEGUN DIAS DEFINIDOS EN EL PARAMETRO SERV_BUSINESS_DAYS_RESOLUTION
                $days_resolution=companyParameter('SERV_BUSINESS_DAYS_RESOLUTION', $record['COMP_CODE']);
                if(!empty($days_resolution)){
                    //CALCULA FECHA DE RESOLUCION TOMANDO EN CUENTA DIAS CONTINUOS
                    $record['TGTRESOL_DTTM'] = date("Y-m-d", strtotime($record['EFFTDATETIME']."+ $days_resolution days"));
                    //CALCULA FECHA DE RESOLUCION TOMANDO EN CUENTA DIAS HABILES DEL CALENDARIO
                    //$record['TGTRESOL_DTTM']= $this->calcResolutionDays($record['COMP_CODE'],$record['EFFTDATETIME'], $days_resolution);
                }
            }
        }
        
        //corregimos un detalle del importador
        if ($record['TGTRESOL_DTTM']=='00-00-00'){
            $sql='UPDATE '. $this->srrqname .' SET TGTRESOL_DTTM=NULL WHERE IDCODE='.singlequote($record['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
        }
        
        //corregimos un detalle del importador
        if ($record['ACCOUNTPRODUCTCODE']==NULL){
            $sql='UPDATE '. $this->srrqname .' SET ACCOUNTPRODUCTCODE=NULL WHERE IDCODE='.singlequote($record['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
        }else{
            $sql='UPDATE '. $this->srrqname .' SET ACCOUNTPRODUCTCODE='.singlequote($record['ACCOUNTPRODUCTCODE']).' WHERE IDCODE='.singlequote($record['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
        }       

        //ACTUALIZANDO DATOS EN EL CASO
        if (array_key_exists ('ATTACHMENTS_NAME', $record ) && array_key_exists ('ATTACHMENTS2_NAME', $record ) && array_key_exists ('ATTACHMENTS3_NAME', $record )){
            //actualizo en el caso el id asignado a cada attachment
            $reg=array ('ATTACHMENTS' => $record['ATTACHMENTS'], 'ATTACHMENTS2' => $record['ATTACHMENTS2'], 'ATTACHMENTS3' => $record['ATTACHMENTS3'], 
                        'ATTACHMENTS_OWNER' => $record['ATTACHMENTS_OWNER'], 'ATTACHMENTS2_OWNER' => $record['ATTACHMENTS2_OWNER'], 'ATTACHMENTS3_OWNER' => $record['ATTACHMENTS3_OWNER'],
                        'ACCOUNTCODE' => $record['ACCOUNTCODE'], 'SUBJECT' => $record['SUBJECT'],  'OWNERCODE' => $user_initiator
                       );
            ClxCommon::$db->updateRecord ( $this->srrqname, $reg , 'IDCODE = '.singlequote($record['IDCODE']));
        }

    }

    function validate_attachment_import(&$msg, &$record){
       $status=true;
        //VALIDANDO QUE EXISTA EL PARAMETRO  CRM_FILE_IMPORT
       $path_file_import=companyParameter('CRM_FILE_IMPORT', ''); 
       if (empty($path_file_import)){ 
           $msg ['SRRQ_ATTACHMENTS'] = dict ('ERR_NOTROOT_FILE_IMPORT');
           return false;
       }

        //VALIDANDO QUE EXISTA EL ARCHIVO EN EL DIRECTORIO DE IMPORTACIÓN
       if (array_key_exists ('SRRQ_ATTACHMENTS_NAME', $record )) {
          $path_file=$path_file_import.$record['SRRQ_ATTACHMENTS_NAME'];
          $name_file=trim($record['SRRQ_ATTACHMENTS_NAME']);
          if (!file_exists($path_file)&&$name_file!=''){
              $msg ['SRRQ_ATTACHMENTS'] = dict ('GEN_ERR_FILE_NOTFOUND', $name_file);
              $status = false;
          }    
       }        

       //VALIDANDO QUE EXISTA EL ARCHIVO EN EL DIRECTORIO DE IMPORTACIÓN
       if (array_key_exists ('SRRQ_ATTACHMENTS2_NAME', $record )) {
           $path_file=$path_file_import.$record['SRRQ_ATTACHMENTS2_NAME'];
           $name_file=trim($record['SRRQ_ATTACHMENTS2_NAME']);
          if (!file_exists($path_file)&&$name_file!=''){
               $msg ['SRRQ_ATTACHMENTS2'] = dict ('GEN_ERR_FILE_NOTFOUND', $name_file);
              $status = false;
          }    
       }        

       //VALIDANDO QUE EXISTA EL ARCHIVO EN EL DIRECTORIO DE IMPORTACIÓN
       if (array_key_exists ('SRRQ_ATTACHMENTS3_NAME', $record )) {
           $path_file=$path_file_import.$record['SRRQ_ATTACHMENTS3_NAME'];
           $name_file=trim($record['SRRQ_ATTACHMENTS3_NAME']);
           if (!file_exists($path_file)&&$name_file!=''){
               $msg ['SRRQ_ATTACHMENTS3'] = dict ('GEN_ERR_FILE_NOTFOUND', $name_file);
               $status = false;
           }    
       }
       
       //VALIDANDO QUE EXISTA EL IBS_CUSCUN A IMPORTAR
       $accountcode='';
       if (array_key_exists ('SRRQ_IBS_CUSCUN_IMPORT', $record )) {
           $ibs_cuscun=trim($record['SRRQ_IBS_CUSCUN_IMPORT']);
           if ($ibs_cuscun!=''){
               $sql = 'SELECT ACCO.IDCODE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IBS_CUSCUN='.singleQuote($ibs_cuscun); 
               $r = ClxCommon::$db->getOneRecord($sql);
               if(empty($r)){
                   $msg ['SRRQ_IBS_CUSCUN'] = dict ('ERR_IBS_CUSCUN_NOTFOUND');
                   $status = false;
               }else{
                   $accountcode = $r['IDCODE'];
               }
           }    
       }

       //VALIDANDO QUE NO ESTA PREDEFINIDO EL ASUNTO. SI ES ASI COLOCO COMO REQUERIDO EN LA IMPORTACIÓN DE CASO
       $sql = "SELECT SUBJECT FROM SERV_REQTYPES_TBL WHERE IDCODE = '" . $record['SRRQ_REQTYPE'] . "' AND SRAR_CODE='".$record['SRRQ_AREACODE']."'" ;
       $r = ClxCommon::$db->getOneRecord($sql);
       if($r['SUBJECT']==''){
           if ($record['SRRQ_SUBJECT']==''){
               $msg ['SRRQ_SUBJECT'] = dict ('ERR_SRRQ_SUBJECT');
               $status = false;
           }    
       }

        //VALIDANDO QUE EL USUARIO ASIGNADO EXISTA
       if (array_key_exists ('SRRQ_ASSIGNEDTO_USER', $record )) {
            if ($record['SRRQ_ASSIGNEDTO_USER']!=''){
                //verificamos que el valor indicado en usuario existe realmente
                $sql = "SELECT COUNT(CLXU.ID)
                    FROM  CLX_AC_USERS CLXU 
                    WHERE
                    CLXU.USERNAME IN ('".$record['SRRQ_ASSIGNEDTO_USER']."')";
                if(ClxCommon::$db->getOne($sql)==0){
                    // si no existe ese usuario mostramos un mensaje
                    $msg['SRRQ_ASSIGNEDTO_USER'] = dict('ERR_USER_NO_RECORD');
                    $status = false;
                }
            }
        }
        
        //VALIDANDO QUE EL USUARIO DUEÑO DEL CASO O ADJUNTOS
        if (array_key_exists ('SRRQ_OWNERCODE_IMPORT', $record )) {
                //verificamos que el valor indicado en usuario existe realmente
                $sql = "SELECT COUNT(CLXU.ID)
                    FROM  CLX_AC_USERS CLXU 
                    WHERE
                    CLXU.USERNAME IN ('".$record['SRRQ_OWNERCODE_IMPORT']."')";
                if(ClxCommon::$db->getOne($sql)==0){
                    // si no existe ese usuario mostramos un mensaje
                    $msg['SRRQ_OWNERCODE'] = dict('ERR_USER_NO_RECORD');
                    $status = false;
                }
        }

        //VALIDANDO QUE EL PRODUCTO DEL CLIENTE PERTENEZCA A ESE CLIENTE
        if (array_key_exists ('SRRQ_ACCOUNTPRODUCTCODE_IMPORT', $record )) {
            if ($record['SRRQ_ACCOUNTPRODUCTCODE_IMPORT']!=''){
                //verificamos que el producto indicado exista para ese cliente
                $sql = "SELECT COUNT(ACPS.IDCODE) FROM  CRM_ACCOUNT_PRODUCTS ACPS WHERE
                    ACPS.ACCOUNTCODE = '".$accountcode."' AND
                    ACPS.IDCODE = '".$record['SRRQ_ACCOUNTPRODUCTCODE_IMPORT']."'";
                if(ClxCommon::$db->getOne($sql)==0){
                    $msg['SRRQ_ACCOUNTPRODUCTCODE'] = dict('ERR_ACCOUNTPRODUCTCODE');
                    $status = false;
                }
            }
        }

        return $status;
    }
    
    function nulleable_AccountProductCode(&$record){    
        //corregimos un detalle del importador
        if ($record['ACCOUNTPRODUCTCODE']==null || $record['ACCOUNTPRODUCTCODE']==0 || $record['ACCOUNTPRODUCTCODE']==''){
            $sql='UPDATE '. $this->srrqname .' SET ACCOUNTPRODUCTCODE=NULL WHERE IDCODE='.singlequote($record['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            ClxCommon::$db->commit();
        } 
    }
} // end class
?>