<?php
/**
* General Code File
* For more information contact  support@alenet.com
* 
* @author       $Author: cramirez $
* @copyright    Alenet, Inc.
* @since        $Date: 2015-09-18 13:47:21 -0500 (vie, 18 sep 2015) $
* @version        $Rev: 6937 $
* 
* CHANGE LOG
* 2009/09/02 Included svn prop
* 2020/03/18: [SA] MEJORAS BNP. 
*/
class trmo_utitities {

	/**
	 * Constructor
	 */
	// 20200911-Edgard: Creación TRfileMO utilities
	function trmo_utitities() {
		multiTableName ( $this, array (
				'TMAL',
				'TMAH',
				'TMAC'
		) );
	} // end function
	
	/**
	 * TAML Validation
	 * 
	 * @param array $msg        	
	 * @param array $record        	
	 * @return boolean
	 */
	function validateTmal(&$msg, &$record) {
		$status = true;
		
		//01-06-2020 EC: CASO 1004105, COLOCA USUARIOS CREADOR DE LOS DOCUMENTOS ADJUNTOS AL CASO
		$ac=UserRequest::$request['ac'];
		$user_initiator=$_SESSION['user_record']['username'];
		
		//01-06-2020 EC: CASO 1004105, COLOCA USUARIOS CREADOR DE LOS DOCUMENTOS ADJUNTOS AL CASO
		if ($ac == 'CREATE') {
			if (UserRequest::$files['TMAL_ATTACHMENT1']['name'] != '') {
				$record['TMAL_ATTACHMENT1_OWNER'] =   $user_initiator ;
			}else{
				$record['TMAL_ATTACHMENT1_OWNER']= '';
			}
			if (UserRequest::$files['TMAL_ATTACHMENT2']['name'] != '') {
				$record['TMAL_ATTACHMENT2_OWNER'] =   $user_initiator ;
			}else{
				$record['TMAL_ATTACHMENT2_OWNER'] = '';
			}
			if (UserRequest::$files['TMAL_ATTACHMENT3']['name'] != '') {
				$record['TMAL_ATTACHMENT3_OWNER'] =   $user_initiator ;
			}else{
				$record['TMAL_ATTACHMENT3_OWNER'] = '';
			}
		}

		
		//01-06-2020 EC: CASO 1004105, SI LA ACCION ES MODIFICAR ESTARAN DESHABILITADOS ALGUNOS O TODOS LOS ATTACHMENTS Y NO SE ENVIARAN CON EL FORMULARIO. TENEMOS QUE COSTRUIR LA VARIABLE _FILES PARA QUE NO BORRE LOS ARCHIVOS YA ADJUNTADOS AL CASO
		if ($ac == 'MODIFY') {
		   //$record=array_merge($record, $_SESSION['SRRQ_ATTACHMENTS_TMP']);
			 $datos_archivo=array('name'=>'', 'type' => '', 'tmp_name'=>'', 'error'=> 4, 'size'=> 0);
			 if (!$record['TMAL_ATTACHMENT_EDIT']){
			 	UserRequest::$files['TMAL_ATTACHMENT1']=$datos_archivo;
			 }
			 if (!$record['TMAL_ATTACHMENT2_EDIT']){
				UserRequest::$files['TMAL_ATTACHMENT2']=$datos_archivo;  
				$record['TMAL_ATTACHMENT2']='';
			 }
			 if (!$record['TMAL_ATTACHMENT3_EDIT']){
			 	UserRequest::$files['TMAL_ATTACHMENT3']=$datos_archivo; 
				$record['TMAL_ATTACHMENT3']='';
			 }
		}
		if (UserRequest::$files['TMAL_ATTACHMENT1']['name'] != '') {
			$record['TMAL_ATTACHMENT1_OWNER'] =   $user_initiator ;
		}
		if (UserRequest::$files['TMAL_ATTACHMENT2']['name'] != '') {
			$record['TMAL_ATTACHMENT2_OWNER'] =   $user_initiator ;
		}
		if (UserRequest::$files['TMAL_ATTACHMENT3']['name'] != '') {
			$record['TMAL_ATTACHMENT3_OWNER'] =   $user_initiator ;
		}
		return $status;
		
	} // end method
	
	
  //01-06-2020 EC: CASO 1004105, FUNCION QUE REALIZA EL CONTROL DE ACCESO PARA EDICION y VISUALIZACION DE LOS ARCHIVOS ADJUNTOS DE UN CASO. 
	function control_Access_Attachment(&$record){
		$ac = UserRequest::$request['ac']; 
		//SI LA ACCION ES CREAR HABILITO PARA SU EDICION LOS ARCHIVOS ADJUNTOS
		if ($ac == 'CREATE'){
			$record['TMAL_ATTACHMENT_EDIT']='1';
			$record['TMAL_ATTACHMENT2_EDIT']='1';
			$record['TMAL_ATTACHMENT3_EDIT']='1';
		}

		//SI LA ACCION ES MODIFICAR QUEDAN INHABILITADOS PARA SU EDICION LOS ARCHIVOS ADJUNTOS Y SOLO SE PERMITIRA ACCESO AL CAMPO DOCUMENTO INHABILTADO PARA SER EDITADO SOLO POR EL DUEÑO DEL DOCUMENTO. LA INHABILITACION DE LOS DOCUMENTOS SE REALIZA POR JQUERY EN LA FORMA REQUEST.
		if ($ac == 'MODIFY'){
			
			$temp=array();
			//SI EL DUEÑO DEL DOC ES DISTINTO AL USUARIO DE SESION INHABILITA
			if ($record['TMAL_ATTACHMENT1_OWNER'] != $_SESSION['user_record']['username'] ){
				 $record['TMAL_ATTACHMENT_EDIT']='0';
				 $temp['TMAL_ATTACHMENT1']=$record['TMAL_ATTACHMENT1'];
			}else{
				 $record['TMAL_ATTACHMENT_EDIT']='1';
				 $temp['TMAL_ATTACHMENT1']=$record['TMAL_ATTACHMENT1'];
			}
			if ($record['TMAL_ATTACHMENT1_OWNER']==''){
				 $record['TMAL_ATTACHMENT_EDIT']='1';
				 $temp['TMAL_ATTACHMENT1']=$record['TMAL_ATTACHMENT1'];
			}

			//SI EL DUEÑO DEL DOC ES DISTINTO AL USUARIO DE SESION INHABILITA
			if ($record['TMAL_ATTACHMENT2_OWNER'] != $_SESSION['user_record']['username']){
				 $record['TMAL_ATTACHMENT2_EDIT']='0';
				 $temp['TMAL_ATTACHMENT2']=$record['TMAL_ATTACHMENT2'];
			}else{
				 $record['TMAL_ATTACHMENT2_EDIT']='1';
				 $temp['TMAL_ATTACHMENT2']=$record['TMAL_ATTACHMENT2'];
			}
			if ($record['TMAL_ATTACHMENT2_OWNER']==''){
				 $record['TMAL_ATTACHMENT2_EDIT']='1';
				 $temp['TMAL_ATTACHMENT2']=$record['TMAL_ATTACHMENT2'];
			}

			//SI EL DUEÑO DEL DOC ES DISTINTO AL USUARIO DE SESION INHABILITA
			if ($record['TMAL_ATTACHMENT3_OWNER'] != $_SESSION['user_record']['username']){
				 $record['TMAL_ATTACHMENT3_EDIT']='0';
				 $temp['TMAL_ATTACHMENT3']=$record['TMAL_ATTACHMENT3'];
			}else{
				 $record['TMAL_ATTACHMENT3_EDIT']='1';
				 $temp['TMAL_ATTACHMENT3']=$record['TMAL_ATTACHMENT3'];
			}
			if ($record['TMAL_ATTACHMENT3_OWNER']==''){
				 $record['TMAL_ATTACHMENT3_EDIT']='1';
				 $temp['TMAL_ATTACHMENT3']=$record['TMAL_ATTACHMENT3'];
			}

		}
	}
		

	/**
	 * Initialice notes
	 * 
	 * @param array $record        	
	 */
	function initNotes(&$record) {
		// $record['SRRQ_NOTES']='';
		// $record['SRRQ_EFFTDATETIME']='now';
	} // end method
	
	/**
	 * createTmah
	 * 
	 * @param array $record        	
	 */
	function createTmah(&$record) {
	   global $db;
		
	   $rec = array ();
	   $results = ClxCommon::$db->executeQuery('SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS 
										WHERE TABLECODE = ' . singleQuote('TMAH') . ' AND FIELDNAME <> ' . singleQuote('ID'));
       while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		    if ($result ['FIELDNAME'] === 'TMAL_CODE') {
			 $rec ['TMAL_CODE'] = $record ['IDCODE'];
			 continue;
		  }
		  if (array_key_exists($result ['FIELDNAME'], $record)) {
			 $rec [$result ['FIELDNAME']] = $record [$result ['FIELDNAME']];
		  }
        }
       ClxCommon::$db->freeResult($results);
	   if (!empty($rec)){
		  ClxCommon::$db->createRecord($this->tmahname, $rec, false);
	   }
	} // end method
	  
	
} // end class
?>