<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-17 18:43:20 -0400 (Sat, 17 Oct 2015) $
 * @version        $Rev: 7344 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
function defaultCardRecord() {
    $card_record = array();
    // Contact
    $card_record ['FULLNAME'] = '';
    $card_record ['LASTNAME'] = '';
    $card_record ['FIRSTNAME'] = '';
    $card_record ['SECOND_LASTNAME'] = '';
    $card_record ['PREFIX'] = '';
    $card_record ['SUFIX'] = '';
    // Phone
    $card_record ['WORK_PHONE'] = '';
    $card_record ['WORK_PHONE_FAX'] = '';
    $card_record ['WORK_PHONE_PREF'] = '';
    // Emails
    $card_record ['WORK_EMAIL'] = '';
    $card_record ['HOME_EMAIL'] = '';
    $card_record ['PREF_EMAIL'] = '';
    // Work address
    $card_record ['WORK_POBOX'] = '';
    $card_record ['WORK_ADDRESS1'] = '';
    $card_record ['WORK_ADDRESS2'] = '';
    $card_record ['WORK_CITY'] = '';
    $card_record ['WORK_STATE'] = '';
    $card_record ['WORK_ZIPCODE'] = '';
    $card_record ['WORK_COUNTRY'] = '';
    // set the General title
    $card_record ['TITLE'] = '';
    return $card_record;
}

// End function
/**
 * Builds Vcard String
 */
function buildVcard($card_record) {
    ini_set('include_path', kPathToWebSite . kPathToPear);
    include_once 'Vcard/Contact_Vcard_Build.php';
    if (!class_exists('Contact_Vcard_Build')) {
        return alert('Vcard Class Missing. Please Contact Administrator');
        salir();
    }
    $vcard = new Contact_Vcard_Build ();
    $vcard->setFormattedName($card_record ['FULLNAME']); // set a formatted
    // name
    $vcard->setName($card_record ['LASTNAME'], $card_record ['FIRSTNAME'], $card_record ['SECOND_LASTNAME'], $card_record ['PREFIX'], $card_record ['SUFIX']); // set
    // the
    // structured
    // name
    // parts
    $vcard->addTelephone($card_record ['WORK_PHONE']);
    $vcard->addParam('TYPE', 'WORK'); // Parameter
    $vcard->addTelephone($card_record ['WORK_PHONE_FAX']);
    $vcard->addParam('TYPE', 'FAX'); // Parameter
    $vcard->addTelephone($card_record ['WORK_PHONE_PREF']);
    $vcard->addParam('TYPE', 'PREF'); // Parameter
    $vcard->addEmail($card_record ['WORK_EMAIL']); // add a work email.
    $vcard->addParam('TYPE', 'WORK'); // Parameter
    $vcard->addEmail($card_record ['HOME_EMAIL']); // add a home/preferred
    // email
    $vcard->addParam('TYPE', 'HOME');
    $vcard->addEmail($card_record ['PREF_EMAIL']); // add a home/preferred
    // email
    $vcard->addParam('TYPE', 'PREF');
    // add a work address
    $vcard->addAddress($card_record ['WORK_POBOX'], $card_record ['WORK_ADDRESS1'], $card_record ['WORK_ADDRESS2'], $card_record ['WORK_CITY'], $card_record ['WORK_STATE'], $card_record ['WORK_ZIPCODE'], $card_record ['WORK_COUNTRY']);
    $vcard->addParam('TYPE', 'WORK');
    // set the title (checks for colon-escaping)
    $vcard->setTitle(str_replace(':', '\:', $card_record ['TITLE']));
    return $vcard->fetch();
}

// End function
/**
 * Send VCard for HTTP Download
 */
function downloadVcard($vcard, $id = CLX_NUM_ZERO) {
    header('Content-type: text/x-vCard');
    header('Content-Disposition: attachment; filename=clx ' . $id . '.vcf');
    header('Pragma: no-cache');
    header('Expires: 0');
    header('Cache-control: public');
    header('Content-Type: text/x-vCard'); // send the vcard
    echo stripslashes($vcard);
}

// End function
/**
 * Builds vcard
 *
 * @param unknown_type $type
 * @return string
 */
function buildContactVcard($type = 'ACCO') {
    $idlist = toString(getIdlist());
    if (empty($idlist))
        return CLX_CHAR_EMPTY_STRING;
    if ($type === 'ACCO') {
        $tablename = 'CRM_ACCOUNTS';
    } elseif ($type === 'CONT') {
        $tablename = 'CRM_CONTACTS';
    } else {
        $tablename = 'MARK_LEADS';
    }
    $results = ClxCommon::$db->getRecords($tablename, 'ID IN (' . $idlist . ')');
    while (($result = ClxCommon::$db->getNextRecord($results))) {
        $card_record = defaultCardRecord();
        if (empty($result ['SHORT_NAME'])) {
		  $result ['SHORT_NAME'] = $result ['LASTNAME'] . ',' . $result ['FIRSTNAME'];
        }
        $card_record ['FULLNAME'] = $result ['SHORT_NAME'];
        $card_record ['LASTNAME'] = $result ['LASTNAME'];
        $card_record ['FIRSTNAME'] = $result ['FIRSTNAME'];
        $card_record ['SECONDNAME'] = '';
        $card_record ['PREFIX'] = (array_key_exists('SALUTATION', $result)) ? $result ['SALUTATION'] : '';
        $card_record ['SUFIX'] = '';
        $card_record ['TITLE'] = $result ['TITLE'];
        // WORK PHONE
        $card_record ['WORK_PHONE'] = $result ['PHONE'];
        $card_record ['WORK_PHONE_FAX'] = $result ['FAX'];
        $card_record ['WORK_PHONE_PREF'] = $result ['MOBILE_PHONE'];
        // HOME PHONE
        $card_record ['HOME_PHONE'] = $result ['HOME_PHONE'];
        $card_record ['HOME_PHONE_FAX'] = $result ['FAX'];
        $card_record ['HOME_PHONE_PREF'] = $result ['HOME_PHONE'];
        $card_record ['WORK_EMAIL'] = $result ['EMAIL'];
        $card_record ['HOME_EMAIL'] = $result ['EMAIL_02'];
        $card_record ['PREF_EMAIL'] = $result ['EMAIL_03'];
        // ADDRESS
        if ($result ['LOCTYPE'] === 'H') {
		  // HOME ADDRESS
		  $card_record ['HOME_POBOX'] = '';
		  $card_record ['HOME_ADDRESS1'] = $result ['ADDRESS1'];
		  $card_record ['HOME_ADDRESS2'] = $result ['ADDRESS2'];
		  $card_record ['HOME_CITY'] = $result ['CITY'];
		  $card_record ['HOME_STATE'] = $result ['STATE'];
		  $card_record ['HOME_ZIPCODE'] = $result ['ZIPCODE'];
		  $card_record ['HOME_COUNTRY'] = $result ['COUNTRY'];
        } else {
		  $card_record ['WORK_POBOX'] = '';
		  $card_record ['WORK_ADDRESS1'] = $result ['ADDRESS1'];
		  $card_record ['WORK_ADDRESS2'] = $result ['ADDRESS2'];
		  $card_record ['WORK_CITY'] = $result ['CITY'];
		  $card_record ['WORK_STATE'] = $result ['STATE'];
		  $card_record ['WORK_ZIPCODE'] = $result ['ZIPCODE'];
		  $card_record ['WORK_COUNTRY'] = $result ['COUNTRY'];
        }
        if ($result ['LOCTYPE_02'] === 'H') {
		  // HOME ADDRESS
		  $card_record ['HOME_POBOX'] = '';
		  $card_record ['HOME_ADDRESS1'] = $result ['ADDRESS1_02'];
		  $card_record ['HOME_ADDRESS2'] = $result ['ADDRESS2_02'];
		  $card_record ['HOME_CITY'] = $result ['CITY_02'];
		  $card_record ['HOME_STATE'] = $result ['STATE_02'];
		  $card_record ['HOME_ZIPCODE'] = $result ['ZIPCODE_02'];
		  $card_record ['HOME_COUNTRY'] = $result ['COUNTRY_02'];
        } else {
		  $card_record ['WORK_POBOX'] = '';
		  $card_record ['WORK_ADDRESS1'] = $result ['ADDRESS1_02'];
		  $card_record ['WORK_ADDRESS2'] = $result ['ADDRESS2_02'];
		  $card_record ['WORK_CITY'] = $result ['CITY_02'];
		  $card_record ['WORK_STATE'] = $result ['STATE_02'];
		  $card_record ['WORK_ZIPCODE'] = $result ['ZIPCODE_02'];
		  $card_record ['WORK_COUNTRY'] = $result ['COUNTRY_02'];
        }
        $vcard = buildVcard($card_record);
        downloadVcard($vcard, $result ['ID']);
    }
	ClxCommon::$db->freeResult($results);
}

// end function
