<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-07 11:58:37 -0400 (Wed, 07 Oct 2015) $
 * @version        $Rev: 7154 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Acps {

    var $acps_record_commit_counter = CLX_NUM_250;
    var $cprblds_acco_sched_process = 'IBS_CPRBLDS_ACCO';
    var $proc_parameters;

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        $this->proc_parameters = $procParameters;
        multiTableName($this, array('ACPS', 'ACCO', 'ACPM'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Execute product interface see process IBS_CPRBLDS
     */
    function cprblds_read_interfase() {
        //e cho '<hr>En prueba loit::loit_read_interfase()<hr>';
        //Load socket tools
        $EBSK = &getTool('EBSK');
        $EBSK->rename_file = true; //Rename file after read
        $EBSK->record_commit_counter = $this->acps_record_commit_counter;
        $EBSK->verbouse = true;
        //Read all products
        $EBSK->read('CPRBLDS');
        ClxCommon::$db->commit();
    }

    /**
     * Method will complete information of account in missing entries
     * It will connect to ibs and update account information.
     * @param type $check_limit nmber of rows to process
     * @param type $by_key_mode if assigned it will search only maching keys, blank for all rows.
     */
    function cprblds_check_find_acco($check_limit = CLX_NUM_ZERO, $by_key_mode = '') {
        $contenidoHTML = '';
        //Comment interface
        if (companyParameter('EIBS_INTERFACE_ACTIVE') <> CLX_NUM_ONE)
            return;
        //throw cases that are 0 if parameter
        $this->report_process_exception();
        if (!class_exists('ibs_crm_account_socket_import'))
            includeCodeLib('EIBS_ACCO');
        $obj = new ibs_crm_account_socket_import();
        //Try to get non cero with cuscun
        $sql = 'SELECT DISTINCT EXT_CLIENT_NO FROM ' . $this->acpsname . ' WHERE EXT_CLIENT_NO <> ' . singleQuote('0') . ' AND EXT_CLIENT_NO IS NOT null AND EXT_CLIENT_NO <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ';
        if ($by_key_mode === '') {
            $sql .= ' AND (ACCOUNTCODE IS NULL OR ACCOUNTCODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')';
        } else {
            $sql .= ' AND ACCOUNTCODE = ' . singleQuote($by_key_mode);
        }
        $check_limit = CLX_NUM_ZERO + $check_limit;
        if ($check_limit > CLX_NUM_ZERO)
            $sql .=' LIMIT ' . $check_limit;
        $num_rec_proc = CLX_INIT_ZERO;
        $commit_count = CLX_INIT_ZERO;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if ($r['EXT_CLIENT_NO'] === '0') {
                $contenidoHTML.= 'Continuando EXT_CLIENT_NO = 0<br>' . CLX_CHAR_NL;
                continue;
            }
            //Connect to socket and get the client
            //Update information
            $obj->GetGenClientByCuscum($r['EXT_CLIENT_NO']);
            //Updating client information
            $sql = 'UPDATE ' . $this->acpsname . ' ACPS, ' . $this->acconame . ' ACCO SET ACPS.ACCOUNTCODE = ACCO.IDCODE WHERE ACCO.IBS_CUSCUN = ACPS.EXT_CLIENT_NO AND ACPS.EXT_CLIENT_NO = ' . singleQuote($r['EXT_CLIENT_NO']);
            ClxCommon::$db->executeQuery($sql);
            $num_rec_proc += CLX_NUM_ONE;
            if ($this->acps_record_commit_counter > CLX_NUM_ZERO && $commit_count > $this->acps_record_commit_counter) {
                $commit_count = CLX_INIT_ZERO;
                ClxCommon::$db->commit();
            }
            $commit_count += CLX_NUM_ONE; //   - this was missing from previous revision, so commit never happens...
        }
		ClxCommon::$db->freeResult($rs);
        unset($obj);
        ClxCommon::$db->commit();
        //Reporta el resto de clientes que no se encontraron en ibs
        $this->report_process_exception(' ACCOUNTCODE = ' . singleQuote('SCHEDULE_SRCH'));
        //$this->report_process_exception($by_key_mode . '= ACCOUNTCODE = ' . singleQuote('SCHEDULE_SRCH'));
        /*
         * GEN_LBL_IMPORTTOTALROWS
         * Import total rows
         * Total de registros procesados
         */
        $contenidoHTML.= '<br>' . dict('GEN_LBL_IMPORTTOTALROWS') . ': ' . $num_rec_proc;
        echo $contenidoHTML;
    }

    /*
     * Schedule process engine program
     */

    function create_proc_sched($s_sched_process, $ar_pars, $s_recurrence = 'ONE') {
        // Schedule to execute inmediately
        $PRSC = &getTool('PRSC');
        $PRSC->setSchedule($s_sched_process, $s_recurrence, date('Y-m-d'), date('H:i:s'), $ar_pars);
    }

    /**
     * Proceso de ejecucion de productos de tarjeta de credito
     */
    function tarjcreds_read_interfase() {
        //Load socket tools
        $EBSK = &getTool('EBSK');
        $EBSK->rename_file = true; //Rename file after read
        //$EBSK->rename_file = false; //Rename file after read
        //$EBSK->record_commit_counter = 10;
        $EBSK->record_commit_counter = $this->acps_record_commit_counter;
        $EBSK->verbouse = false;
        $EBSK->debug = false;
        //Read all products
        $EBSK->read('TARJCREDS');
        ClxCommon::$db->commit();
    }

    /**
     * Reporta excepciones
     */
    function report_process_exception($by_key_mode = null) {
        if ($by_key_mode == null) {
            $by_key_mode = 'EXT_CLIENT_NO = ' . singleQuote('0') . ' AND ACCOUNTCODE = ' . singleQuote('SCHEDULE_SRCH');
        }
        if (empty($this->proc_parameters)) {
            return;
        }
        //Record exceptions
        $sql = 'INSERT INTO CLX_PR_EXCEPT_LOGS (LOG_RECID,EFFTDATE,PROC_STATUS,DESCRIPTION,SCHEDULECODE, TABLECODE, RECORDID) SELECT ' . singleQuote($this->proc_parameters['RUNID']) . ' LOG_RECID, ' . singleQuote($this->proc_parameters['START_TIME']) . ' EFFTDATE, ' . singleQuote('ERRO') . ' PROC_STATUS, CONCAT(' . singleQuote('Producto con referencia a cliente invalido. Cuenta/Tarjeta No: ') . ',IDCODE,' .
                singleQuote(', Nombre: ') . ',IDNAME,' .
                singleQuote(', No. Cliente en archivo: ') . ' ,EXT_CLIENT_NO) DESCRIPTION, ' . singleQuote($this->proc_parameters['SCHEDULECODE']) . ' SCHEDULECODE, ' . singleQuote('ACPS') . ' TABLECODE, 0 RECORDID FROM ' . $this->acpsname . ' WHERE ' . $by_key_mode;
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->commit();
        $sql = 'DELETE FROM ' . $this->acpsname . ' WHERE ' . $by_key_mode;
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->commit();
    }

    function validate_form(&$record, &$msg) {
        // Field on entry form
        $col_name = 'ACPS_ACCOUNTCODE_prim';
        if (!isset($record[$col_name])) {
            // Field on socket import
            $col_name = 'ACPS_ACCOUNTCODE';
        }
        $existe = ClxCommon::$db->oneExistsRecords($this->acpmname, 'ACCOUNTCODE =' . singleQuote($record[$col_name]) . ' AND EXCLUDE_CRM_REP = 1');
        if ($existe > CLX_NUM_ZERO) {
            $msg[$col_name] = smsg('MSG-467');
            return false;
        }
        return true;
    }

}
