<?php
/**
* General Code File
* For more information contact  support@alenet.com
* 
* @author       $Author: fsantana $
* @copyright    Alenet, Inc.
* @since        $Date: 2014-02-03 13:43:29 -0500 (Mon, 03 Feb 2014) $
* @version        $Rev: 4546 $
* 
* CHANGE LOG
* 2009/09/02 Included svn prop
* CASO 1004238 2020-10-28-SA: Se elimino el campo arbol de acceso ACTI_ACCDEP de las tabla ACTI y ACTH 
* CASO 1004352 2021-03-18-SA: MEJORAS BNP / PARA ACTIVIDADES DE CASOS DE SERVICIO SE AGREGA NOTIFICACION AL AREA RESOLUTORIA. NOTIFICAR A PARTICIPANTES DEL AREA. */
class Acti {

    /**
	 * Contructor
	 *
	 * @param array $procParameters        	
	 * @return void
	 */

    var $actiname;
    var $opponame;
    var $acthname;
    var $prodname;
    var $srername;
    var $srrpname;
    var $acconame;

    function __construct($procParameters = array()) {
        multiTableName ( $this, array (
            'ACTI',
            'OPPO',
            'ACTH',
            'PROD',
            'SRER',
			'SRRP','ACCO','SRAN','SRRQ' 
        ) );
        $this->batch_id = (! empty ( $procParameters ['BATCH_ID'] )) ? $procParameters ['BATCH_ID'] : batch_id ();
        $this->username = $_SESSION ["user_record"] ["username"];
        $this->now = xFormat::getNow ( "Y-m-d H:i:s" );
    }

    /**
	 * Initialice firt form
	 * Executed on init event
	 */
    function acti_init_form(&$record) {
    } // end function
	
    /**
	 * Validate record information
	 * Executed on table validate
	 */
    function acti_validate_form(&$record, &$msg) {
		//global $db, $ac;
        $ac = UserRequest::$request['ac'];
        $status = true;
        //CASO 1004530: El sistema NO debe permitir reabrir actividades en casos cerrados. 
		if ($ac == 'MODIFY') {
            $sql = "SELECT 
					ACTI.ACTIVITY_STATUS,
                    ACTI.REQUESTCODE
				FROM 
					$this->actiname ACTI
				WHERE 
					ACTI.ID = ".singlequote($record['ACTI_ID']);
		   $r = ClxCommon::$db->getOneRecord($sql);

           $sql2 = "SELECT 
					SRRQ.REQSTATUS
				FROM 
					 $this->srrqname SRRQ
				WHERE 
					SRRQ.IDCODE = ". singlequote($record['ACTI_REQUESTCODE']);
		    $r2 = ClxCommon::$db->getOneRecord($sql2);            

            //SI LA ACTIVIDAD FINALIZADA SE INTENTA REABRIRLA Y EL CASO ESTA CERRADO
            //NO PERMITIR LA ACCION
            if ($r['ACTIVITY_STATUS']=='F' && $record['ACTI_ACTIVITY_STATUS']!='F' && ($r2['REQSTATUS']=='CE' || $r2['REQSTATUS']=='NP')){
                $msg ['ACTI_ACTIVITY_STATUS'] = dict ( 'GEN_ERR_CASE_CLOSE' );
                $status = false;
            }

        }

        if ($ac == 'CREATE') {
            $sql2 = "SELECT 
					SRRQ.REQSTATUS
				FROM 
					 $this->srrqname SRRQ
				WHERE 
					SRRQ.IDCODE = ". singlequote($record['ACTI_REQUESTCODE']);
		    $r2 = ClxCommon::$db->getOneRecord($sql2); 
            if ($r2['REQSTATUS']=='CE' || $r2['REQSTATUS']=='NP'){
                $msg ['ACTIVITY_STATUS'] = dict ( 'GEN_ERR_CREATE_ACTI' );
                addMessage($msg);
                $status = false;
            }

        }
        return $status;
    } // end function

    /**
	 * Update Parent (FETR) Information one record is saved
	 */
    function acti_save_form(&$record) {

        // Update modified by and modification date on ACTI
        $this->acti_calcule_reminder_relative ( $record );

        // Creating activity History
        // 20210528-SA: Se comenta la llamada a la funcion para crear historico Pre-Record Commit y se habilito en la funcion save_form_post;
        /*		if (! empty ( $_POST ['ACTI_id'] )) {
			$this->add_history ( $_POST ['ACTI_id'] );
		}
		*/
        /**** CASO 1004238 2020-10-28-SA: Se elimino el campo arbol de acceso ACTI_ACCDEP de las tabla ACTI y ACTH 

		$arbol_assignado = getAccessTreeDefNode ( 'ACTI_ACCDEP', $record ['ASSIGNEDTO_USER'] );
		if($arbol_assignado<>'' && $arbol_assignado<>$record ['ACTI_ACCDEP'])
		{
			//Asignando por lo menos al creador si no se encontro nodo
			$record ['ACTI_ACCDEP'] = $arbol_assignado;
		}
		*/
    }

    /**
	 * Save form post record event
	 * @param string $record
	 */
    function save_form_post(&$record){
        //global $ac, $db;
        $ac = UserRequest::$request['ac'];
        if ($ac == 'MODIFY') {
            //checking status to generate new activities if activity condition is exists
            includeCodeLib ( 'SLAP' );
            if (class_exists ( 'SLAP' )) {
                $a = new Slap ();
                if (! empty ( $record ['ID'] )) {
                    $a->process_activity ( $record ['ID']);
                }
            }    
			/*if($record ['ACTIVITY_STATUS'] =='F'){
				//echo 'paso aqui'; die;
				$msg1= "<p class='alert'>El caso " . $idcode . " no pudo cerrarse porque aún posee actividades que no han finalizado</p>";
				//return note($msg_oper, dict('GEN_LBL_CONTINUE'));
				$msg['ACTIVITY_STATUS'] =  $msg1;
				addMessage($msg);
				//return $msg;
				//$status = false;
			}*/
        }    
        // 20210528-SA: Se agrega la llamada a la funcion para crear historico Post-Record Commit;
        // Creating activity History

        if ($ac=='CREATE'){
            $record ['ID'] = ClxCommon::$db->getcreateId(); 
        }    

        if (! empty ( $record ['ID'] )) {
            $this->add_history ( $record ['ID'] );
        }

        //CASO 1004486, BNP - Visualizar desde MIS CASOS que el caso tiene actividad; 
        //2021-07-05-SA: Actualiza el campo Actividades Pendientes de los Casos de Servicios SI Tiene o NO tiene Activades Pendietes;
        //$rec ['REQUESTCODE'] = $record ['IDCODE'];
        //Verificar que existe la tabla SRRQ en el sistema ;
        //global $db;
        $srrqName = tableName('SRRQ');
        $countSRRQ = ClxCommon::$db->tableExists($srrqName);
        if ($countSRRQ > 0) {
            $sql = "UPDATE SERV_REQUESTS SRRQ
			SET OPEN_ACTI =(IF( (SELECT COUNT(*) FROM CRM_ACTIVITIES ACTI 
				WHERE ACTI.REQUESTCODE = SRRQ.IDCODE AND (ACTI.ACTIVITY_STATUS <> 'F' OR ACTI.ACTIVITY_STATUS ='') ) > 0, '1','0') )
			,ACTI_PEND = (SELECT COUNT(*) FROM CRM_ACTIVITIES ACTI 
				WHERE ACTI.REQUESTCODE = SRRQ.IDCODE AND (ACTI.ACTIVITY_STATUS <> 'F' OR ACTI.ACTIVITY_STATUS ='') ) 
			,ACTI_TOTAL = (SELECT COUNT(*) FROM CRM_ACTIVITIES ACTI WHERE ACTI.REQUESTCODE = SRRQ.IDCODE ) 

			WHERE SRRQ.IDCODE=" . singlequote($record ['REQUESTCODE']) ; 

            $results = ClxCommon::$db->executeQuery ( $sql );
        }

    }

    /**
	 * Copies activity record to history
	 * 
	 * @param integer $activity_id        	
	 */
   function add_history($activity_id) {
        //global $db;

        $actirec = ClxCommon::$db->getRecord ( $this->actiname, "ID = $activity_id" );
        if (! empty ( $actirec )) {
            $actirec ['ACTI_CODE'] = $actirec ['ID'];
            unset ( $actirec ['ID'] );

            //Remove fields that not exists in history to prevent errors
            $sql = "SELECT DBTF.FIELDNAME
					FROM CLX_DB_TABLEFIELDS DBTF
					LEFT JOIN CLX_DB_TABLEFIELDS DBTF2
					  ON DBTF.FIELDNAME = DBTF2.FIELDNAME
					  AND DBTF2.TABLECODE = 'ACTH'
					WHERE
					  DBTF.TABLECODE = 'ACTI'
					  AND DBTF2.FIELDNAME IS NULL";
            $rs = ClxCommon::$db->executeQuery($sql);
            while(($r=ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))==true){
                unset($rec[$r['FIELDNAME']]);
            }
			ClxCommon::$db->freeResult($rs);

            ClxCommon::$db->createRecord ( $this->acthname, $actirec );
        }
    }

    /**
	 * Calculate Reminder Relative
	 * 
	 * @param unknown_type $record        	
	 * @return boolean
	 */
    function acti_calcule_reminder_relative(&$record) {
        if (empty ( $record ['REMINDER_REL'] ) || $record ['REMINDER_REL'] == 'NULL') {
            return true;
        }
        $rem_val = ( integer ) substr ( $record ['REMINDER_REL'], 0, 2 ); // 00,
        // 01,
        // ETC
        $rem_uom = substr ( $record ['REMINDER_REL'], 2, 1 ); // M,H,D,W
        // $date =
        // explode($record['START_DTTM']);
        $format = 'Y-m-d H:i:s';
        $sdate = adodb_parse_date ( $record ['START_DTTM'] );

        // If cero just at start
        if ($rem_val == 0) {
            $record ['REMINDER'] = $record ['START_DTTM'];
            return true;
        }

        switch ($rem_uom) {
            case 'H' :
                $record ['REMINDER'] = adodb_date ( $format, adodb_mktime ( ($sdate ['hour'] - $rem_val), $sdate ['minute'], $sdate ['second'], $sdate ['month'], $sdate ['day'], $sdate ['year'] ) );
                break;
            case 'D' :
                $record ['REMINDER'] = adodb_date ( $format, adodb_mktime ( ($sdate ['hour']), $sdate ['minute'], $sdate ['second'], $sdate ['month'], $sdate ['day'] - $rem_val, $sdate ['year'] ) );
                break;
            case 'W' :
                $record ['REMINDER'] = adodb_date ( $format, adodb_mktime ( ($sdate ['hour']), $sdate ['minute'], $sdate ['second'], $sdate ['month'], $sdate ['day'] - (7 * $rem_val), $sdate ['year'] ) );
                break;
            default :
                $record ['REMINDER'] = adodb_date ( $format, adodb_mktime ( ($sdate ['hour']), $sdate ['minute'] - $rem_val, $sdate ['second'], $sdate ['month'], $sdate ['day'], $sdate ['year'] ) );
                break;
        }
        $record ['LAST_REMINDER'] = 'NULL'; // set to null last remainder to run
        // again
    }

    // -------------------------------------------------------------------------

    /**
	 * Load reminder
	 */
    function acti_reminder() {
        //global $db;

        // set reminder
        $sql = "UPDATE $this->actiname 
                    SET LAST_REMINDER = '$this->now'
                    WHERE
                  (CREATE_ALERT = 1 OR SEND_EMAIL = 1)
                  AND REMINDER IS NOT NULL
                  AND LAST_REMINDER IS NULL
                  AND REMINDER<=now()
                  AND ACTIVITY_STATUS IN ('N','I','W')";
        ClxCommon::$db->executeQuery ( $sql );
        // 20210528-SA: Se agrega un commit para asegurar que no se quede la tabla CRM_ACTIVITIES bloqueada;
        ClxCommon::$db->commit();
        $excludeemails = array ();
        $excludealert = array ();
        $sql = "SELECT DISTINCT 
                  ACTI.ID,
                  ACTI.IDNAME,
                  ACTI.DESCRIPTION,
                  ACTI.REMINDER_REL,
                  ACTI.REMINDER,
                  ACTI.LAST_REMINDER,
                  ACTI.ASSIGNEDTO_USER,
                  ACTI.ACTIVITY_STATUS,
                  ACTI.START_DTTM,
                  ACTI.DUEDATE,
                  ACTI.COMPLETE_DATE,
                  ACTI.PERCENT_COMPLETE,
                  ACTI.PRIORITY,
                  ACTI.OWNERCODE,
                  ACTI.CREATE_ALERT,
                  ACTI.SEND_EMAIL,
				  ACTI.AREACODE
                FROM 
                  $this->actiname ACTI
                WHERE
                  ACTI.LAST_REMINDER = '$this->now'";

        $rs =  ClxCommon::$db->executeQuery ( $sql );
        while ( ($r = ClxCommon::$db->getNextRecord ( $rs , ASSOCIATIVE)) == true ) {
            /*
			 * , ACUS.EMAIL, ACUS.USERNAME
			 */
            $from = ClxCommon::$db->getField ( 'CLX_AC_USERS', 'EMAIL', "USERNAME='" . $r ['OWNERCODE'] . "'" );
            $to = ClxCommon::$db->getField ( 'CLX_AC_USERS', 'EMAIL', "USERNAME='" . $r ['ASSIGNEDTO_USER'] . "'" );

            // Sending emails
            // if($r['SEND_EMAIL']==1 &&
            // empty($excludeemails[$fromrec['EMAIL'].$r['ID']])){
            if ($r ['SEND_EMAIL'] == 1) {
                $url = kWebSite . 'tool.php?to=EDIT&ac=DISPLAY&li=ACTIVITIES&qy=ACTIVITIES&idlist=' . $r ['ID'];
                $link = '<br><br><center><a href="' . $url . '">' . dict ( 'GEN_LBL_CLICK_FOR_DETAIL' ) . '</a></center>';
                $descripcion = $r ['DESCRIPTION'].$link;
                if (empty ( $to ))
                    $to = $from;
                //clx_mail ( $from, $to, $r ['DESCRIPTION'], $r ['IDNAME'], true );
                // 20210528-SA: SE AGREGA VALIDACION DE CORREOS PARA AMBOS REMITENTE Y DESTINATARIO
                if (!empty ($from ['EMAIL']) && !empty ($to ['EMAIL']) ) {
                    clx_mail_queue ( $from, $to, $descripcion, $r ['IDNAME'], true );
                }
            }

            // sending alert
            if ($r ['CREATE_ALERT'] == 1) {
                $url = 'tool.php?to=EDIT&ac=DISPLAY&li=ACTIVITIES&qy=ACTIVITIES&idlist=' . $r ['ID'];
                $link = '<br><br><center><a href="' . $url . '">' . dict ( 'GEN_LBL_CLICK_FOR_DETAIL' ) . '</a></center>';
                $descripcion = $r ['IDNAME'].$link;
                if (empty ( $r ['ASSIGNEDTO_USER'] ))
                    $r ['ASSIGNEDTO_USER'] = $r ['OWNERCODE'];
                alrt_send ($descripcion, 'now', $r ['ASSIGNEDTO_USER'] );
            }

            // 3. search services areas to see if exists mails and tasks

            if (! empty ( $r['AREACODE'] )) {
                // 20200318-SA: MEJORAS BNP / SE AGREGA ROL A LAS NOTIFICACION. NOTIFICAR A PARTICIPANTES DEL ROL. 
                $sql = "SELECT 
							SRAN.SEND_EMAIL,
							SRAN.CREATE_ALERT,
							SRAN.CREATE_TASK, 
							CLXU.EMAIL, 
							CLXU.FIRSTNAME, 
							CLXU.LASTNAME, 
							CLXU.USERNAME
						FROM $this->sranname SRAN, CLX_AC_USERS CLXU, $this->srrpname SRRP
						WHERE SRRP.USER_CODE = CLXU.USERNAME AND CLXU.STATUS = 1 AND
						SRAN.AREACODE = '" . $r ['AREACODE'] . "' 
							AND SRRP.ROLE_CODE = SRAN.ROLE_CODE 
							AND (SRAN.SEND_EMAIL = 1 || SRAN.CREATE_ALERT = 1 || SRAN.CREATE_TASK = 1)";

                $results = ClxCommon::$db->executeQuery ( $sql );
                while ( ($result = ClxCommon::$db->getNextRecord ( $results, ASSOCIATIVE )) == true ) {

                    // Sending emails
                    if ($result ['SEND_EMAIL'] == 1) {
                        $url = 'tool.php?to=EDIT&ac=DISPLAY&li=ACTIVITIES&qy=ACTIVITIES&idlist=' . $r ['ID'];
                        $link = '<br><br><center><a href="' . $url . '">' . dict ( 'GEN_LBL_CLICK_FOR_DETAIL' ) . '</a></center>';
                        $descripcion = $r ['DESCRIPTION'].$link;

                        //clx_mail ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject );
                        // CJRD 2015-09-18 - Case 1002993 - BEGIN
                        // clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject );
                        if (!empty ($result ['EMAIL'])||$result ['EMAIL']!=''){
                            clx_mail_queue ( $from, $result ['EMAIL'], $descripcion, $r ['IDNAME'], true );
                        }
                        //clx_mail_queue ( $from , $result ['EMAIL'], $r ['DESCRIPTION'], $r ['IDNAME'], true, '', '', '', array(), '', false, $email_encoding );
                        // CJRD 2015-09-18 - Case 1002993 - END
                    }

                    // sending alert
                    if ($result ['CREATE_ALERT'] == 1 ) {
                        $url = 'tool.php?to=EDIT&ac=DISPLAY&li=ACTIVITIES&qy=ACTIVITIES&idlist=' . $r ['ID'];
                        $link = '<br><br><center><a href="' . $url . '">' . dict ( 'GEN_LBL_CLICK_FOR_DETAIL' ) . '</a></center>';
                        $idname = $r ['IDNAME'].$link;
                        alrt_send ( $idname, 'now', $result ['USERNAME'] );

                        //alrt_send ( $msg, 'now', $result ['USERNAME'] );
                    }
                } // end while
            }

        }
    }

    /**
	 * Builds
	 *
	 * @param array $record        	
	 */
    function create_activity($record) {
        //global $db;

        // OPPORTUNITYCODE
        $DBTB = &getTool ( 'DBTB' );
        $r = $DBTB->tableDefaultRecord ( 'ACTI' );
        unset ( $r ['RECURRENT'] );
        foreach ( $record as $key => $val ) {
            if (array_key_exists ( $key, $r )) {
                $r [$key] = $val;
            }
        }
        // $r['IDCODE'] = 'AUTO';
        includeCodeLib ( 'GEN_REC_UTIL' );
        setCreationData ( $r );
        // setCreationIdcode($r,'ACTI');
        // Creando acceso de internet

        /**** CASO 1004238 2020-10-28-SA: Se elimino el campo arbol de acceso ACTI_ACCDEP de las tabla ACTI y ACTH 
		$r ['ACTI_ACCDEP'] = getAccessTreeDefNode ( 'ACTI_ACCDEP', $record ['ASSIGNEDTO_USER'] );
		if($r ['ACTI_ACCDEP']=='')
		{
			//Asignando por lo menos al creador si no se encontro nodo	
			$r ['ACTI_ACCDEP'] = getAccessTreeDefNode ( 'ACTI_ACCDEP', $this->username );
		} 
		*/
        //Creating record
        $acti_id = ClxCommon::$db->createRecord ( $this->actiname, $r );
        $record['ACTI_ID'] = $acti_id;

        //Adding notifications to create activity if pass as parameter
        $this->create_activity_notification($record);
        $this->serv_activity_notification($record);

        return $acti_id; 
    } // end function


    /**
	 * Sends activity notification
	 * @param unknown_type $record
	 */
    function create_activity_notification(&$record){
        //global $db;

        if ($record ['NOTIFY_ROLE'] == '' && $record ['NOTIFY_USER'] == ''){
            return;
        }

        $ref = '. Ref: ' . $record ['ACTI_ID'];
        if(!empty( $record['OPPORTUNITYCODE'])){
            $ref .= ' Op: '.$record['OPPORTUNITYCODE'];
        }

        $subject = $record ['IDNAME'] . $ref;
        $msg = $record ['IDNAME'] . $ref. ' <br><a href="REPLACE_URL">' . kWebSite . '</a><br><br>';

        //Adding mafi report
        $msg .= $this->activity_build_mafi($record ['ACTI_ID']);
        $url = '?to=EDIT&ac=DISPLAY&li=ACTIACCO_SRCH&qy=ACTIVITIES_ACCO&relfm=&idlist=' . $record ['ACTI_ID'];

        // Perform action on each activity found
        $skeepuser = array ();
        if ($record ['NOTIFY_ROLE'] != '') {

            $sql = "SELECT SRRP.USER_CODE
				FROM $this->srrpname SRRP
				WHERE SRRP.ROLE_CODE = '" . $record ['NOTIFY_ROLE'] . "'";
            $rs3 = ClxCommon::$db->executeQuery ( $sql );
            while ( ($r3 = ClxCommon::$db->getNextRecord ( $rs3, ASSOCIATIVE )) == true ) {
                // test if already sent something
                if (! empty ( $skeepuser [$r3 ['USER_CODE']] )) {
                    // echo 'Usuario de rol ya fue procesado<br>';
                    continue;
                }
                // mark as sent
                $skeepuser [$r3 ['USER_CODE']] = 1;

                // send
                $this->activity_notification ( $record, $r3 ['USER_CODE'], $subject, $msg, $url );

            }
        } else {
            // echo '-Actividad no tiene role<br>';
        }

        // sent to user if not sent already
        if ($record ['NOTIFY_USER'] != '' && empty ( $skeepuser [$record ['NOTIFY_USER']] )) {
            $this->activity_notification($record, $record ['NOTIFY_USER'], $subject, $msg, $url);
        } else {
            // echo 'Actividad no tiene usuario<Br>';
        }

    }


    /**
	 * Sends notification of activity
	 * @param array $record
	 * @param string $to_user
	 * @param string $subject
	 * @param string $msg
	 * @param string $url
	 */
    function activity_notification(&$record, $to_user, $subject, $msg, $url){
        //global $db;
        //Sending emails
        //$url = 'pop.php?to=EDIT&ac=DISPLAY&li=ACTIACCO_SRCH&qy=ACTIVITIES_ACCO&relfm=&idlist='.$activity_id;

        //Get User Information
        $user = ClxCommon::$db->getFields('CLX_AC_USERS', "USERNAME, EMAIL","USERNAME = '$to_user'");
        if(empty($user)) return;
        if($record['SEND_EMAIL']==1){
            //clx_mail($user['EMAIL'], $user['EMAIL'], decode_string(str_replace('REPLACE_URL',kWebSite.$url, $msg)), $subject);
            clx_mail_queue($user['EMAIL'], $user['EMAIL'], decode_string(str_replace('REPLACE_URL',kWebSite.$url, $msg)), $subject);
            //echo '-Email enviado a '.$user['USERNAME'].' '.$user['EMAIL'].'<br>'.$msg.'<br>';
        }

        //sending alert
        if($record['CREATE_ALERT']==1){
            alrt_send(str_replace('REPLACE_URL',$url, $msg), 'now',  $user['USERNAME']);
            //echo '-Alerta enviada a '.$user['USERNAME'].'<br>';
        }

        //creating tasks
        if($record['CREATE_TASK']==1){

            //Create Tasks
            $task = array();
            $task["STATUS"] = "IDLE";
            $task["TYPE"] = 'FIEK';
            $task["SUBJECT"] = $subject;
            $task["DESCRIPTION"] = str_replace('REPLACE_URL',kWebSite.$url, $msg);
            $task["PERCENT_COMPLETE"] = "0";
            $task["COMPLETE_DATE"] = "NULL";
            $task["PRIORITY"] = 'N';
            $task["OWNERCODE"] = $user["USERNAME"];
            $task["ASSIGNEDTO"] = $user["USERNAME"];
            $task["REMINDER_DATETIME"] = "NULL";
            $task["RECURRING"] = "NONE";
            $task["DEPENDS"] = "0";
            $task["START_DATE"] = getNow('Y-m-d H:i:s');
            $task["DUE_DATE"] = "";

            ClxCommon::$db->createRecord("CLX_US_TASKS", $task);
            //echo '-Tarea creada a '.$user['USERNAME'].'<br>';

        }//end if task
    }

    /**
	 * For testing templates
	 * @param unknown_type $activity_id
	 */
    function test_activity_build_mafi($activity_id){
        echo $this->activity_build_mafi($activity_id);
    }

    /**
	 * Builds mafi report
	 * @param unknown_type $msg
	 */
    function activity_build_mafi($activity_id){
        //global $db;

        $pn_tpl = companyParameter('ACTI_SEND_MAFI_PN');
        $pj_tpl = companyParameter('ACTI_SEND_MAFI_PJ');
        if($pn_tpl=='' && $pj_tpl=='') return '';

        $OBJS = &getTool('OBJS');
        $DBFL = &getTool('DBFL');

        $sql = "SELECT 
					OPPO.*
				FROM 
					$this->acconame ACCO, 
					$this->opponame OPPO,
					$this->actiname ACTI
				WHERE 
					ACCO.IDCODE = OPPO.ACCOUNTCODE
					AND ACTI.OPPORTUNITYCODE = OPPO.IDCODE
					AND ACTI.ID = $activity_id";
        $r = ClxCommon::$db->getOneRecord($sql);
        if(!empty($r)){

            $accorec = ClxCommon::$db->getRecord($this->acconame, "IDCODE = '".$r['ACCOUNTCODE']."'");
            foreach($r as $key=>$val){
                //$r['OPPO_'.$key] = $val;
                $fieldrec = $DBFL->getField($key);
                $fieldinstance = &$OBJS->getObject ( "DBFT", $fieldrec["FIELDTYPE"] );
                $r['OPPO_'.$key] = $fieldinstance->formatField($key, $fieldrec, $r);

            }

            foreach($accorec as $key=>$val){
                //$r['ACCO_'.$key] = $val;
                $fieldrec = $DBFL->getField($key);
                $fieldinstance = &$OBJS->getObject ( "DBFT", $fieldrec["FIELDTYPE"] );
                $r['ACCO_'.$key] = $fieldinstance->formatField($key, $fieldrec, $accorec);
            }
            unset($r['ACCO_ID'],$r['OPPO_ID']);

            $UITM = &getTool('UITM');
            $template_code = ($accorec['ISINDIVIDUAL']==1)?$pn_tpl:$pj_tpl;
            $tmpl = $UITM->getTemplateAndRecordMerge($template_code, $r);
            $msg = $tmpl['CONTENTS'];
        }

        return $msg;
    }//end method

    /**
	 * Performs Activity Escalation
	 * Run on schedules for process SERV001 one at a time
	 */
    function escalation() {
        //global $db;

        // Verify that only one exchedule for process is runing at the time
        // Process for escalation = SERV001
        $qty = ClxCommon::$db->countRecords ( 'CLX_PR_SCHEDULES', "PROC_STATUS = 'RUN' AND PROCESSCODE = 'SFA001'" );
        if ($qty > 1) {
            // Something running just return until nothing is running
            // to prevent doing double escalation
            return;
        }

        if (! class_exists ( 'Srer' )) {
            includeCodeLib ( 'SRER' );
        }
        $SRER = new Srer ();

        // Init Set Excalation Dati if null to now
        $sql = "UPDATE $this->actiname 
				SET LAST_ESCALATION = NOW()
				WHERE LAST_ESCALATION = NULL";
        ClxCommon::$db->executeQuery ( $sql );

        // Performing checks
        $sql = "SELECT SRER.* 
				FROM $this->srername SRER
				WHERE SRER.MODULECODE = 'SFA'
					AND SRER.STATUS = 'A' 
					AND SRER.SCALE_AFTER > 0";
        $rs = ClxCommon::$db->executeQuery ( $sql );
        while ( ($r = ClxCommon::$db->getNextRecord ( $rs )) == true ) {
            $crit = array ();

            // Adding type criterias
            if ($r ['ACTIVITY_TYPE'] != '' && $r ['COND_ACTI_TYPE'] != '') {
                $crit [] = "ACTI.ACTIVITY_TYPE " . $r ['COND_ACTI_TYPE'] . " '" . $r ['ACTIVITY_TYPE'] . "'";
            }
            if ($r ['ACTIVITY_STATUS'] != '' && $r ['COND_ACTI_STATUS'] != '') {
                $crit [] = "ACTI.ACTIVITY_STATUS " . $r ['COND_ACTI_STATUS'] . " '" . $r ['ACTIVITY_STATUS'] . "'";
            }
            if ($r ['ACTI_RESULT'] != '' && $r ['COND_ACTI_RESULT'] != '') {
                $crit [] = "ACTI.ACTI_RESULT " . $r ['COND_ACTI_RESULT'] . " '" . $r ['ACTI_RESULT'] . "'";
            }
            if ($r ['PRIORITY'] != '' && $r ['COND_PRIORITY'] != '') {
                $crit [] = "ACTI.PRIORITY " . $r ['COND_PRIORITY'] . " '" . $r ['PRIORITY'] . "'";
            }

            // Join Opportunity
            $oppo_crit = array ();
            if ($r ['OPPSTAGE'] != '' && $r ['COND_OPPSTAGE'] != '') {
                $oppo_crit [] = "OPPO.OPPSTAGE " . $r ['COND_OPPSTAGE'] . " '" . $r ['OPPSTAGE'] . "'";
            }

            // Review with product
            if ($r ['PRODUCT_CODE'] != '' && $r ['COND_PRODCODE'] != '') {
                $oppo_crit [] = "OPPO.PRODUCTCODE " . $r ['COND_PRODCODE'] . " '" . $r ['PRODUCT_CODE'] . "'";
            }

            // Join product table
            if ($r ['PRODUCT_CLASS'] != '' && $r ['COND_PRODCLS'] != '') {
                $oppo_crit [] = "PROD.PRODUCT_CLASS " . $r ['COND_PRODCLS'] . " '" . $r ['PRODUCT_CLASS'] . "'";
            }

            if (count ( $oppo_crit ) > 0) {
                /*
				$crit [] = "EXISTS (SELECT OPPO.ID
			              FROM $this->opponame OPPO,
			                  $this->prodname PROD
			              WHERE 
			                OPPO.PRODUCTCODE = PROD.IDCODE
			                AND OPPO.IDCODE = ACTI.OPPORTUNITYCODE 
							" . implode ( $crit, " AND " ) . ")";
				*/
                // 2013-07-22 cjrd fix error "You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'ACTI.ACTIVITY_TYPE = \'11\' AND ACTI.ACTIVITY_STATUS != \'C\') AND ADDDATE(ACTI.LAST\' at line 9 (1064)"
                $crit [] = "EXISTS (SELECT OPPO.ID
			              FROM $this->opponame OPPO,
			                  $this->prodname PROD
			              WHERE 
			                OPPO.PRODUCTCODE = PROD.IDCODE
			                AND OPPO.IDCODE = ACTI.OPPORTUNITYCODE 
							AND " . implode ( $oppo_crit, " AND " ) . ")";
            }

            if (count ( $crit ) == 0) {
                // no criteria to search
                continue;
            }

            // 2013-07-24 FS-CR: fix according "SREP" List changes 
            // Adding time criterias
            switch ($r ['SCALE_PERIOD']) {
                case 'H' :
                    //$crit [] = 'ADDDATE(ACTI.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' DAY) <= NOW()';
                    $crit [] = 'ADDDATE(ACTI.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' HOUR) <= NOW()';
                    break;
                case 'D' :
                    //$crit [] = 'ADDDATE(ACTI.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' HOUR) <= NOW()';
                    $crit [] = 'ADDDATE(ACTI.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' DAY) <= NOW()';
                    break;
                case 'M' :
                    //$crit [] = 'ADDDATE(ACTI.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' MINUTE) <= NOW()';
                    $crit [] = 'ADDDATE(ACTI.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' MONTH) <= NOW()';
                    break;
                case 'I' :
                    $crit [] = 'ADDDATE(ACTI.LAST_ESCALATION, INTERVAL ' . $r ['SCALE_AFTER'] . ' MINUTE) <= NOW()';
                    break;
                default :
                    continue 2;
                    break;
            }

            // Select activities in previous condition
            $sql = "SELECT ACTI.ID, ACTI.ACTIVITY_STATUS SET_ACTISTATUS, ACTI.IDNAME
					FROM $this->actiname ACTI
					WHERE " . implode ( $crit, " AND " );
            $rs2 = ClxCommon::$db->executeQuery ( $sql );
            while ( ($r2 = ClxCommon::$db->getNextRecord ( $rs2, ASSOCIATIVE )) == true ) {

                $subject = $r ['IDNAME'] . '. Ref: ' . $r2 ['ID'];
                $msg = $r ['IDNAME'] . '. Ref: ' . $r2 ['ID'] . ' - ' . $r2 ['IDNAME'] . ' <br><a href="REPLACE_URL">' . kWebSite . '</a><br>';
                $url = '?to=EDIT&ac=DISPLAY&li=ACTIACCO_SRCH&qy=ACTIVITIES_ACCO&relfm=&idlist=' . $r2 ['ID'];
                // echo '<hr>Preparando actividad escalamiento<br>';
                // echo $subject.'<br>';
                // Perform action on each activity found
                $skeepuser = array ();
                if ($r ['NOTIFY_ROLE'] != '') {

                    $sql = "SELECT SRRP.USER_CODE 
							FROM $this->srrpname SRRP
							WHERE SRRP.ROLE_CODE = '" . $r ['NOTIFY_ROLE'] . "'";
                    $rs3 = ClxCommon::$db->executeQuery ( $sql );
                    while ( ($r3 = ClxCommon::$db->getNextRecord ( $rs3, ASSOCIATIVE )) == true ) {
                        // echo 'Procesando usuario de rol '.$r3
                        // ['USER_CODE'].'<Br>';
                        // test if already sent something
                        if (! empty ( $skeepuser [$r3 ['USER_CODE']] )) {
                            // echo 'Usuario de rol ya fue procesado<br>';
                            continue;
                        }
                        // mark as sent
                        $skeepuser [$r3 ['USER_CODE']] = 1;
                        // send
                        $SRER->escalation_action ( $r, $r3 ['USER_CODE'], $subject, $msg, $url );
                    }
                } else {
                    // echo '-Actividad no tiene role<br>';
                }

                // sent to user if not sent already
                if ($r ['NOTIFY_USER'] != '' && empty ( $skeepuser [$r ['NOTIFY_USER']] )) {
                    $SRER->escalation_action ( $r, $r ['NOTIFY_USER'], $subject, $msg, $url );
                } else {
                    // echo 'Actividad no tiene usuario<Br>';
                }

                // Set status if required from parameters
                if ($r ['SET_ACTISTATUS'] != '') {
                    $r2 ['SET_ACTISTATUS'] = $r ['SET_ACTISTATUS'];
                }

                // echo 'Completado excalamiento '.$subject.'<Br>';

                // Set modification date to last check date
                $sql = "UPDATE 
						  CRM_ACTIVITIES 
						SET 
						  ACTIVITY_STATUS = '" . $r2 ['SET_ACTISTATUS'] . "',
						  LAST_ESCALATION = NOW() 
						WHERE 
						  ID = " . $r2 ['ID'];
                ClxCommon::$db->executeQuery ( $sql );
            }
        }
    }

    //--------------------------------------------------------------------------

    /**
	 * Dump calendar from listing
	 */
    function build_ical_btn(){
        //global $db;

        $idlist = getIdlist();
        $sql = "SELECT ID
				FROM $this->actiname
				WHERE ID IN (" . toString ( $idlist ) . ")";
        $rs = ClxCommon::$db->executeQuery ( $sql );
        while ( ($r = ClxCommon::$db->getNextRecord ( $rs, NUMERIC )) == true ) {
            $this->build_ical($r[0]);
        }
    }

    /**
	 * Builds calendar
	 * @param integer $acti_id
	 */
    function build_ical($acti_id){
        //global $db;

        $acti_rec = ClxCommon::$db->getFields($this->actiname,'ID, IDNAME, START_DTTM, 
						DUEDATE, DESCRIPTION, LOCATION, PRIORITY,
						ACTIVITY_TYPE', "ID = $acti_id"); 

        //STATUS = TENTATIVE, BUSY, OUT OF OFFICE, FREE
        //DTSTART:19960401T033000Z
        //DTEND:19960401T043000Z
        //CLASS:PRIVATE
        // date ( 'c', int $timestamp = time() ] )
        $dtdate = xFormat::date($acti_rec['START_DTTM'], 'Ymd\THis');
        $dedate = xFormat::date($acti_rec['DUEDATE'], 'Ymd\THis');
        $DBLT = &getTool('DBLT');
        $type = $DBLT->getListItem('ATTY',$acti_rec['ACTIVITY_TYPE'], 2);

        $ical = "BEGIN:VCALENDAR\n".
            "VERSION:1.0\n".
            "BEGIN:VEVENT\n".
            "CATEGORIES:<CATEGORY>\n".
            "STATUS:TENTATIVE\n".
            "DTSTART:<DTSTART>\n".
            "DTEND:<DTEND>\n".
            "SUMMARY:<SUMMARY>\n".
            "DESCRIPTION:<DESCRIPTION>\n".
            "LOCATION:<LOCATION>\n".
            "CLASS:PRIVATE\n".
            "END:VEVENT\n".
            "END:VCALENDAR";

        $this->ical_clear_return($acti_rec['IDNAME']);
        $this->ical_clear_return($acti_rec['LOCATION']);
        $this->ical_clear_return($acti_rec['DESCRIPTION']);

        $ical = str_replace("<CATEGORY>", $type, $ical);
        $ical = str_replace("<DTSTART>", $dtdate, $ical);
        $ical = str_replace("<DTEND>", $dedate, $ical);
        $ical = str_replace("<SUMMARY>", $acti_rec['IDNAME'], $ical);
        $ical = str_replace("<DESCRIPTION>", $acti_rec['DESCRIPTION'], $ical);
        $ical = str_replace("<LOCATION>", $acti_rec['LOCATION'], $ical);

        header ( "Content-type: text/calendar" );
        header ( "Content-Disposition: attachment; filename=".$acti_rec['IDNAME']. ".ics" );
        header ( "Pragma: no-cache" );
        header ( "Expires: 0" );
        header ( "Cache-control: public" );

        echo $ical;

    }


    /**
	 * Remove carrier returns from string
	 * @param string $value
	 */
    function ical_clear_return(&$value){
        $value = str_replace("\n",'\n',$value);
        $value = str_replace("\r",'\r',$value);
        $value = trim($value);
    }

    //* CASO 1004352 2021-03-18-SA: MEJORAS BNP / PARA ACTIVIDADES DE CASOS DE SERVICIO SE AGREGA NOTIFICACION AL AREA RESOLUTORIA. NOTIFICAR A PARTICIPANTES DEL 
    function serv_activity_notification(&$record){
        //global $db;
        //echo 'si entro aqui';
        //die;
        /*if (! empty ( $rec ))
			$db->createRecord ( $this->srrsname, $rec );*/



        $fromrec = ClxCommon::$db->getOneRecord ( "SELECT EMAIL,FIRSTNAME,LASTNAME FROM CLX_AC_USERS WHERE USERNAME = '" . $record ['MODIFIEDBY'] . "'" );
        $modifiedby = $fromrec;
        $createdby = ClxCommon::$db->getOneRecord ( "SELECT EMAIL,FIRSTNAME,LASTNAME FROM CLX_AC_USERS WHERE USERNAME = '" . $record ['CREATEDBY'] . "'" );
        $asignedto = ClxCommon::$db->getOneRecord ( "SELECT EMAIL,FIRSTNAME,LASTNAME FROM CLX_AC_USERS WHERE USERNAME = '" . $record ['ASSIGNEDTO_USER'] . "'" );
        $ownercode = ClxCommon::$db->getOneRecord ( "SELECT EMAIL,FIRSTNAME,LASTNAME FROM CLX_AC_USERS WHERE USERNAME = '" . $record ['OWNERCODE'] . "'" );
        $rol = ClxCommon::$db->getOneRecord ( "SELECT IDNAME FROM SERV_AREAS WHERE IDCODE = '" . $record ['AREACODE'] . "'" );
        $srrq_notes  = ClxCommon::$db->getOneRecord ( "SELECT NOTES,SUBJECT FROM SERV_REQUESTS WHERE IDCODE = '" . $record ['REQUESTCODE'] . "'" );

        $DBTL = getTool ( 'DBLT' );
        $actistatus = $DBTL->getListItem ( 'ATST', $record ['ACTIVITY_STATUS'] );

        // send notifications
        $excludeemails = array ();

        $subject = 'Ref#:' .$record ['REQUESTCODE']. ' - '.dict ( 'GEN_LBL_BUSINESS_CASE' ).' : ' . $srrq_notes ['SUBJECT']. ' - '.dict ( 'ECFC2DFFE568C10A67DBC6D3724CFDE2' ).' : ' . $record ['IDNAME'];
        $msg = '<b>' . dict ( 'GEN_LBL_REFERENCE' ) . ':</b> ' .$record ['REQUESTCODE']. '<bR>';
        $msg .= '<b>' . dict ( 'GEN_LBL_CREATEDBY' ) . ':</b> ' . $createdby ['LASTNAME'] . ', ' . $createdby ['FIRSTNAME'] . '<bR>';
        if ($asignedto){
            $msg .= '<b>' . dict ( 'GEN_LBL_ASSIGNED_TO' ) . ':</b> ' . $asignedto ['LASTNAME'] . ', ' .  $asignedto ['FIRSTNAME'] . '<bR>';
        }
        if ($rol){
            $msg .= '<b>' . dict ( '1DA267D2E916D006FF6615ED3A80B96C' ) . ':</b> ' . $rol ['IDNAME'] . '<bR>';
        }
		$msg .= '<b>' . dict ( 'GEN_LBL_STATUS' ) . ':</b> ' . $actistatus ;
		if($record ['NOTES']!='null'){$msg .= '<hr><b>' . dict ( 'GEN_LLB_notes' ) . '</b><br> ' . $record ['NOTES'];}
		if($record ['DESCRIPTION']!='null'){$msg .= ' <br><br><b>' . dict ( 'GEN_LBL_DESCRIPTION' ) . '</b> <bR>' . $record ['DESCRIPTION'];}
		//$msg .= ' <br><br><bR>' . $record ['RESOLUTION'];
        $email_encoding = 'UTF-8';

        //# 1.Send email to Activity Assignee / Enviar a Asignado de la Actividad
		if (isset($asignedto['EMAIL']) && !empty($asignedto['EMAIL'])) {
			$excludeemails [$asignedto['EMAIL']] = 1;
			if ( !(empty ($asignedto ['EMAIL']))||$asignedto ['EMAIL']!=''){
				clx_mail_queue ( $fromrec ['EMAIL'], $asignedto ['EMAIL'], $msg, $subject, true, '', '', '', array(), '', false, $email_encoding );
			}
		}
        //# 2.Send email to Activity Owner / Enviar a Dueno de la Actividad
        if ( empty ( $excludeemails [$ownercode['EMAIL']] )) {
            if (!empty ($ownercode ['EMAIL'])||$ownercode ['EMAIL']!=''){
                $excludeemails [$ownercode['EMAIL']] = 1;
                clx_mail_queue ( $fromrec ['EMAIL'], $ownercode ['EMAIL'], $msg, $subject, true, '', '', '', array(), '', false, $email_encoding );
            }
        }
        //# 3.Send email to person who Modifies / Enviar al que Modifica la Actividad
        // 20210528-SA: SE REPITE $ownercode. REEMPLZA CON $modifiedby>	if ( empty ( $excludeemails [$ownercode['EMAIL']] )) {
        if ( empty ( $excludeemails [$modifiedby['EMAIL']] )) {
            $excludeemails [$modifiedby['EMAIL']] = 1;
            if (!empty ($modifiedby ['EMAIL'])||$modifiedby ['EMAIL']!=''){
                clx_mail_queue ( $fromrec ['EMAIL'], $modifiedby ['EMAIL'], $msg, $subject, true, '', '', '', array(), '', false, $email_encoding );
            }
        }
        //# 4.Send email to Other Activity Service Request Participants / Enviar a Otros Participantes del Caso de la Actividad
        //E.C 17-06-2021 SE ELIMINA LA VISTA Y SE ENVIA LAS NOTIFICACIONES POR PARTES
        /****************************************************************/
        //OBTENEMOS LOS USUARIOS DUEÑOS Y USUARIOS ASIGNADOS DEL CASO
        $sql = "SELECT SRRQ.IDCODE REQUESTCODE,SRRQ.OWNERCODE USERNAME,SRRQ.ASSIGNEDTO_USER USERNAME2, ACUS.FIRSTNAME FIRSTNAME,ACUS.LASTNAME LASTNAME, ACUS.EMAIL EMAIL ,'1' SEND_EMAIL 
                FROM SERV_REQUESTS SRRQ,CLX_AC_USERS ACUS 
                WHERE 1=1 
                AND (SRRQ.OWNERCODE = ACUS.USERNAME OR SRRQ.ASSIGNEDTO_USER = ACUS.USERNAME)
                AND ACUS.EMAIL IS NOT NULL
                AND SRRQ.IDCODE = '" . $record ['REQUESTCODE'] . "'"; 

        $results = ClxCommon::$db->executeQuery ( $sql );
        while ( ($result = ClxCommon::$db->getNextRecord ( $results, ASSOCIATIVE )) == true ) {
            if ($result ['SEND_EMAIL'] == 1 && empty ( $excludeemails [$result ['EMAIL']] )) {
                if (!empty ($result ['EMAIL'])||$result ['EMAIL']!=''){
                    clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject,   true, '', '', '', array(), '', false, $email_encoding );
                }
                $excludeemails [$result ['EMAIL']] = 1;
            }
        }

        //OBTENEMOS LOS PARTICIPANTES DEL AREA DEL CASO
        $sql = "SELECT SRRQ.IDCODE SRRQ_CODE,SRRP.USER_CODE USERNAME,ACUS.FIRSTNAME FIRSTNAME,ACUS.LASTNAME LASTNAME, ACUS.EMAIL EMAIL,SRAN.SEND_EMAIL SEND_EMAIL,SRAN.AREACODE ROLETYPE 
                FROM SERV_REQUESTS SRRQ,SERV_AREA_NOTIFICATIONS SRAN,SERV_ROLE_PARTICIPANTS SRRP,CLX_AC_USERS ACUS 
                WHERE 1=1
                AND SRAN.AREACODE = SRRQ.AREACODE  
                AND SRAN.ROLE_CODE = SRRP.ROLE_CODE 
                AND SRRP.USER_CODE = ACUS.USERNAME 
                AND ACUS.EMAIL IS NOT NULL
                AND SRRQ.IDCODE = '" . $record ['REQUESTCODE'] . "'"; 

        /*$sql = "SELECT SEND_EMAIL,EMAIL,FIRSTNAME,LASTNAME FROM SERV_REQ_NOTIFY_RCPT SRNR 
				WHERE REQUESTCODE = '" . $record ['REQUESTCODE'] . "' ";*/
        $results = ClxCommon::$db->executeQuery ( $sql );
        while ( ($result = ClxCommon::$db->getNextRecord ( $results, ASSOCIATIVE )) == true ) {
            if ($result ['SEND_EMAIL'] == 1 && empty ( $excludeemails [$result ['EMAIL']] )) {
                if (!empty ($result ['EMAIL'])||$result ['EMAIL']!=''){
                    clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject,   true, '', '', '', array(), '', false, $email_encoding );
                }
                $excludeemails [$result ['EMAIL']] = 1;
            }
        }


        // 5. search services areas to see if exists mails and tasks
        if (! empty ( $record ['AREACODE'] )) {
            // 03-05-2021-EC: MEJORAS BNP / SE AGREGA ROL A LAS NOTIFICACION. NOTIFICAR A PARTICIPANTES DEL ROL EN ACTIVIDADES DEL CASO
            $sql = "SELECT 
			            SRAN.SEND_EMAIL,
			            SRAN.CREATE_ALERT,
			            SRAN.CREATE_TASK, 
			            CLXU.EMAIL, 
			            CLXU.FIRSTNAME, 
			            CLXU.LASTNAME, 
			            CLXU.USERNAME
					FROM $this->sranname SRAN, CLX_AC_USERS CLXU, $this->srrpname SRRP
					WHERE SRRP.USER_CODE = CLXU.USERNAME AND CLXU.STATUS = 1 AND
					SRAN.AREACODE = '" . $record ['AREACODE'] . "' 
						AND SRRP.ROLE_CODE = SRAN.ROLE_CODE 
						AND (SRAN.SEND_EMAIL = 1 || SRAN.CREATE_ALERT = 1 || SRAN.CREATE_TASK = 1)
                        AND CLXU.EMAIL IS NOT NULL";

            $results = ClxCommon::$db->executeQuery ( $sql );
            while ( ($result = ClxCommon::$db->getNextRecord ( $results, ASSOCIATIVE )) == true ) {

                // Sending emails
                if ($result ['SEND_EMAIL'] == 1 && empty ( $excludeemails [$result ['EMAIL']] )) {
                    //clx_mail ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject );
                    // CJRD 2015-09-18 - Case 1002993 - BEGIN
                    // clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject );
                    if (!empty ($result ['EMAIL'])||$result ['EMAIL']!=''){
                        clx_mail_queue ( $fromrec ['EMAIL'], $result ['EMAIL'], $msg, $subject,true, '', '', '', array(), '', false, $email_encoding );
                    }                    // CJRD 2015-09-18 - Case 1002993 - END
                    $excludeemails [$result ['EMAIL']] = 1;
                }

                // sending alert
                if ($result ['CREATE_ALERT'] == 1 && empty ( $excludealert [$result ['USERNAME']] )) {
                    alrt_send ( $msg, 'now', $result ['USERNAME'] );
                    $excludealert [$result ['USERNAME']] = 1;
                }

                // creating tasks
                if ($result ['CREATE_TASK'] == 1 && empty ( $excludetask [$result ["USERNAME"]] )) {
                    // Create Tasks
                    $task = array ();
                    $task ["STATUS"] = "IDLE";
                    $task ["TYPE"] = 'FIEK';
                    $task ["SUBJECT"] = $subject;
                    $task ["DESCRIPTION"] = strip_tags ( str_replace ( '<br>', "\n", $msg ) );
                    $task ["PERCENT_COMPLETE"] = "0";
                    $task ["COMPLETE_DATE"] = "NULL";
                    $task ["PRIORITY"] = $record ['PRIORITY'];
                    $task ["OWNERCODE"] = $record ['MODIFIEDBY'];
                    // 20200318-SA: MEJORAS BNP / SE REEMPLAZA USUARIO ASIGNADO POR PARTICIPANTE DE ROL ASIGNADO
                    //$task ["ASSIGNEDTO"] = $record ["ASSIGNEDTO_USER"]; 
                    $task ["ASSIGNEDTO"] =  $result ['USERNAME'] ;
                    $task ["REMINDER_DATETIME"] = "NULL";
                    $task ["RECURRING"] = "NONE";
                    $task ["DEPENDS"] = "0";
                    $task ["START_DATE"] = $record ['MDATE'];
                    $task ["DUE_DATE"] = "";
                    $excludetask [$result ["USERNAME"]] = 1;
                    ClxCommon::$db->createRecord ( "CLX_US_TASKS", $task );
                } // end if task */
            } // end while

        }
    }

} // end class
?>