<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date:  15:35:15 -0500 (Wed, 08 Jan 2014) $
 * @version        $Rev: 4510 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Adtm {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('ADTM'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Build Report Data
     */
    function due_rent_report_init($record) {
        if (empty($_SESSION['paging']['ADTM_LIST']['qfilter'])) {
		  return;
        }
        $comp_code = $_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_COMP_CODE'];
        $edate = xFormat::anytimedate($_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_REPORT_DATE'], 'Y-m-d');
        if (empty($_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_CHART_FIELD01_prim']) && empty($_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_CHART_FIELD01_secd'])) {
		  $_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_CHART_FIELD01'] = '';
        }
        if (empty($_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_CHART_FIELD03_prim']) && empty($_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_CHART_FIELD03_secd'])) {
		  $_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_CHART_FIELD03'] = '';
        }
        $chart_field01 = $_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_CHART_FIELD01'];
        $chart_field03 = $_SESSION['paging']['ADTM_LIST']['qfilter']['ADTM_CHART_FIELD03'];
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('ADTM');
        $sql = 'DROP TABLE IF EXISTS X_TRANS_TMP';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'INSERT INTO ' . $this->adtmname . ' (COMP_CODE, ASSET_CODE, CHART_FIELD01, CHART_FIELD03, AGREEMENT_CODE, REPORT_DATE, ADDRESS, PROPERTY_LOCATION, START_DATE, END_DATE, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, BASE_CURRENCY, AGREEMENT_AMT, MONTH_PERIOD, RENT_AMT, BASE_RENT_AMT, PAID_AMT, LAST_PAY_DATE, DESCRIPTION) SELECT FIAE.COMP_CODE, FIAE.IDCODE ASSET_CODE, FIAE.CHART_FIELD01, FIAE.CHART_FIELD03, AAGR.IDCODE AGREEMENT_CODE, ' . singleQuote($edate) . ' REPORT_DATE, FIAE.ADDRESS, FIAE.PROPERTY_LOCATION,/*verificar zona*/ AAGR.START_DATE, AAGR.END_DATE, AAGR.CURRENCY_CODE, CURR.EXCHANGE_RT, CURR.CUR_OPERATOR, COMP.CURRENCY_CODE BASE_CURRENCY, AAGR.AGREEMENT_AMT, case AAGR.PAYMENT_FREQ WHEN ' . singleQuote('1') . ' THEN TIMESTAMPDIFF(MONTH, AAGR.START_DATE, ' . singleQuote($edate) . ')/12  WHEN ' . singleQuote('2') . ' THEN TIMESTAMPDIFF(MONTH, AAGR.START_DATE, ' . singleQuote($edate) . ')/6 WHEN ' . singleQuote('3') . ' THEN TIMESTAMPDIFF(MONTH, AAGR.START_DATE, ' . singleQuote($edate) . ')/4 WHEN ' . singleQuote('4') . ' THEN TIMESTAMPDIFF(MONTH, AAGR.START_DATE, ' . singleQuote($edate) . ')/3 WHEN ' . singleQuote('12') . ' THEN TIMESTAMPDIFF(MONTH, AAGR.START_DATE, ' . singleQuote($edate) . ')  ELSE 0 END MONTH_PERIOD, IF(COMP.CURRENCY_CODE=FIAE.CURRENCY_CODE, 0,AAGR.AGREEMENT_AMT) RENT_AMT, ROUND((AAGR.AGREEMENT_AMT*POWER(CURR.EXCHANGE_RT,CURR.CUR_OPERATOR)), 2) BASE_RENT_AMT, CONVERT(0, DEC(15, 2)) PAID_AMT, CONVERT(null, DATE) LAST_PAY_DATE, AAGR.DESCRIPTION   FROM  BASE_COMPANIES COMP, AMGT_ASSETS FIAE, AMGT_AGREEMENTS AAGR, (SELECT  CURR.BASE_CURRENCY, CURR.FOREIGN_CURRENCY, CURR.EXCHANGE_RT, CURR.CUR_OPERATOR FROM  BASE_CURRENCY_CONVERSIONS CURR WHERE  CURR.CLX_EFFTDATE = (SELECT MAX(CURRX.CLX_EFFTDATE) FROM BASE_CURRENCY_CONVERSIONS CURRX WHERE CURRX.IDCODE = CURR.IDCODE AND CURRX.CLX_EFFTDATE<=' . singleQuote($edate) . ')) CURR WHERE  FIAE.IDCODE = AAGR.ASSETCODE AND COMP.IDCODE = FIAE.COMP_CODE ' . (($chart_field01 <> '') ? ' AND FIAE.CHART_FIELD01 = ' . singleQuote($chart_field01) . ' ' : '') . ' ' . (($chart_field03 <> '') ? ' AND FIAE.CHART_FIELD03 = ' . singleQuote($chart_field03) . ' ' : '') . ' AND COMP.CURRENCY_CODE = CURR.FOREIGN_CURRENCY AND AAGR.CURRENCY_CODE = CURR.BASE_CURRENCY  AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE) FROM AMGT_ASSETS FIAEX WHERE FIAEX.IDCODE = FIAE.IDCODE) AND AAGR.CLX_EFFTDATE = (SELECT MAX(AAGRX.CLX_EFFTDATE) FROM AMGT_AGREEMENTS AAGRX WHERE AAGRX.IDCODE = AAGR.IDCODE) AND AAGR.COMP_CODE = ' . singleQuote('BAT01') . ' AND AAGR.AGREEMENT_STATUS = ' . singleQuote('ACTI') . ' AND AAGR.AGREEMNT_CLASS = ' . singleQuote('300') . ' AND AAGR.START_DATE < ' . singleQuote($edate) . ' AND AAGR.END_DATE >= ' . singleQuote($edate) . ' AND FIAE.COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'CREATE TEMPORARY TABLE X_TRANS_TMP SELECT FIAT.IDCODE, FIAT.IDNAME, FIAT.CHART_FIELD03, FIAT.ITEM_REF_NO AGREEMENT_CODE, FIAT.EFFTDATE, FIAT.CURRENCY_CODE, FIAT.EXCHANGE_RT, FIAT.TRANS_AMT- FIAT.CALC_AMT_01- FIAT.CALC_AMT_02- FIAT.CALC_AMT_03- FIAT.CALC_AMT_04- FIAT.CALC_AMT_05- FIAT.CALC_AMT_06- FIAT.CALC_AMT_07- FIAT.CALC_AMT_08 TRANS_AMT, ROUND(((FIAT.TRANS_AMT- FIAT.CALC_AMT_01- FIAT.CALC_AMT_02- FIAT.CALC_AMT_03- FIAT.CALC_AMT_04- FIAT.CALC_AMT_05- FIAT.CALC_AMT_06- FIAT.CALC_AMT_07- FIAT.CALC_AMT_08)*POWER(FIAT.EXCHANGE_RT,FIAT.CUR_OPERATOR)), 2) BASE_TRANS_AMT FROM  FIDU_TRANSACTIONS FIAT,  FIDU_ITEMS FIAS WHERE  FIAT.CHART_FIELD03 = FIAS.IDCODE AND FIAT.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAT.TRANS_STATUS = ' . singleQuote('AP') . ' AND FIAT.VOID = 0 ' . (($chart_field01 <> '') ? ' AND FIAT.CHART_FIELD01 = ' . singleQuote($chart_field01) . ' ' : '') . ' ' . (($chart_field03 <> '') ? ' AND FIAT.CHART_FIELD03 = ' . singleQuote($chart_field03) . ' ' : '') . ' AND FIAT.EFFTDATE<=' . singleQuote($edate) . ' AND FIAT.TRANSTBL_CODE IN (' . singleQuoteArray(array('DCC$', 'DCC-C', 'DDA', 'DDA$', 'DDA-C')) . ') AND EXISTS(SELECT AAGR.ID FROM AMGT_AGREEMENTS AAGR WHERE AAGR.IDCODE = FIAT.ITEM_REF_NO AND FIAT.EFFTDATE >= AAGR.START_DATE  AND AAGR.START_DATE < ' . singleQuote($edate) . ' AND AAGR.END_DATE >= ' . singleQuote($edate) . ') AND EXISTS(SELECT FIAE.IDCODE FROM AMGT_ASSETS FIAE WHERE FIAE.IDCODE = FIAS.ASSET_CODE)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->adtmname . ' R SET R.PAID_AMT =  IFNULL(ROUND((SELECT SUM(T.BASE_TRANS_AMT)  FROM X_TRANS_TMP T WHERE T.AGREEMENT_CODE = R.AGREEMENT_CODE AND T.CHART_FIELD03 = R.CHART_FIELD03), 2),0)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->adtmname . ' R SET R.LAST_PAY_DATE =  ROUND((SELECT MAX(T.EFFTDATE)  FROM X_TRANS_TMP T WHERE T.AGREEMENT_CODE = R.AGREEMENT_CODE AND T.CHART_FIELD03 = R.CHART_FIELD03), 2)';
        ClxCommon::$db->executeQuery($sql);
    }

}
