<?php

/**
 * General Code File
 * For more information contact support@alenet.com
 *
 * @author $Author: fsantana $
 * @copyright Alenet, Inc.
 * @since $Date: 2015-10-12 07:55:36 -0400 (Mon, 12 Oct 2015) $
 * @version $Rev: 7215 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Brfe {

    /**
     * Constructor
     *
     * @param
     * array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('BRFE', 'FIAT', 'GDVW', 'PRAT', 'GLAC', 'GLCP'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Initialice fiat form - Executed on init event
     */
    function qsearch() {
        if (!empty(UserRequest::$post ['BRFE_CALCULATE'])) {
		  getLookupValue('BRFE_CHART_FIELD01', 'CHART_FIELD01', UserRequest::$post);
		  getLookupValue('BRFE_BRANCH', 'BRANCH', UserRequest::$post);
		  $comp_code = UserRequest::$post ['BRFE_COMP_CODE'];
		  $from_date = xFormat::anytimedate(UserRequest::$post ['BRFE_FROM_DATE'], 'Y-m-d');
		  $to_date = xFormat::anytimedate(UserRequest::$post ['BRFE_TO_DATE'], 'Y-m-d');
		  $contract_code = UserRequest::$post ['BRFE_CHART_FIELD01'];
		  $transtbl_code = 'SYS_CRED-DISB';
		  $pct_fee = UserRequest::$post ['BRFE_BRANCH_FEE_PCT'];
		  $status = true;
		  if (empty($contract_code) || empty($comp_code) || empty($from_date) || empty($to_date) || $pct_fee <= CLX_NUM_ZERO) {
			 $status = false;
		  }
		  if ($to_date < $from_date)
			 $status = false;
		  if (!empty($status)) {
			 UserRequest::$post ['BRFE_CALCULATE'] = CLX_INIT_ZERO;
			 $this->calculate_branch_fees($comp_code, $from_date, $to_date, $contract_code, $transtbl_code, $pct_fee);
		  } else {
			 addMessage(smsg('MSG-328'));
		  }
        }
    }

    /**
     * Calculate parameters
     *
     * @param unknown_type $comp_code
     * @param unknown_type $from_date
     * @param unknown_type $to_date
     * @param unknown_type $contract_code
     * @param unknown_type $transtbl_code
     */
    private function calculate_branch_fees($comp_code, $from_date, $to_date, $contract_code, $transtbl_code, $pct_fee) {
        $glgroup_code = ClxCommon::$db->getField($this->glcpname, 'GLGROUP_CODE', 'COMP_CODE = ' . singleQuote($comp_code));
        $sql = 'DELETE FROM ' . $this->brfename . ' WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND CHART_FIELD01 = ' . singleQuote($contract_code) . ' AND TO_DATE = ' . singleQuote($to_date) . ' AND FROM_DATE = ' . singleQuote($from_date);
        ClxCommon::$db->executeQuery($sql);
        // set branch operations and amounts
        $sql = 'INSERT INTO ' . $this->brfename . ' (COMP_CODE, BRANCH, CHART_FIELD01, TRANSTBL_CODE, FROM_DATE, TO_DATE, BRANCH_OPER_NO, BRANCH_OPER_AMT, TOTAL_OPER_NO, TOTAL_AMT, FEES_AMT, BRANCH_FEE_PCT, BRANCH_FEE_AMT, CDATE, CREATEDBY, MDATE, MODIFIEDBY) SELECT FIAT.COMP_CODE, FIAT.BRANCH BRANCH, FIAT.CHART_FIELD01, FIAT.TRANSTBL_CODE, ' . singleQuote($from_date) . ' FROM_DATE, ' . singleQuote($to_date) . ' TO_DATE, COUNT(FIAT.ID) BRANCH_OPER_NO, ROUND(SUM(FIAT.TRANS_AMT), 2) BRANCH_OPER_AMT, 0 TOTAL_OPER_NO, 0 TOTAL_AMT, 0 FEES_AMT, ' . $pct_fee . ' BRANCH_FEE_PCT, 0 BRANCH_FEE_AMT, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->now) . ' MDATE, ' . singleQuote($this->username) . ' MODIFIEDBY FROM ' . $this->fiatname . ' FIAT WHERE FIAT.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAT.TRANS_STATUS = ' . singleQuote('AP') . ' AND FIAT.REVERSED = 0 AND FIAT.EFFTDATE BETWEEN ' . singleQuote($from_date) . ' AND ' . singleQuote($to_date) . ' AND FIAT.CHART_FIELD01 = ' . singleQuote($contract_code) . ' AND FIAT.TRANSTBL_CODE = ' . singleQuote($transtbl_code) . ' GROUP BY FIAT.COMP_CODE, FIAT.BRANCH, FIAT.CHART_FIELD01, FIAT.TRANSTBL_CODE';
        ClxCommon::$db->executeQuery($sql);
        // Setach total
        $sql = 'SELECT IFNULL( SUM((case GDVW.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1 WHEN ' . singleQuote('IN') . ' THEN -1 ELSE 1 END)*(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT)),0) BALANCE_AMT FROM ' . $this->gdvwname . ' GDVW WHERE GDVW.COMP_CODE = ' . singleQuote($comp_code) . ' AND GDVW.CHART_FIELD01 = ' . singleQuote($contract_code) . ' AND GDVW.EFFTDATE BETWEEN ' . singleQuote($from_date) . ' AND ' . singleQuote($to_date) . ' AND EXISTS (SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.GLGROUP_CODE = ' . singleQuote($glgroup_code) . ' AND GLAC.IDCODE = GDVW.GLACCOUNTCODE AND GLAC.IS_FEE_BR_ACC = 1)';
        $total = ClxCommon::$db->getOne($sql);
        if ($total < CLX_NUM_ZERO)
		  $total = CLX_INIT_ZERO;
        // adding totals for distribution if result if found
        $sql = 'SELECT IFNULL(SUM(BRFE.BRANCH_OPER_NO),0) TOTAL_OPER_NO, IFNULL(SUM(BRFE.BRANCH_OPER_AMT),0) TOTAL_AMT FROM ' . $this->brfename . ' BRFE WHERE BRFE.COMP_CODE = ' . singleQuote($comp_code) . ' AND BRFE.CHART_FIELD01 = ' . singleQuote($contract_code) . ' AND BRFE.FROM_DATE = ' . singleQuote($from_date) . ' AND BRFE.TO_DATE = ' . singleQuote($to_date);
        $r = ClxCommon::$db->getOneRecord($sql);
        $sql = 'UPDATE ' . $this->brfename . ' BRFE SET BRFE.TOTAL_OPER_NO = ' . singleQuote($r ['TOTAL_OPER_NO']) . ', BRFE.TOTAL_AMT = ' . $r ['TOTAL_AMT'] . ', BRFE.FEES_AMT = ' . $total . ', BRFE.BRANCH_FEE_AMT = IFNULL(ROUND(BRFE.FEES_AMT*(BRFE.BRANCH_OPER_NO/BRFE.TOTAL_OPER_NO)*(BRFE.BRANCH_FEE_PCT/100), 2),0) WHERE BRFE.COMP_CODE = ' . singleQuote($comp_code) . ' AND BRFE.CHART_FIELD01 = ' . singleQuote($contract_code) . ' AND BRFE.FROM_DATE = ' . singleQuote($from_date) . ' AND BRFE.TO_DATE = ' . singleQuote($to_date);
        ClxCommon::$db->executeQuery($sql);
    }

}
