<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2016-11-08 10:10:37 -0500 (Tue, 08 Nov 2016) $
 * @version		$Rev: 8898 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Crpr {

    function __construct($procParameters = array()) {
        multiTableName($this, array('CRPR', 'PROD', 'PRAT', 'PRLT', 'FICO', 'JEHD', 'JELN', 'PROD', 'GDVW', 'COMP', 'GLCP', 'FILO', 'CRPR', 'CPIT', 'FIAE', 'FIAE', 'FILC', 'COMP', 'GLCP', 'ACCO', 'FILS'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = (!empty($_SESSION['user_record']['username']))?$_SESSION['user_record']['username']:'';
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
        $this->debug = false;
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION') {

        }
    }

    /**
     * Runs credit construction based in credit proposal
     */
    function btnCreditBuild() {
        $idlist = getIdlist();
        $sql = 'SELECT IDCODE FROM ' . $this->crprname . ' WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if ($this->validateBuildCredit($r['IDCODE'])) {
                $this->buildCredit($r['IDCODE']);
            }
        }
		ClxCommon::$db->freeResult($rs);
        addMessage(dict('GEN_LBL_PROCESS_COMPLETED'), 'note');
    }

    /**
     * Runs credit construction based in credit proposal
     */
    function btnValidateCustomer() {
        $msg = '';
        $idlist = getIdlist();
        $n_record_qty = ClxCommon::$db->oneExistsRecords($this->crprname, 'DEBTOR_CODE IS NULL');
        if ($n_record_qty > CLX_NUM_ZERO) {
            $sql = 'SELECT EXT_CUST_NO FROM ' . $this->crprname . ' WHERE ID IN (' . toString($idlist) . ' ) AND (DEBTOR_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR DEBTOR_CODE IS NULL) UNION SELECT EXT_CRLEGAL_NO FROM ' . $this->crprname . ' WHERE ID IN (' . toString($idlist) . ') AND (EXT_CRLEGAL_NO = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR EXT_CRLEGAL_NO IS NULL)';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $content = $this->searchClientOnIbsFormByCuscum($r['EXT_CUST_NO']);
            }
			ClxCommon::$db->freeResult($rs);
            if (!empty($content)) {
                addMessage(dict('GEN_LBL_PROCESS_COMPLETED'), 'note');
            } else {
                $msg = '<li>' . smsg('MSG-252') . '</li>';
                if ($msg <> '')
                    addMessage($msg, CLX_CLASS_ALERT);
            }
        }
    }

    /**
     * Build IBS Client Search Form by Cuscum and Performs socket call.
     */
    function searchClientOnIbsFormByCuscum($ibs_cuscun) {
        if (!empty($ibs_cuscun)) {
            $EBSK = &getTool('EBSK');
            $parameters = array('IBS_CUSCUN' => $ibs_cuscun);

            $response = $EBSK->sendMessage(EBSK_IBS_DEF_CLI_JUR_MSG, $parameters, 'SELECT');
            if (empty($response [CLX_NUM_ZERO] ['LEGAL_TYPE']))
                return false; //error reading socket
            $isindividual = ($response [CLX_NUM_ZERO] ['LEGAL_TYPE'] === 'I') ? true : false;
            if ($isindividual === true) {
                $response = $EBSK->sendMessage(EBSK_IBS_DEF_CLI_NAT_MSG, $parameters, 'LOAD');
            } else {
                $response = $EBSK->sendMessage(EBSK_IBS_DEF_CLI_JUR_MSG, $parameters, 'LOAD');
            }
            $id = ClxCommon::$db->getOne('SELECT IDCODE FROM CRM_ACCOUNTS WHERE IBS_CUSCUN = ' . singleQuote($ibs_cuscun));
            if (!empty($id)) {
                $status = true;
                //Actualizando deudor
                $sql = 'UPDATE ' . $this->crprname . ' CRPR SET CRPR.DEBTOR_CODE = (SELECT MAX(ACCO.IDCODE) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IBS_CUSCUN = ' . singleQuote($ibs_cuscun) . ') WHERE CRPR.EXT_CUST_NO = ' . singleQuote($ibs_cuscun);
                ClxCommon::$db->executeQuery($sql);
                //Actualizando representante legal
                $sql = 'UPDATE ' . $this->crprname . ' CRPR SET CRPR.REP_LEGAL_CODE = (SELECT MAX(ACCO.IDCODE) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IBS_CUSCUN = ' . singleQuote($ibs_cuscun) . ') WHERE CRPR.EXT_CRLEGAL_NO = ' . singleQuote($ibs_cuscun);
                ClxCommon::$db->executeQuery($sql);
            } else {
                $status = false;
            }
        }
        return $status;
    }

    /**
     * Validates if proposal could build credits
     * @param unknown_type $crpr_code
     * @return boolean
     */
    function validateBuildCredit($crpr_code) {
        $status = true;
        $msg = '';
        //count items
        if (ClxCommon::$db->oneExistsRecords($this->cpitname, 'CRPR_CODE = ' . singleQuote($crpr_code)) == CLX_NUM_ZERO) {
            $msg = '<li>' . smsg('MSG-322', $crpr_code) . '</li>';
            $status = false;
        }
        if (ClxCommon::$db->oneExistsRecords($this->crprname, 'IDCODE = ' . singleQuote($crpr_code) . ' AND CLX_AUTH_STATUS = ' . singleQuote('AP') . '') == CLX_NUM_ZERO) {
            $msg .= '<li>' . smsg('MSG-321', $crpr_code) . '</li>';
            $status = false;
        }
        //Validate that parameters have been defined for selected product in credit
        //MSG-325
        $sql = 'SELECT CPIT.PRODUCT_CODE, COUNT(CPIT.ID) QTY FROM CRED_PROP_ITEMS CPIT LEFT JOIN GL_PROD_PRMTR_TBL PRAT ON PRAT.PRODUCT_CODE = CPIT.PRODUCT_CODE WHERE CPIT.CRPR_CODE = ' . singleQuote($crpr_code) . ' GROUP BY CPIT.PRODUCT_CODE HAVING COUNT(CPIT.ID)=0 UNION SELECT CPIT.PRODUCT_CODE, COUNT(CPIT.ID) QTY FROM CRED_PROP_ITEMS CPIT LEFT JOIN CRED_PROD_PRMTR_TBL PRLT ON PRLT.PRODUCT_CODE = CPIT.PRODUCT_CODE WHERE CPIT.CRPR_CODE = ' . singleQuote($crpr_code) . ' GROUP BY CPIT.PRODUCT_CODE HAVING COUNT(CPIT.ID)=0';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $msg .= '<li>' . smsg('MSG-325', $crpr_code . ',' . $r['PRODUCT_CODE']) . '</li>';
            $status = false;
        }
		ClxCommon::$db->freeResult($rs);
        //Validate that proposal have been defined in account
        //MSG-326
        $sql = 'SELECT COUNT(1) FROM ' . $this->acconame . ' ACCO INNER JOIN ' . $this->crprname . ' CRPR ON (CRPR.DEBTOR_CODE = ACCO.IDCODE)';
        $rs = ClxCommon::$db->getOne($sql);
        if ($rs == CLX_NUM_ZERO) {
            $msg .= '<li>' . smsg('MSG-326', $crpr_code) . '</li>';
            $status = false;
        }
        if ($msg <> '')
            addMessage($msg, CLX_CLASS_ALERT);
        return $status;
    }

    /**
     * Buld credit from crpr record
     * Proceso contempla los siguentes pasos:
     *
     * @param string $crpr_code
     */
    function buildCredit($crpr_code) {
        /*
         * 1.Crea Registro de credito partiendo de la informacion de Propuesta+Rubros FILO
         * 2.Genera los Registros de garantias de Prestamos FIAE
         * 3.Genera los registros de garantias para el prestamo FILC
         * 4.Genera la operacion de Desembolso para el primer credito FIAT-DESC
         */
        includeCodeLib('GEN_REC_UTIL');
        includeCodeLib('FILO');
        includeCodeLib('FIAE');
        $DBTB = &getTool('DBTB');
        $filo = new Filo();
        $filo_rec_base = $DBTB->tableDefaultRecord('FILO');
        ClxFreeReturn( $DBTB->tableDefaultRecord('FIAE'));
        $filc_rec_base = $DBTB->tableDefaultRecord('FILC');
        ClxFreeReturn( $DBTB->tableDefaultRecord('FILS'));
        $sql = 'SELECT CRPR.COMP_CODE, CRPR.CHART_FIELD01, CRPR.CHART_FIELD02, CRPR.CHART_FIELD03, CRPR.CHART_FIELD04, CRPR.DEBTOR_CODE, CRPR.PROPOSAL_STATUS, CRPR.RECEIVED_DATE, CRPR.EXPIRATION_DATE, CRPR.COMPLETE_DATE, CRPR.ESTCLOSE_DATE, CRPR.DECREE, CRPR.EXT_PROP_NO, CRPR.EXT_BANK_CODE, CRPR.EXT_COST_CENTER, CRPR.EXT_CUST_NO, CRPR.SALES_EXEC, CRPR.ACCO_EXEC, CRPR.ADDRESS, CRPR.BRANCH, ' . singleQuote('PRE') . ' LOAN_STATUS, COMP.CURRENCY_CODE, GLCP.OPERATION_DATE, CPIT.* FROM ' . $this->compname . ' COMP, ' . $this->glcpname . ' GLCP, ' . $this->crprname . ' CRPR, ' . $this->cpitname . ' CPIT  WHERE COMP.IDCODE = CRPR.COMP_CODE AND GLCP.COMP_CODE = COMP.IDCODE AND CPIT.CRPR_CODE = CRPR.IDCODE AND CRPR.IDCODE = ' . singleQuote($crpr_code);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if ($r['LOAN_CODE'] <> '') {

                addMessage(smsg('MSG-319', $r['LOAN_CODE']));
                continue; //already done
            }
            $filo_rec = $filo_rec_base;
            unset($r['ID'], $filo_rec['ID']);
            foreach ($r as $key => $val) {
                if (array_key_exists($key, $filo_rec)) {
                    $filo_rec[$key] = $val;
                }
            }
            $filo_rec['IDCODE'] = 'AUTO';
            $filo_rec['CLX_EFFTDATE'] = $this->today;
            $filo_rec['START_DATE'] = $r['OPERATION_DATE'];
            setCreationData($filo_rec);
            setCreationIdcode($filo_rec, 'FILO');
            ClxCommon::$db->createRecord($this->filoname, $filo_rec, false);
            //Adjuntando a subcuenta fias
            $filo_rec['CHART_FIELD01'] = $r['CHART_FIELD01'];
            $filo_rec['CHART_FIELD02'] = $r['CHART_FIELD02'];
            $filo->build_fias_from_rec($filo_rec);
            //NOTA: Amortizacion
            //Setting Schedule
            $filo->build_amortization($filo_rec['IDCODE'], $filo_rec['CLX_EFFTDATE'], CLX_NUM_ZERO);
            //Marcando como ejecutado
            ClxCommon::$db->updateRecord($this->cpitname, array('LOAN_CODE' => $filo_rec['IDCODE']), 'IDCODE = ' . singleQuote($r['IDCODE']));
            //Addjusting amortizations
            $sql = 'SELECT CPIP.SEQNUM, CPIP.DISBURSEMENT_AMT, CPIP.TENTATIVE_DATE FROM CRED_PROP_ITEMS CPIT, CRED_PROP_ITEM_SCHDLS CPIP WHERE CPIP.CPIT_CODE = CPIT.IDCODE AND CPIT.LOAN_CODE = ' . singleQuote($filo_rec['IDCODE']) . ' ORDER BY CPIT.SEQNUM ASC';
            $rs2 = ClxCommon::$db->executeQuery($sql);
            $period_start_date = '';
            while ($r2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE)) {
                if ($period_start_date === '') {
                    $period_start_date = ClxCommon::$db->getField($this->filsname, 'PERIOD_START_DATE', 'LOAN_CODE = ' . singleQuote($filo_rec['IDCODE']) . ' AND EFFTDATE = ' . singleQuote($filo_rec['CLX_EFFTDATE']) . ' AND SEQNUM = 1');
                }
                $sql = 'UPDATE ' . $this->filsname . ' FILS SET FILS.LOAN_AMT = FILS.LOAN_AMT - ' . $r2['DISBURSEMENT_AMT'] . ' WHERE FILS.LOAN_CODE = ' . singleQuote($filo_rec['IDCODE']) . ' AND FILS.EFFTDATE = ' . singleQuote($filo_rec['CLX_EFFTDATE']) . ' AND FILS.SEQNUM > ' . singleQuote($r2['SEQNUM']);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->filsname . ' FILS  SET FILS.PRINCIPAL_PAY = ' . $r2['DISBURSEMENT_AMT'] . ', FILS.PERIOD_START_DATE = ' . singleQuote($period_start_date) . ', FILS.PERIOD_END_DATE = ' . singleQuote($r2['TENTATIVE_DATE']) . ', FILS.DUE_PAY_DATE = FILS.PERIOD_END_DATE, FILS.NO_DAYS = DATEDIFF(FILS.PERIOD_END_DATE, FILS.PERIOD_START_DATE), FILS.INTEREST_PAY = ((FILS.LOAN_AMT*(FILS.LOAN_INTEREST/100))/FILS.INTEREST_CALC)*FILS.NO_DAYS,  FILS.DAILY_INTEREST = ((FILS.LOAN_AMT*(FILS.LOAN_INTEREST/100))/FILS.INTEREST_CALC),  FILS.PAYMENT_AMT = FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY, FILS.PRINCIPAL_BAL = FILS.LOAN_AMT - FILS.PRINCIPAL_PAY WHERE FILS.LOAN_CODE = ' . singleQuote($filo_rec['IDCODE']) . ' AND FILS.EFFTDATE = ' . singleQuote($filo_rec['CLX_EFFTDATE']) . ' AND FILS.SEQNUM = ' . singleQuote($r2['SEQNUM']);
                ClxCommon::$db->executeQuery($sql);
                $period_start_date = $r2['TENTATIVE_DATE'];
            }
			ClxCommon::$db->freeResult($rs2);
            //Creando Bien de Garantia
            $sql = 'SELECT FIAE.IDCODE, FIAE.CHART_FIELD03 FROM ' . $this->crprname . ' CRPR, ' . $this->fiaename . ' FIAE WHERE FIAE.CRPR_CODE = CRPR.IDCODE AND FIAE.CPIT_CODE = ' . singleQuote($r['IDCODE']) . ' AND CRPR.IDCODE = ' . singleQuote($crpr_code);
            $rs2 = ClxCommon::$db->executeQuery($sql);
            while ($r2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE)) {
                //Setting Colateral Record FICL
                $filc_rec = $filc_rec_base;
                $filc_rec['LOAN_CODE'] = $filo_rec['IDCODE'];
                $filc_rec['ASSETCODE'] = $r2['IDCODE'];
                $filc_rec['COMP_CODE'] = $r['COMP_CODE'];
                $filc_rec['FIAS_LOAN_CODE'] = $filo_rec['CHART_FIELD03'];
                $filc_rec['FIAS_COLL_CODE'] = $r2['CHART_FIELD03'];
                setCreationData($filc_rec);
                ClxCommon::$db->createRecord($this->filcname, $filc_rec, false);
            }
			ClxCommon::$db->freeResult($rs2);
            addMessage(smsg('MSG-319', $filo_rec['IDCODE']));
        }
		ClxCommon::$db->freeResult($rs);
    }

    function readInterfase() {
        $batch_id = getNow('Ymd');
        //Load socket tools
        $EBSK = &getTool('EBSK');
        $EBSK->rename_file = true; //Rename file after read
        //$EBSK->rename_file = false;//Rename file after read
        $EBSK->verbouse = true;
        //Read all proposals
        $EBSK->read('CLX014001');
        //Updating customer information and legal representative
        //CLX008001_R47_PA,		//CLX008002_R47_PA		//e cho EBSK_IBS_DEF_CLI_NAT_MSG.'<br>';		//IBS_DEF_CLI_JUR_MSG
        $sql = 'SELECT EXT_CUST_NO, ID, ' . singleQuote('DEBTOR_CODE') . ' FL FROM ' . $this->crprname . ' WHERE BATCH_ID = ' . singleQuote($batch_id) . ' AND EXT_CUST_NO <>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND EXT_CUST_NO IS NOT null AND (DEBTOR_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '  OR DEBTOR_CODE IS NULL) UNION SELECT EXT_CRLEGAL_NO, ID, ' . singleQuote('REP_LEGAL_CODE') . ' FL FROM ' . $this->crprname . ' WHERE BATCH_ID = ' . singleQuote($batch_id) . ' AND EXT_CRLEGAL_NO <>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND EXT_CRLEGAL_NO IS NOT null AND (REP_LEGAL_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '  OR REP_LEGAL_CODE IS NULL)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $acco_idcode = ClxCommon::$db->getField('CRM_ACCOUNTS', 'IDCODE', 'IBS_CUSCUN = ' . singleQuote($r[CLX_NUM_ZERO]));
            if (empty($acco_idcode)) {
                //Bring client if not exists
                ClxFreeReturn($this->searchClientOnIbsFormByCuscum($r[CLX_NUM_ZERO]));
            } else {
                $sql = 'UPDATE ' . $this->crprname . ' SET ' . $r[CLX_NUM_TWO] . ' = ' . singleQuote($acco_idcode) . ' WHERE ID = ' . singleQuote($r[CLX_NUM_ONE]);
            }
          
			ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($rs);
        //Items
        $EBSK->read('CLX014002');
        //Attach contract number based in product information
        $sql = 'UPDATE ' . $this->crprname . ' CRPR SET CRPR.CHART_FIELD01 = ( SELECT MAX(TRTI.REPLACE_VALUE) FROM CLX_SYS_TRANSL_ITEMS TRTI, CRED_PROP_ITEMS CPIT WHERE TRTI.TRANSL_CODE = ' . singleQuote('IBS_BDA_CRPR01') . ' AND TRTI.ORIGINAL_VALUE = CPIT.EXT_SUBPROD_CODE AND CPIT.CRPR_CODE = CRPR.IDCODE) WHERE CRPR.BATCH_ID = ' . singleQuote($batch_id) . ' AND CRPR.CHART_FIELD01 IS NULL';
        ClxCommon::$db->executeQuery($sql);
        //Find primary participant
        $sql = 'UPDATE ' . $this->crprname . ' CRPR SET CRPR.CHART_FIELD02 = (SELECT MAX(FIPA.ACCOUNTCODE) FROM FIDU_PARTICIPANTS FIPA WHERE FIPA.CONTRACT_CODE = CRPR.CHART_FIELD01 AND FIPA.ISPRIMARY = 1) WHERE CRPR.BATCH_ID = ' . singleQuote($batch_id) . ' AND CRPR.CHART_FIELD02 IS NULL';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->crprname . ' CRPR SET CRPR.SALES_EXEC = (SELECT MAX(FICO.SALES_EXEC) FROM FIDU_CONTRACTS FICO WHERE FICO.IDCODE = CRPR.CHART_FIELD01) WHERE CRPR.BATCH_ID = ' . singleQuote($batch_id) . ' AND CRPR.SALES_EXEC IS NULL';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->crprname . ' CRPR SET CRPR.ACCO_EXEC = (SELECT MAX(FICO.ACCO_EXEC) FROM FIDU_CONTRACTS FICO WHERE FICO.IDCODE = CRPR.CHART_FIELD01) WHERE CRPR.BATCH_ID = ' . singleQuote($batch_id) . ' AND CRPR.ACCO_EXEC IS NULL';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->crprname . ' CRPR SET CRPR.BRANCH = (SELECT MAX(FICO.BRANCH) FROM FIDU_CONTRACTS FICO WHERE FICO.IDCODE = CRPR.CHART_FIELD01) WHERE CRPR.BATCH_ID = ' . singleQuote($batch_id) . ' AND CRPR.BRANCH IS NULL';
        ClxCommon::$db->executeQuery($sql);
        //Colaterales
        $EBSK->read('CLX014003');
        //Plan inversion por rubro
        $EBSK->read('CLX014004');
        //actualizando numero de pagos
        $sql = 'UPDATE CRED_PROP_ITEMS CPIT SET CPIT.NO_PAYMENTS = (SELECT COUNT(CPIP.ID) FROM CRED_PROP_ITEM_SCHDLS CPIP WHERE CPIP.CPIT_CODE = CPIT.IDCODE) WHERE CPIT.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE CRED_PROP_ITEMS CPIT SET CPIT.LOAN_AMT = (SELECT IFNULL(SUM(CPIP.DISBURSEMENT_AMT),0) FROM CRED_PROP_ITEM_SCHDLS CPIP WHERE CPIP.CPIT_CODE = CPIT.IDCODE) WHERE CPIT.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);
    }

    //Loan Calculator
    /**
     * In con
     */
    function loan_calculator_prompt_dialog() {
        $contents = '';
        $ac = UserRequest::$request ['ac'];
        $to = UserRequest::$request [CLX_PROP_TO];
        $it = UserRequest::$request ['it'];
        $formcode = 'CPIT_CALC';
        $title = dict('GEN_LBL_LOAN_CALCULATOR');
        // RTBL_REPCINV
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
        $record = UserRequest::$post;
        if (!empty($record ['confirm']) && empty($msg)) {
            $EDIT->checkForm2($msg, $formrec);
            //Verificar gracias de capital
            if ($record['CPIT_EQ_GRACE_PERIODS'] >= $record['CPIT_NO_PAYMENTS']) {
                $msg['CPIT_EQ_GRACE_PERIODS'] = smsg('MSG-176', $record['CPIT_NO_PAYMENTS']);
            }
            if ($record['CPIT_INT_GRACE_PERIODS'] >= $record['CPIT_NO_PAYMENTS']) {
                $msg['CPIT_INT_GRACE_PERIODS'] = smsg('MSG-176', $record['CPIT_NO_PAYMENTS']);
            }
            //check grace
            for ($i = CLX_NUM_ONE; $i <= CLX_NUM_FIVE; $i++) {
                if ($record['CPIT_FEE_0' . $i . '_FIN_PER'] >= $record['CPIT_NO_PAYMENTS']) {
                    if ($i == CLX_NUM_ONE)
					$lbl = CLX_NUM_393;
                    else
                        $lbl++;
                    $msg['CPIT_FEE_0' . $i . '_FIN_PER'] = smsg('MSG-' . $lbl, $record['CPIT_NO_PAYMENTS']);
                }
            }
            if (empty($msg)) {
                $contents = $this->loan_calculator_run($record);
            }
        } else {
            $record['CPIT_GRACE_PERIOD_DAYS'] = CLX_INIT_ZERO;
            $record['CPIT_EQ_GRACE_PERIODS'] = CLX_INIT_ZERO;
            $record['CPIT_INT_GRACE_PERIODS'] = CLX_INIT_ZERO;
            $record['CPIT_LOAN_PERIOD'] = CLX_INIT_ZERO;
            $record['CPIT_NO_PAYMENTS'] = CLX_INIT_ZERO;
        }
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title, dict('GEN_LBL_EXECUTE'), '_self');
        $contents = $form->source() . ' ' . $contents;
        return $contents;
    }

    /**
     * Generates installment report
     * @param type $record
     * @return string
     */
    private function loan_calculator_run(&$record) {
        if (!is_numeric($record['CPIT_EQ_GRACE_PERIODS'])) {
            $record['CPIT_EQ_GRACE_PERIODS'] = CLX_INIT_ZERO;
        }
        $data = array();
        $nper = $record['CPIT_NO_PAYMENTS'];
        $grace_cap = $record['CPIT_EQ_GRACE_PERIODS'];
        $grace_int = $record['CPIT_INT_GRACE_PERIODS'];
        $formula = intval($record['CPIT_CRED_PAY_METHOD']);
        $loan_amt = $record['CPIT_LOAN_AMT'];
        $freq = $record['CPIT_PAYMENT_FREQ'];
        $rate = ($record['CPIT_LOAN_INTEREST'] / CLX_NUM_HUNDRED) / $freq;
        $start_date = $record['CPIT_START_DATE'];
        $curr_indx_base = intval($record['CPIT_CURR_INDX_BASE']);
        $curr_indx_pct = floatval($record['CPIT_CURR_INDX_FACTOR']);
        /*
          Interpretacion de valores Lista Código: PYFR
          Nombre: Payment Frequencies
          0 	---Select Frequency--- 12 	Monthly -> M 6 	Bimonthly -> BMO 4 	Quarterly -> Q 3 	Four-monthly -> F 2 	Semiannually -> SE 1 	Annually ->Y */
        switch ($freq) {
            case '12':
                $freq_date = 'M';
                $freq_days = CLX_NUM_30;
                break;
            case '6':
                $freq_date = 'BMO';
                $freq_days = CLX_NUM_30 * CLX_NUM_TWO;
                break;
            case '4':
                $freq_date = 'Q';
                $freq_days = CLX_NUM_30 * CLX_NUM_THREE;
                break;
            case '3':
                $freq_date = 'F';
                $freq_days = CLX_NUM_30 * CLX_NUM_FOUR;
                break;
            case '2':
                $freq_date = 'SE';
                $freq_days = CLX_NUM_30 * CLX_NUM_SIX;
                break;
            case '1':
                $freq_date = 'Y';
                $freq_days = CLX_NUM_30 * CLX_NUM_12;
                break;
            default:
                $freq_date = 'NONE';
                break;
        }
        //Get Fee Information getting from query used in the form to match
        $fees = array('1' => array(), '2' => array(), '3' => array(), '4' => array(), '5' => array());
        $sql = 'SELECT DISTINCT GLPF.SEQNUM, GLPF.CHARGE_CUSTOMER, GLPF.FEE_FORMULA FROM GL_PROD_FEES GLPF WHERE GLPF.PRODUCT_CODE =' . singleQuote($record['CPIT_PRODUCT_CODE']) . ' AND GLPF.STATUS = ' . singleQuote('A') . ' AND GLPF.PROD_STATUS = ' . singleQuote('VIG') . ' ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $fees[$r['SEQNUM']] = $r;
        }
		ClxCommon::$db->freeResult($rs);
        if ($formula == CLX_NUM_ONE) {
            if (!class_exists('Financial')) {
                require_once kPathToWebSite . 'classes/Financial.php';
            }
            $finn = new Financial();
            $payment = round($finn->PMT($rate, ($nper - $grace_cap), $loan_amt, CLX_NUM_0_PT_0, CLX_NUM_ZERO) * -CLX_NUM_ONE, CLX_NUM_TWO);
            if ($curr_indx_pct > CLX_NUM_ZERO) {
                $indx_val = CLX_INIT_ZERO;
                $loan_amt2 = $loan_amt;
                //Calculando cuotas
                for ($i = CLX_NUM_ONE; $i <= $nper; $i++) {
                    $indx_v = round($loan_amt2 * (($curr_indx_pct / CLX_NUM_HUNDRED) / $curr_indx_base) * $freq_days, CLX_NUM_FIVE);
                    if ($grace_int > CLX_NUM_ZERO && $grace_int >= $i) {
                        $int = CLX_INIT_ZERO;
                    } else {
                        $int = round($loan_amt2 * $rate, CLX_NUM_FIVE);
                    }
                    $loan_amt2 -= ($payment - ($int - $indx_v));

                    $indx_val += $indx_v;
                }
                //Determinando nuevo monto de pago incluyendo la informacion
                $payment = rounder($finn->PMT($rate, ($nper - $grace_cap), ($loan_amt + $indx_val), CLX_NUM_0_PT_0, CLX_NUM_ZERO) * -CLX_NUM_ONE, CLX_NUM_TWO);
            }
        }
        //Si comision no es financiada
        for ($i = CLX_NUM_ONE; $i <= CLX_NUM_FIVE; $i++) {
            if (isset($fees['' . $i]['FEE_FORMULA']) && $fees['' . $i]['FEE_FORMULA'] === 'P0007' && $record['CPIT_FEE_0' . $i . '_FIN_PER'] == CLX_NUM_ZERO && $record['CPIT_FEE_0' . $i . '_RATE'] > CLX_NUM_ZERO) {
                $record['CPIT_FEE_0' . $i . '_AMT'] = round($record['CPIT_LOAN_AMT'] * ($record['CPIT_FEE_0' . $i . '_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_TWO);
            }
        }
        //Calculando cuotas
        for ($i = CLX_NUM_ONE; $i <= $nper; $i++) {
            $pay = CLX_INIT_ZERO;
            //Gracia de capital
            if ($grace_int > CLX_NUM_ZERO && $grace_int >= $i) {
                $int = CLX_INIT_ZERO;
            } else {
                $int = round($loan_amt * $rate, CLX_NUM_FIVE);
            }
            //Correccion monetaria
            $indx_val = CLX_INIT_ZERO;
            if ($curr_indx_pct > CLX_NUM_ZERO) {
                $indx_val = round($loan_amt * (($curr_indx_pct / CLX_NUM_HUNDRED) / $curr_indx_base) * $freq_days, CLX_NUM_FIVE);
            }
            switch ($formula) {
                case CLX_NUM_ONE://fix pay
                    if ($grace_cap > CLX_NUM_ZERO && $grace_cap >= $i) {
                        $ppal = CLX_INIT_ZERO;
                    } else {
                        $ppal = $payment - $int;
                    }
                    break;
                case CLX_NUM_TWO:

                    //Gracia de capital
                    if ($grace_cap > CLX_NUM_ZERO && $grace_cap >= $i) {
                        $ppal = CLX_INIT_ZERO;
                    } else {
                        $ppal = round($record['CPIT_LOAN_AMT'] / ($nper - $grace_cap), CLX_NUM_THREE);
                    }
                    break;
                case CLX_NUM_THREE://int only ballon
                    if ($i == $nper) {
                        $ppal = $record['CPIT_LOAN_AMT'];
                    } else {
                        $ppal = CLX_INIT_ZERO;
                    }
                    break;
                default:
                    break;
            }
            $record['CPIT_END_DATE'] = adodb_period_date($start_date, $freq_date, $i, 'Y-m-d');
            if ($formula == CLX_NUM_ONE) {
                if ($grace_cap > CLX_NUM_ZERO && $grace_cap >= $i) {
                    $end = $loan_amt;
                } else {
                    $end = $loan_amt - ($ppal - $indx_val);
                }
            } else {
                $end = $loan_amt - $ppal;
            }
            if ($end < CLX_NUM_ZERO) {
                $int = $int + $end; //setting last item dif to interest
                $end = $end - $end;
                $end = CLX_INIT_ZERO;
            }
            //Calculos de comisiones financiadas
            $fee_total_pay = CLX_INIT_ZERO;
            for ($j = CLX_NUM_ONE; $j <= CLX_NUM_FIVE; $j++) {
                $fee['' . $j] = CLX_INIT_ZERO; //Determinando comisiones financiadas
                if (isset($fees['' . $j]['FEE_FORMULA']) && $record['CPIT_FEE_0' . $j . '_FIN_PER'] > CLX_NUM_ZERO && $record['CPIT_FEE_0' . $j . '_RATE'] > CLX_NUM_ZERO && $record['CPIT_FEE_0' . $j . '_FIN_PER'] >= $i) {
                    if ($fees['' . $j]['FEE_FORMULA'] === 'P0007') {
                        //Comision por desembolso
                        $fee_t = round($record['CPIT_LOAN_AMT'] * ($record['CPIT_FEE_0' . $j . '_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_FIVE);
                        $fee_ins = round(($fee_t / $record['CPIT_FEE_0' . $j . '_FIN_PER']), CLX_NUM_FIVE);
                        $fee_fin = round(($fee_ins * (($record['CPIT_FEE_0' . $j . '_FIN_PER'] + CLX_NUM_ONE) - $i)) * $rate, CLX_NUM_FIVE);
                        $fee['' . $j] = $fee_ins + $fee_fin;
                        if ($fees['' . $j]['CHARGE_CUSTOMER'] == CLX_NUM_ONE) {//include in payment
                            $fee_total_pay += $fee['' . $j];
                        }
                    } elseif ($fees['' . $j]['FEE_FORMULA'] === 'F0002') {
                        //Comision por desembolso
                        $fee_t = $record['CPIT_FEE_0' . $j . '_RATE'];
                        $fee_ins = round(($fee_t / $record['CPIT_FEE_0' . $j . '_FIN_PER']), CLX_NUM_FIVE);
                        $fee_fin = round(($fee_ins * (($record['CPIT_FEE_0' . $j . '_FIN_PER'] + CLX_NUM_ONE) - $i)) * $rate, CLX_NUM_FIVE);
                        $fee['' . $j] = $fee_ins + $fee_fin;
                        if ($fees['' . $j]['CHARGE_CUSTOMER'] == CLX_NUM_ONE) {//include in payment
                            $fee_total_pay += $fee['' . $j];
                        }
                    }
                }
            }
            //Calculo de comisiones por recuperacion
            for ($j = CLX_NUM_ONE; $j <= CLX_NUM_FIVE; $j++) {
                if (isset($fees['' . $j]['FEE_FORMULA']) && $record['CPIT_FEE_0' . $j . '_RATE'] > CLX_NUM_ZERO) {
                    //Realmente no financiada
                    if ($fees['' . $j]['FEE_FORMULA'] === 'P0006') {
                        $record['CPIT_FEE_0' . $j . '_FIN_PER'] = CLX_INIT_ZERO;
                        //Comision por desembolso
                        $fee['' . $j] = round(($ppal + $int) * ($record['CPIT_FEE_0' . $j . '_RATE'] / CLX_NUM_HUNDRED), CLX_NUM_FIVE);
                        if ($fees['' . $j]['CHARGE_CUSTOMER'] == CLX_NUM_ONE) {//include in payment
                            $fee_total_pay += $fee['' . $j];
                        }
                    } elseif ($fees['' . $j]['FEE_FORMULA'] === 'F0003' || ($fees['' . $j]['FEE_FORMULA'] === 'F0002' && $record['CPIT_FEE_0' . $j . '_FIN_PER'] == CLX_NUM_ZERO)) {
                        //Comision por desembolso
                        $fee['' . $j] = $record['CPIT_FEE_0' . $j . '_RATE'];
                        if ($fees['' . $j]['CHARGE_CUSTOMER'] == CLX_NUM_ONE) {//include in payment
                            $fee_total_pay += $fee['' . $j];
                        }
                    }
                }
            }
            //Incluye montos de comisiones
            $pay = $ppal + $int + ($formula == CLX_NUM_ONE) ? CLX_NUM_ZERO : $fee_total_pay;
            $data[$i] = array('LOAN_AMT' => rounder($loan_amt, CLX_NUM_TWO),
                'EDATE' => $record['CPIT_END_DATE'],
                'PPAL_PAY' => rounder($ppal, CLX_NUM_TWO),
                'INT_PAY' => rounder($int, CLX_NUM_TWO),
                'CURR_INDX_AMT' => rounder($indx_val, CLX_NUM_TWO),
                'FEE_01_PAY' => rounder($fee['1'], CLX_NUM_TWO),
                'FEE_02_PAY' => rounder($fee['2'], CLX_NUM_TWO),
                'FEE_03_PAY' => rounder($fee['3'], CLX_NUM_TWO),
                'FEE_04_PAY' => rounder($fee['4'], CLX_NUM_TWO),
                'FEE_05_PAY' => rounder($fee['5'], CLX_NUM_TWO),
                'PAY_AMT' => rounder($pay, CLX_NUM_TWO),
                'END_BAL' => rounder($end, CLX_NUM_TWO));
            $loan_amt = $end;
            if ($loan_amt <= CLX_NUM_ZERO)
                break;
        }
        $tw = CLX_NUM_TWO;
        $table = new htmlTable($tw);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_ALIGN => 'center'));
        $table->addCell(dict('GEN_LBL_LOAN_CALCULATOR'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tw));
        $table->addCell(dict('GEN_LBL_LOAN_PARAMETERS'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_COLSPAN => $tw));
        $sql = 'SELECT FM.TABLECODE, TF.FIELDNAME, F.* FROM CLX_DB_FIELDS F, CLX_UI_FORM_PANEL_FIELDS TF, CLX_UI_FORM_PANELS P, CLX_UI_FORMS FM WHERE F.FIELDNAME = TF.FIELDNAME AND P.FORMCODE = FM.IDCODE AND TF.PANELID = P.IDCODE AND P.FORMCODE = ' . singleQuote('CPIT_CALC') . ' AND TF.ACTIVE = 1 AND P.ACTIVE = 1 ORDER BY P.SEQNUM, TF.FIELDSEQNUM';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $fieldinstance = getToolObject('DBFT', $r['FIELDTYPE']);
            $value = $fieldinstance->formatField($r['TABLECODE'] . '_' . $r['FIELDNAME'], $r, $record);
            if ($value === '' || trim($value) === '()')
                continue;
            $table->addCell(dict($r['FIELDLISTLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell($value, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            //Mostrando montos de comisiones que aplican al desembolso
            for ($i = CLX_NUM_ONE; $i <= CLX_NUM_FIVE; $i++) {
                if ($r['FIELDNAME'] === 'FEE_0' . $i . '_RATE' && !empty($record['CPIT_FEE_0' . $i . '_AMT'])) {
                    $table->addCell(dict('GEN_LBL_FEE_0' . $i . '_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                    $table->addCell(xFormat::number($record['CPIT_FEE_0' . $i . '_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                }
            }
        }
		ClxCommon::$db->freeResult($rs);
        $contents = $table->source() . '<br>';
        //Informacion de coutas
        $tw = CLX_NUM_12;
        if ($curr_indx_base > CLX_NUM_ZERO)
            $tw++; //include valorization
        $table = new htmlTable($tw);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_ALIGN => 'center'));
        $table->addCell(dict('GEN_LBL_PAYMENT_SCHEDULE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tw));
        $table->addCell(dict('GEN_LBL_INSTALLMENT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_PAYMENT_DATE'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_LOAN_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_PPAL_PAY'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_INT_PAY'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        if ($curr_indx_base > CLX_NUM_ZERO) {
            $table->addCell(dict('GEN_LBL_CURR_INDX_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        }
        $table->addCell(dict('GEN_LBL_FEE_01_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_FEE_02_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_FEE_03_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_FEE_04_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_FEE_05_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_PAYMENT_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        $table->addCell(dict('GEN_LBL_BALANCE_AMT'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, 'style' => 'text-align:center'));
        foreach ($data as $key => $val) {
            $class = ($key % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
            $table->addCell($key, array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right', 'style' => 'text-align:center'));
            $table->addCell($val['EDATE'], array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right', 'style' => 'text-align:center'));
            $table->addCell(xFormat::number($val['LOAN_AMT']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            $table->addCell(xFormat::number($val['PPAL_PAY']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            $table->addCell(xFormat::number($val['INT_PAY']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            if ($curr_indx_base > CLX_NUM_ZERO) {
                $table->addCell(xFormat::number($val['CURR_INDX_AMT']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            }
            $table->addCell(xFormat::number($val['FEE_01_PAY']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            $table->addCell(xFormat::number($val['FEE_02_PAY']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            $table->addCell(xFormat::number($val['FEE_03_PAY']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            $table->addCell(xFormat::number($val['FEE_04_PAY']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            $table->addCell(xFormat::number($val['FEE_05_PAY']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            $table->addCell(xFormat::number($val['PAY_AMT']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
            $table->addCell(xFormat::number($val['END_BAL']), array(CLX_PROP_CLASS => $class, 'style' => 'text-align:right'));
        }
        $contents .= $table->source();
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_WIDTH, CLX_PROP_100PCT));
        $b = new htmlButton(dict('GEN_LBL_PRINT'));
        $b->setProp('onClick', 'javascript:open_div_window('.singleQuote('div_to_print').', '.singleQuote('Print').','.singleQuote(skinPath() . '/styles.css').');');
        $table->addCell($b->source(), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table->addCell('<div id="div_to_print"><br>' . $contents . '</div>', array());
        $contents = $table->source();
        return $contents;
    }


    /**
     * Cotizador
     * @param type $request
     * @return array
     */
    function cotizador($request){
        //Variable de retorno
        $return = array('GENERAL'=>array(), 'CRONOGRAMA'=>array());

        if(empty($request)){
            return $return;
        }
        require_once kPathToWebSite.'classes/Financial.php';
        $finn = new Financial();

        $currency_code = 'USD';
        $formula = intval($request['CRED_PAY_METHOD']);
        $loan_amt = $request['LOAN_AMT'];
        $loan_rt = $request['INTEREST_RT']/CLX_NUM_HUNDRED;
        $date = $request['START_DATE'];
        //$payday = xFormat::date($date, 'd');

        $loan_period = intval($request['LOAN_PERIOD']);
        $pay_freq = intval($request['PAYMENT_FREQ']);
        $freq = CLX_NUM_12/$pay_freq;
        $base = CLX_NUM_ONE/360;
        $no_cuotas = (int)floor($loan_period/$pay_freq);
        $days_period = intval(CLX_NUM_30*$pay_freq);
        $feci_raw_pct = ($request['FECI_PCT']/CLX_NUM_HUNDRED);
        $feci_pct = $feci_raw_pct/$freq;
        $equipo_pct = ($request['EQUIP_FEE_PCT']/CLX_NUM_HUNDRED)/$freq;
        $equipo_pct_raw = ($request['EQUIP_FEE_PCT']/CLX_NUM_HUNDRED);
        $garantia_pct_raw = ($request['GUAR_FEE_PCT']/CLX_NUM_HUNDRED);
        $garantia_pct = ($request['GUAR_FEE_PCT']/CLX_NUM_HUNDRED)/$freq;
        $pct_apertura = ($request['CLOSING_COST_PCT']/CLX_NUM_HUNDRED);
        $seg_amt =  $request['INSURANCE_AMT'];
        $seg_amt_couta = $request['INSURANCE_AMT']/$freq;
        $legal_fees_amt =  $request['LEGAL_FEES_AMT'];
        $gastos_terceros = $legal_fees_amt;
        $fin_option = intval($request['FIN_OPTION']);
        if($formula===CLX_NUM_8 || $formula===CLX_NUM_NINE){
            $fin_option = CLX_NUM_ZERO;
        }
        /*Financiamientos Extra $fin_option
          0 > No desea financiar los gastos de apertura ni los gastos de notaria
          1 > Desea financiar los gastos de apertura y los gastos de notaria
          2 > Desea financiar los gastos de apertura
         */

        $mto_solicitado_total = CLX_NUM_ZERO;
        $mto_financiar = $loan_amt;
        $gasto_apertura = $mto_financiar*$pct_apertura;
        switch($fin_option){
            case 1:
                //$neto_desembolso = $loan_amt-$gasto_apertura-$legal_fees_amt;
                $neto_desembolso = $loan_amt;
                $mto_financiar += $gasto_apertura+$legal_fees_amt;
                break;
            case 2:
               // $neto_desembolso = $loan_amt-$gasto_apertura;
               $neto_desembolso = $loan_amt;
               $mto_financiar += $gasto_apertura;
                break;
            case 3:
               $neto_desembolso = $loan_amt;
               $mto_financiar += $legal_fees_amt;
                break;
            default:
                if($formula===CLX_NUM_8 || $formula===CLX_NUM_NINE){
                    $neto_desembolso = $loan_amt-$gasto_apertura-$legal_fees_amt;
                }else{
                    $neto_desembolso = $loan_amt;
                }
                break;
        }

        $neto_desembolso_flow = CLX_NUM_ZERO;
        $mto_total_prestamo = CLX_NUM_ZERO;
        $total_interes = CLX_NUM_ZERO;
        $total_interes_feci = CLX_NUM_ZERO;
        $gastos_terceros_cuota = CLX_NUM_ZERO;

        $saldo_gasto_apertura = CLX_NUM_ZERO;
        $saldos_gastos_legales = CLX_NUM_ZERO;
        $int_gasto_apertura = CLX_NUM_ZERO;
        $int_gastos_legales = CLX_NUM_ZERO;

        $pmt = CLX_NUM_ZERO;
          /*Formula
            1 Cuota fija o
            2 Sobre saldo deudor
            3 Solo interes
            8 Interes Agregado
            9 Intereses descontados por adelantado*/
        switch($formula){
            case CLX_NUM_TWO: //Sobre saldo deudor
                $neto_desembolso_flow = $neto_desembolso;
                $loan_amt = $mto_financiar;
                break;
            case CLX_NUM_THREE: //Solo interes
                $neto_desembolso_flow = $neto_desembolso;
                $loan_amt = $mto_financiar;
                break;
            case CLX_NUM_8: //Interes Agregado
                $mto_solicitado_total = $mto_financiar+$gastos_terceros;
                $pmt = ($mto_solicitado_total+($mto_solicitado_total*($loan_rt/$freq)*$no_cuotas))/($no_cuotas*(1-$pct_apertura));
                $mto_total_prestamo = $pmt*$no_cuotas;
                $gasto_apertura = $mto_total_prestamo*$pct_apertura;

               // $saldo_gasto_apertura = $gasto_apertura;
                //$saldos_gastos_legales = $legal_fees_amt;
                //if($fin_option===CLX_NUM_ONE){
                 //   $saldo_gasto_apertura = $gasto_apertura;
                //                $saldos_gastos_legales = $legal_fees_amt;
                /*}elseif($fin_option === CLX_NUM_TWO){
                    $saldos_gastos_legales = $legal_fees_amt;
                }*/

                $total_interes = $mto_solicitado_total*(($loan_rt)/$freq)*$no_cuotas;
                $total_interes_feci = $mto_solicitado_total*(($feci_raw_pct)/$freq)*$no_cuotas;
                $neto_desembolso = $mto_total_prestamo-($gasto_apertura+$total_interes+$gastos_terceros);
                //$loan_amt = $mto_solicitado_total;
                $mto_financiar = $mto_total_prestamo;
                $neto_desembolso_flow = $loan_amt+$gasto_apertura;
                //$loan_amt = $mto_financiar;
                break;
            case CLX_NUM_NINE: //Intereses descontados por adelantado
                $mto_solicitado_total = $mto_financiar+$gastos_terceros;
                //=100/(100-((((B4*100)/12)*B5)+(B6*100))) factor
                $factor = CLX_NUM_HUNDRED/(CLX_NUM_HUNDRED-((((($loan_rt+$feci_raw_pct)*CLX_NUM_HUNDRED)/$freq)*$no_cuotas)+($pct_apertura*CLX_NUM_HUNDRED)));
                $mto_total_prestamo = $mto_solicitado_total*$factor;
                $gasto_apertura = $mto_total_prestamo*$pct_apertura;
                $total_interes = $mto_total_prestamo*($loan_rt/$freq)*$no_cuotas;
                $total_interes_feci = $mto_total_prestamo*(($feci_raw_pct)/$freq)*$no_cuotas;
                $pmt = ($mto_total_prestamo/$no_cuotas);
                $neto_desembolso = $mto_total_prestamo-($gasto_apertura+$total_interes+$gastos_terceros);

               // $saldo_gasto_apertura = $gasto_apertura;
                ///$saldos_gastos_legales = $legal_fees_amt;

                $mto_financiar = $mto_total_prestamo;
                $neto_desembolso_flow = $loan_amt+$gasto_apertura+$gastos_terceros;
                //$loan_amt = $mto_financiar;

                break;
            default: //Cuota fija o defecto
                $loan_amt = $mto_financiar;
                $pmt = $finn->PMT(($loan_rt+$feci_raw_pct)/$freq, $no_cuotas, $loan_amt, CLX_NUM_0_PT_0, CLX_NUM_ZERO) * -CLX_NUM_ONE;
                $neto_desembolso_flow = $neto_desembolso;
                break;
        }
        $seg_amt_couta = $finn->PMT($loan_rt/$freq, 12, $seg_amt, CLX_NUM_0_PT_0, CLX_NUM_ZERO) * -CLX_NUM_ONE;

        $gastos_terceros_cuota = $gastos_terceros/$no_cuotas;
        $gasto_apertura_couta = $gasto_apertura/$no_cuotas;
        $cashflow = array();
        $cashflow[] = rounder(($neto_desembolso_flow)*-1,2);


         //generales
        $return['GENERAL'] = array('TASA_NOMINAL'=>$request['INTEREST_RT'],
                           'TASA_EFECTIVA'=>CLX_NUM_ZERO,
                           'GASTOS_APERTURA'=>$gasto_apertura,
                           'GASTOS_LEGALES'=>$request['LEGAL_FEES_AMT'],
                           'MONTO_FINANCIAR'=>$mto_financiar,
                           'MONEDA'=>$currency_code,
                           'NETO_RECIBIR'=>$neto_desembolso);
        $garantia = ($loan_amt*$garantia_pct_raw)/$no_cuotas;
        $servicio = ($loan_amt*$equipo_pct_raw)/$no_cuotas;
         //cronograma
        for($i=CLX_NUM_ONE; $i<=$no_cuotas; $i++){
            $date = adodb_period_date($date, 'M', $pay_freq, 'Y-m-d');
            $feci = $loan_amt*$feci_pct;
            $seguro = ($i<=12)?$seg_amt_couta:CLX_NUM_ZERO;



            if($formula == 8 || $formula == 9){
                $int_cuota = doubleval($total_interes/$no_cuotas);
            }else{
                $int_cuota = doubleval($loan_amt*$loan_rt*$base*$days_period);
            }
            $couta_cash_flow = CLX_NUM_ZERO;
             switch($formula){
                case CLX_NUM_TWO: //Sobre saldo deudor
                    $cap_cuota = doubleval($loan_amt/($no_cuotas-($i-1)));
                    $pmt = $cap_cuota+$int_cuota;
                    $couta_cash_flow = doubleval($pmt+$gasto_apertura_couta);
                    break;
                case CLX_NUM_THREE: //Solo interes
                    $cap_cuota = doubleval(($no_cuotas==$i)?$loan_amt:CLX_NUM_ZERO);
                    $pmt = $cap_cuota+$int_cuota;
                    $couta_cash_flow = doubleval($pmt+$gasto_apertura_couta);
                    break;
                case CLX_NUM_8: //Interes Agregado
                    $int_cuota = $total_interes/$no_cuotas;
                    $feci = $total_interes_feci/$no_cuotas;
                    $cap_cuota  = $pmt-$int_cuota-$gastos_terceros_cuota-$gasto_apertura_couta;
                    $couta_cash_flow = doubleval($pmt-$gastos_terceros_cuota);
                    break;
                case CLX_NUM_NINE: //Intereses descontados por adelantado
                    $int_cuota = $total_interes/$no_cuotas;
                    $feci = $total_interes_feci/$no_cuotas;
                    $cap_cuota  = $pmt-$int_cuota-$gastos_terceros_cuota/*-$gasto_apertura_couta*/;
                    $couta_cash_flow = doubleval($pmt+$gastos_terceros_cuota-$gasto_apertura_couta);
                    break;
                default: //Cuota fija o defecto
                    if($i===CLX_NUM_ONE){
                        $pmt = $finn->PMT(($loan_rt+$feci_raw_pct)/$freq, $no_cuotas, $loan_amt, CLX_NUM_0_PT_0, CLX_NUM_ZERO) * -CLX_NUM_ONE;
                    }
                    $cap_cuota = doubleval($pmt-$int_cuota-$feci);
                    $couta_cash_flow = doubleval($pmt+$gasto_apertura_couta);
                    break;

            }

            if($i===$no_cuotas){
                $cap_cuota = $loan_amt;
            }
            $loan_amt -= $cap_cuota;
            if($fin_option===CLX_NUM_ONE){
                $int_gasto_apertura = doubleval($saldo_gasto_apertura*$loan_rt*$base*$days_period);
                $int_gastos_legales = doubleval($saldos_gastos_legales*$loan_rt*$base*$days_period);
                $saldo_gasto_apertura -= $gasto_apertura_couta;
                $saldos_gastos_legales -= $gastos_terceros_cuota;
            }elseif($fin_option === CLX_NUM_TWO){
                $int_gasto_apertura = doubleval($saldo_gasto_apertura*$loan_rt*$base*$days_period);
                $int_gastos_legales = CLX_NUM_ZERO;
                $saldos_gastos_legales -= $gastos_terceros_cuota;
            }


            if($formula == 8 || $formula == 9){
                //$seguro = $gasto_apertura_couta;
                //$servicio = $gastos_terceros_cuota;
                //$pmt_couta = $int_cuota + $cap_cuota+$seguro+$servicio+$feci;
                $pmt_couta = $int_cuota + $cap_cuota+$feci+$garantia +$seguro+$servicio+$gasto_apertura_couta+$gastos_terceros_cuota;
            }else{
                $pmt_couta = $int_cuota + $cap_cuota+$feci+$garantia +$seguro+$servicio;
            }
            //used for yield
            //$cashflow[] = $couta_cash_flow;
            $cashflow[] = rounder($pmt_couta-$feci,2);

            //$last_run_date = adodb_getdate(adodb_strtotime($date));
            $return['CRONOGRAMA'][$i] = array('FECHA'=>$date,
                    'CUOTA'=>$pmt_couta,
                    'CAPITAL'=>$cap_cuota,
                    'INTERES'=>$int_cuota,
                    'FECI'=>$feci,
                    'SEGURO'=>$seguro,
                    'SERVICIO'=>$servicio,
                    'GARANTIA'=>$garantia,
                    'DEUDA'=>$loan_amt
                    );

        }

        //Tasa efectiva
        $month_irr = $finn->IRR($cashflow);
        unset($cashflow);

        //$year_irr = (pow($month_irr+CLX_NUM_ONE, $freq)-CLX_NUM_ONE)*CLX_NUM_HUNDRED;
        $year_irr = $month_irr * $freq*CLX_NUM_HUNDRED;

        $return['GENERAL']['TASA_EFECTIVA']=$year_irr;

        return $return;
    }
}
