<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: jclerma $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2017-10-10 07:21:52 -0400 (Tue, 10 Oct 2017) $
 * @version		$Rev: 9578 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
function fias_infu_form_init(&$record) {
    $record['FIAS_GL_TYPE'] = 'AS';
    $record['FIAS_TRUST_ITEM_TYPE'] = 'IN';
}
class Fias {

    var $display = false;

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAS', 'FICO', 'PRAT', 'JELN', 'FIAS', 'JEHD', 'GLCP', 'FIAT', 'FIBP', 'FIBK', 'GLT1', 'GLAC', 'FILO', 'INAT', 'INPR', 'INFA', 'INFU', 'STOC', 'GLT2'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice inpr form
     * Executed on init event
     */
    function fias_init_form(&$record) {
        if (!empty($record['FIAS_CONTRACT_CODE'])) {
            $record['FIAS_COMP_CODE'] = ClxCommon::$db->getField($this->ficoname, 'COMP_CODE', 'IDCODE = ' . singleQuote($record['FIAS_CONTRACT_CODE']));
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function fias_validate_form(&$record, &$msg) {
        $sql = "SELECT * FROM " . $this->fiasname . " WHERE EXT_PRODUCT_CODE  = '" . $record['FIAS_EXT_PRODUCT_CODE'] . "' AND TRUST_ITEM_TYPE = '" . $record['FIAS_TRUST_ITEM_TYPE'] . "' AND " . ((UserRequest::$request['ac'] === 'MODIFY')?"IDCODE <> '" . $record['FIAS_IDCODE'] . "'" : "1 = 1");
        if(ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO){
            $DBLT = &getTool('DBLT');
            $listaGLIT = $DBLT->getListItem('GLIT', $record['FIAS_TRUST_ITEM_TYPE']);
            $msg['FIAS_EXT_PRODUCT_CODE'] = smsg('MSG-532', $record ['FIAS_EXT_PRODUCT_CODE'], $listaGLIT);
        }
    }

    function fias_build(&$record) {
        if (!array_key_exists('CURRENCY_CODE', $record) || $record['CURRENCY_CODE'] === '' || $record['CURRENCY_CODE'] === 'null') {
            return;
        }
        if (empty($record['IDCODE'])) {
            $record['IDCODE'] = 'AUTO';
        }
        //sea menor o igual a la contabilidad +1 dia
        if (empty($record['IDNAME']))
            $record['IDNAME'] = 'N/A';
        $record['CREATEDBY'] = $this->username;
        $record['MODIFIEDBY'] = $this->username;
        $record['CDATE'] = $this->now;
        $record['MDATE'] = $this->now;
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        setCreationData($record);
        setCreationIdCode($record, 'FIAS');
        ClxCommon::$db->createRecord($this->fiasname, $record, false);
        $comp_code = ClxCommon::$db->getField($this->ficoname, 'COMP_CODE', 'IDCODE = ' . singleQuote($record['CONTRACT_CODE']));
        $this->updateFiasCurrency($comp_code, $record['IDCODE']);
    }

    /**
     * Fecha Valor
     */
    function btn_build_back_value() {
        $sql = 'SELECT JEHD.IDCODE FROM ' . $this->jehdname . ' JEHD WHERE JEHD.ID IN (' . toString(getIdList()) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->build_back_value($r['IDCODE']);
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Fecha Valor
     */
    function build_back_value($jehd) {

        if (empty($jehd))
            return;
        //Check if operation si subject to back value. Date efftdate < operation date Excluyendo los devengos
        $sql = 'SELECT JEHD.*, GLCP.OPERATION_DATE, GLCP.GLGROUP_CODE FROM ' . $this->glcpname . ' GLCP, ' . $this->jehdname . ' JEHD WHERE JEHD.COMP_CODE = GLCP.COMP_CODE AND JEHD.EFFTDATE < GLCP.OPERATION_DATE AND JEHD.JE_SOURCE NOT IN (' . singleQuoteArray(array('PINTP', 'CINT', 'INIP', 'INVA')) . ') AND JEHD.IDCODE = ' . singleQuote($jehd) . ' AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND EXISTS (SELECT FIAS.ID FROM ' . $this->fiasname . ' FIAS, ' . $this->jelnname . ' JELN, ' . $this->pratname . ' PRAT WHERE JELN.CHART_FIELD03 = FIAS.IDCODE AND JELN.JEHDR_CODE = JEHD.IDCODE AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE)';
        $src_operation = ClxCommon::$db->getOneRecord($sql);
        if (empty($src_operation))
            return;
        //Si la transaccion toca el producto entonces continuar para ver
        //si el producto de la linea calcula intereses
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT2'); //Clear tmp
        //setting exchange and currency
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($src_operation['COMP_CODE']);
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();

        //Cuentas de banco
        $this->build_back_value_fibk($src_operation, $comp, $jehd, $comprec);

        //Creditos
        $this->build_back_value_filo($src_operation, $comp, $jehd, $comprec);
        //Inversiones
        $this->build_back_value_inat($src_operation, $comp, $jehd, $comprec);
        $this->build_back_value_inat_amortization($src_operation, $comp, $jehd, $comprec);
        $this->build_back_value_inat_valorization($src_operation, $comp, $jehd, $comprec);

        //Cleanup
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt2name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));

        return;
    }

    /**
     * Bank Account Operations
     * @param unknown_type $src_operation
     */
    private function build_back_value_fibk(&$src_operation, &$comp, &$jehd, &$comprec) {
        $operation_date = $comprec['OPERATION_DATE'];
        $je_source = 'CINT'; //Intereses de cuentas de banco
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt2name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));

        $sql = 'INSERT INTO ' . $this->glt2name . ' (BATCH_ID,
					  EFFTDATE,
					  GLACCOUNTCODE,
					  GL01_CODE,
					  GL02_CODE,
					  GL_TYPE,
					  BALANCE_AMT,
					  CALC_AMT_01,
					  CALC_AMT_02,
					  CHART_FIELD01,
					  CHART_FIELD02,
					  CHART_FIELD03,
					  CHART_FIELD04,
					  TRUST_ITEM_TYPE,
					  CURRENCY_CODE,
					  CUR_OPERATOR,
					  EXCHANGE_RT,
					  DEBIT_TRANS_AMT,
					  CREDIT_TRANS_AMT,
					  DEBIT_AMT,
					  CREDIT_AMT,
					  BANK_ACCOUNT_NO,
					  PRODUCT_CODE,
					  CALC_AMT_03,
					  CALC_AMT_04,
					  DIVIDER_FACTOR,
					  ITEM_CODE,
					  ITEM02_CODE,
					  COMP_CODE,
					  NO_DAYS,
                                          NEXT_DATE)
                                SELECT
                                    ' . singleQuote($this->batch_id) . ' BATCH_ID,
                                    IF(FIBP.CLX_EFFTDATE<' . singleQuote($src_operation['EFFTDATE']) . ',' . singleQuote($src_operation['EFFTDATE']) . ',FIBP.CLX_EFFTDATE) EFFTDATE,
                                    GL.GLACCOUNTCODE,
                                    GL.GL01_CODE,
                                    GL.GL02_CODE,
                                    GL.GL_TYPE,
                                    GL.BALANCE_AMT,
                                    FIBP.INTEREST_RT CALC_AMT_01,
                                    0 CALC_AMT_02,
                                    GL.CHART_FIELD01,
                                    GL.CHART_FIELD02,
                                    GL.CHART_FIELD03,
                                    GL.CHART_FIELD04,
                                    GL.TRUST_ITEM_TYPE,
                                    GL.CURRENCY_CODE,
                                    GL.CUR_OPERATOR,
                                    GL.EXCHANGE_RT,
                                    0 DEBIT_TRANS_AMT,
                                    0 CREDIT_TRANS_AMT,
                                    0 DEBIT_AMT,
                                    0 CREDIT_AMT,
                                    GL.BANK_ACCOUNT_NO,
                                    GL.PRODUCT_CODE,
                                    0 CALC_AMT_03,
                                    0 CALC_AMT_04,
                                    FIBP.INTEREST_CALC DIVIDER_FACTOR,
                                    ' . singleQuote('RCREM') . ' ITEM_CODE,
                                    ' . singleQuote('RCREM') . ' ITEM02_CODE,
                                    ' . singleQuote($src_operation['COMP_CODE']) . ' COMP_CODE,
                                    DATEDIFF(' . singleQuote($src_operation['OPERATION_DATE']) . ', ' . singleQuote($src_operation['EFFTDATE']) . ') NO_DAYS,
                                    IF(FIBP.CLX_EFFTDATE<' . singleQuote($src_operation['EFFTDATE']) . ',' . singleQuote($src_operation['EFFTDATE']) . ',FIBP.CLX_EFFTDATE) NEXT_DATE
                                FROM
                                    FIDU_FIBK_PARAMETERS_TBL FIBP,
                                    (SELECT
					  PRAT.PRO_GL_CODE GLACCOUNTCODE,
					  PRAT.AR_GL_CODE GL01_CODE,
					  PRAT.INC_GL_CODE GL02_CODE,
					  GLAC.GL_TYPE,
					  SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT,
					  JELN.CHART_FIELD01,
					  JELN.CHART_FIELD02,
					  JELN.CHART_FIELD03,
					  JELN.CHART_FIELD04,
					  FIAS.TRUST_ITEM_TYPE,
					  FIBK.CURRENCY_CODE,
					  JELN.CUR_OPERATOR,
					  JELN.EXCHANGE_RT,
					  FIBK.BANK_ACCOUNT_NO,
					  FIBK.BANK_PROD_CODE PRODUCT_CODE
				FROM
					GL_CODES_TBL GLAC,
					GL_JOURNAL_LINES JELN,
					FIDU_ITEMS FIAS,
					FIDU_BANK_ACCOUNTS FIBK,
					GL_PROD_PRMTR_TBL PRAT
				WHERE
					JELN.JEHDR_CODE = ' . singleQuote($src_operation['IDCODE']) . '
					AND GLAC.IDCODE = JELN.GLACCOUNTCODE
					AND JELN.CURRENCY_CODE = FIBK.CURRENCY_CODE
					AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE
					AND GLAC.GLGROUP_CODE = ' . singleQuote($src_operation['GLGROUP_CODE']) . '
					AND FIAS.IDCODE = JELN.CHART_FIELD03
					AND FIBK.CALC_INTEREST = 1
					AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO
					AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE
					AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . '
				GROUP BY
					  PRAT.PRO_GL_CODE,
					  PRAT.AR_GL_CODE,
					  PRAT.INC_GL_CODE,
					  GLAC.GL_TYPE,
					  JELN.CHART_FIELD01,
					  JELN.CHART_FIELD02,
					  JELN.CHART_FIELD03,
					  JELN.CHART_FIELD04,
					  FIAS.TRUST_ITEM_TYPE,
					  FIBK.CURRENCY_CODE,
					  JELN.CUR_OPERATOR,
					  JELN.EXCHANGE_RT,
					  FIBK.BANK_ACCOUNT_NO,
					  FIBK.BANK_PROD_CODE) GL
                            WHERE
                                FIBP.BANKACT_CODE = GL.BANK_ACCOUNT_NO
                                AND FIBP.CLX_EFFTDATE <> '. singleQuote($src_operation['OPERATION_DATE']).'
                                AND FIBP.CLX_EFFTDATE BETWEEN (SELECT MAX(FIBPX.CLX_EFFTDATE)
							FROM FIDU_FIBK_PARAMETERS_TBL FIBPX
							WHERE FIBPX.BANKACT_CODE = FIBP.BANKACT_CODE
							AND FIBPX.CLX_EFFTDATE<=' . singleQuote($src_operation['EFFTDATE']) . ') AND ' . singleQuote($src_operation['OPERATION_DATE']) . '';
        ClxCommon::$db->executeQuery($sql);
       //Retornando
        if (ClxCommon::$db->oneExistsRecords($this->glt2name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
                echoLog('Deposit Interest Back Value None: Nothing to do returning<br>');
            }
            return;
        }

        if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
            echoLog(' BANK ACCOUNTS AND DEPOSITS BACK VALUE. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Source Journal Entry: ' . $src_operation['IDCODE']);
        }

        $sql = 'DROP TABLE IF EXISTS TMP_DATE_TMP';
        ClxCommon::$db->executeQuery($sql);

        $sql = 'CREATE TEMPORARY TABLE TMP_DATE_TMP SELECT BANK_ACCOUNT_NO, NEXT_DATE FROM ' . $this->glt2name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);


        $sql = 'UPDATE ' . $this->glt2name . ' T1 SET T1.EFFTDATE =  IFNULL('
                . '(SELECT ADDDATE(MIN(T2.NEXT_DATE),INTERVAL 0 DAY) FROM TMP_DATE_TMP T2 WHERE T2.BANK_ACCOUNT_NO = T1.BANK_ACCOUNT_NO AND T2.NEXT_DATE>T1.EFFTDATE),'
                . 'ADDDATE(' . singleQuote($operation_date) . ',INTERVAL 0 DAY)  ) '
                . 'WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->glt2name . ' T1 SET T1.NEXT_DATE =  ADDDATE(T1.NEXT_DATE, INTERVAL -1 DAY), T1.EFFTDATE =  ADDDATE(T1.EFFTDATE, INTERVAL -1 DAY) WHERE T1.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        $sql = 'DROP TABLE IF EXISTS TMP_DATE_TMP';
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->glt2name . ' SET CALC_AMT_02 = IFNULL(ROUND((BALANCE_AMT*(CALC_AMT_01/100)* case DIVIDER_FACTOR WHEN ' . singleQuote('360') . ' THEN (1/360) WHEN ' . singleQuote('365') . ' THEN (1/365) WHEN ' . singleQuote('30/360') . ' THEN (1/360) WHEN ' . singleQuote('30/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/360') . ' THEN (1/360) WHEN ' . singleQuote('AC/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/AC') . ' THEN (1/365) ELSE 1 END), 2), 0) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = CALC_AMT_02, DEBIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = -1*CALC_AMT_02, CREDIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = CALC_AMT_02, CREDIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = -1*CALC_AMT_02, DEBIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CREDIT_AMT = 0 AND DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        ClxCommon::$db->executeQuery($sql);

        //Delete all participants where rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CALC_AMT_02 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->oneExistsRecords($this->glt2name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
                echoLog('Deposit Interest: Nothing to do returning');
            }
            return;
        }


        //setting entry loop for all days required
        $i = CLX_INIT_ZERO;
        $transacction_date = $src_operation['EFFTDATE'];
        $_SESSION['BACK_VALUE_TRANS_CODE'] = $src_operation['TRANSTBL_CODE'];
        while ($transacction_date < $operation_date) {

            $this->build_backvalue_operation($src_operation, $comp, $jehd, $comprec, $je_source, $transacction_date, $operation_date);

            $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE EFFTDATE = ' . singleQuote($transacction_date) . ' AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);

            $i++;
            $transacction_date = adodb_next_day($transacction_date);
            if ($i > CLX_NUM_50)
                break;
        }
        unset($_SESSION['BACK_VALUE_TRANS_CODE']);
        return;
    }

    /**
     * Credit Account Operations
     * @param unknown_type $src_operation
     */
    private function build_back_value_filo(&$src_operation, &$comp, &$jehd, &$comprec) {
        $operation_date = $comprec['OPERATION_DATE'];
        $je_source = 'PINTP'; //Intereses de Prestamos
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt2name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //En cuenta de banco
        $sql = 'INSERT INTO ' . $this->glt2name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, TRUST_ITEM_TYPE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, BANK_ACCOUNT_NO, PRODUCT_CODE, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, ITEM_CODE, ITEM02_CODE, COMP_CODE, NO_DAYS, NEXT_DATE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($src_operation['EFFTDATE']) . ' EFFTDATE, PRAT.PRO_GL_CODE GLACCOUNTCODE, PRAT.AR_GL_CODE GL01_CODE, PRAT.INC_GL_CODE GL02_CODE, GLAC.GL_TYPE, SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT, FILO.LOAN_INTEREST CALC_AMT_01, 0 CALC_AMT_02, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, FILO.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.EXCHANGE_RT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 DEBIT_AMT, 0 CREDIT_AMT, FILO.IDCODE, FILO.PRODUCT_CODE, 0 CALC_AMT_03, 0 CALC_AMT_04, FILO.INTEREST_CALC DIVIDER_FACTOR, ' . singleQuote('IP') . ' ITEM_CODE, ' . singleQuote('IP') . ' ITEM02_CODE, ' . singleQuote($src_operation['COMP_CODE']) . ' COMP_CODE, DATEDIFF(' . singleQuote($src_operation['OPERATION_DATE']) . ', ' . singleQuote($src_operation['EFFTDATE']) . ') NO_DAYS, FILO.START_DATE NEXT_DATE FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT WHERE JELN.JEHDR_CODE = ' . singleQuote($src_operation['IDCODE']) . ' AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JELN.CURRENCY_CODE = FILO.CURRENCY_CODE AND GLAC.GLGROUP_CODE = ' . singleQuote($src_operation['GLGROUP_CODE']) . ' AND FIAS.IDCODE = JELN.CHART_FIELD03 AND FILO.CALC_INTEREST = 1 AND FILO.PRODUCT_CODE = PRAT.PRODUCT_CODE AND PRAT.ID = (SELECT MAX(PRATX.ID) FROM ' . $this->pratname . ' PRATX WHERE PRATX.PRODUCT_CODE = PRAT.PRODUCT_CODE AND PRATX.PRO_GL_CODE = JELN.GLACCOUNTCODE) AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE) GROUP BY PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, PRAT.INC_GL_CODE, GLAC.GL_TYPE, FILO.LOAN_INTEREST, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, FILO.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.EXCHANGE_RT, FILO.IDCODE, FILO.PRODUCT_CODE, FILO.INTEREST_CALC, FILO.START_DATE';
        ClxCommon::$db->executeQuery($sql);
        //Retornando
        if (ClxCommon::$db->oneExistsRecords($this->glt2name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if (kDefaultIsCron === CLX_NUM_ZERO && $this->display === true) {
                echoLog('Credit Interest Back Value None: Nothing to do returning');
            }
            return;
        }
        if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
            echoLog(' CREDIT BACK VALUE BACK VALUE. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Source Journal Entry: ' . $src_operation['IDCODE']);
        }
        $sql = 'UPDATE ' . $this->glt2name . ' SET CALC_AMT_02 = IFNULL(ROUND((BALANCE_AMT*(CALC_AMT_01/100)* case DIVIDER_FACTOR WHEN ' . singleQuote('360') . ' THEN (1/360) WHEN ' . singleQuote('365') . ' THEN (1/365) WHEN ' . singleQuote('30/360') . ' THEN (1/360) WHEN ' . singleQuote('30/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/360') . ' THEN (1/360) WHEN ' . singleQuote('AC/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/AC') . ' THEN (1/365) ELSE (1/360) END), 2), 0) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = CALC_AMT_02, DEBIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = -1*CALC_AMT_02, CREDIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = CALC_AMT_02, CREDIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = -1*CALC_AMT_02, DEBIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CREDIT_AMT = 0 AND DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        ClxCommon::$db->executeQuery($sql);
        //Delete all participants where rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CALC_AMT_02 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Retor
        if (ClxCommon::$db->oneExistsRecords($this->glt2name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if (kDefaultIsCron === CLX_NUM_ZERO && $this->display === true) {
                echoLog('No credit Interest: Nothing to do returning');
            }
            return;
        }
        //setting entry loop for all days required
        $i = CLX_INIT_ZERO;
        $transacction_date = $src_operation['EFFTDATE'];

        while ($transacction_date <= $operation_date) {
            $this->build_backvalue_operation($src_operation, $comp, $jehd, $comprec, $je_source, $transacction_date, $operation_date);
            $i++;
            $transacction_date = adodb_next_day($transacction_date);
            if ($i > CLX_NUM_50)
                break;
        }
        return;
    }

    /**
     * Investment Account Operations
     * @param unknown_type $src_operation
     */
    private function build_back_value_inat(&$src_operation, &$comp, &$jehd, &$comprec) {
        if ($src_operation['INAT_CODE'] === '')
            return;
        $operation_date = $comprec['OPERATION_DATE'];
        $je_source = 'INIP'; //Intereses de inversiones
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt2name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //En inversiones
        $sql = 'INSERT INTO ' . $this->glt2name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, TRUST_ITEM_TYPE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, BANK_ACCOUNT_NO, PRODUCT_CODE, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, ITEM_CODE, ITEM02_CODE, COMP_CODE, NO_DAYS) '
                . 'SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($src_operation['EFFTDATE']) . ' EFFTDATE, PRAT.PRO_GL_CODE GLACCOUNTCODE, PRAT.AR_GL_CODE GL01_CODE, PRAT.INC_GL_CODE GL02_CODE, GLAC.GL_TYPE, SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT, INPR.COUPON_RT CALC_AMT_01, 0 CALC_AMT_02, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, INFU.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.EXCHANGE_RT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 DEBIT_AMT, 0 CREDIT_AMT, INAT.POSITION_NUMBER, INPR.PRODUCT_CODE, 0 CALC_AMT_03, 0 CALC_AMT_04, INPR.INTEREST_CALC DIVIDER_FACTOR, ' . singleQuote('INVE') . ' ITEM_CODE, ' . singleQuote('INVE') . ' ITEM02_CODE, ' . singleQuote($src_operation['COMP_CODE']) . ' COMP_CODE, DATEDIFF(' . singleQuote($src_operation['OPERATION_DATE']) . ', ' . singleQuote($src_operation['EFFTDATE']) . ') NO_DAYS '
                . 'FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->inatname . ' INAT, ' . $this->inprname . ' INPR, ' . $this->pratname . ' PRAT, ' . $this->infuname . ' INFU '
                . 'WHERE INAT.INVEST_ACTIVITY<>' . singleQuote('VE') . ' AND JELN.JEHDR_CODE = ' . singleQuote($src_operation['IDCODE']) . ' AND INAT.PORTFOLIO_CODE = INFU.IDCODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JELN.CURRENCY_CODE = INFU.CURRENCY_CODE AND JELN.ITEM_REF_NO = INAT.POSITION_NUMBER AND INAT.PORTFOLIO_CODE = FIAS.PORTFOLIO_CODE AND INAT.IDCODE = ' . singleQuote($src_operation['INAT_CODE']) . ' AND GLAC.GLGROUP_CODE = ' . singleQuote($src_operation['GLGROUP_CODE']) . ' AND FIAS.IDCODE = JELN.CHART_FIELD03 AND FIAS.CONTRACT_CODE = JELN.CHART_FIELD01 AND INPR.PRODUCT_CODE = PRAT.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND INPR.CALC_INTEREST = 1 AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE AND INPR.INVESTMENT_CODE = INAT.INVESTMENT_CODE AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE) FROM ' . $this->inprname . ' INPRX WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE AND INPRX.CLX_EFFTDATE<=NOW() ) GROUP BY PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, PRAT.INC_GL_CODE, GLAC.GL_TYPE, INPR.COUPON_RT, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, INFU.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.EXCHANGE_RT, INAT.POSITION_NUMBER, INPR.PRODUCT_CODE, INPR.INTEREST_CALC';
        ClxCommon::$db->executeQuery($sql);
        //Retornando
        if (ClxCommon::$db->oneExistsRecords($this->glt2name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
                echoLog('Investments Interest Back Value None: Nothing to do returning');
            }
            return;
        }
        if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
            echoLog(' INVESTMENTS BACK VALUE. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Source Journal Entry: ' . $src_operation['IDCODE']);
        }
        $sql = 'UPDATE ' . $this->glt2name . ' SET CALC_AMT_02 = IFNULL(ROUND((BALANCE_AMT*(CALC_AMT_01/100)* case DIVIDER_FACTOR WHEN ' . singleQuote('360') . ' THEN (1/360) WHEN ' . singleQuote('365') . ' THEN (1/365) WHEN ' . singleQuote('30/360') . ' THEN (1/360) WHEN ' . singleQuote('30/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/360') . ' THEN (1/360) WHEN ' . singleQuote('AC/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/AC') . ' THEN (1/365) ELSE (1/360) END), 2), 0) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = CALC_AMT_02, DEBIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = -1*CALC_AMT_02, CREDIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = CALC_AMT_02, CREDIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = -1*CALC_AMT_02, DEBIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CREDIT_AMT = 0 AND DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Delete all participants where rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CALC_AMT_02 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Retor
        if (ClxCommon::$db->oneExistsRecords($this->glt2name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
                echoLog('Deposit Interest: Nothing to do returning');
            }
            return;
        }
        //setting entry loop for all days required
        $i = CLX_INIT_ZERO;
        $transacction_date = $src_operation['EFFTDATE'];
        while ($transacction_date < $operation_date) {
            $this->build_backvalue_operation($src_operation, $comp, $jehd, $comprec, $je_source, $transacction_date, $operation_date);
            $i++;
            $transacction_date = adodb_next_day($transacction_date);
            if ($i > CLX_NUM_50)
                break; //just in case






//Updating Infa and portfolios
            $sql = 'UPDATE ' . $this->infaname . ' INFA, ' . $this->glt2name . ' X SET INFA.ACCRUED_INT_AMT = INFA.ACCRUED_INT_AMT + X.CALC_AMT_02 WHERE INFA.POSITION_NUMBER = X.BANK_ACCOUNT_NO AND X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Updating portfolio totals
            if (!class_exists('Infu'))
                includeCodeLib('INFU');
            $infu = new Infu ();
            $sql = 'SELECT DISTINCT INFU.IDCODE, INFU.COMP_CODE FROM ' . $this->fiasname . ' FIAS, ' . $this->glt2name . ' X, ' . $this->infuname . ' INFU WHERE FIAS.IDCODE = X.CHART_FIELD03 AND FIAS.PORTFOLIO_CODE = INFU.IDCODE';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $infu->infu_update_portfolio_totals($r['COMP_CODE'], $r['IDCODE']);
            }
			ClxCommon::$db->freeResult($rs);

            //caso 1004568 Colocando contabilidad nuevamente para no elevar los montos exponencialmente
            $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = CALC_AMT_02, DEBIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = -1*CALC_AMT_02, CREDIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = CALC_AMT_02, CREDIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = -1*CALC_AMT_02, DEBIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CREDIT_AMT = 0 AND DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Delete all participants where rows from overdraft loans. or cero that will not earn int.
            $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CALC_AMT_02 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //fin caso 1004568

        }//loop on date
        return;
    }

    /**
     * Investment Account Operations
     * @param unknown_type $src_operation
     */
    private function build_back_value_inat_amortization(&$src_operation, &$comp, &$jehd, &$comprec) {
        //INAP Amortizacion
        if ($src_operation['INAT_CODE'] === '')
            return;
        $operation_date = $comprec['OPERATION_DATE'];
        $je_source = 'INAP'; //Amortizacion de prima o descuento
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt2name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //En inversiones
        //$sql = 'INSERT INTO ' . $this->glt2name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, TRUST_ITEM_TYPE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, BANK_ACCOUNT_NO, PRODUCT_CODE, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, ITEM_CODE, ITEM02_CODE, COMP_CODE, NO_DAYS) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($src_operation['EFFTDATE']) . ' EFFTDATE, PRAT.PRO_GL_CODE GLACCOUNTCODE, IF(INFA.PREMIUM_DISC_AMT<0, PRAT.PYD2D_GL_CODE, PRAT.PYD2P_GL_CODE) GL01_CODE, IF(INFA.PREMIUM_DISC_AMT<0, PRAT.DISCOUNT_GL_CODE, PRAT.PREMIUM_GL_CODE) GL02_CODE, GLAC.GL_TYPE, SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT, /* Cupon Rt-Yield to determine the portion of premium or discount */ (INPR.COUPON_RT-INFA.YIELD_RT) CALC_AMT_01, INFA.PREMIUM_DISC_AMT CALC_AMT_02, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, INFU.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.EXCHANGE_RT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 DEBIT_AMT, 0 CREDIT_AMT, INAT.POSITION_NUMBER, INPR.PRODUCT_CODE, 0 CALC_AMT_03, 0 CALC_AMT_04, INPR.INTEREST_CALC DIVIDER_FACTOR, ' . singleQuote('INVE') . ' ITEM_CODE, ' . singleQuote('INVE') . ' ITEM02_CODE, ' . singleQuote($src_operation['COMP_CODE']) . ' COMP_CODE, DATEDIFF(' . singleQuote($src_operation['OPERATION_DATE']) . ', ' . singleQuote($src_operation['EFFTDATE']) . ') NO_DAYS FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->inatname . ' INAT, ' . $this->inprname . ' INPR, ' . $this->pratname . ' PRAT, ' . $this->infuname . ' INFU, ' . $this->infaname . ' INFA WHERE JELN.JEHDR_CODE = ' . singleQuote($src_operation['IDCODE']) . ' AND INFA.POSITION_NUMBER = INAT.POSITION_NUMBER AND INAT.PORTFOLIO_CODE = INFU.IDCODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JELN.CURRENCY_CODE = INFU.CURRENCY_CODE AND JELN.ITEM_REF_NO = INAT.POSITION_NUMBER AND INAT.PORTFOLIO_CODE = FIAS.PORTFOLIO_CODE AND INAT.IDCODE = ' . singleQuote($src_operation['INAT_CODE']) . ' AND GLAC.GLGROUP_CODE = ' . singleQuote($src_operation['GLGROUP_CODE']) . ' AND FIAS.IDCODE = JELN.CHART_FIELD03 AND FIAS.CONTRACT_CODE = JELN.CHART_FIELD01 AND INPR.PRODUCT_CODE = PRAT.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND INPR.CALC_INTEREST = 1 AND INFA.FACE_VALUE <> 0 AND INFA.INVEST_AMT <> INFA.FACE_VALUE AND INFA.STOP_AMORTIZATION = 0 AND INPR.INV_AMORT_TYPE = ' . "'S'" . ' /* single interest */ AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE AND INPR.INVESTMENT_CODE = INAT.INVESTMENT_CODE AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE) FROM ' . $this->inprname . ' INPRX WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE AND INPRX.CLX_EFFTDATE<=NOW() ) GROUP BY PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, PRAT.INC_GL_CODE, GLAC.GL_TYPE, INPR.COUPON_RT, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, INFU.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.EXCHANGE_RT, INAT.POSITION_NUMBER, INPR.PRODUCT_CODE, INPR.INTEREST_CALC, INFA.YIELD_RT, INFA.PD_YIELD_RT';
        $sql = 'INSERT INTO ' . $this->glt2name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, TRUST_ITEM_TYPE, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, BANK_ACCOUNT_NO, PRODUCT_CODE, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, ITEM_CODE, ITEM02_CODE, COMP_CODE, NO_DAYS) '
                . 'SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($src_operation['EFFTDATE']) . ' EFFTDATE, PRAT.PRO_GL_CODE GLACCOUNTCODE, IF(INFA.PREMIUM_DISC_AMT<0, PRAT.PYD2D_GL_CODE, PRAT.PYD2P_GL_CODE) GL01_CODE, IF(INFA.PREMIUM_DISC_AMT<0, PRAT.DISCOUNT_GL_CODE, PRAT.PREMIUM_GL_CODE) GL02_CODE, GLAC.GL_TYPE, SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT, /* Cupon Rt-Yield to determine the portion of premium or discount */ (INPR.COUPON_RT-INFA.YIELD_RT) CALC_AMT_01, INFA.PREMIUM_DISC_AMT CALC_AMT_02, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, INFU.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.EXCHANGE_RT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 DEBIT_AMT, 0 CREDIT_AMT, INAT.POSITION_NUMBER, INPR.PRODUCT_CODE, 0 CALC_AMT_03, 0 CALC_AMT_04, INPR.INTEREST_CALC DIVIDER_FACTOR, ' . singleQuote('INVE') . ' ITEM_CODE, ' . singleQuote('INVE') . ' ITEM02_CODE, ' . singleQuote($src_operation['COMP_CODE']) . ' COMP_CODE, DATEDIFF(' . singleQuote($src_operation['OPERATION_DATE']) . ', ' . singleQuote($src_operation['EFFTDATE']) . ') NO_DAYS '
                . 'FROM ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->inatname . ' INAT, ' . $this->inprname . ' INPR, ' . $this->pratname . ' PRAT, ' . $this->infuname . ' INFU, ' . $this->infaname . ' INFA '
                . 'WHERE INAT.INVEST_ACTIVITY<>' . singleQuote('VE') . ' AND JELN.JEHDR_CODE = ' . singleQuote($src_operation['IDCODE']) . ' AND INFA.POSITION_NUMBER = INAT.POSITION_NUMBER AND INAT.PORTFOLIO_CODE = INFU.IDCODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JELN.CURRENCY_CODE = INFU.CURRENCY_CODE AND JELN.ITEM_REF_NO = INAT.POSITION_NUMBER AND INAT.PORTFOLIO_CODE = FIAS.PORTFOLIO_CODE AND INAT.IDCODE = ' . singleQuote($src_operation['INAT_CODE']) . ' AND GLAC.GLGROUP_CODE = ' . singleQuote($src_operation['GLGROUP_CODE']) . ' AND FIAS.IDCODE = JELN.CHART_FIELD03 AND FIAS.CONTRACT_CODE = JELN.CHART_FIELD01 AND INPR.PRODUCT_CODE = PRAT.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND INPR.CALC_INTEREST = 1 AND INFA.INVEST_AMT <> INFA.FACE_VALUE AND INFA.STOP_AMORTIZATION = 0 AND INPR.INV_AMORT_TYPE = ' . "'S'" . ' /* single interest */ AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE AND INPR.INVESTMENT_CODE = INAT.INVESTMENT_CODE AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE) FROM ' . $this->inprname . ' INPRX WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE AND INPRX.CLX_EFFTDATE<=NOW() ) GROUP BY PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, PRAT.INC_GL_CODE, GLAC.GL_TYPE, INPR.COUPON_RT, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, FIAS.TRUST_ITEM_TYPE, INFU.CURRENCY_CODE, JELN.CUR_OPERATOR, JELN.EXCHANGE_RT, INAT.POSITION_NUMBER, INPR.PRODUCT_CODE, INPR.INTEREST_CALC, INFA.YIELD_RT, INFA.PD_YIELD_RT';
        ClxCommon::$db->executeQuery($sql);
        //Retornando
        if (ClxCommon::$db->oneExistsRecords($this->glt2name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
                echoLog('Investments Interest Back Value None: Nothing to do returning');
            }
            return;
        }
        if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
            echoLog(' INVESTMENTS BACK VALUE AMORTIZATION. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Source Journal Entry: ' . $src_operation['IDCODE']);
        }
        $sql = 'UPDATE ' . $this->glt2name . ' SET CALC_AMT_02 = IFNULL(ROUND((BALANCE_AMT*(CALC_AMT_01/100)* case DIVIDER_FACTOR WHEN ' . singleQuote('360') . ' THEN (1/360) WHEN ' . singleQuote('365') . ' THEN (1/365) WHEN ' . singleQuote('30/360') . ' THEN (1/360) WHEN ' . singleQuote('30/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/360') . ' THEN (1/360) WHEN ' . singleQuote('AC/365') . ' THEN (1/365) WHEN ' . singleQuote('AC/AC') . ' THEN (1/365) ELSE (1/360) END), 2), 0) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = CALC_AMT_02, DEBIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = -1*CALC_AMT_02, CREDIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = CALC_AMT_02, CREDIT_TRANS_AMT = CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = -1*CALC_AMT_02, DEBIT_TRANS_AMT = -1*CALC_AMT_02 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_02<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CREDIT_AMT = 0 AND DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        ClxCommon::$db->executeQuery($sql);
        //Delete all participants where rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt2name . ' WHERE CALC_AMT_02 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Retor
        if (ClxCommon::$db->oneExistsRecords($this->glt2name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            if (kDefaultIsCron === CLX_NUM_ZERO || $this->display === true) {
                echoLog('Investment Amortization Interest: Nothing to do returning');
            }
            return;
        }
        //setting entry loop for all days required
        $i = CLX_INIT_ZERO;
        $transacction_date = $src_operation['EFFTDATE'];

        while ($transacction_date < $operation_date) {
            $this->build_backvalue_operation($src_operation, $comp, $jehd, $comprec, $je_source, $transacction_date, $operation_date);
            $i++;
            $transacction_date = adodb_next_day($transacction_date);
            if ($i > CLX_NUM_50)
                break; //just in case








//SEE INFA.AMORTIZATION
            $sql = 'UPDATE ' . $this->infaname . ' INFA, ' . $this->glt2name . ' X SET INFA.AMORTIZED_AMT = INFA.AMORTIZED_AMT+(- 1 *X.CALC_AMT_02), INFA.BOOK_VALUE_AMT = INFA.BOOK_VALUE_AMT+(- 1 *X.CALC_AMT_02), INFA.INVEST_AMT = INFA.INVEST_AMT+(- 1 *X.CALC_AMT_02), INFA.PREMIUM_DISC_AMT = INFA.PREMIUM_DISC_AMT+(- 1 *X.CALC_AMT_02) WHERE INFA.POSITION_NUMBER = X.BANK_ACCOUNT_NO AND X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Updating portfolio totals
            if (!class_exists('Infu'))
                includeCodeLib('INFU');
            $infu = new Infu ();
            $sql = 'SELECT DISTINCT INFU.IDCODE, INFU.COMP_CODE FROM ' . $this->fiasname . ' FIAS, ' . $this->glt2name . ' X, ' . $this->infuname . ' INFU WHERE FIAS.IDCODE = X.CHART_FIELD03 AND FIAS.PORTFOLIO_CODE = INFU.IDCODE';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $infu->infu_update_portfolio_totals($r['COMP_CODE'], $r['IDCODE']);
            }
        }//loop on date
        return;
    }

    /**
     * Investment Account Operations
     * @param unknown_type $src_operation
     */
    private function build_back_value_inat_valorization(&$src_operation, &$comp, &$jehd, &$comprec) {
        /*
          //Como se ajusta el monto de inversiones es requirido valorizar la inversion involucrada a las diferentes fechas
          //Seleccionar inversion
          //Seleccionar valorizar a las diferentes fechas en las que se encuentren tasa de precio
          //INVA valorizacion,
          if ($src_operation['INAT_CODE'] === '')
          return;
          if (!class_exists('Infa'))
          includeCodeLib('Infa');
          $infa = new Infa();
          //Select items where market value exists
          $sql = 'SELECT DISTINCT JEHD.COMP_CODE, INAT.PORTFOLIO_CODE, STOC.CLX_EFFTDATE OPERATION_DATE, INAT.POSITION_NUMBER '
          . 'FROM ' . $this->jehdname . ' JEHD, ' . $this->inatname . ' INAT, ' . $this->stocname . ' STOC '
          . 'WHERE INAT.INVEST_ACTIVITY<>' . singleQuote('VE') . ' AND INAT.IDCODE = JEHD.INAT_CODE AND JEHD.IDCODE = ' . singleQuote($src_operation['IDCODE']) . ' AND STOC.INVESTPROD_CODE = INAT.INVESTMENT_CODE AND STOC.CLX_EFFTDATE BETWEEN JEHD.EFFTDATE AND JEHD.REAL_DATE ORDER BY INAT.POSITION_NUMBER ASC, STOC.CLX_EFFTDATE ASC';
          $rs = ClxCommon::$db->executeQuery($sql);
          while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
          $infa->infa_valorization_backvalue($r['COMP_CODE'], $r['PORTFOLIO_CODE'], $r['POSITION_NUMBER'], $r['OPERATION_DATE']);
          }
		  ClxCommon::$db->freeResult($rs);
		  
		  */
        return;
    }

    /**
     * Builds journal entry
     * @param unknown_type $src_operation
     * @param unknown_type $comp
     * @param unknown_type $jehd
     * @param unknown_type $comprec
     * @param unknown_type $je_source
     * @param unknown_type $transacction_date
     * @param unknown_type $operation_date
     */
    public function build_backvalue_operation(&$src_operation, &$comp, &$jehd, &$comprec, $je_source, $transacction_date, $operation_date) {
        //Exchange
        $sql = 'SELECT DISTINCT CURRENCY_CODE FROM ' . $this->glt2name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($src_operation['COMP_CODE'], $r['CURRENCY_CODE'], $transacction_date);
            $sql = 'UPDATE ' . $this->glt2name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while
		ClxCommon::$db->freeResult($rs);
        //Perform conversions
        $sql = 'UPDATE ' . $this->glt2name . ' SET DEBIT_AMT = ROUND(DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT<>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt2name . ' SET CREDIT_AMT = ROUND(CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CREDIT_AMT<>0';
        ClxCommon::$db->executeQuery($sql);
        //En credito hay que sacar el primer dia!!! se entonces agrego la fecha de inico en next day para evaluar
        //normalmente nulo en todas las condiciones menus credito
        $sql = 'SELECT COUNT(X.GL01_CODE) FROM ' . $this->glt2name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND (NEXT_DATE IS NULL OR NEXT_DATE<' . singleQuote($transacction_date) . ')';
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO)
            return;
        //Build Operation
        $DBLT = &getTool('DBLT');
        $gl_rec = $jehd->jehd_init_record();
        $gl_rec['IDNAME'] = substr('BV ' . $DBLT->getListItem('SOTY', $je_source), CLX_NUM_ZERO, CLX_NUM_60);
        $gl_rec['JE_SOURCE'] = $je_source;
        $gl_rec['LGGROUP_CODE'] = $comprec['LGGROUP_CODE'];
        $gl_rec['EFFTDATE'] = $transacction_date;
        $gl_rec['REAL_DATE'] = $operation_date;
        $gl_rec['COMP_CODE'] = $src_operation['COMP_CODE'];
        $gl_rec['TRANS_CODE'] = null;
        $gl_rec['REQ_CHANNEL'] = 'SYS';
        if (!empty($src_operation['ADJUSTMENT'])) {
            $gl_rec['ADJUSTMENT'] = 1;
        } else {
            $gl_rec['ADJUSTMENT'] = 0;
        }


        $gl_rec['BATCH_ID'] = $this->batch_id;
        $jehd->jehd_build($gl_rec);
        //Dump to log
        if (kDefaultIsCron === CLX_NUM_ZERO && $this->display === true) {
            echoLog(dict('GEN_LBL_CREATED') . ' JEHD: ' . $gl_rec ['IDCODE']);
            echoLog(print_r($gl_rec['IDCODE'], true) . '<Br>');
        }
        //Search any scale if apply and dump lines to journal
        $crit = (!empty($src_operation['OPERATION_MODE'])) ? 'EFFTDATE = ' . singleQuote($transacction_date) . '' : '(NEXT_DATE IS NULL OR NEXT_DATE<' . singleQuote($transacction_date) . ')';
        $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, X.ITEM_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.BANK_ACCOUNT_NO ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt2name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND ' . $crit;
        ClxCommon::$db->executeQuery($sql);

        //contraparte
        $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL02_CODE GLACCOUNTCODE, X.ITEM02_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.BANK_ACCOUNT_NO ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, X.CREDIT_TRANS_AMT DEBIT_AMT, X.DEBIT_TRANS_AMT CREDIT_AMT, 2 SEQNUM FROM ' . $this->glt2name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND ' . $crit;
        ClxCommon::$db->executeQuery($sql);

        //Removing sub account from in,ex,eq
        $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ', ' . singleQuote('EX') . ', ' . singleQuote('EQ') . '))';
        ClxCommon::$db->executeQuery($sql);

        //Verificando conversion;
        $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
        //Approve entry
        $jehd->back_value_enabled = false;
        $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        $jehd->back_value_enabled = true;
    }

    /**
     * Updates currency for items
     * @param type $comp_code
     */
    public function updateFiasCurrency($comp_code, $fias_idcode = '') {
        $cc = ($fias_idcode <> '') ? ' AND FIAS.IDCODE = ' . singleQuote($fias_idcode) : '';
        $sql = 'UPDATE FIDU_ITEMS FIAS, FIDU_BANK_ACCOUNTS FIBK SET FIAS.CURRENCY_CODE = FIBK.CURRENCY_CODE WHERE FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND FIBK.COMP_CODE = ' . singleQuote($comp_code) . ' ' . $cc;
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE FIDU_ITEMS FIAS, CRED_CREDITS FILO SET FIAS.CURRENCY_CODE = FILO.CURRENCY_CODE WHERE FILO.IDCODE = FIAS.LOAN_CODE AND FILO.COMP_CODE = ' . singleQuote($comp_code);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE FIDU_ITEMS FIAS, AMGT_ASSETS FIAE SET FIAS.CURRENCY_CODE = FIAE.CURRENCY_CODE WHERE FIAE.IDCODE = FIAS.ASSET_CODE AND FIAE.COMP_CODE = ' . singleQuote($comp_code) . ' ' . $cc;
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE FIDU_ITEMS FIAS, GUAR_GUARANTEES GUAR SET FIAS.CURRENCY_CODE = GUAR.CURRENCY_CODE WHERE GUAR.IDCODE = FIAS.GUAR_CODE AND GUAR.COMP_CODE = ' . singleQuote($comp_code) . ' ' . $cc;
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE FIDU_ITEMS FIAS, INVE_PORTFOLIOS INFU SET FIAS.CURRENCY_CODE = INFU.CURRENCY_CODE WHERE INFU.IDCODE = FIAS.PORTFOLIO_CODE AND INFU.COMP_CODE = ' . singleQuote($comp_code) . ' ' . $cc;
        ClxCommon::$db->executeQuery($sql);
    }
    
    function fias_infu_form_init(&$record) {
        $record['FIAS_GL_TYPE'] = 'AS';
        $record['FIAS_TRUST_ITEM_TYPE'] = 'IN';
    }

}
