/**
 * Performs exchange rate calculation
 */
function fiatCalculateBaseTransAmt() {

    var xrt = parseFloat($('#FIAT_EXCHANGE_RT').val());
    var oper = parseFloat($('#FIAT_CUR_OPERATOR').val());
    $('#FIAT_TRANS_AMT').val($('#FIAT_TRANS_AMT').val().replace(/,/g, ''));
    var bal = parseFloat($('#FIAT_TRANS_AMT').val());
    var base = 0;
    if (oper == 1) {
        base = Math.round(bal * xrt * 100) / 100;
    } else {
        base = Math.round((bal * 100 / xrt)) / 100;
    }
    $('#FIAT_BASE_TRANS_AMT').val(numDec(base, 2));

}

/*
 * Sets currency exchange for fiat see also JELN_JS
 */
function fiatCurrChangeRate() {
    var comp_code = $('input[name="FIAT_COMP_CODE"]').val();
    if (comp_code == undefined) {
        comp_code = $('#FIAT_COMP_CODE').val();
    }
    var currency_code = $('#FIAT_CURRENCY_CODE').val();

    var url = 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=CURR_GL_JS&fn[]=COMP_CODE&fv[]=' + comp_code + '&fn[]=BASE_CURRENCY&fv[]=' + currency_code;
    $.ajax({
        type: 'GET',
        url: url,
        async: false,
        dataType: 'xml',
        success: function (xml) {
            $(xml).find('CURR_GL_JS').each(function () {
                var self = this;
                var exchange_rt = $(self).find('CURR_EXCHANGE_RT').text();
                var cur_operator = $(self).find('CURR_CUR_OPERATOR').text();
                $('#FIAT_EXCHANGE_RT').val(exchange_rt);
                $('#FIAT_CUR_OPERATOR').val(cur_operator);
                fiatCalculateBaseTransAmt();
            });
        }
    });

}// End function

/**
 * Sets event
 */
function fiatSetEvents() {

    $('#FIAT_CURRENCY_CODE').change(fiatCurrChangeRate);
    $('#FIAT_CUR_OPERATOR').change(fiatCalculateBaseTransAmt);
    $('#FIAT_EXCHANGE_RT').change(fiatCalculateBaseTransAmt);
    $('#FIAT_TRANS_AMT').change(fiatCalculateBaseTransAmt);
}

function fiatSetCredEvents() {

    $('#FIAT_TRANS_AMT').change(fiatCredDistTransAmt);
    $('#FIAT_TRANS_AMT').change(fiatCredChangePay);
    $('#FIAT_PRINCIPAL_PAY').change(fiatCredChangePay);
    $('#FIAT_INTEREST_PAY').change(fiatCredChangePay);
    $('#FIAT_PAY_APPLIES_TO').change(fiatCredChangePay);

    $('#FIAT_FEE_01_PAY').change(fiatCredChangePay);
    $('#FIAT_FEE_02_PAY').change(fiatCredChangePay);
    $('#FIAT_FEE_03_PAY').change(fiatCredChangePay);
    $('#FIAT_FEE_04_PAY').change(fiatCredChangePay);
    $('#FIAT_FEE_05_PAY').change(fiatCredChangePay);

    fiatSetEvents();
    fiatCredChangePay();

}
// $(document).ready(fiatSetEvents);
//$(document).ready(fiatSetCredEvents);


// ------------------------------------------------------------------------------
// C R E D I T S C R I P T S
// ------------------------------------------------------------------------------

function fiatCredChangePay() {

    //FIAT_CRED_DIS
    var type = 'PAY';
    var oper = $("input[name='fm']").val();
    if (oper == 'FIAT_CRED_DIS') {
        type = 'DIS';
    }

    for (var i = 1; i <= 5; i++) {

        var fee_formula = $("input[name='FIAT_FEE_FORMULA_0" + i + "']").val();
        var int_amt = parseFloat($("input[name='FIAT_FEE_0" + i + "_RATE']").val());

        if (type == 'DIS' && fee_formula == 'P0007') {

            int_amt = numDec(parseFloat($('#FIAT_PRINCIPAL_PAY').val()) * (int_amt / 100), 2);
            $('#FIAT_FEE_0' + i + '_PAY').val(int_amt);
        }

        if (type == 'PAY' && fee_formula == 'P0008') {
            int_amt = numDec(parseFloat($('#FIAT_PRINCIPAL_PAY').val()) * (int_amt / 100), 2);
            $('#FIAT_FEE_0' + i + '_PAY').val(int_amt);
        } else if (type == 'PAY' && fee_formula == 'P0006') {
            int_amt = numDec(parseFloat($('#FIAT_TRANS_AMT').val()) * (int_amt / 100), 2);
            $('#FIAT_FEE_0' + i + '_PAY').val(int_amt);

        } else if (type == 'PAY' && fee_formula == 'P0009') {

            int_amt = numDec(parseFloat($('#FIAT_INTEREST_PAY').val()) * (int_amt / 100), 2);
            $('#FIAT_FEE_0' + i + '_PAY').val(int_amt);

        } else {

        }

    }

    fiatCredUpdateTransAmt();
    fiatCalculateBaseTransAmt();
    fiatCredFormatNumbers();

}

/**
 * Loads payment distribution according loan
 */
function fiatCredDistTransAmt() {

    // var cred_code = $('#FIAT_LOAN_CODE').val();
    /*
     * if(cred_code==''){ alert('Credit number required, please try again');
     * $('#FIAT_TRANS_AMT').val(0); fiatCredFormatNumbers(); return; }
     */
    var int_amt = 0;

    var pay_seq = $("input[name='FIAT_PAY_SEQUENCE']").val();
    if (pay_seq == undefined) {
        // Nothign to do
        // var trans_amt = parseFloat($('#FIAT_TRANS_AMT').val());
        //$('#FIAT_PRINCIPAL_PAY').val($('#FIAT_TRANS_AMT').val());
    } else {
        if (pay_seq.length > 0) {
            var fee_formula = '';
//	    var pay_app = parseInt($('#FIAT_PAY_APPLIES_TO').val());
            var trans_amt = parseFloat($('#FIAT_TRANS_AMT').val());
            var ttrans_amt = trans_amt;
            $('#FIAT_INTEREST_PAY').val(0);
            $('#FIAT_PRINCIPAL_PAY').val(0);
            $('#FIAT_FEE_01_PAY').val(0);
            $('#FIAT_FEE_02_PAY').val(0);
            $('#FIAT_FEE_03_PAY').val(0);
            $('#FIAT_FEE_04_PAY').val(0);
            $('#FIAT_FEE_05_PAY').val(0);
            var a = pay_seq.split(',');
            for (var i = 0; i < a.length; i++) {
		var si_trans=true;
                switch (a[i]) {
                    case 'PAY_SEQNO_FEE_01':
                    case 'PAY_SEQNO_FEE_02':
                    case 'PAY_SEQNO_FEE_03':
                    case 'PAY_SEQNO_FEE_04':
                    case 'PAY_SEQNO_FEE_05':
                        var TFEE = a[i].substring(a[i].length - 1, a[i].length);
                        fee_formula = $("input[name='FIAT_FEE_FORMULA_0" + TFEE + ']').val();
                        int_amt = parseFloat($("input[name='FIAT_FEE_0" + TFEE + "_RATE']").val());

                        if (fee_formula == 'P0007' || fee_formula == 'P0008' || fee_formula == 'P0009') {
                            //latter
                            si_trans=false;
                        }
                        else if (fee_formula == 'P0006' && parseInt($("input[name='FIAT_FEE_HAS_LATE_FEE']").val()) == 1) {// Solo si tiene moras
                            int_amt = numDec(ttrans_amt * (int_amt / 100), 2);
                            $('#FIAT_FEE_' + TFEE + '_PAY').val(int_amt);
                            trans_amt = trans_amt - int_amt;
                        } else if (fee_formula != 'P0006' && int_amt <= trans_amt) {
                            $('#FIAT_FEE_' + TFEE + '_PAY').val(int_amt);
                            trans_amt = trans_amt - int_amt;
                        } else if (fee_formula != 'P0006') {
                            $('#FIAT_FEE_' + TFEE + '_PAY').val(trans_amt);
                            trans_amt = 0;
                        }
                        else {
                        }
                        break;
                    case 'PAY_SEQNO_AR':
                        int_amt = parseFloat($("input[name='FIAT_INTEREST_PRE']").val());
                        if (int_amt <= trans_amt) {
                            $('#FIAT_INTEREST_PAY').val(int_amt);
                            trans_amt = trans_amt - int_amt;
                        } else {
                            $('#FIAT_INTEREST_PAY').val(trans_amt);
                            trans_amt = 0;
                        }
                        break;
                    case 'PAY_SEQNO_FEE':
                    case 'PAY_SEQNO_LATEF':
                        break;
                    case 'PAY_SEQNO_PRO':
                        int_amt = parseFloat($("input[name='FIAT_PRINCIPAL_PRE']").val());
                        if (int_amt <= trans_amt && int_amt != 0) {
                            $('#FIAT_PRINCIPAL_PAY').val(int_amt);
                            trans_amt = trans_amt - int_amt;
                        } else {
                            $('#FIAT_PRINCIPAL_PAY').val(trans_amt);
                            trans_amt = 0;
                        }
                        break;
                    default:
                        break;
                }
		if (si_trans && numDec(trans_amt, 2) == 0) {
		    break;
		}
            }

        } else {
            // var trans_amt = parseFloat($("#FIAT_TRANS_AMT").val());
            $('#FIAT_PRINCIPAL_PAY').val($('#FIAT_TRANS_AMT').val());
        }
    }

    //fiatCredChangePay();
    fiatCalculateBaseTransAmt(); //sent to fiat change pay
    fiatCredFormatNumbers();

}// end function


/**
 * Localiza el monto de interes para reserva
 */
function FiloFindFeesTax() {

    var comp_code = $('#FILO_COMP_CODE').val();
    var prod_code = $('#FILO_PRODUCT_CODE_prim').val();
    // GLPV
    var $url = 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=GLPV&fn[]=GLPF.PRODUCT_CODE&fv[]=';
    $url += prod_code + '&fn[]=GLPF.COMP_CODE&fv[]=' + comp_code;
    $.ajax({
        type: 'GET',
        url: $url,
        dataType: 'xml',
        success: function (xml) {
//	    var self = this;
            $(xml).find('GLPV').each(
                    /*		    function () {
                     var seqnum = FiloFeesFormulaLbl($(self).find(
                     'GLPV_SEQNUM').text());
                     } */ );
        }
    });
}// end function

function fiatCredUpdateTransAmt() {
    var tax_amt = 0;
    var cred_amt = parseFloat($('#FIAT_PRINCIPAL_PAY').val());
    var inte_amt = parseFloat($('#FIAT_INTEREST_PAY').val());
    var oper = $('#FIAT_TRANSTBL_CODE').val();
    var sign1 = parseFloat($('input[name=FIAT_FEE_01_CHRG_CUS]').val());
    var sign2 = parseFloat($('input[name=FIAT_FEE_02_CHRG_CUS]').val());
    var sign3 = parseFloat($('input[name=FIAT_FEE_03_CHRG_CUS]').val());
    var sign4 = parseFloat($('input[name=FIAT_FEE_04_CHRG_CUS]').val());
    var sign5 = parseFloat($('input[name=FIAT_FEE_05_CHRG_CUS]').val());
    if (isNaN(cred_amt)) {
        cred_amt = 0;
    }
    if (isNaN(inte_amt)) {
        inte_amt = 0;
    }
    if (isNaN(sign1)) {
        sign1 = 0;
    }
    if (isNaN(sign2)) {
        sign2 = 0;
    }
    if (isNaN(sign3)) {
        sign3 = 0;
    }
    if (isNaN(sign4)) {
        sign4 = 0;
    }
    if (isNaN(sign5)) {
        sign5 = 0;
    }

    var sign = 1;
    if (oper == 'SYS_CRED-DISB') {
        sign = -1;
    }

    var fee_amt = 0;

    fee_amt += sign1 * parseFloat($('#FIAT_FEE_01_PAY').val());
    fee_amt += sign2 * parseFloat($('#FIAT_FEE_02_PAY').val());
    fee_amt += sign3 * parseFloat($('#FIAT_FEE_03_PAY').val());
    fee_amt += sign4 * parseFloat($('#FIAT_FEE_04_PAY').val());
    fee_amt += sign5 * parseFloat($('#FIAT_FEE_05_PAY').val());


    for (var i = 1; i <= 5; i++) {
        var tax = parseFloat($('input[name=FIAT_TAX_0' + i + '_RATE]').val());
        if (isNaN(tax)) {
            $('#FIAT_TAX_0' + i + '_AMT').val(0);
        }
        else {
            tax_amt = numDec(parseFloat($('#FIAT_FEE_0' + i + '_PAY').val())
                    * (tax / 100), 2);
            $('#FIAT_TAX_0' + i + '_AMT').val(tax_amt);
        }
    }

    tax_amt = sign * parseFloat($('#FIAT_TAX_01_AMT').val());
    tax_amt += sign * parseFloat($('#FIAT_TAX_02_AMT').val());
    tax_amt += sign * parseFloat($('#FIAT_TAX_03_AMT').val());
    tax_amt += sign * parseFloat($('#FIAT_TAX_04_AMT').val());
    tax_amt += sign * parseFloat($('#FIAT_TAX_05_AMT').val());
    $('#FIAT_TRANS_AMT').val(numDec((cred_amt + inte_amt + fee_amt + tax_amt), 2));
    $('#FIAT_TAX_AMT').val(numDec(tax_amt, 2));

    fiatCalculateBaseTransAmt();
    fiatCredFormatNumbers();
}// end function

function fiatCredFormatNumbers() {
    $('#FIAT_PRINCIPAL_PAY').val(numDec($('#FIAT_PRINCIPAL_PAY').val(), 2));
    $('#FIAT_INTEREST_PAY').val(numDec($('#FIAT_INTEREST_PAY').val(), 2));
    $('#FIAT_TAX_AMT').val(numDec($('#FIAT_TAX_01_AMT').val(), 2));
    for (var t = 1; t < 6; t++) {
        $('#FIAT_FEE_0' + t + '_PAY').val(numDec($('#FIAT_FEE_0' + t + '_PAY').val(), 2));
        $('#FIAT_TAX_0' + t + '_AMT').val(numDec($('#FIAT_TAX_0' + t + '_AMT').val(), 2));
    }
    $('#FIAT_TRANS_AMT').val(numDec($('#FIAT_TRANS_AMT').val(), 2));
    $('#FIAT_BASE_TRANS_AMT').val(numDec($('#FIAT_BASE_TRANS_AMT').val(), 2));
}// end function

/**
 * Modify current product status
 */
function fiatChangeProdStatus() {
    var inte = 0;
    var pay = 0;
    var ppal = 0;
    switch ($('#FIAT_PAY_APPLIES_TO').val()) {
        case '0':
            // $('#FIAT_PRINCIPAL_PAY').val($('#FIAT_PRINCIPAL_CUR').val());
            // $('#FIAT_INTEREST_PAY').val($('#FIAT_INTEREST_CUR').val());
            // $('#FIAT_TRANS_AMT').val($('#FIAT_INSTALLMENT_CUR').val());
            break;
        case '1':
            $('#FIAT_PRINCIPAL_PAY').val($('#FIAT_PRINCIPAL_PRE').val());
            $('#FIAT_INTEREST_PAY').val($('#FIAT_INTEREST_PRE').val());
            $('#FIAT_TRANS_AMT').val($('#FIAT_INSTALLMENT_PRE').val());
            break;
        case '2':
            ppal = parseFloat($('#FIAT_PRINCIPAL_BAL').val());
            inte = parseFloat($('#FIAT_INTEREST_AMT').val());
            pay = ppal + inte;
            $('#FIAT_PRINCIPAL_PAY').val(ppal);
            $('#FIAT_INTEREST_PAY').val(inte);
            $('#FIAT_TRANS_AMT').val(pay);
            break;
        default:
            ppal = parseFloat($('#FIAT_PRINCIPAL_BAL').val());
            inte = parseFloat($('#FIAT_INTEREST_AMT').val());
            if (isNaN(ppal)) {
                ppal = 0;
            }
            if (isNaN(inte)) {
                inte = 0;
            }
            pay = ppal + inte;
            $('#FIAT_PRINCIPAL_PAY').val(ppal);
            $('#FIAT_INTEREST_PAY').val(inte);
            $('#FIAT_TRANS_AMT').val(pay);
            break;
    }

    fiatCredUpdateTransAmt();
    fiatCalculateBaseTransAmt();
    fiatCredFormatNumbers();
}

/**
 *
 */
function fiatCredAdjustmentSetTrans(payment) {
    var adj = $('#FIAT_ADJUSTMENT').val();
    if (adj == 1) {
        $('#FIAT_TRANSTBL_CODE').val('SYS_CRED-ADJ');
    } else {
        if (payment > 0) {
            $('#FIAT_TRANSTBL_CODE').val('SYS_CRED-PYMT');
        } else {
            $('#FIAT_TRANSTBL_CODE').val('SYS_CRED-DISB');
        }
    }
}

function fiatCopyReserveAmt() {
    var reserve = parseFloat($('input[name=FIAT_RESERVE_AMT]').val());
    if (isNaN(reserve)) {
        $('#FIAT_RESERVE_PAY').val('0.00');
    } else {
        $('#FIAT_RESERVE_PAY').val(reserve);
        $('#FIAT_RESERVE_PAY').val(numDec($('#FIAT_RESERVE_PAY').val(), 2));
    }
}