<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2015-10-07 11:58:37 -0400 (Wed, 07 Oct 2015) $
 * @version		$Rev: 7154 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Glcr {

    var $display = false;

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('GLAC', 'GLCP', 'COMP', 'FICO', 'GLCR', 'GDVW', 'JTMP', 'JCBV', 'GLCR', 'JEHD', 'JELN', 'GDVW', 'FIAS', 'JCBV'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice firt form
     * Executed on init event
     */
    function init_form(&$record) {

    }

// end function
    /**
     * Initialice firt form
     * Executed on init event
     */
    function load_form(&$record) {

    }

// end function
    /**
     * Validate record information
     * Executed on table validate
     */
    function validate_form(&$record, &$msg) {

    }

// end function
    /**
     * Update Parent (FETR) Information one record is saved
     *
     * @param array $record
     */
    function save_form(&$record) {
        // Update modified by and modification date on FIAC
    }

    // PROCESO DE FACTOR DE CORRECCION MONETARIA
    /**
     * Proceso de correccion monetaria.
     * @param type $comp_code
     * @param type $queue
     */
    function monetary_indexation_by_comp($comp_code, $queue = false) {
        $this->display = true;
        $this->monetary_indexation($comp_code, $queue);
    }

    /**
     * Factor de correcion monetaria. Proceso puntual por listado
     *
     * @global type $idlist
     */
    function monetary_indexation_btn() {
        $idlist = getIdlist();
        $sql = 'SELECT IDCODE FROM ' . $this->compname . ' WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->monetary_indexation($r['IDCODE'], true);
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Monetary Indexation / Factor de conversion monetaria
     *
     * @param type $comp_code
     * @param type $queue
     * @return type
     */
    private function monetary_indexation($comp_code, $queue = false) {
        $contenidoHTML = '';
        /*
          Monto Variacion = ((SALDO/ANTERIOR)-(SALDO/ACTUAL))*ACTUAL
          Donde el saldo de la cuenta de activos es Debito-Credito En auxiliar SALDO = SALDO+((SALDO/ANTERIOR)-(SALDO/ACTUAL))*ACTUAL
          Para activos (Debito-Credito)>0:
          Si Monto Variacion > 0
          Debito Capital Credito Ingreso  Si Monto Variacion < 0
          Debito Gastos Credito Capital   Para Pasivos (Debito-Credito)<0:
          Si Monto Variacion > 0
          Debito Gastos Credito Cuenta Original  Si Monto Variacion < 0
          Debito Ingresos Credito Cuenta Original  notar que si es pasivo el saldo es negativo por naturaleza de la cuenta En realidad el signo lo define la cuenta contable directamente por lo que se resume a lo anterior lo define dtpr de un auxiliar que puede es siempre positivo Si Monto Variacion > 0
          Debito Cta Original Credito Ingreso  Si Monto Variacion < 0
          Debito Cuenta Original Credito Capital  Notas: Se coloca CHART_FIELD03 para el campo de ITEM_REF_NO sin embargo
          ver de llevar un auxiliar para mantener el monto de valor del activo
          ya que si no es imposible saber cuanto se valoriza. Las cuentas de ingreso, gasto y patrimonio no tienen chart_Field03 por eso se sumarizan en las lineas. Al momento del pago. */
        if (empty($comp_code))
            return;
        $je_source = 'CINDX';
        //test for process
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        if (!$comp->ruco_status($comp_code, $je_source)) {
            echoLog('Process: ' . $this->je_source . ' Inactive for company ' . $comp_code);
            return;
        }
        $comprec = $comp->comp_operation_parameters($comp_code);
        //Verificando moneda de referencia
        if (empty($comprec['CINDX_CURR_CODE'])) {
            return;
        }
        //Buscando cambio
        $xrate = $comp->comp_current_exchange($comp_code, $comprec['CINDX_CURR_CODE'], $comprec['OPERATION_DATE'], true);
        if (empty($xrate['EXCHANGE_RT']) || $xrate['EXCHANGE_RT'] <= CLX_NUM_ZERO) {
            return;
        }
        //Test last rate and update new
        if (empty($comprec['CINDX_LST_XRATE']) || $comprec['CINDX_LST_XRATE'] == CLX_NUM_ZERO) {
            //Never valorized just return
            $comprec['CINDX_LST_XRATE'] = $xrate['EXCHANGE_RT'];
            ClxCommon::$db->executeQuery('UPDATE ' . $this->glcpname . ' SET CINDX_LST_XRATE=' . $xrate['EXCHANGE_RT'] . ' WHERE COMP_CODE = ' . singleQuote($comp_code));
        }
        if ($comprec['CINDX_LST_XRATE'] == $xrate['EXCHANGE_RT']) {
            //no change on rate
            return;
        }
        //Para poder identificar moneda nacional se utiliza el campo fias currency_code
        //Actualizando para estar seguro de que la moneda esta presente
        if (!class_exists('Fias'))
            includeCodeLib('FIAS');
        $fias = new Fias();
        $fias->updateFiasCurrency($comp_code);
        //Setting new calculated ate
        ClxCommon::$db->executeQuery('UPDATE ' . $this->glcpname . ' SET CINDX_PREV_XRATE = CINDX_LST_XRATE, CINDX_LST_XRATE=' . $xrate['EXCHANGE_RT'] . ' WHERE COMP_CODE = ' . singleQuote($comp_code));
        //Diferencial de cambio. Nota el cambio debe ser division ya que esta ajustando a la moneda base.
        $delta_rate = bcsub($xrate['EXCHANGE_RT'], $comprec['CINDX_LST_XRATE'], CLX_NUM_SIX);
        if ($this->display === true) {
            $contenidoHTML.= '<ul>Comp Code: ' . $comp_code . ', Ref curr:' . $comprec['CINDX_CURR_CODE'] . '<br> Current Exchange Rt:' . $xrate['EXCHANGE_RT'] . '<br> Last Exchange:' . $comprec['CINDX_LST_XRATE'] . '<br> Delta:' . $delta_rate . '</ul>';
            echo $contenidoHTML;
            $contenidoHTML = '';
        }
        //Build temporary table
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('JTMP');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->jtmpname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //Load currency exchange excluding portfolios
        $sql = 'INSERT INTO ' . $this->jtmpname . ' (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, CURRENCY_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, GL_TYPE, EXCHANGE_RT, CUR_OPERATOR, BALANCE_AMT, BASE_BAL_AMT) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, JCBV.COMP_CODE, GLCP.OPERATION_DATE EFFTDATE, JCBV.GLACCOUNTCODE, JCBV.CURRENCY_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, FIAS.EXT_PRODUCT_CODE ITEM_REF_NO, JCBV.GL_TYPE, $delta_rate EXCHANGE_RT, 1 CUR_OPERATOR, ROUND( (((SUM(JCBV.BALANCE_AMT)/' . $comprec['CINDX_LST_XRATE'] . ')-(SUM(JCBV.BALANCE_AMT)/' . $xrate['EXCHANGE_RT'] . '))*' . $xrate['EXCHANGE_RT'] . ') , 2) BALANCE_AMT, SUM(JCBV.BALANCE_AMT) BASE_BAL_AMT FROM ' . $this->glcpname . ' GLCP, ' . $this->compname . ' COMP, ' . $this->glacname . ' GLAC, $this->glcrname GLCR, $this->jcbvname JCBV LEFT JOIN ' . $this->fiasname . ' FIAS ON FIAS.IDCODE = JCBV.CHART_FIELD03 WHERE GLCP.COMP_CODE = JCBV.COMP_CODE AND COMP.IDCODE = JCBV.COMP_CODE AND JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' AND JCBV.CURRENCY_CODE = COMP.CURRENCY_CODE AND GLAC.IDCODE = JCBV.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCR.GLACCOUNTCODE = GLAC.IDCODE AND GLCR.GLGROUP_CODE = GLAC.GLGROUP_CODE AND GLAC.GLCR_TYPE = ' . singleQuote('NI_MV') . ' AND FIAS.CURRENCY_CODE = COMP.CURRENCY_CODE AND (FIAS.PORTFOLIO_CODE IS NULL OR FIAS.PORTFOLIO_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') GROUP BY JCBV.COMP_CODE, GLCP.OPERATION_DATE, JCBV.GLACCOUNTCODE, JCBV.CURRENCY_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, FIAS.EXT_PRODUCT_CODE, JCBV.GL_TYPE HAVING BALANCE_AMT<>0';
        ClxCommon::$db->executeQuery($sql);
        //Portfolios separados para poder serparar valoracion por inversiones valor nominal
        $sql = 'INSERT INTO ' . $this->jtmpname . ' (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, CURRENCY_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, GL_TYPE, EXCHANGE_RT, CUR_OPERATOR, BALANCE_AMT, BASE_BAL_AMT) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, INFA.COMP_CODE, GLCP.OPERATION_DATE EFFTDATE, PRAT.PRO_GL_CODE GLACCOUNTCODE, COMP.CURRENCY_CODE, INFA.CONTRACT_CODE CHART_FIELD01, INFA.PARTICIPANT_ID CHART_FIELD02, FIAS.IDCODE CHART_FIELD03, null CHART_FIELD04, INFA.POSITION_NUMBER ITEM_REF_NO, GLAC.GL_TYPE, ' . $delta_rate . ' EXCHANGE_RT, 1 CUR_OPERATOR, (case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('OR') . ' THEN 1 ELSE -1 END) * IF(GLAC.PROVISION = 1, -1, 1) *ROUND((((SUM(INFA.INVEST_AMT)/' . $comprec['CINDX_LST_XRATE'] . ')-(SUM(INFA.INVEST_AMT)/' . $xrate['EXCHANGE_RT'] . '))*' . $xrate['EXCHANGE_RT'] . '), 2) BALANCE_AMT, SUM(INFA.INVEST_AMT) BASE_BAL_AMT FROM FIDU_ITEMS FIAS, INVE_PORTFOLIOS INFU, INVE_INVESTMENTS INFA, GL_PARAMETERS_TBL GLCP, BASE_COMPANIES COMP, GL_CODES_TBL GLAC, GL_CROSS_REF_TBL GLCR, GL_PROD_PRMTR_TBL PRAT WHERE COMP.IDCODE = ' . singleQuote($comp_code) . ' AND GLCP.COMP_CODE = COMP.IDCODE AND INFA.COMP_CODE = COMP.IDCODE AND INFA.PORTFOLIO_CODE = INFU.IDCODE AND FIAS.PORTFOLIO_CODE = INFU.IDCODE AND FIAS.CONTRACT_CODE = INFA.CONTRACT_CODE AND PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = PRAT.PRO_GL_CODE AND GLCR.GLACCOUNTCODE = GLAC.IDCODE AND GLCR.GLGROUP_CODE = GLAC.GLGROUP_CODE AND INFU.CURRENCY_CODE = COMP.CURRENCY_CODE AND GLAC.GLCR_TYPE = ' . singleQuote('NI_MV') . ' GROUP BY INFA.COMP_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, COMP.CURRENCY_CODE, INFA.CONTRACT_CODE, INFA.PARTICIPANT_ID, FIAS.IDCODE, INFA.POSITION_NUMBER, GLAC.GL_TYPE, GLAC.PROVISION HAVING BALANCE_AMT<>0';
        ClxCommon::$db->executeQuery($sql);
        /* Cuenta de interses de inversiones */
        $sql = 'INSERT INTO ' . $this->jtmpname . ' (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, CURRENCY_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, GL_TYPE, EXCHANGE_RT, CUR_OPERATOR, BALANCE_AMT, BASE_BAL_AMT) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, INFA.COMP_CODE, GLCP.OPERATION_DATE EFFTDATE, PRAT.AR_GL_CODE GLACCOUNTCODE, COMP.CURRENCY_CODE, INFA.CONTRACT_CODE CHART_FIELD01, INFA.PARTICIPANT_ID CHART_FIELD02, FIAS.IDCODE CHART_FIELD03, null CHART_FIELD04, INFA.POSITION_NUMBER ITEM_REF_NO, GLAC.GL_TYPE, $delta_rate EXCHANGE_RT, 1 CUR_OPERATOR, (case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('OR') . ' THEN 1 ELSE -1 END) * IF(GLAC.PROVISION = 1, -1, 1) *ROUND((((SUM((INFA.ACCRUED_INT_AMT-INFA.PAID_INT_AMT))/' . $comprec['CINDX_LST_XRATE'] . ')-(SUM((INFA.ACCRUED_INT_AMT-INFA.PAID_INT_AMT))/' . $xrate['EXCHANGE_RT'] . '))*' . $xrate['EXCHANGE_RT'] . '), 2) BALANCE_AMT, SUM((INFA.ACCRUED_INT_AMT-INFA.PAID_INT_AMT)) BASE_BAL_AMT FROM FIDU_ITEMS FIAS, INVE_PORTFOLIOS INFU, INVE_INVESTMENTS INFA, GL_PARAMETERS_TBL GLCP, BASE_COMPANIES COMP, GL_CODES_TBL GLAC, GL_CROSS_REF_TBL GLCR, GL_PROD_PRMTR_TBL PRAT WHERE COMP.IDCODE = ' . singleQuote($comp_code) . ' AND GLCP.COMP_CODE = COMP.IDCODE AND INFA.COMP_CODE = COMP.IDCODE AND INFA.PORTFOLIO_CODE = INFU.IDCODE AND FIAS.PORTFOLIO_CODE = INFU.IDCODE AND FIAS.CONTRACT_CODE = INFA.CONTRACT_CODE AND PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = PRAT.AR_GL_CODE AND GLCR.GLACCOUNTCODE = GLAC.IDCODE AND GLCR.GLGROUP_CODE = GLAC.GLGROUP_CODE AND INFU.CURRENCY_CODE = COMP.CURRENCY_CODE AND GLAC.GLCR_TYPE = ' . singleQuote('NI_MV') . ' GROUP BY INFA.COMP_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, COMP.CURRENCY_CODE, INFA.CONTRACT_CODE, INFA.PARTICIPANT_ID, FIAS.IDCODE, INFA.POSITION_NUMBER, GLAC.GL_TYPE, GLAC.PROVISION HAVING BALANCE_AMT<>0';
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->oneExistsRecords($this->jtmpname, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Creating accounting
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $jehd = new Jehd ();
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $je_source, CLX_NUM_TWO);
        // Build JEHD
        $sql = 'SELECT DISTINCT ' . singleQuote($idname) . ' IDNAME, JTMP.COMP_CODE, JTMP.EFFTDATE, ' . singleQuote($je_source) . ' JE_SOURCE, 0 CLOSING_ENTRY, 0 REVERSED, JTMP.BATCH_ID, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE FROM ' . $this->jtmpname . ' JTMP WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            // Generar encabezado para portafolio
            $jehd->jehd_build($r);
            $jehdr_code = $r ['IDCODE'];
            // Generando lineas por el debe
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 1 SEQNUM, JTMP.GLACCOUNTCODE, JTMP.CHART_FIELD01, JTMP.CHART_FIELD02, JTMP.CHART_FIELD03, JTMP.CHART_FIELD04, GLCR.ITEM_CODE, JTMP.ITEM_REF_NO, JTMP.CURRENCY_CODE, 1 EXCHANGE_RT, 1 CUR_OPERATOR, JTMP.BALANCE_AMT DEBIT_AMT, 0 CREDIT_AMT, JTMP.BALANCE_AMT DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 RECONCILIED FROM ' . $this->jtmpname . ' JTMP, $this->glcrname GLCR WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLCR.GLACCOUNTCODE = JTMP.GLACCOUNTCODE AND GLCR.GLGROUP_CODE =' . singleQuote($comprec['GLGROUP_CODE']) . ' AND JTMP.BALANCE_AMT > 0 ORDER BY JTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            // Contrapartida ingresos
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 2 SEQNUM, GLCR.INC_GL_CODE GLACCOUNTCODE, JTMP.CHART_FIELD01, JTMP.CHART_FIELD02, JTMP.CHART_FIELD03, JTMP.CHART_FIELD04, GLCR.ITEM_CODE, JTMP.ITEM_REF_NO, JTMP.CURRENCY_CODE, 1 EXCHANGE_RT, 1 CUR_OPERATOR, 0 DEBIT_AMT, JTMP.BALANCE_AMT CREDIT_AMT, 0 DEBIT_TRANS_AMT, JTMP.BALANCE_AMT CREDIT_TRANS_AMT, 0 RECONCILIED FROM ' . $this->jtmpname . ' JTMP, $this->glcrname GLCR WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLCR.GLACCOUNTCODE = JTMP.GLACCOUNTCODE AND GLCR.GLGROUP_CODE =' . singleQuote($comprec['GLGROUP_CODE']) . ' AND JTMP.BALANCE_AMT > 0 ORDER BY JTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            // Generando lineas por el debe
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 3 SEQNUM, GLCR.EXP_GL_CODE GLACCOUNTCODE, JTMP.CHART_FIELD01, JTMP.CHART_FIELD02, JTMP.CHART_FIELD03, JTMP.CHART_FIELD04, GLCR.ITEM_CODE, JTMP.ITEM_REF_NO, JTMP.CURRENCY_CODE, 1 EXCHANGE_RT, 1 CUR_OPERATOR, -1*JTMP.BALANCE_AMT DEBIT_AMT, 0 CREDIT_AMT, -1*JTMP.BALANCE_AMT DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 0 RECONCILIED FROM ' . $this->jtmpname . ' JTMP, $this->glcrname GLCR WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLCR.GLACCOUNTCODE = JTMP.GLACCOUNTCODE AND GLCR.GLGROUP_CODE =' . singleQuote($comprec['GLGROUP_CODE']) . ' AND JTMP.BALANCE_AMT < 0 ORDER BY JTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            // Contrapartida ingresos
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 4 SEQNUM, JTMP.GLACCOUNTCODE, JTMP.CHART_FIELD01, JTMP.CHART_FIELD02, JTMP.CHART_FIELD03, JTMP.CHART_FIELD04, GLCR.ITEM_CODE, JTMP.ITEM_REF_NO, JTMP.CURRENCY_CODE, 1 EXCHANGE_RT, 1 CUR_OPERATOR, 0 DEBIT_AMT, -1*JTMP.BALANCE_AMT CREDIT_AMT, 0 DEBIT_TRANS_AMT, -1*JTMP.BALANCE_AMT CREDIT_TRANS_AMT, 0 RECONCILIED FROM ' . $this->jtmpname . ' JTMP, $this->glcrname GLCR WHERE JTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLCR.GLACCOUNTCODE = JTMP.GLACCOUNTCODE AND GLCR.GLGROUP_CODE =' . singleQuote($comprec['GLGROUP_CODE']) . ' AND JTMP.BALANCE_AMT < 0 ORDER BY JTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND NOT EXISTS (SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuoteArray(array('AS', 'LI')) . ')';
            ClxCommon::$db->executeQuery($sql);
            // Cambiar estatus de asientos generados por el proceso
            if ($queue === true) {
                $jehd->jehd_approve_queue_by_code($jehdr_code);
            } else {
                $jehd->jehd_approve_by_code($jehdr_code);
            }
            if ($this->display === true) {
                echoLog('Approving jehd: ' . $jehdr_code . '-' . $je_source);
            }
        } // end while
		ClxCommon::$db->freeResult($rs);
        //cleanup
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->jtmpname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
    }

    /**
     * Proceso para ajuste de auxiliares al aprobar la operacion.
     * @param type $jehdr_code
     */
    function monetary_indexation_approval($jehdr_code) {
        /* Notas de otros elementos a modificar
          Cuentas por cobrar y cuentas por pagar 1 Ajustar monto de factura 2 Agregar linea de ingreso (si sube) 3 Agregar linea de gasto (si baja) 4 Amortizacion de facturas.  Creditos 1 Ajustar cronogramas  Activos 1 Ajustar depreciaciones   Inversiones 1 Ajustar auxiliares de renta fija y renta variable
          por cada cuenta tipo activo o pasivo */
        $sql = 'SELECT JEHD.COMP_CODE, JEHD.EFFTDATE, JEHD.IDCODE, GLCP.CINDX_PREV_XRATE PREV_RATE, GLCP.CINDX_LST_XRATE CURRENT_RATE FROM ' . $this->jehdname . ' JEHD, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = JEHD.COMP_CODE AND JEHD.IDCODE = ' . singleQuote($jehdr_code) . ' AND JEHD.JE_SOURCE = ' . singleQuote('CINDX') . ' ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Credit
            $this->monetary_indexation_auxiliar_fils($r['IDCODE'], $r['COMP_CODE'], $r['EFFTDATE']);
            $this->monetary_indexation_auxiliar_infa($r['IDCODE'], $r['COMP_CODE'], $r['EFFTDATE']);
            $this->monetary_indexation_auxiliar_amds($r['IDCODE'], $r['COMP_CODE'], $r['EFFTDATE']);
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Actualizacion de auxiliares
     */
    private function monetary_indexation_auxiliar_fils($jehd_code, $comp_code, $efftdate) {
        /* FILS.PRINCIPAL_PAY = FILS.PRINCIPAL_PAY + X.BALANCE_AMT, no hace falta actualizar */
        /* Auxiliares de capital. Sumando monto en linea que toca capital y actualizando auxiliares. No seguro sobre monto de prestamo. */
        $sql = 'UPDATE CRED_CREDITS FILO, CRED_PAYMNT_SCHEDULES FILS, (SELECT FILOX.IDCODE, FILOX.CLX_EFFTDATE, (SELECT MAX(FILSX.ID) FROM CRED_PAYMNT_SCHEDULES FILSX WHERE FILSX.LOAN_CODE = FILOX.IDCODE AND FILSX.EFFTDATE = FILOX.CLX_EFFTDATE AND FILSX.PERIOD_START_DATE <=' . singleQuote($efftdate) . ') FILS_ID, SUM(IFNULL(((case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('OR') . ' THEN 1 ELSE -1 END) * IF(GLAC.PROVISION = 1, -1, 1) *(JELN.DEBIT_AMT-JELN.CREDIT_AMT)),0)) BALANCE_AMT FROM CRED_CREDITS FILOX, FIDU_ITEMS FIAS, GL_JOURNAL_LINES JELN, GL_CODES_TBL GLAC, GL_PARAMETERS_TBL GLCP WHERE FILOX.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAS.LOAN_CODE = FILOX.IDCODE AND FIAS.IDCODE = JELN.CHART_FIELD03 AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = FILOX.COMP_CODE AND EXISTS(SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = FILOX.PRODUCT_CODE AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE) AND FILOX.CLX_EFFTDATE = (SELECT MAX(FILOXX.CLX_EFFTDATE) FROM CRED_CREDITS FILOXX WHERE FILOXX.IDCODE = FILOX.IDCODE AND FILOXX.CLX_EFFTDATE = FILOX.CLX_EFFTDATE) AND JELN.JEHDR_CODE = ' . singleQuote($jehd_code) . ' GROUP BY FILOX.IDCODE, FILOX.CLX_EFFTDATE, FILS_ID) X SET FILO.LOAN_AMT = FILO.LOAN_AMT + X.BALANCE_AMT, FILS.LOAN_AMT = FILS.LOAN_AMT + X.BALANCE_AMT, FILS.PRINCIPAL_PAY = FILS.PRINCIPAL_PAY + X.BALANCE_AMT, /*FILS.PRINCIPAL_BAL = FILS.PRINCIPAL_BAL + X.BALANCE_AMT,*/ FILS.PRINCIPAL_BAL = FILS.LOAN_AMT - (FILS.PRINCIPAL_PAY+FILS.BALLOON_PAY_AMT), FILS.PAYMENT_AMT =  FILS.PAYMENT_AMT + X.BALANCE_AMT, FILS.DAILY_INTEREST = ROUND((FILS.LOAN_AMT+ X.BALANCE_AMT)*(FILS.LOAN_INTEREST/100)/(case FILO.INTEREST_CALC WHEN ' . singleQuote('AC/360') . ' THEN 360 WHEN ' . singleQuote('AC/365') . ' THEN 365 WHEN ' . singleQuote('AC/AC') . ' THEN 365 ELSE FILO.INTEREST_CALC END), 5) WHERE FILS.ID = X.FILS_ID AND FILS.LOAN_CODE = X.IDCODE AND FILS.EFFTDATE = X.CLX_EFFTDATE AND FILO.IDCODE = X.IDCODE AND FILO.CLX_EFFTDATE = X.CLX_EFFTDATE ';
        ClxCommon::$db->executeQuery($sql);
        /* Ajustando cuenta de intereses */
        $sql = 'UPDATE CRED_CREDITS FILO, CRED_PAYMNT_SCHEDULES FILS, (SELECT FILOX.IDCODE, FILOX.CLX_EFFTDATE, (SELECT MAX(FILSX.ID) FROM CRED_PAYMNT_SCHEDULES FILSX WHERE FILSX.LOAN_CODE = FILOX.IDCODE AND FILSX.EFFTDATE = FILOX.CLX_EFFTDATE AND FILSX.PERIOD_START_DATE <=' . singleQuote($efftdate) . ') FILS_ID, SUM(IFNULL(((case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('OR') . ' THEN 1 ELSE -1 END) * IF(GLAC.PROVISION = 1, -1, 1) *(JELN.DEBIT_AMT-JELN.CREDIT_AMT)),0)) BALANCE_AMT FROM CRED_CREDITS FILOX, FIDU_ITEMS FIAS, GL_JOURNAL_LINES JELN, GL_CODES_TBL GLAC, GL_PARAMETERS_TBL GLCP WHERE FILOX.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAS.LOAN_CODE = FILOX.IDCODE AND FIAS.IDCODE = JELN.CHART_FIELD03 AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = FILOX.COMP_CODE AND EXISTS(SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = FILOX.PRODUCT_CODE AND PRAT.AR_GL_CODE = JELN.GLACCOUNTCODE) AND FILOX.CLX_EFFTDATE = (SELECT MAX(FILOXX.CLX_EFFTDATE) FROM CRED_CREDITS FILOXX WHERE FILOXX.IDCODE = FILOX.IDCODE AND FILOXX.CLX_EFFTDATE = FILOX.CLX_EFFTDATE) AND JELN.JEHDR_CODE = ' . singleQuote($jehd_code) . ' GROUP BY FILOX.IDCODE, FILOX.CLX_EFFTDATE, FILS_ID) X SET FILS.PAYMENT_AMT = FILS.PAYMENT_AMT + X.BALANCE_AMT, FILS.INTEREST_PAY = FILS.INTEREST_PAY + X.BALANCE_AMT WHERE FILS.ID = X.FILS_ID AND FILS.LOAN_CODE = X.IDCODE AND FILS.EFFTDATE = X.CLX_EFFTDATE AND FILO.IDCODE = X.IDCODE AND FILO.CLX_EFFTDATE = X.CLX_EFFTDATE ';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Actualizacion de auxiliares de inversion
     */
    private function monetary_indexation_auxiliar_infa($jehd_code, $comp_code, $efftdate) {
        //CINDX_PREV_XRATE
        /* Se ajusta para que el monto nominal no se altere segun solicitado. */
        //Ajustando inversiones capital
        $sql = 'UPDATE INVE_INVESTMENTS INFA, (SELECT INFA.POSITION_NUMBER, INFA.PORTFOLIO_CODE, SUM(IFNULL(((case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('OR') . ' THEN 1 ELSE -1 END) * IF(GLAC.PROVISION = 1, -1, 1) *(JELN.DEBIT_AMT-JELN.CREDIT_AMT)),0)) BALANCE_AMT FROM INVE_PORTFOLIOS INFU, INVE_INVESTMENTS INFA, GL_PROD_PRMTR_TBL PRAT, GL_CODES_TBL GLAC, GL_PARAMETERS_TBL GLCP, FIDU_ITEMS FIAS, GL_JOURNAL_LINES JELN WHERE INFU.COMP_CODE = ' . singleQuote($comp_code) . ' AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = INFU.COMP_CODE AND FIAS.PORTFOLIO_CODE = INFU.IDCODE AND INFA.PORTFOLIO_CODE = INFU.IDCODE AND FIAS.IDCODE = JELN.CHART_FIELD03 AND JELN.ITEM_REF_NO = INFA.POSITION_NUMBER AND PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND JELN.JEHDR_CODE = ' . singleQuote($jehd_code) . ' GROUP BY INFA.POSITION_NUMBER, INFA.PORTFOLIO_CODE) X SET INFA.INVEST_AMT = INFA.INVEST_AMT+X.BALANCE_AMT, /*INFA.FACE_VALUE = IF(INFA.IS_FIXINCOME = 1, INFA.FACE_VALUE+X.BALANCE_AMT, INFA.FACE_VALUE),*/ INFA.BOOK_VALUE_AMT = INFA.BOOK_VALUE_AMT + X.BALANCE_AMT WHERE INFA.POSITION_NUMBER = X.POSITION_NUMBER AND INFA.PORTFOLIO_CODE = X.PORTFOLIO_CODE ';
        ClxCommon::$db->executeQuery($sql);
        //Ajuste de intereses
        $sql = 'UPDATE INVE_INVESTMENTS INFA, (SELECT INFA.POSITION_NUMBER, INFA.PORTFOLIO_CODE, SUM(IFNULL(((case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('OR') . ' THEN 1 ELSE -1 END) * IF(GLAC.PROVISION = 1, -1, 1) *(JELN.DEBIT_AMT-JELN.CREDIT_AMT)),0)) BALANCE_AMT FROM INVE_PORTFOLIOS INFU, INVE_INVESTMENTS INFA, GL_PROD_PRMTR_TBL PRAT, GL_CODES_TBL GLAC, GL_PARAMETERS_TBL GLCP, FIDU_ITEMS FIAS, GL_JOURNAL_LINES JELN WHERE INFU.COMP_CODE = ' . singleQuote($comp_code) . ' AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = INFU.COMP_CODE AND FIAS.PORTFOLIO_CODE = INFU.IDCODE AND INFA.PORTFOLIO_CODE = INFU.IDCODE AND FIAS.IDCODE = JELN.CHART_FIELD03 AND JELN.ITEM_REF_NO = INFA.POSITION_NUMBER AND PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.AR_GL_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND JELN.JEHDR_CODE = ' . singleQuote($jehd_code) . ' GROUP BY INFA.POSITION_NUMBER, INFA.PORTFOLIO_CODE) X SET INFA.ACCRUED_INT_AMT = INFA.ACCRUED_INT_AMT+X.BALANCE_AMT WHERE INFA.POSITION_NUMBER = X.POSITION_NUMBER AND INFA.PORTFOLIO_CODE = X.PORTFOLIO_CODE ';
        ClxCommon::$db->executeQuery($sql);
        //Updating portfolio totals
        if (!class_exists('Infu')) {
            includeCodeLib('INFU');
        }
        $infu = new Infu();
        $infu->infu_update_portfolio_totals($comp_code);
    }

    /**
     * Actualizacion de auxiliares de depreciacion de bienes
     */
    private function monetary_indexation_auxiliar_amds($jehd_code, $comp_code, $efftdate) {
        /* Auxiliares de capital. Sumando monto en linea que toca capital y actualizando auxiliares. No seguro sobre monto de prestamo. */
        $sql = 'UPDATE AMGT_DEPRECIATION AMDS, (SELECT FIAEX.IDCODE, FIAEX.CLX_EFFTDATE, (SELECT MAX(AMDSX.PERIOD_START_DATE) FROM AMGT_DEPRECIATION AMDSX WHERE AMDSX.ASSETCODE = FIAEX.IDCODE AND AMDSX.EFFTDATE = FIAEX.CLX_EFFTDATE AND AMDSX.PERIOD_START_DATE <=' . singleQuote($efftdate) . ') PERIOD_START_DATE, SUM(IFNULL(((case GLAC.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN 1 WHEN ' . singleQuote('EX') . ' THEN 1 WHEN ' . singleQuote('OR') . ' THEN 1 ELSE -1 END) * IF(GLAC.PROVISION = 1, -1, 1) *(JELN.DEBIT_AMT-JELN.CREDIT_AMT)),0)) BALANCE_AMT FROM AMGT_ASSETS FIAEX, FIDU_ITEMS FIAS, GL_JOURNAL_LINES JELN, GL_CODES_TBL GLAC, GL_PARAMETERS_TBL GLCP WHERE FIAEX.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAS.ASSET_CODE = FIAEX.IDCODE AND FIAS.IDCODE = JELN.CHART_FIELD03 AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = FIAEX.COMP_CODE AND EXISTS(SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = FIAEX.PRODUCT_CODE AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE) AND FIAEX.CLX_EFFTDATE = (SELECT MAX(FIAEXX.CLX_EFFTDATE) FROM AMGT_ASSETS FIAEXX WHERE FIAEXX.IDCODE = FIAEX.IDCODE AND FIAEXX.CLX_EFFTDATE = FIAEX.CLX_EFFTDATE) AND JELN.JEHDR_CODE = ' . singleQuote($jehd_code) . ' GROUP BY FIAEX.IDCODE, FIAEX.CLX_EFFTDATE, PERIOD_START_DATE) X SET AMDS.BOOK_VALUE = AMDS.BOOK_VALUE + X.BALANCE_AMT, AMDS.DEPRECIATION_AMT = if(AMDS.PERIOD_START_DATE = X.PERIOD_START_DATE, AMDS.DEPRECIATION_AMT + X.BALANCE_AMT, AMDS.DEPRECIATION_AMT), AMDS.ACCU_DEPRTION_AMT = AMDS.ACCU_DEPRTION_AMT + X.BALANCE_AMT WHERE AMDS.PERIOD_START_DATE >= X.PERIOD_START_DATE AND AMDS.ASSETCODE = X.IDCODE AND AMDS.EFFTDATE = X.CLX_EFFTDATE ';
        ClxCommon::$db->executeQuery($sql);
    }

}
