<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-12 07:55:36 -0400 (Mon, 12 Oct 2015) $
 * @version        $Rev: 7215 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Guar {

    var $display = false;

    function __construct($procParameters = array()) {
        multiTableName($this, array('GUAR', 'PROD', 'PRAT', 'PRGT', 'FIAS', 'GLAC', 'PRLT', 'FICO', 'GDVW', 'JCBV', 'JEHD', 'JELN', 'GLPF', 'GLT1'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param unknown_type $record
     */
    function init_form(&$record) {

    }
	
    /**
     * Initialice form - Executed on init event
     *
     * @param unknown_type $record
     */
    function load_form(&$record) {
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($record['GUAR_COMP_CODE']);
        if ((UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE' || UserRequest::$request['ac'] === 'DUPLICATE')) {
            $record['GUAR_CLX_EFFTDATE'] = $comprec['OPERATION_DATE'];
        }
        if (UserRequest::$request['ac'] <> 'CREATE') {
            $sql = 'SELECT FICO.IDCODE, FICO.CONTRACT_NUMBER, FICO.IDNAME, FIAS.CONTRACT_CODE, FIAS.ACCOUNTCODE FROM ' . $this->fiasname . ' FIAS, ' . $this->ficoname . ' FICO WHERE FIAS.CONTRACT_CODE = FICO.IDCODE AND FIAS.GUAR_CODE = ' . singleQuote($record['GUAR_IDCODE']);
            $fiasrec = ClxCommon::$db->getOneRecord($sql);
            $record['GUAR_CHART_FIELD01'] = $fiasrec['IDCODE'];
            $record['GUAR_CHART_FIELD01_prim'] = $fiasrec['CONTRACT_NUMBER'];
            $record['GUAR_CHART_FIELD01_secd'] = $fiasrec['IDNAME'];
            //GUAR_CHART_FIELD01_prim
            $record['GUAR_CHART_FIELD02'] = $fiasrec['ACCOUNTCODE'];
            $record['GUAR_CHART_FIELD02_prim'] = $fiasrec['ACCOUNTCODE'];
            $record['GUAR_CHART_FIELD02_secd'] = '';
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
        //Validar contrato, si no tiene contrato por defecto en producto
        getLookupValue('GUAR_CHART_FIELD01', 'CHART_FIELD01', UserRequest::$post);
        getLookupValue('GUAR_CHART_FIELD02', 'CHART_FIELD02', UserRequest::$post);
        $sql = 'SELECT CHART_FIELD01 FROM ' . $this->prgtname . ' WHERE PRODUCT_CODE = ' . singleQuote($record['GUAR_PRODUCT_CODE']);
        $prgt_chart_field01 = ClxCommon::$db->getOne($sql);
        if (empty(UserRequest::$post['GUAR_CHART_FIELD01']) && $prgt_chart_field01 === '') {
            $msg['GUAR_CHART_FIELD01'] = smsg('MSG-249', $record['GUAR_CHART_FIELD01']);
        }
        if (!empty(UserRequest::$post['GUAR_CHART_FIELD01'])) {
            $contract_code = UserRequest::$post['GUAR_CHART_FIELD01'];
        } else {
            $contract_code = $prgt_chart_field01;
        }
        //Validate contract vs company should match
        $sql = 'SELECT COUNT(COMP_CODE) FROM ' . $this->ficoname . ' WHERE IDCODE = ' . singleQuote($contract_code) . ' AND COMP_CODE = ' . singleQuote($record['GUAR_COMP_CODE']);
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg['GUAR_COMP_CODE'] = smsg('MSG-250', $record['GUAR_COMP_CODE'] . '.' . $record['GUAR_CHART_FIELD01']);
        }
    }

    /**
     * Update Information one record is saved
     */
    function save_form(&$record) {

        //add fias to
        $this->build_fias($record);
    }

    /**
     * Builds fias record for loan
     *
     * @param array $filorec
     */
    function build_fias(&$guarrec) {
        //test if already exists
        $sql = 'SELECT COUNT(ID) FROM ' . $this->fiasname . ' WHERE GUAR_CODE = ' . singleQuote($guarrec['IDCODE']);
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO)
            return;
        //search if default contract
        $sql = 'SELECT PRGT.CHART_FIELD01, PRGT.CHART_FIELD02 FROM ' . $this->prgtname . ' PRGT WHERE PRGT.PRODUCT_CODE = ' . singleQuote($guarrec['PRODUCT_CODE']);
        $prgtrec = ClxCommon::$db->getOneRecord($sql);
        //set fias type
        $sql = 'SELECT PROD.CURRENCY_CODE, GLAC.GL_TYPE, GLAC.TRUST_ITEM_TYPE FROM ' . $this->prodname . ' PROD, ' . $this->pratname . ' PRAT, ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = PRAT.PRO_GL_CODE AND GLAC.GLGROUP_CODE = PRAT.GLGROUP_CODE AND PRAT.PRODUCT_CODE = PROD.IDCODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.PRODUCT_CODE = ' . singleQuote($guarrec['PRODUCT_CODE']);
        $pratrec = ClxCommon::$db->getOneRecord($sql);
        if (array_key_exists('GUAR_CHART_FIELD01_prim', UserRequest::$post)) {
            getLookupValue('GUAR_CHART_FIELD01', 'CHART_FIELD01', UserRequest::$post);
        }
        //GUAR_PARTICIPANT_ID_prim
        if (array_key_exists('GUAR_CHART_FIELD02_prim', UserRequest::$post)) {
            getLookupValue('GUAR_CHART_FIELD02_prim', 'CHART_FIELD02', UserRequest::$post);
        }
        if (!empty(UserRequest::$post['GUAR_CHART_FIELD01'])) {
            $prgtrec['CHART_FIELD01'] = UserRequest::$post['GUAR_CHART_FIELD01'];
        }
        if (!empty(UserRequest::$post['GUAR_CHART_FIELD02'])) {
            $prgtrec['CHART_FIELD02'] = UserRequest::$post['GUAR_CHART_FIELD02'];
        }
        if (empty($guarrec['EXT_PRODUCT_CODE']) || $guarrec['EXT_PRODUCT_CODE'] === 'null') {
            $guarrec['EXT_PRODUCT_CODE'] = $guarrec['IDCODE'];
        }
        $r = array('GUAR_CODE' => $guarrec['IDCODE'],
            'EXT_PRODUCT_CODE' => $guarrec['EXT_PRODUCT_CODE'],
            'GL_TYPE' => $pratrec['GL_TYPE'],
            'TRUST_ITEM_TYPE' => $pratrec['TRUST_ITEM_TYPE'],
            'CURRENCY_CODE' => $guarrec['CURRENCY_CODE'],
            'CONTRACT_CODE' => $prgtrec['CHART_FIELD01'],
            'ACCOUNTCODE' => ((!empty($prgtrec['CHART_FIELD02'])) ? $prgtrec['CHART_FIELD02'] : ''),
            'IDNAME' => $guarrec['IDNAME'],
            'FIDU_BANKACT_CODE' => 'null',
            'ASSET_CODE' => 'null');
        if ($r['TRUST_ITEM_TYPE'] === '')
            $r['TRUST_ITEM_TYPE'] = 'GA';
        if (!empty($r['CONTRACT_CODE'])) {
            if (!class_exists('Fias'))
                includeCodeLib('FIAS');
            $fias = new Fias();
            $fias->fias_build($r);
            unset($fias);
        }
    }

    // Amortizacion
    /**
     * Method to execute cron for interest
     *
     * @param unknown_type $comp_code
     */
    function run_amortization_cron($comp_code) {
        $this->display = true;
        $this->amortization($comp_code, '');
    }

    /**
     * Runs interest calculation
     *
     */
    function run_amortization() {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->guarname . ' WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->amortization($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
        }
		ClxCommon::$db->freeResult($rs);
    }

    function amortization($comp_code, $guar_code = '') {
        $this->je_source = 'GUAMR'; //provision de intereses de reserva
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        $operation_date_month = adodb_next_month_lastday($operation_date);
        if ($this->display === true) {
            echoLog($idname . '. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Guarantee: ' . (($guar_code === '') ? 'ALL' : $guar_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT1'); //Clear tmp
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //loading temporary table
        $sql = 'INSERT INTO ' . $this->glt1name . ' (COMP_CODE, BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE) SELECT ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($operation_date) . ' EFFTDATE, PRAT.AP_GL_CODE GLACCOUNTCODE, PRAT.INC_GL_CODE GL01_CODE, PRAT.PRO_GL_CODE GL02_CODE, ' . singleQuote('AS') . ' GL_TYPE, GUAR.AMORTIZATION_AMT BALANCE_AMT, GUAR.AMORTIZATION_PCT CALC_AMT_01, -1*(GUAR.FEE_AMORTIZED_AMT-GUAR.FEE_CHARGED_AMT) CALC_AMT_02, -1* SUM(JCBV.BALANCE_AMT) CALC_AMT_03, GUAR.ID CALC_AMT_04, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, GUAR.IDCODE LOAN_CODE, GUAR.PRODUCT_CODE FROM ' . $this->guarname . ' GUAR, ' . $this->fiasname . ' FIAS, ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT WHERE GUAR.IDCODE = FIAS.GUAR_CODE AND FIAS.IDCODE = JCBV.CHART_FIELD03 AND PRAT.PRODUCT_CODE = GUAR.PRODUCT_CODE AND PRAT.AP_GL_CODE = JCBV.GLACCOUNTCODE AND GUAR.CURRENCY_CODE = JCBV.CURRENCY_CODE AND GUAR.AMORTIZATION_FREQ <> ' . singleQuote('0') . ' AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND GUAR.COMP_CODE = ' . singleQuote($comp_code) . ' AND ' . singleQuote($operation_date) . ' = (SELECT (case GUAR2.AMORTIZATION_FREQ WHEN ' . singleQuote('12') . ' THEN ADDDATE(ADDDATE(DATE_FORMAT(GUAR2.START_DATE, ' . singleQuote('%Y-%m-01') . '), INTERVAL (1*PERIOD_DIFF( EXTRACT(YEAR_MONTH FROM ' . singleQuote($operation_date) . '), EXTRACT(YEAR_MONTH FROM GUAR2.START_DATE))+1) MONTH), INTERVAL -1 DAY) WHEN ' . singleQuote('1') . ' THEN ADDDATE(ADDDATE(DATE_FORMAT(GUAR2.START_DATE, ' . singleQuote('%Y-%m-01') . '), INTERVAL ((1*PERIOD_DIFF( EXTRACT(YEAR FROM ' . singleQuote($operation_date) . '), EXTRACT(YEAR FROM DATE_FORMAT(GUAR2.START_DATE, ' . singleQuote('%Y-%m-01') . ')))+1)) YEAR),INTERVAL -1 DAY) WHEN ' . singleQuote('4') . ' THEN  ADDDATE(ADDDATE(DATE_FORMAT(GUAR2.START_DATE, ' . singleQuote('%Y-%m-01') . '), INTERVAL 3*CEIL(( PERIOD_DIFF( EXTRACT(YEAR_MONTH FROM ' . singleQuote($operation_date) . '), EXTRACT(YEAR_MONTH FROM GUAR2.START_DATE))+1)/3) MONTH), INTERVAL -1 DAY) WHEN ' . singleQuote('2') . ' THEN ADDDATE(ADDDATE(DATE_FORMAT(GUAR2.START_DATE, ' . singleQuote('%Y-%m-01') . '), INTERVAL 6*CEIL(( PERIOD_DIFF( EXTRACT(YEAR_MONTH FROM ' . singleQuote($operation_date) . '), EXTRACT(YEAR_MONTH FROM GUAR2.START_DATE))+1)/6) MONTH), INTERVAL -1 DAY) WHEN ' . singleQuote('52') . ' THEN ADDDATE(ADDDATE(GUAR2.START_DATE, INTERVAL 1*FLOOR((DATEDIFF(' . singleQuote($operation_date) . ', GUAR2.START_DATE)+1)/7) WEEK), INTERVAL -1 DAY)  WHEN ' . singleQuote('360') . ' THEN ' . singleQuote($operation_date) . ' WHEN ' . singleQuote('365') . ' THEN ' . singleQuote($operation_date) . ' WHEN ' . singleQuote('366') . ' THEN ' . singleQuote($operation_date) . ' ELSE null END) 	NEXTDATE FROM  ' . $this->guarname . ' GUAR2  WHERE  GUAR2.ID = GUAR.ID) AND GUAR.AMORTIZATION_AMT <> 0 AND GUAR.START_DATE <= ' . singleQuote($operation_date) . ' AND GUAR.END_DATE >= ' . singleQuote($operation_date_month) . ' ' . (($guar_code <> '') ? ' AND GUAR.IDCODE =' . singleQuote($guar_code) : '') . ' AND GUAR.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->guarname . ' X  WHERE  X.IDCODE = GUAR.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($operation_date) . ') GROUP BY PRAT.AP_GL_CODE, PRAT.INC_GL_CODE, PRAT.PRO_GL_CODE, GUAR.AMORTIZATION_AMT, GUAR.AMORTIZATION_PCT,  GUAR.FEE_AMORTIZED_AMT, GUAR.FEE_CHARGED_AMT,  GUAR.ID,  JCBV.CHART_FIELD01,  JCBV.CHART_FIELD02,  JCBV.CHART_FIELD03,  JCBV.CHART_FIELD04,  JCBV.CURRENCY_CODE,  GUAR.IDCODE,  GUAR.PRODUCT_CODE  HAVING  SUM(JCBV.BALANCE_AMT) <> 0';
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Set type AS/LI
        $sql = 'UPDATE ' . $this->glt1name . ' GLT1 SET GLT1.GL_TYPE = (SELECT MAX(GLAC.GL_TYPE) FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = GLT1.GL02_CODE) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //setting operation to available level
        $sql = 'UPDATE ' . $this->glt1name . ' GLT1  SET  GLT1.BALANCE_AMT = GLT1.CALC_AMT_02  WHERE  GLT1.BALANCE_AMT > GLT1.CALC_AMT_02  AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT DISTINCT CURRENCY_CODE, EFFTDATE OPERATION_DATE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $r['OPERATION_DATE']);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . $rate['EXCHANGE_RT'] . ', WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        }//end while
		ClxCommon::$db->freeResult($rs);
        //Guardar monto en distribucion
        $sql = 'UPDATE ' . $this->glt1name . ' SET CALC_AMT_04 = BALANCE_AMT WHERE  BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Generando Distribucion
        $sql = 'SELECT LOAN_CODE, SUM(CALC_AMT_03) TOTAL FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY LOAN_CODE';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'UPDATE ' . $this->glt1name . ' SET BALANCE_AMT = ROUND(BALANCE_AMT*(CALC_AMT_03/' . $r['TOTAL'] . '), 2) WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($rs);
        //Ajustando rounding de distribucion
        $sql = 'SELECT LOAN_CODE, (SUM(BALANCE_AMT)-CALC_AMT_04) DIF  FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY LOAN_CODE, CALC_AMT_04 HAVING (SUM(BALANCE_AMT)-CALC_AMT_04)<>0';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'SELECT CHART_FIELD01, CHART_FIELD02 FROM ' . $this->glt1name . ' WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' LIMIT 1';
            $part = ClxCommon::$db->getOneRecord($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET BALANCE_AMT = BALANCE_AMT + ' . $r['DIF'] . ' WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CHART_FIELD01 = ' . singleQuote($part['CHART_FIELD01']) . ' AND CHART_FIELD02 = ' . singleQuote($part['CHART_FIELD02']);
            ClxCommon::$db->executeQuery($sql);
        }
		ClxCommon::$db->freeResult($rs);
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = ROUND(BALANCE_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2), DEBIT_TRANS_AMT = BALANCE_AMT WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . '';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = ROUND(BALANCE_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2), CREDIT_TRANS_AMT = BALANCE_AMT WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . '';
        ClxCommon::$db->executeQuery($sql);
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;
        //Reject any posible todays entry from this process thas has run today
        $jehd->jehd_reverse_by_je_source($comp_code, $this->je_source, $operation_date);
        /* 2. GENERAR ACTIVIDADES DE DEVENGO PARA PARTICIPANTES DE CONTRATO */
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT COMP_CODE, EFFTDATE OPERATION_DATE, ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01,  CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR,  X.CREDIT_AMT DEBIT_AMT,  X.DEBIT_AMT CREDIT_AMT,  X.CREDIT_TRANS_AMT DEBIT_TRANS_AMT,  X.DEBIT_TRANS_AMT CREDIT_TRANS_AMT,  2 SEQNUM  FROM ' . $this->glt1name . ' X  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            ClxCommon::$db->executeQuery($sql);
            //Removing sub account from in,ex,eq
            $sql = 'UPDATE  ' . $this->jelnname . ' JELN  SET  JELN.CHART_FIELD03 = null  WHERE  JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . '  AND EXISTS(SELECT GLAC.ID  FROM ' . $this->glacname . ' GLAC  WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE  AND GLAC.GL_TYPE IN (' . singleQuoteArray(array('IN', 'EX', 'EQ')) . '))';
            ClxCommon::$db->executeQuery($sql);
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }
		ClxCommon::$db->freeResult($results);
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
    }

    /**
     * Builds loan balances from transaction
     *
     * @param string $jehd_code
     */
    function update_balances_jehd($jehd_code, $batch_id = false) {
        $cc = ' JEHD.IDCODE = ' . singleQuote($jehd_code) . ' ';
        if ($batch_id === true) {
            $cc = ' JEHD.BATCH_ID = ' . singleQuote($batch_id) . ' ';
        }
        $sql = 'SELECT DISTINCT FIAS.GUAR_CODE, GUAR.CLX_EFFTDATE FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN,' . $this->fiasname . ' FIAS, ' . $this->guarname . ' GUAR WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND GUAR.IDCODE = FIAS.GUAR_CODE AND ' . $cc . ' AND GUAR.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->guarname . ' X WHERE GUAR.IDCODE = X.IDCODE AND X.CLX_EFFTDATE<=JEHD.EFFTDATE)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->update_balance($r['GUAR_CODE'], $r['CLX_EFFTDATE']);
            $this->update_interest_balance($r['GUAR_CODE'], $r['CLX_EFFTDATE']);
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Updates guarantee balances based on accounting operation date
     * @param string $guar_code
     * @param string $efftdate
     */
    private function update_balance($guar_code, $efftdate) {
        $sql = 'UPDATE ' . $this->guarname . ' GUAR SET GUAR.AVAILABLE_AMT = IFNULL((SELECT -1*SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS ' . $this->pratname . ' PRAT WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.JE_STATUS IN (' . singleQuoteArray(array('AP', 'APV')) . ') AND JELN.CHART_FIELD03 = FIAS.IDCODE AND GUAR.PRODUCT_CODE = PRAT.PRODUCT_CODE AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE AND JELN.CURRENCY_CODE = GUAR.CURRENCY_CODE AND FIAS.GUAR_CODE = GUAR.IDCODE),0), GUAR.BALANCE_AMT = IFNULL((SELECT SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.JE_STATUS IN (' . singleQuoteArray(array('AP', 'APV')) . ') AND JELN.CHART_FIELD03 = FIAS.IDCODE AND GUAR.PRODUCT_CODE = PRAT.PRODUCT_CODE AND PRAT.ORDER_GL_CODE = JELN.GLACCOUNTCODE AND JELN.CURRENCY_CODE = GUAR.CURRENCY_CODE AND FIAS.GUAR_CODE = GUAR.IDCODE),0) WHERE GUAR.IDCODE = ' . singleQuote($guar_code) . ' AND GUAR.CLX_EFFTDATE >=' . singleQuote($efftdate);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Updates loan balances based on accounting operation date
     * Method update balance of earned interest
     * @param string $guar_code
     * @param string $efftdate
     */
    private function update_interest_balance($guar_code, $efftdate) {
        $sql = 'SELECT (SELECT MAX(GLAC.GL_TYPE) FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = PRAT.AR_GL_CODE) GL_TYPE, SUM((case JEHD.ADJUSTMENT WHEN 0 THEN (JELN.DEBIT_TRANS_AMT) ELSE 0 END))- SUM((case JEHD.ADJUSTMENT WHEN 1 THEN (JELN.CREDIT_TRANS_AMT) ELSE 0 END)) DEBIT_AMT, SUM((case JEHD.ADJUSTMENT WHEN 0 THEN (JELN.CREDIT_TRANS_AMT) ELSE 0 END))- SUM((case JEHD.ADJUSTMENT WHEN 1 THEN (JELN.DEBIT_TRANS_AMT) ELSE 0 END)) CREDIT_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->guarname . ' GUAR, ' . $this->pratname . ' PRAT WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.JE_STATUS IN (' . singleQuoteArray(array('AP', 'APV')) . ') AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FIAS.GUAR_CODE = GUAR.IDCODE AND PRAT.PRODUCT_CODE = GUAR.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.AP_GL_CODE AND JELN.CURRENCY_CODE = GUAR.CURRENCY_CODE AND GUAR.IDCODE = ' . singleQuote($guar_code) . ' AND GUAR.CLX_EFFTDATE =' . singleQuote($efftdate);
        $intearned_amt = ClxCommon::$db->getOneRecord($sql);
        if (empty($intearned_amt['GL_TYPE'])) {
            $intear = CLX_INIT_ZERO;
            $intpai = CLX_INIT_ZERO;
        } elseif ($intearned_amt['GL_TYPE'] === 'AS') {
            $intear = $intearned_amt['CREDIT_AMT'];
            $intpai = $intearned_amt['DEBIT_AMT'];
        } else {
            $intear = $intearned_amt['DEBIT_AMT'];
            $intpai = $intearned_amt['CREDIT_AMT'];
        }
        if (empty($intear))
            $intear = CLX_INIT_ZERO;
        if (empty($intpai))
            $intpai = CLX_INIT_ZERO;
        $sql = 'UPDATE ' . $this->guarname . ' GUAR SET GUAR.FEE_CHARGED_AMT = ' . $intear . ' , GUAR.FEE_AMORTIZED_AMT = $intpai WHERE GUAR.IDCODE = ' . singleQuote($guar_code) . ' AND GUAR.CLX_EFFTDATE >=' . singleQuote($efftdate);
        ClxCommon::$db->executeQuery($sql);
    }

}
