<?php
/**
* General Code File
* For more information contact  support@alenet.com
*
* @author	   $Author: alenetdev $
* @copyright	Alenet, Inc.
* @since		$Date: 2013-04-24 18:44:22 -0500 (mié, 24 abr 2013) $
* @version		$Rev: 3768 $
*
* CHANGE LOG
* 2015/09/08 CJRD - Included svn prop - Caso 1002633
* 2016/02/26 CJRD - Ported to clx56
*/

/*
 * "data/code" Programs import/export superclass
 */
class DataCodeImportTool {
    var $exportform = NULL;
    var $submit_action = 'tool.php';
    var $clx_pack_run_id;
    var $dump_import_sql_script = NULL;
    var $dump_import_script_flmsg;
    var $access = NULL;
    var $sec_table_list = NULL;
    var $table_list = NULL;
    var $accesskey;
    var $code;
    var $name;
    var $system;
    var $version;
    var $has_preferences;
    var $has_access;
    var $has_package;
    var $has_pagelet;
    var $tablename;
    var $record_name_singular;
    var $record_name_plural;
    var $primary_field;
    var $secondary_field;
    var $seqnum_field;
    var $title_import;
    var $title_export;
    var $clx_package_zip_comment_id = 'clx_package.';

    /**
     * Class Constructor
     *
     * @param array $pars
     * @return void
     */
    function __construct($pars = array()) {
        $this->init_general($pars);
    }

    /**
     * Default Init some class elements - mostly for sub-tables
     *
     * @param array $pars
     * @return void
     */
    function init(&$pars) {
        multiTableName($this, array ($this->code));
        $this->init_general($pars);
        $this->TableSetAccess($pars, array($this->code));
        if ($this->dump_import_sql_script === true) {
            ClxCommon::$db->dump_script = true;
        }
    }

    /**
     * Init some class elements - General
     *
     * @param array $pars
     * @return void
     */
    function init_general(&$pars) {
        // Dump SQL instead of execute instructions
        $UTIL = &getTool('UTIL'); // To load UTIL_DUMP_AUPK_SQL_SCRIPT system parameter
        if (!defined('UTIL_DUMP_AUPK_SQL_SCRIPT'))
            define('UTIL_DUMP_AUPK_SQL_SCRIPT', CLX_NUM_ZERO);
        if(is_null($this->dump_import_sql_script)) {
            $this->dump_import_sql_script = (UTIL_DUMP_AUPK_SQL_SCRIPT === strval(CLX_NUM_ONE));
        }
        $this->dump_import_script_flmsg = '';
        if ($this->dump_import_sql_script === true) {
            if(!isset($pars['script_file_out']) || is_null($pars['script_file_out'])) {
                ClxCommon::$db->script_file_out = kPathToTemp . md5($this->code . '_IMP_' . xFormat::getNow('Y-m-d H:i:s')) . '.sql';
                $pars['script_file_out'] = ClxCommon::$db->script_file_out;
            }
            $this->dump_import_script_flmsg = '<br>' . /* dict('GEN_LBL_TO') */ 'SQL actions Script: ' . ' "<a href="' . ClxCommon::$db->script_file_out . '" target=_blank>' . ClxCommon::$db->script_file_out . '</a>"';
        }
        // Change clx package zip comment id, to
        $this->clx_package_zip_comment_id = str_replace('%main_table_name%', $this->code, 'clx_%main_table_name%_package.');
    }


    // -------------------------------------------------------------------------
    // -- P A C K A G I N G
    // -------------------------------------------------------------------------

    /**
     * Default action selector
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action($ac, $idlist) {
        $contents = '';
        return $contents;
    }

    /**
     * Main Table action selector
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action_main_table($ac, $idlist) {
        $msg = array();
        $record = array();
        $contents = '';
        
        if(isset(UserRequest::$request['subac'])) {
            $ac = UserRequest::$request['subac'];
        }
        
        switch ($ac) {
            case 'EXPORT' :
                // Export form definition
                $this->set_export_form_def();
                if (isset(UserRequest::$post['confirm'])) {
                    if ($this->checkAnyForm($this->exportform, $msg)) {
                        $contents = $this->export($idlist);
                        /*
                        $info = popHistory();
                        $contents .= executeHistory($info);
                        */
                    } else {
                        $contents = $this->useAnyForm($this->exportform, $ac, $idlist, $record, $msg);
                    }
                } else {
                    $record['EDIT_filename'] = $this->code . '_' . date('Ymd');
                    $contents = $this->useAnyForm($this->exportform, $ac, $idlist, $record, $msg);
                }
                break;
            case 'CONTENTS' :
                if (isset(UserRequest::$post ['confirm'])) {
                    if ($this->checkImportForm($msg)) {
                        $contents = $this->contents();
                    } else {
                        $contents = $this->importForm(UserRequest::$post, $msg);
                    }
                } else {
                    $contents = $this->importForm($record, $msg);
                }
                break;
            case 'IMPORT' :
                if ($this->access->canAppend() && $this->access->canDelete()) {
                    $contents = $this->import();
                    /*
                    $info = popHistory();
                    $contents .= executeHistory($info);
                    */
                } else {
                    $tablelist = '';
                    foreach($this->table_list as $tablecode) {
                        if(isset($this->sec_table_list[$tablecode])) {
                            if(!$this->sec_table_list[$tablecode]->canAppend() || !$this->sec_table_list[$tablecode]->canDelete()) {
                                $tablelist .= ($tablelist === '' ? '' : ', ') . $tablecode;
                            }
                        } else {
                            $tablelist .= ($tablelist === '' ? '' : ', ') . '*' . $tablecode;
                        }
                    }
                    $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [INVP-CAN_APPEND][' . $ac . '] ' . $tablelist);
                }
                break;
            default :
                $contents = parent::action($ac, $idlist);
               
                break;
        }
        return $contents;
    }

    /**
     * Default pack element objects
     *
     * @param array $record
     * @return obj
     */
    function pack($record) {
        return NULL;
    }


    /**
     * Default unpack element method - mostly for sub-tables
     *
     * @param object $package
     * @return void
     */
    function unpack($package) {
        $record = $this->unpackRecordWid($package);
        $idcode = $record[$this->primary_field];
        // Deletes existing records
        ClxCommon::$db->deleteRecords($this->tablename, $this->primary_field . ' = ' . singleQuote($idcode));
        $new_record_id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObject($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = new $toolcode ($pars);
                $tool->unpack($o);
            }
        }
    }

    // -------------------------------------------------------------------------
    // METODOS DE CLX_TOOL
    // -------------------------------------------------------------------------

    /**
     * Get tool code
     *
     * @param bool $par_sw
     * @return string
     */
    function getCode($par_sw) {
        return $this->code;
    }

    /**
     * Creates an xml object from record
     *
     * @param array $record
     * @param string $elementCode
     * @return obj
     */
    function packRecord($record, $elementCode = NULL){
        if(is_null($elementCode)) {
            $elementCode = $this->code;
        }
        $o = new xmlObject($elementCode);
        $o->setProp('ID', $record['ID']);
        foreach($record as $key=>$value){
            $f = new xmlObject($key);
            $f->setContents(htmlspecialchars($value));
            $o->addObject($f);
        }
        return $o;
    } //end method

    /**
     * Unpack Record into Metadata
     *
     * @param obj $o
     * @return array
     */
    function unpackRecordWid($o){
        $record = array();
        $structure = $this->toolTableStructure();
        $fields = $structure['fields'];
        foreach($fields as $fieldname=>$fieldrec){
            //if($fieldname!='ID'){
                //$record[$fieldname] = addslashes(html_entity_decode($o->getSubObjectContents(uppercase($fieldname))));
                $record[$fieldname] = html_entity_decode($o->getSubObjectContents(uppercase($fieldname)));
            //}
        }
       
        return $record;
    } //end method

    /**
     * Builds Xml Objects from dependant tool
     *
     * @param obj $objs
     * @param string $elementCode
     * @param string $query
     * @return obj
     */
    function packsub(&$objs, $elementCode, $query){
        $records = ClxCommon::$db->executeQuery($query);
        while($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)){
            //$o = $tool->pack($record);
            $o = $this->packRecord($record, $elementCode);
            $objs->addObject($o);
        }
		ClxCommon::$db->freeResult($records);
        unset($o);
    } //end method

    /**
     * Get Table(s) Access Rights
     *
     * @param array $tables
     * @return array
     */
    function getTablesAccessRights($tables) {
        $tablecodes = implode(singleQuote(','), $tables);
        $this->sec_table_list = array();
        $access = new ClxAccess($this->code);
        if (intval($_SESSION['user_record']['isadmin']) === CLX_NUM_ONE) {
            $access->setAdminUser();
            foreach($tables as $tablecode) {
                $this->sec_table_list[$tablecode] = $access;
            }
        } else {
            $username = $_SESSION ['user_record'] ['username'];
            $sql = 'SELECT AT.TABLECODE, MAX(AT.CANREAD) CANREAD, MAX(AT.CANMODIFY) CANMODIFY, MAX(AT.CANDELETE) CANDELETE, MAX(AT.CANAPPEND) CANAPPEND, MAX(AT.ISADMIN) ISADMIN FROM CLX_DB_TABLES TB, CLX_AC_TABLES AT WHERE TB.IDCODE = AT.TABLECODE AND TB.IDCODE IN (' . singleQuote($tablecodes) . ') AND ((AT.OWNERCODE=' . singleQuote('USER') . ' AND UPPER(AT.OWNERREF)=' . singleQuote(uppercase($username)) . ') OR AT.OWNERCODE=' . singleQuote('GRUP') . ' AND AT.OWNERREF IN (SELECT G.GROUPCODE FROM CLX_AC_GROUP_MEMBERS G WHERE UPPER(G.USERNAME)=' . singleQuote(uppercase($username)) . ')) GROUP BY AT.TABLECODE';
            $records = ClxCommon::$db->executeQuery($sql);
            $this->sec_table_list = array();
            while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                $access->setUserAccess(intval($record ['CANREAD']), intval($record ['CANMODIFY']), intval($record ['CANDELETE']), intval($record ['CANAPPEND']), intval($record ['CANREAD']), intval($record ['ISADMIN']));
                $this->sec_table_list[$record ['TABLECODE']] = $access;
            }
			ClxCommon::$db->freeResult($records);
        }
        return $access;
    }

    // -------------------------------------------------------------------------
    // -------------------------------------------------------------------------

    /**
     * Assigns access property
     *
     * @param array $access
     * @return void
     */
    function setAccess($access) {
        $this->access = $access;
    }

    /**
     * Calculates access property
     *
     * @param array $pars
     * @param array $table_list
     * @return array
     */
    function TableSetAccess($pars, $table_list) {
        $this->accesskey = $this->code;
        $this->table_list = $table_list;
        if(isset($pars['access'])) {
            $this->setAccess($pars['access']);
        }
        if(is_null($this->access)) {
            $ACTO = &getTool('ACTO');
            $this->access = $this->getTablesAccessRights($table_list);
        }
        return $this->access;
    }

    /**
     * Generates data entry form based on $aform definitions
     *
     * @param array $aform
     * @param string $subac
     * @param string $idlist
     * @param array $record
     * @param array $msg
     * @param string $toolcode
     * @return obj
     */
    function useAnyForm($aform, $subac, $idlist, $record, $msg, $toolcode = 'EDIT') {
        $ac = UserRequest::$request['ac'];
        $form = new clx_form($toolcode, $aform);
        $form->setArgument('subac', $subac);
        $form->submit_action = $this->submit_action;
        return $form->editForm($ac, $idlist, $record, $msg);
    }

    /**
     * Check data registered in a form based on $aform definitions
     *
     * @param array $aform
     * @param array $msg
     * @param string $toolcode
     * @return boolean
     */
    function checkAnyForm($aform, &$msg, $toolcode = 'EDIT') {
        $form = new clx_form($toolcode, $aform);
        $form->submit_action = $this->submit_action;
        $result = $form->checkForm1(UserRequest::$post['ac'], UserRequest::$post, $msg);
        return $result;
    }

    /**
     * Initialize form to preserve screen fron one stage to the next, changing variables specified in $vars_to_set
     *
     * @param string $method
     * @param array $vars_to_set
     * @return obj
     */
    function initGenForm($method = 'post', $vars_to_set = array()) {
        $form = new htmlForm(CLX_PROP_ACTION, $this->submit_action);
        $form->setProp('method', $method);
        $hidden_vars = UserRequest::$get;
        if(count($hidden_vars) === CLX_NUM_ZERO) {
            if(isset(UserRequest::$post[CLX_PROP_TO])) { $hidden_vars['to'] = UserRequest::$post['to']; }
            if(isset(UserRequest::$post['ac'])) { $hidden_vars['ac'] = UserRequest::$post['ac']; }
            //if(isset(UserRequest::$post['idlist'])) { $hidden_vars['idlist'] = UserRequest::$post['idlist']; }
            if(isset(UserRequest::$post['wind'])) { $hidden_vars['wind'] = UserRequest::$post['wind']; }
            if(isset(UserRequest::$post['it'])) { $hidden_vars['it'] = UserRequest::$post['it']; }
        }
        foreach($hidden_vars as $key=>$val){
            if(isset($vars_to_set[$key])) {
                // Override value passed in parameter
                $form->addArgument($key,$vars_to_set[$key]);
            } else {
                // Preserve previous value
                $form->addArgument($key,$val);
            }
        }
        return $form;
    }

    // ------------------------------------------------------------------------------
    // E X P O R T
    // ------------------------------------------------------------------------------

    /**
     * Form definition creator
     *
     * @param void
     * @return void
     */
    function set_export_form_def() {
        $this->exportform = array(
            'title' => $this->title_export_dict_code,
            'panels' => array(
                array(
                    'type' => 'normal',
                    'initial_state' => '1',
                    'entries' => array(
                        array(
                            'label' => 'GEN_LBL_FILE',
                            'fields' => array(
                                array('name' => 'filename', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '48',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '1')
                                    )
                                )
                            )
                        )
                    )
                )
            )
        );
    }

    /**
     * Process package export
     *
     * @param string $idlist
     * @return string
     */
    function export($idlist) {
        // ignore_user_abort(CLX_NUM_ONE);
        set_time_limit(CLX_NUM_1800);
        $target = kPathToWebSite . kPathToPackages . UserRequest::$request['EDIT_filename'] . '.zip';
        $packcode = basename($target, '.zip');
        include_once kPathToWebSite . 'classes/clx_zip.php';
        include_once kPathToWebSite . 'classes/clx_file.php';
        // create zip file
        $file = new clx_file($target, 'w');
        $file->open();
        $file->close();
        $zip = new clx_zip ();
        $zip->open($target);
        $objects = ClxCommon::$db->getRecords($this->tablename, 'ID IN (' . implode(',', $idlist) . ') ORDER BY ID');
        $i = CLX_NUM_ZERO;
        while ($objectrec = ClxCommon::$db->getNextRecord($objects, ASSOCIATIVE)) {
            $package = $this->pack($objectrec);
            // Package Name
            $pn = $i .'_' . $packcode . '_' . $this->code . '_' . $objectrec ['ID'] . '.xml';
            $zip->addFromString($pn, $package->source_(array('level' => CLX_NUM_ZERO)));
            $i++;
        }
		ClxCommon::$db->freeResult($objects);
        $zip->setArchiveComment($this->clx_package_zip_comment_id . $i);
        $zip->close();
        /*
         * GEL_LBL_OPER_COMP_SUCCESS
         * Operation completed succesfully
         * Operación realizada con éxito
         */
        $contents = dict('GEN_LBL_PACKAGE') . ': ' . kPathToPackages . UserRequest::$request['EDIT_filename'] . '.zip' . '<br>' . dict($this->title_export_dict_code) . '<br>' . dict('GEL_LBL_OPER_COMP_SUCCESS');
        unset($package_objs, $package, $target);
        return note($contents, 'OK');
    }

    // ------------------------------------------------------------------------------
    // I M P O R T
    // ------------------------------------------------------------------------------

    /**
     * Builds Import Form
     *
     * @param array $record
     * @param array $msg
     * @return string
     */
    function importForm($record, $msg) {
        $idlist = '';
        $form = $this->initGenForm();
        $form->addArgument('subac', 'CONTENTS');
        $form->addArgument('confirm', '1');
        $form->addArgument('idlist', toString($idlist));
        $form->setProp('enctype', 'multipart/form-data');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict($this->title_import_dict_code), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('TOOL_PACK_PROMPT_IMPORTEXPLAIN'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!array_key_exists('EDIT_localfile', $record))
            $record ['EDIT_localfile'] = '';
        if (!array_key_exists('EDIT_uploadfile', $record))
            $record ['EDIT_uploadfile'] = '';
        $table->addField($msg, dict('TOOL_PACK_PROMPT_FILEONSERVER') . ':', 'EDIT_localfile', $record ['EDIT_localfile'], CLX_NUM_48, CLX_NUM_255);
        $table->addFile($msg, dict('TOOL_PACK_PROMPT_UPLOADFILE') . ':', 'EDIT_uploadfile', $record ['EDIT_uploadfile']);
        $table->addYesNo(dict('GEN_LBL_REPLACE_LOCAL_FILE'), 'replace_local_file', CLX_NUM_ZERO, CLX_NUM_ONE);
        $form->addContents($table->source());
        $buttons = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        //$c = new htmlFormSubmit(dict('GEN_LBL_IMPORT'), UserRequest::$request['ac'], $form->getProp('id'));
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_IMPORT'), array('action' => UserRequest::$request['ac'], 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCancel ();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    /**
     * Validate Import form
     *
     * @param array $msg
     * @return boolean
     */
    function checkImportForm(&$msg) {
        $msg = array();
        if (empty(UserRequest::$post ['EDIT_localfile'])) {
            if (UserRequest::$files ['EDIT_uploadfile'] ['error']) {
                $msg ['EDIT_uploadfile'] = dict('ERR_PACK_FILETOOBIG');
            }
        } elseif (!file_exists(UserRequest::$post ['EDIT_localfile'])) {
            if (strpos(UserRequest::$post ['EDIT_localfile'], 'http') === false) {
                $msg ['EDIT_localfile'] = 'There is no file with this name.';
            } elseif (!$fd = @fopen(UserRequest::$post ['EDIT_localfile'], 'r')) {
                $msg ['EDIT_localfile'] = 'There is no file with this name.';
            }
        }
        return (count($msg) === CLX_NUM_ZERO);
    }

    /**
     * Process package Import
     *
     * @param void
     * @return string
     */
    function import() {
        $timetolast = CLX_NUM_60*CLX_NUM_60*CLX_NUM_60;
        $filename = UserRequest::$request ['fn'];
        if ($this->dump_import_sql_script === true) {
            ClxCommon::$db->dump_script = true;
        }
        // verify if zip file
        $full_filename = kPathToWebSite . kPathToPackages . $filename;
        include_once kPathToWebSite . 'classes/clx_zip.php';
        $zip = new clx_zip ();
        if ($zip->open($full_filename) === TRUE) {
            if (strpos($zip->getArchiveComment(), $this->clx_package_zip_comment_id) !== false) {
                // Search all xml files and format contents
                for($i = CLX_NUM_ZERO; $i < $zip->numFiles; $i++) {
                    $xml = $zip->getFromIndex($i);
                    //Import package
                    $this->importUnpackXml($xml);
                }
            }
        } else {
            $fd = fopen($full_filename, 'r');
            $xml = '';
            while (!feof($fd)) {
                $xml .= fread($fd, 8192);
            }
            fclose($fd);
            $this->importUnpackXml($xml);
        }
        if ($this->dump_import_sql_script === true) {
            ClxCommon::$db->dump_script = false;
        }
        $contents = dict('GEN_LBL_PACKAGE') . ': ' . $filename . '<br>' .  dict($this->title_import_dict_code) . '<br>' . dict('GEL_LBL_OPER_COMP_SUCCESS') . ($this->dump_import_script_flmsg === '' ? '' : '<br>' . $this->dump_import_script_flmsg);
        return note($contents, 'OK');
    }

    /**
     * Process XML elements
     *
     * @param string $xml
     * @return void
     */
    function importUnpackXml(&$xml) {
        if (trim($xml) === '') return;
        $package = new XMLObject('ROOT');
        $package->parse($xml);
        $this->unpack($package);
    }

    /**
     * Describes package content
     *
     * @param void
     * @return string
     */
    function contents() {
        $contents = '';
        // ignore_user_abort(CLX_NUM_ONE);
        set_time_limit(CLX_NUM_1800);
        $error = false;
        if (empty(UserRequest::$post ['EDIT_localfile'])) {
            $filename = UserRequest::$files ['EDIT_uploadfile'] ['name'];
            $full_filename = kPathToWebSite . kPathToPackages . $filename;
            if (!move_uploaded_file(UserRequest::$files ['EDIT_uploadfile'] ['tmp_name'], $full_filename)) {
                $contents = alert('Can\'t move: ' . $filename . ' to ' . $filename, 'OK');
                $error = true;
            }
        } else {
            $filename = UserRequest::$post ['EDIT_localfile'];
            $file = new clx_file($filename, 'r');
            $fileinfo = $file->filePathInfo();
            $filename = $fileinfo['filename'] . '.' . $fileinfo['extension'];
            $full_filename = kPathToWebSite . kPathToPackages . $filename;
            //if(!file_exists($full_filename)){
            if(!empty(UserRequest::$post['replace_local_file']) || !file_exists($full_filename)){
                //copy file to local
                $file->copy(UserRequest::$post ['EDIT_localfile'], $full_filename);
            }
            $file->close();
        }
        if (!$error) {
            // verify if zip file
            include_once kPathToWebSite . 'classes/clx_zip.php';
            $zip = new clx_zip ();
            if ($zip->open($full_filename) === TRUE) {
                if (strpos($zip->getArchiveComment(), $this->clx_package_zip_comment_id) !== false) {
                    // Search all xml files and format contents
                    $form = false;
                    $this->contentsFormHeader($filename, $form);
                    for($i = CLX_NUM_ZERO; $i < $zip->numFiles; $i++) {
                        $xml = $zip->getFromIndex($i);
                        $o = new XMLObject('ROOT');
                        $o->parse($xml);
                        $this->contentsFormItem($o, $form, $filename, ($i === CLX_NUM_ZERO));
                    }
                    $this->contentsFormFooter($form);
                    $contents = $form->source();
                } else {
                    $contents = alert('Invalid package file' . '<br>' . '[' . $zip->getArchiveComment() . ' / ' . $this->clx_package_zip_comment_id . ']', 'OK');
                }
                // Procesing zip file
                $zip->close();
            } else {
                if (!$fd = fopen($full_filename, 'r')) {
                    $contents = alert('Can\'t open file', 'OK');
                } else {
                    // $xml = fread($fd, filesize($filename));
                    $xml = '';
                    while (!feof($fd)) {
                        $xml .= fread($fd, CLX_NUM_8192);
                    }
                    fclose($fd);
                    $o = new XMLObject('ROOT');
                    $o->parse($xml);
                    $contents = $this->contentsForm($filename, $o);
                }
            }
        }
        unset($filename, $o);
        return $contents;
    }

    /**
     * Presents contents form
     *
     * @param string $filename
     * @param obj $form
     * @return void
     */
    function contentsFormHeader($filename, &$form) {
        // ignore_user_abort(CLX_NUM_ONE);
        set_time_limit(CLX_NUM_1800);
        $form = $this->initGenForm();
        $form->addArgument('subac', 'IMPORT');
        $form->addArgument('fn', $filename);
    }

    /**
     * Adds content form footer
     *
     * @param object $form
     * @return void
     */
    function contentsFormFooter(&$form) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_IMPORT'), array('action' => UserRequest::$request['ac'], 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCancel ();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
    }

    /**
     * Adds items to package content form
     *
     * @param unknown_type $package
     * @param unknown_type $form
     * @param string $filename
     * @param boolean $should_packinfo
     * @return void
     */
    function contentsFormItem($package, &$form, $filename, $should_packinfo = false) {
        // Pinta el encabezado
        if ($should_packinfo) {
            $table = new htmlTable(CLX_WIDTH_TWO, 'class', 'form', 'width', '100%');
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addCell(dict('TOOL_PACK_TITLE_PACKCONTENTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $table->addData(dict('GEN_LBL_FILENAME') . ':', $filename);
            /*
            $table->addData(dict('GEN_LBL_CODE') . ':', $package->getSubObjectContents('IDCODE'));
            $table->addData(dict('GEN_LBL_NAME') . ':', $package->getSubObjectContents('IDNAME'));
            $table->addData(dict('GEN_LBL_VERSION') . ':', $package->getSubObjectContents('VERSION') . '-' . $package->getSubObjectContents('VERSION_COUNTER'));
            $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($package->getSubObjectContents('DESCRIPTION')));
            $table->addData(dict('GEN_LBL_CDATE') . ':', xFormat::date($package->getSubObjectContents('CDATE')));
            $table->addData(dict('GEN_LBL_MDATE') . ':', xFormat::date($package->getSubObjectContents('MDATE')));
            $table->addData(dict('GEN_LBL_USERNAME') . ':', $package->getSubObjectContents('USERNAME'));
            */
            $table->addCell(dict('TOOL_PACK_TITLE_PACKDETAIL'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $form->addContents($table->source());
            $table = new htmlTable(CLX_WIDTH_FOUR);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addCell(dict('GEN_LBL_STATUS'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_WIDTH => '25%'));
            $table->addCell(dict('TOOL_PACK_PROMPT_LOCALVERSION'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_WIDTH => '25%'));
            $table->addCell(dict('TOOL_PACK_PROMPT_PACKVERSION'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_WIDTH => '25%'));
            $table->addCell(dict('GEN_LBL_DESCRIPTION'), array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_WIDTH => '25%'));
            $form->addContents($table->source());
        }
        $table = new htmlTable(CLX_WIDTH_FOUR);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        // One invoice format in each xml file
        $i = CLX_NUM_ZERO;
        $this->packcheck($package, $i, $table);
        $form->addContents($table->source());
    }

    /**
     * Compare package vs Object versions and generaes detail line
     *
     * @param obj $o
     * @param int $i
     * @param obj $table
     * @return void
     */
    function packcheck($o, &$i, &$table){
        $rv = '';
        $ov = '';
        $class = ($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
        if($o->hasSubObject('VERSION')){
            $ov = $o->getSubObjectContents('VERSION').'-'.$o->getSubObjectContents('VERSION_COUNTER');
            $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, $this->primary_field.'='.singlequote($o->getSubObjectContents($this->primary_field)))>CLX_NUM_ZERO);
            $ov1 = str_replace('.', '', $ov);
            $ov1 = str_replace('-', '', $ov1);
            if($exists){
                $record = ClxCommon::$db->getRecord($this->tablename, $this->primary_field.'='.singlequote($o->getSubObjectContents($this->primary_field)));
                $rv = $record['VERSION'].'-'.$record['VERSION_COUNTER'];
            }
            $rv1 = str_replace('.', '', $rv);
            $rv1 = str_replace('-', '', $rv1);
            if (empty($exists)) {
                $table->addCell(dict('GEN_LBL_NEW'), array(CLX_PROP_CLASS => $class, 'style' => 'background-color: yellow', CLX_PROP_WIDTH => '25%'));
            } elseif ($ov1 > $rv1) {
                $table->addCell(dict('GEN_LBL_UPGRADE'), array(CLX_PROP_CLASS => $class, 'style' => 'background-color: green', CLX_PROP_WIDTH => '25%'));
            } elseif ($ov1 == $rv1) {
                $table->addCell(dict('GEN_LBL_SAME'), array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
            } else {
                $table->addCell(dict('GEN_LBL_DOWNGRADE'), array(CLX_PROP_CLASS => $class, 'style' => 'background-color: red', CLX_PROP_WIDTH => '25%'));
            }
            $table->addCell($rv, array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
            $table->addCell($ov, array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
            $table->addCell($this->packname($o), array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
            $i++;
        }else{
            $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, $this->primary_field.'='.singlequote($o->getSubObjectContents($this->primary_field)))>CLX_NUM_ZERO);
            if(!$exists){
                $table->addCell(dict('GEN_LBL_NEW'), array(CLX_PROP_CLASS => $class, 'style' => 'background-color: yellow', CLX_PROP_WIDTH => '25%'));
            }else{
                $table->addCell(dict('GEN_LBL_UPGRADE'), array(CLX_PROP_CLASS => $class, 'style' => 'background-color: green', CLX_PROP_WIDTH => '25%'));
            }
            //$table->addCell(dict('GEN_LBL_OBJECTHASNOVERSION'), 'class', $class, 'colspan', '2');
            $table->addCell(dict('GEN_LBL_OBJECTHASNOVERSION'), array(CLX_PROP_CLASS => $class, CLX_PROP_COLSPAN, CLX_WIDTH_TWO));
            $table->addCell($this->packname($o), array(CLX_PROP_CLASS => $class, CLX_PROP_WIDTH => '25%'));
            $i++;
        }
    } //end method

    /**
     * Get package object name
     *
     * @param obj $o
     * @return string
     */
    function packname($o) {
        $response = $this->name . ': ' . $o->getSubObjectContents($this->secondary_field);
        return $response;
    }

    /**
     * Presents contents form
     *
     * @param string $filename
     * @param obj $package
     * @return string
     */
    function contentsForm($filename, $package) {
        // ignore_user_abort(CLX_NUM_ONE);
        set_time_limit(CLX_NUM_1800);
        $form = $this->initGenForm();
        $form->addArgument('fn', $filename);
        $form->addArgument('subac', 'IMPORT');
        $tableWidth = CLX_NUM_TWO;
        $table = new htmlTable($tableWidth, 'class', 'form', 'width', '100%');
        $table->addCell(dict('TOOL_PACK_TITLE_PACKCONTENTS'), 'class', 'title', CLX_PROP_COLSPAN, $tableWidth);
        $table->addData(dict('GEN_LBL_FILENAME') . ':', $filename);
        $table->addData(dict('GEN_LBL_CODE') . ':', $package->getSubObjectContents($this->primary_field));
        $table->addData(dict('GEN_LBL_NAME') . ':', $package->getSubObjectContents($this->secondary_field));
        $table->addData(dict('GEN_LBL_COMPANY') . ':', xFormat::text($package->getSubObjectContents('COMP_CODE')));
        /*
        $table->addData(dict('GEN_LBL_VERSION') . ':', $package->getSubObjectContents('VERSION') . '-' . $package->getSubObjectContents('VERSION_COUNTER'));
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($package->getSubObjectContents('DESCRIPTION')));
        $table->addData(dict('GEN_LBL_CDATE') . ':', xFormat::date($package->getSubObjectContents('CDATE')));
        $table->addData(dict('GEN_LBL_MDATE') . ':', xFormat::date($package->getSubObjectContents('MDATE')));
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $package->getSubObjectContents('USERNAME'));
         */
        $form->addContents($table->source());
        /*
        $tableWidth = 4;
        $table = new htmlTable($tableWidth, 'class', 'form', 'width', '100%');
        $table->addCell(dict('TOOL_PACK_TITLE_PACKDETAIL'), 'class', 'subtitle', 'colspan', $tableWidth);
        $table->addCells('headers', dict('GEN_LBL_STATUS'), dict('TOOL_PACK_PROMPT_LOCALVERSION'), dict('TOOL_PACK_PROMPT_PACKVERSION'), dict('GEN_LBL_DESCRIPTION'));

        $objs = $package->getObject('PACK_OBJECTS');
        $i = CLX_NUM_ZERO;
        foreach ($objs->objects as $o) {
            $toolcode = $o->tag;
            $tool = &getTool($toolcode);
            $tool->packcheck($o, $i, $table);
        }
        $form->addContents($table->source());
        */
        $table = new htmlTable($tableWidth, 'class', 'form', 'width', '100%');
        //$c = new htmlFormSubmit(dict('GEN_LBL_IMPORT'), 'IMPORT', $form->getProp('id'));
        $c = new htmlFormSubmit(dict('GEN_LBL_IMPORT'), UserRequest::$request['ac'], $form->getProp('id'));
        $buttons = $c->source();
        $c = new htmlButtonCancel ();
        $buttons .= $c->source();
        $table->addCell($buttons, 'class', 'footers', CLX_PROP_COLSPAN, $tableWidth);
        $form->addContents($table->source());
        return $form->source();
    }

} // End Class

/*
 * -------------------------------------------------------------------------------------------------------
 * I N V O I C E   F O R M A T S   I M P O R T / E X P O R T
 * -------------------------------------------------------------------------------------------------------
 */

/*
 * Relation between tables:
 *
 *  INVP (BILL_INVOICE_PROPS) - Invoice format - Main Table
 *      > INPD (BILL_INVOICE_PROPS_FIELDS_DET) - Invoice format - Lines
 *        Relation: INPD.IDDETAIL = INVP.ID
 *          > INPF (BILL_INVOICE_PROPS_FIELDS_DET_FD) - Invoice format - Sub-lines
 *            Relation: INPF.IDFIELDDT = INPD.ID
 */

/*
 * INVP - Invoice format - Main Table
 */
class INVP extends DataCodeImportTool {
    //var $clx_pack_run_id = 'CLX_INVP_PACK_RUN_ID';
    /**
     * Constructor
     *
     * @param array $pars
     * @return void
     */
    function __construct($pars = array()) {
        $this->code = 'INVP';
        $this->name = 'Invoice Format';
        $this->system = 'System';
        $this->version = '1.0.0.0';
        $this->has_preferences = false;
        $this->has_access = true;
        $this->has_package = true;
        $this->has_pagelet = false;
        $this->tablename = 'BILL_INVOICE_PROPS';
        $this->record_name_singular = 'format';
        $this->record_name_plural = 'formats';
        $this->primary_field = 'ID';
        $this->secondary_field = 'TEMPLATE_NAME';
        $this->seqnum_field = '';
        $this->init($pars);
    }//end method

    /**
     * Init some class elements
     *
     * @param array $pars
     * @return void
     */
    function init(&$pars) {
        multiTableName($this, array ('INVP','INPD','INPF'));
        $this->init_general($pars);
        /*
         * TOOL_INVP_TITLE_IMPORT
         * Invoice Formats Import
         * Importación Formatos de Facturas
         */
        $this->title_import_dict_code = 'TOOL_INVP_TITLE_IMPORT';
        /*
         * TOOL_INVP_TITLE_EXPORT
         * Invoice Formats Export
         * Exportación Formatos de Facturas
         */
        $this->title_export_dict_code = 'TOOL_INVP_TITLE_EXPORT';
        $this->TableSetAccess($pars, array($this->code, 'INPD', 'INPF'));
    }

    /**
     * Main Table structure
     *
     * @param void
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        /*
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        */
        $fields['TEMPLATE_NAME'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['COMP_CODE'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['FILE_DIR'] = array('type' => 'varchar(11)', 'null' => 'YES', 'properties' => '');
        $fields['HEIGHT'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['WIDTH'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['IMG_X'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['IMG_Y'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['IMG_H'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['IMG_W'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['UNIT'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['GUIDANCE_PAPER'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['FONT_SIZE'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['FONT_TYPE'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        /*
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        */
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    // -------------------------------------------------------------------------
    // -- P A C K A G I N G
    // -------------------------------------------------------------------------

    /**
     * Action selector
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action($ac, $idlist) {
        return parent::action_main_table($ac, $idlist);
    }

    /**
     * Pack invoice format objects
     *
     * @param array $record
     * @return obj
     */
    function pack($record) {
        // Pack INVP - Invoice format header
        $o = $this->packRecord($record);
        $code = $record['ID'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        // Pack INPD - Invoice format lines
        $sql = 'SELECT * FROM ' . $this->inpdname . ' WHERE IDDETAIL=' . singleQuote($code);
        $this->packsub($objs, 'INPD', $sql);
        // Pack INPF - Invoice format sub-lines
        $sql = 'SELECT * FROM ' . $this->inpfname . ' WHERE IDFIELDDT IN (SELECT ID FROM ' . $this->inpdname . ' WHERE IDDETAIL=' . singleQuote($code) . ')';
        $this->packsub($objs, 'INPF', $sql);
        $o->addObject($objs);
        return $o;
    }

    /**
     * Unpack one invoice format (main table)
     *
     * @param object $package
     * @return void
     */
    function unpack($package) {
        $record = $this->unpackRecordWid($package);
        $idcode = $record[$this->primary_field];
        // Deletes existing records
        $sql = 'SELECT ID FROM ' . $this->inpdname . ' WHERE IDDETAIL = ' . singleQuote($idcode);
        $records = ClxCommon::$db->executeQuery($sql);
        while ($rec_aux = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
            ClxCommon::$db->deleteRecords($this->inpfname, 'IDFIELDDT = ' . singleQuote($rec_aux['ID']));
            ClxCommon::$db->deleteRecords($this->inpdname, 'ID = ' . singleQuote($rec_aux['ID']));
        }
		ClxCommon::$db->freeResult($records);
        ClxCommon::$db->deleteRecords($this->tablename, $this->primary_field . ' = ' . singleQuote($idcode));
        // Create header record
        $new_record_id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        // Create line and sub-line records
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            $pars = array('access' => $this->access, 'script_file_out' => (!isset(ClxCommon::$db->script_file_out) ? '' : ClxCommon::$db->script_file_out));
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                //$tool = &getTool($toolcode);
                $tool = new $toolcode ($pars);
                $tool->unpack($o);
            }
        }
    }
}//end class

/*
 * INPD - Invoice format - lines
 */
class INPD extends DataCodeImportTool {
    /**
     * Constructor
     *
     * @param array $pars
     * @return void
     */
    function __construct($pars = array()) {
        $this->code = 'INPD';
        $this->name = 'Invoice Format Lines';
        $this->system = 'System';
        $this->version = '1.0.0.0';
        $this->has_preferences = false;
        $this->has_access = true;
        $this->has_package = true;
        $this->has_pagelet = false;
        $this->tablename = 'BILL_INVOICE_PROPS_FIELDS_DET';
        $this->record_name_singular = 'format line';
        $this->record_name_plural = 'format lines';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IDFIELD_INV';
        $this->seqnum_field = '';
        $this->init($pars);
    }//end method

    /**
     * Table structure
     *
     * @param void
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        /*
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        */
        $fields['IDFIELD_INV'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['IDDETAIL'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['ENABLED'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['POSITION_X'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['POSITION_Y'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['WIDTH'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['HEIGHT'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ENCLOSE'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['SHOW_LOCATION'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['WORDWRAP'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['WRAP_SEPARATION'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ROW_SEPARATION'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['DETFIELD'] = array('type' => 'decimal(3)', 'null' => 'YES', 'properties' => '');
        $fields['ALIGN'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['HAS_TOTAL'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['X_TOTAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['Y_TOTAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['HAS_DECIMAL'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['X_DECIMAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['Y_DECIMAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['DECIMAL_W'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['DECIMAL_H'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        /*
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(3CLX_NUM_ZERO)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        */
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }
}//end class

/*
 * INPF - Invoice format - sub-lines
 */
class INPF extends DataCodeImportTool {
    /**
     * Constructor
     *
     * @param array $pars
     * @return void
     */
    function __construct($pars = array()) {
        $this->code = 'INPF';
        $this->name = 'Invoice Format Sub-Lines';
        $this->system = 'System';
        $this->version = '1.0.0.0';
        $this->has_preferences = false;
        $this->has_access = true;
        $this->has_package = true;
        $this->has_pagelet = false;
        $this->tablename = 'BILL_INVOICE_PROPS_FIELDS_DET_FD';
        $this->record_name_singular = 'format sub-line';
        $this->record_name_plural = 'format sub-lines';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IDFIELD_INV';
        $this->seqnum_field = '';
        $this->init($pars);
    }//end method

    /**
     * Table structure
     *
     * @param void
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        /*
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        */
        $fields['IDFIELD_INV'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['IDFIELDDT'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['ENABLED'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['POSITION_X'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['POSITION_Y'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['WIDTH'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['HEIGHT'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ENCLOSE'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['SHOW_LOCATION'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['WORDWRAP'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['WRAP_SEPARATION'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ROW_SEPARATION'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ALIGN'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['HAS_TOTAL'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['X_TOTAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['Y_TOTAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['HAS_DECIMAL'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['X_DECIMAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['Y_DECIMAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['DECIMAL_W'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['DECIMAL_H'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        /*
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        */
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }
}//end class


/*
 * -------------------------------------------------------------------------------------------------------
 * C H E C K S   F O R M A T S   I M P O R T / E X P O R T
 * -------------------------------------------------------------------------------------------------------
 */

/*
 * Relation between tables:
 *
 * CHPR (FIDU_CHK_PROPS) - Check format - Main Table
 *      > CHFD (FIDU_CHK_PROPS_FIELDS_DET) - Check format - Lines
 * 	  Relation: CHFD.ID_DETAIL = CHPR.ID
 * 	  > CHDF (FIDU_CHK_PROPS_FIELDS_DET_FD) - Check format - Sub-lines
 * 	    Relation: CHDF.ID_FIELDDT = CHFD.ID
 */

/*
 * CHPR - Check format - Main Table
 */
class CHPR extends DataCodeImportTool {
    //var $clx_pack_run_id = 'CLX_CHPR_PACK_RUN_ID';

    /**
     * Constructor
     *
     * @param array $pars
     * @return void
     */
    function __construct($pars = array()) {
        $this->code = 'CHPR';
        $this->name = 'Check Format';
        $this->system = 'System';
        $this->version = '1.0.0.0';
        $this->has_preferences = false;
        $this->has_access = true;
        $this->has_package = true;
        $this->has_pagelet = false;
        $this->tablename = 'FIDU_CHK_PROPS';
        $this->record_name_singular = 'format';
        $this->record_name_plural = 'formats';
        $this->primary_field = 'ID';
        $this->secondary_field = 'TEMPLATE_NAME';
        $this->seqnum_field = '';
        $this->init($pars);
    }//end method

    /**
     * Init some class elements
     *
     * @param array $pars
     * @return void
     */
    function init(&$pars) {
        multiTableName($this, array ('CHPR','CHFD','CHDF'));
        $this->init_general($pars);
        /*
         * TOOL_CHPR_TITLE_IMPORT
         * Check Formats Import
         * Importación Formatos de Cheques
         */
        $this->title_import_dict_code = 'TOOL_CHPR_TITLE_IMPORT';
        /*
         * TOOL_CHPR_TITLE_EXPORT
         * Check Formats Export
         * Exportación Formatos de Cheques
         */
        $this->title_export_dict_code = 'TOOL_CHPR_TITLE_EXPORT';
        $this->TableSetAccess($pars, array($this->code, 'CHFD', 'CHDF'));
    }

    /**
     * Main Table structure
     *
     * @param void
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        /*
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        */
        $fields['TEMPLATE_NAME'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['COMP_CODE'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['FILE_DIR'] = array('type' => 'varchar(11)', 'null' => 'YES', 'properties' => '');
        $fields['LAST_CHECK_NO'] = array('type' => 'decimal(3)', 'null' => 'YES', 'properties' => '');
        $fields['HEIGHT'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['WIDTH'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['IMG_X'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['IMG_Y'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['IMG_H'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['IMG_W'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['UNIT'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['GUIDANCE_PAPER'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['FONT_SIZE'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['FONT_TYPE'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        /*
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        */
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    // -------------------------------------------------------------------------
    // -- P A C K A G I N G
    // -------------------------------------------------------------------------

    /**
     * Action selector
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action($ac, $idlist) {
        return parent::action_main_table($ac, $idlist);
    }

    /**
     * Pack check format objects
     *
     * @param array $record
     * @return obj
     */
    function pack($record) {
        // Pack INVP - Invoice format header
        $o = $this->packRecord($record);
        $code = $record['ID'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        // Pack CHFD - Check format lines
        $sql = 'SELECT * FROM ' . $this->chfdname . ' WHERE ID_DETAIL=' . singleQuote($code);
        $this->packsub($objs, 'CHFD', $sql);
        // Pack CHDF - Check format sub-lines
        $sql = 'SELECT * FROM ' . $this->chdfname . ' WHERE ID_FIELDDT IN (SELECT ID FROM ' . $this->chfdname . ' WHERE ID_DETAIL=' . singleQuote($code) . ')';
        $this->packsub($objs, 'CHDF', $sql);
        $o->addObject($objs);
        return $o;
    }

    /**
     * Unpack one check format (main table)
     *
     * @param object $package
     * @return void
     */
    function unpack($package) {
        $record = $this->unpackRecordWid($package);
        $idcode = $record[$this->primary_field];
        // Deletes existing records
        $sql = 'SELECT ID FROM ' . $this->chfdname . ' WHERE ID_DETAIL = ' . singleQuote($idcode);
        $records = ClxCommon::$db->executeQuery($sql);
        while ($rec_aux = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
            ClxCommon::$db->deleteRecords($this->chdfname, 'ID_FIELDDT = ' . singleQuote($rec_aux['ID']));
            ClxCommon::$db->deleteRecords($this->chfdname, 'ID = ' . singleQuote($rec_aux['ID']));
        }
		ClxCommon::$db->freeResult($records);
        ClxCommon::$db->deleteRecords($this->tablename, $this->primary_field . ' = ' . singleQuote($idcode));
        // Create header record
        $new_record_id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        // Create line and sub-line records
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            $pars = array('access' => $this->access, 'script_file_out' => ClxCommon::$db->script_file_out);
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                //$tool = &getTool($toolcode);
                $tool = new $toolcode ($pars);
                $tool->unpack($o);
            }
        }
    }
}//end class

/*
 * CHFD Check format - Lines
 */
class CHFD extends DataCodeImportTool {
    /**
     * Constructor
     *
     * @param array $pars
     * @return void
     */
    function __construct($pars = array()) {
        $this->code = 'CHFD';
        $this->name = 'Check Format Lines';
        $this->system = 'System';
        $this->version = '1.0.0.0';
        $this->has_preferences = false;
        $this->has_access = true;
        $this->has_package = true;
        $this->has_pagelet = false;
        $this->tablename = 'FIDU_CHK_PROPS_FIELDS_DET';
        $this->record_name_singular = 'format line';
        $this->record_name_plural = 'format lines';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IDFIELD';
        $this->seqnum_field = '';
        $this->init($pars);
    }//end method

    /**
     * Table structure
     *
     * @param void
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        /*
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        */
        $fields['IDFIELD'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['ID_DETAIL'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['ENABLED'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['POSITION_X'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['POSITION_Y'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ENCLOSE'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['SHOW_LOCATION'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['WORDWRAP'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['WRAP_SEPARATION'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ROW_SEPARATION'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['DETFIELD'] = array('type' => 'decimal(3)', 'null' => 'YES', 'properties' => '');
        $fields['ALIGN'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['HAS_TOTAL'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['X_TOTAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['Y_TOTAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['FONT_SPACING'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '');
        /*
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        */
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }
}//end class

/*
 * CHDF - Check format - sub-lines
 */
class CHDF extends DataCodeImportTool {
    /**
     * Constructor
     *
     * @param array $pars
     * @return void
     */
    function __construct($pars = array()) {
        $this->code = 'CHDF';
        $this->name = 'Check Format Sub-Lines';
        $this->system = 'System';
        $this->version = '1.0.0.0';
        $this->has_preferences = false;
        $this->has_access = true;
        $this->has_package = true;
        $this->has_pagelet = false;
        $this->tablename = 'FIDU_CHK_PROPS_FIELDS_DET_FD';
        $this->record_name_singular = 'format sub line';
        $this->record_name_plural = 'format sub lines';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IDFIELD';
        $this->seqnum_field = '';
        $this->init($pars);
    }//end method

    /**
     * Table structure
     *
     * @param void
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        /*
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        */
        $fields['IDFIELD'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['ID_FIELDDT'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['ENABLED'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['POSITION_X'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['POSITION_Y'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ENCLOSE'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['SHOW_LOCATION'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['WORDWRAP'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['WRAP_SEPARATION'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ROW_SEPARATION'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['ALIGN'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['HAS_TOTAL'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '');
        $fields['X_TOTAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        $fields['Y_TOTAL'] = array('type' => 'decimal(10,2)', 'null' => 'YES', 'properties' => '');
        /*
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        */
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }
}//end class