<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-07 11:58:37 -0400 (Wed, 07 Oct 2015) $
 * @version        $Rev: 7154 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Leba {

    /**
     * Set debug dump
     *
     * @var boolean
     */
    var $display = false;

    /**
     * Constructor
     *
     * @param array $procParameters
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('COMP', 'GLCP', 'JELN', 'JEHD', 'LEBA', 'LEBT', 'JCBV', 'LEGI', 'CURR'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Update leba entries batch
     *
     * @param string $batch_id
     */
    function leba_update_jehd_by_batch($batch_id) {
        $sql = 'SELECT IDCODE FROM ' . $this->jehdname . ' WHERE BATCH_ID = ' . singleQuote($batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
		  $this->leba_update_jehd($r [CLX_NUM_ZERO]);
        }
		ClxCommon::$db->freeResult($rs);
    }

    /**
     * Buils accounting
     * @param string $jehdr_code
     */
    function leba_update_jehd($jehdr_code) {
        //ClxCommon::$db->setAutocommit(false); see jehd::jehd_post_autorize
        //Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('LEBT');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->lebtname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //Sumarize transaction into temporary table
        $sql = 'INSERT INTO ' . $this->lebtname . ' (GLACCOUNTCODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, DEBITS, CREDITS, BASE_DEBITS, BASE_CREDITS, ADJUST_AMT, BASE_ADJUST_AMT, BALANCE_AMT, BASE_BAL_AMT, LEDGER_CODE, FISCAL_PERIOD, MODIFIEDBY, CDATE, MDATE, BATCH_ID, IS_INSERT) SELECT JELN.GLACCOUNTCODE, JEHD.COMP_CODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.CURRENCY_CODE, SUM(JELN.DEBIT_TRANS_AMT) DEBITS, SUM(JELN.CREDIT_TRANS_AMT) CREDITS, SUM(JELN.DEBIT_AMT) BASE_DEBITS, SUM(JELN.CREDIT_AMT) BASE_CREDITS, SUM((JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT)*JEHD.ADJUSTMENT) ADJUST_AMT, SUM((JELN.DEBIT_AMT-JELN.CREDIT_AMT)*JEHD.ADJUSTMENT) BASE_ADJUST_AMT, SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BASE_BAL_AMT, LEGI.LEDGER_CODE, JEHD.FISCAL_PERIOD, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE, ' . singleQuote($this->batch_id) . ' BATCH_ID, 1 IS_INSERT FROM  ' . $this->leginame . ' LEGI, ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE  JEHD.IDCODE = JELN.JEHDR_CODE AND LEGI.LGGROUP_CODE = JEHD.LGGROUP_CODE AND JEHD.IDCODE = ' . singleQuote($jehdr_code) . '  GROUP BY  LEGI.LEDGER_CODE, JELN.GLACCOUNTCODE, JEHD.COMP_CODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.CURRENCY_CODE, JEHD.FISCAL_PERIOD';
        ClxCommon::$db->executeQuery($sql);
        //Mark cases where not exists leba record
        $sql = 'UPDATE ' . $this->lebtname . ' LEBT SET LEBT.IS_INSERT = 0 WHERE LEBT.BATCH_ID = ' . singleQuote($this->batch_id) . '  AND EXISTS(SELECT LEBA.ID FROM ' . $this->lebaname . ' LEBA WHERE LEBA.COMP_CODE = LEBT.COMP_CODE AND LEBA.CHART_FIELD01 = LEBT.CHART_FIELD01  AND LEBA.CHART_FIELD02 = LEBT.CHART_FIELD02 AND (LEBA.CHART_FIELD03 = LEBT.CHART_FIELD03 OR (LEBA.CHART_FIELD03 IS NULL AND LEBT.CHART_FIELD03 IS NULL)) AND (LEBA.CHART_FIELD04 = LEBT.CHART_FIELD04 OR (LEBA.CHART_FIELD04 IS NULL AND LEBT.CHART_FIELD04 IS NULL)) AND LEBA.GLACCOUNTCODE = LEBT.GLACCOUNTCODE AND LEBA.FISCAL_PERIOD  = LEBT.FISCAL_PERIOD AND LEBA.LEDGER_CODE = LEBT.LEDGER_CODE	 AND LEBA.CURRENCY_CODE = LEBT.CURRENCY_CODE)';
        ClxCommon::$db->executeQuery($sql);
        //Updating old entries
        $sql = 'UPDATE  ' . $this->lebaname . ' LEBA, ' . $this->lebtname . ' LEBT SET  LEBA.DEBITS = LEBA.DEBITS + LEBT.DEBITS, LEBA.CREDITS = LEBA.CREDITS + LEBT.CREDITS, LEBA.BASE_DEBITS = LEBA.BASE_DEBITS + LEBT.BASE_DEBITS, LEBA.BASE_CREDITS = LEBA.BASE_CREDITS + LEBT.BASE_CREDITS, LEBA.ADJUST_AMT = LEBA.ADJUST_AMT + LEBT.ADJUST_AMT, LEBA.BASE_ADJUST_AMT = LEBA.BASE_ADJUST_AMT + LEBT.BASE_ADJUST_AMT, LEBA.BALANCE_AMT = LEBA.BALANCE_AMT + LEBT.BALANCE_AMT, LEBA.BASE_BAL_AMT = LEBA.BASE_BAL_AMT + LEBT.BASE_BAL_AMT, LEBA.MODIFIEDBY = LEBT.MODIFIEDBY, LEBA.MDATE = LEBT.MDATE WHERE  LEBA.COMP_CODE = LEBT.COMP_CODE AND LEBA.CHART_FIELD01 = LEBT.CHART_FIELD01  AND LEBA.CHART_FIELD02 = LEBT.CHART_FIELD02 AND (LEBA.CHART_FIELD03 = LEBT.CHART_FIELD03 OR (LEBA.CHART_FIELD03 IS NULL AND LEBT.CHART_FIELD03 IS NULL)) AND (LEBA.CHART_FIELD04 = LEBT.CHART_FIELD04 OR (LEBA.CHART_FIELD04 IS NULL AND LEBT.CHART_FIELD04 IS NULL)) AND LEBA.GLACCOUNTCODE = LEBT.GLACCOUNTCODE AND LEBA.FISCAL_PERIOD  = LEBT.FISCAL_PERIOD AND LEBA.LEDGER_CODE = LEBT.LEDGER_CODE	 AND LEBA.CURRENCY_CODE = LEBT.CURRENCY_CODE AND LEBT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND LEBT.IS_INSERT = 0';
        ClxCommon::$db->executeQuery($sql);
        //inserting new entries
        //Setting new lines
        $sql = 'INSERT INTO ' . $this->lebaname . ' (GLACCOUNTCODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, DEBITS, CREDITS, BASE_DEBITS, BASE_CREDITS, ADJUST_AMT, BASE_ADJUST_AMT, BALANCE_AMT, BASE_BAL_AMT, LEDGER_CODE, FISCAL_PERIOD, MODIFIEDBY, CDATE, MDATE) SELECT  LEBT.GLACCOUNTCODE, LEBT.COMP_CODE, LEBT.CHART_FIELD01, LEBT.CHART_FIELD02, LEBT.CHART_FIELD03, LEBT.CHART_FIELD04, LEBT.CURRENCY_CODE, SUM(LEBT.DEBITS) DEBITS, SUM(LEBT.CREDITS) CREDITS, SUM(LEBT.BASE_DEBITS) BASE_DEBITS, SUM(LEBT.BASE_CREDITS) BASE_CREDITS, SUM(LEBT.ADJUST_AMT) ADJUST_AMT, SUM(LEBT.BASE_ADJUST_AMT) BASE_ADJUST_AMT, SUM(LEBT.BALANCE_AMT) BALANCE_AMT, SUM(LEBT.BASE_BAL_AMT) BASE_BAL_AMT, LEBT.LEDGER_CODE, LEBT.FISCAL_PERIOD, MAX(LEBT.MODIFIEDBY) MODIFIEDBY, MIN(LEBT.CDATE) CDATE, MAX(LEBT.MDATE) MDATE FROM  ' . $this->lebtname . ' LEBT WHERE  LEBT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND LEBT.IS_INSERT = 1 GROUP BY  LEBT.GLACCOUNTCODE, LEBT.COMP_CODE, LEBT.CHART_FIELD01, LEBT.CHART_FIELD02, LEBT.CHART_FIELD03, LEBT.CHART_FIELD04, LEBT.CURRENCY_CODE, LEBT.LEDGER_CODE, LEBT.FISCAL_PERIOD HAVING  SUM(LEBT.BALANCE_AMT)<>0 OR SUM(LEBT.BASE_BAL_AMT)<>0';
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->lebtname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
    }

    /**
     * Rebuild Balances
     *
     * @param string $comp_code
     */
    function leba_rebuild($comp_code) {
        if ($this->display === true) {
		  echoLog('Re-Building ledger for company: ' . $comp_code);
        }
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->lebaname . ' WHERE COMP_CODE = ' . singleQuote($comp_code));
        $operation_date = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE = ' . singleQuote($comp_code));
        unset($operation_date);

        $sql = 'INSERT INTO ' . $this->lebaname . ' (GLACCOUNTCODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, DEBITS, CREDITS, BASE_DEBITS, BASE_CREDITS, ADJUST_AMT, BASE_ADJUST_AMT, BALANCE_AMT, BASE_BAL_AMT, LEDGER_CODE, FISCAL_PERIOD, MODIFIEDBY, CDATE, MDATE) SELECT JELN.GLACCOUNTCODE, JEHD.COMP_CODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.CURRENCY_CODE, SUM(JELN.DEBIT_TRANS_AMT) DEBITS, SUM(JELN.CREDIT_TRANS_AMT) CREDITS, SUM(JELN.DEBIT_AMT) BASE_DEBITS, SUM(JELN.CREDIT_AMT) BASE_CREDITS, SUM((JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT)*JEHD.ADJUSTMENT) ADJUST_AMT, SUM((JELN.DEBIT_AMT-JELN.CREDIT_AMT)*JEHD.ADJUSTMENT) BASE_ADJUST_AMT, SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BASE_BAL_AMT, LEGI.LEDGER_CODE, JEHD.FISCAL_PERIOD, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE FROM  ' . $this->leginame . ' LEGI, ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE  JEHD.IDCODE = JELN.JEHDR_CODE AND LEGI.LGGROUP_CODE = JEHD.LGGROUP_CODE AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' GROUP BY  LEGI.LEDGER_CODE, JELN.GLACCOUNTCODE, JEHD.COMP_CODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02, JELN.CHART_FIELD03, JELN.CHART_FIELD04, JELN.CURRENCY_CODE, JEHD.FISCAL_PERIOD';
        ClxCommon::$db->executeQuery($sql);
    }

}
