<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date:  14:20:58 -0400 (Wed, 02 Sep 2009) $
 * @version        $Rev: 1376 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Ordl {
    /* Contructor
     *
     * @param array $procParameters
     * @return void
     */

    function __construct($procParameters = array()) {
        multiTableName($this, array('ORDL', 'ORDR', 'PROD', 'ITEM', 'COMP'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice figa form
     * Executed on init event
     */
    function ordl_init_form(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') {

        }
        if (!empty($record['ORDL_ITEM_CODE'])) {
		  $sql = 'SELECT ITEM_COLOR, ITEM_SIZE  FROM INVN_ITEMS  WHERE IDCODE =' . singleQuote($record['ORDL_ITEM_CODE']);
		  $item = ClxCommon::$db->getOneRecord($sql);
		  if (!empty($item)) {
			 $record['ORDL_ITEM_COLOR'] = $item['ITEM_COLOR'];
			 $record['ORDL_ITEM_SIZE'] = $item['ITEM_SIZE'];
		  }
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function ordl_validate_form(&$record, &$msg) {
        $item_size = UserRequest::$post['ORDL_ITEM_SIZE'];
        $item_color = UserRequest::$post['ORDL_ITEM_COLOR'];
        $sql = 'SELECT IDCODE FROM ' . $this->itemname . '  WHERE PRODUCT_CODE = ' . singleQuote(UserRequest::$post['ORDL_PRODUCT_CODE']) . ' ';
        if (strlen($item_size) == CLX_NUM_ZERO)
		  $sql .= ' AND ITEM_SIZE IS NULL';
        else
		  $sql .= ' AND ITEM_SIZE = ' . singleQuote($item_size);
        if (strlen($item_color) == CLX_NUM_ZERO)
		  $sql .= ' AND ITEM_COLOR IS NULL';
        else
		  $sql .= ' AND ITEM_COLOR = ' . singleQuote($item_color);
        $item_code = ClxCommon::$db->getOne($sql);
        if (empty($item_code)) {
		  $msg['ORDL_PRODUCT_CODE'] = smsg('MSG-102');
        }
    }

    /**
     * Events associate before database commit
     */
    function ordl_save_pre_commit(&$record) {
        if (empty($record['ITEM_CODE'])) {
		  $record['ITEM_CODE'] = $this->getItemCode(UserRequest::$post['ORDL_PRODUCT_CODE'], UserRequest::$post['ORDL_ITEM_COLOR'], UserRequest::$post['ORDL_ITEM_SIZE']);
        }
        if (empty($record['PRODUCT_CODE'])) {
		  $record['PRODUCT_CODE'] = ClxCommon::$db->getField($this->itemname, 'PRODUCT_CODE', 'IDCODE = ' . singleQuote($record['ITEM_CODE']));
        }
        if (empty($record['PRICE_LIST'])) {
		  $record['PRICE_LIST'] = ClxCommon::$db->getField($this->itemname, 'PRICE', 'IDCODE = ' . singleQuote($record['ITEM_CODE']));
        }
        if (empty($record['PRICE_DISC'])) {
		  $record['PRICE_DISC'] = CLX_INIT_ZERO;
        }
        $record['LINE_TOTAL'] = bcmul($record['LINE_TOTAL'], $record['LINE_SIGN']);
    }

    function ordl_save_post_commit(&$record) {
        $tax = companyParameter('TAX_FL');
        if (empty($tax))
		  $tax = CLX_INIT_ZERO;
        $sql = 'UPDATE ORDR_ORDERS ORDR  SET ORDR.TAX_AMT = IFNULL((SELECT SUM(ORDL.LINE_TOTAL)*($tax/100)  FROM ORDR_ORDER_LINES ORDL WHERE ORDL.ORDERCODE = ORDR.IDCODE),0) WHERE ORDR.IDCODE =' . singleQuote($record['ORDERCODE']);
        ClxCommon::$db->executeQuery($sql);
        //updateting fulfillment status
        $this->ordrFulfillmentStatus($record['ORDERCODE']);
    }

    /**
     * Returns item code according color and size
     *
     * @param string $product_code
     * @param string $item_color
     * @param string $item_size
     * @return string
     */
    function getItemCode($product_code, $item_color, $item_size) {
        //Determine item code
        $sql = 'SELECT IDCODE FROM ' . $this->itemname . '  WHERE PRODUCT_CODE = ' . singleQuote($product_code) . ' ';
        if (strlen($item_size) == CLX_NUM_ZERO)
		  $sql .= ' AND ITEM_SIZE IS NULL';
        else
		  $sql .= ' AND ITEM_SIZE = ' . singleQuote($item_size);
        if (strlen($item_color) == CLX_NUM_ZERO)
		  $sql .= ' AND ITEM_COLOR IS NULL';
        else
		  $sql .= ' AND ITEM_COLOR = ' . singleQuote($item_color);
        return ClxCommon::$db->getOne($sql);
    }

    // FULFILLMENT METHOD
    function fulFillLines() {
        //1.Prompt tracking and shipment
        //2.if data found process
        if (!empty(UserRequest::$request['ORDRSHIPMNT_CODE']) && !empty(UserRequest::$request['TRACKING_NO'])) {
		  $this->fulfillLinesProcess();
		  return note(dict('GEN_LBL_FULFILLMENT_COMP'), dict('GEN_LBL_RETURN'));
        } else {
		  return $this->fulfillLinesPrompt();
        }
    }

    /**
     * Fulfillment Prompt Form.
     *
     * @return string
     */
    function fulfillLinesPrompt() {
        $title = dict('GEN_LBL_FULFILL_ITEMS');
        $idlist = getIdlist();
        $total_items = count($idlist);
        $idlist = toString($idlist); //selected item lines
        //Ask for shipping Line and tracking number
        $msg = array();
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        foreach (UserRequest::$request as $key => $val) {
		  if ($key === 'ORDRSHIPMNT_CODE' || $key === 'TRAKING_NO' || $key === 'NOTIFY_CLIENT')
			 continue;
		  $form->addArgument($key, $val);
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $select = new htmlSelect('ORDRSHIPMNT_CODE');
        $sql = 'SELECT DISTINCT  ORSH.IDCODE ORDRSHIPMNT_CODE,  ORSH.SHIPPED_VIA,  ORSH.SHIPMENT_TYPE,  ORSH.TRACKING_NO FROM  ORDR_ORDER_LINES ORDL, ORDR_SHIPMENTS ORSH WHERE  ORSH.ORDERCODE = ORDL.ORDERCODE AND ORDL.ID IN (' . $idlist . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $select->addItem($r['ORDRSHIPMNT_CODE'] . ', ' . $r['SHIPPED_VIA'] . ' - ' . $r['SHIPMENT_TYPE'], $r['ORDRSHIPMNT_CODE'], (array_key_exists('ORDRSHIPMNT_CODE', UserRequest::$request) && UserRequest::$request['ORDRSHIPMNT_CODE'] == UserRequest::$request['ORDRSHIPMNT_CODE']));
        }
		ClxCommon::$db->freeResult($rs);
        $table->addData(dict('GEN_LBL_TOTAL_ITEMS') . ':', $total_items);
        $table->addData(dict('GEN_LBL_SHIPMENT') . ':', $select->source());
        unset($select);
        $table->addField($msg, dict('GEN_LBL_TRACKING_NO') . ':', 'TRACKING_NO', ((array_key_exists('TRAKING_NO', UserRequest::$request)) ? UserRequest::$request['TRAKING_NO'] : ''), CLX_NUM_32, CLX_NUM_32);
        $check = new htmlCheckbox('NOTIFY_CLIENT', (!empty(UserRequest::$request['NOTIFY_CLIENT'])), CLX_NUM_ONE);
        $table->addData(dict('GEN_LBL_NOTIFY_CLIENT') . ':', $check->source());
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => UserRequest::$request['ac'], 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        unset($c);
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    /**
     * Process fullfilment record
     *
     */
    function fulfillLinesProcess() {
        //2.Add shipment lines
        //3.Update traking number
        //4.Mark lines as fullfiled
        $idlist = toString(getIdlist());
        //Update tracking number
        $sql = 'UPDATE  ORDR_SHIPMENTS  SET  TRACKING_NO = ' . singleQuote(UserRequest::$request['TRACKING_NO']) . ', SHIPMENT_STATUS = ' . singleQuote('O') . ', ACTUAL_SHIP_DTTM = NOW() WHERE  IDCODE = ' . singleQuote(UserRequest::$request['ORDRSHIPMNT_CODE']);
        ClxCommon::$db->executeQuery($sql);
        //Adding ship items if not exists
        $sql = 'SELECT  ' . singleQuote(UserRequest::$request['ORDRSHIPMNT_CODE']) . ' ORDRSHIPMNT_CODE, ORDL.ITEM_CODE, ORDL.QUANTITY QTY_SENT FROM  ORDR_ORDER_LINES ORDL WHERE  ORDL.ID IN (' . $idlist . ') AND NOT EXISTS( SELECT ORSI.ID FROM ORDR_SHIPMENT_ITEMS ORSI WHERE ORSI.ORDRSHIPMNT_CODE = ' . singleQuote(UserRequest::$request['ORDRSHIPMNT_CODE']) . ' AND ORSI.ITEM_CODE = ORDL.ITEM_CODE)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  ClxCommon::$db->createRecord('ORDR_SHIPMENT_ITEMS', $r, false);
        }
		ClxCommon::$db->freeResult($rs);
        //Setting fulfillment status on items
        $sql = 'UPDATE  ORDR_ORDER_LINES  SET  FULLMNT_STATUS = 2 WHERE  ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
        //set order fulfillment status
        $sql = 'SELECT DISTINCT ORDERCODE  FROM ORDR_ORDER_LINES WHERE ID IN (' . $idlist . ')';
        $r = ClxCommon::$db->executeQuery($sql);
        while (($rs = ClxCommon::$db->getNextRecord($r))) {
		  $this->ordrFulfillmentStatus($rs['ORDERCODE']);
        }
		ClxCommon::$db->freeResult($r);
        //Sending notification if required for the user
        if (!empty(UserRequest::$request['NOTIFY_CLIENT'])) {
		  $this->buildShipmentConfirmation(UserRequest::$request['ORDRSHIPMNT_CODE']);
        }
    }

    /**
     * Sets de order fulfillment status
     *
     * @param string $ordercode
     */
    function ordrFulfillmentStatus($ordercode) {
        //si no existe resultado entonces fulfill=0
        //si existe completada y existe cualquier otra entonces fulfill =1
        //si existe completada y no existe otra cosa entonecs fulfill = 2
        $status = array();
        $sql = 'SELECT FULLMNT_STATUS, COUNT(ID) QTY FROM ORDR_ORDER_LINES WHERE ORDERCODE = ' . singleQuote($ordercode) . ' GROUP BY FULLMNT_STATUS';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  if ($r['FULLMNT_STATUS'] == CLX_NUM_TWO) {
			 $status[CLX_NUM_ONE] = CLX_NUM_ONE;
		  } else {
			 $status[CLX_NUM_ZERO] = CLX_NUM_ONE;
		  }
        }
		ClxCommon::$db->freeResult($rs);
        if (empty($status))
		  $fulfill = CLX_INIT_ZERO;
        elseif (!empty($status[CLX_NUM_ZERO]) && !empty($status[CLX_NUM_ONE]))
		  $fulfill = CLX_NUM_ONE;
        elseif (empty($status[CLX_NUM_ZERO]) && !empty($status[CLX_NUM_ONE]))
		  $fulfill = CLX_NUM_TWO;
        else
		  $fulfill = CLX_INIT_ZERO;
        $sql = 'UPDATE ORDR_ORDERS SET FULLMNT_STATUS = ' . singleQuote($fulfill) . ' WHERE IDCODE = ' . singleQuote($ordercode);
        ClxCommon::$db->executeQuery($sql);
    }

    //SHIPMENT CONFIRMATION
    /**
     * Builds Shipment Confirmation
     *
     * @param string $shipment_code
     */
    function buildShipmentConfirmation($shipment_code) {
        $DBLT = getTool('DBLT');
        $record = array();
        //Shipment Information
        $sql = 'SELECT ORDR.COMP_CODE, ORDR.CONTACT_CODE, ORSH.SHIPPED_VIA, ORSH.SHIPMENT_TYPE, ORSH.* FROM ORDR_ORDERS ORDR, ORDR_SHIPMENTS ORSH   WHERE  ORDR.IDCODE = ORSH.ORDERCODE AND ORSH.IDCODE = ' . singleQuote($shipment_code);
        $orderrec = ClxCommon::$db->getOneRecord($sql);
        unset($orderrec['COMPANY']);
        $record = array_merge($record, $orderrec);
        $record['COMPANY_NAME'] = ClxCommon::$db->getField($this->compname, 'IDNAME', 'IDCODE = ' . singleQuote($orderrec['COMP_CODE']));
        //Contact Information
        $contact_rec = ClxCommon::$db->getRecord('CRM_CONTACTS', 'IDCODE = ' . singleQuote($orderrec['CONTACT_CODE']));
        $contact_rec['CONTACT_NAME'] = $contact_rec['IDNAME'];
        unset($contact_rec['IDCODE'], $contact_rec['ID'], $contact_rec['COMPANY']);
        $record = array_merge($record, $contact_rec);
        $record['CURRENT_DATE'] = date('m/d/Y');
        //Build Packing List
        $sql = 'SELECT  PROD.IDNAME PRODUCT_NAME, ITEM.ITEM_TYPE, ITEM.ITEM_FABRIC, ITEM.ITEM_COLOR, ITEM.ITEM_SIZE,   ORSI.ITEM_CODE, ORSI.NOTES DESCRIPTION,   ORSI.QTY_SENT QUANTITY FROM  CRM_PRODUCTS PROD, INVN_ITEMS ITEM, ORDR_SHIPMENT_ITEMS ORSI  WHERE  PROD.IDCODE = ITEM.PRODUCT_CODE AND ITEM.IDCODE = ORSI.ITEM_CODE AND ORSI.ORDRSHIPMNT_CODE = ' . singleQuote($shipment_code) . ' ORDER BY ORSI.ID ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        $record['SHIPPMENT_ITEMS'] = '<ul>';
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $r['ITEM_TYPE'] = $DBLT->getListItem('ITTY', $r['ITEM_TYPE']);
		  $r['ITEM_FABRIC'] = $DBLT->getListItem('ITSZ', $r['ITEM_FABRIC']);
		  $r['ITEM_COLOR'] = $DBLT->getListItem('ITCO', $r['ITEM_COLOR']);
		  $r['ITEM_SIZE'] = $DBLT->getListItem('ITFA', $r['ITEM_SIZE']);
		  $record['SHIPPMENT_ITEMS'] .= '<li><b>' . $r['PRODUCT_NAME'] . '</b> ';
		  $record['SHIPPMENT_ITEMS'] .= '<i>';
		  $record['SHIPPMENT_ITEMS'] .= $r['ITEM_TYPE'] . ' ' . $r['ITEM_FABRIC'] . ' ' . $r['ITEM_COLOR'] . ' ' . $r['ITEM_SIZE'] . 'Sku: ' .
			     $r['ITEM_CODE'] . '</i><br> Qty:' .
			     $r['QUANTITY'] . '</li>';
        }
        $record['SHIPPMENT_ITEMS'] .= '</ul>';
        //Prepare Template
        $UITM = getTool('UITM');
        unset($record['ID']);
        $templatecode = 'MSG_SHIP_CONF';
        $template = $UITM->getTemplateAndRecordMerge($templatecode, $record);
        $from = companyParameter('ORDR_DEFAULT_FROM_MAIL');
        $to = $contact_rec['EMAIL'];
        $cc = null;
        $bcc = $to;
        $msg = $template['CONTENTS'];
        $subject = $template['SUBJECT'];
        if (!clx_mail($from, $to, $msg, $subject, true, $cc, $bcc)) {
		  addMessage(dict('GEN_LBL_EMAIL_SEND_FAIL') . ' ' . $to);
        }
        //Administrator copy
        if (!clx_mail($from, $from, $msg, $subject, true, $cc, $bcc)) {
		  addMessage(dict('GEN_LBL_EMAIL_SEND_FAIL') . ' ' . $from);
        }
    }

}
