<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-07 09:31:44 -0400 (Wed, 07 Oct 2015) $
 * @version        $Rev: 7146 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Prat {

    function __construct($procParameters = array()) {
        multiTableName($this, array('PRAT', 'GLAC'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
        //Validando que no sea reusada una cuenta MSG-155
        $done_gl = array();
        if (!empty($record['PRAT_PRO_GL_CODE']) && !empty($done_gl[$record['PRAT_PRO_GL_CODE']])) {
		  $msg['PRAT_PRO_GL_CODE'] = smsg('MSG-155');
        }
        $done_gl[$record['PRAT_PRO_GL_CODE']] = CLX_NUM_ONE;
        if (!empty($record['PRAT_AR_GL_CODE']) && !empty($done_gl[$record['PRAT_AR_GL_CODE']])) {
		  $msg['PRAT_AR_GL_CODE'] = smsg('MSG-155');
        }
        $done_gl[$record['PRAT_AR_GL_CODE']] = CLX_NUM_ONE;
        if (array_key_exists('PRAT_FEE_GL_CODE', $record)) {
		  if (!empty($record['PRAT_FEE_GL_CODE']) && !empty($done_gl[$record['PRAT_FEE_GL_CODE']])) {
			  $msg['PRAT_FEE_GL_CODE'] = smsg('MSG-155');
		  }
		  $done_gl[$record['PRAT_FEE_GL_CODE']] = CLX_NUM_ONE;
        }
        if (array_key_exists('PRAT_AP_GL_CODE', $record)) {
		  if (!empty($record['PRAT_AP_GL_CODE']) && !empty($done_gl[$record['PRAT_AP_GL_CODE']])) {
			 $msg['PRAT_AP_GL_CODE'] = smsg('MSG-155');
		  }
		  $done_gl[$record['PRAT_AP_GL_CODE']] = CLX_NUM_ONE;
        }
        if (array_key_exists('PRAT_LATEF_GL_CODE', $record)) {
		  if (!empty($record['PRAT_LATEF_GL_CODE']) && !empty($done_gl[$record['PRAT_LATEF_GL_CODE']])) {
			 $msg['PRAT_LATEF_GL_CODE'] = smsg('MSG-155');
		  }
		  $done_gl[$record['PRAT_LATEF_GL_CODE']] = CLX_NUM_ONE;
        }
        if (!empty($record['PRAT_INC_GL_CODE']) && !empty($done_gl[$record['PRAT_INC_GL_CODE']])) {
		  $msg['PRAT_INC_GL_CODE'] = smsg('MSG-155');
        }
        $done_gl[$record['PRAT_INC_GL_CODE']] = CLX_NUM_ONE;
        if (array_key_exists('PRAT_FEE2_GL_CODE', $record)) {
		  if (!empty($record['PRAT_FEE2_GL_CODE']) && !empty($done_gl[$record['PRAT_FEE2_GL_CODE']])) {
			 $msg['PRAT_FEE2_GL_CODE'] = smsg('MSG-155');
		  }
		  $done_gl[$record['PRAT_FEE2_GL_CODE']] = CLX_NUM_ONE;
        }
        if (array_key_exists('PRAT_LATEF2_GL_CODE', $record)) {
		  if (!empty($record['PRAT_LATEF2_GL_CODE']) && !empty($done_gl[$record['PRAT_LATEF2_GL_CODE']])) {
			 $msg['PRAT_LATEF2_GL_CODE'] = smsg('MSG-155');
		  }
		  $done_gl[$record['PRAT_LATEF2_GL_CODE']] = CLX_NUM_ONE;
        }
        if (!empty($record['PRAT_GL01_CODE'])) {
		  if (!empty($done_gl[$record['PRAT_GL01_CODE']])) {
			 $msg['PRAT_GL01_CODE'] = smsg('MSG-155');
		  }
		  $done_gl[$record['PRAT_GL01_CODE']] = CLX_NUM_ONE;
        }
        //Validar que cuenta seleccionada sea la de capital, sea de movimientos y este activa
        $sql = 'SELECT DBTF.FIELDNAME FROM CLX_DB_TABLEFIELDS DBTF, CLX_DB_FIELDS DBFL WHERE DBFL.FIELDNAME = DBTF.FIELDNAME AND DBFL.FIELDTYPE = ' . "'LOOK'" . ' AND DBFL.FIELD_EXTRA1 = ' . "'GLAC'" . ' AND DBTF.TABLECODE = ' . "'PRAT'";
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  if (empty($record['PRAT_' . $r['FIELDNAME']]))
			 continue;
		  $sql = 'SELECT COUNT(GLAC.ID) FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE =' . singleQuote($record['PRAT_' . $r['FIELDNAME']]) . ' AND GLAC.GLGROUP_CODE =' . singleQuote($record['PRAT_GLGROUP_CODE']) . ' AND GLAC.ALLOW_ACTIVITY = 1 AND GLAC.EFFTSTAT = ' . "'A'";
		  if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
			 $msg['PRAT_' . $r['FIELDNAME']] = smsg('MSG-358');
		  }
        }
		ClxCommon::$db->freeResult($rs);
        //Prevent any account to be used on more than one status
        if (CLX_NUM_ONE == CLX_NUM_TWO) {//comentado ya que el status de notificacion debe terner la misma cuenta para direcnte estatus
		  $gls = array('PRO_GL_CODE', 'AR_GL_CODE');
		  foreach ($gls as $key => $val) {
			 if ($record['PRAT_' . $val] === '') {
			     continue;
			 }
			 $sql = 'SELECT COUNT(PRAT.ID) FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE =' . singleQuote($record['PRAT_PRODUCT_CODE']) . ' AND PRAT.PROD_STATUS <> ' . singleQuote($record['PRAT_PROD_STATUS']) . ' AND PRAT.' . $val . ' = ' . singleQuote($record['PRAT_' . $val]);
			 if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
			     $msg['PRAT_' . $val] = smsg('MSG-169');
			 }
		  }
        }
    }

    /**
     * Return current product parameters
     *
     * @param string $product_code
     * @param string $prod_status
     * @return array
     */
    function get_parameters($product_code, $prod_status = 'VIG') {
        $sql = 'SELECT * FROM ' . $this->pratname . ' WHERE PRODUCT_CODE = ' . singleQuote($product_code) . ' AND PROD_STATUS = ' . "'VIG'";
        return ClxCommon::$db->getOneRecord($sql);
    }

}
