<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-08 15:44:29 -0400 (Thu, 08 Oct 2015) $
 * @version        $Rev: 7192 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Stoc {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function validate_form(&$record, &$msg) {
        if (!empty($record['STOC_ISIN']) && !clx_isin($record['STOC_ISIN'])) {
		  $msg['STOC_ISIN'] = smsg('MSG-341');
        }
    }

    /**
     * Interfaz clx5100ds
     */
    function run_clx5100ds() {
        $contenidoHTML = '';
        $EBSK = &getTool('EBSK');
        $EBSK->debug = false;
        //search prices for all products.
        $sql = 'SELECT  DISTINCT STOC.ISIN  FROM  BASE_STOCK_QUOTES STOC WHERE  STOC.ISIN IS NOT null AND STOC.STATUS = ' . singleQuote('A') . ' AND CLX_EFFTDATE = (SELECT MAX(STOCX.CLX_EFFTDATE) FROM BASE_STOCK_QUOTES STOCX WHERE STOCX.IDCODE = STOC.IDCODE AND STOCX.CLX_EFFTDATE<=NOW())';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($prmt = ClxCommon::$db->getNextRecord($rs)) {
		  //Parametro es ISIN
		  $contenidoHTML.= '<br>Procesando: ' . $prmt['ISIN'] . ', Resultado:';
		  if (empty($prmt['ISIN'])) {
			 $contenidoHTML.= ' Producto sin codigo ISIN';
			 continue;
		  }
		  $response = $EBSK->sendMessage('CLX5100DS', $prmt, 'LOAD');
		  if (!empty($response[CLX_NUM_ZERO]['HEADERMSG']['ERRNUM'])) {
			 $contenidoHTML.= ' No encontrado';
		  } else {
			 $contenidoHTML.= ' Actualizado';
		  }
        }
        echoLog($contenidoHTML);
    }

}
