<?php
require 'includes/constants.php';
require 'includes/includes.php';
PrepareConstants();
ConnectToDatabase();
initTools();
$ceme = UserRequest::getRequestField('ceme', FILTER_SANITIZE_NUMBER_INT);
$tg = UserRequest::getRequestField('tg', FILTER_SANITIZE_STRING);
$tgty = UserRequest::getRequestField('tgty', FILTER_SANITIZE_NUMBER_INT);
$now = date('Y-m-d h:i:s');
if(empty($ceme) || empty($tg)) 
    exit();
if(!is_numeric($ceme)) 
    $ceme = CLX_NUM_ZERO;
else 
    $ceme = intval($ceme);
$tg = str_replace('"','',$tg);
$tg = str_replace('\'','',$tg);
$tg = str_replace(';','',$tg);
// Hace autocommit desde el principio para evitar los Dead Locks
ClxCommon::$db->setAutocommit(true);
// Actualiza el status de 'Leido' en los registros del correo específico
// Tabla CEMR
$sql = 'UPDATE MARK_CAMPSEC_EMAIL_RES SET RESULT_CODE=' . singleQuote('READ') . ' WHERE CEME_ID=' . $ceme . ' AND EMAIL=' . singleQuote($tg);
ClxCommon::$db->executeQuery($sql);
// Tabla EMAIL
$sql = 'UPDATE BASE_EMAIL SET RECEIVED_DATE=' . singleQuote($now) . ', EMAIL_STATUS=' . singleQuote('READ') . ' WHERE CEME_ID=' . $ceme . ' AND TO_EMAIL=' . singleQuote($tg);
ClxCommon::$db->executeQuery($sql);
// Se separa el conteo de correos leidos del UPDATE en la tabla MARK_CAMPSEC_EMAIL_EXE para minimizar la posibilidad de Dead Lock
$sql = 'SELECT IFNULL(COUNT(CEMR.ID),0) FROM MARK_CAMPSEC_EMAIL_RES CEMR WHERE CEMR.CEME_ID=' . $ceme . ' AND CEMR.RESULT_CODE=' . singleQuote('READ');
$total_read = ClxCommon::$db->getOne($sql);
$sql = 'UPDATE MARK_CAMPSEC_EMAIL_EXE CEME SET CEME.TOTAL_READ='.$total_read.' WHERE CEME.ID='.$ceme;
ClxCommon::$db->executeQuery($sql);
// Optout
$contenidoHTML = '';
if (!empty($tgty) && $tgty == CLX_NUM_ONE) {
    $record = array('EMAIL' => $tg, 'PHONE' => '', 'ACCOUNTCODE' => '', 'CONTACTID' => CLX_NUM_ZERO, 'CDATE' => $now);
    if (ClxCommon::$db->oneExistsRecords('MARK_CAMPSEC_EXCLUSIONS', 'EMAIL = ' . singleQuote($tg)) == CLX_NUM_ZERO) {
        ClxCommon::$db->createRecord('MARK_CAMPSEC_EXCLUSIONS', $record, false);
    }
    $contenidoHTML.='<html><head></head><body>Email removed / Correo electrónico removido</body></html>';
}
if (empty($tgty)) {
    header('Content-type: image/gif');
    $filename = kPathToWebSite . '/includes/email_tracer.gif';
    $fd = fopen($filename, 'r');
    $contenidoHTML.= fread($fd, filesize($filename));
    fclose($fd);
}
echo $contenidoHTML;
