<?php


/**
 * Funnel Graphic Object
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */

 if (!class_exists('Graphics') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'graphic.php';

class Graphic_fc2funnel extends Graphic {

    var $operators;

    /**
     * CONSTRUCTOR
     */
    function __construct() {
        $this->code = 'GPFE';
        $this->name = 'Single Series - Graphics Funnel';
		$this->GraphicType='funnel';
        $this->type = 'GXPL';
        $this->version = '1.0.0.1';
        $this->description = 'The Clientix - Funnel Graphic';
        $this->graphicsfile = 'Graphic_fc2funnel.php';
        $this->has_range = false;
        $this->serie_types = array('VAL' => dict('GEN_LABEL_VALUE'), 'CAT' => dict('GEN_LABEL_CATEGORY'), 'XAXI' => dict('GEN_LABEL_XAXIS'), 'YAXI' => dict('GEN_LABEL_YAXIS'));
		
    }

    /**
     * The following procedures are intented to be used by the Database
     * Administrator to interface with the user when creating new fields in the database.
     */
    function panel($msg, $graphicsrecord, &$form) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

	function html5graphics($graphicsrec,$record) {
	//	PRE($graphicsrec);
		$GXTcolors=GXTcolorgraphics ();
		IF (isset(UserRequest::$request['graphicsconfig'])) {	echo $this->GraphicsType;
		}	
		$arrChartConfig = array(
			'chart' => array(
				//		caption and subcaption
			'caption' => dict($record['ANGM_title'])
		
			,'subCaption' => dict($record['ANGM_subtitle'])
				//  	 ,"subcaptionFontColor": "#993300"
      
				//		,"subcaptionFontBold": "0"
		
				//,"alignCaptionWithCanvas": "1"
				//,"captionHorizontalPadding": "2"
				//,"captionOnTop": "0"
				//,"captionAlignment": "right"
		
					// parece que gira automaticamente el teGXTo de los subtitulos y barras
		,	'showBorder'=> $graphicsrec['BORDER']
		
		,	'decimals'=> '1'
        ,	'isHollow'=> '1'
        ,	'labelDistance'=> '15'
        ,	'is2D'=> '1'
        ,	'graphicsToolteGXT'=> 'Success : $percentOfPrevValue'
        ,	'showPercentValues'=> '1'		
		
		
		,   'labelDisplay'=> 'Auto'
		,	'useEllipsesWhenOverflow'=> '0'
		
		/* 
		
		fusion,gammel,candy,zune,ocean,carbon,umber
		
		*/
		
		
				//		axes
		,	'xAxisName' => dict($graphicsrec['XLABEL'])
				//	,"xAxisPosition": "right"			
		,	'yAxisName' => dict($graphicsrec['YLABEL'])
				//	,"yAxisPosition": "right"
		,	'numberSuffix' => ''   //tipo de unidad
		
				//		,"xAxisNameFont": "Arial"
				//		,"xAxisNameFontSize": "12"
				//		,"xAxisNameFontColor": "#993300"
				//		,"xAxisNameFontBold": "1"
				//		,"xAxisNameFontItalic": "1"
		
				//     bordes en los subtitulos de grupo de  barra
				//		,"xAxisNameBorderColor": "#6666FF"
				//		,"xAxisNameBorderAlpha": "50"
				//		,"xAxisNameBorderPadding": "6"
				//		,"xAxisNameBorderRadius": "3"
				//		,"xAxisNameBorderThickness": "2"
				//		,"xAxisNameBorderDashed": "1"
				//		,"xAxisNameBorderDashLen": "4"
				//		,"xAxisNameBorderDashGap": "2"

					//		,"yAxisNameBorderColor": "#6666FF"
					//		,"yAxisNameBorderAlpha": "50"
					//		,"yAxisNameBorderPadding": "6"
					//		,"yAxisNameBorderRadius": "3"
					//		,"yAxisNameBorderThickness": "2"
					//		,"yAxisNameBorderDashed": "1"
					//		,"yAxisNameBorderDashLen": "4"
					//		,"yAxisNameBorderDashGap": "2"

					// colores de subtitulos grupo de barras colores transparentes
					//	,"xAxisNameFont": "Arial"
					//	,"xAxisNameFontSize": "14"
					//	,"xAxisNameBgColor": "#3399ff"
					//	,"xAxisNameBgAlpha": "20"
					//	,"xAxisNameFontAlpha": "50"
					//	,"xAxisNameBorderPadding": "10"


					//	,"yAxisNameFont": "Arial"
					//	,"yAxisNameFontSize": "14"
					//	,"yAxisNameBgColor": "#3399ff"
					//	,"yAxisNameBgAlpha": "20"
					//	,"yAxisNameFontAlpha": "50"
					//	,"yAxisNameBorderPadding": "10"

					//	colores de subtitulos de barras
					//	,"yAxisValueBgColor": "#ff0000"
					//	,"yAxisValueBgAlpha": "40"

					//subtitulos de barras cuadro
					//	,"yAxisValueBorderColor": "#ff0000"
					//	,"yAxisValueBorderAlpha": "60"
					//	,"yAxisValueBorderPadding": "5"
					//	,"yAxisValueBorderRadius": "2"
					//	,"yAxisValueBorderThickness": "3"
					//	,"yAxisValueBorderDashed": "1"
					//	,"yAxisValueBorderDashLen": "2"
					//	,"yAxisValueBorderDashGap": "2"

					//	subtitulos de barras colores font
					//,	"yAxisValueFont": "verdana,sans"
					//,	"yAxisValueFontSize": "10px"
					//,	"yAxisValueFontColor": "#ff0000"
					//,	"yAxisValueFontBold": "1"
					//,	"yAxisValueFontItalic": "1"
					//,	"yAxisValueAlpha": "50"

					//	scroll muchas barras
					//,  "scrollPosition": "top"
					,'theme' => lowercase($graphicsrec['GRAPHIC_THEME'])
				// border		
				//,		"showBorder": "1"
				//,		"showgraphicsBorder": "0"
				
				// drawareaborder parece servir para colorear parte entre 2 areas para que
				// rellene hasta abajo
				
				//,"drawFullAreaBorder": "0"

				// canvas
				//,	"canvasbgColor": "#1790e1"
				//,	"canvasbgAlpha": "10"
				//,	"canvasBorderThickness": "1"
				//,	"showAlternateHGridColor": "0"
				//,	"bgColor": "#eeeeee"
				
				//, gradiente
				//,	"usegraphicsGradientColor": "1"
				
				//,	gradientcolor
				//,  "usegraphicsGradientColor": "1"
				//,"graphicsGradientColor": "#003366"
				//,"graphicsFillAngle": "0"
				//,"plotFillAlpha": "60"
				//,"plotFillRatio": "90,100"
				
				//  ,"showPlotBorder": "1"
				//	,"plotBorderDashed": "1"
				//	,"plotBorderDashLen": "4"
				//	,"plotBorderDashGap": "4"
				//	,"plotBorderThickness": "1"
				//	,"plotBorderColor": "#000000"
		
		
		
		//  da un grediente que decoloea un lado para indicar que esta mas iluminado
		//   ,"useRoundEdges": "1"
		
		// mouse over canvio de color
		//	  ,"plotHoverEffect": "1"
		//	  ,"plotFillHoverColor": "#00ffaa"
		//	  ,"plotBorderHoverThickness": "1"
		//	  ,"plotBorderHoverDashed": "1"
		//	  ,"plotBorderHoverDashLen": "6"
		//	  ,"plotBorderHoverDashGap": "2"
			
		// mouse over cambio de color tranparencia
		//	,"HoverColor": "1"
		//	,"HoverAlpha": "1"
		
		
		
		
			)
		);
		if ( !empty($graphicsrec['GRAPHIC_THEME_COLOR']) &&$graphicsrec['GRAPHIC_THEME_COLOR']<>'default' ) {
//			pre($graphicsrec);
			$arrChartConfig['chart']['palettecolors']= $GXTcolors[$graphicsrec['GRAPHIC_THEME_COLOR']];
		}
		if ($graphicsrec['ROTATE_NAMES']==1) {
			$arrChartConfig['chart']['labelDisplay']= 'rotate';
		}
		// An array of hash objects which stores data
	//	$this->getData($record['ANGM_idcode']);
		$values_graphics=$this->buildArray($graphicsrec);	
		//$contadorcolor=0;
		$arrLabelValueData=array();
		
		foreach($values_graphics['sourceData']as $keygraphics=>$valuegraphics) {
			IF (ISSET($valuegraphics[0]['val'])&ISSET($valuegraphics[1]['val'])) {
				if ($valuegraphics[0]['type']=='CAT') {
					
					$arrLabelValueData[]= array(
						"label" => $valuegraphics[0]['val'], "value" => $valuegraphics[1]['val']);
				}
				else {
					$arrLabelValueData[]= array(
						"label" => $valuegraphics[1]['val'], "value" => $valuegraphics[0]['val']);
				
				}
			}
			//pathern  presentacion de barras cuadritos, inclinado
			// pathern presentacion de relleno de barras por ejemplo
			//,"patternType": "square"
			//,"patternBgColor": "#1122ee"
			//,"patternSize": 2
			//,"patternDensity": 8

			// dash
			//",Dashed": "1"
			//",DashLen": "4"
			//",DashGap": "4"

		
		}
		$arrChartConfig['data'] = $arrLabelValueData;


  
		// JSON Encode the data to retrieve the string containing the JSON representation of the data in the array.
		$jsonEncodedData = json_encode($arrChartConfig);

		// chart object
		$h	= $record['ANGM_hsize'];
		$v	= $record['ANGM_vsize'];
		IF (isset(UserRequest::$request['graphicconfig'])) {
			if ($h>400)
				$h=400;
			if ($v>290)
				$v=290;
		}
		
	
		

		$Chart = new FusionCharts($this->GraphicType, $record["ANGM_idname"] ,$h, $v, 'chart-container', 'json', $jsonEncodedData);

		// Render the chart
		$Chart->render();
		echo '
			<script>
			FusionCharts.options.license({
				key: \'0oI2cB-21A-16E2D6E2A4G3E3A2C4D4C7A3B4pckH3B5ljf1B-9kC4D2bvgE3A3B2E4C3F3I3B4D6E5E3A3A2G4A19A32vikC6D3G4kD3H4A9B-21B-16tE3D4A2rveA4D4E2vnjH1B3C2A4C5A3E4B2G4E3C3megB5B2VD3isbD5D1B2sbE2EI2A3C-16xiC1A4B4E2F2C6B3A5B2D2E4B1C1G3q==\',
				creditLabel: false,
			});
			</script>
			<center>
				<div id="chart-container">Chart will render here!</div>
			</center>
		';

	

	
	
	
	}

}

