<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 * @package		Clientix.Tool.Event
 * @abstract		System Events Manager - General Event type.
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 * 2005/07/05 Oracle uppercase record changed
 * 2009/04/06 Included label
 */
class actn extends clx_object {

    /**
     * Initialices when library is loaded to prevents codelib multiple includes
     * @var array
     */
    public $loadedlibraries;
    public $debug = false;
    public $code = '';
    public $name = '';
    public $type = '';
    public $version = '1.0.0';
    public $description = '';
    /**
     * Set to true if action requires user wait
     * @var unknown_type
     */
    protected $bp_req_user_wait = false;

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'ACTN';
        $this->name = 'Table Action Generic Object';
        $this->type = '----';
        $this->version = '0.2.0.0';
        $this->description = 'Table Action Generic Object';
    }

    /**
     * Build code object panel on edit event.
     * @param array $msg
     * @param array $actionrecord
     * @return string
     */
    function panel($msg, $actionrecord) {
        if ($this->debug) {
		  pre($msg);
		  pre($actionrecord);
        }
        return '';
    }

    /**
     * Validate Panel User Input before saving record.
     * @param array $msg
     */
    function checkPanel(&$msg) {

    }

    /**
     * Build object record from user post
     * @param array $actionrecord
     */
    function getPanel(&$actionrecord) {

    }

    /**
     * Sets edit record required on forms of user interface.
     * @param array $actionrecord
     * @param array $values
     */
    function setPanel(&$actionrecord, $values) {

    }

    /**
     * Sets the default values for form on create event.
     * @param array $actionrecord
     */
    function defaultPanel(&$actionrecord) {

    }

    /**
     * Build panel for display form
     * @param obj $table
     * @param array $record
     */
    function viewForm_2(&$table, $record) {

    }

    /**
     * Builds description about the object on event panel listing.
     * @param array $record
     * @return string
     */
    function describe($record) {
        return CLX_CHAR_EMPTY_STRING;
    }

    /**
     * Verify if code library exists
     * @param string $libcode
     * @return bool
     */
    function libExists($libcode) {
        return (ClxCommon::$db->oneExistsRecords('CLX_CODELIB', 'IDCODE=' . singleQuote($libcode)) == CLX_NUM_ZERO) ? false : true;
    }

    /**
     * Execute code according object type.
     * @param string $event
     * @param array $record
     * @param array $msg
     */
    function execute3($event, &$record, &$msg) {IF (ISSET($GLOBALS['ADDRDEBUGEVENTS'])) { echo __METHOD__.' '. __FILE__ .':'.__LINE__; pre($event);pre($record); }

    }

    /**
     * Process step execution according object type.
     * @param string $event
     * @param array $record
     * @param array $parameters
     * @param array $msg
     * @param bool $debug
     * @return mixed
     */
    function execute_process_event($event, &$record, &$parameters, &$msg, $debug = false) {
        return $this->execute3($event, $record, $msg);
    }

    /**
     * Traslate step vars into actual values prior execution.
     * Only values found will ve translated other will remain.
     * @param string $code
     * @param array $record
     * @param array $parameters
     */
    function prepare_process_code($code, &$record, &$parameters) {
        return $code;
    }

    /**
     * Executes Business Process Event
     * @param string $event
     * @param array $record
     * @param array $parameters
     * @param array $msg
     * @param bool $debug
     * @return mixed
     */
    function execute_bp_event($event, &$record, &$msg, $debug = false) {
        return $this->execute3($event, $record, $msg);
    }

    function execute_bp_manual_event($event, &$record, &$msg, $debug = false) {
        return true;
    }

    /**
     * Sets user wait
     * @param boolean $status
     */
    function set_bp_req_user_wait($status) {
        $this->bp_req_user_wait = (bool) $status;
    }

    /**
     * Gets user wait
     * @return boolean
     */
    function get_bp_req_user_wait() {
        return $this->bp_req_user_wait;
    }
	
}
