<?php

/**
 * Decimal field object class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * Change log
 *  Added Oracle on field properties
 *
 */
if (!class_exists('dbft') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'dbft.php';

class dbft_decimal extends dbft {

    // CONSTRUCTOR //
    var $align;
    var $yesno;
    var $display_type;
    //   - BEGIN
    // Caso 1002874 - GB-Neg con PARENTESIS y signo MENOS
    var $neg_num_parentesis = true;

    //   - END
    function __construct() {
        $this->code = 'DECN';
        $this->name = 'Decimal Number';
        $this->type = 'DBFT';
        $this->version = '0.4.5.1';
        $this->description = 'Can somebody place a nice description here?';
        $this->multifield = false; // Describes it field is a multi field see properties;
        $this->has_lookup = true; // Decribes if field can be set as copy field on lookup
        $this->has_question = true; // Describes if field can be used on queries criteria
        $this->operators = array('===' => 'GEN_LBL_EQUALTO', '!== ' => 'GEN_LBL_NOTEQUALTO', '>' => 'GEN_LBL_GREATERTHAN', '>=' => 'GEN_LBL_GREATERTHANOREQUEALTO', '<=' => 'GEN_LBL_LESSTHANOREQUALTO', '<' => 'GEN_LBL_LESSTHAN');
    	IF (ISSET($GLOBALS['ADDRDEBUGEDIT']) && $GLOBALS['ADDRDEBUGEDIT']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}

    }

    function panel($msg, $fieldrecord, &$form) {
        $c = $this->code;
        if ($fieldrecord['DBFL_fieldtype'] != $c) {
		  $this->defaultPanel($fieldrecord);
        }
        $this->yesno = array(CLX_NUM_ZERO => dict('GEN_LBL_NO'), CLX_NUM_ONE => dict('GEN_LBL_YES'));
        $this->align = array(CLX_NUM_ZERO => dict('GEN_LBL_LEFT'), CLX_NUM_ONE => dict('GEN_LBL_CENTER'), CLX_NUM_TWO => dict('GEN_LBL_RIGHT'));
        $this->display_type = array(CLX_NUM_ZERO => dict('GEN_LBL_NUMBER'), CLX_NUM_ONE => dict('GEN_LBL_CURRENCY'));
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_DECFIELDPROP'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $sel = new htmlSelect($c . '_required');
        foreach ($this->yesno as $key => $val) {
		  $sel->addItem($val, $key, ($fieldrecord[$c . '_required'] == $key));
        }
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $sel->source());
        $table->addField($msg, dict('GEN_LBL_FORMAT') . ':', $c . '_format', $fieldrecord[$c . '_format'], CLX_NUM_16, CLX_NUM_16);
        $sel = new htmlSelect($c . '_align');
        foreach ($this->align as $key => $val) {
		  $sel->addItem($val, $key, ($fieldrecord[$c . '_align'] == $key));
        }
        $table->addData(dict('GEN_LBL_ALIGN') . ':', $sel->source());
        $table->addField($msg, dict('GEN_LBL_DEFAULT') . ':', $c . '_default', $fieldrecord[$c . '_default'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_MIN') . ':', $c . '_minvalue', $fieldrecord[$c . '_minvalue'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_MAX') . ':', $c . '_maxvalue', $fieldrecord[$c . '_maxvalue'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_DISPLAY_SIZE') . ':', $c . '_displaysize', $fieldrecord[$c . '_displaysize'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $sel = new htmlSelect($c . '_extra1');
        foreach ($this->display_type as $key => $val) {
		  $sel->addItem($val, $key, ($fieldrecord[$c . '_extra1'] == $key));
        }
        $table->addData(dict('GEN_LBL_DISPLAY_FORMAT') . ':', $sel->source());
        $table->addField($msg, dict('GEN_LBL_DISPLAY_DECIMALS') . ':', $c . '_extra2', $fieldrecord[$c . '_extra2'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function checkPanel(&$msg) {
        $c = $this->code;
        $def = UserRequest::$post[$c . '_default'];
        $min = UserRequest::$post[$c . '_minvalue'];
        $max = UserRequest::$post[$c . '_maxvalue'];
        $for = UserRequest::$post[$c . '_format'];
        if (strlen($def) != CLX_NUM_ZERO) {
		  xValidate::float($msg, $c . '_default', $def, $min, $max, 'default value');
        }
        if (strlen($min) != CLX_NUM_ZERO) {
		  xValidate::float($msg, $c . '_minvalue', $min, '', $max, 'minimum value');
        }
        if (strlen($max) != CLX_NUM_ZERO) {
		  xValidate::float($msg, $c . '_maxvalue', $max, $min, '', 'maximum value');
        }
        xValidate::integer($msg, $c . '_displaysize', UserRequest::$post[$c . '_displaysize'], CLX_NUM_TWO, CLX_NUM_255, 'default size');
        //GEN_ERR_INTLESSORSAMEDEC
        //For decimal(M,D), M must be >= D
        //Para decimales(M,D), M debe ser mayor que D
        if (strpos($for, ',') !== false) {
		  $format = explode(',', $for);
		  if ($format[CLX_NUM_ZERO] < $format[CLX_NUM_ONE]) {
			 $msg[$c . '_format'] = dict('GEN_ERR_INTLESSORSAMEDEC');
		  }
        }
        if (!empty(UserRequest::$post[$c . '_required'])) {
		  xValidate::required($msg, $c . '_default', UserRequest::$post[$c . '_default']);
        }
    }

    function savePanel(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord['FIELD_SIZE'] = (!empty(UserRequest::$post['DBFL_fielddisplaysize'])) ? UserRequest::$post['DBFL_fielddisplaysize'] : CLX_NUM_ZERO;
        $fieldrecord['FIELD_REQUIRED'] = UserRequest::$post[$c . '_required'];
        $fieldrecord['FIELD_FORMAT'] = UserRequest::$post[$c . '_format'];
        $fieldrecord['FIELD_ALIGN'] = UserRequest::$post[$c . '_align'];
        $fieldrecord['FIELD_DEFAULT'] = UserRequest::$post[$c . '_default'];
        $fieldrecord['FIELD_MINVALUE'] = UserRequest::$post[$c . '_minvalue'];
        $fieldrecord['FIELD_MAXVALUE'] = UserRequest::$post[$c . '_maxvalue'];
        $fieldrecord['FIELD_DISPLAYSIZE'] = UserRequest::$post[$c . '_displaysize'];
        $fieldrecord['FIELD_EXTRA1'] = UserRequest::$post[$c . '_extra1'];
        $fieldrecord['FIELD_EXTRA2'] = UserRequest::$post[$c . '_extra2'];
        $fieldrecord['FIELD_EXTRA3'] = '';
        $fieldrecord['FIELD_EXTRA4'] = '';
        $fieldrecord['FIELD_EXTRA5'] = '';
    }

    function loadPanel(&$fieldrecord, $values) {
        $c = $this->code;
        if ($values['FIELDTYPE'] == $c) {
		  $fieldrecord[$c . '_required'] = $values['FIELD_REQUIRED'];
		  $fieldrecord[$c . '_format'] = $values['FIELD_FORMAT'];
		  $fieldrecord[$c . '_align'] = $values['FIELD_ALIGN'];
		  $fieldrecord[$c . '_default'] = $values['FIELD_DEFAULT'];
		  $fieldrecord[$c . '_minvalue'] = $values['FIELD_MINVALUE'];
		  $fieldrecord[$c . '_maxvalue'] = $values['FIELD_MAXVALUE'];
		  $fieldrecord[$c . '_displaysize'] = $values['FIELD_DISPLAYSIZE'];
		  $fieldrecord[$c . '_extra1'] = $values['FIELD_EXTRA1'];
		  $fieldrecord[$c . '_extra2'] = $values['FIELD_EXTRA2'];
        } else {
		  $this->defaultPanel($fieldrecord);
        }
    }

    function defaultPanel(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord[$c . '_size'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_required'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_format'] = '10,2';
        $fieldrecord[$c . '_align'] = CLX_NUM_TWO;
        $fieldrecord[$c . '_default'] = '0.00';
        $fieldrecord[$c . '_minvalue'] = '0.00';
        $fieldrecord[$c . '_maxvalue'] = '100.00';
        $fieldrecord[$c . '_displaysize'] = '20';
        $fieldrecord[$c . '_extra1'] = '0';
        $fieldrecord[$c . '_extra2'] = '2';
        $fieldrecord[$c . '_extra3'] = '';
        $fieldrecord[$c . '_extra4'] = '';
        $fieldrecord[$c . '_extra5'] = '';
    }

    function viewForm(&$table, $record) {
        $this->yesno = array(CLX_NUM_ZERO => dict('GEN_LBL_NO'), CLX_NUM_ONE => dict('GEN_LBL_YES'));
        $this->align = array(CLX_NUM_ZERO => dict('GEN_LBL_LEFT'), CLX_NUM_ONE => dict('GEN_LBL_CENTER'), CLX_NUM_TWO => dict('GEN_LBL_RIGHT'));
        $this->display_type = array(CLX_NUM_ZERO => dict('GEN_LBL_NUMBER'), CLX_NUM_ONE => dict('GEN_LBL_CURRENCY'));
        $table->addData(dict('GEN_LBL_TYPE') . ':', $this->name);
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $this->yesno[$record['DECN_required']]);
        $table->addData(dict('GEN_LBL_FORMAT') . ':', $record['DECN_format']);
        $table->addData(dict('GEN_LBL_ALIGN') . ':', $this->align[$record['DECN_align']]);
        $table->addData(dict('GEN_LBL_DEFAULT') . ':', $record['DECN_default']);
        $table->addData(dict('GEN_LBL_MIN') . ':', $record['DECN_minvalue']);
        $table->addData(dict('GEN_LBL_MAX') . ':', $record['DECN_maxvalue']);
        $table->addData(dict('GEN_LBL_DISPLAY_SIZE') . ':', $record['DECN_displaysize']);
        $table->addData(dict('GEN_LBL_DISPLAY_FORMAT') . ':', $record['DECN_extra1']);
        $table->addData(dict('GEN_LBL_DISPLAY_DECIMALS') . ':', $record['DECN_extra2']);
    }

    function placeEditField($msg, $form_fieldname, $fieldrecord, $record, &$form, $jsevents) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        //Setting form field requirement if any diferent than table default
        if ($fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
		  $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
        }
        if (!empty($fieldrecord['FIELD_HIDDEN'])) {
		  $form->addArgument($form_fieldname, (array_key_exists($form_fieldname, $record)) ? $record[$form_fieldname] : '');
		  if (empty($fieldrecord['FIELD_HIDDEN'])) {
			 $table = $this->placeViewField($form_fieldname, $fieldrecord, $record, $msg);
		  }
        } else {
		  $cpt = dict($fieldrecord['CAPTION']);
		  if (strlen($cpt) > CLX_NUM_ZERO) {
			 $table->addCell($cpt, array(CLX_PROP_CLASS => $fieldrecord['CAPTION_CLASS'], CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		  }
		  if (isset($msg[$form_fieldname])) {
			 $table->addCell($msg[$form_fieldname], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		  }
		  $fieldobj = $this->fieldObject($form_fieldname, $fieldrecord, $record);
		  foreach ($jsevents as $key => $value) {
			 $fieldobj->setProp($key, $value);
		  }
		  $pfx = dict($fieldrecord['FIELDPREFIX']);
		  $fieldsource = (strlen($pfx) > CLX_NUM_ZERO) ? $pfx : '';
		  $fieldsource .= $fieldobj->source();
		  $sfx = dict($fieldrecord['FIELDSUFIX']);
		  $fieldsource .= (strlen($sfx) > CLX_NUM_ZERO) ? $sfx : '';
		  $class = ($fieldrecord['FIELD_REQUIRED']) ? CLX_CLASS_PROMPTREQUIRED : CLX_CLASS_PROMPT;
		  //Added to Display Date Format
		  $fieldlabel = dict($fieldrecord['FIELDFORMLABEL']);
		  $table->addCell($fieldlabel, array(CLX_PROP_CLASS => $class));
		  if (empty($fieldrecord['FIELD_READONLY'])) {
			 $pickercode = '$(function () {$(' . singleQuote('#' . $form_fieldname) . ').calculator({showOn:' . singleQuote('button') . ' , buttonImageOnly: true, constrainInput: false, precision:' . $fieldrecord['FIELD_EXTRA2'] . ', onClose: function(value, inst) {$(' . singleQuote('#' . $form_fieldname) . ').trigger(' . singleQuote('change') . ');}, buttonImage: ' . singleQuote(kPathToExtLibJs . 'jquery/jquery_calculator/calculator.png') . ', duration:' . singleQuote('fast') . '});});';
			 $fieldsource .=CLX_CHAR_NL . setJavaScriptTag($pickercode, false);
		  }
		  if (array_key_exists('SRCH_LISTING', $fieldrecord) && $fieldrecord['SRCH_LISTING'] <> '') {
                $fieldsource .= getSkinIcon('view', 'javascript:formToCookie(' . singleQuote('theForm') . ');openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=EDIT&nofr=1&pfid=' . $fieldrecord['PFID'] . '&ac=POPLIST&li=' . $fieldrecord['SRCH_LISTING']) . ',700, 400,null,'.singlequote($form_fieldname).','.singlequote( __FILE__ .'_'. __LINE__ ) .');', dict('GEN_LBL_SEARCH'));
		  }
		  $table->addCell($fieldsource, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
			if ( $this->debug==true ) {
				$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");
				fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."dbft_decimal-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
				$te=debug_backtrace();
				for ($t=0;$t<12;$t++) {
					if (isset($te[$t]["file"]))
						fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
					
				}

				fwrite($tta,chr(13).chr(10)."placeListFieldText: ".print_r($fieldsource,true));
				fclose($tta);
				if (!isset($GLOBALS['placelistcount']))
					$GLOBALS['placelistcount']=1;
				else
					$GLOBALS['placelistcount']++;
			}
        }
        return $table;
    }

    /**
     * Build session key for filters
     */
    function setQuickFilters($tablecode, $fieldname, $fieldrecord, $record) {
		if ( $this->debug==true ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora inicio de funcion read excel ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}

        $criteria = '';
        if (array_key_exists($tablecode . '_' . $fieldname, $record) && strlen($record[$tablecode . '_' . $fieldname]) > CLX_NUM_ZERO) {
		  if (is_numeric($record[$tablecode . '_' . $fieldname])) {
			 $criteria = $tablecode . '.' . $fieldname . ' = ' . $record[$tablecode . '_' . $fieldname];
		  }
        }
        return $criteria;
    }

    function fieldProperties($fieldrecord) {
        $props = array();
        // DB implementation
        switch (kDatabaseType) {
		  case 'oci':
			 $props['type'] = 'NUMBER(' . $fieldrecord['FIELD_FORMAT'] . ')';
			 break;
		  default:
			 $props['type'] = 'DECIMAL(' . $fieldrecord['FIELD_FORMAT'] . ')';
			 break;
        }
        if ($fieldrecord['FIELD_DEFAULT'] === 'null' || strlen($fieldrecord['FIELD_DEFAULT']) == CLX_NUM_ZERO) {
		  $props['default'] = 'null';
        } else {
		  $props['default'] = $fieldrecord['FIELD_DEFAULT'];
        }
        $props['properties'] = '';
        $props['null'] = ($fieldrecord['FIELD_REQUIRED']) ? 'NO' : 'YES';
        return $props;
    }

    function fieldObject(&$form_fieldname, &$fieldrecord, $record) {
        //Alignment
        switch ($fieldrecord['FIELD_ALIGN']) {
		  case CLX_NUM_ONE:
			 $align = 'text-align: center;';
			 break;
		  case CLX_NUM_TWO:
			 $align = 'text-align: right;right';
			 break;
		  default:
			 $align = 'text-align: left;';
			 break;
        }




        if ($fieldrecord['FIELD_EXTRA2'] <> '') {
		  $dc = $fieldrecord['FIELD_EXTRA2'];
        } elseif (($comma_post = strpos($fieldrecord['FIELD_FORMAT'], ',')) > CLX_NUM_ZERO) {
		  $dc = substr($fieldrecord['FIELD_FORMAT'], $comma_post + CLX_NUM_ONE, (strlen($fieldrecord['FIELD_FORMAT']) - $comma_post));
        } else {
		  $dc = CLX_INIT_ZERO;
        }
        if (array_key_exists($form_fieldname, $record)) {
		  //capture filter options to prevent default values
		  if (array_key_exists($form_fieldname . '_operator', $record) && array_key_exists($form_fieldname . '_boolean', $record)) {
			 //En filtros no es necesario colocar 0
		  } else {
			 if ($record[$form_fieldname] === '') {
			     $record[$form_fieldname] = $fieldrecord['FIELD_DEFAULT'];
			 }
		  }
		  if ($record[$form_fieldname] === '') {
			 $value = '';
		  } else {
			 /*if (strpos($fieldrecord['FIELD_FORMAT'], ',') === false) {
			     $value = rounder($record[$form_fieldname], $dc);
			 } else {
			     $value = rounder($record[$form_fieldname], $dc);
			 }*/
			 $value = rounder($record[$form_fieldname], $dc);
		  }
        } else {
		  if ($fieldrecord['FIELD_DEFAULT'] === '') {
			 $value = '';
		  } else {
			 $value = rounder($fieldrecord['FIELD_DEFAULT'], $dc);
		  }
        }

        $size = (!empty($fieldrecord['FIELD_DISPLAYSIZE'])) ? $fieldrecord['FIELD_DISPLAYSIZE'] : $fieldrecord['FIELD_DB_DISPLAYSIZE'];
        if (!empty($fieldrecord['FIELD_FORMAT'])) {
		  if (strpos($fieldrecord['FIELD_FORMAT'], ',') !== false) {
			 $fieldrecord['FIELD_FORMAT'] = explode(',', $fieldrecord['FIELD_FORMAT']);
			 $maxlength = $fieldrecord['FIELD_FORMAT'][CLX_NUM_ZERO] + $fieldrecord['FIELD_FORMAT'][CLX_NUM_ONE] + CLX_NUM_TWO; //integers+decimals+sign and dot
		  } else {
			 $maxlength = $fieldrecord['FIELD_FORMAT'];
		  }
        } else {
		  $maxlength = '';
        }


        $fieldobj = new htmlField($form_fieldname, $value, $size, $maxlength);
        $fieldobj->setProp('style', $align);
        //Added instead of displaying read only files
        if (!empty($fieldrecord['FIELD_READONLY'])) {
		  $fieldobj->setProp('readonly', 'true');
		  $fieldobj->setProp(CLX_PROP_CLASS, 'readonly');
        }
        return $fieldobj;
    }

    function validateField(&$msg, $form_fieldname, $fieldrecord, &$record, &$table, &$form) {
        //Setting form require pref if any
        if (array_key_exists('FIELD_FORM_REQUIRED', $fieldrecord) && $fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
		  $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
        }
        // Note: !array_key_exists was added to enable lookups to validate
        if (!array_key_exists('FIELD_HIDDEN', $fieldrecord)) {
		  $fieldrecord['FIELD_HIDDEN'] = false;
        }
        if (empty($fieldrecord['FIELD_HIDDEN'])) {
		  if (UserRequest::$request['ac']!='DELETE' &&!empty($record[$form_fieldname]) || $fieldrecord['FIELD_REQUIRED']) {
			 $maxdim = ClxCommon::$db->getMaxNumberFromDimension($fieldrecord['FIELD_FORMAT']);
			 $mimdim = bcmul($maxdim, '-1');
			 if (empty($fieldrecord['FIELD_MAXVALUE']) || $maxdim < $fieldrecord['FIELD_MAXVALUE']) {
			     $fieldrecord['FIELD_MAXVALUE'] = $maxdim;
			 }
			 if (empty($fieldrecord['FIELD_MINVALUE']) || $mimdim > $fieldrecord['FIELD_MINVALUE']) {
			     $fieldrecord['FIELD_MINVALUE'] = $mimdim;
			 }
			 xValidate::float($msg, $form_fieldname, $record[$form_fieldname], $fieldrecord['FIELD_MINVALUE'], $fieldrecord['FIELD_MAXVALUE'], $fieldrecord['FIELDLISTLABEL']);
		  }
        }//end hidden
    }

    function validateImportField(&$msg, $fieldrecord, $fieldvalue) {
        if ($fieldrecord['FIELD_REQUIRED'] == CLX_NUM_ZERO && $fieldvalue === 'null') {
		  return;
        } else {
		  $maxdim = ClxCommon::$db->getMaxNumberFromDimension($fieldrecord['FIELD_FORMAT']);
		  $mimdim = bcmul($maxdim, '-1');
		  if (empty($fieldrecord['FIELD_MAXVALUE']) || $maxdim < $fieldrecord['FIELD_MAXVALUE']) {
			 $fieldrecord['FIELD_MAXVALUE'] = $maxdim;
		  }
		  if (empty($fieldrecord['FIELD_MINVALUE']) || $mimdim > $fieldrecord['FIELD_MINVALUE']) {
			 $fieldrecord['FIELD_MINVALUE'] = $mimdim;
		  }
		  xValidate::float($msg, $fieldrecord['FIELDNAME'], $fieldvalue, $fieldrecord['FIELD_MINVALUE'], $fieldrecord['FIELD_MAXVALUE'], $fieldrecord['FIELDLISTLABEL']);
        }
    }

    function formatField($form_fieldname, $fieldrecord, $record) {
		if ( $this->debug==true ) {$posx=0;$pos=1611;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		     //  comentada consume memoria pero uppercase no trabaja acentos los lookups demasiado en el export  $form_fieldname = uppercase($form_fieldname);
		$form_fieldname = uppercase($form_fieldname);

        $record = array_change_key_case($record, CASE_UPPER);
        if (array_key_exists($form_fieldname, $record)) {
		  $original_value = $record[$form_fieldname];
        } else {
		  $original_value = '';
        }
        if (!empty($fieldrecord['DBQF_FIELD_FORMAT']) && $fieldrecord['DBQF_FIELD_FORMAT'] === '1') {

		  return $original_value;
        }

        //Added to simulate currency formating
        if ($fieldrecord['FIELD_EXTRA2'] <> '') {
		  $dc = $fieldrecord['FIELD_EXTRA2'];
        } elseif (($comma_post = strpos($fieldrecord['FIELD_FORMAT'], ',')) > CLX_NUM_ZERO) {
		  $dc = substr($fieldrecord['FIELD_FORMAT'], $comma_post + CLX_NUM_ONE, (strlen($fieldrecord['FIELD_FORMAT']) - $comma_post));
        } else {
		  $dc = CLX_INIT_ZERO;
        }
        //Setting Textual Value
        if (array_key_exists('FORMAT', $fieldrecord) && $fieldrecord['FORMAT'] == CLX_NUM_7) {
		  if (rounder($record[$form_fieldname], $dc) == CLX_NUM_ZERO) {
			 if ($original_value == BLANK_IF_ZERO) {

			     $record[$form_fieldname] = '';
			 } else {
			     $record[$form_fieldname] = CLX_INIT_ZERO;
			 }
		  }
		  //return clx_format_textual($record[$form_fieldname], getCurrentLanguage());
		  $is_currency = ($fieldrecord['FIELD_EXTRA1'] === '1');
		  return clx_format_textual($record[$form_fieldname], getCurrentLanguage(), false, $is_currency, $dc);
        }
        if (!array_key_exists($form_fieldname, $record))
		  $record[$form_fieldname] = '';
        if (rounder($record[$form_fieldname], $dc) == CLX_NUM_ZERO) {
		  if ($original_value == BLANK_IF_ZERO) {

			 $record[$form_fieldname] = '';
		  } else {
			 $record[$form_fieldname] = CLX_INIT_ZERO;
		  }
        }
        if ($original_value != BLANK_IF_ZERO) {

		  $record[$form_fieldname] = rounder($record[$form_fieldname], $dc);
        }
        if ($record[$form_fieldname] < CLX_NUM_ZERO) {
		  $value = str_replace('-', '', $record[$form_fieldname]);
		  //   - BEGIN
		  // Caso 1002874 - GB-Neg con PARENTESIS y signo MENOS
		  if (!empty($this->neg_num_parentesis)) {
			 $value = '(' . clx_format_currency(-CLX_NUM_ONE * $record[$form_fieldname], $dc) . ')';
		  } else {
			 $value = clx_format_currency($record[$form_fieldname], $dc);
		  }
		  $value = '<font color = "red">' . $value . '</font>';
		  //   - END
        } else {
		  $value = clx_format_currency($record[$form_fieldname], $dc);
        }
        /* 	break;
		}//End switch */
        return $value;
    }

    /**
     * Formats field in text only
     * @param string $form_fieldname
     * @param array $fieldrecord
     * @param array $record
     * @param bool $append_quote when true value will attach ' to prevent number interpretation
     */
    function placeListFieldText($form_fieldname, $fieldrecord, $record, $append_quote = true,$csv=1) {
        $pfx = dict($fieldrecord['FIELDPREFIX']);
        $sfx = dict($fieldrecord['FIELDSUFIX']);
             //  comentada consume memoria pero uppercase no trabaja acentos los lookups demasiado en el export  $form_fieldname = uppercase($form_fieldname);
		$form_fieldname = uppercase($form_fieldname);

        $cell = strip_tags($this->formatField($form_fieldname, $fieldrecord, $record));
        $cell = str_replace(CLX_CHAR_NL, '', $pfx . $cell . $sfx);
        $cell = str_replace(CLX_CHAR_CR, '', $cell);
        $cell = str_replace(CLX_CHAR_TAB, '', $cell);
		if ( $this->debug==true &&!isset($GLOBALS['placelistcount']) && $GLOBALS['placelistcount']<200) {
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");
			fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."dbft_decimal-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			$te=debug_backtrace();
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"]))
					fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
				
			}

			fwrite($tta,chr(13).chr(10)."placeListFieldText: ".$cell);
			fclose($tta);
			if (!isset($GLOBALS['placelistcount']))
				$GLOBALS['placelistcount']=1;
			else
				$GLOBALS['placelistcount']++;			
		}
        return $cell;
    }

}
