<?php

/**
 * file field object class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * Change log
 *  Added Oracle on field properties
 *  cjr added config var to condition the file link to fix the
 * 				issue with IBS menu limitation (it doesn't permit HTML
 * 				redirections) formatField method
 *  cjr messages translation. It were only in english and were
 * 				transformed at dictionary entries instead
 *
 */
if (!class_exists('dbft') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'dbft.php';

class dbft_file extends dbft {

    // CONSTRUCTOR //
    var $dbft_file_ibs_menu = false;

    function __construct() {
        $this->code = 'FILE';
        $this->name = 'File';
        $this->type = 'DBFT';
        $this->version = '0.2.8.1';
        $this->description = 'Can somebody place a nice description here?';
        $this->multifield = false; // Describes it field is a multi field see properties;
        $this->has_lookup = true; // Decribes if field can be set as copy field on lookup
        $this->has_question = true; // Describes if field can be used on queries criteria
        $this->operators = array('===' => 'GEN_LBL_EQUALTO', '!== ' => 'GEN_LBL_NOTEQUALTO');
    	IF (ISSET($GLOBALS['ADDRDEBUGEDIT']) && $GLOBALS['ADDRDEBUGEDIT']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}

    }

    function panel($msg, $fieldrecord, &$form) {
	ClxFreeReturn($form); //no se esta usando
        $c = $this->code;
        if ($fieldrecord['DBFL_fieldtype'] != $c) {
		  $this->defaultPanel($fieldrecord);
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_FILEFIELDPROP'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $yesno = new htmlSelect($c . '_required');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', ($fieldrecord[$c . '_required'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', ($fieldrecord[$c . '_required'] == CLX_NUM_ONE));
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $yesno->source());
        $SDMG = &getTool('SDMG');
        $SDMG->placeChooseMimeGroup($msg, dict('GEN_LBL_MIMEGROUP') . ':', $c . '_extra1', $fieldrecord[$c . '_extra1'], $table);
        $table->addField($msg, dict('GEN_LBL_MAXFILESIZE') . ':', $c . '_maxvalue', $fieldrecord[$c . '_maxvalue'], CLX_NUM_TEN, CLX_NUM_TEN);
        $yesno = new htmlSelect($c . '_extra2');
        $yesno->addItem(dict('GEN_LBL_FILE'), '0', ($fieldrecord[$c . '_extra2'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_DATABASE'), '1', ($fieldrecord[$c . '_extra2'] == CLX_NUM_ONE));
        $yesno->addItem(dict('GEN_LBL_REMOTE_FILE'), '2', ($fieldrecord[$c . '_extra2'] == CLX_NUM_TWO));
        $table->addData(dict('GEN_LBL_SAVEIN') . ':', $yesno->source());
        $table->addField($msg, dict('GEN_LBL_PATHNAME') . ':', $c . '_extra3', $fieldrecord[$c . '_extra3'], CLX_NUM_48, CLX_NUM_255);
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function checkPanel(&$msg) {
        $c = $this->code;
        if (strlen(UserRequest::$post[$c . '_extra1']) > CLX_NUM_ZERO) {
		  $SDMG = &getTool('SDMG');
		  if (!$SDMG->MimeGroupExists(UserRequest::$post[$c . '_extra1'])) {
			 /*
			  * GEN_ERR_NOGROUPWTHISCODE
			  * There is no group with this code
			  * No hay un grupo con ese código
			  */
			 $msg[$c . '_extra1'] = dict('GEN_ERR_NOGROUPWTHISCODE');
		  }
        }
    }

    function savePanel(&$fieldrecord) { // ok
        $c = $this->code;
        $fieldrecord['FIELD_SIZE'] = CLX_NUM_11;
        $fieldrecord['FIELD_REQUIRED'] = UserRequest::$post[$c . '_required'];
        $fieldrecord['FIELD_FORMAT'] = '';
        $fieldrecord['FIELD_ALIGN'] = '0';
        $fieldrecord['FIELD_DEFAULT'] = '0';
        $fieldrecord['FIELD_MINVALUE'] = '';
        $fieldrecord['FIELD_MAXVALUE'] = UserRequest::$post[$c . '_maxvalue'];
        $fieldrecord['FIELD_EXTRA1'] = UserRequest::$post[$c . '_extra1'];
        $fieldrecord['FIELD_EXTRA2'] = UserRequest::$post[$c . '_extra2'];
        $fieldrecord['FIELD_EXTRA3'] = UserRequest::$post[$c . '_extra3'];
        $fieldrecord['FIELD_EXTRA4'] = '';
        $fieldrecord['FIELD_EXTRA5'] = '';
    }

    function loadPanel(&$fieldrecord, $values) { // ok
        $c = $this->code;
        if ($values['FIELDTYPE'] == $c) {
		  $fieldrecord[$c . '_required'] = $values['FIELD_REQUIRED'];
		  $fieldrecord[$c . '_maxvalue'] = $values['FIELD_MAXVALUE'];
		  $fieldrecord[$c . '_extra1'] = $values['FIELD_EXTRA1'];
		  $fieldrecord[$c . '_extra2'] = $values['FIELD_EXTRA2'];
		  $fieldrecord[$c . '_extra3'] = $values['FIELD_EXTRA3'];
        } else {
		  $this->defaultPanel($fieldrecord);
        }
    }

    function defaultPanel(&$fieldrecord) { // ok
        $c = $this->code;
        $fieldrecord[$c . '_size'] = CLX_NUM_ONE;
        $fieldrecord[$c . '_required'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_format'] = '0';
        $fieldrecord[$c . '_align'] = '0';
        $fieldrecord[$c . '_default'] = '0';
        $fieldrecord[$c . '_minvalue'] = '0';
        $fieldrecord[$c . '_maxvalue'] = '2';
        $fieldrecord[$c . '_extra1'] = '';
        $fieldrecord[$c . '_extra2'] = '';
        $fieldrecord[$c . '_extra3'] = kPathToData;
        $fieldrecord[$c . '_extra4'] = '';
        $fieldrecord[$c . '_extra5'] = '';
    }

    function viewForm(&$table, $record) { // ok
        $yesno = array(CLX_NUM_ZERO => dict('GEN_LBL_NO'), CLX_NUM_ONE => dict('GEN_LBL_YES'));
        $table->addData('Type:', $this->name);
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $yesno[$record['FILE_required']]);
        $table->addData(dict('GEN_LBL_MIMEGROUP') . ':', $record['FILE_extra1']);
        $table->addData(dict('GEN_LBL_MAXFILESIZE') . ':', $record['FILE_maxvalue']);
        $table->addData(dict('GEN_LBL_SAVEINDB') . ':', $yesno[$record['FILE_extra2']]);
        $table->addData(dict('GEN_LBL_PATHNAME') . ':', $record['FILE_extra3']);
    }

    function fieldProperties($fieldrecord) {
	ClxFreeReturn($fieldrecord); //no se esta usando
        $props = array();
        // DB implementation
        switch (kDatabaseType) {
		  case 'oci':
			 $props['type'] = 'number(11)';
			 break;
		  default:
			 $props['type'] = 'bigint(11) unsigned';
			 break;
        }
        $props['default'] = CLX_INIT_ZERO;
        $props['properties'] = '';
        $props['null'] = 'NO';
        return $props;
    }

    function defaultField($form_fieldname, $fieldrecord, &$record) {
        $record[$form_fieldname] = '';
    }

    function placeEditField($msg, $form_fieldname, $fieldrecord, $record, &$form, $jsevents) {
        $form->setProp('enctype', 'multipart/form-data');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        //Options availables 0 - local, 1 - db, 2 - remote [FIELD_EXTRA2] => 2
        $imageid = (array_key_exists($form_fieldname, $record)) ? $record[$form_fieldname] : '';
        if ($imageid > CLX_NUM_ZERO) {
		  $imagerec = ClxCommon::$db->getRecord('CLX_SD_FILES', 'ID=' . singleQuote($imageid));
		  $imagedesc = dict('GEN_LBL_CURRENT_FILE', $imagerec['NAME'] . ' (' . $imageid . ')');
		  $table->addCell($imagedesc, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        }
        $cpt = dict($fieldrecord['CAPTION']);
        if (strlen($cpt) > CLX_NUM_ZERO) {
		  $table->addCell($cpt, array(CLX_PROP_CLASS => $fieldrecord['CAPTION_CLASS'], CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        }
        if (isset($msg[$form_fieldname])) {
		  $table->addCell($msg[$form_fieldname], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        }
        $fieldobj = $this->fieldObject($form_fieldname, $fieldrecord, $record);
        foreach ($jsevents as $key => $value) {
		  $fieldobj->setProp($key, $value);
        }
        $pfx = dict($fieldrecord['FIELDPREFIX']);
        $fieldsource = (strlen($pfx) > CLX_NUM_ZERO) ? $pfx : '';
        $fieldsource .= $fieldobj->source();
        $sfx = dict($fieldrecord['FIELDSUFIX']);
        $fieldsource .= (strlen($sfx) > CLX_NUM_ZERO) ? $sfx : '';
        //Setting form require pref if any
        if ($fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
		  $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
        }
        $class = ($fieldrecord['FIELD_REQUIRED']) ? CLX_CLASS_PROMPTREQUIRED : CLX_CLASS_PROMPT;
        $table->addCell(dict($fieldrecord['FIELDFORMLABEL']), array(CLX_PROP_CLASS => $class));
        $table->addCell($fieldsource, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		if ( $this->debug==true &&!isset($GLOBALS['placelistcount']) && $GLOBALS['placelistcount']<200) {
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");
			fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."dbft_file-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			$te=debug_backtrace();
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"]))
					fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
				
			}

			fwrite($tta,chr(13).chr(10)."placeListFieldText: ".print_r($fieldsource,true));
			fclose($tta);
			if (!isset($GLOBALS['placelistcount']))
				$GLOBALS['placelistcount']=1;
			else
				$GLOBALS['placelistcount']++;			
		}
        return $table;
    }

    function placeListField($form_fieldname, $fieldrecord, $record, $class, &$table,$csv=1) {
        $pfx = dict($fieldrecord['FIELDPREFIX']);
        $sfx = dict($fieldrecord['FIELDSUFIX']);
        $cell = $this->formatField($form_fieldname, $fieldrecord, $record);
        if (stristr($cell, '<img src=') !== false) {
		  $cell = str_replace('<img', '<img width=100 height = 100 ', $cell);
        }
        $table->addCell($pfx . $cell . $sfx, array(CLX_PROP_CLASS => $class));
		if ( $this->debug==true &&!isset($GLOBALS['placelistcount']) && $GLOBALS['placelistcount']<200) {
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");
			fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."dbft_file-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			$te=debug_backtrace();
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"]))
					fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
				
			}

			fwrite($tta,chr(13).chr(10)."placeListFieldText: ".print_R($cell,true));
			fclose($tta);
			if (!isset($GLOBALS['placelistcount']))
				$GLOBALS['placelistcount']=1;
			else
				$GLOBALS['placelistcount']++;			
		}
    }

    function fieldObject(&$form_fieldname, &$fieldrecord, $record) {
        if (!array_key_exists($form_fieldname, $record))
		  $record[$form_fieldname] = '';
        if ($record[$form_fieldname] > CLX_NUM_ZERO) {
		  $filerec = ClxCommon::$db->getRecord('CLX_SD_FILES', 'ID=' . singleQuote($record[$form_fieldname]));
		  $def = $filerec['NAME'];
        } else {
		  $def = '';
        }
        if ($fieldrecord['FIELD_EXTRA2'] == CLX_NUM_TWO) {
		  $field_displaysize = $fieldrecord['FIELD_DISPLAYSIZE'];
		  if ($fieldrecord['FIELD_SIZE'] > CLX_NUM_ZERO) {
			 $field_size = $fieldrecord['FIELD_SIZE'];
		  } elseif ($fieldrecord['FIELD_DISPLAYSIZE'] > CLX_NUM_ZERO) {
			 $field_size = $field_displaysize;
		  } else {
			 $field_size = CLX_NUM_255;
		  }
		  if ($field_size > CLX_NUM_255)
			 $field_size = CLX_NUM_255;
		  $fieldobj = new htmlField($form_fieldname, $record[$form_fieldname], $field_displaysize, $field_size);
		  //Added instead of displaying read only files
		  if (!empty($fieldrecord['FIELD_READONLY'])) {
			 $fieldobj->setProp('readonly', 'true');
			 $fieldobj->setProp(CLX_PROP_CLASS, 'readonly');
		  }
        } else {
		  $fieldobj = new htmlObject('input', '', array('type' => 'file', 'name' => $form_fieldname, 'value' => addslashes($def)));
        }
        return $fieldobj;
    }

    function validateField(&$msg, $form_fieldname, $fieldrecord, &$record, &$table, &$form) {
	
        //Setting form require pref if any
        if (array_key_exists('FIELD_FORM_REQUIRED', $fieldrecord) && $fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
		  $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
        }
        // Note: !array_key_exists was added to enable lookups to validate
        if (!array_key_exists('FIELD_HIDDEN', $fieldrecord))
		  $fieldrecord['FIELD_HIDDEN'] = false;
        //Setting hidden to override required
        if ($fieldrecord['FIELD_HIDDEN'] === true) {
		  $fieldrecord['FIELD_REQUIRED'] = CLX_INIT_ZERO;
        }
        $pos = strpos($form_fieldname, '_');
        $tablecode = substr($form_fieldname, CLX_NUM_ZERO, $pos);
        $recordid = $record[$tablecode . '_ID'];
        if ($recordid > CLX_NUM_ZERO) {
		  $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
		  $tablename = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
		  $oldrecord = ClxCommon::$db->getRecord($tablename, 'ID=' . singleQuote($recordid));
		  $oldfileid = $oldrecord[uppercase($fieldrecord['FIELDNAME'])];
		  $alreadyin = ($oldfileid > CLX_NUM_ZERO) ? true : false;
        } else {
		  $alreadyin = false;
        }
        //If not post method on UserRequest::$files just return
        if (empty(UserRequest::$files)) {
		  return;
        }
        if (!array_key_exists($form_fieldname, UserRequest::$files)) {
		  return;
        }
        $required = $fieldrecord['FIELD_REQUIRED'];
        $something = (strlen(UserRequest::$files[$form_fieldname]['name']) > CLX_NUM_ZERO) ? true : false;
        $error = UserRequest::$files[$form_fieldname]['error'];
        $filetype = UserRequest::$files[$form_fieldname]['type'];
        $filesize = ((UserRequest::$files[$form_fieldname]['size']) / CLX_NUM_1024) / CLX_NUM_1024; // we need this value in MB
        $groupcode = $fieldrecord['FIELD_EXTRA1'];

        if (empty($something) && !empty($alreadyin)) {
		  $record[$form_fieldname] = $oldfileid;
        } elseif ($required || $something) {

            $correcttype = (strlen($groupcode) > CLX_NUM_ZERO) ? ClxCommon::$db->oneExistsRecords('CLX_SD_MIMEGROUP_MEMBERS', 'GROUPCODE = ' . singleQuote($groupcode) . ' AND MIMECODE = ' . singleQuote($filetype)) : CLX_NUM_ONE;
		  if (empty($something)) {
			 /*
			  * GEN_ERR_UHAVETOSELFILE
			  * You have to select a file
			  * Es necesario seleccionar un archivo
			  */
			 $msg[$form_fieldname] = dict('GEN_ERR_UHAVETOSELFILE');
		  } elseif (!empty($error)) {
			 /*
			  * GEN_ERR_CANTIMPRTFILE
			  * Can\'t import file: ^1
			  * No se puede importar el archivo: ^1
			  */
			 $msg[$form_fieldname] = dict('GEN_ERR_CANTIMPRTFILE', UserRequest::$files[$form_fieldname]['name']);
		  } elseif (empty($correcttype)) {
			 /*
			  * GEN_ERR_FILENOTHERGHTFMT
			  * This file is not the right format: ^1
			  * El archivo especificado no tiene el formato que se espera en el campo: ^1
			  */
			 $msg[$form_fieldname] = dict('GEN_ERR_FILENOTHERGHTFMT', UserRequest::$files[$form_fieldname]['name']);
		  } elseif ($filesize > $fieldrecord['FIELD_MAXVALUE']) {
			 /*
			  * GEN_ERR_FILETOOBIG
			  * This file is too big
			  * El archivo es demasiado grande
			  */
			 $msg[$form_fieldname] = dict('GEN_ERR_FILETOOBIG');
		  }
        }
    }

    function validateFieldQuestionary(&$msg, $form_fieldname, $fieldrecord, $tablecode, $record, $recordid) {
        if ($recordid > CLX_NUM_ZERO) {
		  $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
		  $tablename = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
		  $oldrecord = ClxCommon::$db->getRecord($tablename, 'ID=' . singleQuote($recordid));
		  $oldfileid = $oldrecord[uppercase($fieldrecord['FIELDNAME'])];
		  $alreadyin = ($oldfileid > CLX_NUM_ZERO);
        } else {
		  $alreadyin = false;
        }
        $required = $fieldrecord['FIELD_REQUIRED'];
        $something = (strlen(UserRequest::$files[$form_fieldname]['name']) > CLX_NUM_ZERO);
        $error = UserRequest::$files[$form_fieldname]['error'];
        $filetype = UserRequest::$files[$form_fieldname]['type'];
        $filesize = ((UserRequest::$files[$form_fieldname]['size']) / CLX_NUM_1024) / CLX_NUM_1024; // we need this value in MB
        $groupcode = $fieldrecord['FIELD_EXTRA1'];
        if (empty($something) && !empty($alreadyin)) {
		  $record[$form_fieldname] = $oldfileid;
        } elseif (!empty($required)or ! empty($something)) {
		  if (strlen($groupcode) > CLX_NUM_ZERO) {
                $correcttype = ClxCommon::$db->oneExistsRecords('CLX_SD_MIMEGROUP_MEMBERS', 'GROUPCODE = ' . singleQuote($groupcode) . ' AND MIMECODE = ' . singleQuote($filetype));
		  } else {
			 $correcttype = CLX_NUM_ONE;
		  }
		  if (empty($something)) {
			 $msg[$form_fieldname] = dict('GEN_ERR_UHAVETOSELFILE');
		  } elseif (!empty($error)) {
			 $msg[$form_fieldname] = dict('GEN_ERR_CANTIMPRTFILE', UserRequest::$files[$form_fieldname]['name']);
		  } elseif (empty($correcttype)) {
			 $msg[$form_fieldname] = dict('GEN_ERR_FILENOTHERGHTFMT', UserRequest::$files[$form_fieldname]['name']);
		  } elseif ($filesize > $fieldrecord['FIELD_MAXVALUE']) {
			 $msg[$form_fieldname] = dict('GEN_ERR_FILETOOBIG');
		  }
        }
    }

    function validateImportField(&$msg, $fieldrecord, $fieldvalue) {
        /*
         * GEN_ERR_CNTIMPRTFILUSGTOOL
         * Can\'t import a file using this tool
         * No se puede importar un archivo usando esta herramienta
         */
        $msg[$fieldrecord['FIELDNAME']] = dict('GEN_ERR_CNTIMPRTFILUSGTOOL');
    }

    function saveField($form_fieldname, $fieldrecord, &$record, $recordid) {
        $SDFL = &getTool('SDFL');
        //Setting form require pref if any
        if ($fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
		  $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
        }
        $required = $fieldrecord['FIELD_REQUIRED'];
        $saveindatabase = $fieldrecord['FIELD_EXTRA2'];
        if ($saveindatabase == CLX_NUM_TWO) {
		  if (array_key_exists($form_fieldname, UserRequest::$post)) {
			 $name = UserRequest::$post[$form_fieldname];
		  } else {
			 $name = $record[$form_fieldname];
		  }
		  $something = (strlen($name) > CLX_NUM_ZERO);
		  $contents = '';
		  $type = '';
		  $path = '';
		  $lowername = lowercase($name);
		  $sql = 'SELECT IDCODE, EXTENSION FROM CLX_SD_MIMETYPES WHERE EXTENSION IS NOT null AND EXTENSION <>' . "''";
		  $rs = ClxCommon::$db->executeQuery($sql);
		  while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
			 if (strpos($lowername, lowercase($r[CLX_NUM_ONE])) !== false) {
			     $type = $r[CLX_NUM_ZERO];
			     //e cho $type.'<br>';
			     break;
			 }
		  }
		  ClxCommon::$db->freeResult($rs);
		  $fieldid = ClxCommon::$db->getField($SDFL->tablename, 'ID', 'FILENAME = ' . singleQuote($name));
		  if (empty($fieldid)) {
			 $record[$fieldrecord['FIELDNAME']] = $SDFL->saveFile($name, $type, $contents, $saveindatabase, $path);
		  } else {
			 $record[$fieldrecord['FIELDNAME']] = $fieldid;
		  }
        } else {
		  if (empty(UserRequest::$files)) {
			 $record[$fieldrecord['FIELDNAME']] = '0';
			 return;
		  }
          if (isset(UserRequest::$files[$form_fieldname]['name'])){
			  $something = (strlen(UserRequest::$files[$form_fieldname]['name']) > CLX_NUM_ZERO);
			  $path = $fieldrecord['FIELD_EXTRA3'];
			  if ($recordid > CLX_NUM_ZERO) { // if there is an old record, we have to check if there is an old file...
				 $tablecode = $fieldrecord['TABLECODE'];
				 $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
				 $tablename = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
				 $oldrecord = ClxCommon::$db->getRecord($tablename, 'ID=' . singleQuote($recordid));
				 $oldfileid = $oldrecord[$fieldrecord['FIELDNAME']];
				 $alreadyin = ($oldfileid > CLX_NUM_ZERO);
				 if ($alreadyin === true && $something === true) {
				     // yep, there is an old file, and the user has selected a
				     //new one, so we have to delete the old one.
				     $SDFL->deleteRecordSk($oldfileid);
				 }
			  } else {
				 $alreadyin = false;
			  }
			  if ($alreadyin === true && !$something === true) { // the file is already in and the user didn't select a new file
				 $record[$fieldrecord['FIELDNAME']] = $oldfileid;
			  } elseif ($required == CLX_NUM_ONE || $something === true) {
				 $name = UserRequest::$files[$form_fieldname]['name'];
				 $type = UserRequest::$files[$form_fieldname]['type'];
				 $contents = file_get_contents(UserRequest::$files[$form_fieldname]['tmp_name']);
				 $record[$fieldrecord['FIELDNAME']] = $SDFL->saveFile($name, $type, $contents, $saveindatabase, $path);
			  } else {
				 $record[$fieldrecord['FIELDNAME']] = '0';
			  }
	        }
	    }
    }

    function loadField($form_fieldname, &$fieldrecord, &$record, $values) {
        if ($fieldrecord['FIELD_EXTRA2'] == CLX_NUM_TWO) {
		  if (!empty($values[$fieldrecord['FIELDNAME']])) {
			 $record[$form_fieldname] = $this->fileName($values[$fieldrecord['FIELDNAME']]);
		  } else {
			 $record[$form_fieldname] = '';
		  }
        } else {
            $record[$form_fieldname] = (isset($values[$fieldrecord['FIELDNAME']])?$values[$fieldrecord['FIELDNAME']]:'');
        }
    }

    function removeField($fieldrecord, $record) {
        $SDFL = &getTool('SDFL');
        $SDFL->deleteRecordSk($record[$fieldrecord['FIELDNAME']]);
    }

    function formatField($form_fieldname, $fieldrecord, $record) {
		     //  comentada consume memoria pero uppercase no trabaja acentos los lookups demasiado en el export  $form_fieldname = uppercase($form_fieldname);
		$form_fieldname = uppercase($form_fieldname);

	
	if (is_null($record))
	    return;
	$record = array_change_key_case($record, CASE_UPPER);
        $contents = '';
        $fileid = $record[$form_fieldname];
        if (!empty($fileid)) {
		  if ($this->isRemoteFile($fileid)) {
			 $filerecord = ClxCommon::$db->getRecord('CLX_SD_FILES', 'FILENAME=' . singleQuote($fileid));
			 $fileid = $filerecord['ID'];
		  } else {
			 $filerecord = ClxCommon::$db->getRecord('CLX_SD_FILES', 'ID=' . singleQuote($fileid));
		  }
		  $mimerec = ClxCommon::$db->getRecord('CLX_SD_MIMETYPES', 'IDCODE=' . singleQuote($filerecord['TYPE']));
		  if ($this->dbft_file_ibs_menu === true) {
			 if (empty($mimerec['HTML_TAG'])) {
			     $windowname = 'window' . $fileid;
                    $url = 'javaScript:openWindow(' . singleQuote($windowname) . ', ' . singleQuote($filerecord['FILENAME']) . ', 800, 600,null,null,'.singlequote( __FILE__ .'_'. __LINE__ ) .');';
			     $contents = '<a href="' . $url . '">' . $filerecord['NAME'] . '</a>';
			 } else {
			     $contents = str_replace('[PATHNAME]', $filerecord['FILENAME'], $mimerec['HTML_TAG']);
			 }
		  } else {
			 if (empty($mimerec['HTML_TAG'])) {
			     $windowname = 'window' . $fileid;

                    $tool = &getTool('SDFL'); 
                    $sdfl_clx_root_sd_files = (SDFL_CLX_ROOT_SD_FILES!='' ? trim(SDFL_CLX_ROOT_SD_FILES) : 'null');
                    if ($sdfl_clx_root_sd_files!='null' && $sdfl_clx_root_sd_files!=''){
                        //Se hace uso de php para desplegar el archivo ubicado fuera de la ruta publica
                        $url = 'window.php?to=SDFL&ac=SHOW_FILE&ff=' . $fileid;
                        //$url = 'javaScript:openWindow(' . singleQuote($windowname) . ', ' . singleQuote('window.php?to=SDFL&ac=SHOW_FILE&ff=' . $fileid) . '  , 800, 600);';
                    }else{
                        //Se coloca el enlace por defecto
                        $url = 'javaScript:openWindow(' . singleQuote($windowname) . ', ' . singleQuote($filerecord['FILENAME']) . ', 800, 600,null,null,'.singlequote( __FILE__ .'_'. __LINE__ ) .');';
                    }
			     $contents = '<a href="' . $url . '">' . $filerecord['NAME'] . '</a>';
			 } else {
			     $contents = str_replace('[PATHNAME]', 'window.php?to=SDFL&ac=SHOW_FILE&no_menu=1&no_alerts=1&ff=' . $fileid, $mimerec['HTML_TAG']);
			 }
		  }
        }
        return $contents;
    }

    /**
     * Returns file id url
     */
    function fileInfo($fileid) {
        $return = array();
        if (!empty($fileid)) {
		  if ($this->isRemoteFile($fileid)) {
			 $filerecord = ClxCommon::$db->getRecord('CLX_SD_FILES', 'FILENAME=' . singleQuote($fileid));
			 $fileid = $filerecord['ID'];
		  } else {
			 $filerecord = ClxCommon::$db->getRecord('CLX_SD_FILES', 'ID=' . singleQuote($fileid));
		  }
		  $mimerec = ClxCommon::$db->getRecord('CLX_SD_MIMETYPES', 'IDCODE=' . singleQuote($filerecord['TYPE']));
		  $return['ID'] = $fileid;
		  $return['URL'] = 'window.php?to=SDFL&ac=SHOW_FILE&no_menu=1&no_alerts=1&ff=' . $fileid;
		  $return['FPDF_FILETYPE'] = $mimerec['EXTENSION']; //see fpdf image()
		  $return['EXTENSION'] = $mimerec['EXTENSION']; //see fpdf image()
		  $return['FULL_URL'] = kWebSite . $return['URL'];
		  $return['TYPE'] = $filerecord['TYPE'];
		  $return['FILENAME'] = $filerecord['NAME'];
		  $return['FULL_FILENAME'] = kPathToWebSite . kPathToData . $return['FILENAME'];
        }
        return $return;
    }

    /**
     * Returns file id url
     */
    function fileUrl($fileid, $full_url = true) {
        $contents = '';
        if (!empty($fileid)) {
		  if ($this->isRemoteFile($fileid)) {
			 $filerecord = ClxCommon::$db->getRecord('CLX_SD_FILES', 'FILENAME=' . singleQuote($fileid));
			 $fileid = $filerecord['ID'];
		  } else {
			 $filerecord = ClxCommon::$db->getRecord('CLX_SD_FILES', 'ID=' . singleQuote($fileid));
		  }
//	    $mimerec = ClxCommon::$db->getRecord('CLX_SD_MIMETYPES', 'IDCODE=' . singleQuote($filerecord['type']));
		  $contents = 'window.php?to=SDFL&ac=SHOW_FILE&no_menu=1&no_alerts=1&ff=' . $fileid;
		  if (!empty($full_url))
			 $contents = kWebSite . $contents;
        }
        return $contents;
    }

    /**
     * Returns filename
     * @param unknown_type $fileid
     * @return string|unknown
     */
    function fileName($fileid) {
        if (empty($fileid) || !is_numeric($fileid))
		  return CLX_CHAR_EMPTY_STRING;
        $filerec = ClxCommon::$db->getRecord('CLX_SD_FILES', 'ID=' . $fileid);
        if (empty($fileid) || !is_numeric($fileid))
		  return CLX_CHAR_EMPTY_STRING;
        if (empty($filerec)) {
		  return CLX_CHAR_EMPTY_STRING;
        } elseif (!empty($filerec['FILENAME'])) {
		  return $filerec['FILENAME'];
        } else {
		  //if file is on db just write it to temp to be accesible
		  $filerec['NAME'] = lowercase($filerec['NAME']);
		  $filerec['NAME'] = str_replace(' ', '', $filerec['NAME']);
		  $filerec['NAME'] = str_replace('-', '', $filerec['NAME']);
		  $filerec['NAME'] = trim($filerec['NAME']);
		  $filename = kPathToWebSite . kPathToTemp . $filerec['NAME'];
		  $f = new clx_file($filename, 'wb');
		  $f->open();
		  if(!$f->hasError()){
			 $f->write(stripslashes($filerec['CONTENTS']));
		  }else{
			 $filename = '';
		  }
		  $f->close();
		  return $filename;
        }
    }

    function isRemoteFile($filename) {
        return (strpos(lowercase($filename), 'http') !== false) ? true : false;
    }

    function saveUrlFileFromUrl($form_fieldname, &$record) {
        $url = $record[$form_fieldname];
        if (empty($url))
		  $record[$form_fieldname] = CLX_INIT_ZERO;
        $fieldrecord = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME =' . singleQuote($form_fieldname));
        if (empty($fieldrecord)) {
		  $record[$form_fieldname] = CLX_INIT_ZERO;
		  return;
        }
        //try to find any image if exists
        $recordid = ClxCommon::$db->getField('CLX_SD_FILES', 'ID', 'FILENAME = ' . singleQuote($url));
        if (!empty($recordid)) {
		  ClxCommon::$db->updateRecord('CLX_SD_FILES', array('FILENAME' => $url), 'ID = ' . $recordid);
		  $record[$form_fieldname] = $recordid;
        } else {
		  //add image entry
		  $this->saveField($form_fieldname, $fieldrecord, $record, $recordid);
        }
    }

}
