<?php

/**
 * Lookup field object class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-09 11:22:02 -0400 (Tue, 09 Oct 2018) $
 * @version    	$Rev: 10222 $
 */
if (!class_exists('dbft') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'dbft.php';

class dbft_lookup extends dbft {

    //Type of display for lookup
    var $ltype = array('Default', 'Select', 'Open', 'Single');
    var $field_cache = array();

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'LOOK';
        $this->name = 'Look up';
        $this->type = 'DBFT';
        $this->version = '0.3.14.9';
        $this->description = 'Can somebody place a nice description here?';
        $this->multifield = false; // Describes it field is a multi field see properties;
        $this->has_lookup = true; // Decribes if field can be set as copy field on lookup
        $this->has_question = true; // Describes if field can be used on queries criteria
        $this->operators = array(
		  '===' => 'GEN_LBL_EQUALTO',
		  '!== ' => 'GEN_LBL_NOTEQUALTO'
        );
		IF (ISSET($GLOBALS['ADDRDEBUGEDIT']) && $GLOBALS['ADDRDEBUGEDIT']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}
    }

    function panel($msg, $fieldrecord, &$form) {
        $c = $this->code;
        if ($fieldrecord['DBFL_fieldtype'] != $c) {
		  $this->defaultPanel($fieldrecord);
        }
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_LOOKUPFIELDPROP'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $yesno = new htmlSelect($c . '_required');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', ($fieldrecord[$c . '_required'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', ($fieldrecord[$c . '_required'] == CLX_NUM_ONE));
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $yesno->source());
        $table->addField($msg, dict('GEN_LBL_DEFAULT') . ':', $c . '_default', $fieldrecord[$c . '_default'], CLX_NUM_32, CLX_NUM_64);
        $DBTB = &getTool('DBTB');
        $contents .= CLX_CHAR_NL . CLX_CHAR_NL . $DBTB->placeChooseTable($msg, dict('GEN_LBL_TABLECODE') . ':', $c . '_extra1', $fieldrecord[$c . '_extra1'], $table);
        $DBTF = &getTool('DBTF');
        $contents .= CLX_CHAR_NL . CLX_CHAR_NL . $DBTF->placeChooseTableField($msg, $c . '_extra1', dict('GEN_LBL_COPYFIELD') . ':', $c . '_extra2', $fieldrecord[$c . '_extra2'], $table);
        $DBTF->placeChooseTableField($msg, $c . '_extra1', dict('GEN_LBL_PRIMARY_SEARCH_FIELD') . ':', $c . '_extra3', $fieldrecord[$c . '_extra3'], $table);
        $DBTF->placeChooseTableField($msg, $c . '_extra1', dict('GEN_LBL_SECONDARY_SEARCH_FIELD') . ':', $c . '_extra4', $fieldrecord[$c . '_extra4'], $table);
        $DBTF->placeChooseTableField($msg, $c . '_extra1', dict('GEN_LBL_EXTRASRCHFIELDOPT') . ':', $c . '_extra9', $fieldrecord[$c . '_extra9'], $table);
        //Handled by relations
        $yesno = new htmlSelect($c . '_extra5');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', (empty($fieldrecord[$c . '_extra5'])));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', (!empty($fieldrecord[$c . '_extra5']) && $fieldrecord[$c . '_extra5'] == CLX_NUM_ONE));
        $table->addData(dict('GEN_LBL_DELWHENPARENT') . ':', $yesno->source());
        $yesno = new htmlSelect($c . '_extra8');
        foreach ($this->ltype as $key => $val) {
		  $yesno->addItem($val, $key, ($fieldrecord[$c . '_extra8'] == $key));
        }
        $table->addData(dict('GEN_LBL_DISPLAY_TYPE') . ':', $yesno->source());
        $UIFM = &getTool('UIFM');
        $contents .= CLX_CHAR_NL . CLX_CHAR_NL . $UIFM->placeChooseForm($msg, dict('GEN_LBL_DISPLAYFORM') . ':', $c . '_extra6', $fieldrecord[$c . '_extra6'], $table);
        $contents .= CLX_CHAR_NL . CLX_CHAR_NL . $UIFM->placeChooseForm($msg, dict('GEN_LBL_SEARCHFORM') . ':', $c . '_extra7', (!empty($fieldrecord[$c . '_extra7'])) ? $fieldrecord[$c . '_extra7'] : '', $table);
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        $contents .= CLX_CHAR_NL . CLX_CHAR_NL . $div->source();
        return $contents . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function checkPanel(&$msg) {
        $c = $this->code;
        if (!empty(UserRequest::$post[$c . '_required'])) {
		  xValidate::required($msg, $c . '_default', trim(UserRequest::$post[$c . '_default']));
        }
        $DBTB = &getTool('DBTB');
        $DBTF = &getTool('DBTF');
        $UIFM = &getTool('UIFM');
        if (empty(UserRequest::$post[$c . '_extra1'])) {
		  $msg[$c . '_extra1'] = dict('GEN_LBL_FIELD_REQUIRED');
        } elseif (!$DBTB->tableExists(UserRequest::$post[$c . '_extra1'])) {
		  $msg[$c . '_extra1'] = dict('GEN_ERR_TABLE_DOES_NOT_EXISTS');
        } else {
		  if (empty(UserRequest::$post[$c . '_extra2'])) {
			 $msg[$c . '_extra2'] = dict('GEN_LBL_FIELD_REQUIRED');
		  } elseif (!$DBTF->fieldExists(UserRequest::$post[$c . '_extra1'], UserRequest::$post[$c . '_extra2'])) {
			 $msg[$c . '_extra2'] = dict('GEN_ERR_NOFIELDONTABLE');
		  } else {
			 $DBFL = &getTool('DBFL');
			 $copyfieldrec = $DBFL->getField(UserRequest::$post[$c . '_extra2']);
			 $field = getToolObject('DBFT', $copyfieldrec['FIELDTYPE']);
			 if (empty($field->has_lookup)) {
			     $msg[$c . '_extra2'] = dict('GEN_ERR_NOFIELDONTABLE');
			 }
		  }
		  if (empty(UserRequest::$post[$c . '_extra3'])) {
			 $msg[$c . '_extra3'] = dict('GEN_LBL_FIELD_REQUIRED');
		  } elseif (!$DBTF->fieldExists(UserRequest::$post[$c . '_extra1'], UserRequest::$post[$c . '_extra3'])) {
			 $msg[$c . '_extra3'] = dict('GEN_ERR_NOFIELDONTABLE');
		  }
		  if (empty(UserRequest::$post[$c . '_extra4'])) {
			 $msg[$c . '_extra4'] = dict('GEN_LBL_FIELD_REQUIRED');
		  } elseif (!$DBTF->fieldExists(UserRequest::$post[$c . '_extra1'], UserRequest::$post[$c . '_extra4'])) {
			 $msg[$c . '_extra4'] = dict('GEN_ERR_NOFIELDONTABLE');
		  }
		  //terciary field
		  if (!empty(UserRequest::$post[$c . '_extra9']) && !$DBTF->fieldExists(UserRequest::$post[$c . '_extra1'], UserRequest::$post[$c . '_extra9'])) {
			 $msg[$c . '_extra9'] = dict('GEN_ERR_NOFIELDONTABLE');
		  }
		  if (!empty(UserRequest::$post[$c . '_extra6'])) {
			 if (!$UIFM->formExists(UserRequest::$post[$c . '_extra6'])) {
			     $msg[$c . '_extra6'] = dict('GEN_LBL_FORM_INVALID');
			 } else {
			     $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote(UserRequest::$post[$c . '_extra6']));
			     if ($formrec['TABLECODE'] != UserRequest::$post[$c . '_extra1']) {
			         $msg[$c . '_extra6'] = dict('GEN_LBL_FORMTBLINVALID', UserRequest::$post[$c . '_extra1']);
			     }
			 }
		  }
		  if (!empty(UserRequest::$post[$c . '_extra7'])) {
			 if (!$UIFM->formExists(UserRequest::$post[$c . '_extra7'])) {
			     $msg[$c . '_extra7'] = dict('GEN_LBL_FORM_INVALID');
			 } else {
			     $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote(UserRequest::$post[$c . '_extra7']));
			     if ($formrec['TABLECODE'] != UserRequest::$post[$c . '_extra1']) {
			         $msg[$c . '_extra7'] = dict('GEN_LBL_FORMTBLINVALID', UserRequest::$post[$c . '_extra1']);
			     }
			 }
		  }
        }
    }

    function savePanel(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord['FIELD_SIZE'] = CLX_INIT_ZERO;
        $fieldrecord['FIELD_REQUIRED'] = UserRequest::$post[$c . '_required'];
        $fieldrecord['FIELD_DEFAULT'] = UserRequest::$post[$c . '_default'];
        $fieldrecord['FIELD_FORMAT'] = '';
        $fieldrecord['FIELD_ALIGN'] = CLX_INIT_ZERO;
        $fieldrecord['FIELD_MINVALUE'] = '';
        $fieldrecord['FIELD_MAXVALUE'] = '';
        $fieldrecord['FIELD_EXTRA1'] = UserRequest::$post[$c . '_extra1'];
        $fieldrecord['FIELD_EXTRA2'] = UserRequest::$post[$c . '_extra2'];
        $fieldrecord['FIELD_EXTRA3'] = UserRequest::$post[$c . '_extra3'];
        $fieldrecord['FIELD_EXTRA4'] = UserRequest::$post[$c . '_extra4'];
        $fieldrecord['FIELD_EXTRA5'] = UserRequest::$post[$c . '_extra5'];
        $fieldrecord['FIELD_EXTRA6'] = UserRequest::$post[$c . '_extra6'];
        $fieldrecord['FIELD_EXTRA7'] = UserRequest::$post[$c . '_extra7'];
        $fieldrecord['FIELD_EXTRA8'] = UserRequest::$post[$c . '_extra8'];
        $fieldrecord['FIELD_EXTRA9'] = UserRequest::$post[$c . '_extra9'];
    }

    function loadPanel(&$fieldrecord, $values) {
        $c = $this->code;
        if ($values['FIELDTYPE'] == $c) {
		  $fieldrecord[$c . '_required'] = $values['FIELD_REQUIRED'];
		  $fieldrecord[$c . '_default'] = ($values['FIELD_DEFAULT'] === '') ? 'null' : $values['FIELD_DEFAULT'];
		  $fieldrecord[$c . '_extra1'] = $values['FIELD_EXTRA1'];
		  $fieldrecord[$c . '_extra2'] = $values['FIELD_EXTRA2'];
		  $fieldrecord[$c . '_extra3'] = $values['FIELD_EXTRA3'];
		  $fieldrecord[$c . '_extra4'] = $values['FIELD_EXTRA4'];
		  $fieldrecord[$c . '_extra5'] = $values['FIELD_EXTRA5'];
		  $fieldrecord[$c . '_extra6'] = $values['FIELD_EXTRA6'];
		  $fieldrecord[$c . '_extra7'] = $values['FIELD_EXTRA7'];
		  $fieldrecord[$c . '_extra8'] = $values['FIELD_EXTRA8'];
		  $fieldrecord[$c . '_extra9'] = $values['FIELD_EXTRA9'];
        } else {
		  $this->defaultPanel($fieldrecord);
        }
    }

    function defaultPanel(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord[$c . '_size'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_required'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_format'] = '';
        $fieldrecord[$c . '_align'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_default'] = 'null';
        $fieldrecord[$c . '_minvalue'] = '';
        $fieldrecord[$c . '_maxvalue'] = '';
        $fieldrecord[$c . '_extra1'] = '';
        $fieldrecord[$c . '_extra2'] = '';
        $fieldrecord[$c . '_extra3'] = '';
        $fieldrecord[$c . '_extra4'] = '';
        $fieldrecord[$c . '_extra5'] = '0';
        $fieldrecord[$c . '_extra6'] = '';
        $fieldrecord[$c . '_extra8'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_extra9'] = '';
    }

    function viewForm(&$table, $record) {
        $yesno = array(CLX_NUM_ZERO => dict('GEN_LBL_NO'), CLX_NUM_ONE => dict('GEN_LBL_YES'));
        $table->addData(dict('GEN_LBL_TYPE') . ':', $this->name);
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $yesno[$record['LOOK_required']]);
        $table->addData(dict('GEN_LBL_TABLECODE') . ':', $record['LOOK_extra1']);
        $table->addData(dict('GEN_LBL_COPYFIELD') . ':', $record['LOOK_extra2']);
        $table->addData(dict('GEN_LBL_PRIMARY_SEARCH_FIELD') . ':', $record['LOOK_extra3']);
        $table->addData(dict('GEN_LBL_SECONDARY_SEARCH_FIELD') . ':', $record['LOOK_extra4']);
        $table->addData(dict('GEN_LBL_EXTRASRCHFIELDOPT') . ':', $record['LOOK_extra9']);
        $table->addData(dict('GEN_LBL_DELWHENPARENT') . ':', $yesno[$record['LOOK_extra5']]);
        $table->addData(dict('GEN_LBL_DISPLAYFORM') . ':', $record['LOOK_extra6']);
    }

    function fieldProperties($fieldrecord) {
        if (array_key_exists($fieldrecord['FIELD_EXTRA2'], $this->field_cache)) {
		  $copyfieldrec = $this->field_cache[$fieldrecord['FIELD_EXTRA2']];
        } else {
		  $copyfieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($fieldrecord['FIELD_EXTRA2']));
		  $this->field_cache[$fieldrecord['FIELD_EXTRA2']] = $copyfieldrec;
        }
        $copyfieldrec['FIELDNAME'] = $fieldrecord['FIELDNAME'];
        $copyfieldrec['FIELD_DEFAULT'] = $fieldrecord['FIELD_DEFAULT'];
        $copyfieldrec['FIELD_REQUIRED'] = $fieldrecord['FIELD_REQUIRED'];
        $field = getToolObject('DBFT', $copyfieldrec['FIELDTYPE']);
        $props = $field->fieldProperties($copyfieldrec);
        $props['properties'] = '';
        $props['index'] = '';
        $props['null'] = ($fieldrecord['FIELD_REQUIRED']) ? 'NO' : 'YES';
        return $props;
    }

    function defaultField($form_fieldname, $fieldrecord, &$record) {
        $callingpage = peekHistory();
        $hasparent = (isset($callingpage['parentrecord']));
        
        //if (!empty($hasparent) && empty($fieldrecord['NOPARENT'])) {
        if ($hasparent) {
		  $parentrecord = $callingpage['parentrecord'];
		  //Copy field
		  if (array_key_exists($fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA2'], $parentrecord))
			 $record[$form_fieldname] = $parentrecord[$fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA2']];
		  //Primary
		  if (array_key_exists($fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA3'], $parentrecord))
			 $record[$form_fieldname . '_prim'] = $parentrecord[$fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA3']];
		  // Secundary
		  if (array_key_exists($fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA4'], $parentrecord))
			 $record[$form_fieldname . '_secd'] = $parentrecord[$fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA4']];
		  // Terciary
		  if (!empty($fieldrecord['FIELD_EXTRA9'])) {
			 if (array_key_exists($fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA9'], $parentrecord))
			     $record[$form_fieldname . '_terc'] = $parentrecord[$fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA9']];
		  }
        }
        if (!array_key_exists($form_fieldname, $record) || $record[$form_fieldname] === '')
		  $record[$form_fieldname] = trim($fieldrecord['FIELD_DEFAULT']);
    }

    function placeEditField($msg, $form_fieldname, $fieldrecord, $record, &$form, $jsevents) {
		IF ($this->debug===true) { 
			echo 'Metodo linea:'. __METHOD__ .' '. __FILE__ .':'.__LINE__; 
			pre('record');
			
			ECHO "placedit lookup ";
			echo "formfield";
			pre($form_fieldname);
			PRE($fieldrecord);
			$te=debug_backtrace();$posx=0;$pos=0;
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"])){
					if ($t==$posx)
						echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
					echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
				}
			}
		}
			
        $criteria = '';
        $has_terciary = (!empty($fieldrecord['FIELD_EXTRA9'])) ? true : false;
        if (!array_key_exists($form_fieldname, $record))
		  $record[$form_fieldname] = '';
        if (!array_key_exists($form_fieldname . '_prim', $record))
		  $record[$form_fieldname . '_prim'] = '';
        if (!array_key_exists($form_fieldname . '_secd', $record))
		  $record[$form_fieldname . '_secd'] = '';
        if (!array_key_exists($form_fieldname . '_terc', $record))
		  $record[$form_fieldname . '_terc'] = '';
        if ($fieldrecord['FIELD_READONLY'] == CLX_NUM_ONE || $fieldrecord['FIELD_HIDDEN'] == CLX_NUM_ONE) {
		  $form->addArgument($form_fieldname, (array_key_exists($form_fieldname, $record)) ? $record[$form_fieldname] : '');
		  $form->addArgument($form_fieldname . '_prim', $record[$form_fieldname . '_prim']);
		  $form->addArgument($form_fieldname . '_secd', $record[$form_fieldname . '_secd']);
		  $form->addArgument($form_fieldname . '_terc', $record[$form_fieldname . '_terc']);
		  $table = $this->placeViewField($form_fieldname, $fieldrecord, $record, $msg);
        } else {
		  $callingpage = peekHistory();
		  $hasparent = (isset($callingpage['parentrecord'][$fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA3']]));
		  $sameasparent = (!empty($callingpage['li']) && !empty($form->arguments['li']) && $callingpage['li'] == $form->arguments['li']); //Added to prevent same parent to
		  if (empty($sameasparent) && !empty($hasparent) && $fieldrecord['FIELD_READONLY'] <> CLX_NUM_ZERO) {//This was for loading the values directly from the parent. but has a problem regarding the display since same can affect
			 $form->addArgument($form_fieldname, $callingpage['parentrecord'][$fieldrecord['FIELD_EXTRA1'] . '_' . $fieldrecord['FIELD_EXTRA3']]);
			 $form->addArgument($form_fieldname, $record[$form_fieldname]);
			 $form->addArgument($form_fieldname . '_prim', $record[$form_fieldname . '_prim']);
			 $form->addArgument($form_fieldname . '_secd', $record[$form_fieldname . '_secd']);
			 $form->addArgument($form_fieldname . '_terc', $record[$form_fieldname . '_terc']);
			 $table = $this->placeViewField($form_fieldname, $fieldrecord, $record, $msg);
		  } else {
			 $DBFL = &getTool('DBFL');
			 $table = new htmlTable(CLX_WIDTH_SIX);
			 $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
			 $cpt = dict($fieldrecord['CAPTION']);
			 if (strlen($cpt) > CLX_NUM_ZERO)
			     $table->addCell($cpt, array(CLX_PROP_CLASS => $fieldrecord['CAPTION_CLASS'], CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
			 if (isset($msg[$form_fieldname]))
			     $table->addCell($msg[$form_fieldname], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
			 if (!empty($msg[$form_fieldname . '_prim']))
			     $table->addCell($msg[$form_fieldname . '_prim'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
			 if (!empty($msg[$form_fieldname . '_secd']))
			     $table->addCell($msg[$form_fieldname . '_secd'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
			 if (!empty($msg[$form_fieldname . '_terc']))
			     $table->addCell($msg[$form_fieldname . '_terc'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
			 $copy = new htmlFieldHidden($form_fieldname, $record[$form_fieldname], CLX_NUM_30, '');
			 $prim = new htmlField($form_fieldname . '_prim', $record[$form_fieldname . '_prim'], CLX_NUM_30, '');
			 $secd = new htmlField($form_fieldname . '_secd', $record[$form_fieldname . '_secd'], CLX_NUM_30, '');
			 $terc = new htmlField($form_fieldname . '_terc', $record[$form_fieldname . '_terc'], CLX_NUM_30, '');
			 foreach ($jsevents as $key => $value) {
			     $copy->setProp($key, $value);
			     $prim->setProp($key, $value);
			     $secd->setProp($key, $value);
			 }
			 //Setting form require pref if any
			 if ($fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
			     $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
			 }
			 $class = ($fieldrecord['FIELD_REQUIRED']) ? CLX_CLASS_PROMPTREQUIRED : CLX_CLASS_PROMPT;
			 $primaryfield = $fieldrecord['FIELD_EXTRA3'];
			 $primaryfieldrecord = $DBFL->getField($primaryfield);
			 $secondaryfield = $fieldrecord['FIELD_EXTRA4'];
			 $secondaryfieldrecord = $DBFL->getField($secondaryfield);
			 if (!empty($has_terciary)) {
			     $terciaryfield = $fieldrecord['FIELD_EXTRA9'];
			     $terciaryfieldrecord = $DBFL->getField($terciaryfield);
			     if (array_key_exists($fieldrecord['TABLECODE'] . '_' . $terciaryfieldrecord['FIELDNAME'], $record)) {
			         $criteria = ' WHERE A.' . $terciaryfield . ' = ' . singleQuoteWoSq($record[$fieldrecord['TABLECODE'] . '_' . $terciaryfieldrecord['FIELDNAME']]);
			     } elseif (!empty($callingpage['parentrecord']) && array_key_exists($terciaryfieldrecord['FIELD_EXTRA1'] . '_' . $terciaryfieldrecord['FIELD_EXTRA2'], $callingpage['parentrecord'])) {
			         $criteria = ' WHERE A.' . $terciaryfield . ' = ' . singleQuoteWoSq($callingpage['parentrecord'][$terciaryfieldrecord['FIELD_EXTRA1'] . '_' . $terciaryfieldrecord['FIELD_EXTRA2']]);
			     }
			 }
			 $pfx = dict($fieldrecord['FIELDPREFIX']);
			 $sfx = dict($fieldrecord['FIELDSUFIX']);
			 /* SINGLE LOOKUP TYPE */
			 if ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_THREE) {
			     $orig = new htmlField($form_fieldname, $record[$form_fieldname], CLX_NUM_30, '');
			     $orig->setProp('onFocus', $form_fieldname . '_prim.value=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ';' . $form_fieldname . '_secd.value=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ';');
			     foreach ($jsevents as $key => $value) {
			         $orig->setProp($key, $value);
			     }
			     if ($fieldrecord['FIELD_EXTRA2'] == $fieldrecord['FIELD_EXTRA3']) {
			         $prim = new htmlFieldHidden($form_fieldname . '_prim', $record[$form_fieldname . '_prim'], CLX_NUM_30, '');
			     } else {
			         $prim = new htmlField($form_fieldname . '_prim', $record[$form_fieldname . '_prim'], CLX_NUM_30, '');
			     }
			     $prim->setProp('readonly', true);
			     $secd = new htmlField($form_fieldname . '_secd', $record[$form_fieldname . '_secd'], CLX_NUM_30, '');
			     $secd->setProp('readonly', true);
			     if (!empty($fieldrecord['FIELD_RELATED'])) {
			         if (strpos($fieldrecord['FIELD_RELATED'], '.') !== false) {
					   $fieldsplit = explode('.', $fieldrecord['FIELD_RELATED']);
					   $history = peekHistory();
					   if (array_key_exists('parentrecord', $history) && !empty($history['parentrecord'])) {
						  $record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']] = $history['parentrecord'][$history['parentrecord']['TABLECODE'] . '_' . $fieldsplit[CLX_NUM_ONE]];
					   } else {
						  $record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']] = '';
					   }
					   unset($fieldsplit);
			         }
			         $fr = '&rf=' . urlencode($record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']]);
			         $fr .= '&rfi=' . $fieldrecord['PFID'];
			     } else {
			         $fr = '';
			     }
			     $tablecode = $fieldrecord['TABLECODE'];
			     $fieldid = $fieldrecord['ID'];
			     //Detai;
			     $url = 'javascript: showpanel(' . singleQuote('DIV_' . $form_fieldname) . ');';
			     $link = getSkinIcon('install', $url, dict('GEN_LBL_DETAIL'));
                    $url = 'javascript: openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=EDIT&ac=SEARCH&tc=' . $tablecode . '&fid=' . $fieldid . $fr) . ', ' . CLX_SRCH_WIN_DEF_WIDTH . ', ' . CLX_SRCH_WIN_DEF_HEIGHT . ',null,'.singlequote($form_fieldname).','.singlequote( __FILE__ .'_'. __LINE__ ) .');';
			     //If search listing then use listing on search else use just the value
			     if (!empty($fieldrecord['SRCH_LISTING'])) {
                        $url = 'javascript:formToCookie(' . singleQuote('theForm') . ');openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=EDIT&nofr=1&no_menu=1&no_alerts=1&nofr=1&pfid=' . $fieldrecord['PFID'] . '&ac=POPLIST&li=' . $fieldrecord['SRCH_LISTING']) . ',800, 500,null,'.singlequote($form_fieldname).','.singlequote( __FILE__ .'_'. __LINE__ ) .');';
			     }
			     $link .= getSkinIcon('view', $url, dict('GEN_LBL_SEARCH'));
			     $table->addCell(dict($fieldrecord['FIELDFORMLABEL']), array(CLX_PROP_CLASS => $class));
			     $src = $pfx . $orig->source() . $sfx . $link .
					   ' <div id="DIV_' . $form_fieldname . '" name="DIV_' . $form_fieldname . '"  style="display: none;">';
			     if ($fieldrecord['FIELD_EXTRA2'] == $fieldrecord['FIELD_EXTRA3']) {
			         $src .= $prim->source();
			     } else {
			         $src .= '<br>' . dict($primaryfieldrecord['FIELDFORMLABEL']) . ':<br>' . dict($primaryfieldrecord['FIELDPREFIX']) . $prim->source() . dict($primaryfieldrecord['FIELDSUFIX']);
			     }
			     $src .= '<br>' . dict($secondaryfieldrecord['FIELDFORMLABEL']) . ':<br>' . dict($secondaryfieldrecord['FIELDPREFIX']) . $secd->source() . dict($secondaryfieldrecord['FIELDSUFIX']) . '</div>';
			     $table->addCell($src, array(CLX_PROP_CLASS => CLX_CLASS_DATA, 'nowrap' => 'true', CLX_PROP_COLSPAN => '6'));
			     /*
			      * OPEN LOOKUP TYPE
			      */
			 } elseif ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_TWO) {
			     $secd = new htmlFieldHidden($form_fieldname . '_secd', $record[$form_fieldname . '_secd'], CLX_NUM_30, '');
			     if (!empty($fieldrecord['FIELD_RELATED'])) {
			         if (strpos($fieldrecord['FIELD_RELATED'], '.') !== false) {
					   $fieldsplit = explode('.', $fieldrecord['FIELD_RELATED']);
					   $history = peekHistory();
					   //print_r($history);
					   if (array_key_exists('parentrecord', $history) && !empty($history['parentrecord'])) {
						  $record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']] = $history['parentrecord'][$history['parentrecord']['TABLECODE'] . '_' . $fieldsplit[CLX_NUM_ONE]];
					   } else {
						  $record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']] = '';
					   }
					   unset($fieldsplit);
			         }
			         //e cho urlencode(CLX_CHAR_SINGLE_QUOTE).'<br>';
			         $fr = '&rf=' . urlencode($record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']]);
			         $fr .= '&rfi=' . $fieldrecord['PFID'];
			     } else {
			         $fr = '';
			     }
			     $tablecode = $fieldrecord['TABLECODE'];
			     $fieldid = $fieldrecord['ID'];
                    $url = 'javascript:openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=EDIT&ac=SEARCH&nofr=1&no_menu=1&no_alerts=1&tc=' . $tablecode . '&fid=' . $fieldid . ' ' . $fr) . ', 705, 400,null,null,'.singlequote( __FILE__ .'_'. __LINE__ ) .');';
			     //If search listing then use listing on search else use just the value
			     if (!empty($fieldrecord['SRCH_LISTING'])) {
                        $url = 'javascript:formToCookie(' . singleQuote('theForm') . ');openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=EDIT&nofr=1&no_menu=1&no_alerts=1&nofr=1&pfid=' . $fieldrecord['PFID'] . '&ac=POPLIST&li=' . $fieldrecord['SRCH_LISTING']) . ',' . CLX_SRCH_WIN_DEF_WIDTH . ', ' . CLX_SRCH_WIN_DEF_HEIGHT . ',null,'.singlequote($form_fieldname).','.singlequote( __FILE__ .'_'. __LINE__ ) .' );';
			     }
                    $link = getSkinIcon('view', 'javascript:openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . $url . ', ' . CLX_SRCH_WIN_DEF_WIDTH . ', ' . CLX_SRCH_WIN_DEF_HEIGHT . ',null,'.singlequote($form_fieldname).');', dict('GEN_LBL_SEARCH'));
			     $table->addCell(dict($fieldrecord['FIELDFORMLABEL']), array(CLX_PROP_CLASS => $class));
			     $table->addCells(CLX_CLASS_DATA, array($pfx . $prim->source() . $sfx . $link . $secd->source()));
			     /*
			      * SELECT LOOKUP TYPE
			      */
			 } elseif ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_ONE) { // Select Display lookup
			     $tablerecord = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($fieldrecord['FIELD_EXTRA1']));
			     $sqltable = $tablerecord['MODULECODE'] . '_' . $tablerecord['IDNAME'];
			     //Test Access Tree
			     if ($_SESSION['user_record']['isadmin'] !== '1') {
			         $tlooks = ClxCommon::$db->executeQuery('SELECT	TF.TABLECODE TABLECODE, F.*  FROM CLX_DB_TABLEFIELDS TF, CLX_DB_FIELDS F WHERE TF.TABLECODE = ' . singleQuote($fieldrecord['FIELD_EXTRA1']) . '  AND TF.FIELDNAME = F.FIELDNAME  AND F.FIELDTYPE = ' . singleQuote('TLO') . '');
			         $has_tlook_field = ClxCommon::$db->numRows($tlooks);
			     } else {
			         $has_tlook_field = false;
			     }
			     if (!empty($has_tlook_field)) {
			         $tboolean = '';
			         $ACTR = &getTool('ACTR');
			         while (($tlook_field = ClxCommon::$db->getNextRecord($tlooks))) {
					   $nodes = $ACTR->getUserNodes($tlook_field['FIELD_EXTRA1']);
					   foreach ($nodes as $node) {
						  $tcriteria .= $tboolean . ' A.' . $tlook_field['fieldname'] . ' LIKE ' . singleQuote($node . '%');
						  $tboolean = ' OR ';
					   }
			         }
					 ClxCommon::$db->freeResult( $tlooks );
			         if (strlen($tcriteria) > CLX_NUM_ZERO)
					   $criteria = ' WHERE (' . $tcriteria . ')';
			     }
			     // Adding related fields
			     if (!empty($fieldrecord['FIELD_RELATED']) && array_key_exists($fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED'], $record)) {
			         $field_related = $fieldrecord['FIELD_RELATED'];
			         //Test if lookup to lookup to search under parent
			         $lookrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME = ' . singleQuote($field_related));
			         if (!ClxCommon::$db->fieldExists($sqltable, $field_related)) {
					   $field_related = $lookrec['FIELD_EXTRA2'];
			         }
			         if (strlen($criteria) > CLX_NUM_ZERO) {
					   $criteria .= ' AND A.' . $field_related . ' =' . singleQuote($record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']]) . ' ';
			         } else {
					   $criteria = ' WHERE A.' . $field_related . ' =' . singleQuote($record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']]) . ' ';
			         }
			     }
			     $ACFS = &getTool('ACFS');
			     $fcriteria = $ACFS->get_lookup_criteria($tablerecord['IDCODE'], 'A');
			     if ($fcriteria <> '') {
			         if (strlen($criteria) > CLX_NUM_ZERO) {
					   $criteria .= ' AND ' . $fcriteria;
			         } else {
					   $criteria = ' WHERE ' . $fcriteria;
			         }
			     }
			     if (!empty($has_terciary)) {
			         $sql = 'SELECT A.' . $fieldrecord['FIELD_EXTRA2'] . ' COPY, A.' . $fieldrecord['FIELD_EXTRA3'] . ' PRIM, A.' . $fieldrecord['FIELD_EXTRA4'] . ' SEC, A.' . $fieldrecord['FIELD_EXTRA9'] . ' TERC FROM ' . $sqltable . ' A ' . $criteria . ' ORDER BY ' . $fieldrecord['FIELD_EXTRA2'];
			     } else {
			         $sql = 'SELECT A.' . $fieldrecord['FIELD_EXTRA2'] . ' COPY, A.' . $fieldrecord['FIELD_EXTRA3'] . ' PRIM, A.' . $fieldrecord['FIELD_EXTRA4'] . ' SEC, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' TERC FROM ' . $sqltable . ' A ' . $criteria .
						  ' ORDER BY ' . $fieldrecord['FIELD_EXTRA2'];
			     }
			     if ($sqltable === '_') {
			         ClxCommon::$db->reportError($sql, CLX_NUM_ZERO, 'Missing table: ' . $fieldrecord['FIELD_EXTRA1'] . ' required on lookup: ' . $fieldrecord['FIELDNAME'], array());
			     }

			     $results = ClxCommon::$db->executeQuery($sql);
			     $select = new htmlSelect($form_fieldname);
			     foreach ($jsevents as $key => $value) {
			         $select->setProp($key, $value);
			     }
			     $select->addItem('', '', true);
			     while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			         //TO BE IMPLEMENTED LOOKUP INSEDE LOOKUP
			         if ($result['TERC'] <> '')
					   $result['TERC'] = ', ' . $result['TERC'];
			         $select->addItem($result['PRIM'] . ', ' . $result['SEC'] . $result['TERC'], $result['COPY'], (array_key_exists($form_fieldname, $record) && $result['COPY'] == $record[$form_fieldname]));
			     }
				 ClxCommon::$db->freeResult( $results );
			     $table->addCell(dict($fieldrecord['FIELDFORMLABEL']), array(CLX_PROP_CLASS => $class));
			     $table->addCell($pfx . $select->source() . $sfx, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => '5'));
			     /*
			      * DEFAULT LOOKUP TYPE
			      */
			 }else {
			     if (!empty($fieldrecord['FIELD_RELATED'])) {
			         if (strpos($fieldrecord['FIELD_RELATED'], '.') !== false) {
					   $fieldsplit = explode('.', $fieldrecord['FIELD_RELATED']);
					   $history = peekHistory();
					   //print_r($history);
					   if (array_key_exists('parentrecord', $history) && !empty($history['parentrecord']) && array_key_exists($history['parentrecord']['TABLECODE'] . '_' . $fieldsplit[CLX_NUM_ONE], $history['parentrecord'])) {
						  $record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']] = $history['parentrecord'][$history['parentrecord']['TABLECODE'] . '_' . $fieldsplit[CLX_NUM_ONE]];
					   } else {
						  $record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']] = '';
					   }
					   unset($fieldsplit);
			         }
			         //e cho urlencode(CLX_CHAR_SINGLE_QUOTE).'<br>';
			         $fr = '&rf=' . urlencode($record[$fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELD_RELATED']]);
			         $fr .= '&rfi=' . $fieldrecord['PFID'];
			     } else {
			         $fr = '';
			     }

			     $tablecode = $fieldrecord['TABLECODE'];
			     $fieldid = $fieldrecord['ID'];
                    $url = 'javascript:openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=EDIT&ac=SEARCH&tc=' . $tablecode . '&fid=' . $fieldid . $fr) . ', 820, 400, null, '.singlequote($form_fieldname) . ','.singlequote( __FILE__ .'_'. __LINE__ ) .' );';
			     //If search listing then use listing on search else use just the value
			     if (!empty($fieldrecord['SRCH_LISTING'])) {
                        $url = 'javascript:formToCookie(' . singleQuote('theForm') . ');openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=EDIT&nofr=1&nofr=1&no_menu=1&no_alerts=1&pfid=' . $fieldrecord['PFID'] . '&ac=POPLIST&li=' . $fieldrecord['SRCH_LISTING']) . ',810, 400,null,'.singlequote($form_fieldname).','.singlequote( __FILE__ .'_'. __LINE__ ) .');';
			     }
			     $link = getSkinIcon('view', $url, dict('GEN_LBL_SEARCH'));
			     $table->addCell(dict($fieldrecord['FIELDFORMLABEL']), array(CLX_PROP_CLASS => $class));
			     $table->addCells(CLX_CLASS_DATA, array($pfx . dict($primaryfieldrecord['FIELDFORMLABEL']), $copy->source() . $prim->source(), dict($secondaryfieldrecord['FIELDFORMLABEL']), $secd->source() . $sfx, $link));
			     if (!empty($has_terciary)) {
			         $table->addCells(CLX_CLASS_DATA, array(CLX_CHAR_HTML_NBSP, dict($terciaryfieldrecord['FIELDFORMLABEL']), $terc->source(), CLX_CHAR_HTML_NBSP, CLX_CHAR_HTML_NBSP, CLX_CHAR_HTML_NBSP));
			     } else {
			         if (is_object($form) && method_exists($form, 'addArgument'))
					   $form->addArgument($form_fieldname . '_terc', '');
			     }
			 }// End if type
		  }
        }
		if ( $this->debug==true && isset($GLOBALS['placelistcount']) && $GLOBALS['placelistcount']<200) {
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");$pos=0;
			fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."dbft_lookup-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			$te=debug_backtrace();
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"]))
					fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
				
			}

			fwrite($tta,chr(13).chr(10)."placeListFieldText: ".print_r($fieldrecord,true));
			fclose($tta);
		}
        return $table;
    }

    function fieldObject(&$form_fieldname, &$fieldrecord, $record) {
        die('Somebody called the fieldObject function inside the lookup field<br>');
    }

    function placeViewField($form_fieldname, $fieldrecord, $record, $msg = array()) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        if (empty($fieldrecord['FIELD_HIDDEN'])) {
		  if (empty($fieldrecord['FIELD_EXTRA6'])) {// No form to lookup
			 $cpt = dict($fieldrecord['CAPTION']);
			 if (strlen($cpt) > CLX_NUM_ZERO)
			     $table->addCell($cpt, array(CLX_PROP_CLASS => $fieldrecord['CAPTION_CLASS'], CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			 if (!empty($msg[$form_fieldname]))
			     $table->addCell($msg[$form_fieldname], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			 $pfx = dict($fieldrecord['FIELDPREFIX']);
			 $sfx = dict($fieldrecord['FIELDSUFIX']);
			 $cell = $this->formatField($form_fieldname, $fieldrecord, $record);
			 // Field Anchor
			 $cell = $this->placeFieldAnchor($form_fieldname, $fieldrecord, $record, $cell);
			 $table->addCell(dict($fieldrecord['FIELDFORMLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			 $table->addCell($pfx . $cell . $sfx, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		  } else {
			 $table->addCell(dict($fieldrecord['FIELDFORMLABEL']), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
			 if (!empty($record[$form_fieldname])) {//test if lookup id exists
			     $UIFM = &getTool('UIFM');
			     $EDIT = &getTool('EDIT');
			     $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote($fieldrecord['FIELD_EXTRA6']));
			     $tablerec = tableRecord($fieldrecord['FIELD_EXTRA1']);
			     $tablename = tableName($fieldrecord['FIELD_EXTRA1']);
			     $lookupid = ClxCommon::$db->getField($tablename, 'ID', $fieldrecord['FIELD_EXTRA2'] . '=' . singleQuote($record[$form_fieldname]));
			     if (!empty($lookupid)) {//test ir id return something
			         $lookuprec = $EDIT->loadRecord_($tablerec, $lookupid, true);
			         $form = $UIFM->userViewForm($formrec, '', $lookuprec);
			     } else {
			         $form = '';
			     }
			 } else {
			     $form = '';
			 }
			 $table->addCell($form, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		  }
        }//end if !hidden
        return $table;
    }

    function searchFieldObject($form_fieldname, $fieldrecord, $record) {
        $DBFL = &getTool('DBFL');
        $copyfieldrec = $DBFL->getField($fieldrecord['FIELD_EXTRA2']);
        $fieldobj = new htmlField($form_fieldname, (array_key_exists($form_fieldname, $record)) ? $record[$form_fieldname] : '', $copyfieldrec['FIELD_DISPLAYSIZE'], $copyfieldrec['FIELD_SIZE']);
        return $fieldobj;
    }

    /**
     * Build session key for filters
     */
    function setQuickFilters($tablecode, $fieldname, $fieldrecord, $record) {
        $criteria = '';
        if ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_ZERO) {//Lookup default type
		  $record = $this->getLookupValue($tablecode . '_' . $fieldname, $fieldrecord, $record);
		  if (!empty($record[$tablecode . '_' . $fieldname]) && is_array($record[$tablecode . '_' . $fieldname])) {
			 $in = '';
			 $and = '';
			 reset($record[$tablecode . '_' . $fieldname]);
			 foreach ($record[$tablecode . '_' . $fieldname] as $k => $v) {
			     if ($v === '')
			         continue;
			     $in .= $and . singleQuote(str_replace(CLX_CHAR_SINGLE_QUOTE, '', $v));
			     $and = ',';
			 }
			 if (strlen($in) > CLX_NUM_ZERO) {
			     $criteria .= $tablecode . '.' . $fieldname . ' IN (' . $in . ')';
			 }
		  } else {
			 $has_something = false;
			 if (empty($has_something) && array_key_exists($tablecode . '_' . $fieldname, $record) && strlen($record[$tablecode . '_' . $fieldname]) > CLX_NUM_ZERO) {
			     $has_something = true;
			 }
			 if (empty($has_something) && array_key_exists($tablecode . '_' . $fieldname . '_prim', $record) && strlen($record[$tablecode . '_' . $fieldname . '_prim']) > CLX_NUM_ZERO) {
			     $has_something = true;
			 }
			 if (empty($has_something) && array_key_exists($tablecode . '_' . $fieldname . '_secd', $record) && strlen($record[$tablecode . '_' . $fieldname . '_secd']) > CLX_NUM_ZERO) {
			     $has_something = true;
			 }
			 if (empty($has_something) && array_key_exists($tablecode . '_' . $fieldname . '_terc', $record) && strlen($record[$tablecode . '_' . $fieldname . '_terc']) > CLX_NUM_ZERO) {
			     $has_something = true;
			 }
			 if (array_key_exists($tablecode . '_' . $fieldname, $record) && strlen($record[$tablecode . '_' . $fieldname]) > CLX_NUM_ZERO) {
					if (strpos($record[$tablecode . '_' . $fieldname.'_prim'], '%')!==false)
						$criteria = $tablecode . '.' . $fieldname . ' LIKE ' . singleQuote($record[$tablecode . '_' . $fieldname.'_prim']) . ' ';
					else	
			     		$criteria = $tablecode . '.' . $fieldname . ' = ' . singleQuote($record[$tablecode . '_' . $fieldname]) . ' ';
			 } elseif ($has_something && strlen($record[$tablecode . '_' . $fieldname]) == CLX_NUM_ZERO) {
			     $criteria = $tablecode . '.' . $fieldname . ' = ' . singleQuote('CLX_NOVALUEFOUNDONSEARC') . ' ';
			 }
		  }
        } else {
		  if (array_key_exists($tablecode . '_' . $fieldname, $record) && strlen($record[$tablecode . '_' . $fieldname]) > CLX_NUM_ZERO) {
			 $criteria = $tablecode . '.' . $fieldname . ' = ' . singleQuote(str_replace(CLX_CHAR_SINGLE_QUOTE, '', $record[$tablecode . '_' . $fieldname]));
		  }
        }
        return $criteria;
    }

    function validateField(&$msg, $form_fieldname, $fieldrecord, &$record, &$table, &$form) {
        $has_terciary = (!empty($fieldrecord['FIELD_EXTRA9'])) ? true : false;
        //Setting form require pref if any
        if (array_key_exists('FIELD_FORM_REQUIRED', $fieldrecord) && $fieldrecord['FIELD_FORM_REQUIRED'] != CLX_NUM_TWO) {
		  $fieldrecord['FIELD_REQUIRED'] = $fieldrecord['FIELD_FORM_REQUIRED'];
        }

        // Note: !array_key_exists was added to enable lookups to validate
        if (!array_key_exists('FIELD_HIDDEN', $fieldrecord))
		  $fieldrecord['FIELD_HIDDEN'] = false;
        //Setting hidden to override required
        if (!empty($fieldrecord['FIELD_HIDDEN'])) {
		  $fieldrecord['FIELD_REQUIRED'] = CLX_INIT_ZERO;
        }
        // Setting look type select validation
        if ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_THREE) {
		  $record[$form_fieldname] = trim($record[$form_fieldname]);
		  if (!empty($fieldrecord['FIELD_REQUIRED']) && empty($record[$form_fieldname])) {
			IF(UserRequest::$request['ac']!='DELETE')
			 $msg[$form_fieldname] = dict('GEN_ERR_REQUIRED_FIELD');
		  } else {
			 $tablename = tableName($fieldrecord['FIELD_EXTRA1']);
			 $criteria = '';
			 if (strlen($record[$form_fieldname]) > CLX_NUM_ZERO) {
			     $ftype = ClxCommon::$db->getField('CLX_DB_FIELDS', 'FIELDTYPE', 'FIELDNAME=' . singleQuote($fieldrecord['FIELD_EXTRA2']));
			     if ($ftype === 'DECN' || $ftype === 'INTN' || $ftype == 'BOOL') {
			         $original = $record[$form_fieldname];
			         if ($record[$form_fieldname] === '')
					   $record[$form_fieldname] = CLX_INIT_ZERO;
			         $record[$form_fieldname] = $original;
			         unset($original);
			         $criteria = $fieldrecord['FIELD_EXTRA2'] . ' = ' . $record[$form_fieldname];
			     }else {
			         $criteria = $fieldrecord['FIELD_EXTRA2'] . ' = ' . singleQuoteWoSq($record[$form_fieldname]);
			     }
                    $qty = ClxCommon::$db->oneExistsRecords($tablename, $criteria);
			     if ($qty == CLX_NUM_ZERO) {
			         //   Para que aparezca el valor que no encontro
			         $msg[$form_fieldname] = dict('GEN_ERR_KEY_DONT_EXIST', $record[$form_fieldname]);
			     }
			 }
		  }
		  $record[$form_fieldname . '_prim'] = '';
		  $record[$form_fieldname . '_secd'] = '';
		  $record[$form_fieldname . '_terc'] = '';
        } elseif ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_TWO) {
		  $record[$form_fieldname . '_prim'] = trim($record[$form_fieldname . '_prim']);
		  if (UserRequest::$request['ac']!='DELETE' &&$fieldrecord['FIELD_REQUIRED'] === '1' && empty($record[$form_fieldname . '_prim'])) {
			 $msg[$form_fieldname . '_prim'] = dict('GEN_ERR_REQUIRED_FIELD');
		  }
        } elseif ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_ONE) {
		  if (UserRequest::$request['ac']!='DELETE' && $fieldrecord['FIELD_REQUIRED'] === '1' && empty($record[$form_fieldname])) {
			 $msg[$form_fieldname . '_prim'] = dict('GEN_ERR_REQUIRED_FIELD');
		  }
        } else {
		  $something = ((!empty($record[$form_fieldname . '_prim'])) or ( !empty($record[$form_fieldname . '_secd'])));
		  $required = ($fieldrecord['FIELD_REQUIRED']);
		  if (UserRequest::$request['ac']!='DELETE' &&!empty($required) && empty($something)) {
			 $msg[$form_fieldname . '_prim'] = dict('GEN_ERR_REQUIRED_FIELD');
		  } elseif (!empty($required) or ! empty($something)) {
			 $tablecode = $fieldrecord['FIELD_EXTRA1'];
			 $idfield = $fieldrecord['FIELD_EXTRA2'];
			 $primaryfield = $fieldrecord['FIELD_EXTRA3'];
			 $secondaryfield = $fieldrecord['FIELD_EXTRA4'];
			 $tablerecord = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
			 $sqltable = $tablerecord['MODULECODE'] . '_' . $tablerecord['IDNAME'];
			 $primaryfieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($primaryfield));
			 $primaryfieldobj = getToolObject('DBFT', $primaryfieldrec['FIELDTYPE']);
			 $secondaryfieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($secondaryfield));
			 $secondaryfieldobj = getToolObject('DBFT', $secondaryfieldrec['FIELDTYPE']);
			 if (!empty($has_terciary)) {
			     $terciaryfield = $fieldrecord['FIELD_EXTRA9'];
			     $terciaryfieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($terciaryfield));
			     $terciaryfieldobj = getToolObject('DBFT', $terciaryfieldrec['FIELDTYPE']);
			 }
			 $criteria = '';
			 $altcriteria = '';
			 $boolean = '';
			 $usedfields = CLX_INIT_ZERO;
			 if (strlen($record[$form_fieldname . '_prim']) > CLX_NUM_ZERO) {
			     //If look it will solve already the relation.
			     if ($secondaryfieldrec['FIELDTYPE'] === 'LOOK')
			         $primaryfieldobj->validateField($msg, $form_fieldname . '_prim', $primaryfieldrec, $record, $table, $form);
			     if ($primaryfieldrec['FIELDTYPE'] === 'CHAR') {
			         $criteria .= $boolean . $primaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_prim']);
			         $altcriteria .= $boolean . $primaryfield . ' LIKE ' . singleQuoteWoSq($record[$form_fieldname . '_prim'] . '%');
			         $boolean = ' AND ';
			     } else {
			         $criteria .= $boolean . $primaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_prim']);
			         $altcriteria .= $boolean . $primaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_prim']);
			         $boolean = ' AND ';
			     }
			     $usedfields++;
			 }
			 //If look it will solve already the relation.
			 if (strlen($record[$form_fieldname . '_secd']) > CLX_NUM_ZERO) {
			     if ($secondaryfieldrec['FIELDTYPE'] <> 'LOOK')
			         $secondaryfieldobj->validateField($msg, $form_fieldname . '_secd', $secondaryfieldrec, $record, $table, $form);
			     if ($secondaryfieldrec['FIELDTYPE'] === 'CHAR') {
			         $criteria .= $boolean . $secondaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_secd']);
			         $altcriteria .= $boolean . $secondaryfield . ' LIKE ' . singleQuoteWoSq($record[$form_fieldname . '_secd'] . '%');
			         $boolean = ' AND ';
			     } else {
			         $criteria .= $boolean . $secondaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_secd']);
			         $altcriteria .= $boolean . $secondaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_secd']);
			         $boolean = ' AND ';
			     }
			     $usedfields++;
			 }
			 //terciary field
			 //If look it will solve already the relation.
			 if (!empty($has_terciary) && strlen($record[$form_fieldname . '_terc']) > CLX_NUM_ZERO) {
			     if ($terciaryfieldrec['FIELDTYPE'] <> 'LOOK')
			         $terciaryfieldobj->validateField($msg, $form_fieldname . '_terc', $terciaryfieldrec, $record, $table, $form);
			     if ($terciaryfieldrec['FIELDTYPE'] === 'CHAR') {
			         $criteria .= $boolean . $terciaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_terc']);
			         $altcriteria .= $boolean . $terciaryfield . ' LIKE ' . singleQuoteWoSq($record[$form_fieldname . '_terc']);
			         $boolean = ' AND ';
			     } else {
			         $criteria .= $boolean . $terciaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_terc']);
			         $altcriteria .= $boolean . $terciaryfield . ' = ' . singleQuoteWoSq($record[$form_fieldname . '_terc']);
			         $boolean = ' AND ';
			     }
			     $usedfields++;
			 }
			 $qty = ClxCommon::$db->countRecords($sqltable, $criteria);
			 if (($primaryfieldrec['FIELDTYPE'] === 'CHAR') or ( $secondaryfieldrec['FIELDTYPE'] === 'CHAR')) {
			     $altqty = ClxCommon::$db->countRecords($sqltable, $altcriteria);
			 } else {
			     $altqty = $qty;
			 }
			 if (($qty == CLX_NUM_ONE)) {
			     // do nothing.
			 } elseif (($qty + $altqty) == CLX_NUM_ZERO) {
			     $msg[$form_fieldname] = dict('GEN_ERR_KEY_DONT_EXIST', '');
			 } elseif (($qty > CLX_NUM_ONE) or ( $altqty > CLX_NUM_ONE)) {
			     //If more than one found may give error on multiple keys like code, efftdate. thats the reason is comented
			 }


			 if (count($msg) == CLX_NUM_ZERO) {
             // ivan 2022-04-04 comente los sql en participante like '%3%' se comoe la memoria 
			 // los record estan comentados asi que nada hace la consulta
			     if ($qty == CLX_NUM_ONE) {
             //           $lookrec = ClxCommon::$db->getRecord($sqltable, $criteria);
			     } else {
             //           $lookrec = ClxCommon::$db->getRecord($sqltable, $altcriteria);
			     }
			     /* $record[$form_fieldname] = $lookrec[uppercase($idfield)];
			       $record[$form_fieldname . '_prim'] = $lookrec[uppercase($primaryfield)];
			       $record[$form_fieldname . '_secd'] = $lookrec[uppercase($secondaryfield)];
			       $record[$form_fieldname . '_terc'] = ($has_terciary) ? $lookrec[uppercase($terciaryfield)] : ''; */
			 } else {
			     //$record[$form_fieldname] = '';
			 }
		  } else {
			 //$record[$form_fieldname] = '';
		  }
        }// End display
    }

    function validateImportField(&$msg, $fieldrecord, $fieldvalue) {
        if ($fieldrecord['FIELD_REQUIRED'] == CLX_NUM_ZERO && $fieldvalue === 'null') {
		  return;
        } else {
		  $something = (strlen($fieldvalue) > CLX_NUM_ZERO);
		  $required = ($fieldrecord['FIELD_REQUIRED']);
		  if (empty($something) and ! empty($required)) {
			 $msg[$fieldrecord['FIELDNAME']] = dict('GEN_ERR_REQUIRED_FIELD');
		  } elseif (!empty($something)) {
			 if ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_TWO) {
			     return;
			 }
			 $tablename = tableName($fieldrecord['FIELD_EXTRA1']);
                $qty = ClxCommon::$db->oneExistsRecords($tablename, $fieldrecord['FIELD_EXTRA2'] . '= ' . singleQuoteWoSq($fieldvalue));
			 if ($qty == CLX_NUM_ZERO) {
			     //   - Se corrije el reporte del valor que no consigue. Estaba poniendo el nombre del campo
			     $msg[$fieldrecord['FIELDNAME']] = dict('GEN_ERR_KEY_DONT_EXIST', $fieldvalue);
			 }
		  }
        }
    }

    /**
     * Sabes field(non-PHPdoc)
     * @see dbft::saveField()
     */
    function saveField($form_fieldname, $fieldrecord, &$record, $recordid = null) {
        if (!array_key_exists($form_fieldname, UserRequest::$post))
		  $record[$form_fieldname] = '';
        //[FICO_SALES_EXEC_prim] =>
        //  [FICO_SALES_EXEC_secd] =>
        if ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_ZERO) {
		  $have_something = false;
		  if (array_key_exists($form_fieldname . '_prim', UserRequest::$post) && UserRequest::$post[$form_fieldname . '_prim'] <> '') {
			 $have_something = true;
		  }
		  if (array_key_exists($form_fieldname . '_secd', UserRequest::$post) && UserRequest::$post[$form_fieldname . '_secd'] <> '') {
			 $have_something = true;
		  }
		  if (!empty($have_something)) {
			 $record[$fieldrecord['FIELDNAME']] = UserRequest::$post[$form_fieldname];
		  } else {
			 $record[$fieldrecord['FIELDNAME']] = '';
		  }
        } else {
		  $record[$fieldrecord['FIELDNAME']] = UserRequest::$post[$form_fieldname];
        }
        if ($fieldrecord['FIELD_REQUIRED'] == CLX_NUM_ZERO && $record[$fieldrecord['FIELDNAME']] === '') {
		  $record[$fieldrecord['FIELDNAME']] = 'null';
        }
    }

    function loadField($form_fieldname, &$fieldrecord, &$record, $values) {
        $has_terciary = (!empty($fieldrecord['FIELD_EXTRA9'])) ? true : false;
        $record[$form_fieldname] = $values[uppercase($fieldrecord['FIELDNAME'])];
        if (array_key_exists($fieldrecord['FIELDNAME'], $values)) {
		  $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($fieldrecord['FIELD_EXTRA1']));
		  if (!empty($tablerec)) { //If table is found
			 $criteria_terc = '';
			 if (!empty($has_terciary)) {
			     $callingpage = peekHistory();
			     $terciaryfield = $fieldrecord['FIELD_EXTRA9'];
			     $terciaryfieldrecord = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($terciaryfield));
			     //print_r($terciaryfieldrecord);//FIELD_EXTRA2
			     if (!empty($callingpage['parentrecord']) && array_key_exists($terciaryfieldrecord['FIELD_EXTRA1'] . '_' . $terciaryfieldrecord['FIELD_EXTRA2'], $callingpage['parentrecord'])) {
			         $criteria_terc = ' AND ' . $terciaryfield = singleQuote($callingpage['parentrecord'][$terciaryfieldrecord['FIELD_EXTRA1'] . '_' . $terciaryfieldrecord['FIELD_EXTRA2']]);
			     }/*
			       esto necesita revision, trata de dar un tercer criterio pero falla en lo que la forma tiene un campo con el mismo valor
			       lo que hace perder la referencia. del lookup ver como se peude reprogramar basado en la relacion del lookup
			       elseif(array_key_exists($terciaryfieldrecord['fieldname'], $values) && $values[$terciaryfieldrecord['fieldname']]<>''){
			       $criteria_terc = ' AND ' . $terciaryfield = '' . $values[$terciaryfieldrecord['fieldname']]);
			       } */
			 }
			 $lookrec = ClxCommon::$db->getRecord($tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'], $fieldrecord['FIELD_EXTRA2'] . '=' . singleQuote($values[$fieldrecord['FIELDNAME']]) . ' ' . $criteria_terc);
             if (!empty($lookrec)) { 
			 	$record[$form_fieldname] = $lookrec[uppercase($fieldrecord['FIELD_EXTRA2'])];
             }
			 if (is_array($lookrec)) {
			     $record[$form_fieldname . '_prim'] = (array_key_exists(uppercase($fieldrecord['FIELD_EXTRA3']), $lookrec)) ? $lookrec[uppercase($fieldrecord['FIELD_EXTRA3'])] : '';
			     $record[$form_fieldname . '_secd'] = (array_key_exists(uppercase($fieldrecord['FIELD_EXTRA4']), $lookrec)) ? $lookrec[uppercase($fieldrecord['FIELD_EXTRA4'])] : '';
			     $record[$form_fieldname . '_terc'] = (array_key_exists(uppercase($fieldrecord['FIELD_EXTRA9']), $lookrec) && $has_terciary) ? $lookrec[uppercase($fieldrecord['FIELD_EXTRA9'])] : '';
			 }
		  } else {
			 $l = 'Table ' . $fieldrecord['FIELD_EXTRA1'] . ' not found for lookup field ' . $fieldrecord['FIELDNAME'];
                if (ClxCommon::$db->oneExistsRecords('CLX_BUGS', 'ERRMSG = ' . singleQuote($l)) == CLX_NUM_ZERO) {//solo reportando 1 vez
			     $BUGS = &getTool('BUGS');
			     $BUGS->report(E_USER_NOTICE, $l, UserRequest::$server['SCRIPT_NAME'], 'objects/dbft_lookup line 1010', UserRequest::$request, CLX_NUM_ONE, $l, UserRequest::$server['SCRIPT_NAME'], 'objects/dbft_lookup line 1010');
			 }
			 $record[$form_fieldname] = '';
			 $record[$form_fieldname . '_prim'] = '';
			 $record[$form_fieldname . '_secd'] = '';
			 $record[$form_fieldname . '_terc'] = '';
		  }
        }
    }

    function set_obj_cache(&$fieldrecord) {
        if (empty($this->obj_cache[$fieldrecord['FIELDNAME']])) {
		  $DBFL = &getTool('DBFL');
		  $this->obj_cache[$fieldrecord['FIELDNAME']]['tablename'] = tableName($fieldrecord['FIELD_EXTRA1']);
		  $this->obj_cache[$fieldrecord['FIELDNAME']]['copy'] = $DBFL->getField($fieldrecord['FIELD_EXTRA2']);
		  $this->obj_cache[$fieldrecord['FIELDNAME']]['prim'] = $DBFL->getField($fieldrecord['FIELD_EXTRA3']);
		  $this->obj_cache[$fieldrecord['FIELDNAME']]['secn'] = $DBFL->getField($fieldrecord['FIELD_EXTRA4']);
        }
    }

    function get_obj_subsql(&$fieldrecord) {
        $sql = '(SELECT MAX(CONCAT(' . $fieldrecord["FIELD_EXTRA3"] . ', CONCAT(", ", ' . $fieldrecord["FIELD_EXTRA4"] . '))) FROM ' . $this->obj_cache[$fieldrecord["FIELDNAME"]]['tablename'] .
			 ' WHERE ' . $fieldrecord["FIELD_EXTRA2"] . ' = ' . $fieldrecord['TABLECODE'] . '.' . $fieldrecord['FIELDNAME'] . ') ' . $fieldrecord['TABLECODE'] . '_' . $fieldrecord['FIELDNAME'];
        return $sql;
    }

    function formatField($form_fieldname, $fieldrecord, $record) {

        //Added to check for empty values then do nothing.
        if (!array_key_exists($form_fieldname, $record))
		  return CLX_CHAR_EMPTY_STRING;


        if(!empty($fieldrecord['DBQF_FIELD_FORMAT']) &&   $fieldrecord['DBQF_FIELD_FORMAT'] === '1'){
		  if (array_key_exists($form_fieldname, $record)) {
			 $original_value = $record[$form_fieldname];
		  } else {
			 $original_value = '';
		  }
		  return $original_value;
        }

        //$DBFL = &getTool('DBFL');
        //Code no format
        if (!empty($fieldrecord['DBQF_FIELD_FORMAT']) && $fieldrecord['DBQF_FIELD_FORMAT'] == CLX_NUM_ONE) {
		  $contents = htmlspecialchars($record[$form_fieldname]);
			unset($lookdata);
			unset($form_fieldname);
			unset($fieldrecord);
			unset($record);
			unset($DBLT);
			unset($fieldrecord_secd);
			unset($lookuprec);
			unset($tablename);
			unset($fieldrecord_prim);
			unset($fieldrecord_secd);
		  return $contents;
        }
        if ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_TWO && $fieldrecord['FIELDTYPE'] === 'LOOK') {
		  $contents = htmlspecialchars($record[$form_fieldname]);
			unset($lookdata);
			unset($form_fieldname);
			unset($fieldrecord);
			unset($record);
			unset($DBLT);
			unset($fieldrecord_secd);
			unset($lookuprec);
			unset($tablename);
			unset($fieldrecord_prim);
			unset($fieldrecord_secd);
		  return $contents;
        }
        $form_fieldname = uppercase($form_fieldname);
        $record = array_change_key_case($record, CASE_UPPER);
        $contents = '';
        if (array_key_exists($form_fieldname . "_prim", $record) && strlen($record[$form_fieldname . "_prim"])> 0 && array_key_exists($form_fieldname . "_secd", $record) && strlen($record[$form_fieldname . "_secd"])>0) {
		  $contents = htmlspecialchars($record[$form_fieldname . '_prim'] . ', ' . $record[$form_fieldname . '_secd']);
        } else {
		  $tablename = tableName($fieldrecord['FIELD_EXTRA1']);
		  if($tablename === '_') {
			 echo 'Table ['.$fieldrecord['FIELD_EXTRA1'].'] does not exists in Metadata';
			 exit();
		  }
			
			$fetched = false;
			$findVar='look_'.$tablename.'_'. $fieldrecord['FIELD_EXTRA2'].$form_fieldname.'_'. (empty($record[$form_fieldname])? '':$record[$form_fieldname]);
			if (kApcTtl_5>0) $lookuprec = apc_fetchFct($findVar , $fetched);
		
			if (empty($fetched) ){
				$lookuprec = ClxCommon::$db->getRecord($tablename, $fieldrecord['FIELD_EXTRA2'] . '=' . singleQuote(((array_key_exists($form_fieldname, $record)) ? $record[$form_fieldname] : '')));
 				if (is_bool($lookuprec ))
					$lookuprec='-(vacio)-';
				
					
				if (kApcTtl_5>0 ){
					apc_addFct($findVar,$lookuprec,kApcTtl_5);
				}
			}
			if (!is_array($lookuprec))
				$lookuprec=array();
			unset ($findVar);
			unset ($fetched);
		  //test if any is a lookup
		  //$fieldrecord_prim = $DBFL->getField($fieldrecord['FIELD_EXTRA3']);
		  //$fieldrecord_secd = $DBFL->getField($fieldrecord['FIELD_EXTRA4']);

		   $this->set_obj_cache($fieldrecord);
			 $tablename = $this->obj_cache[$fieldrecord["FIELDNAME"]]['tablename'];
			 $fieldrecord_prim = $this->obj_cache[$fieldrecord["FIELDNAME"]]['prim'];
			 $fieldrecord_secd = $this->obj_cache[$fieldrecord["FIELDNAME"]]['secn'];

           

		  if ($fieldrecord_prim['FIELDTYPE'] === 'LOOK') {
			 $lookdata = ClxCommon::$db->getFields(tableName($fieldrecord_prim['FIELD_EXTRA1']), $fieldrecord_prim['FIELD_EXTRA3'] . ', ' . $fieldrecord_prim['FIELD_EXTRA4'], $fieldrecord_prim['FIELD_EXTRA2'] . '=' . singleQuoteWoSq($lookuprec[uppercase($fieldrecord['FIELD_EXTRA3'])]));
			 if (!empty($lookdata)) {
			     $lookuprec[uppercase($fieldrecord['FIELD_EXTRA3'])] = $lookdata[$fieldrecord_prim['FIELD_EXTRA3']] . ' - ' . $lookdata[$fieldrecord_prim['FIELD_EXTRA4']];
			 }
			 unset($lookdata);
		  } elseif ($fieldrecord_prim['FIELDTYPE'] === 'LIST') {
			 $DBLT = &getTool('DBLT');
			 $lookuprec[uppercase($fieldrecord['FIELD_EXTRA3'])] = $DBLT->getListItem($fieldrecord_prim['FIELD_EXTRA1'], $lookuprec[uppercase($fieldrecord['FIELD_EXTRA3'])]);
		  }

		  if ($fieldrecord_secd['FIELDTYPE'] === 'LOOK') {
			 if (!empty($lookuprec) && !is_array($fieldrecord['FIELD_EXTRA4']) && array_key_exists($fieldrecord['FIELD_EXTRA4'], $lookuprec)) {
			
				
					$fetched = false;
					$findVar='LOOK_' .$fieldrecord_secd['FIELD_EXTRA1'].'_'. $fieldrecord_secd['FIELD_EXTRA3'] . '_' . $fieldrecord_secd['FIELD_EXTRA4'].'_'. $fieldrecord_secd['FIELD_EXTRA2'] . '_' . $lookuprec[$fieldrecord['FIELD_EXTRA4']];

					if (kApcTtl_5>0) $lookdata = apc_fetchFct($findVar , $fetched);
						
					if ($fetched===false) {
						//just as normal
						$lookdata = ClxCommon::$db->getFields(tableName($fieldrecord_secd['FIELD_EXTRA1']), $fieldrecord_secd['FIELD_EXTRA3'] . ', ' . $fieldrecord_secd['FIELD_EXTRA4'], $fieldrecord_secd['FIELD_EXTRA2'] . '=' . singleQuoteWoSq($lookuprec[$fieldrecord['FIELD_EXTRA4']]));
						if (kApcTtl_5>0 && !empty($lookdata)) {
							apc_addFct($findVar,$lookdata,kApcTtl_5);
							
						}
					
					}
					unset($fetched);
					unset($findVar);
			     if (!empty($lookdata)) {
			         $lookuprec[$fieldrecord['FIELD_EXTRA4']] = $lookdata[$fieldrecord_secd['FIELD_EXTRA3']] . ' - ' . $lookdata[$fieldrecord_secd['FIELD_EXTRA4']];
			     }
			     unset($lookdata);
			 }
		  } elseif ($fieldrecord_secd['FIELDTYPE'] === 'LIST') {
			 $DBLT = &getTool('DBLT');
			 $lookuprec[uppercase($fieldrecord['FIELD_EXTRA4'])] = $DBLT->getListItem($fieldrecord_secd['FIELD_EXTRA1'], $lookuprec[uppercase($fieldrecord['FIELD_EXTRA4'])]);
		  }

		  $contents .= (is_array($lookuprec) && array_key_exists($fieldrecord['FIELD_EXTRA3'], $lookuprec))?$lookuprec[$fieldrecord['FIELD_EXTRA3']]:'';
		  if (!empty($lookuprec) && !empty($fieldrecord['FIELD_EXTRA4']) && array_key_exists($fieldrecord['FIELD_EXTRA4'], $lookuprec)) {
			 $contents .= ', ' . $lookuprec[$fieldrecord['FIELD_EXTRA4']];
		  }
		  $contents = trim(htmlspecialchars($contents));
        }
        if (!empty($fieldrecord['NOCODES'])) {
		  //not include parentesis
        } elseif (!empty($_SESSION['user_record']['isadmin'])) {
		  if ($contents === ', ') {
			 $contents = ' (' . $record[$form_fieldname] . ')';
			}
			else {
                $contents .=  ((empty($contents))? '': ' '). '(' . $record[$form_fieldname] . ')';
		  }
        }
        $contents = (trim($contents)==',')?'':$contents;
		unset($lookdata);
		unset($form_fieldname);
		unset($fieldrecord);
		unset($record);
		unset($DBLT);
		unset($fieldrecord_secd);
		unset($lookuprec);
		unset($tablename);
        unset($fieldrecord_prim);
        unset($fieldrecord_secd);
        return $contents;
    }

    /**
     * Returns lookup value
     * @param type $form_fieldname
     * @param type $fieldrecord
     * @param type $record
     * @return string
     */
    function getLookupValue($form_fieldname, $fieldrecord, $record) {
        $msg = array();

        if ($fieldrecord['FIELD_EXTRA8'] != CLX_NUM_ZERO && $fieldrecord['FIELD_EXTRA8'] != CLX_NUM_TWO && $fieldrecord['FIELDTYPE'] === 'LOOK') {
		  return $record;
        }
		
        //Open format
        if ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_TWO && $fieldrecord['FIELDTYPE'] === 'LOOK') {
		  $record[$form_fieldname] = $record[$form_fieldname . '_prim'];
		  return $record;
        }
		
        if ($fieldrecord['FIELD_EXTRA8'] == CLX_NUM_ZERO) { // if look display type default
		  $record[$fieldrecord['FIELDNAME']] = '';
			
		
		  if (!empty($record[$form_fieldname . '_prim']) || !empty($record[$form_fieldname . '_secd'])) {
	
			 $form = '';
			 $table = '';
			 $tablecode = $fieldrecord['FIELD_EXTRA1'];
			 $primaryfield = $fieldrecord['FIELD_EXTRA3'];
			 $secondaryfield = $fieldrecord['FIELD_EXTRA4'];
			 $tablerecord = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
			 $sqltable = $tablerecord['MODULECODE'] . '_' . $tablerecord['IDNAME'];
			 $primaryfieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($primaryfield));
			 $primaryfieldobj = getToolObject('DBFT', $primaryfieldrec['FIELDTYPE']);
			 $secondaryfieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($secondaryfield));
			 $secondaryfieldobj = getToolObject('DBFT', $secondaryfieldrec['FIELDTYPE']);
			 $criteria = '';
			 $altcriteria = '';
			 $boolean = '';
			 $usedfields = CLX_INIT_ZERO;
			 $prim = clx_html_spchrs_decode($record[$form_fieldname . '_prim']);
			 $secn = clx_html_spchrs_decode($record[$form_fieldname . '_secd']);
			 $terc = clx_html_spchrs_decode($record[$form_fieldname . '_terc']);
			 ClxCommon::$db->addslashes($prim);
			 ClxCommon::$db->addslashes($secn);
			 ClxCommon::$db->addslashes($terc);
			 if (!empty($record[$form_fieldname . '_prim'])) {
			     $primaryfieldobj->validateField($msg, $form_fieldname . '_prim', $primaryfieldrec, $record, $table, $form);
			     if ($primaryfieldrec['FIELDTYPE'] === 'CHAR') {
			         $criteria .= $boolean . $primaryfield . ' = ' . singleQuoteWoSq($prim);
			         $altcriteria .= $boolean . $primaryfield . ' LIKE ' . singleQuoteWoSq($prim . '%');
			         $boolean = ' AND ';
			     } else {
			         $criteria .= $boolean . $primaryfield . ' = ' . singleQuoteWoSq($prim);
			         $altcriteria .= $boolean . $primaryfield . ' = ' . singleQuoteWoSq($prim);
			         $boolean = ' AND ';
			     }
			     $usedfields++;
			 }
			 if (!empty($record[$form_fieldname . '_secd'])) {
			     if ($secondaryfieldrec['FIELDTYPE'] <> 'LOOK')
			         $secondaryfieldobj->validateField($msg, $form_fieldname . '_secd', $secondaryfieldrec, $record, $table, $form);
			     if ($secondaryfieldrec['FIELDTYPE'] === 'CHAR') {
			         $criteria .= $boolean . $secondaryfield . ' = ' . singleQuoteWoSq($secn);
			         $altcriteria .= $boolean . $secondaryfield . ' LIKE ' . singleQuoteWoSq($secn . '%');
			         $boolean = ' AND ';
			     } else {
			         $criteria .= $boolean . $secondaryfield . ' = ' . singleQuoteWoSq($secn);
			         $altcriteria .= $boolean . $secondaryfield . ' = ' . singleQuoteWoSq($secn);
			         $boolean = ' AND ';
			     }
			     $usedfields++;
			 }

			 $results = array();
             if (ClxCommon::$db->oneExistsRecords($sqltable, $criteria) > CLX_NUM_ZERO) {
			     if (!isset($record[$form_fieldname]))
			         $record[$form_fieldname] = '';

			     $results = ClxCommon::$db->executeQuery('SELECT ' . $fieldrecord['FIELD_EXTRA2'] . ' FROM ' . $sqltable . ' WHERE ' . $criteria);
			     while ($row = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			         if (!is_string($record[$form_fieldname])) {
					   $record[$form_fieldname][] = $row[$fieldrecord['FIELD_EXTRA2']];
			         } else {
					   $record[$form_fieldname] = $row[$fieldrecord['FIELD_EXTRA2']];
			         }
			     }
				 ClxCommon::$db->freeResult( $results );
			 } elseif (ClxCommon::$db->oneExistsRecords($sqltable, $altcriteria) > CLX_NUM_ZERO ) {
					$results = ClxCommon::$db->executeQuery('SELECT ' . $fieldrecord['FIELD_EXTRA2'] . ' FROM ' . $sqltable . ' WHERE ' . $altcriteria);
					
					 while ($row = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
						 if (!is_string($record[$form_fieldname])) {
						   $record[$form_fieldname][] = $row[$fieldrecord['FIELD_EXTRA2']];
						 } else {
						   $record[$form_fieldname] = $row[$fieldrecord['FIELD_EXTRA2']];
						 }
					 }
					 ClxCommon::$db->freeResult( $results );
			
				
			 } else {
			     $record[$form_fieldname] = '';
			 }
		  } elseif (array_key_exists($form_fieldname . '_prim', $record) && array_key_exists($form_fieldname . '_secd', $record) && empty($record[$form_fieldname . '_prim']) && empty($record[$form_fieldname . '_secd'])) {
			 $record[$form_fieldname] = '';
		  }
        }// End if default type
        return $record;
    }

}
