<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('plot') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'plot.php';

class plot_fc3columns extends plot {

    var $operators;

    /**
     * CONSTRUCTOR
     */
    function __construct() {
        $this->code = 'PLF3';
        $this->name = 'Single Series - Columns 3D';
        $this->type = 'PLOT';
        $this->version = '1.0.0.1';
        $this->description = 'The Clientix Single Series - Columns Chart';
        $this->plotfile = 'FC_2_3_Column3D.swf';
        $this->has_range = false;
        $this->serie_types = array('VAL' => dict('GEN_LABEL_VALUE'), 'CAT' => dict('GEN_LABEL_CATEGORY'), 'XAXI' => dict('GEN_LABEL_XAXIS'), 'YAXI' => dict('GEN_LABEL_YAXIS'));
    }

    function createPanel(&$plotrecord) {
        $DICT = &getTool('DICT');
        $plotrecord['XLABEL'] = $DICT->createEntry($this->code . '_xlabel', UserRequest::$post);
        $plotrecord['YLABEL'] = $DICT->createEntry($this->code . '_ylabel', UserRequest::$post);
        $plotrecord['LINE_AVERAGE'] = UserRequest::$post[$this->code . '_line_average'];
        $plotrecord['LINE_MAX'] = UserRequest::$post[$this->code . '_line_max'];
        $plotrecord['LINE_MIN'] = UserRequest::$post[$this->code . '_line_min'];
    }

    function savePanel(&$plotrecord) {
        $DICT = &getTool('DICT');
        $plotrecord['XLABEL'] = $DICT->saveEntry($this->code . '_xlabel', UserRequest::$post);
        $plotrecord['YLABEL'] = $DICT->saveEntry($this->code . '_ylabel', UserRequest::$post);
        $plotrecord['LINE_AVERAGE'] = UserRequest::$post[$this->code . '_line_average'];
        $plotrecord['LINE_MAX'] = UserRequest::$post[$this->code . '_line_max'];
        $plotrecord['LINE_MIN'] = UserRequest::$post[$this->code . '_line_min'];
    }

    function loadPanel(&$plotrecord, $values) {
        $DICT = &getTool('DICT');
        $DICT->loadEntry($this->code . '_xlabel', $values['XLABEL'], $plotrecord);
        $DICT->loadEntry($this->code . '_ylabel', $values['YLABEL'], $plotrecord);
        $plotrecord[$this->code . '_line_average'] = $values['LINE_AVERAGE'];
        $plotrecord[$this->code . '_line_max'] = $values['LINE_MAX'];
        $plotrecord[$this->code . '_line_min'] = $values['LINE_MIN'];
    }

    function defaultPanel(&$plotrecord) {
        $plotrecord[$this->code . '_xlabel'] = '';
        $plotrecord[$this->code . '_xlabel_DICT'] = '';
        $plotrecord[$this->code . '_ylabel'] = '';
        $plotrecord[$this->code . '_ylabel_DICT'] = '';
        $plotrecord[$this->code . '_line_average'] = CLX_INIT_ZERO;
        $plotrecord[$this->code . '_line_max'] = CLX_INIT_ZERO;
        $plotrecord[$this->code . '_line_min'] = CLX_INIT_ZERO;
    }

    function viewForm(&$table, $record) {
        $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
        $table->addData(dict('GEN_LBL_TYPE'), $this->name);
        $table->addData(dict('GEN_LBL_XLABEL') . ':', dict($record[$this->code . '_xlabel']));
        $table->addData(dict('GEN_LBL_YLABEL') . ':', dict($record[$this->code . '_ylabel']));
        $table->addData(dict('GEN_LBL_AVERAGELINE') . ':', $yesno[$record[$this->code . '_line_average']]);
        $table->addData(dict('GEN_LBL_MAXLINE') . ':', $yesno[$record[$this->code . '_line_max']]);
        $table->addData(dict('GEN_LBL_MINLINE') . ':', $yesno[$record[$this->code . '_line_min']]);
    }

}
