<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Events Manager - System Alert Message.
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class uimi extends clx_object {

    /**
     * Contructor
     */
    function __construct() {
        $this->code = 'UIMI';
        $this->name = 'Generic Clientix Menu Item';
        $this->type = '----';
        $this->version = '0.1.0.0';
        $this->description = 'This is a Generic Clientix Menu Item';
    }

    /**
     * Build Meny item type on edit menu.
     * @param array $msg
     * @param array $record
     */
    function panel($msg, $record) {
	ClxFreeReturn($msg); //no se esta usando
	ClxFreeReturn($record); //no se esta usando
    }

    /**
     * Verifies Menu Item Panel.
     * @param array $msg
     */
    function checkPanel(&$msg) {
	ClxFreeReturn($msg); //no se esta usando
    }

    /**
     * Loads form values in record for future save.
     * @param array $record
     */
    function getPanel(&$record) {
	ClxFreeReturn($record); //no se esta usando
        $record['EXTRA1'] = UserRequest::$post['CODE_extra1'];
        $record['EXTRA2'] = UserRequest::$post['CODE_extra2'];
        $record['EXTRA3'] = UserRequest::$post['CODE_extra3'];
        $record['EXTRA4'] = UserRequest::$post['CODE_extra4'];
    }

    /**
     * Sets form values from menu record
     * @param array $record
     * @param array $values
     */
    function setPanel(&$record, $values) {
	ClxFreeReturn($record); //no se esta usando
	ClxFreeReturn($values); //no se esta usando
        $record['CODE_extra1'] = $values['EXTRA1'];
        $record['CODE_extra2'] = $values['EXTRA2'];
        $record['CODE_extra3'] = $values['EXTRA3'];
        $record['CODE_extra4'] = $values['EXTRA4'];
    }

    /**
     * Loads Default Panel Values
     * @param array $record
     */
    function defaultPanel(&$record) {
	ClxFreeReturn($record); //no se esta usando
        $record['CODE_extra1'] = '';
        $record['CODE_extra2'] = '';
        $record['CODE_extra3'] = '';
        $record['CODE_extra4'] = '';
    }

    /**
     * Displays Form Object for menu items tool
     * @param obj $table
     * @param array $record
     */
    function viewForm(&$table, $record) {
	ClxFreeReturn($record); //no se esta usando
	ClxFreeReturn($table); //no se esta usando

    }

    /**
     * Return string with description of menu item.
     * @param array $record
     * @return string
     */
    function describe($record) {
	ClxFreeReturn($record); //no se esta usando
        return CLX_CHAR_EMPTY_STRING;
    }

    /**
     * Returns URL Form Menu Item
     * @param array $record
     * @return string
     */
    function makeURL($record) {
	ClxFreeReturn($record); //no se esta usando
        return 'index.php';
    }

    /**
     * Saves Menu access information
     * @param string $ownercode
     * @param string $ownerref
     */
    function saveAccessWizard($ownercode, $ownerref) {
	ClxFreeReturn($ownercode); //no se esta usando
	ClxFreeReturn($ownerref); //no se esta usando
    }

}
