<?php

/**
 * Graphics Manager
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-22 15:20:30 -0400 (ma., 22 ene. 2019) $
 * @version    	$Rev: 10484 $
 *
 * Based on Fusion Lite Chart http://www.infosoftglobal.com/
 * 7/5/2005 Oracle uppercase record changed
 */

class an_Graphics extends clx_tool {

    var $fonttypes;

    /**
     * Constructor
     */
    function __construct() {
 		include("../extlibs/php/fusioncharts/fusioncharts.php");

		$this->code = 'ANGM';
        $this->name = 'Graphics Manager';
        $this->system = 'Analytics';
        $this->version = '4.0.1.2';

        $this->has_access = true;
        $this->has_package = true;
        $this->has_pagelet = true;
        $this->tablename = 'CLX_AN_GRAPHICS';
        $this->record_name_singular = 'Graphic Manager';
        $this->record_name_plural = 'Graphics Manager';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->yes_no = array('GEN_LBL_NO', 'GEN_LBL_YES');
        $this->fonttypes = array('arial' => 'Arial',
		  'verdana' => 'Verdana');

		$this->themes= array('Fusion','Gammel','Candy','Zune','Ocean','Carbon','Umber');

		$this->themes_color= array('default','group_mixed1','group_mixed2','group_mixed3','group_reds','group_pinks','group_oranges','group_yellows','group_grays','group_greens','group_purpples','group_browns','group_whites','group_blues');


	}

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_ANALYTICS:Graphics', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO');
        $fields['TITLE'] = array('type' => 'varchar(50)', 'null' => 'NO', 'dict' => true);
        $fields['SUBTITLE'] = array('type' => 'varchar(50)', 'null' => 'NO', 'dict' => true);
        $fields['XLABEL'] = array('type' => 'varchar(50)', 'null' => 'YES', 'dict' => true);
        $fields['YLABEL'] = array('type' => 'varchar(50)', 'null' => 'YES', 'dict' => true);
        $fields['LINE_AVERAGE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['LINE_MAX'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['LINE_MIN'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOWNAMES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['ROTATE_NAMES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOWVALUES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['ANIMATION'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOW_LEGEND'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOW_COLSHADOW'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOW_PCTVALUES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOW_PCTINLABEL'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'null' => 'YES');
        $fields['QUERYCODE'] = array('type' => 'varchar(16)', 'null' => 'NO');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO');
        $fields['HSIZE'] = array('type' => 'int(5) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['VSIZE'] = array('type' => 'int(5) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['FONTSIZE'] = array('type' => 'int(3) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['FONTTYPE'] = array('type' => 'varchar(16)', 'null' => 'NO');
        $fields['BORDER'] = array('type' => 'int(3) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['GRAPHIC_TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO');
        $fields['GRAPHIC_THEME'] = array('type' => 'varchar(25)', 'null' => 'NO');
		$fields['GRAPHIC_THEME_COLOR'] = array('type' => 'varchar(75)', 'null' => 'NO');
	    $fields['SEARCH_FORM'] = array('type' => 'varchar(16)', 'null' => 'YES');
        $fields['EXEONSEARCH'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['FIELD_EXTRA1'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA2'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA3'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA4'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA5'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA6'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA7'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA8'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA9'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA10'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA11'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA12'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA13'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA14'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA15'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'QUERYCODE');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    function pack($record) {
        $o = $this->packRecord($record);
        $code = $record['IDCODE'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'ANGS', 'SELECT * FROM CLX_AN_GRAPHICS_SERIES WHERE CHARTCODE=' . singleQuote($code));
        $this->packsub($objs, 'DICT', 'SELECT DICT.* FROM CLX_DICTIONARY DICT, CLX_AN_GRAPHICS X WHERE (DICT.ENTRY=X.TITLE OR DICT.ENTRY=X.SUBTITLE OR DICT.ENTRY=X.XLABEL OR DICT.ENTRY=X.YLABEL) AND X.IDCODE=' . singleQuote($code));
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $chartcode = $record['IDCODE'];
        $exists = (ClxCommon::$db->countRecords($this->tablename, 'IDCODE=' . singleQuote($chartcode)) > CLX_NUM_ZERO);
        if ($exists === true) {
		  $chartid = ClxCommon::$db->getField($this->tablename, 'ID', 'IDCODE=' . singleQuote($chartcode));
		  $this->deleteRecordSk($chartid);
        }
        $chartid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o, 'id' => $chartcode));
		  }
        }
    }

    function action($ac, $idlist) {
	    if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'GRAPHIC':
				 $contents = $this->graphics(UserRequest::$request['pl']);
			     break;
			 case 'XML':
			     sendXmlHeader();
			     $contents = $this->getXmlData(UserRequest::$request['pl']);
			     break;
			 case 'GETGRAPHIC':
					$contents=$this->getgraphic($idlist);
					break;
				default: 
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AN_GRAPHIC-CAN_READ_3][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'ANGMList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = '';
        $sortclause = '';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_TEN);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANGM_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TEN));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_QUERYCODE'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_TYPE'), dict('GEN_LBL_VERSION'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_ANIMATION'),dict('GEN_GRAPHIC_THEME')));
        $i = CLX_INIT_ZERO;	
	    while ($record = $page->nextRecord()) {
		  $recordid = $record['ID'];
		//	        echo "========3==",chr(10);

		//	PRE($record);
		//	DIE;
		  if (ClxCommon::$db->countRecords('CLX_OBJECTS', 'IDCODE = ' . singleQuote($record['GRAPHIC_TYPE'])) > CLX_NUM_ZERO) {
			 $fieldobject = getToolObject('GXPL', $record['GRAPHIC_TYPE']);
			 $name = $fieldobject->name;
		  } else {
			 $name = '-error-';
		  }
		  $select = new htmlCheckbox('selector_' . $recordid, false);
		  $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
		  $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
		  $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['MODULECODE'], $record['QUERYCODE'], $record['IDCODE'], $record['IDNAME'], $name, $record['VERSION'] . '-' . $record['VERSION_COUNTER'], xFormat::text($record['DESCRIPTION']), dict($this->yes_no[$record['ANIMATION']]),$record['GRAPHIC_THEME']));
		  $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DUPLICATE'), array('action' => 'DUPLICATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_CHART')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function searchForm() {
        $msg = array();
        $contents = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANGM_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!array_key_exists('ANGM_idcode', UserRequest::$post))
		  UserRequest::$post['ANGM_idcode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'ANGM_idcode', UserRequest::$post['ANGM_idcode'], CLX_NUM_16, CLX_NUM_16);
        if (!array_key_exists('ANGM_idname', UserRequest::$post))
		  UserRequest::$post['ANGM_idname'] = '';
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANGM_idname', UserRequest::$post['ANGM_idname'], CLX_NUM_32, CLX_NUM_64);
        if (!array_key_exists('ANGM_querycode', UserRequest::$post))
		  UserRequest::$post['ANGM_querycode'] = '';
        $table->addField($msg, dict('GEN_LBL_QUERYCODE') . ':', 'ANGM_querycode', UserRequest::$post['ANGM_querycode'], CLX_NUM_16, CLX_NUM_16);
        if (!array_key_exists('ANGM_modulecode', UserRequest::$post))
		  UserRequest::$post['ANGM_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'ANGM_modulecode', UserRequest::$post['ANGM_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
      //  $buttons = $c->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
		  $table = new htmlTable(CLX_WIDTH_TWO);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $criteria = '';
			$and='';
		  if (UserRequest::$post['ANGM_idcode'] <> '') {
			 $criteria .= $and.'IDCODE LIKE ' . singleQuote(UserRequest::$post['ANGM_idcode'] . '%');
				$and=' AND ';
			}
		  if (UserRequest::$post['ANGM_idname'] <> '') {
			 $criteria .= $and.'IDNAME LIKE ' . singleQuote(UserRequest::$post['ANGM_idname'] . '%');
				$and=' AND ';
			}
		  if (UserRequest::$post['ANGM_modulecode'] <> '') {
			 $criteria .= $and.'MODULECODE LIKE ' . singleQuote(UserRequest::$post['ANGM_modulecode'] . '%');
				$and=' AND ';
			}
		  if (UserRequest::$post['ANGM_querycode'] <> '') {
			 $criteria .= $and.'QUERYCODE LIKE ' . singleQuote(UserRequest::$post['ANGM_querycode'] . '%');
				$and=' AND ';
			}
		  $qty = ClxCommon::$db->countRecords($this->tablename, $criteria);
		  if ($qty == CLX_NUM_ZERO) {
			 $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		  } else {
			 $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			 $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
			 $i = CLX_INIT_ZERO;
			 while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			     $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
			     $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=an_graphic></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . '</a>', $record['IDNAME']));
			     $i++;
			 }
		  }
		  $contents .= $table->source();
        }
        return $contents;
    }

    /**
     * Edit Form
     * @param type $ac
     * @param type $idlist
     * @param type $record
     * @param type $msg
     * @return type
     */
    function editForm($ac, $idlist, $record, $msg) {
	//	pre($ac);
		$DICT = &getTool('DICT');
        $modify = (UserRequest::$request['ac'] === 'MODIFY') ? true : false;
        $title = ($modify) ? dict('TOOL_ANGM_TITLE_MODIFY') : dict('TOOL_ANGM_TITLE_CREATE');

        // Build/get the different javascripts...
        $OBJS = &getTool('OBJS');
        $graphiccodes = $OBJS->objectList('GXPL');
		$list = 'var panellist = new Array();' . CLX_CHAR_NL . CLX_CHAR_NL;
        $i = CLX_INIT_ZERO;
        foreach ($graphiccodes as $graphiccode) {
		  $list .= sprintf('panellist[%s] = ' . singleQuote('%s') . ';', $i, $graphiccode) . CLX_CHAR_NL;
		  $i++;
        }

        $script = setJavaScriptTag($list, false);

        $variables = array();
        $variables['VISIBLEPANEL'] = 'ANGM_graphic_type';
        $topscript = setJavaScriptTag(getJavaScript('dynform_top.js', $variables), false);
        $topscript .= setJavascriptTag(getJavaScriptFilename('GRAPHIC_editform.js'), true);
        $btmscript = setJavaScriptTag(getJavaScriptFilename('dynform_btm.js'), true);
        $btmscript .= setJavaScriptTag('initForm();', false);

        //Build the form
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument('ANGM_id', $record['ANGM_id']);
        $form->addArgument('idlist', toString($idlist));

        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!empty($modify)) {
		  $table->addData(dict('GEN_LBL_CODE') . ':', $record['ANGM_idcode']);
		  $form->addArgument('ANGM_idcode', $record['ANGM_idcode']);
        } else {
		  $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'ANGM_idcode', $record['ANGM_idcode'], CLX_NUM_16, CLX_NUM_16);
        }
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANGM_idname', $record['ANGM_idname'], CLX_NUM_48, CLX_NUM_64);

        //Title, subtitle and axis labels
        $DICT->editEntry($msg, dict('GEN_LBL_TITLE') . ':', 'ANGM_title', $record, $table, $form);
        $DICT->editEntry($msg, dict('GEN_LBL_SUBTITLE') . ':', 'ANGM_subtitle', $record, $table, $form);
        $table->addText($msg, dict('GEN_LBL_DESCRIPTION') . ':', 'ANGM_description', $record['ANGM_description'], CLX_NUM_FOUR, CLX_NUM_48);
        $table->addField($msg, dict('GEN_LBL_VERSION') . ':', 'ANGM_version', $record['ANGM_version'], CLX_NUM_16, CLX_NUM_16);
        $DBQY = &getTool('DBQY');
        $DBQY->placeChooseQuery($msg, dict('GEN_LBL_QUERYCODE') . ':', 'ANGM_querycode', $record['ANGM_querycode'], $table);
        $DBMO = &getTool('DBMO');
        $DBMO->placeChooseModule($msg, dict('GEN_LBL_MODULECODE') . ':', 'ANGM_modulecode', $record['ANGM_modulecode'], $table);
        $UIFM = &getTool('UIFM');
        $UIFM->placeChooseForm($msg, dict('TOOL_UILG_PROMPT_SCHFORM') . ':', 'ANGM_search_form', $record['ANGM_search_form'], $table);
        $pop = new HTMLSelect('ANGM_exeonsearch');
        foreach ($this->yes_no as $key => $val) {
		  $pop->addItem(dict($val), $key, ($record['ANGM_exeonsearch'] == $key));
        }
        $table->addData(dict('TOOL_UILG_PROMPT_EXEONSEARCH') . ':', $pop->source());
        $table->addSeparator(CLX_CLASS_DATA);

        $table2 = new htmlTable(CLX_NUM_FOUR);
        $table2->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table2->addField($msg, dict('GEN_LBL_HSIZE') . ':', 'ANGM_hsize', $record['ANGM_hsize'], CLX_NUM_FIVE, CLX_NUM_FIVE);
        $table2->addField($msg, dict('GEN_LBL_VSIZE') . ':', 'ANGM_vsize', $record['ANGM_vsize'], CLX_NUM_FIVE, CLX_NUM_FIVE);
        $pop = new htmlSelect($this->code . '_fonttype');
	    foreach ($this->fonttypes as $key => $val) {
		  $pop->addItem($val, $key, ($record[$this->code . '_fonttype'] == $key));
        }
        $table2->addData(dict('GEN_LBL_FONT_TYPE') . ':', $pop->source());
        $table2->addField($msg, dict('GEN_LBL_FONTSIZE') . ':', 'ANGM_fontsize', $record['ANGM_fontsize'], CLX_NUM_FIVE, CLX_NUM_THREE);
        $table2->addYesNo(dict('TOOL_UILG_PROMPT_SHOWNAMES'), 'ANGM_shownames', $record['ANGM_shownames'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('GEN_LBL_ROTATE_NAMES'), 'ANGM_rotate_names', $record['ANGM_rotate_names'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_PROMPT_SHOWVALUES'), 'ANGM_showvalues', $record['ANGM_showvalues'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_SHOW_LEGEND'), 'ANGM_show_legend', $record['ANGM_show_legend'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_SHOW_COL_SHADOW'), 'ANGM_show_colshadow', $record['ANGM_show_colshadow'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_SHOW_PCT_VALUES'), 'ANGM_show_pctvalues', $record['ANGM_show_pctvalues'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_SHOW_PCT_ONLBL'), 'ANGM_show_pctinlabel', $record['ANGM_show_pctinlabel'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_PROMPT_ANIMATION'), 'ANGM_animation', $record['ANGM_animation'], CLX_NUM_ZERO);
  //   	$table2->addField($msg,dict('GEN_GRAPHIC_THEME').':', 'ANGM_graphic_theme',$record['ANGM_graphic_theme'], CLX_NUM_FIVE, CLX_NUM_TWO);

	//$this->themes_color
    
    
	 	
		$popx = new htmlSelect('ANGM_graphic_theme');//pre($record);
        foreach ($this->themes as $valuetm) {
		  $popx->addItem($valuetm, $valuetm, ($valuetm == $record['ANGM_graphic_theme']));
        }
		$table2->addData(dict('GEN_GRAPHIC_THEME').':', $popx->source());
		
		$popx = new htmlSelect('ANGM_graphic_theme_color');
        foreach ($this->themes_color as $valuetmc) {
		  $popx->addItem($valuetmc, $valuetmc, ($valuetmc == $record['ANGM_graphic_theme_color']));
        }
		$table2->addData(dict('GEN_GRAPHIC_THEME_COLOR').':', $popx->source());

		$graphics = $OBJS->objectPop('GXPL', 'ANGM_graphic_type', $record['ANGM_graphic_type']);
        $graphics->setProp('onchange', 'updateForm();');
        $table2->addData(dict('GEN_LBL_TYPE'), $graphics->source());
		$table2->addField($msg, dict('GEN_LBL_BORDER') . ':', 'ANGM_border', $record['ANGM_border'], CLX_NUM_FIVE, CLX_NUM_TWO);


        $table->addCell($table2->source(), array(CLX_PROP_COLSPAN => CLX_NUM_TWO));
        //graphic Type
        if (!empty($msg['ANGM_graphic_type'])) {
		  $table->addCell($msg['ANGM_graphic_type'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        }

        $form->addContents($table->source());


        //-- graphic Types Properties
	    foreach ($graphiccodes as $graphiccode) {
		  $fieldobject = $OBJS->getObject_('GXPL', $graphiccode);
		  $form->addContents($fieldobject->panel($msg, $record, $form));
        }

        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons = (!empty($modify)) ? htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => $ac, 'form' => $form->getProp(CLX_PROP_ID)))->source() : htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID)))->source();

        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $script . $topscript . $form->source() . $btmscript;
    }

    function checkForm(&$msg) {
        $msg = array();
        $action = UserRequest::$post['ac'];
        if ($action === 'CREATE') {
		  xValidate::unique($msg, 'ANGM_idcode', 'idcode', $this->tablename, 'IDCODE=' . singleQuote(UserRequest::$post['ANGM_idcode']));
        }
        $DBQY = &getTool('DBQY');
        if (!$DBQY->queryExists(UserRequest::$post['ANGM_querycode'])) {
		  $msg['ANGM_querycode'] = dict('TOOL_UIVW_NOQUERYCODE');
        }
        if (strlen(UserRequest::$post['ANGM_idname']) == CLX_NUM_ZERO) {
		  $msg['ANGM_idname'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        $DBMO = &getTool('DBMO');
        if (!$DBMO->moduleExists(UserRequest::$post['ANGM_modulecode'])) {
		  $msg['ANGM_modulecode'] = dict('TOOL_DBMO_ERR_NO_RECORD');
        }
        //Check Form for now only one
        $UIFM = &getTool('UIFM');
        $forms = array('ANGM_search_form');
        reset($forms);
        foreach ($forms as $key => $val) {
		  if (!empty(UserRequest::$post[$val])) {
			 if (!$UIFM->formExists(UserRequest::$post[$val])) {
			     $msg[$val] = dict('TOOL_UILG_ERR_NOFORMCODE');
			 }
		  }
        }
        xValidate::integer($msg, 'ANGM_hsize', UserRequest::$post['ANGM_hsize'], CLX_NUM_HUNDRED, '5000', dict('GEN_LBL_HSIZE'));
        xValidate::integer($msg, 'ANGM_vsize', UserRequest::$post['ANGM_vsize'], CLX_NUM_HUNDRED, '5000', dict('GEN_LBL_VSIZE'));
        xValidate::integer($msg, 'ANGM_fontsize', UserRequest::$post['ANGM_fontsize'], '1', '50', dict('GEN_LBL_VSIZE'));
        xValidate::integer($msg, 'ANGM_border', UserRequest::$post['ANGM_border'], '0', '50', dict('GEN_LBL_VSIZE'));
        if (UserRequest::$post['ANGM_exeonsearch'] == CLX_NUM_ONE && UserRequest::$post['ANGM_search_form'] === '') {
		  $msg['ANGM_search_form'] = dict('TOOL_UILG_ERR_SRCHFORMREQUIRED');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['ANGM_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['ANGM_idname']);
    }

    function viewFormFill($record) {
		addHistory('chartcode', $record['ANGM_idcode']);
        $contents = '';

        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANGM_TITLE_VIEW') . ': ' . $record['ANGM_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $contents .= $table->source();
        $infotable = new htmlTable(CLX_WIDTH_TWO);
        $infotable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $infotable->addData(dict('GEN_LBL_CODE') . ':', $record['ANGM_idcode']);
        $infotable->addData(dict('GEN_LBL_NAME') . ':', $record['ANGM_idname']);
        $infotable->addData(dict('GEN_LBL_TITLE') . ':', dict($record['ANGM_title']));
        $infotable->addData(dict('GEN_LBL_SUBTITLE') . ':', dict($record['ANGM_subtitle']));
        $infotable->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['ANGM_description']));
        $infotable->addData(dict('GEN_LBL_VERSION') . ':', $record['ANGM_version'] . '-' . $record['ANGM_version_counter']);
        $infotable->addData(dict('GEN_LBL_MODULECODE') . ':', $record['ANGM_modulecode']);
        $infotable->addData(dict('GEN_LBL_QUERYCODE') . ':', $record['ANGM_querycode']);
        $infotable->addData(dict('TOOL_UILG_PROMPT_SCHFORM') . ':', $record['ANGM_search_form']);
        $infotable2 = new htmlTable(CLX_WIDTH_FOUR);
        $infotable2->addData(dict('GEN_LBL_FONTTYPE') . ':', $this->fonttypes[$record['ANGM_fonttype']]);
        $infotable2->addData(dict('GEN_LBL_SIZE') . ':', $record['ANGM_hsize'] . ' x ' . $record['ANGM_vsize']);
        $infotable2->addData(dict('GEN_LBL_FONTSIZE') . ':', $record['ANGM_fontsize']);
        $infotable2->addData(dict('GEN_LBL_BODER') . ':', $record['ANGM_border']);
        $infotable2->addData(dict('GEN_LBL_SHOWNAMES') . ':', dict($this->yes_no[$record['ANGM_shownames']]));
        $infotable2->addData(dict('GEN_LBL_ROTATE_NAMES') . ':', dict($this->yes_no[$record['ANGM_rotate_names']]));
        $infotable2->addData(dict('GEN_LBL_SHOWVALUES') . ':', dict($this->yes_no[$record['ANGM_showvalues']]));
        $infotable2->addData(dict('GEN_LBL_ANIMATION') . ':', dict($this->yes_no[$record['ANGM_animation']]));
        $infotable2->addData(dict('TOOL_UILG_SHOW_LEGEND') . ':', dict($this->yes_no[$record['ANGM_show_legend']]));
        $infotable2->addData(dict('TOOL_UILG_SHOW_COL_SHADOW') . ':', dict($this->yes_no[$record['ANGM_show_colshadow']]));
        $infotable2->addData(dict('TOOL_UILG_SHOW_PCT_VALUES') . ':', dict($this->yes_no[$record['ANGM_show_pctvalues']]));
        $infotable2->addData(dict('TOOL_UILG_SHOW_PCT_ONLBL') . ':', dict($this->yes_no[$record['ANGM_show_pctinlabel']]));
        $infotable->addCell($infotable2->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $contents .= $infotable->source();

        /*         * **************** Details *********************** */
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $graphicinstance = getToolObject('GXPL', $record['ANGM_graphic_type']);
        $graphicinstance->viewForm($table, $record);
        $contents .= buildPanelInterface('', 'GRAPHICDETAILS', $table->source(), -1 * CLX_NUM_ONE);

        /*         * **************** Preview *********************** */



	/*	$imgconttable = new htmlTable(CLX_WIDTH_TWO);
        $imgconttable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $imgtable = new htmlTable(CLX_WIDTH_ONE);
        $imgtable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));

        $imgtable->addCell(dict('GEN_LBL_GRAPHIC_SAMPLE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $img = $this->graphic($record['ANGM_idcode']);
        $imgtable->addCell($img, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $imgconttable->addCell($imgtable->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));

        $imgtable = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $imgtable->addCell(dict('GEN_LBL_GRAPHIC_XML'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $text = new htmlTextArea('', $this->getXmlData($record['ANGM_idcode']), CLX_NUM_15, CLX_NUM_60);
        $text->setProp('readonly', 'true');
        $imgtable->addCell($text->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $imgconttable->addCell($imgtable->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $contents .= $imgconttable->source();
		*/

		$text = new htmlTextArea('', $this->getXmlData($record['ANGM_idcode']), CLX_NUM_15, CLX_NUM_60);
        $text->setProp('readonly', 'true');
        $xmltext=$text->source();
   //   pre($xmltext);

		$imgconttable = new htmlTable(CLX_WIDTH_ONE);
        $imgconttable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
	//	pre(userRequest::$request);
		$Xcontents='
			<div>
				<div style="float: left;width: 45%;height: 20px;background-color:blue-light;">
					<div>'.dict('GEN_LBL_GRAPHIC_SAMPLE').'</div>

				</div>
				<div style="float: right;width: 45%;height: 20px;background-color:blue-light;">
					<div id="carga_lineal">'.dict('GEN_LBL_GRAPHIC_XML').'</div>


				</div>

				<div style="float: left;width: 45%;height: 295px;background-color:blue-light;">
					<div id="carga_GRAPHIC"></div>
				</div>
				<div style="float: right;width: 45%;height: 295px;background-color:blue-light;">
					<div id="xmltext">'.$xmltext.'</div>
				</div>
			</div>	
			<script type="text/javascript">	
			$(document ).ready(function() {
				console.log( "ready!" );
				$("#carga_GRAPHIC").load("window.php?to=ANGM&ac=GETGRAPHIC&selector_'.$record['ANGM_id'].'=1&sublist=&submitx1=Desplegar=&mc=&relfm=&graphicconfig=1");


			});
			</script>

			';
		$imgconttable->addCell($Xcontents, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $contents .= $imgconttable->source();



        /*         * **************** Ranges *********************** */
        if ($graphicinstance->has_range === true) {
		  $ANGR = &getTool('ANGR');
		  $contents .= '<br>' . $ANGR->makepanel($record['ANGM_idcode']);
        }
        /*         * **************** Series *********************** */
        $ANGS = &getTool('ANGS');
        $contents .= $ANGS->makepanel($record['ANGM_idcode']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['ANGM_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['ANGM_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['ANGM_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $contents;
    }

    function filterFormFill($msg, &$table) {
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'ANGM_idcode', '', CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANGM_idname', '', CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'ANGM_modulecode', '', CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addField($msg, dict('GEN_LBL_QUERYCODE') . ':', 'ANGM_querycode', '', CLX_NUM_16, CLX_NUM_16);
        $sort = new HtmlSelect('ANGM_sort');
        $sort->addItem('', '', true);
        $sort->addItem('Module Code', 'modulecode', false);
        $sort->addItem('Query Code', 'querycode', false);
        $sort->addItem('Code', 'idcode', false);
        $sort->addItem('Name', 'idname', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['ANGM_idcode'])) {
		  $filter .= $boolean . ' IDCODE LIKE ' . singleQuote(UserRequest::$post['ANGM_idcode'] . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['ANGM_idname'])) {
		  $filter .= $boolean . ' IDNAME LIKE ' . singleQuote(UserRequest::$post['ANGM_idname'] . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['ANGM_modulecode'])) {
		  $filter .= $boolean . ' MODULECODE LIKE ' . singleQuote(UserRequest::$post['ANGM_modulecode'] . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['ANGM_querycode'])) {
		  $filter .= $boolean . ' QUERYCODE LIKE ' . singleQuote(UserRequest::$post['ANGM_querycode'] . '%');
		  $boolean = 'AND';
        }
        $_SESSION['paging']['ANGMList']['sortby'] = UserRequest::$post['ANGM_sort'];
        $_SESSION['paging']['ANGMList']['criteria'] = $filter;
        $_SESSION['paging']['ANGMList']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
    /*function clearfilter() {
        $_SESSION['paging']['ANGMList']['criteria'] = '';
    }*/

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['ANGM_id'] = $recordid;
        $record['ANGM_idcode'] = $values['IDCODE'];
        $record['ANGM_idname'] = $values['IDNAME'];
        $DICT = &getTool('DICT');
        $DICT->loadEntry('ANGM_title', $values['TITLE'], $record);
        $DICT->loadEntry('ANGM_subtitle', $values['SUBTITLE'], $record);
        $record['ANGM_version'] = $values['VERSION'];
        $record['ANGM_version_counter'] = $values['VERSION_COUNTER'];
        $record['ANGM_cdate'] = xFormat::date($values['CDATE']);
        $record['ANGM_mdate'] = xFormat::date($values['MDATE']);
        $record['ANGM_username'] = $values['USERNAME'];
        $record['ANGM_description'] = $values['DESCRIPTION'];
        $record['ANGM_modulecode'] = $values['MODULECODE'];
        $record['ANGM_querycode'] = $values['QUERYCODE'];
        $record['ANGM_search_form'] = $values['SEARCH_FORM'];
        $record['ANGM_hsize'] = $values['HSIZE'];
        $record['ANGM_vsize'] = $values['VSIZE'];
        $record['ANGM_fontsize'] = $values['FONTSIZE'];
        $record['ANGM_fonttype'] = $values['FONTTYPE'];
        $record['ANGM_border'] = $values['BORDER'];
        $record['ANGM_shownames'] = $values['SHOWNAMES'];
        $record['ANGM_rotate_names'] = $values['ROTATE_NAMES'];
        $record['ANGM_showvalues'] = $values['SHOWVALUES'];
        $record['ANGM_animation'] = $values['ANIMATION'];
        $record['ANGM_show_legend'] = $values['SHOW_LEGEND'];
        $record['ANGM_show_colshadow'] = $values['SHOW_COLSHADOW'];
        $record['ANGM_show_pctvalues'] = $values['SHOW_PCTVALUES'];
        $record['ANGM_show_pctinlabel'] = $values['SHOW_PCTINLABEL'];
        $record['ANGM_graphic_type'] = $values['GRAPHIC_TYPE'];
		$record['ANGM_graphic_theme'] = $values['GRAPHIC_THEME'];
		$record['ANGM_graphic_theme_color'] = $values['GRAPHIC_THEME_COLOR'];
		$record['ANGM_exeonsearch'] = $values['EXEONSEARCH'];
        $OBJS = &getTool('OBJS');
        $graphiccodes = $OBJS->objectList('GXPL');
        foreach ($graphiccodes as $graphiccode) {
		  $graphicobject = $OBJS->getObject_('GXPL', $graphiccode);
		  $graphicobject->loadPanel($record, $values);
        }
        if ($values['GRAPHIC_TYPE'] <> '') {
		  $graphicobject = $OBJS->getObject_('GXPL', $values['GRAPHIC_TYPE']);;
		  $graphicobject->loadPanel($record, $values);
        }
        return $record;
    }

    function saveRecord() {        //echo "========2==",chr(10);

    //    pre($record);
	//	die;

        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDNAME'] = UserRequest::$post['ANGM_idname'];
        $DICT = &getTool('DICT');
        $record['TITLE'] = $DICT->saveEntry('ANGM_title', UserRequest::$post);
        $record['SUBTITLE'] = $DICT->saveEntry('ANGM_subtitle', UserRequest::$post);
        $record['VERSION'] = UserRequest::$post['ANGM_version'];
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['ANGM_description'];
        $record['QUERYCODE'] = UserRequest::$post['ANGM_querycode'];
        $record['SEARCH_FORM'] = UserRequest::$post['ANGM_search_form'];
        $record['MODULECODE'] = UserRequest::$post['ANGM_modulecode'];
        $record['HSIZE'] = UserRequest::$post['ANGM_hsize'];
        $record['VSIZE'] = UserRequest::$post['ANGM_vsize'];
        $record['FONTSIZE'] = UserRequest::$post['ANGM_fontsize'];
        $record['FONTTYPE'] = UserRequest::$post['ANGM_fonttype'];
        $record['BORDER'] = UserRequest::$post['ANGM_border'];
        $record['SHOWNAMES'] = UserRequest::$post['ANGM_shownames'];
        $record['ROTATE_NAMES'] = UserRequest::$post['ANGM_rotate_names'];
        $record['SHOWVALUES'] = UserRequest::$post['ANGM_showvalues'];
        $record['ANIMATION'] = UserRequest::$post['ANGM_animation'];
        $record['SHOW_LEGEND'] = UserRequest::$post['ANGM_show_legend'];
        $record['SHOW_COLSHADOW'] = UserRequest::$post['ANGM_show_colshadow'];
        $record['SHOW_PCTVALUES'] = UserRequest::$post['ANGM_show_pctvalues'];
        $record['SHOW_PCTINLABEL'] = UserRequest::$post['ANGM_show_pctinlabel'];
        $record['GRAPHIC_TYPE'] = UserRequest::$post['ANGM_graphic_type'];
		$record['GRAPHIC_THEME'] = UserRequest::$post['ANGM_graphic_theme'];
		$record['GRAPHIC_THEME_COLOR'] =  UserRequest::$post['ANGM_graphic_theme_color'];
        $record['EXEONSEARCH'] = UserRequest::$post['ANGM_exeonsearch'];
		$graphicobject = getToolObject('GXPL', UserRequest::$post['ANGM_graphic_type']);
        $graphicobject->savePanel($record);
        $recid = ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['ANGM_id']);
        unset($recid);
        $this->versionIncrease('ID', UserRequest::$post['ANGM_id']);
    }

    function createRecordVoid_() {
        ClxFreeReturn($this->createRecord_());
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['ANGM_idcode'];
        $record['IDNAME'] = UserRequest::$post['ANGM_idname'];
        $DICT = &getTool('DICT');
        $record['TITLE'] = $DICT->createEntry('ANGM_title', UserRequest::$post);
        $record['SUBTITLE'] = $DICT->createEntry('ANGM_subtitle', UserRequest::$post);
        $record['VERSION'] = UserRequest::$post['ANGM_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['ANGM_description'];
        $record['QUERYCODE'] = UserRequest::$post['ANGM_querycode'];
        $record['MODULECODE'] = UserRequest::$post['ANGM_modulecode'];
        $record['SEARCH_FORM'] = UserRequest::$post['ANGM_search_form'];
        $record['HSIZE'] = UserRequest::$post['ANGM_hsize'];
        $record['VSIZE'] = UserRequest::$post['ANGM_vsize'];
        $record['FONTSIZE'] = UserRequest::$post['ANGM_fontsize'];
        $record['FONTTYPE'] = UserRequest::$post['ANGM_fonttype'];
        $record['BORDER'] = UserRequest::$post['ANGM_border'];
        $record['SHOWNAMES'] = UserRequest::$post['ANGM_shownames'];
        $record['ROTATE_NAMES'] = UserRequest::$post['ANGM_rotate_names'];
        $record['SHOWVALUES'] = UserRequest::$post['ANGM_showvalues'];
        $record['ANIMATION'] = UserRequest::$post['ANGM_animation'];
        $record['SHOW_LEGEND'] = UserRequest::$post['ANGM_show_legend'];
        $record['SHOW_COLSHADOW'] = UserRequest::$post['ANGM_show_colshadow'];
        $record['SHOW_PCTVALUES'] = UserRequest::$post['ANGM_show_pctvalues'];
        $record['SHOW_PCTINLABEL'] = UserRequest::$post['ANGM_show_pctinlabel'];
        $record['GRAPHIC_TYPE'] = UserRequest::$post['ANGM_graphic_type'];
        $record['EXEONSEARCH'] = UserRequest::$post['ANGM_exeonsearch'];
		$graphicobject = getToolObject('GXPL', UserRequest::$post['ANGM_graphic_type']);
        $graphicobject->createPanel($record);
		
    //    echo "========1==",chr(10);
	//	echo $this->tablename;
	//	PRE($record);
	//	die;
		
		$recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $graphicobject->defaultRange($record);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $record['MODULECODE']);
		
		if (isset(UserRequest::$post['ANGM_id'])) {
		//	PRE(UserRequest::$post['ANGM_id']);
			$sql='INSERT INTO CLX_AN_GRAPHICS_SERIES (`CHARTCODE`, `NAME`, `TYPE`, `TABLECODE`, `FIELDNAME`, `FUNCTION` , `EXPRESSION` , 
			`GROUPBY`, `STATUS`,`SEQNUM`, `SERIES_PROPERTIES`, `USE_QUERY_FIELD`,
			`QUERYCODE` , `REL_TABLECODE`,`REL_FIELDNAME` )'.
			'SELECT '.singlequote($record['IDCODE']).',`NAME`, `TYPE`, `TABLECODE`, `FIELDNAME`, `FUNCTION` , `EXPRESSION` , 
			`GROUPBY`, `STATUS`,`SEQNUM`, `SERIES_PROPERTIES`, `USE_QUERY_FIELD`,
			`QUERYCODE` , `REL_TABLECODE`,`REL_FIELDNAME` 
			FROM CLX_AN_GRAPHICS_SERIES WHERE CHARTCODE=' . 
			'(SELECT IDCODE FROM CLX_AN_GRAPHICS WHERE ID= '.UserRequest::$post['ANGM_id'].')';
			ClxCommon::$db->executeQuery($sql);
		}
        return $recordid;
    }


    function deleteRecordSk($id) {
        $record = $this->loadToolRecord($id);
		$graphicobject = getToolObject('GXPL', $record['ANGM_graphic_type']);
        $graphicobject->deletePanel($record);
        ClxCommon::$db->deleteRecords('CLX_AN_GRAPHICS_SERIES', 'CHARTCODE=' . singleQuote($record['ANGM_idcode']));
        ClxCommon::$db->deleteRecords('CLX_AN_GRAPHICS_RANGES', 'CHARTCODE=' . singleQuote($record['ANGM_idcode']));
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $record['ANGM_modulecode']);
    }

    function defaultRecord() {//echo "aca";
        $record = array();
        $record['ANGM_id'] = CLX_INIT_ZERO;
        $record['ANGM_idcode'] = '';
        $record['ANGM_idname'] = '';
        $record['ANGM_title'] = '';
        $record['ANGM_title_DICT'] = '';
        $record['ANGM_subtitle'] = '';
        $record['ANGM_subtitle_DICT'] = '';
        $record['ANGM_version'] = '1.0.0';
        $record['ANGM_cdate'] = '';
        $record['ANGM_mdate'] = '';
        $record['ANGM_username'] = $_SESSION['user_record']['username'];
        $record['ANGM_description'] = '';
        $record['ANGM_modulecode'] = '';
        $record['ANGM_querycode'] = '';
        $record['ANGM_search_form'] = '';
        $record['ANGM_hsize'] = '400';
        $record['ANGM_vsize'] = '400';
        $record['ANGM_fontsize'] = '12';
        $record['ANGM_fonttype'] = 'arial';
        $record['ANGM_border'] = '1';
        $record['ANGM_exeonsearch'] = '1';
        $record['ANGM_shownames'] = CLX_INIT_ZERO;
        $record['ANGM_rotate_names'] = CLX_INIT_ZERO;
        $record['ANGM_showvalues'] = CLX_INIT_ZERO;
        $record['ANGM_animation'] = CLX_INIT_ZERO;
        $record['ANGM_show_legend'] = CLX_INIT_ZERO;
        $record['ANGM_show_colshadow'] = CLX_INIT_ZERO;
        $record['ANGM_show_pctvalues'] = CLX_INIT_ZERO;
        $record['ANGM_show_pctinlabel'] = CLX_INIT_ZERO;
        $record['ANGM_graphic_type'] = 'PLAN';
		$record['ANGM_graphic_theme'] = $this->themes[0];
		$record['ANGM_graphic_theme_color'] = 'default';
		$OBJS = &getTool('OBJS');
        $graphiccodes = $OBJS->objectList('GXPL');
        foreach ($graphiccodes as $graphiccode) {

		  $graphicobject = $OBJS->getObject_('GXPL', $graphiccode);
		  $graphicobject->defaultPanel($record);
        }
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        parent::versionIncrease($fieldname, $fieldvalue);
        $modulecode = ClxCommon::$db->getField($this->tablename, 'MODULECODE', $fieldname . '=' . singleQuote($fieldvalue));
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $modulecode);
    }

    /**
     * Builds Pagelet for Tool
     * @param string $code
     * @param string $ac
     * @param integer $objectid
     * @return string
     */
    function pagelet($code, $ac = null, $objectid = null) {
        return $this->graphic($code);
    }

    function graphicQuery($graphiccode, &$series_records, &$sql) {
        $graphicrecord = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote($graphiccode));
        $graphicinstance = getToolObject('GXPL', $graphicrecord['GRAPHIC_TYPE']);
        $graphicinstance->GraphicsQuery($graphicrecord, $series_records, $sql);
    }

    /**
     * Return true if graphic exists or false on falure
     */
    function chartExists(&$idcode) {
        $qty = ClxCommon::$db->countRecords($this->tablename, 'IDCODE=' . singleQuote($idcode));
        if ($qty > CLX_NUM_ZERO) {
		  $idcode = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'IDCODE=' . singleQuote($idcode));
        }
        return $qty > CLX_NUM_ZERO;
    }

    function graphicData($graphicrecord) {

        $graphicinstance = getToolObject('GXPL', $graphicrecord['GRAPHIC_TYPE']);
        $series_data = $graphicinstance->graphicData($graphicrecord);
        return $series_data;
    }

    /**
     * returns the actual flash graphic
     *
     * @param unknown_type $chartcode
     * @return unknown
     */
	function getgraphic($idlist) {
		$record = $this->loadToolRecord(getidlist()[0]);
		$chartcode=$record['ANGM_idcode'];
        $graphicrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($chartcode));
        $graphicinstance = getToolObject('GXPL', $graphicrec['GRAPHIC_TYPE']);
        $graphicinstance->return_xml_only = false;
		return $graphicinstance->html5graphics($graphicrec,$record);

	}
	function graphic($chartcode) {

        if (!$this->getAccess()->canRead()) {
		  return warning(dict('GEN_ERR_NO_ACCESS') . ' [AN_GRAPHIC-CAN_READ_1]' . ' ' . $this->getCode(false));
        }
        $graphicrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($chartcode));
        $DBQY = getTool('DBQY');
        //$qaccess = $DBQY->getUserAccess($graphicrec['QUERYCODE']);
        $qaccess = $DBQY->getAppAccess($graphicrec['QUERYCODE']);
        if (!$qaccess->canRead()) {
		  return warning(dict('GEN_ERR_NO_ACCESS') . ' [AN_GRAPHIC-CAN_READ_2]' . ' ' . $this->getCode(false) . ' Query: ' . $graphicrec['QUERYCODE']);
        }

//$graphicinstance = getToolObject('GXPL', $graphicrec['GRAPHIC_TYPE']);
        $objeto=rand(1,1000000000);
		$Xcontents='
			<div>
				<div style="float: left;width: '.($graphicrec['HSIZE']+1).'px;height:'.($graphicrec['VSIZE']+1).'px;background-color:blue-light;">
					<div id="carga_GRAPHIC_'.$objeto.'"></div>
				</div>

			</div>	
			<script type="text/javascript">	
			$(document ).ready(function() {
				console.log( "ready!" );
				$("#carga_GRAPHIC_'.$objeto.'").load("window.php?to=ANGM&ac=GETGRAPHIC&selector_'.$graphicrec['ID'].'=1&sublist=&submitx1=Desplegar=&mc=&relfm=");


			});
			</script>

			';
		$imgconttable = new htmlTable(CLX_WIDTH_ONE);
		$imgconttable->setProps(array( CLX_PROP_WIDTH => ($graphicrec['HSIZE']+1).'px'));
        $imgconttable->addCell($Xcontents, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        return $imgconttable->source();
    }    

    /**
     * Returns graphic xml data
     *
     * @param string $chartcode
     * @return string
     */
	/* tipos de chart 
//////////////	   area2d
{
	chart": {
        "caption": "Sales of Liquor",
        "subCaption": "Last week",
        "xAxisName": "Day",
        "yAxisName": "Sales (In USD)",
        "numberPrefix": "$",
        "showValues": "1",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Mon",
		  "value": "4123"
        },
        {
		  "label": "Tue",
		  "value": "4633"
        },
        {
		  "label": "Wed",
		  "value": "5507"
        },
        {
		  "label": "Thu",
		  "value": "4910"
        },
        {
		  "label": "Fri",
		  "value": "5529"
        },
        {
		  "label": "Sat",
		  "value": "5803"
        },
        {
		  "label": "Sun",
		  "value": "6202"
        }
    ]
}
//////// barra 2d	 
{
    "chart": {
        "caption": "Top 5 Stores by Sales",
        "subCaption": "Last month",
        "yAxisName": "Sales (In USD)",
        "numberPrefix": "$",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Bakersfield Central",
		  "value": "880000"
        },
        {
		  "label": "Garden Groove harbour",
		  "value": "730000"
        },
        {
		  "label": "Los Angeles Topanga",
		  "value": "590000"
        },
        {
		  "label": "Compton-Rancho Dom",
		  "value": "520000"
        },
        {
		  "label": "Daly City Serramonte",
		  "value": "330000"
        }
    ]
}
/////////////////barra 3d
{
    "chart": {
        "caption": "Top 5 Stores by Sales",
        "subCaption": "Last month",
        "yAxisName": "Sales (In USD)",
        "numberPrefix": "$",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Bakersfield Central",
		  "value": "880000"
        },
        {
		  "label": "Garden Groove harbour",
		  "value": "730000"
        },
        {
		  "label": "Los Angeles Topanga",
		  "value": "590000"
        },
        {
		  "label": "Compton-Rancho Dom",
		  "value": "520000"
        },
        {
		  "label": "Daly City Serramonte",
		  "value": "330000"
        }
    ]
}	 
//// box and wisker 2d
{
    "chart": {
        "caption": "Distribution of annual salaries",
        "subcaption": "By Gender",
        "xAxisName": "Pay Grades",
        "YAxisName": "Salaries (In USD)",
        "numberPrefix": "$",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Grade 1"
			 },
			 {
			     "label": "Grade 2"
			 },
			 {
			     "label": "Grade 3"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Male",
		  "lowerboxcolor": "#0075c2",
		  "upperboxcolor": "#1aaf5d",
		  "data": [
			 {
			     "value": "2400,2000,2500,2800,3500,4000, 3700, 3750, 3880, 5000,5500,7500,8000,8200, 8400, 8500, 8550, 8800, 8700, 9000, 14000"
			 },
			 {
			     "value": "7500,9000,12000,13000,14000,16500,17000, 18000, 19000, 19500"
			 },
			 {
			     "value": "15000,19000,25000,32000,50000,65000"
			 }
		  ]
        },
        {
		  "seriesname": "Female",
		  "lowerboxcolor": "#f45b00",
		  "upperboxcolor": "#f2c500",
		  "data": [
			 {
			     "value": "1900,2100,2300,2350,2400,2550,3000,3500,4000, 6000, 6500, 9000"
			 },
			 {
			     "value": "7000,8000,8300,8700,9500,11000,15000, 17000, 21000"
			 },
			 {
			     "value": "24000,32000,35000,37000,39000, 58000"
			 }
		  ]
        }
    ]
}	 
//// bubble chart
{
    "chart": {
        "caption": "Sales Analysis of Shoe Brands",
        "subcaption": "Last Quarter",
        "xAxisMinValue": "0",
        "xAxisMaxValue": "100",
        "yAxisMinValue": "0",
        "yAxisMaxValue": "30000",
        "plotFillAlpha": "70",
        "plotFillHoverColor": "#6baa01",
        "xAxisName": "Average Price",
        "yAxisName": "Units Sold",
        "numDivlines": "2",
        "showValues": "1",
        "plotTooltext": "$name : Profit Contribution - $zvalue%",
        "drawQuadrant": "1",
        "quadrantLineAlpha": "80",
        "quadrantLineThickness": "3",
        "quadrantXVal": "50",
        "quadrantYVal": "15000",
        "quadrantLabelTL": "Low Price / High Sale",
        "quadrantLabelTR": "High Price / High Sale",
        "quadrantLabelBL": "Low Price / Low Sale",
        "quadrantLabelBR": "High Price / Low Sale",
        "use3dlighting": "0",
        "showAlternateHGridColor": "0",
        "showAlternateVGridColor": "0",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "$0",
			     "x": "0"
			 },
			 {
			     "label": "$20",
			     "x": "20",
			     "showverticalline": "1"
			 },
			 {
			     "label": "$40",
			     "x": "40",
			     "showverticalline": "1"
			 },
			 {
			     "label": "$60",
			     "x": "60",
			     "showverticalline": "1"
			 },
			 {
			     "label": "$80",
			     "x": "80",
			     "showverticalline": "1"
			 },
			 {
			     "label": "$100",
			     "x": "100",
			     "showverticalline": "1"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "color": "#00aee4",
		  "data": [
			 {
			     "x": "80",
			     "y": "15000",
			     "z": "24",
			     "name": "Nike"
			 },
			 {
			     "x": "60",
			     "y": "18500",
			     "z": "26",
			     "name": "Adidas"
			 },
			 {
			     "x": "50",
			     "y": "19450",
			     "z": "19",
			     "name": "Puma"
			 },
			 {
			     "x": "65",
			     "y": "10500",
			     "z": "8",
			     "name": "Fila"
			 },
			 {
			     "x": "43",
			     "y": "8750",
			     "z": "5",
			     "name": "Lotto"
			 },
			 {
			     "x": "32",
			     "y": "22000",
			     "z": "10",
			     "name": "Reebok"
			 },
			 {
			     "x": "44",
			     "y": "13000",
			     "z": "9",
			     "name": "Woodland"
			 }
		  ]
        }
    ],
    "trendlines": [
        {
		  "line": [
			 {
			     "startValue": "20000",
			     "endValue": "30000",
			     "isTrendZone": "1",
			     "color": "#aaaaaa",
			     "alpha": "14"
			 },
			 {
			     "startValue": "10000",
			     "endValue": "20000",
			     "isTrendZone": "1",
			     "color": "#aaaaaa",
			     "alpha": "7"
			 }
		  ]
        }
    ],
    "vTrendlines": [
        {
		  "line": [
			 {
			     "startValue": "44",
			     "isTrendZone": "0",
			     "color": "#0066cc",
			     "thickness": "1",
			     "dashed": "1",
			     "displayValue": "Gross Avg."
			 }
		  ]
        }
    ]
}	 
// candelist chart

{
    "chart": {
        "caption": "Daily Stock Price HRYS",
        "subCaption": "Last 2 months",
        "numberprefix": "$",
        "vNumberPrefix": " ",
        "pyaxisname": "Price",
        "vyaxisname": "Volume (In Millions)",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "2 month ago",
			     "x": "1"
			 },
			 {
			     "label": "1 month ago",
			     "x": "31"
			 },
			 {
			     "label": "Today",
			     "x": "60"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "data": [
			 {
			     "open": "18.74",
			     "high": "19.16",
			     "low": "18.67 ",
			     "close": "18.99",
			     "x": "1",
			     "volume": "4991285"
			 },
			 {
			     "open": "18.74",
			     "high": "19.06",
			     "low": "18.54",
			     "close": "18.82",
			     "x": "2",
			     "volume": "3615889"
			 },
			 {
			     "open": "19.21",
			     "high": "19.3",
			     "low": "18.59 ",
			     "close": "18.65",
			     "x": "3",
			     "volume": "4749586"
			 },
			 {
			     "open": "19.85",
			     "high": "19.86",
			     "low": "19.12",
			     "close": "19.4",
			     "x": "4",
			     "volume": "4366740"
			 },
			 {
			     "open": "20.19",
			     "high": "20.21",
			     "low": "19.57",
			     "close": "19.92",
			     "x": "5",
			     "volume": "3982709"
			 },
			 {
			     "open": "20.47",
			     "high": "20.64",
			     "low": "20.15",
			     "close": "20.16",
			     "x": "6",
			     "volume": "2289403"
			 },
			 {
			     "open": "20.36",
			     "high": "20.52",
			     "low": "20.29",
			     "close": "20.48",
			     "x": "7",
			     "volume": "1950919"
			 },
			 {
			     "open": "20.21",
			     "high": "20.25",
			     "low": "19.91",
			     "close": "20.15",
			     "x": "8",
			     "volume": "2391070"
			 },
			 {
			     "open": "19.46",
			     "high": "20.54",
			     "low": "19.46",
			     "close": "20.22",
			     "x": "9",
			     "volume": "4548422"
			 },
			 {
			     "open": "19.24",
			     "high": "19.5",
			     "low": "19.13",
			     "close": "19.44",
			     "x": "10",
			     "volume": "1889811"
			 },
			 {
			     "open": "19.25",
			     "high": "19.41",
			     "low": "18.99",
			     "close": "19.22",
			     "x": "11",
			     "volume": "2543355"
			 },
			 {
			     "open": "18.85",
			     "high": "19.45",
			     "low": "18.8",
			     "close": "19.24",
			     "x": "12",
			     "volume": "2134393"
			 },
			 {
			     "open": "18.97",
			     "high": "19.01",
			     "low": "18.68",
			     "close": "18.95",
			     "x": "13",
			     "volume": "1740852"
			 },
			 {
			     "open": "18.69",
			     "high": "19",
			     "low": "18.35",
			     "close": "18.97",
			     "x": "14",
			     "volume": "2701392"
			 },
			 {
			     "open": "19.02",
			     "high": "19.1",
			     "low": "18.68",
			     "close": "18.7",
			     "x": "15",
			     "volume": "2198755"
			 },
			 {
			     "open": "19.29",
			     "high": "19.38",
			     "low": "18.88",
			     "close": "19.05",
			     "x": "16",
			     "volume": "2464958"
			 },
			 {
			     "open": "18.64",
			     "high": "19.35",
			     "low": "18.53",
			     "close": "19.33",
			     "x": "17",
			     "volume": "2962994"
			 },
			 {
			     "open": "18.14",
			     "high": "18.58",
			     "low": "18.08",
			     "close": "18.52",
			     "x": "18",
			     "volume": "1964932"
			 },
			 {
			     "open": "18.49",
			     "high": "18.92",
			     "low": "18.19",
			     "close": "18.26",
			     "x": "19",
			     "volume": "3013102"
			 },
			 {
			     "open": "18.71",
			     "high": "18.84",
			     "low": "18",
			     "close": "18.51",
			     "x": "20",
			     "volume": "4435894"
			 },
			 {
			     "open": "19.17",
			     "high": "19.35",
			     "low": "18.61",
			     "close": "18.66",
			     "x": "21",
			     "volume": "3245851"
			 },
			 {
			     "open": "19.12",
			     "high": "19.41",
			     "low": "18.92",
			     "close": "19.2",
			     "x": "22",
			     "volume": "2259792"
			 },
			 {
			     "open": "19.43",
			     "high": "19.58",
			     "low": "19.16",
			     "close": "19.33",
			     "x": "23",
			     "volume": "3531327"
			 },
			 {
			     "open": "19.72",
			     "high": "19.81",
			     "low": "19.04",
			     "close": "19.27",
			     "x": "24",
			     "volume": "5834733"
			 },
			 {
			     "open": "19.7",
			     "high": "19.94",
			     "low": "19.49",
			     "close": "19.77",
			     "x": "25",
			     "volume": "2009987"
			 },
			 {
			     "open": "19.84",
			     "high": "19.98",
			     "low": "19.39",
			     "close": "19.88",
			     "x": "26",
			     "volume": "2767592"
			 },
			 {
			     "open": "20.71",
			     "high": "20.73",
			     "low": "19.16",
			     "close": "19.63",
			     "x": "27",
			     "volume": "673358"
			 },
			 {
			     "open": "21.14",
			     "high": "21.14",
			     "low": "20.55",
			     "close": "20.65",
			     "x": "28",
			     "volume": "3164006"
			 },
			 {
			     "open": "21.5",
			     "high": "21.86",
			     "low": "21.2",
			     "close": "21.33",
			     "x": "29",
			     "volume": "7986466"
			 },
			 {
			     "open": "20.45",
			     "high": "21.08",
			     "low": "20.1",
			     "close": "20.56",
			     "x": "30",
			     "volume": "5813040"
			 },
			 {
			     "open": "20.07",
			     "high": "20.69",
			     "low": "20.04",
			     "close": "20.36",
			     "x": "31",
			     "volume": "3440002"
			 },
			 {
			     "open": "19.88",
			     "high": "20.11",
			     "low": "19.51",
			     "close": "20.03",
			     "x": "32",
			     "volume": "2779171"
			 },
			 {
			     "open": "19.76",
			     "high": "20.13",
			     "low": "19.65",
			     "close": "19.88",
			     "x": "33",
			     "volume": "2918115"
			 },
			 {
			     "open": "19.77",
			     "high": "19.97",
			     "low": "19.27",
			     "close": "19.9",
			     "x": "34",
			     "volume": "3850357"
			 },
			 {
			     "open": "19.43",
			     "high": "19.72",
			     "low": "18.88",
			     "close": "19.5",
			     "x": "35",
			     "volume": "5047378"
			 },
			 {
			     "open": "19.69",
			     "high": "19.84",
			     "low": "19.17",
			     "close": "19.43",
			     "x": "36",
			     "volume": "3479017"
			 },
			 {
			     "open": "19.59",
			     "high": "20.02",
			     "low": "19.02",
			     "close": "19.41",
			     "x": "37",
			     "volume": "5749874"
			 },
			 {
			     "open": "20.95",
			     "high": "21.09",
			     "low": "19.64",
			     "close": "19.83",
			     "x": "38",
			     "volume": "6319111"
			 },
			 {
			     "open": "20.52",
			     "high": "21.03",
			     "low": "20.45",
			     "close": "21",
			     "x": "39",
			     "volume": "4412413"
			 },
			 {
			     "open": "20.36",
			     "high": "20.96",
			     "low": "20.2",
			     "close": "20.44",
			     "x": "40",
			     "volume": "5948318"
			 },
			 {
			     "open": "21.45",
			     "high": "21.48",
			     "low": "19.63",
			     "close": "20.3",
			     "x": "41",
			     "volume": "11935440"
			 },
			 {
			     "open": "23.49",
			     "high": "23.57",
			     "low": "21.12",
			     "close": "21.63",
			     "x": "42",
			     "volume": "10523910"
			 },
			 {
			     "open": "24.04",
			     "high": "24.21",
			     "low": "23.04",
			     "close": "23.28",
			     "x": "43",
			     "volume": "3843797"
			 },
			 {
			     "open": "23.6",
			     "high": "24.065",
			     "low": "23.51",
			     "close": "23.94",
			     "x": "44",
			     "volume": "3691404"
			 },
			 {
			     "open": "22.87",
			     "high": "23.49",
			     "low": "22.86",
			     "close": "23.48",
			     "x": "45",
			     "volume": "3387393"
			 },
			 {
			     "open": "22.35",
			     "high": "22.89",
			     "low": "22.35",
			     "close": "22.74",
			     "x": "46",
			     "volume": "3737330"
			 },
			 {
			     "open": "22.11",
			     "high": "22.5",
			     "low": "21.9",
			     "close": "22.24",
			     "x": "47",
			     "volume": "4630397"
			 },
			 {
			     "open": "22.58",
			     "high": "22.80",
			     "low": "22.25",
			     "close": "22.42",
			     "x": "48",
			     "volume": "3024711"
			 },
			 {
			     "open": "23.54",
			     "high": "23.76",
			     "low": "22.6",
			     "close": "22.68",
			     "x": "49",
			     "volume": "3984508"
			 },
			 {
			     "open": "23.66",
			     "high": "24.09",
			     "low": "23.09",
			     "close": "23.46",
			     "x": "50",
			     "volume": "3420204"
			 },
			 {
			     "open": "24.36",
			     "high": "24.42",
			     "low": "22.90",
			     "close": "23.6",
			     "x": "51",
			     "volume": "5151096"
			 },
			 {
			     "open": "24.34",
			     "high": "24.6",
			     "low": "23.73",
			     "close": "24.15",
			     "x": "52",
			     "volume": "5999654"
			 },
			 {
			     "open": "23.38",
			     "high": "24.8",
			     "low": "23.36",
			     "close": "24.1",
			     "x": "53",
			     "volume": "5382049"
			 },
			 {
			     "open": "23.76",
			     "high": "23.84",
			     "low": "23.23",
			     "close": "23.47",
			     "x": "54",
			     "volume": "3508510"
			 },
			 {
			     "open": "23.64",
			     "high": "23.94",
			     "low": "23.48",
			     "close": "23.76",
			     "x": "55",
			     "volume": "2718428"
			 },
			 {
			     "open": "23.99",
			     "high": "24.18",
			     "low": "23.59",
			     "close": "23.66",
			     "x": "56",
			     "volume": "2859391"
			 },
			 {
			     "open": "23.32",
			     "high": "24.26",
			     "low": "23.32",
			     "close": "23.79",
			     "x": "57",
			     "volume": "4138618"
			 },
			 {
			     "open": "24.08",
			     "high": "24.4",
			     "low": "23.26",
			     "close": "23.39",
			     "x": "58",
			     "volume": "4477478"
			 },
			 {
			     "open": "22.84",
			     "high": "23.96",
			     "low": "22.83",
			     "close": "23.88",
			     "x": "59",
			     "volume": "4822378"
			 },
			 {
			     "open": "23.38",
			     "high": "23.78",
			     "low": "22.94",
			     "close": "23.01",
			     "x": "60",
			     "volume": "4037312"
			 },
			 {
			     "open": "23.97",
			     "high": "23.99",
			     "low": "23.14",
			     "close": "23.32",
			     "x": "61",
			     "volume": "4879546"
			 }
		  ]
        }
    ]
}	 
////////////// column 2d
JSON
XML
{
    "chart": {
        "caption": "Monthly revenue for last year",
        "subCaption": "Harry's SuperMart",
        "xAxisName": "Month",
        "yAxisName": "Revenues (In USD)",
        "numberPrefix": "$",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Jan",
		  "value": "420000"
        },
        {
		  "label": "Feb",
		  "value": "810000"
        },
        {
		  "label": "Mar",
		  "value": "720000"
        },
        {
		  "label": "Apr",
		  "value": "550000"
        },
        {
		  "label": "May",
		  "value": "910000"
        },
        {
		  "label": "Jun",
		  "value": "510000"
        },
        {
		  "label": "Jul",
		  "value": "680000"
        },
        {
		  "label": "Aug",
		  "value": "620000"
        },
        {
		  "label": "Sep",
		  "value": "610000"
        },
        {
		  "label": "Oct",
		  "value": "490000"
        },
        {
		  "label": "Nov",
		  "value": "900000"
        },
        {
		  "label": "Dec",
		  "value": "730000"
        }
    ],
    "trendlines": [
        {
		  "line": [
			 {
			     "startvalue": "700000",
			     "valueOnRight": "1",
			     "displayvalue": "Monthly Target"
			 }
		  ]
        }
    ]
}
//// column 3d
{
    "chart": {
        "caption": "Monthly revenue for last year",
        "subCaption": "Harry's SuperMart",
        "xAxisName": "Month",
        "yAxisName": "Revenues (In USD)",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Jan",
		  "value": "420000"
        },
        {
		  "label": "Feb",
		  "value": "810000"
        },
        {
		  "label": "Mar",
		  "value": "720000"
        },
        {
		  "label": "Apr",
		  "value": "550000"
        },
        {
		  "label": "May",
		  "value": "910000"
        },
        {
		  "label": "Jun",
		  "value": "510000"
        },
        {
		  "label": "Jul",
		  "value": "680000"
        },
        {
		  "label": "Aug",
		  "value": "620000"
        },
        {
		  "label": "Sep",
		  "value": "610000"
        },
        {
		  "label": "Oct",
		  "value": "490000"
        },
        {
		  "label": "Nov",
		  "value": "900000"
        },
        {
		  "label": "Dec",
		  "value": "730000"
        }
    ]
}
///////////drag line 2d
{
    "chart": {
        "caption": "Quarterly Sales Projections",
        "subCaption": "iPhone vs Samsung Galaxy",
        "xAxisName": "Quarter",
        "yAxisName": "No. of Units",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Q1"
			 },
			 {
			     "label": "Q2"
			 },
			 {
			     "label": "Q3(E)"
			 },
			 {
			     "label": "Q4(E)"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Apple",
		  "valuePosition": "ABOVE",
		  "allowDrag": "0",
		  "data": [
			 {
			     "value": "1200"
			 },
			 {
			     "value": "1500",
			     "dashed": "1"
			 },
			 {
			     "value": "1300",
			     "allowDrag": "1",
			     "dashed": "1"
			 },
			 {
			     "value": "900",
			     "allowDrag": "1",
			     "tooltext": "Predicted sales $value units"
			 }
		  ]
        },
        {
		  "seriesname": "Samsung",
		  "allowDrag": "0",
		  "data": [
			 {
			     "value": "600"
			 },
			 {
			     "value": "850",
			     "dashed": "1"
			 },
			 {
			     "value": "1000",
			     "allowDrag": "1",
			     "dashed": "1"
			 },
			 {
			     "value": "1200",
			     "allowDrag": "1",
			     "tooltext": "Predicted sales $value units"
			 }
		  ]
        }
    ]
}
/// error2dchart
{
    "chart": {
        "caption": "Machinery lifespan range",
        "subcaption": "Means & standard deviations",
        "xAxisName": "Systems",
        "yAxisName": "Life Span",
        "numberSuffix": " Years",
        "halfErrorBar": "0",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Central AC"
			 },
			 {
			     "label": "Computers"
			 },
			 {
			     "label": "Bar-code Scanners"
			 },
			 {
			     "label": "Packaging Machines"
			 },
			 {
			     "label": "Chilling Compartments"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Daly City Serramonte",
		  "data": [
			 {
			     "value": "8",
			     "errorvalue": "2"
			 },
			 {
			     "value": "3",
			     "errorvalue": "0.5"
			 },
			 {
			     "value": "2",
			     "errorvalue": "1"
			 },
			 {
			     "value": "6",
			     "errorvalue": "1.8"
			 },
			 {
			     "value": "8",
			     "errorvalue": "1.2"
			 }
		  ]
        },
        {
		  "seriesname": "Bakersfield Central",
		  "data": [
			 {
			     "value": "7",
			     "errorvalue": "1"
			 },
			 {
			     "value": "4",
			     "errorvalue": "0.5"
			 },
			 {
			     "value": "2",
			     "errorvalue": "1"
			 },
			 {
			     "value": "4",
			     "errorvalue": "0.8"
			 },
			 {
			     "value": "7",
			     "errorvalue": "1"
			 }
		  ]
        },
        {
		  "seriesname": "Garden Groove harbour",
		  "data": [
			 {
			     "value": "9",
			     "errorvalue": "2"
			 },
			 {
			     "value": "3",
			     "errorvalue": "0.7"
			 },
			 {
			     "value": "3",
			     "errorvalue": "1"
			 },
			 {
			     "value": "6",
			     "errorvalue": "1.8"
			 },
			 {
			     "value": "7",
			     "errorvalue": "1.2"
			 }
		  ]
        }
    ]
}
///////////////////errorline 2d
{
    "chart": {
        "caption": "Revenues and Profits",
        "subCaption": "Predicted for next year",
        "xAxisname": "Month",
        "yAxisName": "Amount (In USD)",
        "numberPrefix": "$",
        "halferrorbar": "0",
        "plotTooltext": "<div id='nameDiv' style='font-size: 14px; border-bottom: 1px dashed #999999; font-weight:bold; padding-bottom: 3px; margin-bottom: 5px; display: inline-block;'>$label :</div>{br}$seriesName : <b>$dataValue</b>{br}Deviation : <b>± $errorDataValue</b>",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Jan"
			 },
			 {
			     "label": "Feb"
			 },
			 {
			     "label": "Mar"
			 },
			 {
			     "label": "Apr"
			 },
			 {
			     "label": "May"
			 },
			 {
			     "label": "Jun"
			 },
			 {
			     "label": "Jul"
			 },
			 {
			     "label": "Aug"
			 },
			 {
			     "label": "Sep"
			 },
			 {
			     "label": "Oct"
			 },
			 {
			     "label": "Nov"
			 },
			 {
			     "label": "Dec"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesName": "Revenues",
		  "dashed": "1",
		  "dashlen": "2",
		  "dashGap": "2",
		  "data": [
			 {
			     "value": "16000",
			     "errorvalue": "2000"
			 },
			 {
			     "value": "20000",
			     "errorvalue": "4000"
			 },
			 {
			     "value": "18000",
			     "errorvalue": "1000"
			 },
			 {
			     "value": "19000",
			     "errorvalue": "1500"
			 },
			 {
			     "value": "15000",
			     "errorvalue": "1000"
			 },
			 {
			     "value": "21000",
			     "errorvalue": "4500"
			 },
			 {
			     "value": "16000",
			     "errorvalue": "1500"
			 },
			 {
			     "value": "20000",
			     "errorvalue": "3000"
			 },
			 {
			     "value": "17000",
			     "errorvalue": "2000"
			 },
			 {
			     "value": "22000",
			     "errorvalue": "4000"
			 },
			 {
			     "value": "19000",
			     "errorvalue": "2500"
			 },
			 {
			     "value": "23000",
			     "errorvalue": "3000"
			 }
		  ]
        },
        {
		  "seriesName": "Profits",
		  "dashed": "1",
		  "dashlen": "2",
		  "dashGap": "2",
		  "data": [
			 {
			     "value": "8000",
			     "errorvalue": "2000"
			 },
			 {
			     "value": "9000",
			     "errorvalue": "2000"
			 },
			 {
			     "value": "7000",
			     "errorvalue": "2700"
			 },
			 {
			     "value": "8000",
			     "errorvalue": "2750"
			 },
			 {
			     "value": "6000",
			     "errorvalue": "1200"
			 },
			 {
			     "value": "11000",
			     "errorvalue": "3000"
			 },
			 {
			     "value": "6900",
			     "errorvalue": "1250"
			 },
			 {
			     "value": "8000",
			     "errorvalue": "1400"
			 },
			 {
			     "value": "6500",
			     "errorvalue": "1200"
			 },
			 {
			     "value": "12000",
			     "errorvalue": "3000"
			 },
			 {
			     "value": "6000",
			     "errorvalue": "1500"
			 },
			 {
			     "value": "11000",
			     "errorvalue": "2500"
			 }
		  ]
        }
    ]
}
///error scatter
{
    "chart": {
        "xaxisname": "Month",
        "yaxisname": "Revenue (In USD)",
        "caption": "Revenue forecast",
        "subcaption": "For Next Year",
        "halfverticalerrorbar": "0",
        "numberPrefix": "$",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Jan",
			     "x": "20"
			 },
			 {
			     "label": "Feb",
			     "x": "30"
			 },
			 {
			     "label": "Mar",
			     "x": "40"
			 },
			 {
			     "label": "Apr",
			     "x": "50"
			 },
			 {
			     "label": "May",
			     "x": "60"
			 },
			 {
			     "label": "Jun",
			     "x": "70"
			 },
			 {
			     "label": "Jul",
			     "x": "80"
			 },
			 {
			     "label": "Aug",
			     "x": "90"
			 },
			 {
			     "label": "Sep",
			     "x": "100"
			 },
			 {
			     "label": "Oct",
			     "x": "110"
			 },
			 {
			     "label": "Nov",
			     "x": "120"
			 },
			 {
			     "label": "Dec",
			     "x": "130"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "This Year",
		  "color": "",
		  "anchorradius": "8",
		  "anchorbgcolor": "#1aaf5d",
		  "data": [
			 {
			     "y": "450000",
			     "x": "20",
			     "verticalErrorValue": "50000"
			 },
			 {
			     "y": "860000",
			     "x": "30",
			     "verticalErrorValue": "69000"
			 },
			 {
			     "y": "750000",
			     "x": "40",
			     "verticalErrorValue": "69000"
			 },
			 {
			     "y": "570000",
			     "x": "50",
			     "verticalErrorValue": "60000"
			 },
			 {
			     "y": "910000",
			     "x": "60",
			     "verticalErrorValue": "50000"
			 },
			 {
			     "y": "580000",
			     "x": "70",
			     "verticalErrorValue": "55000"
			 },
			 {
			     "y": "610000",
			     "x": "80",
			     "verticalErrorValue": "87000"
			 },
			 {
			     "y": "620000",
			     "x": "90",
			     "verticalErrorValue": "45000"
			 },
			 {
			     "y": "520000",
			     "x": "100",
			     "verticalErrorValue": "59000"
			 },
			 {
			     "y": "530000",
			     "x": "110",
			     "verticalErrorValue": "72000"
			 },
			 {
			     "y": "950000",
			     "x": "120",
			     "verticalErrorValue": "69000"
			 },
			 {
			     "y": "770000",
			     "x": "130",
			     "verticalErrorValue": "69000"
			 }
		  ]
        }
    ]
}
//doughtnut 3d
{
    "chart": {
        "caption": "Split of Revenue by Product Categories",
        "subCaption": "Last year",
        "numberPrefix": "$",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Food",
		  "value": "28504"
        },
        {
		  "label": "Apparels",
		  "value": "14633"
        },
        {
		  "label": "Electronics",
		  "value": "10507"
        },
        {
		  "label": "Household",
		  "value": "4910"
        }
    ]
}
//dragable area 2d
{
    "chart": {
        "caption": "Quarterly Sales Projections",
        "subCaption": "iPhone vs Samsung Galaxy",
        "xAxisName": "Quarter",
        "yAxisName": "No. of Units",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Q1"
			 },
			 {
			     "label": "Q2"
			 },
			 {
			     "label": "Q3(E)"
			 },
			 {
			     "label": "Q4(E)"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Apple",
		  "valuePosition": "ABOVE",
		  "allowDrag": "0",
		  "data": [
			 {
			     "value": "1200"
			 },
			 {
			     "value": "1500",
			     "dashed": "1"
			 },
			 {
			     "value": "1300",
			     "allowDrag": "1",
			     "dashed": "1"
			 },
			 {
			     "value": "900",
			     "allowDrag": "1",
			     "tooltext": "Predicted sales $value units"
			 }
		  ]
        },
        {
		  "seriesname": "Samsung",
		  "allowDrag": "0",
		  "data": [
			 {
			     "value": "600"
			 },
			 {
			     "value": "850",
			     "dashed": "1"
			 },
			 {
			     "value": "1000",
			     "allowDrag": "1",
			     "dashed": "1"
			 },
			 {
			     "value": "1200",
			     "allowDrag": "1",
			     "tooltext": "Predicted sales $value units"
			 }
		  ]
        }
    ]
}
//////////// dragable column 2d
{
    "chart": {
        "caption": "Inventory status - Bakersfield Central",
        "subCaption": "Top 5 Food items",
        "xAxisName": "Food Item",
        "yAxisName": "No. of Units",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Poultry"
			 },
			 {
			     "label": "Rice"
			 },
			 {
			     "label": "Peanut Butter"
			 },
			 {
			     "label": "Salmon"
			 },
			 {
			     "label": "Cereal"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Available Stock",
		  "allowDrag": "0",
		  "data": [
			 {
			     "value": "6000"
			 },
			 {
			     "value": "9500"
			 },
			 {
			     "value": "11900"
			 },
			 {
			     "value": "8000"
			 },
			 {
			     "value": "9700"
			 }
		  ]
        },
        {
		  "seriesname": "Estimated Demand",
		  "dashed": "1",
		  "data": [
			 {
			     "value": "19000"
			 },
			 {
			     "value": "16500"
			 },
			 {
			     "value": "14300"
			 },
			 {
			     "value": "10000"
			 },
			 {
			     "value": "9800"
			 }
		  ]
        }
    ]
}
////dragable 2d line

{
    "chart": {
        "caption": "Quarterly Sales Projections",
        "subCaption": "iPhone vs Samsung Galaxy",
        "xAxisName": "Quarter",
        "yAxisName": "No. of Units",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Q1"
			 },
			 {
			     "label": "Q2"
			 },
			 {
			     "label": "Q3(E)"
			 },
			 {
			     "label": "Q4(E)"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Apple",
		  "valuePosition": "ABOVE",
		  "allowDrag": "0",
		  "data": [
			 {
			     "value": "1200"
			 },
			 {
			     "value": "1500",
			     "dashed": "1"
			 },
			 {
			     "value": "1300",
			     "allowDrag": "1",
			     "dashed": "1"
			 },
			 {
			     "value": "900",
			     "allowDrag": "1",
			     "tooltext": "Predicted sales $value units"
			 }
		  ]
        },
        {
		  "seriesname": "Samsung",
		  "allowDrag": "0",
		  "data": [
			 {
			     "value": "600"
			 },
			 {
			     "value": "850",
			     "dashed": "1"
			 },
			 {
			     "value": "1000",
			     "allowDrag": "1",
			     "dashed": "1"
			 },
			 {
			     "value": "1200",
			     "allowDrag": "1",
			     "tooltext": "Predicted sales $value units"
			 }
		  ]
        }
    ]
}
//multiseries 3d
{
    "chart": {
        "caption": "Split of Sales by Product Category",
        "subCaption": "In top 5 stores last month",
        "yAxisname": "Sales (In USD)",
        "numberPrefix": "$",
        "alignCaptionWithCanvas": "1",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Bakersfield Central"
			 },
			 {
			     "label": "Garden Groove harbour"
			 },
			 {
			     "label": "Los Angeles Topanga"
			 },
			 {
			     "label": "Compton-Rancho Dom"
			 },
			 {
			     "label": "Daly City Serramonte"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Food Products",
		  "data": [
			 {
			     "value": "17000"
			 },
			 {
			     "value": "19500"
			 },
			 {
			     "value": "12500"
			 },
			 {
			     "value": "14500"
			 },
			 {
			     "value": "17500"
			 }
		  ]
        },
        {
		  "seriesname": "Non-Food Products",
		  "data": [
			 {
			     "value": "25400"
			 },
			 {
			     "value": "29800"
			 },
			 {
			     "value": "21800"
			 },
			 {
			     "value": "19500"
			 },
			 {
			     "value": "11500"
			 }
		  ]
        }
    ]
}

//multiseries 2d
{
    "chart": {
        "caption": "Split of Sales by Product Category",
        "subCaption": "In top 5 stores last month",
        "yAxisname": "Sales (In USD)",
        "numberPrefix": "$",
        "placevaluesInside": "1",
        "xAxisLineColor": "#999999",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Bakersfield Central"
			 },
			 {
			     "label": "Garden Groove harbour"
			 },
			 {
			     "label": "Los Angeles Topanga"
			 },
			 {
			     "label": "Compton-Rancho Dom"
			 },
			 {
			     "label": "Daly City Serramonte"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Food Products",
		  "data": [
			 {
			     "value": "17000"
			 },
			 {
			     "value": "19500"
			 },
			 {
			     "value": "12500"
			 },
			 {
			     "value": "14500"
			 },
			 {
			     "value": "17500"
			 }
		  ]
        },
        {
		  "seriesname": "Non-Food Products",
		  "data": [
			 {
			     "value": "25400"
			 },
			 {
			     "value": "29800"
			 },
			 {
			     "value": "21800"
			 },
			 {
			     "value": "19500"
			 },
			 {
			     "value": "11500"
			 }
		  ]
        }
    ],
    "trendlines": [
        {
		  "line": [
			 {
			     "startvalue": "15000",
			     "color": "#0075c2",
			     "valueOnRight": "1",
			     "displayvalue": "Avg. for{br}Food"
			 },
			 {
			     "startvalue": "22000",
			     "color": "#1aaf5d",
			     "valueOnRight": "1",
			     "displayvalue": "Avg. for{br}Non-food"
			 }
		  ]
        }
    ]
}

//multiseries column 2d
{
    "chart": {
        "caption": "Comparison of Quarterly Revenue",
        "xAxisname": "Quarter",
        "yAxisName": "Revenues (In USD)",
        "numberPrefix": "$",
        "plotFillAlpha": "80",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Q1"
			 },
			 {
			     "label": "Q2"
			 },
			 {
			     "label": "Q3"
			 },
			 {
			     "label": "Q4"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Previous Year",
		  "data": [
			 {
			     "value": "10000"
			 },
			 {
			     "value": "11500"
			 },
			 {
			     "value": "12500"
			 },
			 {
			     "value": "15000"
			 }
		  ]
        },
        {
		  "seriesname": "Current Year",
		  "data": [
			 {
			     "value": "25400"
			 },
			 {
			     "value": "29800"
			 },
			 {
			     "value": "21800"
			 },
			 {
			     "value": "26800"
			 }
		  ]
        }
    ],
    "trendlines": [
        {
		  "line": [
			 {
			     "startvalue": "12250",
			     "color": "#0075c2",
			     "displayvalue": "Previous{br}Average",
			     "valueOnRight": "1",
			     "thickness": "1",
			     "showBelow": "1",
			     "tooltext": "Previous year quarterly target  : $13.5K"
			 },
			 {
			     "startvalue": "25950",
			     "color": "#1aaf5d",
			     "displayvalue": "Current{br}Average",
			     "valueOnRight": "1",
			     "thickness": "1",
			     "showBelow": "1",
			     "tooltext": "Current year quarterly target  : $23K"
			 }
		  ]
        }
    ]
}
///multiseries column 3d
{
    "chart": {
        "caption": "Harry's SuperMart",
        "subCaption": "Sales by quarter",
        "xAxisName": "Quarter",
        "yAxisName": "Sales (In USD)",
        "numberPrefix": "$",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Q1"
			 },
			 {
			     "label": "Q2"
			 },
			 {
			     "label": "Q3"
			 },
			 {
			     "label": "Q4"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Previous Year",
		  "data": [
			 {
			     "value": "10000"
			 },
			 {
			     "value": "11500"
			 },
			 {
			     "value": "12500"
			 },
			 {
			     "value": "15000"
			 }
		  ]
        },
        {
		  "seriesname": "Current Year",
		  "data": [
			 {
			     "value": "25400"
			 },
			 {
			     "value": "29800"
			 },
			 {
			     "value": "21800"
			 },
			 {
			     "value": "26800"
			 }
		  ]
        }
    ]
}
//pie 2d
{
    "chart": {
        "caption": "Split of Visitors by Age Group",
        "subCaption": "Last year",
        "use3DLighting": "0",
        "showPercentValues": "1",
        "decimals": "1",
        "useDataPlotColorForLabels": "1",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Teenage",
		  "value": "1250400"
        },
        {
		  "label": "Adult",
		  "value": "1463300"
        },
        {
		  "label": "Mid-age",
		  "value": "1050700"
        },
        {
		  "label": "Senior",
		  "value": "491000"
        }
    ]
}
//pie 3d 
{
    "chart": {
        "caption": "Split of Visitors by Age Group",
        "subCaption": "Last year",
        "enableSmartLabels": "0",
        "startingAngle": "0",
        "showPercentValues": "1",
        "decimals": "1",
        "useDataPlotColorForLabels": "1",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Teenage",
		  "value": "1250400"
        },
        {
		  "label": "Adult",
		  "value": "1463300"
        },
        {
		  "label": "Mid-age",
		  "value": "1050700"
        },
        {
		  "label": "Senior",
		  "value": "491000"
        }
    ]
}
///pyram 2d
{
    "chart": {
        "caption": "The Global Wealth Pyramid",
        "captionOnTop": "0",
        "captionPadding": "25",
        "alignCaptionWithCanvas": "1",
        "subcaption": "Credit Suisse 2013",
        "subCaptionFontSize": "12",
        "borderAlpha": "20",
        "is2D": "1",
        "showValues": "1",
        "numberPrefix": "$",
        "numberSuffix": "M",
        "plotTooltext": "$label of world population is worth USD $value tn ",
        "showPercentValues": "1",
        "chartLeftMargin": "40",
        "theme": "fusion"
    },
    "data": [
        {
		  "label": "Top 32 mn (0.7%)",
		  "value": "98.7"
        },
        {
		  "label": "Next 361 mn (7.7%)",
		  "value": "101.8"
        },
        {
		  "label": "Next 1.1 bn (22.9%)",
		  "value": "33"
        },
        {
		  "label": "Last 3.2 bn (68.7%)",
		  "value": "7.3"
        }
    ]
}
//radar chart
{
    "chart": {
        "caption": "Budget analysis",
        "subCaption": "Current month",
        "numberPrefix": "$",
        "theme": "fusion"
    },
    "categories": [
        {
		  "category": [
			 {
			     "label": "Marketing"
			 },
			 {
			     "label": "Product Management"
			 },
			 {
			     "label": "Customer Service"
			 },
			 {
			     "label": "Human Resource"
			 },
			 {
			     "label": "Sales & Distribution"
			 }
		  ]
        }
    ],
    "dataset": [
        {
		  "seriesname": "Allocated Budget",
		  "data": [
			 {
			     "value": "19000"
			 },
			 {
			     "value": "16500"
			 },
			 {
			     "value": "14300"
			 },
			 {
			     "value": "10000"
			 },
			 {
			     "value": "9800"
			 }
		  ]
        },
        {
		  "seriesname": "Actual Cost",
		  "data": [
			 {
			     "value": "6000"
			 },
			 {
			     "value": "9500"
			 },
			 {
			     "value": "11900"
			 },
			 {
			     "value": "8000"
			 },
			 {
			     "value": "9700"
			 }
		  ]
        }
    ]
}







	*/
    function getXmlData($chartcode) {
	//	pre($chartcode);
        $graphicrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($chartcode));
        $graphicinstance = getToolObject('GXPL', $graphicrec['GRAPHIC_TYPE']);
        $graphicinstance->return_xml_only = true;
	//	pre($graphicrec['GRAPHIC_TYPE']);
	    return $graphicinstance->build ($graphicrec);
    }
    function makeQuickFilterForm($graphiccode) {
        $graphicrecord = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote($graphiccode));
        $querycode = $graphicrecord['QUERYCODE'];
        if (!empty($graphicrecord['SEARCH_FORM'])) {
		  $UIFM = &getTool('UIFM');
		  $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
		  $form->setProp(CLX_PROP_ID, $querycode . '_QFILTER');
		  $form->addArgument(CLX_PROP_TO, 'EDIT');
		  $form->addArgument('ac', 'QFILTER');
		  $form->addArgument('li', $querycode);
		  $form->addArgument('qy', $querycode);
		  $schformrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote($graphicrecord['SEARCH_FORM']));
		  $form->addContents($UIFM->userEditForm($schformrec, '', UserRequest::$request, array(), $form));
		  $table = new htmlTable(CLX_WIDTH_ONE);
		  $table->setProps(array(CLX_PROP_CLASS => 'buttons', CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $b = htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID)));
		  $table->addCell($b->source(), array(CLX_PROP_CLASS => 'buttons'));
		  $form->addContents($table->source());
		  return $form->source();
        } else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }

// End method
}

//End Class
