<?php

/**
 * Reports Jobs Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-02-05 15:00:48 +0000 (Tue, 05 Feb 2019) $
 * @version    	$Rev: 10529 $
 * @package		Clientix.Tool.Analytics
 * @abstract		Report Jobs
 * CHANGE LOG
 *  Included label
 */
class an_report_jobs extends clx_tool {

    var $reportFormatForm;
	const RUN_IN_CRON_TRUE = '1'; // '1' means {run with clxcron.php instead of Ajax call} 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
	const LIST_REFRESH_SECS = '15000'; // Batch report listing refresh rate in miliseconds
	const LIST_MAX_RECS = CLX_NUM_TEN_THOUSAND; // Batch report listing max records per page
	var $renameSourceFile;

    function __construct() {
        $this->code = 'ANRJ';
        $this->name = 'Reports Jobs Manager';
        $this->system = 'Analytics';
        $this->version = '0.1.0.2';

        $this->has_preferences = false;
        $this->has_access = true;
        $this->has_package = false;
        $this->has_pagelet = true;

        $this->renameSourceFile=false;

        $this->tablename = 'CLX_AN_REPORT_JOBS';
        $this->record_name_singular = 'report job';
        $this->record_name_plural = 'report jobs';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IDNAME';
		$this->seqnum_field = '';
        $this->job_status = array('IDLE' => 'GEN_LBL_IDLE', 'RUN' => 'GEN_LBL_RUN', 'END' => 'GEN_LBL_END', 'ERRO' => 'GEN_LBL_ERROR');
		$this->debug=false;
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SYSTEMDATA:MENU_REPORT_JOBS', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['TOOLCODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['TOOLAC'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['TOOLID'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['PARAMETERS'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['MESSAGE'] = array('type' => 'varchar(255)', 'properties' => '');
        $fields['REP_MIME_TYPE'] = array('type' => 'varchar(20)', 'null' => 'NO', 'properties' => '');
        $fields['FILENAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['JOB_STATUS'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['START_DATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['END_DATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['BATCH_ID'] = array('type' => 'varchar(32)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'JOB_STATUS');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function action($ac, $idlist) {
		if ( !empty($_SESSION["_dEBUG"])or $this->debug ) { 
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo".($this->debug?"_jobs":"").".txt","a+");
			
			fwrite($tta,chr(13).chr(10).__LINE__. "(5)-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			$te=debug_backtrace();

			for ($t=0;$t<18;$t++) {
				if (isset($te[$t]["file"]))
				fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
			}
			fclose($tta);
		}	
        $msg = array();
		if ($this->getAccess()->canRead()) {
			switch ($ac) {
			 case 'SET_BATCH':
			  if ($this->getAccess()->canDisplay()) {
			         if ($this->validateBatch($msg)) {
					   $contents = $this->setBatch();
			         } else {
					   $contents = alert('-' . implode('<br>-', $msg));
			         }
			     } else {
			         $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[AN_REPORT_JOBS-CAN_APPEND][' . $ac . '] ' . $this->getCode(false));
			     }
			     break;
			 case 'RUN_BATCH':
			     $contents = $this->runBatch($idlist);
			     break;
			 case 'GET_BATCH':
			     $contents = $this->getBatch($idlist);
			     break;
			 case 'RUN_CRON_BATCH':
					// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
			     $contents = $this->runCronBatch();
			     break;
			 case 'RETRY':
			     $contents = $this->runRetry($idlist);
			     break;
			 case "SHOW_PANEL":
					// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
		    		//$contents = $this->makepanel(toString($idlist));
					//setJavaScriptTag('setTimeout(function(){  window.location.reload(1);}, 15000)');
					$contents = $this->makepanelWithTimeout($idlist);
			     break;
			 default:
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[AN_REPORT_JOBS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }
	
	/*
	 * This list appears in pop-up whem report ifs fired
	 */
	function makelist($listingcode = null) {
        $t = time();
        $to = $this->code;
        //$here = 'tool.php?to=' . $to . '&t=' . $t;
        $here = UserRequest::$server['PHP_SELF'].'?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        //$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->setProp(CLX_PROP_ID, 'ANRJList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = '';
        $sortclause = '';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_FIVE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANRJ_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FIVE));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_TOOLCODE'), dict('GEN_LBL_JOB_STATUS'), dict('GEN_LBL_BATCH_ID')));
		$i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
		  $recordid = $record['ID'];
		  $select = new htmlCheckbox('selector_' . $recordid, false);
		  $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
		  $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
		  $idname = $record['ID'] . ', ' . $record['IDNAME'];
		  if (!empty($record['FILENAME'])) {
			 $link = new htmlAnchor(getSkinIcon('document', false, dict('GEN_LBL_DOWNLOAD')) . ' ' . $idname, $record['FILENAME']);
			 $link->setProp(CLX_PROP_TARGET, 'blank');
			 $idname = $link->source();
			 unset($link);
		  } else {
			 $link = new htmlAnchor(getSkinIcon('sqsWait', false, dict('GEN_LBL_REFRESH_WAIT')) . ' ' . $idname, 'javascript:location.reload(true);');
			 $idname = $link->source();
			 unset($link);
		  }
		  $idname.= '<bR><i>' . dict('GEN_LBL_START') . ': ' . xFormat::date($record['START_DATE'], $_SESSION['prefs']['DATE_FORMAT'].' h:i:s');
		  if (!empty($record['END_DATE']))
			 $idname.= ', ' . dict('GEN_LBL_END') . ': ' . xFormat::date($record['END_DATE'], $_SESSION['prefs']['DATE_FORMAT'].' h:i:s');
		  $idname.= ' ' . dict('GEN_LBL_BY') . ' ' . $record['USERNAME'] . '</i>';
		  $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($idname, $record['TOOLCODE'] . '-' . $record['TOOLAC'] . '(' . $record['TOOLID'] . ')', dict($this->job_status[$record['JOB_STATUS']]), $record['BATCH_ID']));
		  $i++;
        }
		$buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canDelete()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
		// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
        if ($this->getAccess()->canModify()) {
			/*
			 * GEN_LBL_RETRY
			 * Retry
			 * Reintentar
			 */
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_RETRY'), array('action' => 'RETRY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
		// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
        //return $form->source();
        return jQueryIncludes() . setJavaScriptTag('js/standard/util.js', true, true) . CLX_CHAR_NL . $form->source();
    }

    /**
     * Builds Panel listing on tool
     *
     * @param string $groupcode
     * @return string
     */
    function makepanel($groupcode = null) {
		$this->assign_def_vals();
        $jobid = $groupcode;
        clearHistory();
        pushHistory($this->code, 'SHOW_PANEL', array());
        if ($this->getAccess()->canRead()) {
		  $t = time();
		  $to = $this->code;
		  //$here = 'tool.php?to=' . $to . '&t=' . $t;
		  $here = UserRequest::$server['PHP_SELF'].'?to=' . $to . '&t=' . $t;
		  $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
		  $form->setProp(CLX_PROP_ID, 'ANRJPanel');
		  $form->addArgument(CLX_PROP_TO, $this->code);
		  $form->addArgument('ac', 'NOT_DEFINED');
		  $form->addArgument('jobid', $jobid);
		  $selectclause = '*';
		  $fromclause = $this->tablename;
		  if (!empty($jobid)) {
			 // Only one or a group of Job ID
			 $whereclause = 'ID IN (' . $jobid . ')';
				// 2018-12-11 CR Al ser filtro por ID, elimina los demás filtros de la opción "Mis Reportes" | Caso 1003486 - GB-Rep BATCH no arranca
				$this->clearfilter();
		  } else {
			 // Just the current user jobs (to be implemented as menu option for the user (w/o display option), instead of ClientTools option
			 $whereclause = 'UPPER(USERNAME) = ' . singleQuote(uppercase($_SESSION['user_record']['username']));
		  }
		  $sortclause = 'START_DATE DESC';
			// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
			if(!empty($_SESSION['paging'][$this->code . 'List']['sortby'])) {
				$sortclause = $_SESSION['paging'][$this->code . 'List']['sortby'];
			}
			if(!empty($_SESSION['paging'][$this->code . 'List']['criteria'])) {
				$whereclause .= ' AND ' . $_SESSION['paging'][$this->code . 'List']['criteria'];
			}
		  $page = new xPaging();
			// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
		  //$page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
		  $page->setProp('rpp', ANRJ_LIST_MAX_RECS);
		  $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
		  $table = new htmlTable(CLX_WIDTH_EIGHT);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $table->addCell(dict('TOOL_ANRJ_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_EIGHT));
		  $page->header($table);
		  $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_TOOLCODE'), dict('GEN_LBL_JOB_STATUS'), dict('GEN_LBL_BATCH_ID'), dict('GEN_LBL_START_DATE'), dict('GEN_LBL_END_DATE'), dict('GEN_LBL_MESSAGE')));
		  $i = CLX_INIT_ZERO;
		  while ($record = $page->nextRecord()) {
			 $recordid = $record['ID'];
			 $select = new htmlCheckbox('selector_' . $recordid, false);
			 $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
			 $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
			 $idname = $record['ID'] . ', ' . $record['IDNAME'];
			 if (!empty($record['FILENAME'])) {
			     $link = new htmlAnchor(getSkinIcon('document', false, dict('GEN_LBL_DOWNLOAD')) . ' ' . $idname, $record['FILENAME']);
			     $link->setProp(CLX_PROP_TARGET, 'blank');
					
					if (isset( UserRequest::$request['UILG_format'] )) {
						$fname=explode(chr(47),$record['FILENAME']);
						$fname=$fname[count($fname)-1];
						$link->setProp('download', $fname);
					}
			     $idname = $link->source();
			     unset($link);
			 } else {//adding wait
			     $link = new htmlAnchor(getSkinIcon('sqsWait', false, dict('GEN_LBL_REFRESH_WAIT')) . ' ' . $idname, 'javascript:location.reload(true);');
			     /*.
					setJavaScriptTag('setTimeout(function(){  window.location.reload(1);}, 15000)')*/
			     $idname = $link->source();//.
					// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
			     setJavaScriptTag('setTimeout(function(){  location.reload(true);}, '.ANRJ_LIST_REFRESH_SECS.')');
			     unset($link);
			 }
			 $idname.= '<bR><i>' . dict('GEN_LBL_START') . ': ' . xFormat::date($record['START_DATE'], $_SESSION['prefs']['DATE_FORMAT'].' h:i:s');
			 if (!empty($record['END_DATE']))
			     $idname.= ', ' . dict('GEN_LBL_END') . ': ' . xFormat::date($record['END_DATE'], $_SESSION['prefs']['DATE_FORMAT'].' h:i:s');
			 $idname.= ' ' . dict('GEN_LBL_BY') . ' ' . $record['USERNAME'] . '</i>';
			 $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($idname, $record['TOOLCODE'] . '-' . $record['TOOLAC'] . '(' . $record['TOOLID'] . ')', dict($this->job_status[$record['JOB_STATUS']]), $record['BATCH_ID'], $record['START_DATE'], $record['END_DATE'], $record['MESSAGE']));
			 $i++;
		  }
		  $buttons = '';
		  if (empty($jobid) && $this->getAccess()->canDelete()) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  }
			// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
			if (empty($jobid) && $this->getAccess()->canModify()) {
				$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_RETRY'), array('action' => 'RETRY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
			}
			$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
		  $form->addContents($page->footers($table, $buttons));
			// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
		  //return getStyleHtml().buildPanelInterface(dict('TOOL_ANRJ_TITLE_LIST'), $jobid . 'TABLES', $form->source(), CLX_NUM_MINUS_1);
		  return getStyleHtml().buildPanelInterface(dict('TOOL_ANRJ_TITLE_LIST'), $jobid . 'TABLES', jQueryIncludes() . CLX_CHAR_NL . setJavaScriptTag('js/standard/util.js', true) . CLX_CHAR_NL . $form->source(), CLX_NUM_MINUS_1);
        } else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }

    function searchForm() {
        $msg = array();
        $contents = '';
        if (!array_key_exists('ANRJ_idname', UserRequest::$post))
		  UserRequest::$post['ANRJ_idname'] = '';
        if (!array_key_exists('ANRJ_toolcode', UserRequest::$post))
		  UserRequest::$post['ANRJ_toolcode'] = '';
        if (!array_key_exists('ANRJ_start_date', UserRequest::$post))
		  UserRequest::$post['ANRJ_start_date'] = '';
        if (!array_key_exists('ANRJ_username', UserRequest::$post))
		  UserRequest::$post['ANRJ_username'] = '';
        if (!array_key_exists('ANRJ_job_status', UserRequest::$post))
		  UserRequest::$post['ANRJ_job_status'] = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANRJ_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANRJ_idname', UserRequest::$post['ANRJ_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_TOOLCODE') . ':', 'ANRJ_toolcode', UserRequest::$post['ANRJ_toolcode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_START_DATE') . ':', 'ANRJ_start_date', UserRequest::$post['ANRJ_start_date'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_USERNAME') . ':', 'ANRJ_username', UserRequest::$post['ANRJ_username'], CLX_NUM_30, CLX_NUM_30);
        $table->addField($msg, dict('GEN_LBL_JOB_STATUS') . ':', 'ANRJ_job_status', UserRequest::$post['ANRJ_job_status'], CLX_NUM_16, CLX_NUM_16);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
		  $table = new htmlTable(CLX_WIDTH_FIVE);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $criteria = '';
		  if (UserRequest::$post['ANRJ_toolcode'] <> '') {
			 $criteria .= 'UPPER(TOOLCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANRJ_toolcode']) . '%');
		  }
		  if (UserRequest::$post['ANRJ_idname'] <> '') {
			 $criteria .= 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['ANRJ_idname'])) . '%');
		  }
		  if (UserRequest::$post['ANRJ_username'] <> '') {
			 $criteria .= 'UPPER(USERNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['ANRJ_username'])) . '%');
		  }
		  if (UserRequest::$post['ANRJ_job_status'] <> '') {
			 $criteria .= 'JOB_STATUS LIKE ' . singleQuote(UserRequest::$post['ANRJ_job_status'] . '%');
		  }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
		  if ($qty == CLX_NUM_ZERO) {
			 $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_FIVE));
		  } else {

			 $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FIVE));
			 $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
			 $i = CLX_INIT_ZERO;
			 while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			     $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['ID']) . ');';
			     $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=an_reports_jobs></page><a href=' . singleQuote($js) . '>' . $record['ID'] . '</a>', $record['IDNAME'], CLX_CHAR_HTML_NBSP, CLX_CHAR_HTML_NBSP, CLX_CHAR_HTML_NBSP));
			     $i++;
			 }
			 ClxCommon::$db->freeResult($records);
		  }
		  $contents .= $table->source();
        }
        return $contents;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_ID') . ':', $record['ANRJ_id']);
        $table->addData(dict('GEN_LBL_TOOLCODE') . ':', $record['ANRJ_toolcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['ANRJ_idname']);
    }

    function viewFormFill($record) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANRJ_TITLE_VIEW') . ': ' . $record['ANRJ_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_ID') . ':', $record['ANRJ_id']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['ANRJ_idname']);
        $table->addData(dict('GEN_LBL_TOOLCODE') . ':', $record['ANRJ_toolcode']);
        $table->addData(dict('GEN_LBL_TOOLAC') . ':', $record['ANRJ_toolac']);
        $table->addData(dict('GEN_LBL_TOOLID') . ':', $record['ANRJ_toolid']);
        $table->addData(dict('GEN_LBL_JOB_STATUS') . ':', $record['ANRJ_job_status']);
        $table->addData(dict('GEN_LBL_START_DATE') . ':', $record['ANRJ_start_date']);
        $table->addData(dict('GEN_LBL_END_DATE') . ':', $record['ANRJ_end_date']);
        $table->addData(dict('GEN_LBL_EXTENSION') . ':', $record['ANRJ_rep_mime_type']);
        $table->addData(dict('GEN_LBL_FILENAME') . ':', $record['ANRJ_filename']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['ANRJ_username']);
        $table->addData(dict('GEN_LBL_PARAMETERS') . ':', $record['ANRJ_parameters']);
        $table->addData(dict('GEN_LBL_BATCH_ID') . ':', $record['ANRJ_batch_id']);
        return $table->source();
    }

    function filterFormFill($msg, &$table) {
        if (!array_key_exists('ANRJ_idname', UserRequest::$post)) {
		  UserRequest::$post['ANRJ_idname'] = '';
        }
        if (!array_key_exists('ANRJ_toolcode', UserRequest::$post)) {
		  UserRequest::$post['ANRJ_toolcode'] = '';
        }
        if (!array_key_exists('ANRJ_start_date', UserRequest::$post)) {
		  UserRequest::$post['ANRJ_start_date'] = '';
        }
        if (!array_key_exists('ANRJ_username', UserRequest::$post)) {
		  UserRequest::$post['ANRJ_username'] = '';
        }
        if (!array_key_exists('ANRJ_job_status', UserRequest::$post)) {
		  UserRequest::$post['ANRJ_job_status'] = '';
        }
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANRJ_idname', UserRequest::$post['ANRJ_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_TOOLCODE') . ':', 'ANRJ_toolcode', UserRequest::$post['ANRJ_toolcode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_START_DATE') . ':', 'ANRJ_start_date', UserRequest::$post['ANRJ_start_date'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_USERNAME') . ':', 'ANRJ_username', UserRequest::$post['ANRJ_username'], CLX_NUM_30, CLX_NUM_30);
        $sort = new HtmlSelect('ANRJ_job_status');
        foreach ($this->job_status as $key => $val) {
		  $sort->addItem(dict($val), $key, false);
        }
        $table->addData(dict('GEN_LBL_JOB_STATUS') . ':', $sort->source());
        $sort = new HtmlSelect('ANRJ_sort');
        $sort->addItem('', '', true);
        $sort->addItem(dict('GEN_LBL_START_DATE'), 'modulecode', false);
        $sort->addItem(dict('GEN_LBL_NAME'), 'idname', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (UserRequest::$post['ANRJ_toolcode'] <> '') {
		  $filter .= $boolean . ' UPPER(TOOLCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANRJ_toolcode']) . '%');
		  $boolean = 'AND';
        }
        if (UserRequest::$post['ANRJ_idname'] <> '') {
		  $filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['ANRJ_idname'])) . '%');
		  $boolean = 'AND';
        }
        if (UserRequest::$post['ANRJ_username'] <> '') {
		  $filter .= $boolean . ' UPPER(USERNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['ANRJ_username'])) . '%');
		  $boolean = 'AND';
        }
        if (UserRequest::$post['ANRJ_job_status'] <> '') {
		  $filter .= $boolean . ' JOB_STATUS = ' . singleQuote(UserRequest::$post['ANRJ_job_status']);
		  $boolean = 'AND';
        }
		// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
		/*
        if (UserRequest::$post['ANRJ_job_status'] <> '') {
		  $filter .= $boolean . ' JOB_STATUS LIKE ' . singleQuote(UserRequest::$post['ANRJ_job_status'] . '%');
		  $boolean = 'AND';
        }
		*/
        $_SESSION['paging']['ANRJList']['sortby'] = UserRequest::$post['ANRJ_sort'];
        $_SESSION['paging']['ANRJList']['criteria'] = $filter;
        $_SESSION['paging']['ANRJList']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////	
    /*function clearfilter() {
        $_SESSION['paging']['ANRJList']['criteria'] = '';
        $_SESSION['paging']['ANRJList']['sortby'] = '';
        $_SESSION['paging']['ANRJList']['startat'] = '0';
    }*/
	
    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['ANRJ_id'] = $recordid;
        $record['ANRJ_idname'] = $values['IDNAME'];
        $record['ANRJ_start_date'] = xFormat::date($values['START_DATE']);
        $record['ANRJ_end_date'] = (!empty($values['END_DATE'])) ? xFormat::date($values['END_DATE']) : '';
        $record['ANRJ_username'] = $values['USERNAME'];
        $record['ANRJ_toolcode'] = $values['TOOLCODE'];
        $record['ANRJ_toolac'] = $values['TOOLAC'];
        $record['ANRJ_toolid'] = $values['TOOLID'];
        $record['ANRJ_parameters'] = $values['PARAMETERS'];
        $record['ANRJ_message'] = $values['MESSAGE'];
        $record['ANRJ_rep_mime_type'] = $values['REP_MIME_TYPE'];
        $record['ANRJ_filename'] = $values['FILENAME'];
        $record['ANRJ_job_status'] = $values['JOB_STATUS'];
        $record['ANRJ_batch_id'] = $values['BATCH_ID'];
        return $record;
    }

    function saveRecord() {
        $record = array();
        $record['IDNAME'] = UserRequest::$post['ANRJ_idname'];
        $record['START_DATE'] = UserRequest::$post['ANRJ_start_date'];
        $record['END_DATE'] = UserRequest::$post['ANRJ_end_date'];
        $record['USERNAME'] = UserRequest::$post['ANRJ_username'];
        $record['TOOLCODE'] = UserRequest::$post['ANRJ_toolcode'];
        $record['TOOLAC'] = UserRequest::$post['ANRJ_toolac'];
        $record['TOOLID'] = UserRequest::$post['ANRJ_toolid'];
        $record['PARAMETERS'] = UserRequest::$post['ANRJ_parameters'];
        $record['MESSAGE'] = UserRequest::$post['ANRJ_message'];
        $record['REP_MIME_TYPE'] = UserRequest::$post['ANRJ_rep_mime_type'];
        $record['FILENAME'] = UserRequest::$post['ANRJ_filename'];
        $record['JOB_STATUS'] = UserRequest::$post['ANRJ_job_status'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['ANRJ_id']);
    }

    function createRecordVoid_() {
        ClxFreeReturn($this->createRecord_());
    }

    function createRecord_() {
        $record = array();
        $record['IDNAME'] = UserRequest::$post['ANRJ_idname'];
        $record['START_DATE'] = UserRequest::$post['ANRJ_start_date'];
        $record['END_DATE'] = UserRequest::$post['ANRJ_end_date'];
        $record['USERNAME'] = UserRequest::$post['ANRJ_username'];
        $record['TOOLCODE'] = UserRequest::$post['ANRJ_toolcode'];
        $record['TOOLAC'] = UserRequest::$post['ANRJ_toolac'];
        $record['TOOLID'] = UserRequest::$post['ANRJ_toolid'];
        $record['PARAMETERS'] = UserRequest::$post['ANRJ_parameters'];
        $record['MESSAGE'] = UserRequest::$post['ANRJ_message'];
        $record['REP_MIME_TYPE'] = UserRequest::$post['ANRJ_rep_mime_type'];
        $record['FILENAME'] = UserRequest::$post['ANRJ_filename'];
        $record['JOB_STATUS'] = UserRequest::$post['ANRJ_job_status'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        return $recordid;
    }

    function deleteRecordSk($id) {
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $record = array();
        $record['ANRJ_id'] = CLX_INIT_ZERO;
        $record['ANRJ_idname'] = '';
        $record['ANRJ_start_date'] = getNow('Y-m-d H:i:s');
        $record['ANRJ_end_date'] = '';
        $record['ANRJ_username'] = $_SESSION['user_record']['username'];
        $record['ANRJ_toolcode'] = '';
        $record['ANRJ_toolid'] = '';
        $record['ANRJ_parameters'] = '';
        $record['ANRJ_message'] = '';
        $record['ANRJ_rep_mime_type'] = '';
        $record['ANRJ_filename'] = '';
        $record['ANRJ_job_status'] = 'IDLE';
        $record['ANRJ_batch_id'] = '';
        return $record;
    }

    /**
     * BAtch schedule validations
     *
     * @param array $msg
     * @return bolean
     */
    function validateBatch(&$msg) {
        if (empty(UserRequest::$request['tto']))
		  $msg['tto'] = dict('GEN_LBL_MISSING_REQUEST', ' &tto=... ');
        if (empty(UserRequest::$request['tac']))
		  $msg['tac'] = dict('GEN_LBL_MISSING_REQUEST', ' &tac=... ');
        if (!empty(UserRequest::$request['tac']) && UserRequest::$request['tac'] == UserRequest::$request['ac'])
		  $msg['tac'] = dict('GEN_LBL_INVALID_REQUEST');
        return empty($msg);
    }
	
	/**
     * Standard reports request parameters | for example, called from: an_reports->buildReport()
     */
    function setBatchReports($title, $filetype = 'html', $parameters = array()) {
		if (defined('clxbathrun')) {
			//prevent any posible rescheduling in better way
			return;
		}
		$target = 'index.php';
		if (array_key_exists('PHP_SELF', UserRequest::$server)) {
			$target = UserRequest::$server['PHP_SELF'];
		}
		
		$url = $target . '?' .
				'to=ANRJ' .
				'&ac=' . UserRequest::$request['BATCH_ACTION'] .
				'&tto=' . UserRequest::$request['to'] .
				'&tac=' . UserRequest::$request['ac'] .
				'&tmt=' . $filetype .
				'&tsd=now' .
				'&tsdone=1' .
				'&tname=' . urlencode(substr($title, 0, 64)
				
				);
		$_SESSION['TOOL_PARAMETERS'] = $parameters;

		if (UserRequest::$request[dict('GEN_LBL_BATCH_ACTION')] == 'SHOW_PANEL') {
			UserRequest::$request['tto'] = UserRequest::$request['to'];
			UserRequest::$request['tac'] = UserRequest::$request['ac'];
			UserRequest::$request['tmt'] = $filetype;
			UserRequest::$request['tid'] = toString(getIdList());
			UserRequest::$request['tsd'] = 'now';
			UserRequest::$request['tsdone'] = 1;
			UserRequest::$request['tname'] = urlencode(substr($title, CLX_NUM_ZERO, CLX_NUM_64));
			$tid = $this->setMountBatchReports();
			$url .= '&tid=' . $tid;
			$url .= '&idlist=' . $tid;
			$a = fopen(kPathToWebSite . kPathToTemp . 'CODE_SIBLING_' . UserRequest::$request['CODE_SIBLING'] . '.txt', 'w+');
			fwrite($a, $tid);
			fclose($a);
			header('location: ' . $url);
		} else {//############################################
			$max = CLX_NUM_20;
			$file = kPathToWebSite . kPathToTemp . 'CODE_SIBLING_' . UserRequest::$request['CODE_SIBLING'] . '.txt';
			while (!file_exists($file) and -- $max > CLX_NUM_ZERO) {
				sleep(CLX_NUM_ONE);
			}
			$a = fopen($file, 'r');
			$tid = fread($a, filesize($file));
			fclose($a);
			$this->runbatch(array($tid));
			unlink($file);
		}
		salir(CLX_NUM_ZERO);
	}

	/**
     * General request parameters | for example, called from: an_reports->buildJasperReport()
     */
    function setBatchGeneral($title, $filetype = 'html', $parameters = array()) {
	if (defined('clxbathrun')) {
		  //prevent any posible rescheduling in better way
		  return;
        }
        $target = 'index.php';
        if (array_key_exists('PHP_SELF', UserRequest::$server)) {
		  $target = UserRequest::$server['PHP_SELF'];
        }
		
        $_SESSION['TOOL_PARAMETERS'] = $parameters;
        $url = $target . '?' . 'to=ANRJ' . '&ac=SET_BATCH' . '&tto=' . UserRequest::$request[CLX_PROP_TO] .
			 '&tac=' . UserRequest::$request['ac'] .
			 '&tmt=' . $filetype . '&tid=' . toString(getIdList()) . '&tsd=now' . '&tsdone=1' . '&tname=' . urlencode(substr($title, CLX_NUM_ZERO, CLX_NUM_64)
					
				);
		if ( !empty($_SESSION["_dEBUG"]) or $this->debug) { 
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo".($this->debug?"_jobs":"").".txt","a+");
			
			fwrite($tta,chr(13).chr(10).__LINE__. "(6)-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			fwrite($tta,chr(13).chr(10)."setBatchGeneral=>url: ".$url.chr(13).chr(10));	
			$te=debug_backtrace();

			for ($t=0;$t<18;$t++) {
				if (isset($te[$t]["file"]))
				fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));


			}
			fclose($tta);
		}	
				
        header('location: ' . $url);
        salir(CLX_NUM_ZERO);
    }
	
	/**
     * Create batch report run request, and make a Ajax call to run in background
     */
    function setBatch() {##echo 'setbatch';
		if (defined('clxcron') && clxcron == CLX_NUM_ONE) {
			//prevent any posible rescheduling in better way
			return '';
		}
		$name = (!empty(UserRequest::$request['tname'])) ? UserRequest::$request['tname'] : dict('GEN_LBL_NONAME');
		$extension = (empty(UserRequest::$request['tmt'])) ? 'txt' : str_replace('.', '', UserRequest::$request['tmt']);
		
		if (empty(UserRequest::$request['tsd']))
			UserRequest::$request['tsd'] = 'now';
		if (empty(UserRequest::$request['tid']))
			UserRequest::$request['tid'] = '';
		if (UserRequest::$request['tto'] == $this->code && UserRequest::$request['tac'] === 'SET_BATCH') {
			//prevent any posible rescheduling
			return '';
		}
		$recordid = CLX_INIT_ZERO;
		//$contents = '';
		$record = array();
		$record['IDNAME'] = substr($name, CLX_NUM_ZERO, CLX_NUM_60);
		$record['START_DATE'] = xFormat::date(UserRequest::$request['tsd'], 'Y/m/d h:i:s');
		$record['USERNAME'] = $_SESSION['user_record']['username'];
		$record['TOOLCODE'] = UserRequest::$request['tto'];
		$record['TOOLAC'] = UserRequest::$request['tac'];
		$record['TOOLID'] = UserRequest::$request['tid'];
		$session = $_SESSION;
		unset($session['user_record']['password']);
		unset($session['TOOL_PARAMETERS']['clientix_MenuBar_option']);
		unset($session['TOOL_PARAMETERS']['PHPSESSID']);
		unset($session['TOOL_PARAMETERS']['ZDEDebuggerPresent']);
		$record['PARAMETERS'] = serialize($session);
		unset($session);
		$record['REP_MIME_TYPE'] = $extension;
		$record['JOB_STATUS'] = 'IDLE';

		$recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);

		//$contents = note(dict('UTIL_DBBK_PROC_SCHEDULED') . ' No.' . $recordid);
		//$contents .= $this->makepanel($recordid);
/*
//		if(true) {
			// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
			// Ver revision Rev. 879 en el SVN
			$contents = note(dict('UTIL_DBBK_PROC_SCHEDULED') . ' No.' . $recordid);
			$contents .= $this->makepanel($recordid);
			$this->batchCall($recordid);
			$url = UserRequest::$server['PHP_SELF'] . '?to=' . $this->code . '&ac=SHOW_PANEL&idlist=' . $recordid;
			header('location: ' . $url);
			$contents = gotoLocation($url);
			return $contents;
//		}
*/
		// 2019-01-15 CR para arreglar el export en los listados...
		//if($this->run_in_cron()) {
		if($this->run_in_cron() && UserRequest::$request['tac'] !== 'BUILDCSV_BATCH') {
			// If ANRJ_RUN_IN_CRON is '1', run the report by clxcron.php instead of Ajax
			// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
			$code = '';
		  $url = UserRequest::$server['PHP_SELF'] . '?to=' . $this->code . '&ac=SHOW_PANEL&idlist=' . $recordid;
		  $code = '$(location).attr("href","' . $url . '")';
		} else {
			//Please after post
			$text_extra='';
			if(isset(UserRequest::$request['UILG_format'])) {
				$text_extra=',UILG_format:"'.UserRequest::$request['UILG_format'].'"';
			}
			$url = UserRequest::$server['PHP_SELF'] . '?to=' . $this->code . '&ac=SHOW_PANEL&idlist=' . $recordid.'&UILG_format='.UserRequest::$request['UILG_format'];
			$ajax = 'window.php?to=ANRJ&ac=RUN_BATCH&idlist=' . $recordid.'&UILG_format='.UserRequest::$request['UILG_format'];
			$text_extra='';
			if(isset(UserRequest::$request['UILG_format'])) {
				$text_extra=',UILG_format:"'.UserRequest::$request['UILG_format'].'"';
			}
			$code = 'jQuery.ajaxSetup({async:true});$.get("window.php", { to: "ANRJ", ac: "RUN_BATCH", idlist:' . $recordid . $text_extra.'}, function(){ $(location).attr("href","' . $url . '")});';
		}

		//return '<div id="loader"></div>' . jQueryIncludes() . ajaxContainer('') . setJavaScriptTag($code);
		#return  '<div id="loader"></div>' . ajaxContainer('') . setJavaScriptTag($code);
        return  '<div id="loader"></div>' . jQueryIncludes() . ajaxContainer('') . setJavaScriptTag($code);
	}

	function batchCall($recordid) {//DEPRECATED SOLVED BY AJAX DIRECTLY
        $php_command_line = 'php';
        if (defined('kPhpCLI')) {
		  $php_command_line = kPhpCLI;
		}
        $s_pars = '"to=$this->code&ac=RUN_BATCH&idlist=$recordid"';
        $s_command = $php_command_line . ' ' . kPathToWebSite . 'tool_batch.php '.$s_pars;
        $this->execInBackground($s_command);
    }

    function execInBackground($cmd) {//DEPRECATED SOLVED BY AJAX DIRECTLY
        if (substr(php_uname(), 0, 7) == 'Windows') {
		  pclose(popen('start /B ' . $cmd, 'r'));
        } else {
		  exec($cmd . ' > /dev/null &');
        }
    }

    /**
     * Set call to be run as batch command
     * Sample call
     * 	tool.php?to=ANRJ&ac=SET_BATCH&tto=UILG&tac=EXPORT
     * 				&tmt=xls&tid=TEST&tsd=now&tname=my test&tprm=etc...
     * tname -> Target name(optional),
     * tto -> Target to,
     * tac -> Target ac,
     * tsd -> Target start_date,
     * tid -> Target tool code,
     * tmt	-> Target extension
     * tprm -> Target parameters
     * @return string
     */
    function setMountBatchReports() {
        if (defined('clxcron') && clxcron == CLX_NUM_ONE) {
		  //prevent any posible rescheduling in better way
		  return;
        }
        $name = (!empty(UserRequest::$request['tname'])) ? UserRequest::$request['tname'] : dict('GEN_LBL_NONAME');
        $extension = (empty(UserRequest::$request['tmt'])) ? 'txt' : str_replace('.', '',UserRequest::$request['tmt']);
        if (empty(UserRequest::$request['tsd']))
		  UserRequest::$request['tsd'] = 'now';
        if (empty(UserRequest::$request['tid']))
		  UserRequest::$request['tid'] = '';
        if (UserRequest::$request['tto'] == $this->code && UserRequest::$request['tac'] == 'SET_BATCH') {
		  //prevent any posible rescheduling
		  return;
        }
		$recordid = CLX_NUM_ZERO;
        $contents = '';
        $record = array();
        $record['IDNAME'] = substr($name, CLX_NUM_ZERO, CLX_NUM_60);
        $record['START_DATE'] = xFormat::date(UserRequest::$request['tsd'], 'Y-m-d H:i:s');
		$record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['TOOLCODE'] = UserRequest::$request['tto'];
        $record['TOOLAC'] = UserRequest::$request['tac'];
        $record['TOOLID'] = UserRequest::$request['tid'];
        $session = $_SESSION;
        unset($session['user_record']['password']);
        unset($session['TOOL_PARAMETERS']['clientix_MenuBar_option']);
        unset($session['TOOL_PARAMETERS']['PHPSESSID']);
        unset($session['TOOL_PARAMETERS']['ZDEDebuggerPresent']);
        unset($session['XMENUS']);
        $record['PARAMETERS'] = serialize($session); //UserRequest::$request['tprm'];
        unset($session);
        $record['REP_MIME_TYPE'] = $extension;
        //$record['FILENAME'] = $filename;
        $record['JOB_STATUS'] = 'IDLE';
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record,false);
        return $recordid;
    }


	/**
     * Actual RUN and real generation of the Report!
     */
    function runBatch($recordid) {
//$_SESSION["_dEBUG"] = 1;
		if (!empty($_SESSION["_dEBUG"]) or $this->debug) {
			$tta = fopen(kPathToWebSite . "/" . kPathToTemp . "archivo".($this->debug?"_jobs":"").".txt", "a+");
			fwrite($tta, chr(13) . chr(10) . __LINE__. "(1)-hora:" . date("h:i:s d/m/Y") . chr(13) . chr(10));
			fwrite($tta, "runBatch=>this->tablename:" . $this->tablename . chr(13) . chr(10));
			$te = debug_backtrace();
			for ($t = 0; $t < 18; $t++) {
				if (isset($te[$t]["file"]))
					fwrite($tta, substr($te[$t]["file"] . str_repeat(" ", 80), 0, 80) . chr(9) . $te[$t]["line"] . chr(9) . $te[$t]["function"] . chr(13) . chr(10));
			}
			fclose($tta);
		}

		if (!defined('clxbathrun')) {
			define('clxbathrun', '1');
		}
		$recordid = toString($recordid);

		if (empty($recordid)) {
			$recordid = '0'; //   to avoid error importing tool at Banvalor (production)
		}

		$STORE_REQUEST = UserRequest::$request;
		$STORE_POST = UserRequest::$post;
		$STORE_GET = UserRequest::$get;
		$_SESSION['TOOL_PARAMETERS']['RTBL_BATCH_ID'] = $recordid; //IVAN: COLOCADO ID PARA EL NOMBRE DE ARCHIVO BATCH ERROR 500 RESOURCE
		$STORE_SESSION = $_SESSION;
		$record = ClxCommon::$db->getRecord($this->tablename, 'ID = ' . $recordid . ' AND JOB_STATUS = ' . singleQuote('IDLE'));
		if (empty($record)) {
			return '';
		}
		if (!empty($_SESSION["_dEBUG"]) or $this->debug) {
			$tta = fopen(kPathToWebSite . "/" . kPathToTemp . "archivo".($this->debug?"_jobs":"").".txt", "a+");
			fwrite($tta, chr(13) . chr(10) . __LINE__. "(2)-hora:" . date("h:i:s d/m/Y") . chr(13) . chr(10));
			fwrite($tta, chr(13) . chr(10) . "runBatch=>renameSourceFile: " . ($this->renameSourceFile ? 'TRUE' : 'FALSE') . chr(13) . chr(10));
			fwrite($tta, chr(13) . chr(10) . "runBatch=>record['TOOLCODE']: " . $record['TOOLCODE'] . chr(13) . chr(10));
			fwrite($tta, chr(13) . chr(10) . "runBatch=>recordid: " . $recordid . chr(13) . chr(10));
			fwrite($tta, chr(13) . chr(10) . "runBatch=>idlist: " . var_export($record['TOOLID'], true) . chr(13) . chr(10));
			fwrite($tta, chr(13) . chr(10) . "runBatch=>RECORD: " . var_export($record, true) . chr(13) . chr(10));
			fwrite($tta, chr(13) . chr(10) . "runBatch=>UserRequest::get['ac']: " . UserRequest::$request['ac'] . chr(13) . chr(10));
			$te = debug_backtrace();
			for ($t = 0; $t < 18; $t++) {
				if (isset($te[$t]["file"]))
					fwrite($tta, substr($te[$t]["file"] . str_repeat(" ", 80), 0, 80) . chr(9) . $te[$t]["line"] . chr(9) . $te[$t]["function"] . chr(13) . chr(10));
			}
			fclose($tta);
		}

		UserResponse::setIgnoreUserAbort(CLX_NUM_ONE);
		UserResponse::setRunTimeLimit(CLX_NUM_FIVE * CLX_NUM_60 * CLX_NUM_60);

		$_SESSION = unserialize($record['PARAMETERS']);
		$_SESSION['TOOL_PARAMETERS']['RTBL_BATCH_ID'] = $recordid; //IVAN: COLOCADO ID PARA EL NOMBRE DE ARCHIVO BATCH ERROR 500 RESOURCE
		ClxCommon::$db->updateRecord($this->tablename, array('JOB_STATUS' => 'RUN', 'BATCH_ID' => getmypid(), 'START_DATE' => xFormat::date('now', 'Y-m-d H:i:s'), 'END_DATE' => null), 'ID = ' . $record['ID']);
		ClxCommon::$db->commit();
		$TOOL = &getTool($record['TOOLCODE']);
		UserRequest::$request = array(CLX_PROP_TO => $record['TOOLCODE'], 'ac' => $record['TOOLAC'], 'idlist' => $record['TOOLID']);
		if (isset($STORE_REQUEST['UILG_format']))
			UserRequest::$request['UILG_format']=$STORE_REQUEST['UILG_format'];
		if (isset($_SESSION['TOOL_PARAMETERS'])) {
			reset($_SESSION['TOOL_PARAMETERS']);
			foreach ($_SESSION['TOOL_PARAMETERS'] as $key => $value) {
				UserRequest::$request[$key] = $value;
			}
		}
		UserRequest::$get = UserRequest::$request;
		UserRequest::$post = UserRequest::$request;
		$idlist = $record['TOOLID']; //IVAN: esta en blanco siempre en BD (450 Registros)
		//Search mime extension
		$extension = $record['REP_MIME_TYPE'];
		if (empty($extension)) {
			$extension = 'txt';
		}
		$_SESSION['TOOL_PARAMETERS']['RTBL_BATCH_ID'] = $record['ID']; //IVAN: COLOCADO ID PARA EL NOMBRE DE ARCHIVO BATCH ERROR 500 RESOURCE
		if ($extension == 'msexcel') { //Ivan colocado no es extensión valida para windows del usuario
			$file_name = 'temp/anrj_' . $record['ID'] . '.xls';
		} elseif ($extension == 'text') { //Ivan colocado no es extensión valida para windows del usuario	
			$file_name = 'temp/anrj_' . $record['ID'] . '.txt';
		} else {
			$file_name = 'temp/anrj_' . $record['ID'] . '.' . $extension;
		}
        if((UserRequest::$post['RTBL_EMISSION_TYPE'] == 'FD') && ($extension == 'msexcel' || $extension == 'pdf'))
		  $file_name = 'data/files/consolidado/anrj_' . $record['ID'] . '.zip';
		$TOOL->output_to_file = array();
		$TOOL->output_to_file['file_name'] = kPathToWebSite . $file_name;
		$this->renameSourceFile=false;
        if(UserRequest::$post['fm'] == 'GLREP_CONS' && UserRequest::$post['it'] == 'GLREP_CONS') 
		  $this->renameSourceFile = true; //para el reporte consolidado ya que siempre generaba estatus de error
		if ($this->renameSourceFile) {
			// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
			$contents = $TOOL->action(UserRequest::$get['ac'], $idlist);

			if (!empty($_SESSION["_dEBUG"]) or $this->debug) {
				$tta = fopen(kPathToWebSite . "/" . kPathToTemp . "archivo".($this->debug?"_jobs":"").".txt", "a+");
				fwrite($tta, chr(13) . chr(10) . __LINE__. "(3)-hora:" . date("h:i:s d/m/Y") . chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "strlen(runBatch=>contents): " . strlen($contents) . chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "runBatch=>idlist: " . var_export($idlist, true) . chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "runBatch=>UserRequest::get['ac']: " . UserRequest::$get['ac'] . chr(13) . chr(10));
				$te = debug_backtrace();
				for ($t = 0; $t < 18; $t++) {
					if (isset($te[$t]["file"]))
						fwrite($tta, substr($te[$t]["file"] . str_repeat(" ", 80), 0, 80) . chr(9) . $te[$t]["line"] . chr(9) . $te[$t]["function"] . chr(13) . chr(10));
				}
				fclose($tta);
			}

			// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
			//rename(kPathToWebSite . $TOOL->action(UserRequest::$get['ac'], $idlist), kPathToWebSite . $file_name);
			rename(kPathToWebSite . $contents, kPathToWebSite . $file_name);
			
		} else {
			UserRequest::$request['ANRP_rbat'] = '0';
			$contents = $TOOL->action(UserRequest::$get['ac'], $idlist);

			if (!empty($_SESSION["_dEBUG"]) or $this->debug) {
				$tta = fopen(kPathToWebSite . "/" . kPathToTemp . "archivo".($this->debug?"_jobs":"").".txt", "a+");
				fwrite($tta, chr(13) . chr(10) . __LINE__. "(4)-hora:" . date("h:i:s d/m/Y") . chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "strlen(runBatch=>contents): " . strlen($contents) . chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "run request info: " . var_export(UserRequest::$request, true) . chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "runBatch=>idlist: " . var_export($idlist, true) . chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "run file_namet: " .$file_name . chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "extension: '" .$extension ."'".				chr(13) . chr(10));
				fwrite($tta, chr(13) . chr(10) . "runBatch=>UserRequest::get['ac']: " . UserRequest::$get['ac'] . chr(13) . chr(10));
				$te = debug_backtrace();
				for ($t = 0; $t < 18; $t++) {
					if (isset($te[$t]["file"]))
						fwrite($tta, substr($te[$t]["file"] . str_repeat(" ", 80), 0, 80) . chr(9) . $te[$t]["line"] . chr(9) . $te[$t]["function"] . chr(13) . chr(10));
				}
				fclose($tta);
			}
			if (isset(UserRequest::$request['ANRP_report_type']) && UserRequest::$request['ANRP_report_type']==2) {
				if (!empty($_SESSION["_dEBUG"])){ 
					$tta = fopen(kPathToWebSite . $file_name, "a+");
				}
				//fwrite($tta,'ddddd'.$contents);
                $contents = decode_string($contents);
                if (!empty($_SESSION["_dEBUG"])){ 
					fwrite($tta,$contents);
					fclose($tta);
				}
				unset($TOOL->output_to_file['file_name']);
			}
			else	if(isset($TOOL->output_to_file['file_name'])) {
				// The report is already sent to a file with no memory buffering in $contents
				if($contents !== CLX_CHAR_EMPTY_STRING) {
					ClxCommon::$db->updateRecord($this->tablename, array('JOB_STATUS' => 'ERRO', 'END_DATE' => xFormat::date('now', 'Y-m-d H:i:s'), 'FILENAME' => $file_name), 'ID = ' . $recordid . ' AND JOB_STATUS = ' . singleQuote('RUN') . '');
					$BUGS = getTool('BUGS');
					$BUGS->autoreport(E_USER_ERROR, $contents, UserRequest::$server['SCRIPT_NAME'], CLX_NUM_785, UserRequest::$request);
				}
			} else {
				if (!empty($_SESSION["_dEBUG"])){ 	
					$tta = fopen(kPathToWebSite . "/" . kPathToTemp . "archivo".($this->debug?"_jobs":"").".txt", "a+");
					fwrite($tta, chr(13) . chr(10) . __LINE__. "(23)-hora:" . date("h:i:s d/m/Y") . chr(13) . chr(10));
				
					fclose($tta);
				}
				// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
				if (!(strpos($contents, '!DOCTYPE') > 0 and ( $extension == 'msexcel' or $extension == 'pdf' ))) { //IVAN:colocado condición esta colocando html dentro de los archivos
					$contents = decode_string($contents);
				}
				if($extension == 'html') {
					$variables = array();
					$variables['PAGE_TITLE'] = $record['IDNAME'];
					$variables['JAVA_SCRIPT_1'] = '';
					$variables['JAVA_SCRIPT_2'] = '';
					$variables['JAVA_SCRIPT_3'] = '';
					$variables['JAVA_SCRIPT_4'] = '';
					$variables['JAVA_SCRIPT_5'] = '';
					$variables['STYLE_SHEET'] = sprintf('<link href=' . singleQuote('%s') . ' rel=' . singleQuote('stylesheet') . ' type=' . singleQuote('text/css') . '>', kWebSite . kPathToSkins . $_SESSION['skin'] . '/styles.css');
					$variables['CONTENTS'] = $contents;
					$contents = getSkinForm('pop.html', $variables);
					unset($variables);
				}
				$fp = new clx_file(kPathToWebSite . $file_name, 'w');
				$fp->open();
				if ($fp->hasError()) {
					ClxCommon::$db->updateRecord($this->tablename, array('JOB_STATUS' => 'ERRO', 'END_DATE' => xFormat::date('now', 'Y-m-d H:i:s'), 'FILENAME' => $file_name /*, 'PARAMETERS' => 'DONE' */), 'ID = ' . $recordid . ' AND JOB_STATUS = ' . singleQuote('RUN') . '');
					$BUGS = getTool('BUGS');
					$BUGS->autoreport(E_USER_ERROR, '[ANRJ-010] Cannot write directory/file: ' . $file_name, UserRequest::$server['SCRIPT_NAME'], CLX_NUM_785, UserRequest::$request);
				}
				$fp->write($contents);
				$fp->close();
			}
		}
	
		// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
		$job_status = array();
		if((isset($TOOL->output_to_file['file_name']) && $contents === CLX_CHAR_EMPTY_STRING) || $contents !== CLX_CHAR_EMPTY_STRING) {
			$job_status['JOB_STATUS'] = 'END';
			$job_status['MESSAGE'] = 'DONE';
		} else {
			$job_status['JOB_STATUS'] = 'ERRO';
			$job_status['MESSAGE'] = 'NO_CONTENT';
		}
		ClxCommon::$db->updateRecord($this->tablename, array('JOB_STATUS' => $job_status['JOB_STATUS'], 'END_DATE' => xFormat::date('now', 'Y-m-d H:i:s'), 'FILENAME' => $file_name, 'MESSAGE' => $job_status['MESSAGE'] . ' | ' . $record['REP_MIME_TYPE']), 'ID = ' . $recordid . ' AND JOB_STATUS = ' . singleQuote('RUN') . '');
		ClxCommon::$db->commit();
		UserRequest::$request = $STORE_REQUEST;
		UserRequest::$post = $STORE_POST;
		UserRequest::$get = $STORE_GET;
		$_SESSION = $STORE_SESSION;
	}

	/**
     * Return
     * @param type $recordid
     * @return array
     */
    function getBatch($recordid) {
        if (!defined('clxbathrun'))
		  define('clxbathrun', '1');
        $recordid = toString($recordid);
        if (empty($recordid)){
		  $recordid = '0';
        }
        $record = ClxCommon::$db->getOneRecord('SELECT JOB_STATUS FROM '.$this->tablename.' WHERE ID = ' . $recordid  );
        return $record;
    }

    /**
     * Builds Pagelet for Tool
     * @param string $code
     * @param string $ac
     * @param integer $objectid
     * @return string
     */
    function pagelet($code, $ac = null, $objectid = null){
        return $this->makelist();
    }

	/*
	 * Run the report by clxcron.php instead of Ajax. Takes record in IDLE one by one, processed in each clxcron.php call
	 */
	function runCronBatch() {
		if(! $this->run_in_cron()) {
			// If ANRJ_RUN_IN_CRON is '1', run the report by clxcron.php instead of Ajax
			// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
			return CLX_CHAR_EMPTY_STRING;
		}
        $record = ClxCommon::$db->getOneRecord($sql='SELECT ID FROM '.$this->tablename.' WHERE JOB_STATUS = ' . singleQuote('IDLE') . ' ORDER BY ID ASC');
		//echo $sql;
		$show_msg = true;
		if($record['REP_MIME_TYPE'] !== 'pdf') {
			$show_msg = false;
			ob_clean();
		}
		if($show_msg === true) { 
			echoLog($this->code.' processing... ');
		}
		if(empty($record)) {
			echoLog('Nothing to process');
			return CLX_CHAR_EMPTY_STRING;
		}
		if($show_msg === true) { 
			echoLog('Report Job ID: '.$record['ID']);
		}
		UserRequest::$get['ac'] = 'RUN_BATCH';
		$this->runBatch($record['ID']);
		return CLX_CHAR_EMPTY_STRING;
	}
	
	/*
	 * Make panel list for menu option "My Repors", with automatic reload each ANRJ_LIST_REFRESH_SECS miliseconds
	 */
	function makepanelWithTimeout($idlist) {
		// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
		$this->assign_def_vals();
		$contents = jQueryIncludes() . CLX_CHAR_NL . setJavaScriptTag('js/standard/util.js', true) . CLX_CHAR_NL;
		$contents .= $this->makepanel(toString($idlist));
		if ($_SESSION['skin']!='ibs')
			$contents .=  CLX_CHAR_NL . setJavaScriptTag('setTimeout(function(){  window.location.reload(1);}, '.ANRJ_LIST_REFRESH_SECS.')');
		return $contents;
	}

	/*
	 * Retry report run of ID list
	 */
	function runRetry($idlist) {
		// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
		ClxCommon::$db->updateRecord($this->tablename, array('JOB_STATUS' => 'IDLE', 'MESSAGE' => ''), 'ID IN (' . toString($idlist) . ')');
		//return $this->makepanelWithTimeout(CLX_CHAR_EMPTY_STRING);
		header('Location: '.$_SERVER['HTTP_REFERER']);
		exit();
	}
	
	/*
	 * Assign system parameters default values
	 */
	function assign_def_vals() {
		// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
		if(!defined('ANRJ_RUN_IN_CRON')) {
			define('ANRJ_RUN_IN_CRON', self::RUN_IN_CRON_TRUE);
		}
		if(!defined('ANRJ_LIST_REFRESH_SECS')) {
			define('ANRJ_LIST_REFRESH_SECS', self::LIST_REFRESH_SECS);
		}
		if(!defined('ANRJ_LIST_MAX_RECS')) {
			define('ANRJ_LIST_MAX_RECS', self::LIST_MAX_RECS);
		}
	}
	
	/*
	 * Returns True if ANRJ_RUN_IN_CRON is '1', which means {run the report by clxcron.php instead of Ajax}
	 */
	function run_in_cron() {
		$this->assign_def_vals();
		return (ANRJ_RUN_IN_CRON === self::RUN_IN_CRON_TRUE);
	}
}
