<?php
/**
 * Process Seccion Manager
 *
 * @package		Clientix.Tool.Business Process
 * @abstract		Business Process Manager
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-06-21 08:03:11 -0400 (Thu, 21 Jun 2018) $
 * @version    	$Rev: 9841 $
 *
 */
class bp_activities extends clx_tool {

    /**
     * Event type
     *
     * @var array
     */
    var $event_type = array();

    /**
     * activity type
     *
     * @var array
     */
    var $activity_type = array();

    /**
     * Action Type
     *
     * @var array
     */
    var $action_type = array();
    var $debug = false;

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'BPAC';
        $this->name = 'Business Process - Activities';
        $this->system = 'Business Process';
        $this->version = '5.5.0.1';




        $this->tablename = 'CLX_BP_ACTIVITIES';
        $this->record_name_singular = 'GEN_LBL_BP_ACTIVITY';
        $this->record_name_plural = 'GEN_LBL_BP_ACTIVITIES';
        $this->primary_key = array(
		  'ACTIVITIESCODE'
        );
        $this->primary_field = 'ACTIVITIESCODE';
        $this->secondary_field = 'IDNAME';
        $this->seqnum_field = 'SEQNUM';
        // Establecer Lista de Acciones
        $this->action_type = $this->set_action_list();
        $this->activity_type = array(
		  'START' => 'GEN_LBL_START',
		  'END' => 'BPAC_LBL_END',
		  'GATE' => 'GEN_LBL_GATE',
		  'MANUAL' => 'GEN_LBL_MANUAL',
		  'CLX' => 'GEN_LBL_CLX'
        );
        $this->event_type = array();
        $EVNT = &getTool('EVNT');
        foreach ($EVNT->events as $code => $info) {
		  if ($info ['language'] !== 'PHP' || $info ['object'] !== 'BPPR') {
			 continue;
		  }
		  $this->event_type [$code] = $info ['name'];
        }
        $this->editform = array(
		  CLX_CLASS_TITLE => 'TOOL_BPAC_TITLE_CREATE', // ETIQUETA
		  'panels' => array(
			 array(
			     'type' => 'normal',
			     'entries' => array(
			         array(
					   'label' => 'GEN_LBL_ACTIVITIESCODE',
					   'fields' => array(
						  array(
						      'name' => 'activitiescode',
						      'type' => 'string',
						      'default' => '',
						      'size' => '16',
						      'displaysize' => '16',
						      'dontmodify' => '1',
						      'validations' => array(
								array(
								    'type' => 'unique',
								    'fieldname' => 'activitiescode',
								    'tablename' => $this->tablename
								)
						      )
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_IDNAME',
					   'fields' => array(
						  array(
						      'name' => 'idname',
						      'type' => 'string',
						      'default' => '',
						      'size' => '64',
						      'displaysize' => '48',
						      'validations' => array(
								array(
								    'type' => 'string',
								    'required' => '1'
								)
						      )
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_STATUS',
					   'fields' => array(
						  array(
						      'name' => 'status',
						      'type' => CLX_CLASS_LIST,
						      'default' => '1',
						      'options' => $this->status
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_LANECODE',
					   'fields' => array(
						  array(
						      'name' => 'lanecode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'BPLA',
						      'validations' => array(
								array(
								    'type' => 'string',
								    'required' => '1'
								),
								array(
								    'type' => 'lookup',
								    'fieldname' => 'lanecode',
								    'tablename' => 'CLX_BP_LANES'
								)
						      )
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_CATEGORIESCODE',
					   'fields' => array(
						  array(
						      'name' => 'categoriescode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'BPCT',
						      'validations' => array(
								array(
								    'type' => 'string',
								    'required' => '1'
								),
								array(
								    'type' => 'lookup',
								    'fieldname' => 'categoriescode',
								    'tablename' => 'CLX_BP_CATEGORIES'
								)
						      )
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_ACTIVITY_TYPE',
					   'fields' => array(
						  array(
						      'name' => 'activity_type',
						      'type' => CLX_CLASS_LIST,
						      'options' => $this->activity_type
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_TRIGGER_EVENT',
					   'fields' => array(
						  array(
						      'name' => 'event_type',
						      'type' => CLX_CLASS_LIST,
						      'options' => $this->event_type
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_ACTION_TYPE',
					   'fields' => array(
						  array(
						      'name' => 'action_type',
						      'type' => CLX_CLASS_LIST,
						      'options' => $this->action_type
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array(
						      'name' => 'description',
						      'type' => 'text',
						      'default' => '',
						      'cols' => '48',
						      'rows' => '4'
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_USER_INSTRUCTIONS',
					   'fields' => array(
						  array(
						      'name' => 'user_instructions',
						      'type' => 'text',
						      'default' => '',
						      'cols' => '48',
						      'rows' => '4'
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_SEQNUM',
					   'fields' => array(
						  array(
						      'name' => 'seqnum',
						      'type' => 'string',
						      'default' => '1',
						      'readonly' => true,
						      'size' => '32',
						      'displaysize' => '16',
						      'validations' => array()
						  )
					   )
			         )
			     )
			 )
		  )
        );
        $this->viewform = &$this->editform;
        $this->viewform [CLX_CLASS_TITLE] = 'TOOL_BPAC_TITLE_DISPLAY'; // Etiqueta listo
        $this->toolpanelkeys = array(
		  array(
			 'name' => 'LANECODE',
			 'type' => 'string'
		  )
        ); // listo
        $this->toolpanel = array(
		  'name' => $this->tablename,
		  CLX_CLASS_TITLE => $this->record_name_plural,
		  'has_reorder' => true,
		  'fields' => array(
			 array(
			     'name' => 'ID',
			     'label' => 'GEN_LBL_ID',
			     'type' => 'number'
			 ),
			 array(
			     'name' => 'ACTIVITIESCODE',
			     'label' => 'GEN_LBL_ACTIVITIESCODE',
			     'type' => 'string'
			 ),
			 array(
			     'name' => 'IDNAME',
			     'label' => 'GEN_LBL_IDNAME',
			     'type' => 'string'
			 ),
			 array(
			     'name' => 'STATUS',
			     'type' => CLX_CLASS_LIST,
			     'label' => 'GEN_LBL_STATUS',
			     'options' => $this->status,
			     'default' => '1'
			 ),
			 array(
			     'name' => 'ACTIVITY_TYPE',
			     'label' => 'GEN_LBL_ACTIVITY_TYPE',
			     'options' => $this->activity_type,
			     'type' => CLX_CLASS_LIST
			 ),
			 array(
			     'name' => 'EVENT_TYPE',
			     'label' => 'GEN_LBL_EVENT_TYPE',
			     'options' => $this->event_type,
			     'type' => CLX_CLASS_LIST
			 ),
			 array(
			     'name' => 'ACTION_TYPE',
			     'type' => 'fieldgroup',
			     'label' => 'GEN_LBL_ACTION_TYPE',
			     'fields' => array(
			         array(
					   'name' => 'ACTION_TYPE',
					   'label' => 'ACTION_TYPE',
					   'type' => CLX_CLASS_LIST,
					   'options' => $this->action_type
			         ),
			         array(
					   'name' => 'EXTRA2',
					   'label' => 'GEN_LBL_BLANK',
					   'type' => 'string',
					   'prefix' => ' '
			         ),
			         array(
					   'name' => 'EXTRA3',
					   'label' => 'GEN_LBL_BLANK',
					   'type' => 'string',
					   'prefix' => ' '
			         )
			     )
			 ),
			 array(
			     'name' => 'LANECODE',
			     'label' => 'GEN_LBL_LANECODE',
			     'type' => 'string'
			 ),
			 array(
			     'name' => 'CATEGORIESCODE',
			     'label' => 'GEN_LBL_CATEGORIESCODE',
			     'type' => 'string'
			 ),
			 array(
			     'name' => 'USER_INSTRUCTIONS',
			     'label' => 'GEN_LBL_USER_INSTRUCTIONS',
			     'type' => 'string'
			 )
		  ),
		  'buttons' => array(
			 array(
			     'access' => 'canread',
			     'tool' => 'has_display',
			     'library' => 'GEN_LBL_CONNECT',
			     'name' => 'CONNECT',
			     'prop' => 'MULT'
			 ),
			 array(
			     'access' => 'canread',
			     'tool' => 'has_display',
			     'library' => 'GEN_LBL_SHOW_FLOW',
			     'name' => 'SHOW_FLOW',
			     'prop' => 'ON',
			     'window' => 'POP'
			 )
		  )
        );
    }

// End method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::toolTableStructure()
     */
    function toolTableStructure() {
        $fields = array();
        $fields ['ID'] = array(
		  'type' => 'int(11) unsigned',
		  'null' => 'NO',
		  'properties' => 'auto_increment',
		  'index' => 'PRI'
        );
        $fields ['ACTIVITIESCODE'] = array(
		  'type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['IDNAME'] = array(
		  'type' => 'varchar(64)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['LANECODE'] = array(
		  'type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['STATUS'] = array(
		  'type' => 'varchar(1)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['CATEGORIESCODE'] = array(
		  'type' => 'varchar(16)',
		  //'null' => 'NO',
		  'null' => 'YES',
		  'properties' => ''
        );
        $fields ['SEQNUM'] = array(
		  'type' => 'int(11) unsigned',
		  'null' => 'NO',
		  'properties' => '',
		  'default' => CLX_NUM_ZERO
        );
        $fields ['DESCRIPTION'] = array(
		  'type' => 'mediumtext',
		  'properties' => ''
        );
        $fields ['USER_INSTRUCTIONS'] = array(
		  'type' => 'mediumtext',
		  'properties' => ''
        );
        $fields ['ACTIVITY_TYPE'] = array(
		  'type' => 'varchar(64)',
		  'null' => 'NO',
		  'default' => '1',
		  'properties' => ''
        );
        $fields ['EVENT_TYPE'] = array(
		  'type' => 'varchar(64)',
		  'null' => 'NO',
		  'default' => '1',
		  'properties' => ''
        );
        $fields ['ACTION_TYPE'] = array(
		  'type' => 'varchar(4)',
		  'null' => 'NO',
		  'default' => '1',
		  'properties' => ''
        );
        $fields ['EXTRA1'] = array(
		  'type' => 'int(11) unsigned',
		  'null' => 'YES',
		  'properties' => ''
        );
        $fields ['EXTRA2'] = array(
		  'type' => 'text',
		  'null' => 'YES',
		  'properties' => ''
        );
        $fields ['EXTRA3'] = array(
		  'type' => 'varchar(255)',
		  'null' => 'YES',
		  'properties' => ''
        );
        $fields ['EXTRA4'] = array(
		  'type' => 'varchar(255)',
		  'null' => 'YES',
		  'properties' => ''
        );
        $fields ['EXTRA5'] = array(
		  'type' => 'varchar(255)',
		  'null' => 'YES',
		  'properties' => ''
        );
        $fields ['EXTRA6'] = array(
		  'type' => 'text',
		  'null' => 'YES',
		  'properties' => ''
        );
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes [$ipf . '01'] = array(
		  'index' => 'PRI',
		  'fieldname' => 'ID'
        );
        $indexes [$ipf . '02'] = array(
		  'index' => 'UNI',
		  'fieldname' => 'ACTIVITIESCODE'
        );
        $indexes [$ipf . '03'] = array(
		  'index' => 'MUL',
		  'fieldname' => 'LANECODE'
        );
        $indexes [$ipf . '04'] = array(
		  'index' => 'MUL',
		  'fieldname' => 'CATEGORIESCODE'
        );
        $indexes [$ipf . '05'] = array(
		  'index' => 'MUL',
		  'fieldname' => 'ACTION_TYPE'
        );
        $indexes [$ipf . '06'] = array(
		  'index' => 'MUL',
		  'fieldname' => 'ACTIVITY_TYPE'
        );
        $indexes [$ipf . '07'] = array(
		  'index' => 'MUL',
		  'fieldname' => 'EVENT_TYPE'
        );
        return array(
		  'idcode' => $this->code,
		  'idname' => $this->name,
		  'name' => $this->tablename,
		  'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes
        );
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::pack()
     */
    function pack($record) {
        $o = $this->packRecord($record);
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'BPAP', 'SELECT * FROM CLX_BP_ACTIVITY_PRMTS WHERE ACTIVITIESCODE =' . singleQuote($record ['ACTIVITIESCODE']));
        $this->packsub($objs, 'BPPE', 'SELECT * FROM CLX_BP_PERFORMERS WHERE ACTIVITIESCODE =' . singleQuote($record ['ACTIVITIESCODE']));
        $this->packsub($objs, 'BPRU', 'SELECT * FROM CLX_BP_RULES WHERE  ACTIVITIESCODE =' . singleQuote($record ['ACTIVITIESCODE']));
        $o->addObject($objs);
        return $o;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::unpack()
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        ClxCommon::$db->deleteRecords($this->tablename, $this->primary_field . '=' . singleQuote($record [$this->primary_field]));
        ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o));
		  }
        }
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::action()
     */
    function action($ac, $idlist) {
        //if ($this->access ['canread'] === true) {
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'SHOW_FLOW' :
			     $contents = $this->show_proces_flow();
			     break;
			 case 'CONNECT' :
			     addHistory('list_activities', toString(getIdlist()));
			     pushHistory('BPTR', 'CREATE', $idlist);
			     $info = popHistory();
			     $contents = executeHistory($info);
			     break;
			 default :
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[BP_ACTIVITIES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::checkForm()
     */
    function checkForm(&$msg) {
        ClxFreeReturn(parent::checkForm($msg));
        switch (UserRequest::$post ['BPAC_activity_type']) {
		  case 'START' :
		  case 'GATE' :
		  case 'CLX' :
			 break;
		  default :
			 if (UserRequest::$post ['BPAC_event_type'] !== 'BCNO') {
			     $msg ['BPAC_event_type'] = dict('GEN_LBL_MUST_BE_EQUAL_TO_NONE');
			 }
			 break;
        }
        return count($msg) == CLX_NUM_ZERO;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::viewFormFill()
     */
    function viewFormFill($record) { // Este metodo pinta el panel de actividades
	addHistory('activitiescode', $record ['BPAC_activitiescode']);
        $contents = '';
        $BPAP = &getTool('BPAP');
        $contents .= $BPAP->makepanel($record ['BPAC_activitiescode']);
        $BPPE = &getTool('BPPE');
        $contents .= $BPPE->makepanel($record ['BPAC_activitiescode']);
        $BPRU = &getTool('BPRU'); // Secciones actividades
        $contents .= $BPRU->makepanel($record ['BPAC_activitiescode']);
        return $contents;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::editForm()
     */
    function editForm($ac, $idlist, $record, $msg) {
        $OBJS = &getTool('OBJS');
        // Build/get the different java scripts...
        $actioncodes = $OBJS->objectList('ACTN');
        $list = CLX_CHAR_TAB . ' panellist = new Array();' . CLX_CHAR_NL . ' panellist[0] = ' . "''" . CLX_CHAR_NL;
        $i = CLX_INIT_ZERO;
        foreach ($actioncodes as $actioncode) {
		  $list .= sprintf(CLX_CHAR_TAB . ' panellist[%s] = ' . "'%s'; " . CLX_CHAR_NL, $i, $actioncode);
		  $i ++;
        }
        $variables = array();
        $variables ['CONTENTS'] = $list;
        $script = setJavaScriptTag(getJavaScript('BPAC_editform.js', $variables));
        $variables = array();
        $variables ['VISIBLEPANEL'] = 'EVNT_action';
        $topscript = setJavaScriptTag(getJavaScript('dynform_top.js', $variables));
        $btmscript = setJavaScriptTag(getJavaScriptFilename('dynform_btm.js'), true);
        // Build the form
        $modify = (UserRequest::$request['ac'] === 'MODIFY');
        $title = ($modify) ? dict('TOOL_BPAC_TITLE_MODIFY') : dict('TOOL_BPAC_TITLE_CREATE');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('BPAC_id', $record ['BPAC_id']);
        $form->addArgument('BPAC_seqnum', $record ['BPAC_seqnum']);
        $form->addArgument('confirm', '1');
        $form->addArgument('EVNT_ownercode', $record ['EVNT_ownercode']);
        $form->addArgument('BPAC_activitiescode', (!empty($record ['BPAC_activitiescode'])) ? $record ['BPAC_activitiescode'] : '' );
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        //$table->addCell($title, CLX_PROP_CLASS, CLX_CLASS_TITLE, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_ACTIVITIESCODE') . ':', 'BPAC_activitiescode', $record ['BPAC_activitiescode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'BPAC_idname', $record ['BPAC_idname'], CLX_NUM_48, CLX_NUM_64);
        $table->addList(dict('GEN_LBL_STATUS'), 'BPAC_status', $record ['BPAC_status'], $this->status, false);
        $table->addLookup($msg, dict('GEN_LBL_LANECODE') . ':', 'BPAC_lanecode', $record ['BPAC_lanecode'], 'BPLA', CLX_NUM_16, CLX_NUM_16);
        $table->addLookup($msg, dict('GEN_LBL_CATEGORIESCODE') . ':', 'BPAC_categoriescode', $record ['BPAC_categoriescode'], 'BPCT', CLX_NUM_16, CLX_NUM_16);
        $table->addText($msg, dict('GEN_LBL_DESCRIPTION') . ':', 'BPAC_description', $record ['BPAC_description'], CLX_NUM_FOUR, CLX_NUM_48);
        $table->addText($msg, dict('GEN_LBL_USER_INSTRUCTIONS') . ':', 'BPAC_user_instructions', $record ['BPAC_user_instructions'], CLX_NUM_FOUR, CLX_NUM_48);
        $table->addSeparator(CLX_CLASS_DATA);
        if (!empty($msg ['BPAC_activity_type'])) {
		  $table->addCell($msg ['BPAC_activity_type'], CLX_PROP_CLASS, CLX_CLASS_ALERT, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        }
        $table->addList(dict('GEN_LBL_ACTIVITY_TYPE'), 'BPAC_activity_type', $record ['BPAC_activity_type'], $this->activity_type, false);
        if (!empty($msg ['BPAC_event_type'])) {
		  $table->addCell($msg ['BPAC_event_type'], CLX_PROP_CLASS, CLX_CLASS_ALERT, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        }
        $event = new htmlSelect('BPAC_event_type');
        foreach ($this->event_type as $code => $info) {
		  $event->addItem(dict($info), $code, ($code == $record ['BPAC_event_type']));
        }
        $event->setProp('onchange', 'UPDATEEventLanguage();');
        $table->addData(dict('GEN_LBL_TRIGGER_EVENT') . ':', $event->source());
        if (!empty($msg ['EVNT_action'])) {
		  $table->addCell($msg ['EVNT_action'], CLX_PROP_CLASS, CLX_CLASS_ALERT, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        }
        $actions = $OBJS->objectPop('ACTN', 'EVNT_action', $record ['EVNT_action'], true, $record ['EVNT_ownercode']);
        $actions->setProp('onchange', 'updateForm();');
        $table->addData(dict('GEN_LBL_ACTION_TYPE'), $actions->source());
        $form->addContents($table->source());
        foreach ($actioncodes as $actioncode) {
		  $actionobject = $OBJS->getObject_('ACTN', $actioncode);
		  $form->addContents($actionobject->panel($msg, $record));
        }
        // Footers
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons = '';
        if (!empty($modify)) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        } else {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $c = new htmlButtonCancel ();
        $buttons .= $c->source();
        $table->addCell($buttons, CLX_PROP_CLASS, CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        $form->addContents($table->source());
        return $script . $topscript . $form->source() . $btmscript;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::deleteRecord()
     */
    function deleteRecordSk($id) {
        $activity = ClxCommon::$db->getField($this->tablename, 'ACTIVITIESCODE', 'ID=' . $id);
        $BPRU = &getTool('BPRU');
        $rs = ClxCommon::$db->getRecords($BPRU->tablename, 'ACTIVITIESCODE=' . singleQuote($activity));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $BPRU->deleteRecordSk($r ['ID']);
        }
        $BPPE = &getTool('BPPE');
        $rs = ClxCommon::$db->getRecords($BPPE->tablename, 'ACTIVITIESCODE=' . singleQuote($activity));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $BPPE->deleteRecordSk($r ['ID']);
        }
        $BPTR = &getTool('BPTR');
        $rs = ClxCommon::$db->getRecords($BPTR->tablename, 'FROMACTIVITY=' . singleQuote($activity) . ' OR TOACTIVITY=' . singleQuote($activity));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $BPTR->deleteRecordSk($r ['ID']);
        }
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::defaultRecord()
     */
    function defaultRecord() {
        $callingpage = peekHistory(); // Buscar ojo
        $record = parent::defaultRecord();
        $record ['BPAC_id'] = CLX_INIT_ZERO;
        $record ['BPAC_activitiescode'] = $callingpage ['lanecode'] . '.' . (ClxCommon::$db->countRecords($this->tablename, 'LANECODE = ' . singleQuote($callingpage ['lanecode'])) + CLX_NUM_ONE);
        $record ['BPAC_version'] = '3.0.0';
        $record ['BPAC_status'] = CLX_NUM_ONE;
        $record ['BPLA_code'] = $callingpage ['lanecode'];
        $record ['BPAC_status'] = CLX_NUM_ONE;
        // agregados por fjs
        $record ['BPAC_lanecode'] = $callingpage ['lanecode'];
        $record ['BPAC_categoriescode'] = '';
        $record ['EVNT_action'] = 'ATNO';
        $record ['EVNT_ownercode'] = $this->code;
        // Seqnum usado para ordenar el listado
        $record ['BPAC_seqnum'] = (ClxCommon::$db->countRecords($this->tablename, 'LANECODE = ' . singleQuote($callingpage ['lanecode'])) + CLX_NUM_ONE);
        $OBJS = &getTool('OBJS');
        $actioncodes = $OBJS->objectList('ACTN');
        foreach ($actioncodes as $actioncode) {
		  $actionobject = $OBJS->getObject_('ACTN', $actioncode);
		  $actionobject->defaultPanel($record);
        }
        return $record;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::loadRecord()
     */
    function loadToolRecord($recordid) {
        $record = parent::loadToolRecord($recordid);
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $values ['ACTION'] = $record ['BPAC_action_type'];
        $record ['EVNT_action'] = $record ['BPAC_action_type'];
        $record ['EVNT_ownercode'] = $this->code;
        $OBJS = &getTool('OBJS');
        //$actionobject = &$OBJS->getObject_('ACTN', $values ['ACTION_TYPE']);
        $actionobject = $OBJS->getObject_('ACTN', $values ['ACTION_TYPE']);
        $actionobject->setPanel($record, $values);
        return $record;
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::createRecord()
     */
    function createRecordVoid_() {
        ClxFreeReturn($this->createRecord_());
    }

    function createRecord_() {
        // Se esta utilizando la functionalidad de eventos para mantener
        // consistencia
        $record = array();
        $OBJS = &getTool('OBJS');
        $actionobject = &$OBJS->getObject_('ACTN', UserRequest::$post ['EVNT_action']);
        $actionobject->getPanel($record, array());
        foreach ($record as $key => $val) {
		  UserRequest::$post ['BPAC_' . lowercase($key)] = $val;
        }
        UserRequest::$post ['BPAC_action_type'] = UserRequest::$post ['EVNT_action'];
        return parent::createRecord();
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::saveRecord()
     */
    function saveRecord() {
        // Se esta utilizando la functionalidad de eventos para mantener
        // consistencia
        $record = array();
        $OBJS = &getTool('OBJS');
        $actionobject = &$OBJS->getObject_('ACTN', UserRequest::$post ['EVNT_action']);
        $actionobject->getPanel($record, array());
        foreach ($record as $key => $val) {
		  UserRequest::$post ['BPAC_' . lowercase($key)] = $val;
        }
        UserRequest::$post ['BPAC_action_type'] = UserRequest::$post ['EVNT_action'];
        parent::saveRecord();
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::reorderRecords()
     */
    function reorderRecords() {
        $callingpage = peekHistory();
        $records = ClxCommon::$db->getRecords($this->tablename, 'LANECODE=' . singleQuote($callingpage ['lanecode']) . ' ORDER BY SEQNUM');
        $list = array();
        while (($record = ClxCommon::$db->getNextRecord($records))) {
		  $list [$record ['ID']] = htmlentities($record ['IDNAME'], ENT_COMPAT, 'UTF-8', true);
        }
        return $list;
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::reorderAction()
     */
    function reorderAction() {
        parent::reorderAction();
        $callingpage = peekHistory();
        $BPLA = &getTool('BPLA');
        $BPLA->versionIncrease('LANECODE', $callingpage ['lanecode']);
    }

// end method
    /**
     * Set acction list
     *
     * @return multitype:string
     */
    private function set_action_list() {
        $list = array();
        $sql = 'SELECT IDCODE FROM CLX_OBJECTS WHERE TYPE = ' . singleQuote('ACT') . '';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
		  $list [$r [CLX_NUM_ZERO]] = 'GEN_LBL_' . $r [CLX_NUM_ZERO];
        }
        return $list;
    }

// end method
    /**
     * Displays action flow
     *
     * @return string
     */
    private function show_proces_flow() {
        $callingpage = peekHistory('main');
        require kPathToWebSite . 'classes/Jtree.php';
        // Armando arbol de actividades
        $activities = array();
        $sql = 'SELECT
				  BPAC.ACTIVITIESCODE id,
				  BPAC.IDNAME idname,
				  BPTR.FROMACTIVITY parent_id
				FROM
				  CLX_BP_PROCESSES BPPR,
				  CLX_BP_LANES BPLA,
				  CLX_BP_ACTIVITIES BPAC
				  LEFT JOIN CLX_BP_TRANSITIONS BPTR
				    ON BPTR.TOACTIVITY = BPAC.ACTIVITIESCODE
				WHERE
				  BPPR.PROCESSCODE = BPLA.PROCESSCODE
				  AND BPAC.LANECODE = BPLA.LANECODE
				  AND BPPR.PROCESSCODE = ' . singleQuote($callingpage ['processcode']) . '
				  /*AND BPAC.ACTIVITY_TYPE = ' . singleQuote('STAR') . '*/
				ORDER BY
				  BPLA.SEQNUM ASC,
				  BPAC.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $activities [] = $r;
        }
        // create a new tree object
        $jt = new JTree ();
        // iterate building the tree
        foreach ($activities as $activity) {
		  $uid = $jt->createNode($activity ['idname'], $activity [CLX_PROP_ID]);
		  $parentId = null;
		  if (!empty($activity ['parent_id'])) {
			 $parentId = $activity ['parent_id'];
		  }
		  $jt->addChild($parentId, $uid);
        }
        $it = new JTreeRecursiveIterator($jt, new JTreeIterator($jt->getTree()), false, CLX_NUM_ZERO, false);
        // iterate to create the ul list
        foreach ($it as $k => $v) {

        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('GEN_LBL_PROCESS_FLOW'), CLX_PROP_CLASS, CLX_CLASS_TITLE, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        $table->addCell(dict('GEN_LBL_PROCESS'), CLX_PROP_CLASS, CLX_CLASS_PROMPT);
        $table->addCell($callingpage ['processcode'], CLX_PROP_CLASS, CLX_CLASS_DATA);
        $table->addCell(dict('GEN_LBL_PROCESS'), CLX_PROP_CLASS, CLX_CLASS_PROMPT);
        $table->addCell($it->getContent(), CLX_PROP_CLASS, CLX_CLASS_DATA);
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CLOSE'));
        $table->addCell($c->source(), CLX_PROP_CLASS, CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN, CLX_WIDTH_TWO);
        return $table->source();
    }

    /**
     * Return true if activity required wait
     * @param string $activity_code
     * @return boolean
     */
    public function activity_has_wait($activity_code) {
        if (empty($activity_code))
		  return false;
        $eventtype = ClxCommon::$db->getField($this->tablename, 'ACTION_TYPE', 'ACTIVITIESCODE = ' . singleQuote($activity_code));
        $action = getToolObject('ACTN', $eventtype);
        return $action->get_bp_req_user_wait();
    }

    /**
     * executes activity
     * @param string $activity_code
     * @param array $record
     * @param array $msg
     */
    public function execute_activity($activity_code, &$record, &$msg) {
        if (empty($activity_code))
		  return false;
        $eventrec = ClxCommon::$db->getRecord($this->tablename, 'ACTIVITIESCODE = ' . singleQuote($activity_code));
        if (!empty($eventrec)) {
		  $eventrec['ACTION'] = $eventrec['ACTION_TYPE']; //Event objects are set to action. action_type was introduced in this tool.
		  if ($eventrec['ACTION'] === '')
			 return true;
		  $action = getToolObject('ACTN', $eventrec['ACTION']);
		  return $action->execute_bp_event($eventrec, $record, $msg, $this->debug);
        }
        return false;
    }

    /**
     * Executes event
     * @param unknown_type $activity_code
     * @param unknown_type $record
     * @param unknown_type $msg
     * @return boolean
     */
    public function execute_manual_activity($activity_code, &$record, &$msg) {
        if (empty($activity_code))
		  return false;
        $eventrec = ClxCommon::$db->getRecord($this->tablename, 'ACTIVITIESCODE = ' . singleQuote($activity_code));
        if (!empty($eventrec)) {
		  $eventrec['ACTION'] = $eventrec['ACTION_TYPE']; //Event objects are set to action. action_type was introduced in this tool.
		  if ($eventrec['ACTION'] === '')
			 return true;
		  $action = getToolObject('ACTN', $eventrec['ACTION']);
		  return $action->execute_bp_manual_event($eventrec, $record, $msg, $this->debug);
        }
        return false;
    }

}

// End class