<?php

/**
 * Process Seccion Manager
 *
 * @package		Clientix.Tool.Business Process
 * @abstract		Business Process Manager
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-06-21 08:03:11 -0400 (Thu, 21 Jun 2018) $
 * @version    	$Rev: 9841 $
 *
 */
class bp_transitions extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'BPTR';
        $this->name = 'Business Process - Transitions';
        $this->system = 'Business Process'; // Chequear
        $this->version = '5.5.0.1';




        $this->tablename = 'CLX_BP_TRANSITIONS';
        $this->record_name_singular = 'GEN_LBL_BP_TRANSITIONS'; // ETIQUETAS listo
        $this->record_name_plural = 'GEN_LBL_BP_TRANSITIONS'; // ETIQUETAS listo
        $this->primary_key = array('TRANSITIONSCODE');
        $this->primary_field = 'TRANSITIONSCODE';
        $this->secondary_field = 'IDNAME';
        $this->terciary_field = 'PROCESSCODE';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_BPTR_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_TRANSITIONSCODE',
					   'fields' => array(
						  array('name' => 'transitionscode',
						      'type' => 'string',
						      'default' => '',
						      'size' => '16',
						      'displaysize' => '16',
						      'dontmodify' => '1',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								), array('type' => 'unique',
								    'fieldname' => 'transitionscode',
								    'tablename' => $this->tablename)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_IDNAME',
					   'fields' => array(
						  array('name' => 'idname',
						      'type' => 'string',
						      'default' => '',
						      'size' => '64',
						      'displaysize' => '48',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_PROCESSCODE',
					   'fields' => array(
						  array('name' => 'processcode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'BPPR',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								), array('type' => 'lookup',
								    'fieldname' => 'processcode',
								    'tablename' => 'CLX_BP_PROCESSES'
								)
						      )
						  )
					   )
			         )
			     )
			 ), array(CLX_CLASS_TITLE => 'GEN_LBL_DIRECTION',
			     'type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FROMACTIVITY',
					   'fields' => array(
						  array('name' => 'fromactivity',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'BPAC',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								), array('type' => 'lookup',
								    'fieldname' => 'activitiescode',
								    'tablename' => 'CLX_BP_ACTIVITIES'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_TOACTIVITY',
					   'fields' => array(
						  array('name' => 'toactivity',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'BPAC',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								), array('type' => 'lookup',
								    'fieldname' => 'activitiescode',
								    'tablename' => 'CLX_BP_ACTIVITIES'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_CONDITION',
					   'fields' => array(
						  array('name' => 'condition',
						      'type' => CLX_CLASS_LIST,
						      'default' => '1',
						      'options' => $this->yesno)
					   )
			         )
			     )
			 )
		  )
        );
        $this->viewform = $this->editform;
        $this->viewform [CLX_CLASS_TITLE] = 'TOOL_BPTR_TITLE_DISPLAY';
        $this->toolpanelkeys = array(array('name' => 'PROCESSCODE',
			 'type' => 'string'
		  )
        );
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'fields' => array(
			 array('name' => 'ID',
			     'label' => 'GEN_LBL_ID',
			     'type' => 'number'
			 ), array('name' => 'TRANSITIONSCODE',
			     'label' => 'GEN_LBL_TRANSITIONSCODE',
			     'type' => 'string'
			 ), array('name' => 'IDNAME',
			     'label' => 'GEN_LBL_IDNAME',
			     'type' => 'string'
			 ), array('name' => 'PROCESSCODE',
			     'label' => 'GEN_LBL_PROCESSCODE',
			     'type' => 'string'
			 ), array('name' => 'FROMACTIVITY',
			     'label' => 'GEN_LBL_FROMACTIVITY',
			     'type' => 'string'
			 ), array('name' => 'TOACTIVITY',
			     'label' => 'GEN_LBL_TOACTIVITY',
			     'type' => 'string'
			 ), array('name' => 'CONDITION',
			     'label' => 'GEN_LBL_CONDITION',
			     'type' => CLX_CLASS_LIST,
			     'options' => $this->yesno)
		  )
        );
    }

// End method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::toolTableStructure()
     */
    function toolTableStructure() {
        $fields = array();
        $fields ['ID'] = array('type' => 'int(11) unsigned',
		  'null' => 'NO',
		  'properties' => 'auto_increment',
		  'index' => 'PRI'
        );
        $fields ['TRANSITIONSCODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['IDNAME'] = array('type' => 'varchar(64)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['CONDITION'] = array('type' => 'tinyint(1) unsigned',
		  'null' => 'NO',
		  'default' => '1',
		  'properties' => ''
        );
        $fields ['PROCESSCODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['FROMACTIVITY'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['TOACTIVITY'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes [$ipf . '01'] = array('index' => 'PRI',
		  'fieldname' => 'ID'
        );
        $indexes [$ipf . '02'] = array('index' => 'UNI',
		  'fieldname' => 'TRANSITIONSCODE'
        );
        $indexes [$ipf . '03'] = array('index' => 'MUL',
		  'fieldname' => 'PROCESSCODE'
        );
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes
        );
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::action()
     */
    function action($ac, $idlist) {
        //if ($this->access ['canread'] === true) {
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 default :
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  //$contents = warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[BP_TRANSITIONS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::unpack()
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        ClxCommon::$db->deleteRecords($this->tablename, $this->primary_field . '=' . singleQuote($record [$this->primary_field]));
        ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::versionIncrease()
     */
    function versionIncrease($fieldname, $fieldvalue) {
        $processcode = ClxCommon::$db->getField($this->tablename, 'PROCESSCODE', $fieldname . '=' . singleQuote($fieldvalue));
        $BPPR = &getTool('BPPR');
        $BPPR->versionIncrease('PROCESSCODE', $processcode);
        parent::versionIncrease($fieldname, $fieldvalue);
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::defaultRecord()
     */
    function defaultRecord() {
        // list_activities
        $callingpage = peekHistory();
        $record = parent::defaultRecord();
        $record ['BPTR_transitionscode'] = $callingpage ['processcode'] . '.' . (ClxCommon::$db->countRecords($this->tablename, 'PROCESSCODE = ' . singleQuote($callingpage ['processcode'])) + CLX_NUM_ONE);
        $record ['BPTR_version'] = '3.0.0';
        $record ['BPTR_status'] = CLX_NUM_ONE;
        $record ['BPTR_condition'] = CLX_NUM_ONE;
        $record ['BPTR_processcode'] = $callingpage ['processcode'];
        if (!empty($callingpage ['list_activities'])) {
		  $i = CLX_INIT_ZERO;
		  $sql = 'SELECT ACTIVITIESCODE FROM CLX_BP_ACTIVITIES WHERE ID IN (' . $callingpage ['list_activities'] . ') ORDER BY ID ASC LIMIT 2';
		  $rs = ClxCommon::$db->executeQuery($sql);
		  while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			 if ($i == CLX_NUM_ZERO)
			     $record ['BPTR_fromactivity'] = $r ['ACTIVITIESCODE'];
			 else
			     $record ['BPTR_toactivity'] = $r ['ACTIVITIESCODE'];
			 $i ++;
		  }
		  ClxCommon::$db->freeResult($rs);
		  $record ['BPTR_idname'] = $record ['BPTR_fromactivity'] . ' -> ' . $record ['BPTR_toactivity'];
        }
        return $record;
    }

// end method
}
