<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-12 19:03:48 -0400 (Fri, 12 Oct 2018) $
 * @version        $Rev: 10244 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class db_import_executions extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'DBIX';
        $this->name = 'Import Executions';
        $this->system = 'Database';
        $this->version = '7.0.0.0';


        $this->accesskey = 'DBIM';

        $this->tablename = 'CLX_DB_IMPORT_EXECUTIONS';
        $this->record_name_singular = 'import execution';
        $this->record_name_plural = 'import executions';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IMPORTCODE';
		$this->STATUS_TYPE=ARRAY('ACT'=>'ACTIVO','IACT'=>'INACTIVO','ERRO'=>'ERROR');
    
		$this->quickfilterform = array('panels' => array(
					array('type' => 'normal',
						'entries' => array(
							array('label' => 'GEN_LBL_LOG_ID', 'fields' => array(array('name' => 'log_id', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16'))),
			   
			))));
		
		IF (ISSET($GLOBALS['ADDRDEBUGIMPORT']) && (empty($_SERVER['REMOTE_ADDR']) || $GLOBALS['ADDRDEBUGIMPORT']==$_SERVER['REMOTE_ADDR'])) {
			$this->debug=true;
		}
		else if ( ISSET($GLOBALS['ADDRDEBUGIMPORTREP']) && ($GLOBALS['ADDRDEBUGIMPORTREP']==$_SERVER['REMOTE_ADDR'] or $GLOBALS['ADDRDEBUGIMPORTREP']=='(1)' )){
			$this->debug=true; 
			$this->debugescribir=true;
		}
	}
	
    /**
     * @see clx_tools::toolTableStructure
     * @return array
     */
    function toolTableStructure() {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1640;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_executions-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IMPORTCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['RECORD_QTY'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['OWNERCODE'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'null' => 'YES', 'properties' => '');
        $fields['FILENAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['RUN_BATCH'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['BATCH_STATUS'] = array('type' => 'varchar(10)', 'null' => 'NO', 'default' => '' . singleQuote('IDLE') . '', 'default_raw' => 'IDLE');
        $fields['BATCH_PID'] = array('type' => 'varchar(34)', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['BATCH_SDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['BATCH_EDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['BATCH_PRMT'] = array('type' => 'mediumtext', 'null' => 'YES', 'properties' => '');
		$fields['IMFT_ID'] = array('type' =>  'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['FILEDATE_REQ']=array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
		$fields['LOG_ID'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['STATUS'] = array('type' => 'varchar(8)', 'null' => 'NO', 'default' => singleQuote('ACT') );
        $fields['OBSERVATION'] = array('type' => 'varchar(2000)', 'null' => 'YES', 'default' => '' );
        $fields['FILENAME_INC_DATE'] =array('type' => 'int(1) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['CH_VALUE_DATE']=array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $fields['PRE_CHARGE'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        
		$indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'IMPORTCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IMPORTCODE,LOG_ID,FILEDATE_REQ');
        $indexes[$ipf . '04'] = array('index' => 'MUL','fieldname' => 'FILEDATE_REQ');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function action($ac, $idlist) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1639;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_executions-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        if ($this->getAccess()->canRead()) {
			switch ($ac) {
			 case 'LIST':
			     if (!empty(UserRequest::$request['importcode'])) {//Adding parameter to the filter if mc is set on menu to display only mc.
			         $_SESSION['paging']['DBIXList']['criteria'] = ' IMPORTCODE = ' . singleQuote(UserRequest::$request['importcode']);
			         if (empty($_SESSION['paging']['DBIXList']['sortby']))
					   $_SESSION['paging']['DBIXList']['sortby'] = CLX_INIT_ZERO;
			         if (empty($_SESSION['paging']['DBIXList']['startat']))
					   $_SESSION['paging']['DBIXList']['startat'] = CLX_INIT_ZERO;
			     }
			     $contents = parent::action($ac, $idlist);
			     break;
			 case 'PANEL':
			     $contents = $this->makepanel(UserRequest::$request['importcode']);
			     break;
				case 'DELETE_LOT':
					$contents =$this->promptDelete($idlist);
					break;
			 default:
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_IMPORT_EXECUTIONS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makepanel($importcode = null) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1641;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_executions-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        if ($this->getAccess()->canRead()) {
		  $t = time();
		  $to = $this->code;
		  $here = 'tool.php?to=' . $to . '&t=' . $t;
		  $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
		  $form->setProp(CLX_PROP_ID, 'DBIXPanel');
		  $form->addArgument(CLX_PROP_TO, $this->code);
		  $form->addArgument('importcode', $importcode);
		  $form->addArgument('ac', 'NOT_DEFINED');
		  $selectclause = '*';
		  $fromclause = 'CLX_DB_IMPORT_EXECUTIONS';
		  $whereclause = 'IMPORTCODE=' . singleQuote($importcode);
		  $sortclause = 'LOG_ID DESC,CDATE DESC';
			$tablecode = ClxCommon::$db->getOne('SELECT TABLECODE FROM CLX_DB_IMPORTS WHERE IDCODE=' . singlequote($importcode));
			
		  $page = new xPaging();
			$page->setProp('rpp', CLX_NUM_TEN);
			$page->setProp('printheaders', false);
		  $page->setProp('selector', false);
			if ($this->debug==true) {
				ECHO 'selectclause: ',$selectclause,'<br>';
				ECHO 'fromclause: ', $fromclause,'<br>';
				ECHO 'whereclause: ', $whereclause,'<br>';
				ECHO 'sortclause: ', $sortclause,'<br>';
			}
		  $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
			IF (DEFINED('DBIM_INCLUDE_DATE_INF') && DBIM_INCLUDE_DATE_INF==1) 
			  $table = new htmlTable(CLX_WIDTH_13+2);
			else
				$table = new htmlTable(CLX_WIDTH_13+1);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT, 'id'=>'DBIX_TABLE') );
		  $page->header($table);
			$valores_titulos=array(dict('GEN_LBL_SEL'),dict('GEN_LBL_DATE'), dict('GEN_LBL_FILENAME'), dict('GEN_LBL_RECORD_QTY'), dict('GEN_LBL_BY'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_RUN_BATCH'), dict('GEN_LBL_BATCH_STATUS'), dict('GEN_LBL_BATCH_SDATE'), dict('GEN_LBL_BATCH_EDATE'), dict('GEN_LBL_BATCH_PID'), dict('GEN_LBL_STATUSX'), dict('GEN_LBL_LOG'),dict('GEN_LBL_STATE_LOG'));
			IF (DEFINED('DBIM_INCLUDE_DATE_INF') && DBIM_INCLUDE_DATE_INF==1) 
				$valores_titulos[]=dict('GEN_LBL_REQ_DATE');
		  $table->addCells(CLX_CLASS_HEADERS, $valores_titulos);
		  $i = CLX_INIT_ZERO;
			$extrabarfiles=array();
			$contbarr=0;
			$extrabarr='<style>#container1,#container2,#container3,#container4,#container5,#container6,#container7 {margin: 0 auto;width: 100px;padding: 0.2em;background: #DCDDDF;}.ui-progress-bar{margin-top: 0.2em;margin-bottom: 0.2em;}.ui-progress span.ui-label {font-size: 0.8em;position: absolute;right: 0;line-height: 14px;padding-right: 14px;color: rgba(0,0,0,0.6);text-shadow: rgba(255,255,255, 0.45) 0 1px 0px;white-space: nowrap;} @-webkit-keyframes animate-stripes {from {background-position: 0 0;} to {background-position: 14px 0;}} .ui-progress-bar {position: relative; height: 13px; padding-right: 2px; background-color: #abb2bc; border-radius: 14px;-moz-border-radius: 14px; -webkit-border-radius: 14px; background: -webkit-gradient(linear, left bottom, left top, color-stop(0, #b6bcc6), color-stop(1, #9da5b0)); background: -moz-linear-gradient(#9da5b0 0%, #b6bcc6 100%); -webkit-box-shadow: inset 0px 1px 2px 0px rgba(0, 0, 0, 0.5), 0px 1px 0px 0px #FFF; -moz-box-shadow: inset 0px 1px 2px 0px rgba(0, 0, 0, 0.5), 0px 1px 0px 0px #FFF; box-shadow: inset 0px 1px 2px 0px rgba(0, 0, 0, 0.5), 0px 1px 0px 0px #FFF; } .ui-progress { position: relative; display: block; overflow: hidden; height: 11px; -moz-border-radius: 16px; -webkit-border-radius: 16px; border-radius: 35px; -webkit-background-size: 16px 16px; background-color: #74d04c; background: -webkit-gradient(linear, 0 0, 16 16, color-stop(0.00, rgba(255,255,255,0.17)), color-stop(0.25, rgba(255,255,255,0.17)), color-stop(0.26, rgba(255,255,255,0)), color-stop(0.50, rgba(255,255,255,0)), color-stop(0.51, rgba(255,255,255,0.17)), color-stop(0.75, rgba(255,255,255,0.17)), color-stop(0.76, rgba(255,255,255,0)), color-stop(1.00, rgba(255,255,255,0)) ), -webkit-gradient(linear, left bottom, left top, color-stop(0, #74d04c), color-stop(1, #9bdd62)); background: -moz-repeating-linear-gradient(top left -30deg, rgba(255,255,255,0.17), rgba(255,255,255,0.17) 18px, rgba(255,255,255,0) 18px, rgba(255,255,255,0) 19px ), -moz-linear-gradient(#9bdd62 0%, #74d04c 100%); -webkit-box-shadow: inset 0px 1px 0px 0px #dbf383, inset 0px -1px 1px #58c43a; -moz-box-shadow: inset 0px 1px 0px 0px #dbf383, inset 0px -1px 1px #58c43a; box-shadow: inset 0px 1px 0px 0px #dbf383, inset 0px -1px 1px #58c43a; border: 1px solid #4c8932; -webkit-animation: animate-stripes 2s linear infinite; } </style>';

//				$extrabarr='<style>#container1,#container2,#container3,#container4,#container5,#container6,#container7 {margin: 0 auto;width: 100px;padding: 0.1em;background: #DCDDDF;}.ui-progress-bar{margin-top: 0.2em;margin-bottom: 0.2em;}.ui-progress span.ui-label {font-size: 0.6em;position: absolute;right: 0;line-height: 11px;padding-right: 11px;color: rgba(0,0,0,0.6);text-shadow: rgba(255,255,255, 0.45) 0 1px 0px;white-space: nowrap;} @-webkit-keyframes animate-stripes {from {background-position: 0 0;} to {background-position: 11px 0;}} .ui-progress-bar {position: relative; height: 10px; padding-right: 2px; background-color: #abb2bc; border-radius: 11px;-moz-border-radius: 11px; -webkit-border-radius: 11px; background: -webkit-gradient(linear, left bottom, left top, color-stop(0, #b6bcc6), color-stop(1, #9da5b0)); background: -moz-linear-gradient(#9da5b0 0%, #b6bcc6 100%); -webkit-box-shadow: inset 0px 1px 2px 0px rgba(0, 0, 0, 0.5), 0px 1px 0px 0px #FFF; -moz-box-shadow: inset 0px 1px 2px 0px rgba(0, 0, 0, 0.5), 0px 1px 0px 0px #FFF; box-shadow: inset 0px 1px 2px 0px rgba(0, 0, 0, 0.5), 0px 1px 0px 0px #FFF; } .ui-progress { position: relative; display: block; overflow: hidden; height: 8px; -moz-border-radius: 13px; -webkit-border-radius: 13px; border-radius: 35px; -webkit-background-size: 13px 13px; background-color: #74d04c; background: -webkit-gradient(linear, 0 0, 13 13, color-stop(0.00, rgba(255,255,255,0.17)), color-stop(0.25, rgba(255,255,255,0.17)), color-stop(0.26, rgba(255,255,255,0)), color-stop(0.50, rgba(255,255,255,0)), color-stop(0.51, rgba(255,255,255,0.17)), color-stop(0.75, rgba(255,255,255,0.17)), color-stop(0.76, rgba(255,255,255,0)), color-stop(1.00, rgba(255,255,255,0)) ), -webkit-gradient(linear, left bottom, left top, color-stop(0, #74d04c), color-stop(1, #9bdd62)); background: -moz-repeating-linear-gradient(top left -30deg, rgba(255,255,255,0.17), rgba(255,255,255,0.17) 15px, rgba(255,255,255,0) 15px, rgba(255,255,255,0) 16px ), -moz-linear-gradient(#9bdd62 0%, #74d04c 100%); -webkit-box-shadow: inset 0px 1px 0px 0px #dbf383, inset 0px -1px 1px #58c43a; -moz-box-shadow: inset 0px 1px 0px 0px #dbf383, inset 0px -1px 1px #58c43a; box-shadow: inset 0px 1px 0px 0px #dbf383, inset 0px -1px 1px #58c43a; border: 1px solid #4c8932; -webkit-animation: animate-stripes 2s linear infinite; } </style>';

		  while ($record = $page->nextRecord()) {
			 $recordid = $record['ID'];
				if ($record['STATUS']!='IACT'){
					$select = new htmlCheckbox('selector_' . $recordid, false);
					$select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
					$table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
				} else {
					$table->addCell('<input type=checkbox disabled>', array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
				}
				$record['STATUS']=str_replace('\'','',$record['STATUS']);
				$codebarextra='<div style="width:125px">&nbsp;</div>';
				$base=basename(STRTR($record['FILENAME'],ARRAY('%3A'=>':','%2F'=>'/','+'=>' ')));
				$filebarr=kPathToWebSite."/".kPathToTemp.str_replace(".","",$base).".barr";
				if(($record['RUN_BATCH']==1 && ($record['BATCH_STATUS']=='RUN' || $record['BATCH_STATUS']=='IDLE')) && (!file_exists($filebarr) || file_get_contents($filebarr) <>100  ) ) {
					$extrabarfiles[++$contbarr]=array($recordid,$filebarr);
					$codebarextra.='<div id="container'.$contbarr.'"><div id="progress_bar'.$contbarr.'" class="ui-progress-bar ui-container"><div class="ui-progress" style="width: 0%;"><span class="ui-label" style="display:none;">Procesando <b class="value">0%</b></span></div><!-- .ui-progress --></div><!-- #progress_bar --></div>';
				//pre($extrabarfiles);
				}
				$valores_listado=array(
			     xformat::datetime($record['CDATE']),
					basename($record['FILENAME']).$codebarextra, $record['RECORD_QTY'], $record['OWNERCODE'], xFormat::text($record['DESCRIPTION'],62),
			     dict($this->yesno[$record['RUN_BATCH']]), (CLX_NUM_ZERO+$record['RUN_BATCH'] === CLX_NUM_ONE) ? dict($this->notify_status[$record['BATCH_STATUS']]) : '',
			     xformat::datetime($record['BATCH_SDATE']),
			     xformat::datetime($record['BATCH_EDATE']),
			     $record['BATCH_PID'],
					$this->STATUS_TYPE[$record['STATUS']],
					$record['LOG_ID'],
					xFormat::text($record['OBSERVATION'],24	)
				);	
				IF (DEFINED('DBIM_INCLUDE_DATE_INF') && DBIM_INCLUDE_DATE_INF==1) 
					$valores_listado[]=	$record['FILEDATE_REQ'];	
				$table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT,$valores_listado );
			 $i++;
		  }
			$sql='select COUNT(1) from CLX_DB_TABLEFIELDS Y WHERE Y.TABLECODE='.singlequote($tablecode).' AND EXISTS (SELECT 1 FROM CLX_DB_TABLES X WHERE X.IDCODE=Y.TABLECODE AND MODULECODE='.singlequote('USER').')   AND Y.FIELDNAME='.singlequote('LOG_ID');
			$buttons='';
			if ($this->getAccess()->canDelete() &&ClxCommon::$db->getOne($sql)>0){
			 $buttons =htmlButton::getButton('submit', dict('GEN_LBL_DELETE_LOT'), array('action' => 'DELETE_LOT', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  }
			$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        
			 $form->addContents($page->footers($table, $buttons));
			$extrabarr.='<script>var requestinformationbar='.singlequote(kWebSite."/data/code/request_information_bar.php").';'.chr(13).chr(10);
		
			for ($t=1;$t<8;$t++) {
				if ($t<=$contbarr) {
					$extrabarr.='var num'.$t.'=0;'.chr(13).chr(10);
					$extrabarr.='var file'.$t.'="'.$extrabarfiles[$t][1].'";'.chr(13).chr(10);
					$extrabarr.='var idrecord'.$t.'="'.$extrabarfiles[$t][0].'";'.chr(13).chr(10);
				}	
				else {
					$extrabarr.='var num'.$t.'=100;'.chr(13).chr(10);
					$extrabarr.='var file'.$t.'="";'.chr(13).chr(10);
					$extrabarr.='var idrecord'.$t.'="";'.chr(13).chr(10);
				}
			}
			$extrabarr.='</script>';
		  return buildPanelInterface(dict('TOOL_DBIX_TITLE_LIST'), 'IMPORT_EXECS_' . $importcode, $extrabarr.$form->source().setJavaScriptTag(getJavaScriptFilename('DBIX_editform.js'), true), CLX_NUM_MINUS_1);
        } else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }
		
	 /**
     * Present authorization form to describe rejections
     *
     * @param
     *        	$status
     */
    function promptDelete($idlist) {
		$rs = ClxCommon::$db->executeQuery($r='SELECT LOG_ID FROM '.$this->tablename.' WHERE IMPORTCODE='.singleQuote(UserRequest::$post['importcode']).' AND ID IN  (' . singleQuoteArray($idlist) . ')');
		$lot=array();
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$lot[]=	$r['LOG_ID'];
		}
		
		
        if (!empty(UserRequest::$post ['confirm']) && array_key_exists($this->code . '_observation', UserRequest::$post)) {
		  // store observation and continue
			$importable = ClxCommon::$db->getOneRecord($a='SELECT B.MODULECODE,B.IDNAME FROM CLX_DB_IMPORTS A,CLX_DB_TABLES B WHERE A.TABLECODE=B.IDCODE AND  A.IDCODE=' . singleQuote(UserRequest::$post['importcode']));
			ClxCommon::$db->deleteRecords($importable['MODULECODE'].'_'.$importable['IDNAME'], ' LOG_ID IN (' . singleQuoteArray($lot).')');
		  
		  ClxCommon::$db->updateRecord($this->tablename, array('OBSERVATION' => UserRequest::$post [$this->code . '_observation'],'STATUS'=>'IACT'), ' IMPORTCODE='.singleQuote(UserRequest::$post['importcode']).' AND LOG_ID IN (' . singleQuoteArray($lot) . ')');
		  $info = popHistory();
		  return executeHistory($info);
        }
	    $delete_fm = array(CLX_CLASS_TITLE => 'TOOL_DELETE_REASON',
		  'panels' => array(
				array('type' => 'normal',
			     'entries' => array(
			         
						array('label' => 'GEN_LBL_LOG',
							'fields' => array(
								array(	'name' => 'log_id',
										'type' => 'string',
										'default' =>'', 
										'size' => '300', 
										'displaysize' => '25', 
										'dontmodify' => '1')
							)
						),
						array('label' => 'GEN_LBL_OBSERVATION',
					   'fields' => array(
						  array('name' => 'observation',
						      'type' => 'text',
						      'default' => '',
						      'cols' => '48',
						      'rows' => '4'
						  )
					   )
			         ),						
			     )
				
				)	
			
		  )
        );
        $record = array(	$this->code . '_log_id' => ((!empty(UserRequest::$post [$this->code . '_log_id'])) ? UserRequest::$post [$this->code . '_log_id'] :' '.implode(', ',$lot))	,
							$this->code . '_observation' => ((!empty(UserRequest::$post [$this->code . '_observation'])) ? UserRequest::$post [$this->code . '_observation'] : '')
        );
        $msg = array();
	    $form = new clx_form($this->code, $delete_fm);
		$form->setArgument('importcode', UserRequest::$post['importcode']);
		$form->modify=true;
        return $form->editForm(UserRequest::$request['ac'], $idlist, $record, $msg);
    }

}
