<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-02-01 14:55:29 +0000 (Fri, 01 Feb 2019) $
 * @version        $Rev: 10520 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed [ene],[feb],[mar],[abr],[may],[jun],[ago],[sep],[oct],[nov],[dic]
 *  Included label[01],[02],[03],[04],[05],[06],[07],[08],[09],[10],[11],[12]
 */

class db_import_mappings extends clx_tool {

    var $editform_csv;
    
    function __construct() {
        $this->code = 'DBIC';
        $this->name = 'Import Mappings';
        $this->system = 'Database';
        $this->version = '7.0.0.0';

        $this->accesskey = 'DBIM';


        $this->tablename = 'CLX_DB_IMPORT_MAPPINGS';
        $this->record_name_singular = 'mapping';
        $this->record_name_plural = 'mappings';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IMPORTCODE';
		$this->tercsecondary_field = 'IMPORTCODE';
        $this->seqnum_field = 'SEQNUM';
		$this->otherRule=$this->seekOtherSaveRule();
		$this->date_in_formats2 = array(										 
									
									'ymd' => 'GEN_LBL_DATEFORMAT16',
									'Ymd' => 'GEN_LBL_DATEFORMAT17',
									'dmy' => 'GEN_LBL_DATEFORMAT18',
									'dmY' => 'GEN_LBL_DATEFORMAT19',
									'mdy' => 'GEN_LBL_DATEFORMAT06',
									'mdY' => 'GEN_LBL_DATEFORMAT07',
									'ymdHis' => 'GEN_LBL_DATEFORMAT14',
									'YmdHis' => 'GEN_LBL_DATEFORMAT15',
									'mdyHis' => 'GEN_LBL_DATEFORMAT36',
									'mdYHis' => 'GEN_LBL_DATEFORMAT37',
									'mdyHis' => 'GEN_LBL_DATEFORMAT38',
									'mdYHis' => 'GEN_LBL_DATEFORMAT39',
									'd#m#y' => 'GEN_LBL_DATEFORMAT40',
									'd#m#Y' => 'GEN_LBL_DATEFORMAT41',
									'y#m#d' => 'GEN_LBL_DATEFORMAT42',										 
									'Y#m#d' => 'GEN_LBL_DATEFORMAT43',
									'm#d#y' => 'GEN_LBL_DATEFORMAT44',
									'm#d#Y' => 'GEN_LBL_DATEFORMAT45',
									'Y#M#d' => 'GEN_LBL_DATEFORMAT52',
									'd#M#Y' => 'GEN_LBL_DATEFORMAT53',
									'M#d#Y' => 'GEN_LBL_DATEFORMAT54',
									'd#m#y#H#i#s' => 'GEN_LBL_DATEFORMAT46',
									'd#m#Y#H#i#s' => 'GEN_LBL_DATEFORMAT47',
									'm#d#y#H#i#s' => 'GEN_LBL_DATEFORMAT48',
									'm#d#Y#H#i#s' => 'GEN_LBL_DATEFORMAT49',
									'y#m#d#H#i#s' => 'GEN_LBL_DATEFORMAT50',
									'Y#m#d#H#i#s' => 'GEN_LBL_DATEFORMAT51',
									'____#__#__#H:i:s' => 'GEN_LBL_DATEFORMAT55',
									
								);
        $this->editform_csv = array(CLX_CLASS_TITLE => 'TOOL_DBIC_TITLE_CREATE',
		  'panels' => array(
				array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_TABLE_FIELD',
					   'fields' => array(
						  array('name' => 'table_fieldname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'dontmodify' => '1')
					   )
			         ), array('label' => 'TOOL_DBIC_FILL_WITH',
					   'fields' => array(
						  array('name' => 'type', 'type' => 'dynamic', 'panels' => array(
								'FILE' => 'TOOL_DBIC_FIELD',
								'CALC' => 'GEN_LBL_CONSTANT',
								'FORM' => 'TOOL_DBIC_FORMULA',
								'IGNR' => 'TOOL_DBIC_IGNORE'
						      )
						  )
					   
					   )
			         )
			     )
			 ), 
				array('type' => 'dynamic',
			     'code' => 'FILE',
			     'entries' => array(
						array('label' => 'GEN_LBL_FILE_FIELD',
					   'fields' => array(
						  array('name' => 'file_fieldname', 'type' => 'function', 'function' => 'getAvailableFields','sufix_extra'=>''))
						), 
						array(
					   'label' => 'GEN_LBL_FILE_FORMAT_AND_CONVERT',
							'fields' => array(
								
								array('name' => 'start_position', 'type' => 'string', 'size' => '10', 'displaysize' => '10', 'sufix' => 'GEN_LBL_CHARACTERS', 'validations' => array(
									array('type' => 'integer', 'required' => '1')),'prefix_extra'=>'<div class="columns5">'.'<div class="columns3">'.'<div class="columns1">'. dict('GEN_LBL_START_POSITION').'</div><div class="columns">','sufix_extra'=>'' 
								),
								
								
								array('name' => 'start_text', 'type' => 'string', 'size' => '70', 'displaysize' => '18', 'sufix' => '', 
									'validations' => array(array('type' => 'integer', 'required' => '0')),'sufix_extra'=>'</div>', 'prefix_extra'=>'</div><div class="columns1">'.dict( 'GEN_LBL_START_TEXT').'</div><div class="columns">'
								),
								
													
								array('name' => 'field_length', 'type' => 'string', 'size' => '10', 'displaysize' => '10', 'sufix' => 'GEN_LBL_CHARACTERS', 'validations' => array(array('type' => 'integer', 'required' => '1')) ,
									'sufix_extra'=>'','prefix_extra'=>'</div><div class="columns3"><div class="columns1">'. dict('GEN_LBL_FIELD_LENGTH').'</div><div class="columns">'
								),
								
								array('name' => 'end_text', 'type' => 'string', 'size' => '70', 'displaysize' => '18', 'sufix' => '', 
									'sufix_extra'=>'', 'prefix_extra' =>'</div><div class="columns1">'.dict('GEN_LBL_END_CHARACTER').'</div><div class="columns">'
								),								
								array('name' => 'select_text', 'type' => CLX_CLASS_LIST, 'default' => '0',
									'options' => array( '1'=>'GEN_LBL_SELECT_TEXT',
														'2'=>'GEN_LBL_OTHER_TEXT'),'sufix_extra'=>'</div>' , 'prefix_extra' =>'</div><div class="columns1">'. dict('GEN_LBL_SELECT_TEXT').'</div><div class="columns">'
								),

							    array('name' => 'text_replace', 'type' => 'string', 'size' => '150', 'displaysize' => '18', 'sufix' => '', 'validations' => array(
										array('type' => 'integer', 'required' => '0')),'sufix_extra'=>'', 'prefix_extra' =>'</div>'.'<div class="columns3">'.'<div class="columns1">'. dict('GEN_LBL_FIELD_TEXT_REPLACE').'</div><div class="columns">'
								),
								
								array('name' => 'text_replace_expression', 'type' => 'string', 'size' => '150', 'displaysize' => '18', 'sufix' => '', 'validations' => array(
										array('type' => 'integer', 'required' => '0')),'sufix_extra'=>'</div>', 'prefix_extra' =>'</div><div class="columns1">'.dict('GEN_LBL_FIELD_REGULAR').'</div><div class="columns">'
								),	
								array('name' => 'text_replace_new', 'type' => 'string', 'size' => '150', 'displaysize' => '18', 'sufix' => '', 'validations' => array(
										array('type' => 'integer', 'required' => '0')),'sufix_extra'=>'', 'prefix_extra' =>'</div><div class="columns3"><div class="columns1">'.dict('GEN_LBL_FIELD_TEXT_NEW').'</div><div class="columns">'
								),									
								array('name' => 'text_set', 'type' => CLX_CLASS_LIST, 'default' => '0',
									'options' => array( '1'=>'GEN_LBL_ALL_TEXT',
														'2'=>'GEN_LBL_LEFT_TEXT',
														'3'=>'GEN_LBL_RIGHT_TEXT',
														'4'=>'GEN_LBL_FIRST_CASE',
														'5'=>'GEN_LBL_SECOND_CASE',
														'6'=>'GEN_LBL_THIRD_CASE'),'sufix_extra'=>'</div>' , 'prefix_extra' =>'</div><div class="columns1">'. dict('GEN_LBL_APPLICCATION_TEXT').'</div><div class="columns">'
								),
								array('name' => 'format_text', 'type' => CLX_CLASS_LIST, 'default' => '0',
									'options' =>array_merge(array(''=>'',
															'ex1' => 'GEN_LBL_CONVERT_INTEGER',
															'ex2' => 'GEN_LBL_CONVERT_DECIMAL',
															'ex3' => 'GEN_LBL_CONVERT_STRING'), 
															$this->date_in_formats2)
										,'sufix_extra'=>"</div></div>", 'prefix_extra' =>'</div><div class="columns1">'. dict('GEN_LBL_FIELD_FORMAT_TO').'</div><div class="columns">'
								),
								
								
					  
								
								array('name' => 'select_options', 'type' => CLX_CLASS_LIST, 'default' => '0', 
									'size'=>'8','options' => array('0'=>'','1'=>'		','2'=>'		 ','3'=>'		','4'=>'','5'=>'','6'=>'','7'=>'' ),'sufix_extra'=>'</div></div>', 'prefix_extra' => '</div><div class="columns4"><div class="columns1">'.dict('GEN_LBL_OPTIONS_SELECT').'</div><div class="columns2">'
								),
								array('name' => 'text_save_name', 'type' => 'string', 'size' => '70', 'displaysize' => '20', 'sufix' => '', 'validations' => array(
										array('type' => 'integer', 'required' => '0')),'sufix_extra'=>'</div>', 'prefix_extra' =>'<div class="columns41"><div class="columns1">'.dict('GEN_LBL_NAME_SAVE').'</div><div class="columns">'
								),
								array('name' => 'other_aplicattions', 'type' => CLX_CLASS_LIST, 'default' => '0',
									'options' => $this->otherRule,'sufix_extra'=>'</div>' , 'prefix_extra' =>'<div class="columns1">'. dict('GEN_LBL_OTHER_SAVE').'</div><div class="columns">'
								),
								array('name' => 'importcode', 'type' => 'string', 'readonly'=>true
								)
																
								
							)
						)
			     )
			 ), 
				array('type' => 'dynamic',
			     'code' => 'CALC',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FORMULA',
					   'fields' => array(
						  array('name' => 'formula', 'type' => 'text', 'cols' => '48', 'rows' => '4'))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'FORM',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FORMULA',
					   'fields' => array(
						  array('name' => 'formula2', 'type' => 'text', 'cols' => '48', 'rows' => '4'))
			         ),
						array('label' => 'GEN_LBL_FORMULA_BULK',
					   'fields' => array(
						  array('name' => 'formula3', 'type' => 'text', 'cols' => '48', 'rows' => '4'))
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'IGNR',
			     'entries' => array()
			 )
		  )
        );
		//$this->getParameters_DBIM();
		$SYPR = getTool('SYPR');
		$SYPR-> initParameters('DBIM');
    }

    function toolTableStructure() {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1654;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IMPORTCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
		$fields['IMPORTSHEETS'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['TABLE_FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $fields['TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['FILE_FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
		$fields['FORMULA'] = array('type' => 'mediumtext', 'null' => 'YES', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['START_POSITION'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FIELD_LENGTH'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['MAPPING_MANUAL'] = array('type' => 'int(1) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['RULE_ID'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['POSITION_SHEET'] = array('type' => 'varchar(8)', 'null' => 'YES', 'properties' => '');
		
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'IMPORTCODE,SEQNUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function pack($record) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1655;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $o = $this->packRecord($record);
        $id = $record['ID'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'DBIT', 'SELECT * FROM CLX_DB_IMPORT_TRANSLATIONS WHERE MAPID=' . $id);
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1656;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $parameters = array_values(array_merge(array('package' => null, 'id' => null), $parameters));
        list($package, $formid) = $parameters;
        $record = $this->unpackRecord($package);
        $mapid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o, 'id' => $mapid));
		  }
        }
    }
  

    function action($ac, $idlist) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1657;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		if ($this->getAccess()->canRead()) {
			$msg=null;
			switch ($ac) {
				case 'REMAPPING':
					
					$this->remapping();
					$info = popHistory();
			     $contents = executeHistory($info);
					
					break;
				case 'CLEAR':
					$this->cleanmapping();
			     $info = popHistory();
			     $contents = executeHistory($info);
						
					break;	
				case 'CREATE':
				case 'CREATE2':UserRequest::$post['ac']=UserRequest::$request['ac']='CREATE';
			     if ($this->getAccess()->canDisplay()) {
			         if (isset(UserRequest::$post['confirm'])) {
					   if ($this->checkForm($msg)) {
						  $this->createRecordVoid_();
								if   ($ac=='CREATE2') {
									$contents =  $this->editForm('CREATE', array(), UserRequest::$post, $msg);
								}
								else if ($ac=='CREATE') {
									$info = popHistory();
									$contents = executeHistory($info);
								}	
					   } else {
						  $contents = $this->editForm($ac, array(), UserRequest::$post, $msg);
					   }
			         } else {
					   $record = $this->defaultRecord();
					   $contents = $this->editForm($ac, array(), $record, $msg);
			         }
			     } else {
			         $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [CLX_TOOL-CAN_APPEND][' . $ac . '] ' . $this->getCode(false));
			     }
			     break;
			 case 'MODIFY':
				case 'MODIFY2':
				case 'MODIFY3':
					//UserRequest::$post['ac2']=UserRequest::$request['ac2']=UserRequest::$request['ac'];
					UserRequest::$post['ac']=UserRequest::$request['ac']='MODIFY';
			     if ($this->getAccess()->canModify()) {
			         if (isset(UserRequest::$post['confirm'])) {
					   if ($ac=='MODIFY3') {
								$record = $this->loadToolRecord(UserRequest::$post['DBIC_id'] );
								$record['DBIC_file_fieldname']=empty(UserRequest::$post['DBIC_file_fieldname'])?'0':UserRequest::$post['DBIC_file_fieldname'];
								if (!empty(UserRequest::$post['DBIC_other_aplicattions']) ){
									$record['DBIC_text_save_name']=UserRequest::$post['DBIC_other_aplicattions'];
									UserRequest::$post['DBIC_text_save_name']=UserRequest::$post['DBIC_other_aplicattions'];
								}	
								$contents = $this->editForm('MODIFY', $idlist, $record, $msg);
							}			
							else if ($this->checkForm($msg)) {
						  ClxFreeReturn($this->saveRecord());
						  if ($ac=='MODIFY' && count($idlist) > CLX_NUM_ZERO ) {
									$id = array_pop($idlist);
									UserRequest::$post['DBIC_id']=array();
						      $record = $this->loadToolRecord($id);
									
									$contents = $this->editForm(UserRequest::$request['ac'], $idlist, $record, $msg);
							    } else if ( isset($GLOBALS["process"])  ) { 
						      $contents="";      
								}
								else if   ($ac=='MODIFY2') {
									$record = $this->loadToolRecord(UserRequest::$post['DBIC_id'] );
									$contents = $this->editForm(UserRequest::$request['ac'], $idlist, $record, $msg);
								}
								else if ($ac=='MODIFY') {
						      $info = popHistory();
						      $contents = executeHistory($info);
						  }
								
					   } else {
						  $contents = $this->editForm($ac, $idlist, UserRequest::$post, $msg);
					   }
			         } else { 
							$id = array_pop($idlist);
							$record = $this->loadToolRecord($id);
							   
					   $contents = $this->editForm($ac, $idlist, $record, $msg);
			         }
			     } else {
			         $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [CLX_TOOL-CAN_MODIFY][' . $ac . '] ' . $this->getCode(false));
			     }
			     break;
					default:
						 $contents = parent::action($ac, $idlist);
					
				}
				
			
		 
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_IMPORT_MAPPINGS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makepanel($importcode = null) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1639;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
    //width:280px;
	
	//word-wrap: break-word;
	//word-break: break-all;
		if ($this->getAccess()->canRead()) {
		  $t = time();
		  $to = $this->code;
		  $here = 'tool.php?to=' . $to . '&t=' . $t;
		  $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
		  $form->setProp(CLX_PROP_ID, 'DBICPanel');
		  $form->addArgument(CLX_PROP_TO, $this->code);
			$form->addArgument("sheets_", "");
		  $form->addArgument('importcode', $importcode);
		  $form->addArgument('ac', 'NOT_DEFINED');
			$fields=$this->get_labelfieldsTable($importcode);
			$import_rec = ClxCommon::$db->getRecord('CLX_DB_IMPORTS', 'IDCODE=' . singleQuote($importcode));
			$typeImport=$import_rec['TYPE'];
			IF ($typeImport=='CSV2')
				$typeImport='CSV';
			IF ($typeImport=='XLS2')
				$typeImport='XLS';
			IF ($typeImport=='FRL2')
				$typeImport='FRL';
			IF ($typeImport=='FRL3')
				$typeImport='FRL';

		    $selectclause = '*';
		  $fromclause = 'CLX_DB_IMPORT_MAPPINGS';
        	$notview=array('ID','BATCH_ID','IMPORTCODE','LOG_ID','LINE_OF_LOG_ID','LINE_OF_BATCH_ID');
			if (defined('DBIM_NOT_VIEW_FIELDS_MAPS')) {
				$notview=explode(',',str_replace(' ','',DBIM_NOT_VIEW_FIELDS_MAPS));
			}
			$whereclause = 'IMPORTCODE=' . singleQuote($importcode) .' AND TABLE_FIELDNAME NOT IN ('. singleQuoteArray($notview).') ORDER BY ID';
		    $sortclause = '';
		  $page = new xPaging();
		  $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
		  $page->setProp('printheaders', false);
		  $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, ''); 	
		  $table = new htmlTable(CLX_WIDTH_SIX);
			$table->setProp('id','DBIM_P');
			
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			$page->header($table);
		  $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_TABLE_FIELD') . ' (' . dict('GEN_LBL_TARGET') . ')',dict('GEN_LBL_LISTLABEL'), dict('GEN_LBL_SOURCE'),dict('GEN_LBL_SAMPLEPARSING'),dict('GEN_LBL_MANUALMAPPING')));
		  $i = CLX_INIT_ZERO;
			$existmapping=false;
			$all_record=array();
			$all_rule=array();
			while ($record = $page->nextRecord()) {
				$all_record[]=$record; 	
				if ($record['RULE_ID']>0)
					$all_rule[$record['RULE_ID']]=$record['RULE_ID'];
			}
			if (count($all_rule)>0) {
				$Rules = ClxCommon::$db->executequery('SELECT ID RULE_ID,RULE FROM CLX_DB_IMPORT_FIELDS_RULE WHERE ID IN ('. implode(',',$all_rule). ') ');
				while ($record = ClxCommon::$db->getNextRecord($Rules)) {
					$all_rule[$record['RULE_ID']]=$record['RULE'];
				}
			
			}

			$DBIU=new db_import_run();
			$test=0;
			if (!empty($all_record[0])) {
				$this->getFields($importcode,$all_record[0]['IMPORTSHEETS']);
			
				foreach ($all_record as $record) {
					$recordid = $record['ID'];
					$select = new htmlCheckbox('selector_' . $recordid, false);
					$select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');$(\'[name=\\\'sheets_\\\']\').val($(\'#DBIM_sheets\').val());');
					$table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
					$rule=array();
					if ($import_rec['TYPE']!='FRL' &&$import_rec['TYPE']!='FRL2'&&$import_rec['TYPE']!='FRL3') {
						$test= $record['FILE_FIELDNAME'] ;
					}
					if (!empty($record['RULE_ID'])) {
						$rule = json_decode(ClxCommon::$db->getOne('SELECT RULE FROM CLX_DB_IMPORT_FIELDS_RULE WHERE ID= ' . $record['RULE_ID']),true);
					}
					if ($record['TYPE'] === 'FIX' or (($record['START_POSITION']>0 or $record['FIELD_LENGTH']>0) and $typeImport=='FRL')) {
						$source = 'Start: ' . $record['START_POSITION'] . ', length: ' . $record['FIELD_LENGTH'];
						$source2= empty($this->returnFieldsData[0][$test])?'':$DBIU->convertToString($this->returnFieldsData[0][$test],$rule);
					} elseif ($record['TYPE'] === 'IGNR') {
						$source = dict('GEN_LBL_IGNORE');
						$source2='';
					} elseif ($record['TYPE'] === 'FILE') {
						$source = $source = dict('TOOL_DBIC_FIELD').': '  . $record['FILE_FIELDNAME'];
						$source2= empty($this->returnFieldsData[0][$test])?'':$DBIU->convertToString($this->returnFieldsData[0][$test],$rule);
						$existmapping=true;
					} elseif ($record['TYPE'] === 'CALC') {
						$source = dict('GEN_LBL_CONSTANT');
						$source2 =$record['FORMULA'];
					} elseif ($record['TYPE'] === 'FORM') {
						$source = dict('TOOL_DBIC_FORMULA');
						$source2 =$record['FORMULA'];
						if (strlen($source2)>40)
							$source2=substr($source2,0,40)."...";
					}
					$table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, 
					array($record['TABLE_FIELDNAME'],(empty($record['TABLE_FIELDNAME']) || !isset($fields[$record['TABLE_FIELDNAME']])?'':$fields[$record['TABLE_FIELDNAME']]), $source, 
					$source2,$record['MAPPING_MANUAL']? dict('GEN_LBL_YES'):dict('GEN_LBL_NO') ));
					$i++;
				}
			}
			$buttons = '';
		  $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
			$buttons .= setJavaScriptTag('$("[name=\'sheets_\']").val($("#DBIM_sheets").val())'); 
			if ($typeImport<>'FRL'&&$import_rec['TYPE']<>'FRL2'&&$import_rec['TYPE']<>'FRL3') { 	
				if ($existmapping)
					$buttons .= htmlButton::getButton('submit', dict('GEN_LBL_CLEAR'), array('action' => 'CLEAR', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'CLEAR'))->source();
				else
					$buttons .= htmlButton::getButton('submit', dict('GEN_LBL_REMAPPING'), array('action' => 'REMAPPING', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'REMAPPING'))->source();
			}
			
		  if ($this->getAccess()->canModify()) {
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		  }
			//$buttons .="<script>$('.button:nth-child(3)').bind('click',function() {alert(1)})</script>";
			
		  $form->addContents($page->footers($table, $buttons). '<script>$(\'div[id*=\\\'MAPPINGS\\\'] tr:not(:first-child):not(:last-child) td:nth-child(4)\').each(function() {if ($(this).text()!=\''.dict('GEN_LBL_IGNORE').'\')$(\'#DBIM_sheets\').prop( \'disabled\', true )}) </script><script>
			$(\'div[id*=\\\'MAPPINGS\\\'] tr:not(:first-child):not(:last-child) td:nth-child(5)\').each(function() {$(this).css("word-wrap","break-word");$(this).css("word-break","break-all");$(this).css("width","240px");}) </script>'); 
		  return buildPanelInterface(dict('TOOL_DBIC_TITLE_LIST'), 'IMPORT_FIELDS_MAPPINGS_' . $importcode, $form->source(), -1 * CLX_NUM_ONE);
		} else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }
	function get_labelfieldsTable($importcode){
		$records = ClxCommon::$db->executeQuery('SELECT B.FIELDNAME ,D.VALUE FROM CLX_DB_IMPORTS A,CLX_DB_TABLEFIELDS B,CLX_DB_FIELDS C LEFT JOIN CLX_DICTIONARY D ON D.ENTRY=C.FIELDFORMLABEL WHERE A.TABLECODE=B.TABLECODE AND A.IDCODE='.singleQuote($importcode).' AND B.FIELDNAME=C.FIELDNAME AND UPPER(LANGUAGE)='.singleQuote(uppercase(getCurrentLanguage())));
		$label=array();
		while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			$label[$record['FIELDNAME']]=$record['VALUE'];
		}
		return $label;
	}	
    function editForm($ac, $idlist, $record, $msg) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1658;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		UserRequest::$request['ac'] = UserRequest::$post['ac'] =$ac;
		$import_rec = ClxCommon::$db->getRecord('CLX_DB_IMPORTS', 'IDCODE=' . singleQuote($record['DBIC_importcode']));
		$fields=$this->get_labelfieldsTable($record['DBIC_importcode']);
		$record["DBIC_sheets_"]=!empty($record["DBIC_sheets_"])?$record["DBIC_sheets_"] :UserRequest::$request["sheets_"];
		$xpos=strpos($record['DBIC_sheets_'],'(');
		if ($xpos !==false) {
			$this->posSheetname=substr($record['DBIC_sheets_'],$xpos);
			$record['DBIC_sheets_']=substr($record['DBIC_sheets_'],0,$xpos);
		}	
		
		$this->editform = $this->editform_csv;
		$this->editform['panels'][0]['entries'][0]['fields'][0]['sufix_extra']=' ('.( isset($fields[$record['DBIC_table_fieldname'] ]) ?$fields[$record['DBIC_table_fieldname'] ]:'').')';
		if ($import_rec['TYPE'] !== 'FRL' &&$import_rec['TYPE']!=='FRL2'&&$import_rec['TYPE']!=='FRL3') { 
			$this->editform['panels'][1]['entries'][1]['fields'][0] ['prefix_extra']=str_replace('class="columns1"','style="color:#FF0000" class="columns1"', $this->editform['panels'][1]['entries'][1]['fields'][0] ['prefix_extra']);
			$this->editform['panels'][1]['entries'][1]['fields'][2] ['prefix_extra']=str_replace('class="columns1"','style="color:#FF0000" class="columns1"', $this->editform['panels'][1]['entries'][1]['fields'][2] ['prefix_extra']);
			
        }
		
		$this->editform['panels'][1]['entries'][1]['fields'][13]['default']=empty(UserRequest::$post['DBIC_importcode'])?'':UserRequest::$post['DBIC_importcode'];
		
		
		$this->editform['panels'][1]['entries'][1]['fields'][12]['options']=$this->seekOtherSaveRule();
		if (empty(UserRequest::$post['DBIC_other_aplicattions']))
			UserRequest::$post['DBIC_other_aplicattions']='';
		$this->editform['panels'][1]['entries'][1]['fields'][13]['default']=UserRequest::$post['DBIC_other_aplicattions'];
		
        if (UserRequest::$request['ac'] === 'MODIFY') {
		  $this->editform['TITLE'] = 'TOOL_' . $this->code . '_TITLE_MODIFY';
        } else {
		  $this->editform['TITLE'] = 'TOOL_' . $this->code . '_TITLE_CREATE';
        }
		
        $form = new clx_form($this->code, $this->editform);
//		$form->addArgument("sheets_", UserRequest::$request["sheets_"]);
		$form ->other_html='';
		$cadenaRule='initSelect(new Array(';
		for($i=1;$i<9;$i++) {
			if (empty($record['DBIC_rule'][$i-1])) {
				$cadenaRule.=singleQuote('<option value="'.$i.'">'.$i.'-</option>'). ($i!=8 ? ",":"" );
			}	
			else { 
				$record['DBIC_rule'][$i-1]=str_replace(chr(10),'',str_replace(chr(13),'',$record['DBIC_rule'][$i-1]));
				$cadenaRule.=singleQuote('<option value="'.$record['DBIC_rule'][$i-1].'">'.$record['DBIC_rule'][$i-1].'</option>'). ($i!=8 ? ",":"" );
			}
		}
		if ($import_rec['TYPE']=='FRL'&&$import_rec['TYPE']=='FRL2'&&$import_rec['TYPE']=='FRL3') {
			$test=0;
		}
		else if (!empty($record['DBIC_file_fieldname'])){
			$test=trim($record['DBIC_file_fieldname']);
		
		}
		else {
			$notview=array('ID','BATCH_ID','LOG_ID','LINE_OF_LOG_ID','LINE_OF_BATCH_ID','IMPORTSHEETS');
			$test = ClxCommon::$db->getOne('SELECT FILE_FIELDNAME FROM CLX_DB_IMPORT_FIELDS WHERE IMPORTCODE=' . singleQuote($record['DBIC_importcode']) .( (empty($record['DBIC_sheets_']))? ''  : ' AND IMPORTSHEETS='. singleQuote($record['DBIC_sheets_']) ). ' ORDER BY SEQNUM');
			if ($test=='') { ;
				foreach ($this->returnFieldsData[0] as $key=>$data) {
					$test=$key;
					break;
				}
			}
		}
		if(empty($record['DBIC_start_text'])) $record['DBIC_start_text']='';
		if(empty($record['DBIC_end_text'])) $record['DBIC_end_text']='';
		if(empty($record['DBIC_select_text'])) $record['DBIC_select_text']='';
		if(empty($record['DBIC_text_replace'])) $record['DBIC_text_replace']='';
		if(empty($record['DBIC_text_replace_expression']))	$record['DBIC_text_replace_expression']='';
		if(empty($record['DBIC_text_replace_new'])) $record['DBIC_text_replace_new']='';
		if(empty($record['DBIC_text_set'])) $record['DBIC_text_set']='';
		if(empty($record['DBIC_format_text'])) $record['DBIC_format_text']='';
		if(empty($record['DBIC_select_options'])) $record['DBIC_select_options']='';
		if(empty($record['DBIC_other_aplicattions'])) $record['DBIC_other_aplicattions']='';
		if(empty($record['DBIC_rule'])) $record['DBIC_rule']='';
		$DBIU=new db_import_run();
		$test=trim(clx_change_acentos_char_html($test));
			$typeImport=$import_rec['TYPE'];
			IF ($typeImport=='CSV2')
				$typeImport='CSV';
			IF ($typeImport=='FRL2')
				$typeImport='FRL';
			IF ($typeImport=='FRL3')
				$typeImport='FRL';
			IF ($typeImport=='XLS2')
				$typeImport='XLS';
		$form ->other_html.='<input type=\'hidden\' id=\'sheets_\' name=\'sheets_\' value='.  singleQuote($record["DBIC_sheets_"]).'>'.
			setJavaScriptTag(getJavaScriptFilename('DBIC_editform.js'), true). setJavaScriptTag($cadenaRule.'),'.singleQuote($typeImport).',new Array(\''.dict('GEN_LBL_DELETE').'\')  )');
		if (!isset($this->returnFieldsData[0][$test]))
			$this->returnFieldsData[0][$test]='';
		return $form->editForm($ac, $idlist, $record, $msg).$DBIU->convertToString($this->returnFieldsData[0][$test],$record['DBIC_rule'],true);
    }
	function getAvailableFields($field_name, $record) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1659;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $importcode = $record['DBIC_importcode'];
		$DBIU=new db_import_run();
		$xpos=strpos($record['DBIC_sheets_'],'(');
		if ($xpos !==false) {
			$this->posSheetname=substr($record['DBIC_sheets_'],$xpos);
			$record['DBIC_sheets_']=substr($record['DBIC_sheets_'],0,$xpos);
		}	
			
		if (empty($importcode) && !empty($record["DBIC_id"])) {
			$importcode=ClxCommon::$db->getOne('SELECT IMPORTCODE FROM '.$this->tablename. ' WHERE ID=' . $record['DBIC_id']);
		}
		$pop = new HTMLSelect($field_name);
        $fields = ClxCommon::$db->getRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote($importcode) .( (empty($record['DBIC_sheets_']))? ''  : ' AND IMPORTSHEETS='. singleQuote($record['DBIC_sheets_']) ). ' ORDER BY SEQNUM');
		$notview=array('ID','BATCH_ID','LOG_ID','LINE_OF_LOG_ID','LINE_OF_BATCH_ID','IMPORTSHEETS');
		while (($field = ClxCommon::$db->getNextRecord($fields))) {
			if (!in_array($field['FILE_FIELDNAME'],$notview)) {
				$pop->addItem($field['FILE_FIELDNAME'], $field['FILE_FIELDNAME'], ($field['FILE_FIELDNAME'] == $record[$field_name]));
					
			}	
		}
	    return $pop->source();
    }

    function viewFormFill($record) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1660;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        addHistory('mapid', $record['DBIC_id']);
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_DBIM_TITLE_VIEW'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_IMPORTCODE') . ':', $record['DBIC_importcode']);
        $table->addData(dict('GEN_LBL_TABLE_FIELD') . ' (' . dict('GEN_LBL_TARGET') . '):', $record['DBIC_table_fieldname']);
        $table->addData(dict('GEN_LBL_FILE_FIELD') . ' (' . dict('GEN_LBL_SOURCE') . '):', $record['DBIC_file_fieldname']);
        $contents .= $table->source();
        if ($record['DBIC_file_fieldname'] !== 'IGNORE') {
		  $DBIT = &getTool('DBIT');
		  $contents .= $DBIT->makepanel($record['DBIC_id']);
        }
        return $contents;
    }

    function loadToolRecord($recordid) {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1661;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
    	$values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
		if (empty(UserRequest::$post['DBIC_other_aplicattions'])) {
			if (!empty($values['RULE_ID'])) {
				$values2=ClxCommon::$db->getRecord('CLX_DB_IMPORT_FIELDS_RULE', 'ID= ' . $values['RULE_ID']);
				if (is_array($values2))	{ 
					$values = array_merge($values,$values2);
				}
			}
		
		}
		else {
			$values2=ClxCommon::$db->getRecord('CLX_DB_IMPORT_FIELDS_RULE', 'NAME= ' . singleQuote(UserRequest::$post['DBIC_other_aplicattions']));
			$values = array_merge($values,$values2);
			if (is_array($values2) )	{ 
				$values = array_merge($values,$values2);
			}
		}
		$record = array();
		if (empty(UserRequest::$post['DBIC_id'])) {
			$record['DBIC_id'] = $recordid;
			$record['DBIC_table_fieldname'] = empty($record['DBIC_table_fieldname']) ? $values['TABLE_FIELDNAME']:$record['DBIC_table_fieldname'];
			$record['DBIC_table_fieldname'] = $values['TABLE_FIELDNAME'];
			$record['DBIC_type'] = $values['TYPE'];
			if ($values['TYPE'] === 'CALC') {
				$record['DBIC_formula'] = $values['FORMULA'];
				$record['DBIC_formula2'] = '';
			} elseif ($values['TYPE'] === 'FORM') {
				$record['DBIC_formula'] = '';
				$record['DBIC_formula2'] = $values['FORMULA'];
			} else {
				$record['DBIC_formula'] = '';
				$record['DBIC_formula2'] = '';
			}
			$record['DBIC_file_fieldname'] = $values['FILE_FIELDNAME'];
			$record['DBIC_start_position'] = $values['START_POSITION'];
			$record['DBIC_field_length'] = $values['FIELD_LENGTH'];
			$record['DBIC_importcode'] = $values['IMPORTCODE'];
			$record['DBIC_seqnum'] = $values['SEQNUM'];
			$record['DBIC_rule'] = empty($values['RULE'])? '':json_decode($values['RULE'],true);
			$record['DBIC_text_save_name']=empty($values['NAME'])? '':$values['NAME'];
			
        }
		else {
			$record=UserRequest::$post;
			$record['DBIC_importcode'] = $values['IMPORTCODE'];
			$record['DBIC_rule'] = empty($values['RULE'])? '':json_decode($values['RULE'],true);
			$record['DBIC_text_save_name']=empty($values['NAME'])? '':$values['NAME'];
			
			
		}
	
		$this->getFields($values['IMPORTCODE']);
		return $record;
    }

    function saveRecord() {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1662;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
    	$import_rec = ClxCommon::$db->getRecord('CLX_DB_IMPORTS', 'IDCODE=' . singleQuote(UserRequest::$post['DBIC_importcode']));
		$import_mapping_old = ClxCommon::$db->getRecord('CLX_DB_IMPORT_MAPPINGS', ' TABLE_FIELDNAME= '. singleQuote(UserRequest::$post['DBIC_table_fieldname'] ) .' AND IMPORTCODE=' . singleQuote(UserRequest::$post['DBIC_importcode']));
		$record = array();
		if ($import_rec['TYPE']!='FRL'&&$import_rec['TYPE']!='FRL2'&&$import_rec['TYPE']!='FRL3')
			$record['FILE_FIELDNAME'] = UserRequest::$post['DBIC_file_fieldname'];
		else
			$record['FILE_FIELDNAME'] ='';
	
		$combinacion=0;
        if (UserRequest::$post['DBIC_type'] === 'FORM') {
		  $record['FORMULA'] = clx_html_spchrs_decode(UserRequest::$post['DBIC_formula2']);
        } else {
		  $record['FORMULA'] = clx_html_spchrs_decode(UserRequest::$post['DBIC_formula']);
        }
	    $record['MAPPING_MANUAL']=1;
		
        $record['START_POSITION'] = (array_key_exists('DBIC_start_position', UserRequest::$post)) ? UserRequest::$post['DBIC_start_position'] : CLX_CHAR_EMPTY_STRING;
        $record['FIELD_LENGTH'] = (array_key_exists('DBIC_field_length', UserRequest::$post)) ? UserRequest::$post['DBIC_field_length'] : CLX_CHAR_EMPTY_STRING;
        $combinacion=0;
		$record['TYPE'] = UserRequest::$post['DBIC_type'];
		
		if( ($import_rec['TYPE']=='FRL'||$import_rec['TYPE']=='FRL2'||$import_rec['TYPE']=='FRL3')   && $record['TYPE']=='FILE') {
			$record['TYPE'] = 'FIX';
			$matches=preg_split('/(\|,Set1:)|(\|,size:)|(Cut_pos:)/',UserRequest::$post['DBIC_select_options'][0],-1, PREG_SPLIT_DELIM_CAPTURE);
			for ($t=0;$t<count($matches);$t++) {
				switch ($matches[$t]) {	
					case '|,Set1:':
						$set1=$matches[$t+1]; 
						break;
					case '|,size:':
						$record['FIELD_LENGTH']=$matches[$t+1]; $combinacion+=2;
						break;						
					case 'Cut_pos:':
						$record['START_POSITION']=$matches[$t+1];$combinacion+=1;
				}
			}	
		}
		else {
			if (empty($record['START_POSITION']))
				$record['FIELD_LENGTH']='0';
		}
		if (isset(UserRequest::$post['sheets_'])) {
			$record['IMPORTSHEETS']=UserRequest::$post['sheets_'];
		//	$record['POSITION_SHEET']=UserRequest::$post['possheets_'];
		}
		else {
			$record['IMPORTSHEETS']='';
			//$record['POSITION_SHEET']='';
		}		
		$record2=array();
		if (isset(UserRequest::$post['DBIC_select_options'])) {
			$record2['RULE']= json_encode( UserRequest::$post['DBIC_select_options']);
		}
		else {
			$record2['RULE']='';
		}
		$record2['MDATE'] = xFormat::getNow('Y-m-d');
		$extra=0;
		$extra2='.';
			
		if (!empty($record2['NAME']) && !empty($record2['RULE'])) {
			if (ClxCommon::$db->getOne('select count(*) from CLX_DB_IMPORT_FIELDS_RULE WHERE NAME='.singleQuote($record2['NAME'].'  ') )>0) {
				$extra=1;
				while (ClxCommon::$db->getOne('select count(*) from CLX_DB_IMPORT_FIELDS_RULE WHERE NAME='.singleQuote($record2['NAME'].$extra2.$extra))>0) {
					$extra++;
				}	
			}
		}	
		if (empty($import_mapping_old['RULE_ID'])) {
			
			$record2['CDATE'] = $record2['MDATE'];
			$record2['NAME']= (UserRequest::$post['DBIC_text_save_name']!='') ? UserRequest::$post['DBIC_text_save_name']:'GenAuto'.rand(0,9999999999);
			ClxCommon::$db->createRecord('CLX_DB_IMPORT_FIELDS_RULE', $record2, false);
			$IDRULE=ClxCommon::$db->getOne('SELECT MAX(ID) ID FROM CLX_DB_IMPORT_FIELDS_RULE' );
			$record['RULE_ID']=$IDRULE;
		}	
		else {

			if (UserRequest::$post['DBIC_text_save_name']!='') {
				$record2['NAME']= UserRequest::$post['DBIC_text_save_name'];
			}
			ClxCommon::$db->updateRecord('CLX_DB_IMPORT_FIELDS_RULE', $record2, 'ID=' . $import_mapping_old['RULE_ID']);
			
			ClxCommon::$db->updateRecord('CLX_DB_IMPORT_FIELDS_RULE', $record2, 'ID=' . $import_mapping_old['RULE_ID']);
			$record['RULE_ID']=$import_mapping_old['RULE_ID'];
		}
	/*	if (empty($import_mapping_old['RULE_ID'])) {
			$record2['CDATE'] = $record['MDATE'];
			
			ClxCommon::$db->createRecord('CLX_DB_IMPORT_FIELDS_RULE', $record2, false);
			$IDRULE=ClxCommon::$db->getOne('SELECT MAX(ID) ID FROM CLX_DB_IMPORT_FIELDS_RULE' );
			$record['RULE_ID']=$IDRULE;
		
		}
		else {
			
			ClxCommon::$db->updateRecord('CLX_DB_IMPORT_FIELDS_RULE', $record2, 'ID=' . $import_mapping_old['RULE_ID']);
			$record['RULE_ID']=$import_mapping_old['RULE_ID'];
		}*/
		//
		
		ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['DBIC_id']);
			 $this->versionIncrease('ID', UserRequest::$post['DBIC_id']);
		$importcode=ClxCommon::$db->getOne('SELECT IMPORTCODE FROM '.$this->tablename. ' WHERE ID=' . UserRequest::$post['DBIC_id']);
		ClxCommon::$db->executeQuery('update '.$this->tablename. ' set IMPORTSHEETS = '.singleQuote($record['IMPORTSHEETS']). ' where IMPORTCODE ='.singleQuote($importcode)  );
		ClxCommon::$db->commit();
		if(!empty($record2['NAME'])) {
			$entry_code = uppercase('GEN_LBL_RULE_'.$record2['NAME']);
			 if(ClxCommon::$db->getOne('select COUNT(*) X FROM CLX_DICTIONARY WHERE ENTRY='.singleQuote($entry_code))==0) {
				$tempPost=UserRequest::$post;
				$tempRequest=UserRequest::$request;
				UserRequest::$request=UserRequest::$post=array ('to' => 'DICT',  'ac' => 'CREATE',  'confirm' => '1',  'idlist' => '',  'DICT_entry' => $entry_code, 'DICT_en' => $record2['NAME'],  'DICT_es' => $record2['NAME'],  'DICT_es_VE' => '',  'DICT_es_VE_null' => '1',  'DICT_es_PA' => '',  'DICT_es_PA_null' => '1',  'DICT_es_HN' => '',  'DICT_es_HN_null' => '1',  'DICT_es_MX' => '',  'DICT_es_MX_null' => '1',  'DICT_es_NI' => '',  'DICT_es_NI_null' => '1',  'DICT_es_PY' => '',  'DICT_es_PY_null' => '1',  'submit1' => 'Crear',);
				$DICT = &getTool('DICT');
				$DICT->saveRecord();
				ClxCommon::$db->commit();
				UserRequest::$post=$tempPost;
				UserRequest::$request=$tempRequest;
		    }
		}
		
	}

	function getFields($importcode, $importSheet ='') {

		$Import = ClxCommon::$db->getRecord('CLX_DB_IMPORTS', 'IDCODE = ' . singleQuote($importcode));
		if (!isset(UserRequest::$post['sheets_']))
			UserRequest::$post['sheets_']='';
		if (!class_exists('db_import_run'))
		  include_once kPathToWebSite . 'tools/db_import.php';
		$DBIU=new db_import_run();
		$this->returnFieldsData=$DBIU->getFieldsTest($importcode,replace_ascii_chars($Import['RECORD_DELIM']),$Import['FIELD_DELIM'], $Import['FIELD_CDELIM'],empty(UserRequest::$post['sheets_']) ?$importSheet:UserRequest::$post['sheets_']);
	}
		
	function versionIncrease($fieldname, $fieldvalue) {
        $importcode = ClxCommon::$db->getField($this->tablename, 'IMPORTCODE', $fieldname . '=' . singleQuote($fieldvalue));
        $DBIM = &getTool('DBIM');
        $DBIM->versionIncrease('IDCODE', $importcode);
    }


    function remapping() {
		if (!class_exists('db_import_run'))
		  include_once kPathToWebSite . 'tools/db_import.php';
		
		$this->cleanmapping();
		$importcode=UserRequest::$post['importcode'];
		$sheetPage=UserRequest::$post['sheets_'];
		$importrec = ClxCommon::$db->getRecord('CLX_DB_IMPORTS', 'IDCODE=' . singleQuote($importcode));
		$DBIU=new db_import_run();
		
		if ($importrec['TYPE'] === 'CSV'||$importrec['TYPE'] === 'CSV2') {
			$DBIU->readTEXTimportCode($importcode,false);
		
			$file_fields = $DBIU->extractFileFields($importcode, replace_ascii_chars($importrec['RECORD_DELIM']), $importrec['FIELD_DELIM'], $importrec['FIELD_CDELIM'],true, true);
		}
		else if ($importrec['TYPE'] === 'XLS' ||$importrec['TYPE'] === 'XLS2') {
			$DBIU->readFileExcelImportCode($importcode,false);
			list($sheetName,$file_fields) = $DBIU->extractFileFieldsExcel($importcode,$sheetPage,true, true);
		}
		else if ($import_rec['TYPE']==='FRL'||$import_rec['TYPE']==='FRL2'||$import_rec['TYPE']=='FRL3') {
			$DBIU->readTEXTimportCode($importcode,false);	
			$filepath=kPathToWebSite.'import/_'.$record['FILE_DELIM'];				
			$file_fields = array($DBIU->readfixtext($importcode, $record_delim,$importrec['RECORD_DELIM'],$filepath));			
		}
		$DBIU->getFields(UserRequest::$post['importcode'],'','','',UserRequest::$post['sheets_']);

	}
	function cleanmapping() {
		ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . singleQuote(UserRequest::$post['importcode']));

	}
	function seekOtherSaveRule() {
		  if(!ClxCommon::$db->tableExists('CLX_DB_IMPORT_FIELDS_RULE')) {
			 return array(''=>'');
		  }
		$records = ClxCommon::$db->executeQuery('SELECT DISTINCT NAME FROM CLX_DB_IMPORT_FIELDS_RULE WHERE NAME<>'.singleQuote('Generate Auto').' AND SUBSTR(NAME,1,7)<>'.singleQuote('GenAuto'));
		$ruleName=array(''=>'');
		while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			$ruleName[$record['NAME']]='GEN_LBL_RULE_'.$record['NAME'];
		}
		
		return $ruleName;
	}	
	
}
