<?php

/**
 * System messages
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-22 15:45:22 -0400 (ma., 22 ene. 2019) $
 * @version        $Rev: 10496 $
 *
 * CHANGE LOG
 *  Included label
 */
class sys_messages extends clx_tool {

    var $exportform;
    var $importform;
    var $debug;

    function __construct() {
        $this->code = 'SMSG';
        $this->name = 'System Messages Manager';
        $this->system = 'System';
        $this->version = '5.5.0.0';
        $this->debug = false;

        $this->has_access = true;


        $this->tablename = 'CLX_SYS_MESSAGES';
        $this->record_name_singular = 'GEN_SMSG_ENTRY';
        $this->record_name_plural = 'GEN_SMSG_ENTRIES';
        $this->primary_field = 'ENTRY';
        $this->secondary_field = 'LANGUAGE';

        $this->primary_key = array('ENTRY', 'LANGUAGE');
        $this->exportform = array(CLX_CLASS_TITLE => 'TOOL_DICT_TITLE_EXPORT',
		  'panels' => array(
			 array('type' => 'normal',
			     'initial_state' => '1',
			     'entries' => array(
			         array('label' => 'GEN_LBL_FILE',
					   'fields' => array(
						  array('name' => 'filename', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '48', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         )
			     )
			 )
		  )
        );
        $this->importform = array(CLX_CLASS_TITLE => 'TOOL_SMSG_TITLE_IMPORT',
		  'panels' => array(
			 array('type' => 'normal',
			     'initial_state' => '1',
			     'entries' => array(
			         array('label' => 'TOOL_PACK_PROMPT_FILEONSERVER',
					   'fields' => array(
						  array('name' => 'localfile', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '48', 'validations' => array(
								array('type' => 'string', 'required' => '0'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_FILE',
					   'fields' => array(
						  array('name' => 'filename', 'type' => 'file', 'default' => '', 'validations' => array(
								array('type' => 'string', 'required' => '0'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_OPTIONS',
					   'fields' => array(
						  array('name' => 'options', 'type' => CLX_CLASS_LIST, 'default' => '', 'options' => array(
								'NEW' => 'TOOL_DICT_IMPORT_NEW',
								'UPD' => 'TOOL_DICT_UPDATE',
								'REP' => 'TOOL_DICT_REPLACE'
						      )
						  )
					   )
			         )
			     )
			 )
		  )
        );

        $this->quickfilterform = array(
		  CLX_CLASS_TITLE => 'TOOL_PRLO_TITLE_CREATE',
		  'panels' => array(
			 array(
			     'type' => 'normal',
			     'entries' => array(
			         array(
					   'label' => 'GEN_LBL_ENTRY',
					   'fields' => array(
						  array(
						      'name' => 'entry',
						      'type' => 'string',
						      'size' => '',
						      'displaysize' => '35',
						      'default' => ''
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_VALUE',
					   'fields' => array(
						  array(
						      'name' => 'value',
						      'type' => 'string',
						      'size' => '',
						      'displaysize' => '35',
						      'default' => ''
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_LANGUAGE',
					   'fields' => array(
						  array(
						      'name' => 'language',
						      'type' => 'string',
						      'size' => '10',
						      'displaysize' => '10',
						      'default' => ''
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_MDATE',
					   'fields' => array(
						  array(
						      'name' => 'mdate',
						      'type' => 'date',
						      'displaysize' => '35'
						  )
					   )
			         )
			     )
			 )
		  )
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SYSTEM:MENU_SYS_MESSAGES', 'TOOL', $this->code, 'ac=LIST');
        $DBLT = getTool('DBLT');
        if (!$DBLT->listExists('LANG')) {
		  $items = array();
		  $items['en'] = 'GEN_LBL_ENGLISH'; //dict('GEN_LBL_ENGLISH');
		  $items['sp'] = 'GEN_LBL_SPANISH'; //dict('GEN_LBL_SPANISH');
		  $DBLT->createList('LANG', 'Languages', 'These are the languages supported by the system messages', CLX_NUM_ONE, $items);
        }
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['ENTRY'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '', 'index' => array('type' => 'COM', 'indexname' => 'ENTRYLANG', 'fieldname_sec' => 'LANGUAGE'));
        $fields['VALUE'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['LANGUAGE'] = array('type' => 'varchar(10)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['RESOLUTION'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['TABLECODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['ENTRY_VERSION'] = array('type' => 'int(3)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['SOURCE_LANGUAGE'] = array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $fields['TOOL_ENTRY'] = array('type' => 'int(1)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'ENTRY,LANGUAGE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'MyISAM',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

//-- D I C T I O N A R Y
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        if (empty($record['ENTRY_VERSION']))
		  $record['ENTRY_VERSION'] = CLX_INIT_ZERO;
        //print_r($record);
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'ENTRY=' . singleQuote($record['ENTRY']) . ' AND UPPER(LANGUAGE)=' . singleQuote(uppercase($record['LANGUAGE']))) == CLX_NUM_ZERO) {
		  ClxCommon::$db->createRecord($this->tablename, $record, false);
        } else {
		  ClxCommon::$db->updateRecord($this->tablename, $record, 'ENTRY=' . singleQuote($record['ENTRY']) . ' AND UPPER(LANGUAGE)=' . singleQuote(uppercase($record['LANGUAGE'])));
        }
    }

// End method
    function action($ac, $idlist) {
        $contents = '';
        if ($this->getAccess()->canRead()) {
		  $msg = array();
		  $record = array();
		  switch ($ac) {
			 case 'DESCRIBE':
			     $contents = $this->viewDescribe();
			     break;
			 case 'EXPORT':
			     if (isset(UserRequest::$post['confirm'])) {
			         if ($this->checkAnyForm($this->exportform, $msg)) {
					   $this->exportDictRecords();
					   $info = popHistory();
					   $contents .= executeHistory($info);
			         } else {
					   $contents = $this->useAnyForm($this->exportform, $ac, array(), $record, $msg);
			         }
			     } else {
			         $record['SMSG_filename'] = 'packages/SMSG_' . uppercase($_SESSION['user_record']['username']) . date('-Ymd-Hi') . '.xml';
			         $contents = $this->useAnyForm($this->exportform, $ac, array(), $record, $msg);
			     }
			     break;
			 case 'IMPORT':
			     if (isset(UserRequest::$post['confirm'])) {
			         if ($this->checkImportForm($msg)) {
					   $this->importDictRecords();
					   $info = popHistory();
					   $contents .= executeHistory($info);
			         } else {
					   $contents = $this->useAnyForm($this->importform, $ac, array(), $record, $msg);
			         }
			     } else {
			         $contents = $this->useAnyForm($this->importform, $ac, array(), $record, $msg);
			     }
			     break;
			 default:
			     $contents = parent::action($ac, $idlist);
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [SYS_MESSAGES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
         //$t = time('U'); genera un warning
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, $this->code.'List');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = '';
        $sortclause = '';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_7);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SMSG_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_7));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_ENTRY'), dict('GEN_LBL_LANGUAGE'), dict('GEN_LBL_VALUE') . ' / ' . dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_RESOLUTION'), dict('GEN_LBL_MODULE'), dict('GEN_LBL_MDATE')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
		  $recordid = $record['ID'];
		  $select = new htmlCheckbox('selector_' . $recordid, false);
		  $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
		  $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
		  if (!empty($record['TABLECODE'])) {
			 $record['MODULECODE'] .= '.' . $record['TABLECODE'];
		  }
		  if (empty($record['DESCRIPTION'])) {
			 $record['DESCRIPTION'] = dict('GEN_LBL_NODESCRIPTION');
		  }
		  $record['VALUE'] = '<b>' . $record['VALUE'] . '</b>' . '<br><i>' . $record['DESCRIPTION'] . '</i>';
		  $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<b>' . $record['ENTRY'] . '</b>', clx_language_lower_upper($record['LANGUAGE']), $record['VALUE'], $record['RESOLUTION'], $record['MODULECODE'], xFormat::datetime($record['MDATE'])));
		  $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_SYS_MESSAGES')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_EXPORT'), array('action' => 'EXPORT', 'form' => $form->getProp(CLX_PROP_ID), $form->getProp(CLX_PROP_ID, 'ON')))->source();
        if ($this->getAccess()->canDisplay()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_IMPORT'), array('action' => 'IMPORT', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function searchForm() {
        $msg = array();
        $contents = '';
        if (!array_key_exists('DCT_entry', UserRequest::$post))
		  UserRequest::$post['DCT_entry'] = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SMSG_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_ENTRY') . ':', 'DCT_entry', UserRequest::$post['DCT_entry'], CLX_NUM_40, CLX_NUM_40);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
		  $table = new htmlTable(CLX_WIDTH_TWO);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $criteria = '';
		  $lang = getCurrentLanguage();
		  $criteria .= 'LANGUAGE = ' . singleQuote($lang);
		  if (UserRequest::$post['DCT_entry'] <> '') {
			 $criteria .= 'AND ENTRY LIKE ' . singleQuote(UserRequest::$post['DCT_entry'] . '%');
		  }
		  if ($criteria === '') {
			 $table->addCell(dict('GEN_LBL_REQUIRED'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		  } else {
                $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
			 if ($qty == CLX_NUM_ZERO) {
			     $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			 } else {
			     $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			     $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
			     $i = CLX_INIT_ZERO;
			     while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			         $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['ENTRY']) . ');';
			         $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=sys_messages></page><a href=' . singleQuote($js) . '>' . $record['ENTRY'] . '</a>', $record['VALUE']));
			         $i++;
			     }
				 ClxCommon::$db->freeResult( $records );
			 }
		  }
		  $contents .= $table->source();
        }
        return $contents;
    }

    function editForm($ac, $idlist, $record, $msg) {
        $modify = ((UserRequest::$request['ac'] === 'MODIFY') or ( UserRequest::$request['ac'] === 'MODIFY_FAST'));
        $title = ($modify) ? dict('TOOL_SMSG_TITLE_MODIFY') : dict('TOOL_SMSG_TITLE_CREATE');
        $file = (UserRequest::$request['ac'] === 'CREATE_FAST') ? 'pop.php' : 'tool.php';
        $form = new htmlForm(CLX_PROP_ACTION, $file);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument('idlist', toString($idlist));
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!empty($modify)) {
		  $table->addData(dict('GEN_LBL_ENTRY') . ':', $record['SMSG_entry']);
		  $form->addArgument('SMSG_entry', $record['SMSG_entry']);
        } else {
		  $table->addField($msg, dict('GEN_LBL_ENTRY') . ':', 'SMSG_entry', $record['SMSG_entry'], CLX_NUM_40, CLX_NUM_40);
        }
        //$table->addData(dict('GEN_LBL_ISTOOLENTRY') . ':', $istool->source());
        $form->addArgument('SMSG_tool_entry', $record['SMSG_tool_entry']);
        $DBMO = &getTool('DBMO');
        $DBMO->placeChooseModule($msg, dict('GEN_LBL_MODULECODE') . ':', 'SMSG_modulecode', $record['SMSG_modulecode'], $table);
        $DBTB = &getTool('DBTB');
        $DBTB->placeChooseTable($msg, dict('GEN_LBL_TABLECODE') . ':', 'SMSG_tablecode', $record['SMSG_tablecode'], $table);
        $DBLT = &getTool('DBLT');
        $languages = $DBLT->getListAsArray('LANG');
        foreach ($languages as $langcode => $langname) {
			$langcode=clx_language_lower_upper($langcode);
			$langcodeupper=uppercase($langcode);
		  $table->addCell($langname, array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
		  $table->addField($msg, dict('GEN_LBL_MESSAGE') . ':', 'SMSG_' . $langcode, $record['SMSG_' . $langcodeupper], CLX_NUM_50, CLX_NUM_255);
		  $table->addField($msg, dict('GEN_LBL_DESCRIPTION') . ':', 'SMSG_description_' . $langcode, $record['SMSG_description_' . $langcode], CLX_NUM_50, CLX_NUM_255);
		  $table->addField($msg, dict('GEN_LBL_RESOLUTION') . ':', 'SMSG_resolution_' . $langcode, $record['SMSG_resolution_' . $langcode], CLX_NUM_50, CLX_NUM_255);
        }
        $form->addContents($table->source());
        $buttons = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        if (!empty($modify)) {
		  $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => $ac, 'form' => $form->getProp(CLX_PROP_ID)))->source();
        } else {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        }
        if (($ac !== 'CREATE_FAST') and ( $ac !== 'MODIFY_FAST')) {
		  $c = new htmlButtonCancel();
		  $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    function checkForm(&$msg) {
        if (empty($msg))
		  $msg = array();
        $modify = ((UserRequest::$post['ac'] === 'MODIFY') or ( UserRequest::$post['ac'] === 'MODIFY_FAST'));
        if (empty($modify)) {
		  xValidate::required($msg, 'SMSG_entry', UserRequest::$post['SMSG_entry']);
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function useAnyForm($aform, $ac, $idlist, $record, $msg) {
        $form = new clx_form($this->code, $aform);
        return $form->editForm($ac, $idlist, $record, $msg);
    }

    function checkAnyForm($aform, &$msg) {
        $form = new clx_form($this->code, $aform);
        $result = $form->checkForm1(UserRequest::$post['ac'], UserRequest::$post, $msg);
        return $result;
    }

    function checkImportForm(&$msg) {
        if (empty(UserRequest::$post['SMSG_localfile'])) {
		  if (UserRequest::$files['SMSG_filename']['error']) {
			 $msg['SMSG_filename'] = dict('ERR_PACK_FILETOOBIG');
		  }
        } elseif (!file_exists(UserRequest::$post['SMSG_localfile'])) {
		  if (strpos(UserRequest::$post['SMSG_localfile'], 'http') === false) {
			 $msg['SMSG_localfile'] = 'There is no file with this name.';
		  } else {
			 $fd = fopen(UserRequest::$post['SMSG_localfile'], 'r');
			 if (empty($fd)) {
			     $msg['SMSG_localfile'] = 'There is no file with this name.';
			 }
		  }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_ENTRY') . ':', $record['SMSG_entry']);
    }

    function viewFormFill($record) {
        $DBLT = &getTool('DBLT');
        $languages = $DBLT->getListAsArray('LANG');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SMSG_TITLE_VIEW'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_ENTRY') . ':', $record['SMSG_entry']);
        $table->addData(dict('GEN_LBL_MODULE') . ':', $record['SMSG_modulecode']);
        $table->addData(dict('GEN_LBL_TABLECODE') . ':', $record['SMSG_tablecode']);
        foreach ($languages as $langcode => $langname) {
			$langcode=clx_language_lower_upper($langcode);
		  $table->addData($langname . ':', $record['SMSG_' . $langcode]);
		  $table->addData(dict('GEN_LBL_ENTRY') . ':', $record['SMSG_description_' . $langcode]);
		  $table->addData(dict('GEN_LBL_ENTRY') . ':', $record['SMSG_resolution_' . $langcode]);
        }
        return $table->source();
    }

    function viewDescribe() {
        if (!empty(UserRequest::$get['idlist'])) {
		  $record = $this->loadToolRecord(UserRequest::$get['idlist']);
        } else {
		  $record = array();
        }
        return $this->viewFormDescribe($record);
    }

    function viewFormDescribe($record) {
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CLOSE'));
        if (empty($record)) {
		  return note(dict('TOOL_GEN_MSG_FOUNDRECORDS')) . '<br>' . $c->source();
        }
        if (!empty(clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']))) {
		  $lang = clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']);
        } else {
		  $lang = clx_language_lower_upper(kSystemLanguage);
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SMSG_TITLE_DESCRIBE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_ENTRY') . ':', $record['SMSG_entry']);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', $record['SMSG_description_' . $lang]);
        $table->addData(dict('GEN_LBL_RESOLUTION') . ':', $record['SMSG_resolution_' . $lang]);
        return $table->source() . '<br>' . $c->source();
    }

    function filterFormFill($msg, &$table) {
        if (!array_key_exists('SMSG_entry', UserRequest::$post))
		  UserRequest::$post['SMSG_entry'] = '';
        if (!array_key_exists('SMSG_value', UserRequest::$post))
		  UserRequest::$post['SMSG_value'] = '';
        if (!array_key_exists('SMSG_language', UserRequest::$post))
		  UserRequest::$post['SMSG_language'] = '';
        if (!array_key_exists('SMSG_mdate', UserRequest::$post))
		  UserRequest::$post['SMSG_mdate'] = '';
        if (!array_key_exists('SMSG_modulecode', UserRequest::$post))
		  UserRequest::$post['SMSG_modulecode'] = '';
        if (!array_key_exists('SMSG_tablecode', UserRequest::$post))
		  UserRequest::$post['SMSG_tablecode'] = '';
        $table->addField($msg, dict('GEN_LBL_ENTRY') . ':', 'SMSG_entry', UserRequest::$post['SMSG_entry'], CLX_NUM_40, CLX_NUM_40);
        $table->addField($msg, dict('GEN_LBL_VALUE') . ':', 'SMSG_value', UserRequest::$post['SMSG_value'], CLX_NUM_40, CLX_NUM_40);
        $table->addField($msg, dict('GEN_LBL_LANGUAGE') . ':', 'SMSG_language', UserRequest::$post['SMSG_language'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addField($msg, dict('TOOL_SMSG_FILTER_MDATE') . ':', 'SMSG_mdate', UserRequest::$post['SMSG_mdate'], CLX_NUM_32, CLX_NUM_32);
        $DBMO = &getTool('DBMO');
        $DBMO->placeChooseModule($msg, dict('GEN_LBL_MODULECODE') . ':', 'SMSG_modulecode', UserRequest::$post['SMSG_modulecode'], $table);
        $DBTB = &getTool('DBTB');
        $DBTB->placeChooseTable($msg, dict('GEN_LBL_TABLECODE') . ':', 'SMSG_tablecode', UserRequest::$post['SMSG_tablecode'], $table);
        $sort = new HtmlSelect('SMSG_sort');
        $sort->addItem('', '', true);
        $sort->addItem(dict('GEN_LBL_ENTRY'), 'entry', false);
        $sort->addItem(dict('GEN_LBL_VALUE'), 'value', false);
        $sort->addItem(dict('GEN_LBL_LANGUAGE'), 'language', false);
        $sort->addItem(dict('GEN_LBL_MDATE'), 'mdate DESC', false);
        $sort->addItem(dict('GEN_LBL_MODULE'), 'modulecode', false);
        $sort->addItem(dict('GEN_LBL_TABLE'), 'tablecode', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['SMSG_entry'])) {
		  $filter .= $boolean . ' ENTRY LIKE ' . singleQuote(UserRequest::$post['SMSG_entry'] . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SMSG_value'])) {
		  $filter .= $boolean . ' VALUE LIKE ' . singleQuote(clx_change_especial_char_html (UserRequest::$post['SMSG_value']) . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SMSG_language'])) {
		  $filter .= $boolean . ' UPPER(LANGUAGE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SMSG_language']) . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SMSG_mdate'])) {
		  $filter .= $boolean . ' MDATE >= ' . singleQuote(xFormat::date(UserRequest::$post['SMSG_mdate'], 'Y-m-d H:i:s'));
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SMSG_modulecode'])) {
		  $filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SMSG_modulecode']) . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SMSG_tablecode'])) {
		  $filter .= $boolean . ' UPPER(TABLECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SMSG_tablecode']) . '%');
		  $boolean = 'AND';
        }

        $sortby = (array_key_exists('SMSG_sort', UserRequest::$post)) ? UserRequest::$post['SMSG_sort'] : CLX_CHAR_EMPTY_STRING;
        $this->setFilterKeys($filter, $sortby, CLX_NUM_ZERO);
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
   /* function clearfilter() {
        $_SESSION['paging']['SMSGlist']['criteria'] = '';
    }*/

    function loadToolRecord($recordinfo) {
        $DBLT = &getTool('DBLT');
        $languages = $DBLT->getListAsArray('LANG');
        if (is_numeric($recordinfo)) {
		  $entry = ClxCommon::$db->getField($this->tablename, 'ENTRY', 'ID=' . $recordinfo);
        } else {
		  $entry = $recordinfo;
        }
        $record = array();
        $record[$this->code.'_entry'] = $entry;
        $record[$this->code.'_tool_entry'] = CLX_INIT_ZERO;
        $record[$this->code.'_modulecode'] = '';
        $record[$this->code.'_tablecode'] = '';
        foreach ($languages as $language => $name) {
		  $value = ClxCommon::$db->getRecord($this->tablename, 'ENTRY=' . singleQuote($entry) . ' AND UPPER(LANGUAGE)=' . singleQuote(uppercase($language)));
		  if (empty($value)) {
			 $value = ClxCommon::$db->getRecord($this->tablename, 'ENTRY=' . singleQuote($entry) . ' AND UPPER(LANGUAGE)=' . singleQuote(uppercase(kSystemLanguage)));
		  }
		  if (empty($value)) {
			 $record[$this->code.'_' . $language] = clx_html_spchrs_decode($value['VALUE']);
			 $record[$this->code.'_description_' . clx_language_lower_upper($language)] = '';
			 $record[$this->code.'_resolution_' . clx_language_lower_upper($language)] = '';
		  } else {
			 $record[$this->code.'_' . $language] = clx_html_spchrs_decode($value['VALUE']);
			 $record[$this->code.'_description_' . clx_language_lower_upper($language)] = clx_html_spchrs_decode($value['DESCRIPTION']);
			 $record[$this->code.'_resolution_' . clx_language_lower_upper($language)] = clx_html_spchrs_decode($value['RESOLUTION']);
			 $record[$this->code.'_tool_entry'] = $value['TOOL_ENTRY'];
			 $record[$this->code.'_modulecode'] = $value['MODULECODE'];
			 $record[$this->code.'_tablecode'] = $value['TABLECODE'];
		  }
        }
        return $record;
    }

    function saveRecord() {
        $DBLT = &getTool('DBLT');
        $languages = $DBLT->getListAsArray('LANG');
        $entry = UserRequest::$post[$this->code.'_entry'];
        ClxCommon::$db->deleteRecords($this->tablename, 'ENTRY=' . singleQuote($entry));
        $record = array();
        $record['ENTRY'] = $entry;
        $record['MDATE'] = xFormat::getNow('Y-m-d- H:i:s');
        $record['TOOL_ENTRY'] = (!empty(UserRequest::$post[$this->code.'_tool_entry'])) ? CLX_NUM_ONE : CLX_NUM_ZERO;
        $record['ENTRY_VERSION'] = '0';
        $record['MODULECODE'] = UserRequest::$post[$this->code.'_modulecode'];
        $record['TABLECODE'] = UserRequest::$post[$this->code.'_tablecode'];
        foreach ($languages as $language => $name) {
			$language=clx_language_lower_upper($language);
		  $record['LANGUAGE'] = $language;
		  $record['VALUE'] = clx_html_spchrs_decode(UserRequest::$post[$this->code.'_' . $language]);
		  $record['DESCRIPTION'] = clx_html_spchrs_decode(UserRequest::$post[$this->code.'_description_' . $language]);
		  $record['RESOLUTION'] = clx_html_spchrs_decode(UserRequest::$post[$this->code.'_resolution_' . $language]);
		  if (strlen($record['VALUE']) == CLX_NUM_ZERO){
			 $record['VALUE'] = '';
		  }
		  ClxCommon::$db->createRecord($this->tablename, $record, false);
        }

    }

    function createRecord_() {
        $this->saveRecord();
    }

    function deleteRecordSk($id) {
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $DBLT = &getTool('DBLT');
        $languages = $DBLT->getListAsArray('LANG');
        //$maxid = ClxCommon::$db->getOne('SELECT COUNT(DISTINCT ENTRY) FROM ' . $this->tablename);
        $maxid = xFormat::getNow("YmdHis");
        $record = array();
        $record[$this->code.'_entry'] = 'MSG-' . $maxid;
        $record[$this->code.'_tool_entry'] = CLX_INIT_ZERO;
        $record[$this->code.'_modulecode'] = '';
        $record[$this->code.'_tablecode'] = '';
        foreach ($languages as $language => $name) {
			$language=clx_language_lower_upper($language);
		  $record[$this->code.'_' . $language] = '';
		  $record[$this->code.'_description_' . $language] = '';
		  $record[$this->code.'_resolution_' . $language] = '';
        }
        return $record;
    }

    /**
     * Build Tool Lookup field in forms.
     * @param string $name
     * @param string $default
     * @param array $data
     * @param int $display_size
     * @param int $maxlength
     * @return string
     */
    function chooseRecord($name, $default, $data = array(), $display_size = CLX_NUM_32, $maxlength = CLX_NUM_64) {
        $code = $this->code;
        $alt = 'TOOL_' . $code . '_ALT_SEARCH';
        $searchIcon = getSkinIcon('view', 'javascript:openWindow(\'\', \'pop.php?to=$code&ac=SEARCH&target=' . $name . '\', 500, 300,null,'.singlequote($name).','.singlequote( __FILE__ .'_'. __LINE__ ) .');', dict($alt));
        $c = new htmlField($name, $default, null, CLX_NUM_48, CLX_NUM_128);
        return $c->source() . $searchIcon;
    }

    /**
     * Validates if record exists
     * @param string $field_label
     * @param string $field_value
     * @param array $msg
     * @return bool
     */
    function recordExists($field_label, &$field_value, &$msg) {
        return true;
    }

    function entry($entry, $lang) {
		$lang=clx_language_lower_upper($lang);
        $sql = 'SELECT VALUE FROM ' . $this->tablename . ' WHERE ENTRY = ' . singleQuote($entry) . ' AND UPPER(LANGUAGE) IN (' . singleQuote(uppercase($lang)) . ', ' . singleQuote(uppercase(kSystemLanguage)) . ') ORDER BY LANGUAGE DESC';
        $value = ClxCommon::$db->getOne($sql);
        return $value;
    }

    /**
     * Describes tool based on record
     * @param string $primary_field_value
     */
    function describe($primary_field_value) {
        return smsg($primary_field_value);
    }

    protected function clearDictHeap($entry) {
        if ($this->debug) {
		  pre($entry);
        }
    }

}

//End Class
