<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 * @copyright    Alenet, Inc.
 * @package		Clientix.Tool.System
 * @abstract		Process Engine Managers
 * @author       $Author: fsantana $
 * @since        $Date: 2015-09-03 15:14:44 -0400 (Thu, 03 Sep 2015) $
 * @version      $Rev: 6820 $
 *
 * CHANGE LOG
 *  Included label
 */
class sys_notify_logs extends clx_tool {

    var $alert_log_status = array('PEND' => 'GEN_LBL_PENDING', 'SENT' => 'GEN_LBL_SENT', 'ERRO' => 'GEN_LBL_ERROR');

    function __construct() {
        $this->code = 'SYAG';
        $this->name = 'System Notification Log Manager';
        $this->system = 'System';
        $this->version = '5.5.0.0';


        $this->has_access = true;


        $this->tablename = 'CLX_SYS_NOTIFY_LOGS';
        $this->record_name_singular = 'GEN_LBL_SYS_NOTIFY_LOG';
        $this->record_name_plural = 'GEN_LBL_SYS_NOTIFY_LOGS';
        $this->primary_key = array('ID');
        $this->primary_field = 'ID';
        $this->secondary_field = 'SENT_DATI';

        $this->quickfilterform = array(
		  CLX_CLASS_TITLE => 'TOOL_SYAG_TITLE_CREATE',
		  'panels' => array(
			 array(
			     'type' => 'normal',
			     'entries' => array(
			         array(
					   'label' => 'GEN_LBL_SUBJECT',
					   'fields' => array(
						  array('name' => 'subject', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48'
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_FROM_EMAIL',
					   'fields' => array(
						  array('name' => 'from_email', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48'
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_TO_EMAIL',
					   'fields' => array(
						  array('name' => 'to_email', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48'
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_SENT_DATI',
					   'fields' => array(
						  array('name' => 'sent_dati', 'type' => 'dati', 'default' => '', 'size' => '64', 'displaysize' => '48'
						  )
					   )
			         )
			     )
			 )
		  )
        );
        $this->editform = array(
		  CLX_CLASS_TITLE => 'TOOL_SYAG_TITLE_CREATE',
		  'panels' => array(
			 array(
			     'type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_MODULECODE',
					   'fields' => array(
						  array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO',
						      'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'),
								array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_DB_MODULES')
						      )
						  )
					   )
			         ),
			         array('label' => 'GEN_LBL_TOOLCODE',
					   'fields' => array(
						  array('name' => 'toolcode', 'type' => 'lookup', 'default' => '', 'tool' => 'MAGR',
						      'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'),
								array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_TOOLS')
						      )
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_OWNERID',
					   'fields' => array(
						  array('name' => 'ownerid', 'type' => 'lookup', 'default' => '', 'tool' => 'SYAL',
						      'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'),
								array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_SYS_ALERTS')
						      )
						  )
					   )
			         )
			     )
			 ),
			 array(
			     'type' => 'normal',
			     CLX_CLASS_TITLE => 'TOOL_SYAG_EMAIL_OVERVIEW',
			     'entries' => array(
			         array(
					   'label' => 'GEN_LBL_SUBJECT',
					   'fields' => array(
						  array('name' => 'subject', 'type' => 'string')
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_TO_EMAIL',
					   'fields' => array(
						  array('name' => 'to_email', 'type' => 'string')
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_FROM_EMAIL',
					   'fields' => array(
						  array('name' => 'from_email', 'type' => 'string')
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_SENT_DATI',
					   'fields' => array(
						  array('name' => 'sent_dati', 'type' => 'string')
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_MSG_STATUS',
					   'fields' => array(
						  array('name' => 'msg_status', 'type' => 'text')
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_MSG_CONTENTS',
					   'fields' => array(
						  array('name' => 'msg_contents', 'type' => 'text')
					   )
			         )
			     )
			 ),
			 array(
			     'type' => 'normal',
			     CLX_CLASS_TITLE => 'TOOL_SYAG_EMAIL_DETAILS',
			     'entries' => array(
			         array(
					   'label' => 'GEN_LBL_FROM_USER',
					   'fields' => array(
						  array('name' => 'from_user', 'type' => 'lookup', 'default' => '', 'tool' => 'ACUS',
						      'validations' => array(
								array('type' => 'sqlobject', 'required' => '0'),
								array('type' => 'lookup', 'fieldname' => 'username', 'tablename' => 'CLX_AC_USERS')
						      )
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_EMAIL_NOTICE',
					   'fields' => array(
						  array('name' => 'email_notice', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno)
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_EMAIL_COPYFROM',
					   'fields' => array(
						  array('name' => 'email_copyfrom', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno)
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_TASK_NOTICE',
					   'fields' => array(
						  array('name' => 'task_notice', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno)
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_ALERT_NOTICE',
					   'fields' => array(
						  array('name' => 'alert_notice', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yesno)
					   )
			         )
			     )
			 )
		  )
        );
        $this->viewform = $this->editform;
        $this->searchform = $this->editform;
        $this->toollist = array(
		  'name' => $this->tablename,
		  CLX_CLASS_TITLE => $this->record_name_plural,
		  'sortclause' => 'SENT_DATI DESC',
		  'has_modify' => false,
		  'has_create' => false,
		  'has_duplicate' => false,
		  'has_filter' => true,
		  'fields' =>
		  array(
			 array('name' => 'ID', 'type' => 'number', 'label' => 'GEN_LBL_ID'),
			 array('name' => 'OWNERID', 'type' => 'string', 'label' => 'GEN_LBL_OWNERID'),
			 array('name' => 'SUBJECT', 'type' => 'string', 'label' => 'GEN_LBL_SUBJECT'),
			 array('name' => 'FROM_EMAIL', 'type' => 'string', 'label' => 'GEN_LBL_FROM_EMAIL'),
			 array('name' => 'TO_EMAIL', 'type' => 'string', 'label' => 'GEN_LBL_TO_EMAIL'),
			 array('name' => 'MSG_STATUS', 'type' => 'string', 'label' => 'GEN_LBL_MSG_STATUS'),
			 array('name' => 'SENT_DATI', 'type' => 'string', 'label' => 'GEN_LBL_SENT_DATI')
		  )
        );
        $this->toolpanelkeys = array(array('name' => 'TOOLCODE', 'type' => 'string'), array('name' => 'OWNERID', 'type' => 'string'));
        $this->toolpanel = array(
		  'has_modify' => false,
		  'has_create' => false,
		  'has_duplicate' => false,
		  'has_filter' => true,
		  'name' => $this->tablename,
		  CLX_CLASS_TITLE => $this->record_name_plural,
		  'sortclause' => 'SENT_DATI DESC',
		  'fields' =>
		  array(
			 array('name' => 'ID', 'type' => 'number', 'label' => 'GEN_LBL_ID'),
			 array('name' => 'SUBJECT', 'type' => 'string', 'label' => 'GEN_LBL_SUBJECT'),
			 array('name' => 'FROM_EMAIL', 'type' => 'string', 'label' => 'GEN_LBL_FROM_EMAIL'),
			 array('name' => 'TO_EMAIL', 'type' => 'string', 'label' => 'GEN_LBL_TO_EMAIL'),
			 array('name' => 'MSG_STATUS', 'type' => 'string', 'label' => 'GEN_LBL_MSG_STATUS'),
			 array('name' => 'SENT_DATI', 'type' => 'string', 'label' => 'GEN_LBL_SENT_DATI')
		  )
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SYSTEM:SYS_NOTIFY_LOGS', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['TOOLCODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['OWNERID'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['FROM_USER'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['FROM_EMAIL'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['TO_EMAIL'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['TEST'] = array('type' => 'int(1)', 'null' => 'YES', 'properties' => '');
        $fields['MSG_STATUS'] = array('type' => 'varchar(32)', 'null' => 'YES', 'properties' => '');
        $fields['SENT_DATI'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['SENTBY_USER'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['SUBJECT'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $fields['MSG_CONTENTS'] = array('type' => 'text', 'null' => 'YES', 'properties' => '');
        $fields['EMAIL_NOTICE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['EMAIL_COPYFROM'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['TASK_NOTICE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['ALERT_NOTICE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'OWNERID');
        return array('idcode' => $this->code,
		  'idname' => $this->name,
		  'name' => $this->tablename,
		  'type' => 'MyISAM',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function saveLog($record) {
        ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

    function toolArchive() {
        if (!defined('UTIL_ARCHIVE_MODE'))
		  define('UTIL_ARCHIVE_MODE', CLX_NUM_12);
        //Archive
        $sql = 'SELECT * FROM ' . $this->tablename;
        if (UTIL_ARCHIVE_MODE == CLX_NUM_ONE) {
		  $archive_tbl = $this->tablename . '_' . getNow('m') . '_' . getNow('Y');
        } else {
		  $archive_tbl = $this->tablename . '_' . getNow('Y');
        }
        $tableinfo = $this->toolTableStructure();
        unset($tableinfo['fields']['ID']);
        $tableinfo['name'] = $archive_tbl;
        $tableinfo['type'] = 'ARCHIVE';
        $tableinfo['indexes'] = array();
        $structure = ClxCommon::$db->translateTableStructure($tableinfo);
        //Create table if not exists
        if (!ClxCommon::$db->tableExists($structure['name'])) {
		  //Create table if not exists
		  ClxCommon::$db->createTable($structure['name'], $structure['type'], $structure['fields'], $structure['case_sensitive']);
        }
        $comma = '';
        $select = '';
        foreach ($structure['fields'] as $key => $val) {
		  $select .= $comma . $key;
		  $comma = ',';
        }
        //Lock table to archive
        $sql = 'SELECT MAX(ID) FROM ' . $this->tablename;
        $maxid = ClxCommon::$db->getOne($sql);
        if (empty($maxid)) {
		  return;
        }
        //Backup
        $sql = 'INSERT INTO ' . $structure['name'] . '(' . $select . ') SELECT ' . $select . ' FROM ' . $this->tablename . ' WHERE ID <=' . $maxid;
        ClxCommon::$db->executeQuery($sql);
        //Unlock table
        $sql = 'DELETE FROM ' . $this->tablename . ' WHERE ID<=' . $maxid;
        ClxCommon::$db->executeQuery($sql);
        //Restore stats if apply
        ClxCommon::$db->buldStats($this->tablename);
    }

    function toolArchive_batch($parameters) {

        $contenidoHTML = '';
        $DBBK = getToolObject('UTIL', 'DBBK');
        $bkp_time_limit = $DBBK->get_bkp_time_limit();
        UserResponse::setRunTimeLimit($bkp_time_limit * CLX_NUM_TWO * CLX_NUM_60 * CLX_NUM_60);
        $this->toolArchive();
        $sql = 'SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE SUBSTR(TABLE_NAME, 1, ' . (strlen($this->tablename) + CLX_NUM_ONE) . ') = ' . singleQuote(($this->tablename ). '_') . ' AND TABLE_SCHEMA = ' . singleQuote(kDatabaseName);
        $results = ClxCommon::$db->executeQuery($sql);
        $tables = array();
        while (($rec = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE))) {
		  $tables[] = $rec['TABLE_NAME'];
        }
		ClxCommon::$db->freeResult( $results );
        // Verifica su hay archives
        if (count($tables) > CLX_NUM_ZERO) {
		  $parameters['TABLES'] = implode('/', $tables);
		  if (defined('ACAD_ARC_NAME_SUFFIX')) {
			 $archive_name_suffix = ACAD_ARC_NAME_SUFFIX;
		  } else {
			 $archive_name_suffix = '';
		  }
		  if ($archive_name_suffix === '' || $archive_name_suffix === 'null' || is_null($archive_name_suffix)
		  ) {
			 $archive_name_suffix = '';
		  }
		  $parameters['NAME_SUFFIX'] = '_' . $this->tablename . $archive_name_suffix;
		  $parameters['DUMP_OPTIONS'] = '--skip-add-drop-table';
		  $parameters['LBS_OPT_PAR'] = '-ncss 0';
		  $contenidoHTML.= '<br>' .
			     'Calling backup procedure<br>' .
			     'Tables: ' . str_replace('/', ', ', $parameters['TABLES']) . '<br>' .
			     'File name suffix: ' . $parameters['NAME_SUFFIX'] . '<br>';
		  $results = $DBBK->run($parameters);
		  if ($results === '') {
			 $contenidoHTML.= '<br>';
			 foreach ($tables as $key => $val) {
			     $contenidoHTML.= 'Dropping Table: ' . $val . '<br>';
			     $sql = 'DROP TABLE IF EXISTS ' . $val;
			     ClxCommon::$db->executeQuery($sql);
			 }
		  } else {
			 $contenidoHTML.= '<br>ERROR: excecuting backup<br>' . $results . '<br>';
		  }
        }
        echo $contenidoHTML;
    }

}
