<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class us_myinfo extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'USIF';
        $this->name = 'My information editor';
        $this->system = 'User';
        $this->version = '0.4.1.2';

        $this->has_access = true;


        $this->tablename = '';
        $this->record_name_singular = '';
        $this->record_name_plural = '';
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_PERSONAL_INFORMATION:MENU_EDIT_INFORMATION', 'TOOL', $this->code, 'ac=INFORMATION');
        $UIMI->add($this->code, 'MENU_PERSONAL_INFORMATION:MENU_CHANGE_PASSWORD', 'TOOL', $this->code, 'ac=PASSWORD');
    }

    // idlist is an array
    function action($ac, $idlist) {
        $contents = '';
        $msg = array();
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'PASSWORD' :
			     if ($this->getAccess()->canModify()) {
			         if (!empty(UserRequest::$post ['confirm']) && UserRequest::$post ['confirm']) {
					   if ($this->myiPasswordCheckForm($msg)) {
						  $this->myiPasswordSaveRecord();
						  /*
						   * GEN_LBL_INFORMATIONSAVED Your information
						   * have been saved. Su Informaci�n a sido
						   * actualizada.
						   */
						  $contents = note(dict('GEN_LBL_INFORMATIONSAVED'), dict('GEN_LBL_CONTINUE'));
					   } else {
						  $contents = $this->myiPasswordForm(UserRequest::$post, $msg);
					   }
			         } else {
					   $contents = $this->myiPasswordForm(array(), $msg);
			         }
			     } else {
			         $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [US_MYINFO-CAN_MODIFY_1][' . $ac . '] ' . $this->getCode(false));
			     }
			     break;
			 case 'INFORMATION' :
			     if ($this->getAccess()->canModify()) {
			         if (!empty(UserRequest::$post ['confirm']) && UserRequest::$post ['confirm']) {
					   if ($this->myiCheckForm($msg)) {
						  $this->myiSaveRecord();
						  $contents = note(dict('GEN_LBL_INFORMATIONSAVED'), dict('GEN_LBL_CONTINUE'));
					   } else {
						  $contents = $this->myiForm(UserRequest::$post, $msg);
					   }
			         } else {
					   $record = $this->myiLoadRecord();
					   $contents = $this->myiForm($record, $msg);
			         }
			     } else {
			         $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [US_MYINFO-CAN_MODIFY_2][' . $ac . '] ' . $this->getCode(false));
			     }
			     break;
			 default :
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [US_MYINFO-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    // M Y I N F O R M A T I O N
    function myiForm($record, $msg) {
        $title = dict('TOOL_MYIF_MODIFY_INFORMATION');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'INFORMATION');
        $form->addArgument('confirm', '1');
        $form->addArgument('myi_id', $record ['myi_id']);
        $form->addArgument('myi_username', $record ['myi_username']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProp(CLX_PROP_CLASS, CLX_CLASS_FORM);
        $table->addCells(CLX_CLASS_TITLE, array($title, CLX_CHAR_HTML_NBSP));
        $table->addData(dict('GEN_LBL_USERNAME'), $record ['myi_username'], CLX_CLASS_PROMPT, CLX_CLASS_DATA);
        $table->addField($msg, dict('GEN_LBL_FIRSTNAME'), 'myi_firstname', $record ['myi_firstname'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_LASTNAME'), 'myi_lastname', $record ['myi_lastname'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_COMPANY'), 'myi_company', $record ['myi_company'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_POSITION'), 'myi_position', $record ['myi_position'], CLX_NUM_32, CLX_NUM_32);
        $table->addField($msg, dict('GEN_LBL_EMAIL'), 'myi_email', $record ['myi_email'], CLX_NUM_32, CLX_NUM_64);
        $c = new htmlSubmit(dict('GEN_LBL_SAVE'));
        $buttons = $c->source();
        $c = new htmlButtonGoto(dict('GEN_LBL_CANCEL'), 'index.php');
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS, CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN, CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

    function myiCheckForm(&$msg) {
        $msg = array();
        if (empty(UserRequest::$post ['myi_firstname'])) {
		  $msg ['myi_firstname'] = dict('GEN_ERR_FIRSTNAMEREQ');
		  // write a first name.';
        }
        if (empty(UserRequest::$post ['myi_lastname'])) {
		  $msg ['myi_lastname'] = dict('GEN_ERR_LASTNAMEREQ');
		  // write a last name.';
        }
        xValidate::Mail($msg, 'myi_email', UserRequest::$post ['myi_email']);
        return count($msg) == CLX_NUM_ZERO;
    }

    function myiLoadRecord() {
        $record = array();
        $record ['myi_id'] = $_SESSION ['user_record'] [CLX_PROP_ID];
        $record ['myi_username'] = $_SESSION ['user_record'] ['username'];
        $record ['myi_firstname'] = $_SESSION ['user_record'] ['firstname'];
        $record ['myi_lastname'] = $_SESSION ['user_record'] ['lastname'];
        $record ['myi_company'] = $_SESSION ['user_record'] ['company'];
        $record ['myi_position'] = $_SESSION ['user_record'] ['position'];
        $record ['myi_email'] = $_SESSION ['user_record'] ['email'];
        return $record;
    }

    function myiSaveRecord() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record ['FIRSTNAME'] = UserRequest::$post ['myi_firstname'];
        $record ['LASTNAME'] = UserRequest::$post ['myi_lastname'];
        $record ['COMPANY'] = UserRequest::$post ['myi_company'];
        $record ['POSITION'] = UserRequest::$post ['myi_position'];
        $record ['EMAIL'] = UserRequest::$post ['myi_email'];
        $record ['MDATE'] = $d;
        ClxCommon::$db->updateRecord('CLX_AC_USERS', $record, 'ID=' . UserRequest::$post ['myi_id']);
        foreach ($record as $key => $value) {
		  $_SESSION ['user_record'] [lowercase($key)] = $value;
        }
    }

    // M Y P A S S W O R D
    function myiPasswordForm($record, $msg) {
        $title = dict('TOOL_MYIF_MODIFY_PASSWORD');
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server ['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'PASSWORD');
        $form->addArgument('confirm', '1');
        $form->addArgument('myi_id', $_SESSION ['user_record'] [CLX_PROP_ID]);
        if (!empty(UserRequest::$get ['login'])) {
		  addMessage(dict('GEN_LBL_CHANGE_PASS_REQ'));
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCells(CLX_CLASS_TITLE, array($title, CLX_CHAR_HTML_NBSP));
        $table->addData(dict('GEN_LBL_USERNAME'), $_SESSION ['user_record'] ['username']);
        $table->addPassword($msg, dict('GEN_LBL_OLDPASSWORD'), 'myi_password', (!empty($record ['myi_password'])) ? $record ['myi_password'] : '', CLX_NUM_32, CLX_NUM_32);
        $table->addPassword($msg, dict('GEN_LBL_NEWPASSWORD'), 'myi_newpassword', (!empty($record ['myi_newpassword'])) ? $record ['myi_newpassword'] : '', CLX_NUM_32, CLX_NUM_32);
        $table->addPassword($msg, dict('GEN_LBL_PASSCONFIRM'), 'myi_passwordconf', (!empty($record ['myi_passwordconf'])) ? $record ['myi_passwordconf'] : '', CLX_NUM_32, CLX_NUM_32);
        $c = new htmlSubmit(dict('GEN_LBL_SAVE'));
        $buttons = $c->source();
        if (!empty($_SESSION ['SETPASSWORD'])) {
		  $c = new htmlButtonGoto(dict('GEN_LBL_CANCEL'), 'logoff.php');
		  $buttons .= $c->source();
        } else {
		  $c = new htmlButtonGoto(dict('GEN_LBL_CANCEL'), 'index.php');
		  $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS, CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN, CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

    function myiPasswordCheckForm(&$msg) {
        $msg = array();

        $oldpass = ClxCommon::$db->getField('CLX_AC_USERS', 'PASSWORD', 'USERNAME = ' . singleQuote($_SESSION ['user_record'] ['username']));

        if (empty(UserRequest::$post ['myi_password']) || !clx_mcript_verify(UserRequest::$post ['myi_password'], $oldpass)) {
		  $msg ['myi_password'] = dict('GEN_ERR_PASSWORD_INVALID');
        } else {
		  xValidate::password($msg, 'myi_newpassword', UserRequest::$post ['myi_newpassword'], 'myi_passwordconf', UserRequest::$post ['myi_passwordconf']);
		  // Load user parameters required for validation
		  $ACUS = &getTool('ACUS');
		  // Additional password validations
		  xValidate::password_extras($msg, 'myi_newpassword', UserRequest::$post ['myi_newpassword']);
		  // Enforce history
		  $password = clx_mcript(UserRequest::$post ['myi_newpassword']);
		  $action = 'PASSWORD';
		  if (!$ACUS->checkPasswordHistory($_SESSION ['user_record'] [CLX_PROP_ID], $password, $action)) {
			 $msg ['myi_newpassword'] = dict('GEN_ACUS_PASS_ON_HISTORY');
		  }
		  // Validating that password should be at least x number od day to change
		  if (!$ACUS->checkPasswordMinDaysToChange($_SESSION ['user_record'] [CLX_PROP_ID])) {
			 $msg ['myi_newpassword'] = dict('GEN_ACUS_PASS_MIN_CHANGE', ACUS_PWD_MIN_DAYS);
		  }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function myiPasswordSaveRecord() {
        $d = xFormat::getNow();
        $record = array();
        $record ['PASSWORD'] = clx_mcript(UserRequest::$post ['myi_newpassword']);
        // move user password for history
        $usrec = ClxCommon::$db->getRecord('CLX_AC_USERS', 'ID=' . $_SESSION ['user_record'] [CLX_PROP_ID]);
        $record ['PASSWORD01'] = $usrec ['PASSWORD'];
        $record ['PASSWORD02'] = $usrec ['PASSWORD01'];
        $record ['PASSWORD03'] = $usrec ['PASSWORD02'];
        $record ['PASSWORD04'] = $usrec ['PASSWORD03'];
        $record ['PASSWORD05'] = $usrec ['PASSWORD04'];
        $record ['PASSREQCHANGE'] = CLX_INIT_ZERO;
        $record ['PASSLSTCHANGE'] = $d;
        $record ['LOGIN_COUNTER'] = CLX_INIT_ZERO;
        $record ['MDATE'] = $d;
        ClxCommon::$db->updateRecord('CLX_AC_USERS', $record, 'ID=' . $_SESSION ['user_record'] [CLX_PROP_ID]);
        unset($_SESSION ['SETPASSWORD']);
        foreach ($record as $key => $value) {
		  $_SESSION ['user_record'] [lowercase($key)] = $value;
        }
    }

}
