<?php

/**
 *  Oracle uppercase record changed
 */
class utilities extends clx_tool {

    var $loadedUtilities;

    function __construct() {
        $this->code = 'UTIL';
        $this->name = 'Utilities';
        $this->system = 'System';
        $this->version = '0.4.0.0';

        $this->has_access = true;


        $this->tablename = '';
        $this->record_name_singular = 'utility';
        $this->record_name_plural = 'utilities';
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SYSTEM:MENU_UTILITIES', 'TOOL', $this->code, 'ac=LIST');
    }

    // idlist is an array
    function action($ac, $idlist) {
        $contents = '';
        $msg = array();
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'PANEL':
			     $u = getToolObject($this->code, UserRequest::$request['ut']);
			     if ($u->haspanel === true) {
			         if (isset(UserRequest::$request['confirm'])) {
					   if ($u->checkPanel($msg)) {
						  $contents = $u->execute_();
						  if (empty($contents)) {
						      $info = popHistory();
						      $contents = $this->action($info['ac'], (array_key_exists(CLX_PROP_ID, $info)) ? $info[CLX_PROP_ID] : '');
						  }
					   } else {
						  $contents = $u->panel($msg);
					   }
			         } else {
					   $msg = array();
					   $contents = $u->panel($msg);
			         }
			     } else {
			         $contents = $u->execute_();
			         if (empty($contents)) {
					   $info = popHistory();
					   $contents = $this->action($info['ac'], (array_key_exists(CLX_PROP_ID, $info)) ? $info[CLX_PROP_ID] : '');
			         }
			     }
			     break;
			 default:
			     $contents = parent::action($ac, $idlist);
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [UTILITIES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
	ClxFreeReturn($listingcode);	    
        $to = $this->code;
        $t = time();
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', CLX_NUM_ZERO);
        $table = new htmlTable(CLX_WIDTH_THREE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_UTIL_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_THREE));
        $table->addCells(CLX_CLASS_HEADERS, array(CLX_CHAR_HTML_NBSP, dict('GEN_LBL_VERSION'), dict('GEN_LBL_DESCRIPTION')));
        $OBJS = &getTool('OBJS');
        $utilities = $OBJS->objectList($this->code);
        $i = CLX_INIT_ZERO;
        foreach ($utilities as $utilitycode) {
		  $record = $OBJS->getObjectRecord($this->code, $utilitycode);
		  $e = new htmlButtonGoto($record['IDNAME'], $here . '&ac=PANEL&ut=' . $utilitycode);
		  $table->addCell($e->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, 'style' => 'text-align: center'));
		  $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['VERSION'], $record['DESCRIPTION']));
		  $i++;
        }
        return $table->source();
    }

}
