<?php

if (!class_exists('FiloReports')) {
    if (!class_exists('Filo'))
        includeCodeLib('FILO'); // Parent Class
    /**
     * General Code File
     * For more information contact support@alenet.com
     *
     * @author $Author: fsantana $
     * @copyright Alenet, Inc.
     * @since $Date: 2016-10-31 09:02:05 -0400 (Mon, 31 Oct 2016) $
     * @version $Rev: 8861 $
     *
     *          CHANGE LOG
     *           Included svn prop
     *
     */

    class FiloReports extends filo {

        var $contents = '';
        var $send_pdf = false;
        var $date_format = 'Y-m-d';

        function __construct($procParameters = array()) {
            parent::__construct();
            $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
            $this->username = $_SESSION ['user_record'] ['username'];
            $this->now = xFormat::getNow('Y-m-d H:i:s');
            multiTableName($this, array('COLO', 'ACCO', 'GLAC', 'GDVW', 'FILO', 'FICO', 'FIAS', 'GLCP', 'CSDW', 'CSBT', 'JELN', 'JEHD', 'PRAT'));
        }

        /**
         * Returns source code
         */
        function source() {
            return $this->contents;
        }

// End method
        // CARTERA DE INVERSION
        /**
         * Investment Report Prompt
         *
         * @param
         *        	void
         */
        function prompt() {
            // initialization
            $ac = UserRequest::$request ['ac'];
            $to = UserRequest::$request [CLX_PROP_TO];
            $it = UserRequest::$request ['it'];
            $this->contents = '';
            // RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('RTBL_FILO'));
            $record = UserRequest::$post;
            if (!empty($record ['confirm'])) {
                $EDIT->checkForm2($msg, $formrec);
            }
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_DISPLAY'));
            $this->contents .= $form->source();
            if (!empty($record ['confirm']) && empty($msg)) {
                if ($record ['RTBL_BRANCH_prim'] === '')
                    $record ['RTBL_BRANCH'] = '';
                if ($record ['RTBL_CHART_FIELD01_prim'] === '')
                    $record ['RTBL_CHART_FIELD01'] = '';
                $this->rep_filo($record ['RTBL_ASOF_DATE'], $record ['RTBL_DATE_FORMAT'], $record ['RTBL_COMP_CODE'], $record ['RTBL_CHART_FIELD01'], $record ['RTBL_LOAN_CODE'], $record ['RTBL_BRANCH'], $record ['RTBL_SEND_PDF']);
            }
        }

        /**
         * Investment reports - Cartera de inversiones
         *
         * @param string $efftdate
         * @param string $dt_format
         * @param string $comp_code
         * @param bool $send_pdf
         */
        function rep_filo($efftdate, $dt_format, $comp_code, $contract_code, $loan_code, $branch_code, $send_pdf = false) {
            $header = $this->contents;
            $this->contents = '';
            $title = dict('GEN_LBL_CREDIT_PURSE');
            $this->send_pdf = $send_pdf;
            $this->date_format = $dt_format;
            $this->send_pdf = $send_pdf;
	    $sql = 'SELECT DISTINCT PROD.IDCODE, PROD.IDNAME FROM ' . $this->prodname . ' PROD, ' . $this->filoname . ' FILO, ' . $this->ficoname . ' FICO, ' . $this->fiasname . ' FIAS WHERE FICO.IDCODE = FIAS.CONTRACT_CODE AND FILO.PRODUCT_CODE = PROD.IDCODE AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.START_DATE<=' . singleQuote($efftdate) . ' AND FILO.LOAN_STATUS NOT IN (' . singleQuote('PEND') . ') ' . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' ' : '') . ' ' . (($contract_code !== '') ? ' AND FIAS.CONTRACT_CODE = ' . singleQuote($contract_code) : '') . ' ' . (($branch_code !== '') ? ' AND FILO.BRANCH = ' . singleQuote($branch_code) . ' ' : '') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILO.IDCODE = FILOX.IDCODE AND FILOX.CLX_EFFTDATE<=CURDATE()) ';
            $prods = ClxCommon::$db->executeQuery($sql);
            while (($prod = ClxCommon::$db->getNextRecord($prods))) {
                $this->contents .= '<p class=CLX_CLASS_SUBTITLE>' . $prod ['IDNAME'] . ' (' . $prod ['IDCODE'] . ')</p>';
                $this->contents .= '<table class=CLX_CLASS_LIST>';
                $sql = 'SELECT FIAS.LOAN_CODE, FILO.CLX_EFFTDATE, FILO.IDNAME, FICO.CONTRACT_NUMBER, FILO.LOAN_AMT, FILO.START_DATE, ACCO.IDNAME DEBTOR_CODE, FILO.END_DATE, FILO.NO_PAYMENTS, 0 INSTALLMENT_NO, 0 PAYMENT_AMT, 0 PRINCIPAL_PAY, 0 INTEREST_PAY, FILO.FEE_01_AMT, FILO.FEE_02_AMT, FILO.FEE_03_AMT, FILO.FEE_04_AMT, FILO.FEE_05_AMT, FILO.PRINCIPAL_BAL, FILO.LOAN_INTEREST, 0 INSTALLMENT_LATE, 0 LATE_AMOUNT, 0 INTEREST_LATE FROM ' . $this->ficoname . ' FICO, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO, ' . $this->acconame . ' ACCO WHERE FICO.IDCODE = FIAS.CONTRACT_CODE AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.DEBTOR_CODE = ACCO.IDCODE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.START_DATE<=' . singleQuote($efftdate) . ' AND FILO.PRODUCT_CODE = ' . singleQuote($prod ['IDCODE']) . ' AND FILO.LOAN_STATUS NOT IN (' . singleQuote('PEND') . ') ' . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' ' : '') . ' ' . (($contract_code !== '') ? ' AND FIAS.CONTRACT_CODE = ' . singleQuote($contract_code) . ' ' : '') . ' ' . (($branch_code !== '') ? ' AND FILO.BRANCH = ' . singleQuote($branch_code) . ' ' : '') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILO.IDCODE = FILOX.IDCODE AND FILOX.CLX_EFFTDATE<=CURDATE()) ORDER BY FILO.IDCODE';
                $rs = ClxCommon::$db->executeQuery($sql);
                $i = CLX_INIT_ZERO;
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    //Saldos de la couta a la fecha
                    $sql = 'SELECT INSTALLMENT_NO, IFNULL(PAYMENT_AMT, 0) PAYMENT_AMT, IFNULL(PRINCIPAL_PAY, 0) PRINCIPAL_PAY, IFNULL(INTEREST_PAY, 0) INTEREST_PAY FROM ' . $this->filsname . ' WHERE LOAN_CODE = ' . singleQuote($r ['LOAN_CODE']) . ' AND EFFTDATE = ' . singleQuote($r ['CLX_EFFTDATE']) . ' AND PERIOD_START_DATE <= ' . singleQuote($efftdate) . ' AND PERIOD_END_DATE >= ' . singleQuote($efftdate);
                    $r2 = ClxCommon::$db->getOneRecord($sql);
                    if (!empty($r2)) {
                        $r = array_merge($r, $r2);
                    }
                    /* Monto por pagar debe incluir lo vencido y monto pagado toda la historia */
                    $sql = 'SELECT IFNULL(COUNT(INSTALLMENT_NO),0) INSTALLMENT_LATE, IFNULL(SUM(PRINCIPAL_PAY),0) LATE_AMOUNT, IFNULL(SUM(INTEREST_PAY), 0) INTEREST_LATE FROM ' . $this->filsname . ' WHERE LOAN_CODE = ' . singleQuote($r ['LOAN_CODE']) . ' AND EFFTDATE = ' . singleQuote($r ['CLX_EFFTDATE']) . ' AND PERIOD_END_DATE <= ' . singleQuote($efftdate);
                    $r2 = ClxCommon::$db->getOneRecord($sql);
                    $r = array_merge($r, $r2);
                    /* Restando el monto pagado */
                    $sql = 'SELECT IFNULL(SUM((PPAL_PAID_AMT+ ADVANCE_PAID_AMT)),0) EQ_PAID, IFNULL(SUM(INTPAID_AMT), 0) INTPAID FROM ' . $this->filsname . ' WHERE LOAN_CODE = ' . singleQuote($r ['LOAN_CODE']) . ' AND EFFTDATE = ' . singleQuote($r ['CLX_EFFTDATE']) . ' AND PERIOD_START_DATE <= ' . singleQuote($efftdate);
                    $r2 = ClxCommon::$db->getOneRecord($sql);
                    if (!empty($r2)) {
                        $r['LATE_AMOUNT'] -= $r2['EQ_PAID'];
                        $r['INTEREST_LATE'] -= $r2['INTPAID'];
                    }
                    unset($r ['CLX_EFFTDATE'], $r2);
                    if ($i == CLX_NUM_ZERO) {
                        $fees = array('FEE_01_AMT' => '',
                            'FEE_02_AMT' => '',
                            'FEE_03_AMT' => '',
                            'FEE_04_AMT' => '',
                            'FEE_05_AMT' => ''
                        );
                        $sql = 'SELECT DISTINCT GLPF.IDNAME, GLPF.SEQNUM FROM ' . $this->glpfname . ' GLPF, ' . $this->filoname . ' FILO WHERE FILO.PRODUCT_CODE = GLPF.PRODUCT_CODE AND FILO.IDCODE = ' . singleQuote($r ['LOAN_CODE']);
                        $fs = ClxCommon::$db->executeQuery($sql);
                        while (($f = ClxCommon::$db->getNextRecord($fs))) {
                            $fees ['FEE_0' . $f ['SEQNUM'] . '_AMT'] = $f ['IDNAME'];
                        }
                        $this->contents .= '<tr>';
                        $delete_keys = array();
                        foreach ($r as $key => $val) {
                            if (array_key_exists($key, $fees)) {
                                if ($fees [$key] !== '') {
                                    $this->contents .= '<td  class=CLX_CLASS_HEADERS>' . $fees [$key] . '</td>';
                                } else {
                                    $delete_keys [$key] = CLX_NUM_ONE;
                                    unset($r [$key]);
                                }
                            } else {
                                if ($key === 'LOAN_INTEREST') {
                                    $this->contents .= '<td  class=CLX_CLASS_HEADERS>' . dict('GEN_LBL_' . $key) . ' (%)</td>';
                                } else {
                                    $this->contents .= '<td  class=CLX_CLASS_HEADERS>' . dict('GEN_LBL_' . $key) . '</td>';
                                }
                            }
                        }
                        $this->contents .= '</tr>';
                    }
                    // pre($r);
                    $class = ($i % CLX_NUM_TWO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
                    $i ++;
                    foreach ($r as $key => $val) {
                        if (!empty($delete_keys [$key])) {
                            unset($r [$key]);
                        } elseif ($key === 'LOAN_CODE' || $key === 'IDNAME' || $key === 'CONTRACT_NUMBER' || $key === 'DEBTOR_CODE') {
                            // do nothing
                        } elseif ($key === 'START_DATE' || $key === 'END_DATE') {
                            $r [$key] = xFormat::date($val, $this->date_format);
                        } elseif ($key === 'LOAN_INTEREST') {
                            $r [$key] = xFormat::number($val, CLX_NUM_FIVE);
                        } elseif ($key === 'INSTALLMENT_NO' || $key === 'NO_PAYMENTS') {
                            $r [$key] = $val;
                        } else {
                            $r [$key] = xFormat::number($val);
                        }
                    }
                    $this->contents .= '<tr><td  class="' . $class . '">' . implode('</td><td  class="' . $class . '">', $r) . '</td></tr>';
                }
                $this->contents .= '</table><br>';
            } // end while prods
			ClxCommon::$db->freeResult($prods);
			ClxCommon::$db->freeResult($rs);
            $this->contents = $header . '<br>' . dialog($title, CLX_CLASS_PROMPT, $this->contents, '');
        }

// End funcion
        // ESTADO DE CUENTA DE CREDITO - VER print_dialog_credit en
        // FIDU_STATEMENT (FIRE)
        /**
         * Investment Report Prompt
         *
         * @param
         *        	void
         */
        function prompt_stats_report() {
            // initialization
            $ac = UserRequest::$request ['ac'];
            $to = UserRequest::$request [CLX_PROP_TO];
            $it = UserRequest::$request ['it'];
            $this->contents = '';
            // RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('RTBL_CRED_STAT') . '');
            $record = UserRequest::$post;
            if (!empty($record ['confirm'])) {
                $EDIT->checkForm2($msg, $formrec);
            }
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_DISPLAY'));
            $this->contents .= $form->source();
            if (!empty($record ['confirm']) && empty($msg)) {
                // Para ver batchs
                $schedule_title = 'CRED_STAT_' . $record ['RTBL_COMP_CODE'] . '_' . $record ['RTBL_EDATE'];
                // Schedule will redirect if not empty
                $ANRJ = &getTool('ANRJ');
                $ANRJ->setBatchGeneral($schedule_title, 'xls', UserRequest::$post); // Will redirect if  excheduled
                $this->contents = '';
                $this->rep_cred_statistics($record ['RTBL_COMP_CODE'], $record ['RTBL_EDATE'], $record ['RTBL_DATE_FORMAT'], $record ['RTBL_CHART_FIELD01']);
            }
        }

        /**
         *
         * @param unknown_type $listcode
         * @param unknown_type $value
         * @param unknown_type $format
         * @return string
         */
        private function rep_cred_statistics_list_item($listcode, $value, $format = CLX_NUM_TWO) {
            $DBLT = &getTool('DBLT');
            return $this->rep_cred_statistics_decode(trim($DBLT->getListItem($listcode, $value, $format)));
            // $this->rep_cred_statistics_decode(str_replace(CLX_CHAR_NL,'',trim($this->lists[$listcode][$value])));
        }

        /**
         * Set report encoding
         *
         * @param string $value
         * @return string
         */
        private function rep_cred_statistics_decode($value) {
            return decode_string($value);
        }

        /**
         * Credit Statistical Report.
         *
         * @param string $comp_code
         * @param string $edate
         * @param string $dt_format
         * @param string $contract_code
         */
        function rep_cred_statistics($comp_code, $edate, $dt_format, $contract_code = '') {
            //Setting autocommit to true in this report no rollback required for this report
            ClxCommon::$db->setAutocommit(true);
            $pct_dpl_dec = CLX_NUM_ONE; // set the display decimals for pct
            $contents = '';
            $year_sdate = xformat::date($edate, 'Y-01-01');
            $year_edate = xformat::date($edate, 'Y-12-31');
            $month_edate = xformat::date($edate, 'm');
            $yn_edate = xformat::date($edate, 'Y');
            $progname = ClxCommon::$db->getField($this->ficoname, 'IDNAME', 'IDCODE = ' . singleQuote($contract_code));
            $contract_criteria = '';
            if ($contract_code !== '') {
                $contract_criteria = ' AND EXISTS (SELECT FIAS.ID FROM ' . $this->fiasname . ' FIAS WHERE FIAS.LOAN_CODE = FILO.IDCODE AND FIAS.CONTRACT_CODE = ' . singleQuote($contract_code) . ') ';
            }
            multiTableName($this, array('CSCT', 'CSBT', 'CSTT', 'CSRT', 'CSIT', 'COLO', 'GDVW'));
            $showrep = array(CLX_NUM_ONE => CLX_NUM_ONE, CLX_NUM_TWO => CLX_NUM_ONE, CLX_NUM_FIVE => CLX_NUM_ONE, CLX_NUM_SIX => CLX_NUM_ONE);
		$fld_delim = CLX_CHAR_TAB;
            $rec_delim = CLX_CHAR_NL;
            // Init Temporary Tables
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('CSCT'); // Clear tmp CRED_STAT_CRED_TMP
            $DBTB->buildTemporaryTable('CSBT'); // Clear tmp CRED_STAT_BAL_TMP
            $DBTB->buildTemporaryTable('CSTT'); // Clear tmp CRED_STAT_FIAT_TMP
            $DBTB->buildTemporaryTable('CSRT'); // Clear tmp CRED_STAT_REP_TMP
            $DBTB->buildTemporaryTable('CSIT'); // Clear tmp CRED_STAT_FILS_TMP
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->csctname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->csbtname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->csttname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->csrtname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->csitname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            /* LISTADO DE CREDITO A OPERAR *//* SOLO INCLUIR CREDITOS ACTIVOS */
            $sql = 'INSERT INTO CRED_STAT_CRED_TMP (COMP_CODE, LOAN_CODE, EFFTDATE, CURRENCY_CODE, LOAN_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, BRANCH, COUNTRY, STATE, PRODUCT_CODE, START_DATE, LOAN_AMT, PRINCIPAL_BAL, INTEARNED_AMT, INTPAID_AMT, YEAR_NO, BATCH_ID) SELECT FILO.COMP_CODE, FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, FILO.CURRENCY_CODE, FILO.LOAN_STATUS, FILO.PROP_ITEM_CLASS, FILO.PROP_ITEM_TYPE, FILO.BRANCH, IFNULL(COLO.COUNTRY, ' . singleQuote('PA') . ') COUNTRY, IFNULL(COLO.STATE, ' . singleQuote('PA-1') . ') STATE, FILO.PRODUCT_CODE, FILO.START_DATE, FILO.LOAN_AMT, FILO.PRINCIPAL_BAL, FILO.INTEARNED_AMT, FILO.INTPAID_AMT, YEAR(FILO.START_DATE) YEAR_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM CRED_CREDITS FILO LEFT JOIN BASE_COMPANY_LOCATIONS COLO ON FILO.BRANCH = COLO.IDCODE WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.LOAN_STATUS <> ' . singleQuote('PEND') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM CRED_CREDITS FILOX WHERE FILOX.IDCODE= FILO.IDCODE AND FILOX.START_DATE<= ' . singleQuote($edate) . ') AND EXISTS(SELECT PRLT.ID FROM CRED_PROD_PRMTR_TBL PRLT WHERE PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND HAS_STATISTICS = 1) AND FILO.START_DATE <= ' . singleQuote($edate) . ' ' . $contract_criteria;
            ClxCommon::$db->executeQuery($sql);
            /* AND FILO.BRANCH = '501' */
            /* SUMARIZANDO SALDOS DE CREDITO */
            $sql = 'INSERT INTO CRED_STAT_BAL_TMP (LOAN_CODE, START_DATE, GLACCOUNTCODE, IS_INTEREST, PROD_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, STATE, BRANCH, BALANCE_AMT, YEAR_NO, BATCH_ID) SELECT CSCT.LOAN_CODE, CSCT.START_DATE, JELN.GLACCOUNTCODE, 0 IS_INTEREST, CSCT.LOAN_STATUS PROD_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE STATE, CSCT.BRANCH BRANCH, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT, 2012 YEAR_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM GL_JOURNAL_LINES JELN, GL_JOURNAL_HDR JEHD, FIDU_ITEMS FIAS, CRED_STAT_CRED_TMP CSCT WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND FIAS.LOAN_CODE= CSCT.LOAN_CODE AND EXISTS (SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = CSCT.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND PRAT.PROD_STATUS IN (' . singleQuoteArray(array('VIG', 'MOR', 'VEN')) . ')) AND JEHD.EFFTDATE <= ' . singleQuote($edate) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSCT.LOAN_CODE, JELN.GLACCOUNTCODE, CSCT.LOAN_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, CSCT.START_DATE HAVING SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) <> 0';
            ClxCommon::$db->executeQuery($sql);
            /* Monto de interes */
            $sql = 'INSERT INTO CRED_STAT_BAL_TMP (LOAN_CODE, START_DATE, GLACCOUNTCODE, IS_INTEREST, PROD_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, STATE, BRANCH, BALANCE_AMT, YEAR_NO, BATCH_ID) SELECT CSCT.LOAN_CODE, CSCT.START_DATE, JELN.GLACCOUNTCODE, 1 IS_INTEREST, CSCT.LOAN_STATUS PROD_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE STATE, CSCT.BRANCH BRANCH, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT, 2012 YEAR_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM GL_JOURNAL_LINES JELN, GL_JOURNAL_HDR JEHD, FIDU_ITEMS FIAS, CRED_STAT_CRED_TMP CSCT WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND FIAS.LOAN_CODE= CSCT.LOAN_CODE AND EXISTS (SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = CSCT.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.AR_GL_CODE AND PRAT.PROD_STATUS IN (' . singleQuoteArray(array('VIG', 'MOR', 'VEN')) . ')) AND JEHD.EFFTDATE <= ' . singleQuote($edate) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSCT.LOAN_CODE, JELN.GLACCOUNTCODE, CSCT.LOAN_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, CSCT.START_DATE HAVING SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) <> 0';
            ClxCommon::$db->executeQuery($sql);
            /* OPERACIONES DE DESEMBOLSO Y RECUPERACION */
            $sql = 'INSERT INTO CRED_STAT_FIAT_TMP (LOAN_CODE, START_DATE, GLACCOUNTCODE, IS_INTEREST, PROD_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, STATE, BRANCH, REVERSED, TRANSTBL_CODE, BALANCE_AMT, YEAR_NO, BATCH_ID) SELECT CSCT.LOAN_CODE, JEHD.EFFTDATE START_DATE, JELN.GLACCOUNTCODE, 0 IS_INTEREST, CSCT.LOAN_STATUS PROD_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE STATE, CSCT.BRANCH BRANCH, JEHD.REVERSED, JEHD.TRANSTBL_CODE, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT, 2012 YEAR_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM GL_JOURNAL_LINES JELN, GL_JOURNAL_HDR JEHD, FIDU_ITEMS FIAS, CRED_STAT_CRED_TMP CSCT, FIDU_TRANSACTIONS FIAT WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND FIAS.LOAN_CODE= CSCT.LOAN_CODE AND EXISTS (SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = CSCT.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND PRAT.PROD_STATUS IN (' . singleQuoteArray(array('VIG', 'MOR', 'VEN')) . ')) AND FIAT.EFFTDATE >= ' . singleQuote($year_sdate) . ' AND FIAT.EFFTDATE <= ' . singleQuote($edate) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSCT.LOAN_CODE, JELN.GLACCOUNTCODE, CSCT.LOAN_STATUS, JEHD.TRANSTBL_CODE, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, JEHD.EFFTDATE, JEHD.REVERSED HAVING SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) <> 0';
            ClxCommon::$db->executeQuery($sql);
            /* RECUPERACION PORCION DE INTERESES */
            $sql = 'INSERT INTO CRED_STAT_FIAT_TMP (LOAN_CODE, START_DATE, GLACCOUNTCODE, IS_INTEREST, PROD_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, STATE, BRANCH, REVERSED, TRANSTBL_CODE, BALANCE_AMT, YEAR_NO, BATCH_ID) SELECT CSCT.LOAN_CODE, JEHD.EFFTDATE START_DATE, JELN.GLACCOUNTCODE, 1 IS_INTEREST, CSCT.LOAN_STATUS PROD_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE STATE, CSCT.BRANCH BRANCH, JEHD.REVERSED, JEHD.TRANSTBL_CODE, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT, 2012 YEAR_NO, ' . singleQuote($this->batch_id) . '  BATCH_ID FROM GL_JOURNAL_LINES JELN, GL_JOURNAL_HDR JEHD, FIDU_ITEMS FIAS, CRED_STAT_CRED_TMP CSCT, FIDU_TRANSACTIONS FIAT WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND FIAS.LOAN_CODE= CSCT.LOAN_CODE AND EXISTS (SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = CSCT.PRODUCT_CODE AND JELN.GLACCOUNTCODE = PRAT.AR_GL_CODE AND PRAT.PROD_STATUS IN (' . singleQuoteArray(array('VIG', 'MOR', 'VEN')) . ')) AND FIAT.EFFTDATE >= ' . singleQuote($year_sdate) . ' AND FIAT.EFFTDATE <= ' . singleQuote($edate) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSCT.LOAN_CODE, JELN.GLACCOUNTCODE, CSCT.LOAN_STATUS, JEHD.TRANSTBL_CODE, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, JEHD.EFFTDATE, JEHD.REVERSED HAVING SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) <> 0';
            ClxCommon::$db->executeQuery($sql);
            /* CUOTAS VENCIDAS E INFORMACION DE PAGOS */
            $sql = 'INSERT INTO CRED_STAT_FILS_TMP (COMP_CODE, LOAN_CODE, EFFTDATE, LOAN_STATUS, START_DATE, STATE, BRANCH, PROP_ITEM_CLASS, PROP_ITEM_TYPE, BATCH_ID, PRINCIPAL_BAL, INTEARNED_AMT, INTPAID_AMT, LOAN_AMT) SELECT X.COMP_CODE, X.LOAN_CODE, X.EFFTDATE, X.LOAN_STATUS, X.START_DATE, X.STATE, X.BRANCH, X.PROP_ITEM_CLASS, X.PROP_ITEM_TYPE, ' . singleQuote($this->batch_id) . ' BATCH_ID, SUM(FILS.PRINCIPAL_PAY-FILS.PPAL_PAID_AMT) PRINCIPAL_BAL, SUM(FILS.PRINCIPAL_PAY) INTEARNED_AMT, SUM(FILS.PRINCIPAL_PAY) INTPAID_AMT, X.LOAN_AMT LOAN_AMT FROM CRED_STAT_CRED_TMP X, CRED_PAYMNT_SCHEDULES FILS WHERE X.LOAN_CODE = FILS.LOAN_CODE AND X.EFFTDATE = FILS.EFFTDATE AND FILS.PERIOD_END_DATE < ' . singleQuote($edate) . ' AND X.LOAN_STATUS NOT IN (' . singleQuoteArray(array('VIG', 'LIT')) . ') AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY X.COMP_CODE, X.LOAN_CODE, X.EFFTDATE, X.START_DATE, X.LOAN_STATUS, X.STATE, X.BRANCH, X.PROP_ITEM_CLASS, X.PROP_ITEM_TYPE, X.LOAN_AMT';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE CRED_STAT_FILS_TMP SET PRINCIPAL_BAL = 0, INTPAID_AMT = 0 WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /*
              ClxCommon::$db->executeQuery('DROP TABLE IF EXISTS DEBUG_TMP');
              ClxCommon::$db->executeQuery('CREATE TABLE DEBUG_TMP SELECT * FROM CRED_STAT_CRED_TMP');
              ClxCommon::$db->executeQuery('DROP TABLE IF EXISTS DEBUG_TMP2');
              ClxCommon::$db->executeQuery('CREATE TABLE DEBUG_TMP2 SELECT * FROM CRED_STAT_BAL_TMP');
             */
            /* setting loan amount */
            $sql = 'UPDATE CRED_STAT_FILS_TMP Y SET Y.LOAN_AMT = IFNULL((SELECT SUM(FILS.PRINCIPAL_PAY) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = Y.LOAN_CODE AND FILS.EFFTDATE = Y.EFFTDATE),0) WHERE Y.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* set interest paid */
            $sql = 'UPDATE CRED_STAT_FILS_TMP Y SET Y.INTPAID_AMT = IFNULL((SELECT SUM(X.BALANCE_AMT) FROM CRED_STAT_BAL_TMP X WHERE X.LOAN_CODE = Y.LOAN_CODE AND X.IS_INTEREST = 0),0) WHERE Y.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* UPDATING PAID AMOUNT FOR PERIOD BEFORE END DATE */
            $sql = 'UPDATE CRED_STAT_FILS_TMP Y SET Y.PRINCIPAL_BAL = (- 1 *((LOAN_AMT-INTEARNED_AMT)-INTPAID_AMT)) WHERE Y.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'DELETE X.* FROM CRED_STAT_FILS_TMP X WHERE X.PRINCIPAL_BAL <= 0 AND X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'DELETE C.* FROM CRED_STAT_CRED_TMP C WHERE NOT EXISTS(SELECT B.LOAN_CODE FROM CRED_STAT_BAL_TMP B WHERE B.LOAN_CODE = C.LOAN_CODE)';
            ClxCommon::$db->executeQuery($sql);
            // Se coloca como saldo el saldo contable a la fecha y no el saldo
            // del credito de esta forma el reporte sale con saldo segun
            // contabilidad.
            // Limpiando saldos segun registro de credito.
            $sql = 'UPDATE ' . $this->csctname . ' CSCT SET CSCT.PRINCIPAL_BAL = 0, CSCT.INTPAID_AMT = 0, CSCT.INTEARNED_AMT = 0 WHERE CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            // colocando saldo de capital segun contabilidad
            $sql = 'UPDATE ' . $this->csctname . ' CSCT SET CSCT.PRINCIPAL_BAL = IFNULL((SELECT SUM(CSBT.BALANCE_AMT) FROM ' . $this->csbtname . ' CSBT WHERE CSBT.LOAN_CODE = CSCT.LOAN_CODE AND CSBT.IS_INTEREST = 0 AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id) . '),0) WHERE CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            // colocando saldo de intereses segun contabilidad
            $sql = 'UPDATE ' . $this->csctname . ' CSCT SET CSCT.INTEARNED_AMT = IFNULL((SELECT SUM(CSBT.BALANCE_AMT) FROM ' . $this->csbtname . ' CSBT WHERE CSBT.LOAN_CODE = CSCT.LOAN_CODE AND CSBT.IS_INTEREST = 1 AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id) . '),0) WHERE CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* Limpiando reporte */
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->csrtname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
            $sql = 'INSERT INTO ' . $this->csrtname . ' (COMP_CODE, PROP_ITEM_CLASS, PROP_ITEM_TYPE, ACTV_TTL_NO, ACTV_TTL_AMT, ACTV_TTL_PCT, MRS_TTL_NO, MRS_TTL_AMT, MRS_PCT_NO, MRS_PCT_AMT, FRMZLD_NO, FRMZLD_AMT, DSMBLS_NO, DSMBLS_AMT, RCPRCN_CPTL_AMT, RCPRCN_INTRST_AMT, BATCH_ID) SELECT DISTINCT CSCT.COMP_CODE, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, /*CARTERA ACTIVA-ACTIVA_TOTAL*/ 0 ACTV_TTL_NO, 0 ACTV_TTL_AMT, 0 ACTV_TTL_PCT, /*CARTERA ACTIVA-MOROSA*/ 0 MRS_TTL_NO, 0 MRS_TTL_AMT, 0 MRS_PCT_NO, 0 MRS_PCT_AMT, /*FORMALIZADO*/ 0 FRMZLD_NO, 0 FRMZLD_AMT, /*DESEMBOLSO*/ 0 DSMBLS_NO, 0 DSMBLS_AMT, /*RECUPERACION*/ 0 RCPRCN_CPTL_AMT, 0 RCPRCN_INTRST_AMT, CSCT.BATCH_ID FROM ' . $this->csctname . ' CSCT WHERE CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            // Loading Company Locations
            $colonames = array('' => 'No definida');
            $sql = 'SELECT COLO.IDCODE, COLO.IDNAME FROM BASE_COMPANY_LOCATIONS COLO, BASE_REL_COMP_LOCS DYCL WHERE DYCL.COMPLOC_CODE = COLO.IDCODE AND DYCL.COMP_CODE = ' . singleQuote($comp_code);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $colonames [$r ['IDCODE']] = $r ['IDNAME'];
            }
			ClxCommon::$db->freeResult($rs);
            // CALCULANDO CAMPOS DE CARTERA ACTIVA TOTAL
            $sql = 'UPDATE ' . $this->csrtname . ' CSRT SET CSRT.ACTV_TTL_NO = (SELECT COUNT(CSCT.LOAN_CODE) FROM ' . $this->csctname . ' CSCT WHERE CSCT.PROP_ITEM_CLASS = CSRT.PROP_ITEM_CLASS AND CSCT.PROP_ITEM_TYPE = CSRT.PROP_ITEM_TYPE AND CSCT.PRINCIPAL_BAL <> 0 AND CSCT.BATCH_ID = CSRT.BATCH_ID) WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->csrtname . ' CSRT SET CSRT.ACTV_TTL_AMT = IFNULL((SELECT SUM(CSCT.PRINCIPAL_BAL) FROM ' . $this->csctname . ' CSCT WHERE CSCT.PROP_ITEM_CLASS = CSRT.PROP_ITEM_CLASS AND CSCT.PROP_ITEM_TYPE = CSRT.PROP_ITEM_TYPE AND CSCT.BATCH_ID = CSRT.BATCH_ID),0) WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.ACTV_TTL_PCT = ROUND(IFNULL((R.ACTV_TTL_AMT/(SELECT SUM(X.PRINCIPAL_BAL) FROM CRED_STAT_CRED_TMP X WHERE X.BATCH_ID = R.BATCH_ID))*100,0), 3) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM CRED_STAT_FILS_TMP X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* CARTERA ACTIVA MOROSA */
            $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.MRS_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM CRED_STAT_FILS_TMP X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.BATCH_ID = R.BATCH_ID) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* FORMALIZADO NRO Y MONTO */
            $sql = 'UPDATE ' . $this->csrtname . ' CSRT SET CSRT.FRMZLD_NO = IFNULL((SELECT COUNT(CSCT.LOAN_CODE) FROM ' . $this->csctname . ' CSCT WHERE CSCT.PROP_ITEM_CLASS = CSRT.PROP_ITEM_CLASS AND CSCT.PROP_ITEM_TYPE = CSRT.PROP_ITEM_TYPE AND CSCT.START_DATE >= ' . singleQuote($year_sdate) . ' AND CSCT.START_DATE <= ' . singleQuote($edate) . ' AND CSCT.BATCH_ID = CSRT.BATCH_ID),0) WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->csrtname . ' CSRT SET CSRT.FRMZLD_AMT = IFNULL((SELECT SUM(CSCT.LOAN_AMT) FROM ' . $this->csctname . ' CSCT WHERE CSCT.PROP_ITEM_CLASS = CSRT.PROP_ITEM_CLASS AND CSCT.PROP_ITEM_TYPE = CSRT.PROP_ITEM_TYPE AND CSCT.START_DATE >= ' . singleQuote($year_sdate) . ' AND CSCT.START_DATE <= ' . singleQuote($edate) . ' AND CSCT.BATCH_ID = CSRT.BATCH_ID),0) WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* DESEMBOLSO */
            $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.DSMBLS_AMT = IFNULL((SELECT SUM(X.BALANCE_AMT) FROM CRED_STAT_FIAT_TMP X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.IS_INTEREST = 0 AND X.TRANSTBL_CODE IN (' . singleQuoteArray(array('SYS_CRED-DISB', 'CRED_REFREO')) . ') AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* RECUPERACION, PAGOS DE CAPITAL E INTERES */
            /* Recuperacion de capital */
            $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.RCPRCN_CPTL_AMT = -1*IFNULL((SELECT SUM(X.BALANCE_AMT) FROM CRED_STAT_FIAT_TMP X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.IS_INTEREST = 0 AND X.TRANSTBL_CODE =' . singleQuote('SYS_CRED-PYMT') . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* recuperacion de intereses */
            $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.RCPRCN_INTRST_AMT = -1*IFNULL((SELECT SUM(X.BALANCE_AMT) FROM CRED_STAT_FIAT_TMP X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.IS_INTEREST = 1 AND X.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //CUADRO 1 GENERANDO REPORTE POR
            // ACTIVIDAD/RUBRO-----------------------
            // build report
            $month_edate = xformat::date($edate, 'm');
            $yn_edate = xformat::date($edate, 'Y');
            if (!empty($showrep[CLX_NUM_ONE])) {
                /* Title */
                $tbl_width = CLX_NUM_13;
                $contents = 'CUADRO N� 1' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'CARTERA ACTIVA, FORMALIZACIONES, DESEMBOLSOS Y RECUPERACI�N SEGUN ACTIVIDAD / RUBROS' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'CARTERA ACTIVA' . str_repeat($fld_delim, CLX_NUM_7) . 'FORMALIZADO' . str_repeat($fld_delim, CLX_NUM_TWO) . 'DESEMBOLSO' . $fld_delim . 'RECUPERACI�N' . $fld_delim . $rec_delim;
                $contents .= $fld_delim . 'TOTAL' . str_repeat($fld_delim, CLX_NUM_THREE) . 'MOROSA' . str_repeat($fld_delim, CLX_NUM_TWO) . '%' . str_repeat($fld_delim, CLX_NUM_FIVE) . 'CAPITAL' . $fld_delim . 'INTERESES' . $rec_delim;
                $contents .= 'ACTIVIDAD / RUBROS' . $fld_delim . 'N�' . $fld_delim . 'MONTO' . $fld_delim . '%' . $fld_delim . 'N�' . $fld_delim . 'MONTO' . $fld_delim . '% N�' . $fld_delim . '% MONTO' . $fld_delim . 'N�' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $rec_delim;
                $sql = 'SELECT CSRT.PROP_ITEM_CLASS PROP_ITEM_CLASS, CSRT.PROP_ITEM_TYPE PROP_ITEM_TYPE, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.ACTV_TTL_PCT) ACTV_TTL_PCT, SUM(CSRT.MRS_TTL_NO) MRS_TTL_NO, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT, SUM(CSRT.MRS_PCT_NO) MRS_PCT_NO, SUM(CSRT.MRS_PCT_AMT) MRS_PCT_AMT, SUM(CSRT.FRMZLD_NO) FRMZLD_NO, SUM(CSRT.FRMZLD_AMT) FRMZLD_AMT, SUM(CSRT.DSMBLS_AMT) DSMBLS_AMT, SUM(CSRT.RCPRCN_CPTL_AMT) RCPRCN_CPTL_AMT, SUM(CSRT.RCPRCN_INTRST_AMT) RCPRCN_INTRST_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.PROP_ITEM_CLASS, CSRT.PROP_ITEM_TYPE WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $r ['MRS_PCT_NO'] = rounder(($r ['MRS_TTL_NO'] / $r ['ACTV_TTL_NO']) * CLX_NUM_HUNDRED, CLX_NUM_TWO);
                    $r ['MRS_PCT_AMT'] = rounder(($r ['MRS_TTL_AMT'] / $r ['ACTV_TTL_AMT']) * CLX_NUM_HUNDRED, CLX_NUM_TWO);
                    if (empty($r ['PROP_ITEM_TYPE'])) {
                        if (empty($r ['PROP_ITEM_CLASS'])) {
                            $r ['RUBRO'] = 'TOTAL';
                        } else {
                            $r ['RUBRO'] = 'TOTAL ' . $this->rep_cred_statistics_list_item('CPIC', $r ['PROP_ITEM_CLASS'], CLX_NUM_TWO);
                        }
                    } else {
                        $r ['RUBRO'] = '  ' . $this->rep_cred_statistics_list_item('CPIT', $r ['PROP_ITEM_TYPE'], CLX_NUM_TWO);
                    }
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_PCT'], $pct_dpl_dec) . $fld_delim . clx_format_currency($r ['MRS_TTL_NO'], CLX_NUM_ZERO);
                    $contents .= $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_PCT_NO'], $pct_dpl_dec) . $fld_delim . clx_format_currency($r ['MRS_PCT_AMT'], $pct_dpl_dec);
                    $contents .= $fld_delim . clx_format_currency($r ['FRMZLD_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['FRMZLD_AMT'], CLX_NUM_TWO);
                    $contents .= $fld_delim . clx_format_currency($r ['DSMBLS_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['RCPRCN_CPTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['RCPRCN_INTRST_AMT'], CLX_NUM_TWO) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //CUADRO 2 Intereses por Cobrar y Morosidad por
            // Rubro --------------------------------
            if (!empty($showrep[CLX_NUM_TWO])) {
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.PRINCIPAL_BAL <> 0 AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ') WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_AMT = IFNULL((SELECT SUM(X.INTEARNED_AMT-X.INTPAID_AMT) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.INTEARNED_AMT-X.INTPAID_AMT) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.LOAN_STATUS <> ' . singleQuote('VIG') . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                /* Title */
                $tbl_width = CLX_NUM_FIVE;
                $contents .= 'CUADRO N� 2' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'INTERESES POR COBRAR Y MOROSIDAD POR RUBRO' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'INTERESES POR COBRAR' . str_repeat($fld_delim, CLX_NUM_TWO) . 'MOROSIDAD A INTERESES' . str_repeat($fld_delim, CLX_NUM_TWO) . $rec_delim;
                $contents .= 'RUBRO' . $fld_delim . 'OPERACIONES' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . '%' . $rec_delim;
                $sql = 'SELECT CSRT.PROP_ITEM_TYPE RUBRO, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT, SUM(CSRT.MRS_PCT_AMT) MRS_PCT_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.PROP_ITEM_TYPE WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if ($r ['ACTV_TTL_AMT'] == CLX_NUM_ZERO) {
                        $r ['MRS_PCT_AMT'] = CLX_NUM_HUNDRED;
                    } else {
                        $r ['MRS_PCT_AMT'] = ($r ['MRS_TTL_AMT'] / $r ['ACTV_TTL_AMT']) * CLX_NUM_HUNDRED;
                    }
                    if ($r ['RUBRO'] === '') {
                        $r ['RUBRO'] = 'TOTAL';
                    } else {
                        $r ['RUBRO'] = $this->rep_cred_statistics_list_item('CPIT', $r ['RUBRO'], CLX_NUM_TWO);
                    }
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_PCT_AMT'], $pct_dpl_dec) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //Cuadro 3 Morosidad a Capital por Rubro
            if (!empty($showrep[CLX_NUM_THREE])) {
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.PRINCIPAL_BAL <> 0 AND X.BATCH_ID = R.BATCH_ID) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.LOAN_STATUS <> ' . singleQuote('VIG') . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                /* Title */
                $tbl_width = CLX_NUM_FIVE;
                $contents .= 'CUADRO N� 3' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'MOROSIDAD DE CAPITAL RUBRO' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'SALDO DE LA CARTERA' . str_repeat($fld_delim, CLX_NUM_TWO) . 'MOROSIDAD A CAPITAL' . str_repeat($fld_delim, CLX_NUM_TWO) . $rec_delim;
                $contents .= 'RUBRO' . $fld_delim . 'OPERACIONES' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . '%' . $rec_delim;
                $sql = 'SELECT CSRT.PROP_ITEM_TYPE RUBRO, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT, SUM(CSRT.MRS_PCT_AMT) MRS_PCT_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.PROP_ITEM_TYPE WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $r ['MRS_PCT_AMT'] = $r ['MRS_TTL_AMT'] / $r ['ACTV_TTL_AMT'] * CLX_NUM_HUNDRED;
                    if ($r ['RUBRO'] === '') {
                        $r ['RUBRO'] = 'TOTAL';
                    } else {
                        $r ['RUBRO'] = $this->rep_cred_statistics_list_item('CPIT', $r ['RUBRO'], CLX_NUM_TWO);
                    }
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_PCT_AMT'], $pct_dpl_dec) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //CUadro 4 Saldo a Prestamos (Capital e Intereses)
            // por Rubro
            if (!empty($showrep[CLX_NUM_FOUR])) {
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.PRINCIPAL_BAL <> 0 AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ') WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.BATCH_ID = ' . singleQuote($this->batch_id) . '),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.INTEARNED_AMT-X.INTPAID_AMT) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.BATCH_ID = ' . singleQuote($this->batch_id) . '),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                /* Title */
                $tbl_width = CLX_NUM_FOUR;
                $contents .= 'CUADRO N� 4' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'SALDO DE PRESTAMOS (CAPITAL E INTERESES) POR RUBRO' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . $fld_delim . 'SALDOS(MONTO)' . str_repeat($fld_delim, CLX_NUM_TWO) . $rec_delim;
                $contents .= 'RUBRO' . $fld_delim . 'OPERACIONES' . $fld_delim . 'CAPITAL' . $fld_delim . 'INTERESES' . $rec_delim;
                $sql = 'SELECT IFNULL(CSRT.PROP_ITEM_TYPE,' . singleQuote('TOTAL') . ') RUBRO, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.PROP_ITEM_TYPE WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if ($r ['RUBRO'] === 'TOTAL') {
                        $r ['RUBRO'] = 'TOTAL';
                    } else {
                        if ($r ['RUBRO'] === '')
                            $r ['RUBRO'] = '6';
                        $r ['RUBRO'] = $this->rep_cred_statistics_list_item('CPIT', $r ['RUBRO'], CLX_NUM_TWO);
                    }
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //CUADRO 41 Intereses por Cobrar y Morosidad por rubro equivalente al reporte 6 por provincia
            if (CLX_NUM_ONE == CLX_NUM_TWO && !empty($showrep[CLX_NUM_SIX])) { //Se mando a hacer pero luego resulto lo mismo que el cuadro 2
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE  X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.PRINCIPAL_BAL <> 0 AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ') WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_AMT = IFNULL((SELECT SUM(X.INTEARNED_AMT-X.INTPAID_AMT) FROM ' . $this->csctname . ' X WHERE  X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.INTEARNED_AMT-X.INTPAID_AMT) FROM ' . $this->csctname . ' X WHERE X.PROP_ITEM_CLASS = R.PROP_ITEM_CLASS AND X.PROP_ITEM_TYPE = R.PROP_ITEM_TYPE AND X.LOAN_STATUS <> ' . singleQuote('VIG') . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                /* Title */
                $tbl_width = CLX_NUM_FIVE;
                $contents .= 'CUADRO N� 6.1' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'INTERESES POR COBRAR Y MOROSIDAD POR RUBRO' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'INTERESES POR COBRAR' . str_repeat($fld_delim, CLX_NUM_TWO) . 'MOROSIDAD A INTERESES' . str_repeat($fld_delim, CLX_NUM_TWO) . $rec_delim;
                $contents .= 'RUBRO' . $fld_delim . 'OPERACIONES' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . '%' . $rec_delim;
                $sql = 'SELECT IFNULL(CSRT.PROP_ITEM_TYPE,' . singleQuote('TOTAL') . ') RUBRO, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT, SUM(CSRT.MRS_PCT_AMT) MRS_PCT_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.PROP_ITEM_TYPE WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if ($r ['ACTV_TTL_AMT'] == CLX_NUM_ZERO) {
                        $r ['MRS_PCT_AMT'] = CLX_NUM_HUNDRED;
                    } else {
                        $r ['MRS_PCT_AMT'] = ($r ['MRS_TTL_AMT'] / $r ['ACTV_TTL_AMT']) * CLX_NUM_HUNDRED;
                    }
                    $r ['RUBRO'] = 'TOTAL ' . $this->rep_cred_statistics_list_item('CPIT', $r ['RUBRO'], CLX_NUM_TWO);
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_PCT_AMT'], $pct_dpl_dec) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //REPORTES POR
            // PROVINCIA---------------
            //CUADRO 5 GENERANDO REPORTE POR
            // PROVINCIA-----------------------
            if (!empty($showrep[CLX_NUM_FIVE])) {
                /* ACTUALIZANDO LOS SALDOS */
                ClxCommon::$db->executeQuery('DELETE FROM ' . $this->csrtname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
                $sql = 'INSERT INTO ' . $this->csrtname . ' (COMP_CODE, STATE, BRANCH, ACTV_TTL_NO, ACTV_TTL_AMT, ACTV_TTL_PCT, MRS_TTL_NO, MRS_TTL_AMT, MRS_PCT_NO, MRS_PCT_AMT, FRMZLD_NO, FRMZLD_AMT, DSMBLS_NO, DSMBLS_AMT, RCPRCN_CPTL_AMT, RCPRCN_INTRST_AMT, BATCH_ID) SELECT DISTINCT CSCT.COMP_CODE, CSCT.STATE, CSCT.BRANCH, /*CARTERA ACTIVA-ACTIVA_TOTAL*/ 0 ACTV_TTL_NO, 0 ACTV_TTL_AMT, 0 ACTV_TTL_PCT, /*CARTERA ACTIVA-MOROSA*/ 0 MRS_TTL_NO, 0 MRS_TTL_AMT, 0 MRS_PCT_NO, 0 MRS_PCT_AMT, /*FORMALIZADO*/ 0 FRMZLD_NO, 0 FRMZLD_AMT, /*DESEMBOLSO*/ 0 DSMBLS_NO, 0 DSMBLS_AMT, /*RECUPERACION*/ 0 RCPRCN_CPTL_AMT, 0 RCPRCN_INTRST_AMT, CSCT.BATCH_ID FROM ' . $this->csctname . ' CSCT WHERE CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                /* CALCULANDO CAMPOS DE CARTERA ACTIVA TOTAL */
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.PRINCIPAL_BAL <> 0 AND X.BATCH_ID = R.BATCH_ID) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                /* Actualizando cartera activa y porcentaje de cartera activa */
                $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.ACTV_TTL_PCT = ROUND(IFNULL((R.ACTV_TTL_AMT/(SELECT SUM(X.PRINCIPAL_BAL) FROM CRED_STAT_CRED_TMP X WHERE X.BATCH_ID = R.BATCH_ID))*100,0), 3) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM CRED_STAT_FILS_TMP X WHERE X.BATCH_ID = R.BATCH_ID), 0), R.MRS_TTL_AMT = 0 WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                /* CARTERA ACTIVA MOROSA */
                $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.MRS_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM CRED_STAT_FILS_TMP X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.BATCH_ID = R.BATCH_ID) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE CRED_STAT_REP_TMP R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM CRED_STAT_FILS_TMP X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                /* FORMALIZADO NRO Y MONTO */
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.FRMZLD_NO = IFNULL((SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.START_DATE >= ' . singleQuote($year_sdate) . ' AND X.START_DATE <= ' . singleQuote($edate) . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.FRMZLD_AMT = IFNULL((SELECT SUM(X.LOAN_AMT) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.START_DATE >= ' . singleQuote($year_sdate) . ' AND X.START_DATE <= ' . singleQuote($edate) . ' AND X.BATCH_ID= R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                /* DESEMBOLSO */
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.DSMBLS_AMT = IFNULL((SELECT SUM(X.BALANCE_AMT) FROM ' . $this->csttname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.IS_INTEREST = 0 AND X.TRANSTBL_CODE IN (' . singleQuoteArray(array('SYS_CRED-DISB', 'CRED_REFREO')) . ') AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                /* RECUPERACION, PAGOS DE CAPITAL E INTERES */
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.RCPRCN_CPTL_AMT = -1*IFNULL((SELECT SUM(X.BALANCE_AMT) FROM ' . $this->csttname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.IS_INTEREST = 0 AND X.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.RCPRCN_INTRST_AMT = -1*IFNULL((SELECT SUM(X.BALANCE_AMT) FROM ' . $this->csttname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.IS_INTEREST = 1 AND X.TRANSTBL_CODE =' . singleQuote('SYS_CRED-PYMT') . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                /* Title */
                $tbl_width = CLX_NUM_13;
                $contents .= 'CUADRO N� 5' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'CARTERA ACTIVA, FORMALIZACIONES, DESEMBOLSOS Y RECUPERACI�N SEG�N REGIONAL Y SUCURSAL' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'CARTERA ACTIVA' . str_repeat($fld_delim, CLX_NUM_7) . 'FORMALIZADO' . str_repeat($fld_delim, CLX_NUM_TWO) . 'DESEMBOLSO' . $fld_delim . 'RECUPERACI�N' . $fld_delim . $rec_delim;
                $contents .= $fld_delim . 'TOTAL' . str_repeat($fld_delim, CLX_NUM_TWO) . 'MOROSA' . str_repeat($fld_delim, CLX_NUM_THREE) . '%' . str_repeat($fld_delim, CLX_NUM_FIVE) . 'CAPITAL' . $fld_delim . 'INTERESES' . $rec_delim;
                $contents .= 'REGI�N / SUCURSAL' . $fld_delim . 'N�' . $fld_delim . 'MONTO' . $fld_delim . '%' . $fld_delim . 'N�' . $fld_delim . 'MONTO' . $fld_delim . '% N�' . $fld_delim . '% MONTO' . $fld_delim . 'N�' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $rec_delim;
                $sql = 'SELECT CSRT.STATE STATE, CSRT.BRANCH BRANCH, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.ACTV_TTL_PCT) ACTV_TTL_PCT, SUM(CSRT.MRS_TTL_NO) MRS_TTL_NO, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT, SUM(CSRT.MRS_PCT_NO) MRS_PCT_NO, SUM(CSRT.MRS_PCT_AMT) MRS_PCT_AMT, SUM(CSRT.FRMZLD_NO) FRMZLD_NO, SUM(CSRT.FRMZLD_AMT) FRMZLD_AMT, SUM(CSRT.DSMBLS_AMT) DSMBLS_AMT, SUM(CSRT.RCPRCN_CPTL_AMT) RCPRCN_CPTL_AMT, SUM(CSRT.RCPRCN_INTRST_AMT) RCPRCN_INTRST_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.STATE, CSRT.BRANCH WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if ($r ['ACTV_TTL_NO'] == CLX_NUM_ZERO) {
                        $r ['MRS_PCT_NO'] = rounder(CLX_NUM_HUNDRED, CLX_NUM_TWO);
                    } else {
                        $r ['MRS_PCT_NO'] = rounder(($r ['MRS_TTL_NO'] / $r ['ACTV_TTL_NO']) * CLX_NUM_HUNDRED, CLX_NUM_TWO);
                    }
                    if ($r ['ACTV_TTL_AMT'] == CLX_NUM_ZERO) {
                        $r ['MRS_PCT_AMT'] = rounder(CLX_NUM_HUNDRED, CLX_NUM_TWO);
                    } else {
                        $r ['MRS_PCT_AMT'] = rounder(($r ['MRS_TTL_AMT'] / $r ['ACTV_TTL_AMT']) * CLX_NUM_HUNDRED, CLX_NUM_TWO);
                    }
                    if (empty($r ['BRANCH'])) {
                        if (empty($r ['STATE'])) {
                            $r ['RUBRO'] = 'TOTAL';
                        } else {
                            $r ['RUBRO'] = 'TOTAL ' . $this->rep_cred_statistics_list_item('STAT', $r ['STATE'], CLX_NUM_TWO);
                        }
                    } else {
                        $r ['RUBRO'] = '  ' . $this->rep_cred_statistics_decode($colonames [$r ['BRANCH']]);
                    }
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_PCT'], $pct_dpl_dec) . $fld_delim . clx_format_currency($r ['MRS_TTL_NO'], CLX_NUM_ZERO);
                    $contents .= $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_PCT_NO'], $pct_dpl_dec) . $fld_delim . clx_format_currency($r ['MRS_PCT_AMT'], $pct_dpl_dec);
                    $contents .= $fld_delim . clx_format_currency($r ['FRMZLD_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['FRMZLD_AMT'], CLX_NUM_TWO);
                    $contents .= $fld_delim . clx_format_currency($r ['DSMBLS_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['RCPRCN_CPTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['RCPRCN_INTRST_AMT'], CLX_NUM_TWO) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //CUADRO 6 Intereses por Cobrar y Morosidad por
            // Provincia/Region --------------------------------
            if (!empty($showrep[CLX_NUM_SIX])) {
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.PRINCIPAL_BAL <> 0 AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ') WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_AMT = IFNULL((SELECT SUM(X.INTEARNED_AMT-X.INTPAID_AMT) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.INTEARNED_AMT-X.INTPAID_AMT) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.LOAN_STATUS <> ' . singleQuote('VIG') . ' AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                /* Title */
                $tbl_width = CLX_NUM_FIVE;
                $contents .= 'CUADRO N� 6' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'INTERESES POR COBRAR Y MOROSIDAD POR PROVINCIA/REGI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACION' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'INTERESES POR COBRAR' . str_repeat($fld_delim, CLX_NUM_TWO) . 'MOROSIDAD A INTERESES' . str_repeat($fld_delim, CLX_NUM_TWO) . $rec_delim;
                $contents .= 'PROVINCIA' . $fld_delim . 'OPERACIONES' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . '%' . $rec_delim;
                $sql = 'SELECT CSRT.STATE, CSRT.BRANCH BRANCH, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT, SUM(CSRT.MRS_PCT_AMT) MRS_PCT_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.STATE, CSRT.BRANCH WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if ($r ['ACTV_TTL_AMT'] == CLX_NUM_ZERO) {
                        $r ['MRS_PCT_AMT'] = CLX_NUM_HUNDRED;
                    } else {
                        $r ['MRS_PCT_AMT'] = ($r ['MRS_TTL_AMT'] / $r ['ACTV_TTL_AMT']) * CLX_NUM_HUNDRED;
                    }
                    if (empty($r ['BRANCH'])) {
                        if (empty($r ['STATE'])) {
                            $r ['RUBRO'] = 'TOTAL';
                        } else {
                            $r ['RUBRO'] = 'TOTAL ' . $this->rep_cred_statistics_list_item('STAT', $r ['STATE'], CLX_NUM_TWO);
                        }
                    } else {
                        $r ['RUBRO'] = '  ' . $this->rep_cred_statistics_decode($colonames [$r ['BRANCH']]);
                    }
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_PCT_AMT'], $pct_dpl_dec) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //Cuadro 7 Morosidad a Capital por Provincia
            if (!empty($showrep[CLX_NUM_7])) {
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.PRINCIPAL_BAL <> 0 AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ') WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.LOAN_STATUS <> ' . singleQuote('VIG') . ' AND X.BATCH_ID = ' . singleQuote($this->batch_id) . '),0), R.MRS_PCT_AMT = IFNULL((R.MRS_TTL_AMT/R.ACTV_TTL_AMT)*100,0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                /* Title */
                $tbl_width = CLX_NUM_FIVE;
                $contents .= 'CUADRO N� 7' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'MOROSIDAD DE CAPITAL PROVINCIA' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'SALDO DE LA CARTERA' . str_repeat($fld_delim, CLX_NUM_TWO) . 'MOROSIDAD A CAPITAL' . str_repeat($fld_delim, CLX_NUM_TWO) . $rec_delim;
                $contents .= 'PROVINCIA' . $fld_delim . 'OPERACIONES' . $fld_delim . 'MONTO' . $fld_delim . 'MONTO' . $fld_delim . '%' . $rec_delim;
                $sql = 'SELECT CSRT.STATE RUBRO, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT, SUM(CSRT.MRS_PCT_AMT) MRS_PCT_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.STATE WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if ($r ['ACTV_TTL_AMT'] == CLX_NUM_ZERO) {
                        $r ['MRS_PCT_AMT'] = CLX_NUM_HUNDRED;
                    } else {
                        $r ['MRS_PCT_AMT'] = $r ['MRS_TTL_AMT'] / $r ['ACTV_TTL_AMT'] * CLX_NUM_HUNDRED;
                    }
                    if ($r ['RUBRO'] === '') {
                        $r ['RUBRO'] = 'TOTAL';
                    } else {
                        $r ['RUBRO'] = $this->rep_cred_statistics_list_item('STAT', $r ['RUBRO'], CLX_NUM_TWO);
                    }
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_PCT_AMT'], $pct_dpl_dec) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //Cuadro 8 Saldo a Prestamos (Capital e Intereses)
            // por Provincia --------------------------------
            if (!empty($showrep[CLX_NUM_8])) {
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_NO = (SELECT COUNT(X.LOAN_CODE) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.PRINCIPAL_BAL <> 0 AND X.BATCH_ID = R.BATCH_ID) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.ACTV_TTL_AMT = IFNULL((SELECT SUM(X.PRINCIPAL_BAL) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $sql = 'UPDATE ' . $this->csrtname . ' R SET R.MRS_TTL_AMT = IFNULL((SELECT SUM(X.INTEARNED_AMT-X.INTPAID_AMT) FROM ' . $this->csctname . ' X WHERE X.STATE = R.STATE AND X.BRANCH = R.BRANCH AND X.BATCH_ID = R.BATCH_ID),0) WHERE R.BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                /* Title */
                $tbl_width = CLX_NUM_FOUR;
                $contents .= 'CUADRO N� 8' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'SALDO DE PRESTAMOS (CAPITAL E INTERESES) POR PROVINCIA' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . $fld_delim . 'SALDOS(MONTO)' . str_repeat($fld_delim, CLX_NUM_TWO) . $rec_delim;
                $contents .= 'PROVINCIA' . $fld_delim . 'OPERACIONES' . $fld_delim . 'CAPITAL' . $fld_delim . 'INTERESES' . $rec_delim;
                $sql = 'SELECT IFNULL(CSRT.STATE,' . singleQuote('TOTAL') . ') RUBRO, SUM(CSRT.ACTV_TTL_NO) ACTV_TTL_NO, SUM(CSRT.ACTV_TTL_AMT) ACTV_TTL_AMT, SUM(CSRT.MRS_TTL_AMT) MRS_TTL_AMT FROM ' . $this->csrtname . ' CSRT WHERE CSRT.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSRT.STATE WITH ROLLUP';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if ($r ['RUBRO'] === 'TOTAL') {
                        $r ['RUBRO'] = 'TOTAL';
                    } else {
                        if ($r ['RUBRO'] === '')
                            $r ['RUBRO'] = '6';
                        $r ['RUBRO'] = $this->rep_cred_statistics_list_item('STAT', $r ['RUBRO'], CLX_NUM_TWO);
                    }
                    $contents .= uppercase($r ['RUBRO']) . $fld_delim . clx_format_currency($r ['ACTV_TTL_NO'], CLX_NUM_ZERO) . $fld_delim . clx_format_currency($r ['ACTV_TTL_AMT'], CLX_NUM_TWO) . $fld_delim . clx_format_currency($r ['MRS_TTL_AMT'], CLX_NUM_TWO) . $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
            }
            //Seccion por a�o sumarizando
            // reporte----------------------
            if (!empty($showrep[CLX_NUM_NINE]) || !empty($showrep[CLX_NUM_TEN]) || !empty($showrep[CLX_NUM_11]) || !empty($showrep[CLX_NUM_12]) || !empty($showrep[CLX_NUM_13]) || !empty($showrep[CLX_NUM_14]) || !empty($showrep[CLX_NUM_15])) {
                // Sumarizando saldos por anio
                // SUMARIZANDO SALDOS Y OPERACIONES DE CREDITO
                $sql = 'DELETE FROM ' . $this->csbtname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
                /* Saldos de credito */
                $sql = 'INSERT INTO ' . $this->csbtname . ' (LOAN_CODE, START_DATE, GLACCOUNTCODE, IS_INTEREST, PROD_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, STATE, BRANCH, REVERSED, TRANSTBL_CODE, BALANCE_AMT, YEAR_NO, BATCH_ID) SELECT CSCT.LOAN_CODE, CSCT.START_DATE, GDVW.GLACCOUNTCODE, 0 IS_INTEREST, CSCT.LOAN_STATUS PROD_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, GDVW.REVERSED, ' . singleQuote('BALANCE') . ' TRANSTBL_CODE, SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) BALANCE_AMT, YEAR(GDVW.EFFTDATE) YEAR_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS, ' . $this->csctname . ' CSCT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE= CSCT.LOAN_CODE AND GDVW.EFFTDATE <= ' . singleQuote($edate) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND EXISTS (SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = CSCT.PRODUCT_CODE AND PRAT.PRO_GL_CODE = GDVW.GLACCOUNTCODE) GROUP BY CSCT.LOAN_CODE, GDVW.GLACCOUNTCODE, CSCT.LOAN_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, CSCT.START_DATE, GDVW.REVERSED, YEAR(GDVW.EFFTDATE) HAVING SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) <> 0';
                ClxCommon::$db->executeQuery($sql);
                $sql = 'INSERT INTO ' . $this->csbtname . ' (LOAN_CODE, START_DATE, GLACCOUNTCODE, IS_INTEREST, PROD_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, STATE, BRANCH, REVERSED, TRANSTBL_CODE, BALANCE_AMT, YEAR_NO, BATCH_ID) SELECT CSCT.LOAN_CODE, CSCT.START_DATE, GDVW.GLACCOUNTCODE, 1 IS_INTEREST, CSCT.LOAN_STATUS PROD_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, GDVW.REVERSED, ' . singleQuote('BALANCE') . ' TRANSTBL_CODE, SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) BALANCE_AMT, YEAR(GDVW.EFFTDATE) YEAR_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS, ' . $this->csctname . ' CSCT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE= CSCT.LOAN_CODE AND GDVW.EFFTDATE <= ' . singleQuote($edate) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND EXISTS (SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = CSCT.PRODUCT_CODE AND PRAT.AR_GL_CODE = GDVW.GLACCOUNTCODE) GROUP BY CSCT.LOAN_CODE, GDVW.GLACCOUNTCODE, CSCT.LOAN_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, CSCT.START_DATE, GDVW.REVERSED, YEAR(GDVW.EFFTDATE) HAVING SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) <> 0';
                ClxCommon::$db->executeQuery($sql);
                /* Agregando montos por transacciones */
                $sql = 'INSERT INTO ' . $this->csbtname . ' (LOAN_CODE, START_DATE, GLACCOUNTCODE, IS_INTEREST, PROD_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, STATE, BRANCH, REVERSED, TRANSTBL_CODE, BALANCE_AMT, YEAR_NO, BATCH_ID) SELECT CSCT.LOAN_CODE, CSCT.START_DATE, GDVW.GLACCOUNTCODE, 0 IS_INTEREST, CSCT.LOAN_STATUS PROD_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, GDVW.REVERSED, GDVW.TRANSTBL_CODE, SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) BALANCE_AMT, YEAR(GDVW.EFFTDATE) YEAR_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS, ' . $this->csctname . ' CSCT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE= CSCT.LOAN_CODE AND GDVW.EFFTDATE >= ' . singleQuote($year_sdate) . ' AND GDVW.EFFTDATE <= ' . singleQuote($year_edate) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND EXISTS (SELECT FIAT.ID FROM ' . $this->fiatname . ' FIAT WHERE FIAT.IDCODE = GDVW.TRANS_CODE) AND EXISTS (SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = CSCT.PRODUCT_CODE AND PRAT.PRO_GL_CODE = GDVW.GLACCOUNTCODE) GROUP BY CSCT.LOAN_CODE, GDVW.GLACCOUNTCODE, CSCT.LOAN_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, CSCT.START_DATE, GDVW.REVERSED, GDVW.TRANSTBL_CODE, YEAR(GDVW.EFFTDATE) HAVING SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) <> 0';
                ClxCommon::$db->executeQuery($sql);
                $sql = 'INSERT INTO ' . $this->csbtname . ' (LOAN_CODE, START_DATE, GLACCOUNTCODE, IS_INTEREST, PROD_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, STATE, BRANCH, REVERSED, TRANSTBL_CODE, BALANCE_AMT, YEAR_NO, BATCH_ID) SELECT DISTINCT CSCT.LOAN_CODE, CSCT.START_DATE, GDVW.GLACCOUNTCODE, 1 IS_INTEREST, CSCT.LOAN_STATUS PROD_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, GDVW.REVERSED, GDVW.TRANSTBL_CODE, SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) BALANCE_AMT, YEAR(GDVW.EFFTDATE) YEAR_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS, ' . $this->csctname . ' CSCT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE= CSCT.LOAN_CODE AND GDVW.EFFTDATE >= ' . singleQuote($year_sdate) . ' AND GDVW.EFFTDATE <= ' . singleQuote($year_edate) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND EXISTS (SELECT FIAT.ID FROM ' . $this->fiatname . ' FIAT WHERE FIAT.IDCODE = GDVW.TRANS_CODE) AND EXISTS (SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = CSCT.PRODUCT_CODE AND PRAT.AR_GL_CODE = GDVW.GLACCOUNTCODE) GROUP BY CSCT.LOAN_CODE, GDVW.GLACCOUNTCODE, CSCT.LOAN_STATUS, CSCT.PROP_ITEM_CLASS, CSCT.PROP_ITEM_TYPE, CSCT.STATE, CSCT.BRANCH, CSCT.START_DATE, GDVW.REVERSED, GDVW.TRANSTBL_CODE, YEAR(GDVW.EFFTDATE) HAVING SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) <> 0';
                ClxCommon::$db->executeQuery($sql);
            }
            //Cuadro 9 Cartera de Prestamos por Provincia/Regi�n
            // y A�o---------------------------------------
            if (!empty($showrep[CLX_NUM_NINE])) {
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                $syear = CLX_NUM_2001;
                $eyear = xFormat::date($edate, 'Y');
                // Title
                $years = array();
                $totals = array();
                for ($i = $syear; $i <= $eyear; $i ++) {
                    $years [] = $i;
                    $totals [$i] = CLX_INIT_ZERO;
                }
                $tbl_width = count($years) + CLX_NUM_ONE;
                $contents .= 'CUADRO N� 9' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'CARTERA DE PRESTAMOS SEG�N PROVINCIA Y A�O' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'SALDOS(MONTO)' . str_repeat($fld_delim, ($tbl_width - CLX_NUM_TWO)) . $rec_delim;
                $contents .= 'PROVINCIA' . $fld_delim;
                foreach ($years as $k => $v) {
                    $contents .= $v . $fld_delim;
                }
                $contents .= $rec_delim;
                $sql = 'SELECT DISTINCT CSBT.STATE RUBRO FROM ' . $this->csbtname . ' CSBT WHERE CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $rubro = $r ['RUBRO'];
                    if ($r ['RUBRO'] === '')
                        $r ['RUBRO'] = '6';
                    $r ['RUBRO'] = $this->rep_cred_statistics_list_item('STAT', $r ['RUBRO'], CLX_NUM_TWO);
                    $contents .= uppercase($r ['RUBRO']);
                    foreach ($years as $k => $v) {
                        $sql = 'SELECT IFNULL(SUM(CSBT.BALANCE_AMT),0) BALANCE FROM ' . $this->csbtname . ' CSBT WHERE CSBT.STATE = ' . singleQuote($rubro) . ' AND CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.IS_INTEREST = 0 AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] += $bal;
                    }
                    $contents .= $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
                $contents .= uppercase('TOTAL');
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . clx_format_currency($totals [$v], CLX_NUM_TWO);
                }
                $contents .= $rec_delim;
            }
            //Cuadro 10 Recuperaci�n de Capital e Intereses por
            // Provincia/Regi�n y A�o---------------------------------------
            if (!empty($showrep[CLX_NUM_TEN])) {
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                $syear = CLX_NUM_2001;
                $eyear = xFormat::date($edate, 'Y');
                // Title
                $years = array();
                $totals = array();
                for ($i = $syear; $i <= $eyear; $i ++) {
                    $years [] = $i;
                    $totals [$i] = array('c' => CLX_NUM_ZERO, 'i' => CLX_NUM_ZERO);
                }
                $totals ['TOTAL'] = array('c' => CLX_NUM_ZERO, 'i' => CLX_NUM_ZERO);
                $tbl_width = (count($years) * CLX_NUM_TWO) + CLX_NUM_THREE;
                $contents .= 'CUADRO N� 10' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'RECUPERACI�N DE CAPITAL E INTERESES POR PROVINCIA/REGI�N Y A�O' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= 'PROVINCIA';
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . $v . $fld_delim;
                }
                $contents .= $fld_delim . 'TOTAL';
                $contents .= $rec_delim;
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . 'CAPITAL' . $fld_delim . 'INTERESES';
                }
                $contents .= $fld_delim . 'CAPITAL' . $fld_delim . 'INTERESES';
                $contents .= $rec_delim;
                $sql = 'SELECT DISTINCT CSBT.STATE RUBRO FROM ' . $this->csbtname . ' CSBT WHERE CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $rubro = $r ['RUBRO'];
                    if ($r ['RUBRO'] === '')
                        $r ['RUBRO'] = '6';
                    $r ['RUBRO'] = $this->rep_cred_statistics_list_item('STAT', $r ['RUBRO'], CLX_NUM_TWO);
                    $contents .= uppercase($r ['RUBRO']);
                    $tcap = CLX_INIT_ZERO;
                    $tint = CLX_INIT_ZERO;
                    foreach ($years as $k => $v) {
                        $sql = 'SELECT IFNULL(SUM(- 1 *CSBT.BALANCE_AMT),0) BALANCE FROM ' . $this->csbtname . ' CSBT WHERE CSBT.STATE = ' . singleQuote($rubro) . ' AND CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.IS_INTEREST = 0 AND CSBT.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] ['c'] += $bal;
                        $tcap += $bal;
                        $sql = 'SELECT IFNULL(SUM(- 1 *CSBT.BALANCE_AMT),0) BALANCE FROM ' . $this->csbtname . ' CSBT WHERE CSBT.STATE = ' . singleQuote($rubro) . ' AND CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.IS_INTEREST = 1 AND CSBT.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] ['i'] += $bal;
                        $tint += $bal;
                    }
                    $contents .= $fld_delim . clx_format_currency($tcap, CLX_NUM_TWO);
                    $contents .= $fld_delim . clx_format_currency($tint, CLX_NUM_TWO);
                    $totals ['TOTAL'] ['c'] += $tcap;
                    $totals ['TOTAL'] ['i'] += $tint;
                    $contents .= $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
                $contents .= uppercase('TOTAL');
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . clx_format_currency($totals [$v] ['c'], CLX_NUM_TWO);
                    $contents .= $fld_delim . clx_format_currency($totals [$v] ['i'], CLX_NUM_TWO);
                }
                $contents .= $fld_delim . clx_format_currency($totals ['TOTAL'] ['c'], CLX_NUM_TWO);
                $contents .= $fld_delim . clx_format_currency($totals ['TOTAL'] ['i'], CLX_NUM_TWO);
                $contents .= $rec_delim;
            }
            //Cuadro 11 Recuperaci�n de Capital e Intereses por
            // Rubro y A�o-----------------------
            if (!empty($showrep[CLX_NUM_11])) {
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                $syear = CLX_NUM_2001;
                $eyear = xFormat::date($edate, 'Y');
                // Title
                $years = array();
                $totals = array();
                for ($i = $syear; $i <= $eyear; $i ++) {
                    $years [] = $i;
                    $totals [$i] = array('c' => CLX_NUM_ZERO, 'i' => CLX_NUM_ZERO);
                }
                $totals ['TOTAL'] = array('c' => CLX_NUM_ZERO, 'i' => CLX_NUM_ZERO);
                $tbl_width = (count($years) * CLX_NUM_TWO) + CLX_NUM_THREE;
                $contents .= 'CUADRO N� 11' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'RECUPERACI�N DE CAPITAL E INTERESES POR RUBRO Y A�O' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= 'RUBRO';
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . $v . $fld_delim;
                }
                $contents .= $fld_delim . 'TOTAL';
                $contents .= $rec_delim;
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . 'CAPITAL' . $fld_delim . 'INTERESES';
                }
                $contents .= $fld_delim . 'CAPITAL' . $fld_delim . 'INTERESES';
                $contents .= $rec_delim;
                $sql = 'SELECT DISTINCT CSBT.PROP_ITEM_TYPE RUBRO FROM ' . $this->csbtname . ' CSBT WHERE CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $rubro = $r ['RUBRO'];
                    if ($r ['RUBRO'] === '')
                        $r ['RUBRO'] = '6';
                    $r ['RUBRO'] = $this->rep_cred_statistics_list_item('CPIT', $r ['RUBRO'], CLX_NUM_TWO);
                    $contents .= uppercase($r ['RUBRO']);
                    $tcap = CLX_INIT_ZERO;
                    $tint = CLX_INIT_ZERO;
                    foreach ($years as $k => $v) {
                        $sql = 'SELECT IFNULL(SUM(- 1 *CSBT.BALANCE_AMT),0) BALANCE FROM ' . $this->csbtname . ' CSBT WHERE CSBT.PROP_ITEM_TYPE = ' . singleQuote($rubro) . ' AND CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.IS_INTEREST = 0 AND CSBT.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] ['c'] += $bal;
                        $tcap += $bal;
                        $sql = 'SELECT IFNULL(SUM(- 1 *CSBT.BALANCE_AMT),0) BALANCE FROM ' . $this->csbtname . ' CSBT WHERE CSBT.PROP_ITEM_TYPE = ' . singleQuote($rubro) . ' AND CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.IS_INTEREST = 1 AND CSBT.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] ['i'] += $bal;
                        $tint += $bal;
                    }
                    $contents .= $fld_delim . clx_format_currency($tcap, CLX_NUM_TWO);
                    $contents .= $fld_delim . clx_format_currency($tint, CLX_NUM_TWO);
                    $totals ['TOTAL'] ['c'] += $tcap;
                    $totals ['TOTAL'] ['i'] += $tint;
                    $contents .= $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
                $contents .= uppercase('TOTAL');
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . clx_format_currency($totals [$v] ['c'], CLX_NUM_TWO);
                    $contents .= $fld_delim . clx_format_currency($totals [$v] ['i'], CLX_NUM_TWO);
                }
                $contents .= $fld_delim . clx_format_currency($totals ['TOTAL'] ['c'], CLX_NUM_TWO);
                $contents .= $fld_delim . clx_format_currency($totals ['TOTAL'] ['i'], CLX_NUM_TWO);
                $contents .= $rec_delim;
            }
            //Cuadro 12 Desembolso de Prestamos por
            // Provincia/Regi�n y A�o---------------------------------------
            if (!empty($showrep[CLX_NUM_12])) {
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                $syear = CLX_NUM_2001;
                $eyear = xFormat::date($edate, 'Y');
                // Title
                $years = array();
                $totals = array();
                for ($i = $syear; $i <= $eyear; $i ++) {
                    $years [] = $i;
                    $totals [$i] = CLX_INIT_ZERO;
                }
                $totals ['TOTAL'] = CLX_INIT_ZERO;
                $tbl_width = count($years) + CLX_NUM_TWO;
                $contents .= 'CUADRO N� 12' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'DESEMBOLSO DE PRESTAMOS POR PROVINCIA/REGI�N Y A�O' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'SALDOS(MONTO)' . str_repeat($fld_delim, ($tbl_width - CLX_NUM_TWO)) . $rec_delim;
                $contents .= 'PROVINCIA';
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . $v;
                }
                $contents .= $fld_delim . 'TOTAL';
                $contents .= $rec_delim;
                $sql = 'SELECT DISTINCT CSBT.STATE RUBRO FROM ' . $this->csbtname . ' CSBT WHERE CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $rubro = $r ['RUBRO'];
                    if ($r ['RUBRO'] === '')
                        $r ['RUBRO'] = '6';
                    $r ['RUBRO'] = $this->rep_cred_statistics_list_item('STAT', $r ['RUBRO'], CLX_NUM_TWO);
                    $contents .= uppercase($r ['RUBRO']);
                    $tcap = CLX_INIT_ZERO;
                    foreach ($years as $k => $v) {
                        $sql = 'SELECT IFNULL(SUM(CSBT.BALANCE_AMT),0) BALANCE FROM ' . $this->csbtname . ' CSBT WHERE CSBT.STATE = ' . singleQuote($rubro) . ' AND CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.IS_INTEREST = 0 AND CSBT.TRANSTBL_CODE IN (' . singleQuoteArray(array('SYS_CRED-DISB', 'CRED_REFREO')) . ') AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        if (empty($bal))
                            $bal = CLX_INIT_ZERO;
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] += $bal;
                        $tcap += $bal;
                        $totals ['TOTAL'] += $bal;
                    }
                    if (empty($tcap))
                        $tcap = CLX_INIT_ZERO;
                    $contents .= $fld_delim . clx_format_currency($tcap, CLX_NUM_TWO);
                    $contents .= $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
                $contents .= uppercase('TOTAL');
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . clx_format_currency($totals [$v], CLX_NUM_TWO);
                }
                $contents .= $fld_delim . clx_format_currency($totals ['TOTAL'], CLX_NUM_TWO);
                $contents .= $rec_delim;
            }
            //Cuadro 13 Desembolso de Prestamos por
            // Provincia/Regi�n y A�o---------------------------------------
            if (!empty($showrep[CLX_NUM_13])) {
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                $syear = CLX_NUM_2001;
                $eyear = xFormat::date($edate, 'Y');
                // Title
                $years = array();
                $totals = array();
                for ($i = $syear; $i <= $eyear; $i ++) {
                    $years [] = $i;
                    $totals [$i] = CLX_INIT_ZERO;
                }
                $totals ['TOTAL'] = CLX_INIT_ZERO;
                $tbl_width = count($years) + CLX_NUM_TWO;
                $contents .= 'CUADRO N� 13' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'DESEMBOLSO DE PRESTAMOS POR RUBRO Y A�O' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= $fld_delim . 'SALDOS(MONTO)' . str_repeat($fld_delim, ($tbl_width - CLX_NUM_TWO)) . $rec_delim;
                $contents .= 'RUBRO';
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . $v;
                }
                $contents .= $fld_delim . 'TOTAL';
                $contents .= $rec_delim;
                $sql = 'SELECT DISTINCT CSBT.PROP_ITEM_TYPE RUBRO FROM ' . $this->csbtname . ' CSBT WHERE CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $rubro = $r ['RUBRO'];
                    if ($r ['RUBRO'] === '')
                        $r ['RUBRO'] = '6';
                    $r ['RUBRO'] = $this->rep_cred_statistics_list_item('CPIT', $r ['RUBRO'], CLX_NUM_TWO);
                    $contents .= uppercase($r ['RUBRO']);
                    $tcap = CLX_INIT_ZERO;
                    foreach ($years as $k => $v) {
                        $sql = 'SELECT IFNULL(SUM(CSBT.BALANCE_AMT),0) BALANCE FROM ' . $this->csbtname . ' CSBT WHERE CSBT.PROP_ITEM_TYPE = ' . singleQuote($rubro) . ' AND CSBT.YEAR_NO = ' . singleQuote($v) . ' AND CSBT.IS_INTEREST = 0 AND CSBT.TRANSTBL_CODE IN (' . singleQuoteArray(array('SYS_CRED-DISB', 'CRED_REFREO')) . ') AND CSBT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] += $bal;
                        $tcap += $bal;
                        $totals ['TOTAL'] += $bal;
                    }
                    $contents .= $fld_delim . clx_format_currency($tcap, CLX_NUM_TWO);
                    $contents .= $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
                $contents .= uppercase('TOTAL');
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . clx_format_currency($totals [$v], CLX_NUM_TWO);
                }
                $contents .= $fld_delim . clx_format_currency($totals ['TOTAL'], CLX_NUM_TWO);
                $contents .= $rec_delim;
            }
            //Cuadro 14 FORMALIZACIONES POR PROVINCIA/REGI�N Y
            // A�O------------------------
            if (!empty($showrep[CLX_NUM_14])) {
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                $syear = ClxCommon::$db->getOne('SELECT MIN(YEAR_NO) FROM ' . $this->csctname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
                $eyear = xFormat::date($edate, 'Y');
                // Title
                $years = array();
                $totals = array();
                for ($i = $syear; $i <= $eyear; $i ++) {
                    $years [] = $i;
                    $totals [$i] = CLX_INIT_ZERO;
                }
                $totals ['TOTAL'] = CLX_INIT_ZERO;
                $tbl_width = count($years) + CLX_NUM_TWO;
                $contents .= 'CUADRO N� 14' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'FORMALIZACIONES POR PROVINCIA/REGI�N Y A�O' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                // Headers
                $contents .= 'PROVINCIA';
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . $v;
                }
                $contents .= $fld_delim . 'TOTAL';
                $contents .= $rec_delim;
                $sql = 'SELECT DISTINCT CSCT.STATE RUBRO FROM ' . $this->csctname . ' CSCT WHERE CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $rubro = $r ['RUBRO'];
                    if ($r ['RUBRO'] === '')
                        $r ['RUBRO'] = 'OTH';
                    $r ['RUBRO'] = $this->rep_cred_statistics_list_item('STAT', $r ['RUBRO'], CLX_NUM_TWO);
                    $contents .= uppercase($r ['RUBRO']);
                    $tcap = CLX_INIT_ZERO;
                    foreach ($years as $k => $v) {
                        $sql = 'SELECT IFNULL(SUM(CSCT.LOAN_AMT),0) BALANCE FROM ' . $this->csctname . ' CSCT WHERE CSCT.STATE = ' . singleQuote($rubro) . ' AND CSCT.YEAR_NO = ' . singleQuote($v) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] += $bal;
                        $tcap += $bal;
                        $totals ['TOTAL'] += $bal;
                    }
                    $contents .= $fld_delim . clx_format_currency($tcap, CLX_NUM_TWO);
                    $contents .= $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
                $contents .= uppercase('TOTAL');
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . clx_format_currency($totals [$v], CLX_NUM_TWO);
                }
                $contents .= $fld_delim . clx_format_currency($totals ['TOTAL'], CLX_NUM_TWO);
                $contents .= $rec_delim;
            }
            //cuadro 15 FORMALIZACIONES POR RUBRO Y
            // A�O------------------------
            if (!empty($showrep[CLX_NUM_15])) {
                $contents .= str_repeat($rec_delim, CLX_NUM_TWO);
                $syear = ClxCommon::$db->getOne('SELECT MIN(YEAR_NO) FROM ' . $this->csctname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
                $eyear = xFormat::date($edate, 'Y');
                // Title
                $years = array();
                $totals = array();
                for ($i = $syear; $i <= $eyear; $i ++) {
                    $years [] = $i;
                    $totals [$i] = CLX_INIT_ZERO;
                }
                $totals ['TOTAL'] = CLX_INIT_ZERO;
                $tbl_width = count($years) + CLX_NUM_TWO;
                $contents .= 'CUADRO N� 15' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'FORMALIZACIONES POR RUBRO Y A�O' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= 'BANCO DE DESARROLLO AGROPECUARIO  - OFICINA DE PLANIFICACI�N' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('PROGRAMA ' . $progname . ' ') . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= uppercase('A ' . dict('UICA_LBL_MONTH_' . $month_edate)) . ' ' . $yn_edate . ' ' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= '(MONTOS EN BALBOAS)' . str_repeat($fld_delim, $tbl_width - CLX_NUM_ONE) . $rec_delim;
                $contents .= $rec_delim;
                $contents .= 'RUBRO';
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . $v;
                }
                $contents .= $fld_delim . 'TOTAL';
                $contents .= $rec_delim;
                $sql = 'SELECT DISTINCT CSCT.PROP_ITEM_TYPE RUBRO FROM ' . $this->csctname . ' CSCT WHERE CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $rubro = $r ['RUBRO'];
                    if ($r ['RUBRO'] === '')
                        $r ['RUBRO'] = 'OTH';
                    $r ['RUBRO'] = $this->rep_cred_statistics_list_item('CPIT', $r ['RUBRO'], CLX_NUM_TWO);
                    $contents .= uppercase($r ['RUBRO']);
                    $tcap = CLX_INIT_ZERO;
                    foreach ($years as $k => $v) {
                        $sql = 'SELECT IFNULL(SUM(CSCT.LOAN_AMT),0) BALANCE FROM ' . $this->csctname . ' CSCT WHERE CSCT.PROP_ITEM_TYPE = ' . singleQuote($rubro) . ' AND CSCT.YEAR_NO = ' . singleQuote($v) . ' AND CSCT.BATCH_ID = ' . singleQuote($this->batch_id);
                        $bal = ClxCommon::$db->getOne($sql);
                        $contents .= $fld_delim . clx_format_currency($bal, CLX_NUM_TWO);
                        $totals [$v] += $bal;
                        $tcap += $bal;
                        $totals ['TOTAL'] += $bal;
                    }
                    $contents .= $fld_delim . clx_format_currency($tcap, CLX_NUM_TWO);
                    $contents .= $rec_delim;
                }
				ClxCommon::$db->freeResult($rs);
                $contents .= uppercase('TOTAL');
                foreach ($years as $k => $v) {
                    $contents .= $fld_delim . clx_format_currency($totals [$v], CLX_NUM_TWO);
                }
                $contents .= $fld_delim . clx_format_currency($totals ['TOTAL'], CLX_NUM_TWO);
                $contents .= $rec_delim;
            }
            $this->contents = $contents;
        }

        /**
         * Prompts report format
         *
         * @return string
         */
        function rep_participation_prompt() {
            // initialization
            $ac = UserRequest::$request ['ac'];
            $to = UserRequest::$request [CLX_PROP_TO];
            $it = UserRequest::$request ['it'];
            $contents = '';
            // RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('PART_REP') . '');
            $record = UserRequest::$post;
            if (!empty($record ['confirm'])) {
                $EDIT->checkForm2($msg, $formrec);
            }
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_DISPLAY'));
            $contents .= $form->source() . '<Br>';
            ;
            if (!empty($record ['confirm']) && empty($msg)) {
                $contents .= $this->rep_participation_report_format($record ['RTBL_COMP_CODE'], $record ['RTBL_EDATE'], $record ['RTBL_DATE_FORMAT'], $record ['RTBL_CHART_FIELD01'], $record ['RTBL_CHART_FIELD02']);
            }
            return $contents;
        }

        /**
         * Credit Statistical Report.
         *
         * @param string $comp_code
         * @param string $edate
         * @param string $dt_format
         * @param string $contract_code
         * @param string $participant_id
         */
        public function rep_participation_report($comp_code, $edate, $dt_format, $contract_code = '', $participant_id = '') {
            $sql = 'DROP TABLE IF EXISTS TEMP1_TMP';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'DROP TABLE IF EXISTS TEMP2_TMP';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'CREATE TEMPORARY TABLE TEMP1_TMP SELECT GDVW.COMP_CODE, GDVW.CHART_FIELD01, FIAT.BENEFICIARY_CODE, SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) BALANCE_AMT, SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) TOTAL_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 5) CA_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 5) INV_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 5) OTH_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 5) IN_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 5) EX_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 2) CA_TOTAL_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 2) INV_TOTAL_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 2) OTH_TOTAL_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 2) IN_TOTAL_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 2) EX_TOTAL_AMT, ROUND(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT), 5) AVAILABLE_AMT FROM FIDU_TRANSACTIONS FIAT, GL_JOURNAL_DET_VW GDVW WHERE GDVW.CHART_FIELD01 = FIAT.CHART_FIELD01 AND FIAT.IDCODE = GDVW.TRANS_CODE AND FIAT.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAT.EFFTDATE <= ' . singleQuote($edate) . ' AND GDVW.EFFTDATE <= ' . singleQuote($edate) . ' AND GDVW.GL_TYPE = ' . singleQuote('AS') . ' AND FIAT.BENEFICIARY_CODE IS NOT null ' . (($contract_code !== '') ? ' AND FIAT.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ' : '') . ' GROUP BY GDVW.COMP_CODE, GDVW.CHART_FIELD01, FIAT.BENEFICIARY_CODE ORDER BY GDVW.COMP_CODE, GDVW.CHART_FIELD01, FIAT.BENEFICIARY_CODE';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP SET CA_AMT = 0, INV_AMT  = 0, OTH_AMT  = 0, IN_AMT = 0, EX_AMT = 0, CA_TOTAL_AMT = 0, INV_TOTAL_AMT = 0, OTH_TOTAL_AMT = 0, IN_TOTAL_AMT = 0, EX_TOTAL_AMT = 0, AVAILABLE_AMT = 0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'CREATE TEMPORARY TABLE TEMP2_TMP SELECT A.COMP_CODE, A.CHART_FIELD01, SUM(A.BALANCE_AMT) BALANCE_AMT FROM TEMP1_TMP A GROUP BY A.COMP_CODE, A.CHART_FIELD01';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP A SET A.TOTAL_AMT = IFNULL((SELECT B.BALANCE_AMT FROM TEMP2_TMP B WHERE B.CHART_FIELD01 = A.CHART_FIELD01),0)';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'DROP TABLE IF EXISTS TEMP2_TMP';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'CREATE TEMPORARY TABLE TEMP2_TMP SELECT GL.COMP_CODE, GL.CHART_FIELD01, GL.GLACCOUNTCODE, GL.GL_TYPE, MAX(case GL.GL_TYPE WHEN ' . singleQuote('AS') . ' THEN case GL.TRUST_ITEM_TYPE WHEN ' . singleQuote('IN') . ' THEN ' . singleQuote('IN') . ' WHEN ' . singleQuote('CA') . ' THEN ' . singleQuote('CA') . ' ELSE ' . singleQuote('OTH') . ' END ELSE ' . singleQuote('OT') . ' END) TRUST_ITEM_TYPE, SUM(GL.DEBIT_AMT-GL.CREDIT_AMT) BALANCE_AMT FROM GL_JOURNAL_DET_VW GL WHERE GL.COMP_CODE = ' . singleQuote($comp_code) . ' AND GL.EFFTDATE <= ' . singleQuote($edate) . ' AND GL.REVERSED = 0 ' . (($contract_code !== '') ? ' AND GL.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ' : '') . ' GROUP BY GL.COMP_CODE, GL.CHART_FIELD01, GL.GLACCOUNTCODE, GL.GL_TYPE ORDER BY GL.COMP_CODE, GL.CHART_FIELD01, GL.GL_TYPE';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP A SET CA_TOTAL_AMT = IFNULL((SELECT SUM(B.BALANCE_AMT) FROM TEMP2_TMP B WHERE B.CHART_FIELD01 = A.CHART_FIELD01 AND B.GL_TYPE = ' . singleQuote('AS') . ' AND B.TRUST_ITEM_TYPE = ' . singleQuote('CA') . '),0)';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP A SET INV_TOTAL_AMT = IFNULL((SELECT SUM(B.BALANCE_AMT) FROM TEMP2_TMP B WHERE B.CHART_FIELD01 = A.CHART_FIELD01 AND B.GL_TYPE = ' . singleQuote('AS') . ' AND B.TRUST_ITEM_TYPE = ' . singleQuote('IN') . '),0)';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP A SET OTH_TOTAL_AMT = IFNULL((SELECT SUM(B.BALANCE_AMT) FROM TEMP2_TMP B WHERE B.CHART_FIELD01 = A.CHART_FIELD01 AND B.GL_TYPE = ' . singleQuote('AS') . ' AND B.TRUST_ITEM_TYPE = ' . singleQuote('OTH') . '),0)';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP A SET IN_TOTAL_AMT = IFNULL((SELECT SUM(B.BALANCE_AMT) FROM TEMP2_TMP B WHERE B.CHART_FIELD01 = A.CHART_FIELD01 AND B.GL_TYPE = ' . singleQuote('IN') . '),0)';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP A SET EX_TOTAL_AMT = IFNULL((SELECT SUM(B.BALANCE_AMT) FROM TEMP2_TMP B WHERE B.CHART_FIELD01 = A.CHART_FIELD01 AND B.GL_TYPE = ' . singleQuote('EX') . '),0)';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP A SET A.CA_AMT  = IFNULL(ROUND(A.CA_TOTAL_AMT*(A.BALANCE_AMT/nullIF(A.TOTAL_AMT,0)), 5),0), A.INV_AMT = IFNULL(ROUND(A.INV_TOTAL_AMT*(A.BALANCE_AMT/nullIF(A.TOTAL_AMT,0)), 5),0), A.OTH_AMT = IFNULL(ROUND(A.OTH_TOTAL_AMT*(A.BALANCE_AMT/nullIF(A.TOTAL_AMT,0)), 5),0), A.IN_AMT  = IFNULL(ROUND(A.IN_TOTAL_AMT*(A.BALANCE_AMT/nullIF(A.TOTAL_AMT,0)), 5),0), A.EX_AMT  = IFNULL(ROUND(A.EX_TOTAL_AMT*(A.BALANCE_AMT/nullIF(A.TOTAL_AMT,0)), 5),0)';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE TEMP1_TMP A SET A.AVAILABLE_AMT = IFNULL( ROUND((A.CA_TOTAL_AMT + A.INV_TOTAL_AMT+A.OTH_TOTAL_AMT) *(A.BALANCE_AMT/nullIF(A.TOTAL_AMT,0)), 5),0) ';
            ClxCommon::$db->executeQuery($sql); // A.IN_TOTAL_AMT + A.EX_TOTAL_AMT
            // Cambiando signo de ingreso
            $sql = 'UPDATE TEMP1_TMP SET IN_TOTAL_AMT = -1*IN_TOTAL_AMT, IN_AMT = -1* IN_AMT';
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Formast report
         *
         * @param unknown_type $comp_code
         * @param unknown_type $edate
         * @param unknown_type $dt_format
         * @param unknown_type $contract_code
         * @param unknown_type $participant_id
         */
        private function rep_participation_report_format($comp_code, $edate, $dt_format, $contract_code = '', $participant_id = '') {
            // Perform calculations
            $this->rep_participation_report($comp_code, $edate, $dt_format, $contract_code, $participant_id);
            $table1 = new htmlTable(CLX_WIDTH_ONE);
            $table1->setProps(array(CLX_PROP_CLASS => ''));
            $table1->addCell(dict('GEN_LBL_PARTICIPATION_REPORT'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST));
            $table->addCell(dict('GEN_COMP_CODE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell(ClxCommon::$db->getField($this->compname, 'IDNAME', 'IDCODE = ' . singleQuote($comp_code)), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $table->addCell(dict('GEN_LBL_TO'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            $table->addCell(xFormat::date($edate, $dt_format), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            if ($participant_id !== '') {
                $table->addCell(dict('GEN_BENEFICIARY_CODE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
                $sql = 'SELECT CONCAT(IDNAME,' . singleQuote(' (') . ', IDCODE,' . singleQuote(')') . ') FROM ' . $this->acconame . ' WHERE IDCODE = ' . singleQuote($participant_id);
                $table->addCell(ClxCommon::$db->getOne($sql), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            }
            $table1->addCell($table->source() . '<br>', array());
            $table = new htmlTable(CLX_WIDTH_15);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST));
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_CHART_FIELD01'), dict('GEN_BENEFICIARY_CODE'), dict('GEN_APORTE_AMT'), dict('GEN_TOTAL_APORTE_AMT'), dict('GEN_CA_TOTAL_AMT'), dict('GEN_INV_TOTAL_AMT'), dict('GEN_OTH_TOTAL_AMT'), dict('GEN_IN_TOTAL_AMT'), dict('GEN_EX_TOTAL_AMT'), dict('GEN_CA_AMT'), dict('GEN_INV_AMT'), dict('GEN_OTH_ASSETS'), dict('GEN_EX_AMT'), dict('GEN_IN_AMT'), dict('GEN_AVAILABLE_AMT')));
            // build reprot
            $sql = 'SELECT FICO.CONTRACT_NUMBER, A.*, (SELECT max(CONCAT(ACCO.IDNAME,' . singleQuote(' (') . ', ACCO.IDCODE,' . singleQuote(')') . ')) FROM ' . $this->acconame . ' ACCO WHERE ACCO.IDCODE = A.BENEFICIARY_CODE) BENEF_NAME FROM TEMP1_TMP A, FIDU_CONTRACTS FICO WHERE FICO.IDCODE = A.CHART_FIELD01 AND A.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($contract_code !== '') ? ' AND A.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ' : '') .
                    (($participant_id !== '') ? ' AND A.BENEFICIARY_CODE = ' . singleQuote($participant_id) : '');
            $rs = ClxCommon::$db->executeQuery($sql);
            $i = CLX_INIT_ZERO;
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $class = ($i % CLX_NUM_TWO == CLX_NUM_ONE) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
                $i ++;
                if ($r ['BENEF_NAME'] === '')
                    $r ['BENEF_NAME'] = 'N/A';
                $table->addCell($r ['CONTRACT_NUMBER'], array(CLX_PROP_CLASS => $class));
                $table->addCell($r ['BENEF_NAME'], array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['BALANCE_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['TOTAL_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['CA_TOTAL_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['INV_TOTAL_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['OTH_TOTAL_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['IN_TOTAL_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['EX_TOTAL_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['CA_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['INV_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['OTH_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['EX_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['IN_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
                $table->addCell(xFormat::number($r ['AVAILABLE_AMT'], CLX_NUM_TWO), array(CLX_PROP_CLASS => $class));
            }
			ClxCommon::$db->freeResult($rs);
            $table1->addCell($table->source(), array());
            return $table1->source();
        }

        /**
         * Return beneficiary availability
         *
         * @param string $comp_code
         * @param string $edate
         * @param string $contract_code
         * @param string $beneficiary_code
         * @return float <multitype:, boolean>
         */
        function rep_participation_available_amt($comp_code, $edate, $contract_code, $beneficiary_code) {
            // Perform calculations
            $this->rep_participation_report($comp_code, $edate, 'Y-m-d', $contract_code, $beneficiary_code);
            $sql = 'SELECT ROUND(IFNULL(A.AVAILABLE_AMT,0), 2) FROM TEMP1_TMP A WHERE A.COMP_CODE = ' . singleQuote($comp_code) . ' AND A.CHART_FIELD01 = ' . singleQuote($contract_code) . ' AND A.BENEFICIARY_CODE = ' . singleQuote($beneficiary_code);
            return ClxCommon::$db->getOne($sql);
        }

        // EDO de cuenta de beneficiario
        /**
         * Prompts report format
         *
         * @return string
         */
        function rep_beneficiary_statement_prompt() {
            // initialization
            $ac = UserRequest::$request ['ac'];
            $to = UserRequest::$request [CLX_PROP_TO];
            $it = UserRequest::$request ['it'];
            $contents = '';
            // RTBL_REPCINV
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('PART_REP_STMP') . '');
            $record = UserRequest::$post;
            if (!empty($record ['confirm'])) {
                $EDIT->checkForm2($msg, $formrec);
            }
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', '', dict('GEN_LBL_DISPLAY'));
            $contents .= $form->source() . '<Br>';
            ;
            if (!empty($record ['confirm']) && empty($msg)) {
                $contents = $this->rep_beneficiary_statement($record ['RTBL_COMP_CODE'], $record ['RTBL_EDATE'], $record ['RTBL_CHART_FIELD01'], $record ['RTBL_CHART_FIELD02'], $record ['RTBL_REP_FORMAT'], $record ['RTBL_DATE_FORMAT']);
            }
            return $contents;
        }

        /**
         * Initializar stile
         *
         * @return array
         */
        private function rep_beneficiary_statement_styles() {
            $styles = array();
            $styles ['all'] = new clx_style('all');
            $styles ['all']->setFontSize(CLX_NUM_8);
            $styles ['all']->setBoxHeight(CLX_NUM_20);
            $styles ['all']->setBoxPadding(CLX_NUM_TWO);
            $styles ['all']->setBoxWidth(CLX_NUM_650);
            $styles ['all']->setFontColor('000000');
	    $styles [CLX_CLASS_DATA] = clone $styles ['all'];
            $styles [CLX_CLASS_DATA]->setBoxWidth(CLX_NUM_155);
            $styles ['tbhead'] = clone $styles [CLX_CLASS_DATA];
            $styles ['tbhead']->setFontBold();
            $styles ['tbhead']->setBoxBorder(CLX_NUM_ONE, 'top');
            $styles ['tbhead']->setBoxBorder(CLX_NUM_ONE, 'bottom');
            $styles ['tbhead']->setBoxBgColor('cccccc');
            $styles ['tbheaddesc'] = clone $styles ['tbhead'];
            $styles ['tbheaddesc']->setBoxWidth(CLX_NUM_350);
            $styles ['tbheadsep'] = clone $styles ['tbhead'];
            $styles ['tbheadsep']->setBoxWidth(CLX_NUM_TWO);
            $styles ['datanum'] = clone $styles [CLX_CLASS_DATA];
            $styles ['dataint'] = clone $styles [CLX_CLASS_DATA];
            $styles ['datadesc'] = clone $styles [CLX_CLASS_DATA];
            $styles ['datadesc']->setBoxWidth(CLX_NUM_350);
            $styles ['datanum']->setDataType('decimal');
            $styles ['dataint']->setDataType('integer');
            $styles ['datanum']->setFontAligment(CLX_PROP_RIGHT);
            $styles ['datadescbold'] = clone $styles ['datadesc'];
            $styles ['datadescbold']->setFontBold();
            $styles ['datanumbold'] = clone $styles ['datanum'];
            $styles ['datanumbold']->setFontBold();
            $styles ['datanumboldtopline'] = clone $styles ['datanumbold'];
            $styles ['datanumboldtopline']->setBoxBorder(CLX_NUM_ONE, 'top');
            $styles ['datanumboldtopline']->setBoxBorder(CLX_NUM_ONE, 'bottom');
            $styles ['datadescboldtopline'] = clone $styles ['datadescbold'];
            $styles ['datadescboldtopline']->setBoxBorder(CLX_NUM_ONE, 'top');
            $styles ['datadescboldtopline']->setBoxBorder(CLX_NUM_ONE, 'bottom');
            $styles ['databoldtopline'] = clone $styles [CLX_CLASS_DATA];
            $styles ['databoldtopline']->setFontBold();
            $styles ['databoldtopline']->setBoxBorder(CLX_NUM_ONE, 'top');
            $styles ['databoldtopline']->setBoxBorder(CLX_NUM_ONE, 'bottom');
            $styles ['datanumboldbottomline'] = clone $styles ['datanumbold'];
            $styles ['datanumboldbottomline']->setBoxBorder(CLX_NUM_ONE, 'bottom');
            $styles ['datasep'] = clone $styles [CLX_CLASS_DATA];
            $styles ['datasep']->setBoxWidth(CLX_NUM_ONE);
            $styles ['head'] = clone $styles ['all'];
            $styles ['head']->setBoxColSpan(CLX_NUM_THREE);
            $styles ['head']->setFontAligment('center');
            $styles ['head']->setFontBold();
            $styles ['head2'] = clone $styles ['head'];
            $styles ['head3'] = clone $styles ['head'];
            $styles ['section_title'] = clone $styles ['head'];
            $styles ['section_title']->setBoxBorder(CLX_NUM_ONE, 'bottom');
            $styles ['section_title']->setBoxBorder(CLX_NUM_ONE, 'top');
            $styles ['head']->setFontBoldUnderline();
            $styles ['footer'] = clone $styles ['all'];
            $styles ['footer']->setFontAligment('center');
            //setting name for all clones
            foreach ($styles as $key => $val) {
                $styles[$key]->setName($key);
            }
            return $styles;
        }

        /**
         * Builds beneficiary statement based on participations
         *
         * @param string $comp_code
         * @param string $edate
         * @param string $contract_code
         * @param string $beneficiary_code
         */
        function rep_beneficiary_statement($comp_code, $edate, $contract_code, $beneficiary_code, $rep_format, $date_format) {
            // Perform calculations
            $this->rep_participation_report($comp_code, $edate, 'Y-m-d', $contract_code, $beneficiary_code);
            require_once kPathToWebSite . kPathToPear.'Spreadsheet/Excel/Writer.php';
            include_once kPathToWebSite.kPathToFpdf . 'fpdf.php';
            include_once 'classes/clx_report.php';
            include_once 'classes/clx_report_page.php';
            include_once 'classes/clx_report_panel.php';
            include_once 'classes/clx_report_object.php';
            include_once 'classes/clx_report_object_table.php';
            include_once 'classes/clx_report_data.php';
            include_once 'classes/clx_style.php';
            $styles = $this->rep_beneficiary_statement_styles();
            $report = new clx_report('L', 'mm', 'Legal');
            $page = new clx_report_page ();
            $this->rep_beneficiary_statement_header($page, $styles, $comp_code, $edate, $contract_code, $beneficiary_code, $rep_format);
            $this->rep_beneficiary_statement_position($page, $styles, $beneficiary_code);
            $this->rep_beneficiary_statement_activities($page, $styles, $comp_code, $edate, $contract_code, $beneficiary_code);
            $this->rep_beneficiary_statement_fund_info($page, $styles, $beneficiary_code);
            $report->addPage($page);
            return $report->source2($rep_format, false);
        }

        /**
         * Report Head Section
         *
         * @param string $page
         * @param string $styles
         * @param string $comp_code
         * @param string $edate
         * @param string $contract_code
         * @param string $beneficiary_code
         * @param string $rep_format
         */
        function rep_beneficiary_statement_header(&$page, &$styles, $comp_code, $edate, $contract_code, $beneficiary_code) {
            $ficoname = ClxCommon::$db->getField($this->ficoname, 'IDNAME', 'IDCODE = ' . singleQuote($contract_code));
            $edate = explode('-', $edate);
            $of_lbl = dict('GEN_LBL_OF');
            $date_lbl = $edate [CLX_NUM_TWO] . ' ' . $of_lbl . ' ' . dict('UICA_LBL_MONTH_' . $edate [CLX_NUM_ONE]) . ' ' . $of_lbl . ' ' . $edate [CLX_NUM_ZERO];
            $page->setHeader(new clx_report_data(dict('GEN_LBL_TRUST') . ' ' . $ficoname, $styles ['head']));
            $page->setHeader(new clx_report_data($date_lbl, $styles ['head3']));
            // Adding section title
            $table = new clx_report_object_table ();
            $table->addColumn(new clx_report_data('', $styles ['footer']));
            $sql = 'SELECT ACCO.IDCODE, ACCO.IDNAME, ACCO.IDENTIFICATION FROM ' . $this->acconame . ' ACCO WHERE ACCO.IDCODE = ' . singleQuote($beneficiary_code);
            $r = ClxCommon::$db->getOneRecord($sql);
            $table->addRow(new clx_report_data(dict('GEN_LBL_CLIENT') . ': ' . $r ['IDNAME'], $styles ['datadescbold']));
            $sql = 'SELECT FICO.CONTRACT_NUMBER, FICO.IDNAME FROM ' . $this->ficoname . ' FICO WHERE FICO.IDCODE = ' . singleQuote($contract_code);
            $r = ClxCommon::$db->getOneRecord($sql);
            $table->addRow(new clx_report_data(dict('GEN_LBL_CONTRACT_NUMBER') . ': ' . $r ['IDNAME'] . ' (' . $r ['CONTRACT_NUMBER'] . ')', $styles ['datadescbold']));
            $page->addPanel(new clx_report_panel($table));
        }

        /**
         * Position section
         *
         * @param obj $page
         * @param array $styles
         * @param string $beneficiary_code
         */
        private function rep_beneficiary_statement_position(&$page, &$styles, $beneficiary_code) {
            $DBLT = &getTool('DBLT');
            $gl_types = $DBLT->getListAsArray('GLTY');
            // Adding section title
            $table = new clx_report_object_table ();
            $table->addColumn(new clx_report_data('', $styles ['datadescbold']));
            $table->addRow(new clx_report_data('1. ' . dict('GEN_LBL_POSITION'), $styles ['datadescbold']));
            $page->addPanel(new clx_report_panel($table));
            // Adding
            $table = new clx_report_object_table ();
            $table->addColumn(new clx_report_data(dict('GEN_LBL_DESCRIPTION'), $styles ['tbheaddesc']));
            $table->addColumn(new clx_report_data('', $styles ['tbhead']));
            $table->addColumn(new clx_report_data(dict('GEN_LBL_LOCAL_CURRENCY'), $styles ['tbhead']));
            $table->addColumn(new clx_report_data(dict('GEN_LBL_TOTAL'), $styles ['tbhead']));
            $sql = 'SELECT GL.GLACCOUNTCODE, GLAC.IDNAME, GLAC.GL_TYPE, GL.BALANCE_AMT, ROUND(IFNULL(ROUND(GL.BALANCE_AMT*(PR.BALANCE_AMT/nullIF(PR.TOTAL_AMT,0)), 5),0), 2) PAR_BALANCE_AMT FROM TEMP2_TMP GL, TEMP1_TMP PR, GL_CODES_TBL GLAC, GL_PARAMETERS_TBL GLCP WHERE GL.CHART_FIELD01 = PR.CHART_FIELD01 AND GLAC.IDCODE = GL.GLACCOUNTCODE AND GLCP.COMP_CODE = GL.COMP_CODE AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE AND PR.BENEFICIARY_CODE = ' . singleQuote($beneficiary_code) . ' ORDER BY GL.GLACCOUNTCODE';
            $rs = ClxCommon::$db->executeQuery($sql);
            $type = '';
            $trial_balance = CLX_INIT_ZERO;
            $total = CLX_INIT_ZERO;
            $last_gl_type = '';
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                if ($type != $r ['GL_TYPE']) {
                    if ($type !== '') {
                        $table->addRow(new clx_report_data('-- ' . dict('GEN_LBL_TOTAL') . ' ' . $gl_types [$r ['GL_TYPE']], $styles ['datadescbold']));
                        $table->addRow(new clx_report_data('', $styles ['datanum']));
                        $table->addRow(new clx_report_data('', $styles ['datanum']));
                        $table->addRow(new clx_report_data($total, $styles ['datanumbold']));
                    }
                    $type = $r ['GL_TYPE'];
                    $table->addRow(new clx_report_data($gl_types [$r ['GL_TYPE']], $styles ['datadescbold']));
                    $table->addRow(new clx_report_data('', $styles ['datanum']));
                    $table->addRow(new clx_report_data('', $styles ['datanum']));
                    $table->addRow(new clx_report_data('', $styles ['datanum']));
                    $total = CLX_INIT_ZERO;
                }
                $table->addRow(new clx_report_data(' -- ' . $r ['IDNAME'], $styles ['datadesc']));
                $table->addRow(new clx_report_data('', $styles ['datanum']));
                $table->addRow(new clx_report_data($r ['PAR_BALANCE_AMT'], $styles ['datanum']));
                $table->addRow(new clx_report_data('', $styles ['datanum']));
                $trial_balance += round($r ['PAR_BALANCE_AMT'], CLX_NUM_TWO);
                $total += round($r ['PAR_BALANCE_AMT'], CLX_NUM_TWO);
                $last_gl_type = $r ['GL_TYPE'];
            }
			ClxCommon::$db->freeResult($rs);
            if ($last_gl_type !== '') {
                $table->addRow(new clx_report_data('-- ' . dict('GEN_LBL_TOTAL') . ' ' . $gl_types [$last_gl_type], $styles ['datadescbold']));
                $table->addRow(new clx_report_data('', $styles ['datanum']));
                $table->addRow(new clx_report_data('', $styles ['datanum']));
                $table->addRow(new clx_report_data($total, $styles ['datanumbold']));
            }
            $table->addRow(new clx_report_data(	dict('GEN_LBL_TRIAL_BALANCE'), $styles ['datadescboldtopline']));
            $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
            $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
            $table->addRow(new clx_report_data(round($trial_balance, CLX_NUM_TWO), $styles ['datanumboldtopline']));
            $page->addPanel(new clx_report_panel($table));
        }

        /**
         * Reporte de beneficiario
         *
         * @param obj $page
         * @param obj $styles
         * @param string $comp_code
         * @param string $edate
         * @param string $contract_code
         * @param string $beneficiary_code
         */
        private function rep_beneficiary_statement_activities(&$page, &$styles, $comp_code, $edate, $contract_code, $beneficiary_code) {
            // Adding section title
            $table = new clx_report_object_table ();
            $table->addColumn(new clx_report_data('', $styles ['datadescbold']));
            $table->addRow(new clx_report_data('2. ' . dict('GEN_LBL_ACTIVITIES'), $styles ['datadescbold']));
            $page->addPanel(new clx_report_panel($table));
            // Adding
            $table = new clx_report_object_table ();
            $table->addColumn(new clx_report_data(dict('GEN_LBL_DATE'), $styles ['tbhead']));
            $table->addColumn(new clx_report_data(dict('GEN_LBL_DESCRIPTION'), $styles ['tbheaddesc']));
            $table->addColumn(new clx_report_data(dict('GEN_LBL_FOREIGN_CURRENCY'), $styles ['tbhead']));
            $table->addColumn(new clx_report_data(dict('GEN_LBL_LOCAL_CURRENCY'), $styles ['tbhead']));
            $table->addColumn(new clx_report_data(dict('GEN_LBL_COMMITED_AMOUNT'), $styles ['tbhead']));
            $comp_currency = ClxCommon::$db->getField($this->compname, 'CURRENCY_CODE', 'IDCODE = ' . singleQuote($comp_code));
            $sql = 'SELECT GDVW.COMP_CODE, GDVW.CHART_FIELD01, GDVW.CURRENCY_CODE, GDVW.EXCHANGE_RT, FIAT.BENEFICIARY_CODE, GDVW.EFFTDATE, GDVW.IDCODE, GDVW.IDNAME, SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT) BAL_TRANS_AMT, SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) BALANCE_AMT FROM FIDU_TRANSACTIONS FIAT, GL_JOURNAL_DET_VW GDVW WHERE GDVW.CHART_FIELD01 = FIAT.CHART_FIELD01 AND FIAT.IDCODE = GDVW.TRANS_CODE AND FIAT.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAT.EFFTDATE <= ' . singleQuote($edate) . ' AND GDVW.EFFTDATE <= ' . singleQuote($edate) . ' AND FIAT.BENEFICIARY_CODE = ' . singleQuote($beneficiary_code) . ' AND GDVW.GL_TYPE = ' . singleQuote('AS') . ' AND FIAT.BENEFICIARY_CODE IS NOT null AND FIAT.CHART_FIELD01 = ' . singleQuote($contract_code) . ' GROUP BY GDVW.COMP_CODE, GDVW.CHART_FIELD01, GDVW.CURRENCY_CODE, GDVW.EXCHANGE_RT, FIAT.BENEFICIARY_CODE, GDVW.EFFTDATE, GDVW.IDCODE, GDVW.IDNAME ORDER BY GDVW.EFFTDATE, GDVW.IDCODE, GDVW.IDNAME';
            $rs = ClxCommon::$db->executeQuery($sql);
            $balance = CLX_INIT_ZERO;
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $table->addRow(new clx_report_data($r ['EFFTDATE'], $styles [CLX_CLASS_DATA]));
                if ($comp_currency == $r ['CURRENCY_CODE']) {
                    $table->addRow(new clx_report_data($r ['IDNAME'], $styles ['datadesc']));
                    $table->addRow(new clx_report_data('', $styles ['datanum']));
                    $table->addRow(new clx_report_data($r ['BALANCE_AMT'], $styles ['datanum']));
                } else {
                    $table->addRow(new clx_report_data($r ['IDNAME'] . '. ' . dict('GEN_LBL_EXCHANGE_RT') . ': ' . $r ['EXCHANGE_RT'] . ' ' . $r ['CURRENCY_CODE'], $styles ['datadesc']));
                    $table->addRow(new clx_report_data($r ['BAL_TRANS_AMT'], $styles ['datanum']));
                    $table->addRow(new clx_report_data('', $styles ['datanum']));
                }
                $balance += $r ['BALANCE_AMT'];
                $table->addRow(new clx_report_data($balance, $styles ['datanum']));
            }
			ClxCommon::$db->freeResult($rs);
            $sql = 'SELECT ROUND((IN_TOTAL_AMT-EX_TOTAL_AMT)*(BALANCE_AMT/TOTAL_AMT), 2) INGRESO, AVAILABLE_AMT FROM TEMP1_TMP WHERE BENEFICIARY_CODE = ' . singleQuote($beneficiary_code);
            $r = ClxCommon::$db->getOneRecord($sql);
            $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
            $table->addRow(new clx_report_data(dict('GEN_LBL_TOTAL_DEP_WITH'), $styles ['datadescboldtopline']));
            $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
            $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
            $table->addRow(new clx_report_data(round($balance, CLX_NUM_TWO), $styles ['datanumboldtopline']));
            // Ingresos y gastos
            $table->addRow(new clx_report_data('', $styles [CLX_CLASS_DATA]));
            $table->addRow(new clx_report_data(dict('GEN_LBL_INCOME_EXPESE'), $styles ['datadesc']));
            $table->addRow(new clx_report_data('', $styles ['datanum']));
            $table->addRow(new clx_report_data('', $styles ['datanum']));
            $table->addRow(new clx_report_data(round($r ['INGRESO'], CLX_NUM_TWO), $styles ['datanum']));
            $balance += $r ['INGRESO'];
            // Otroe movimientos del fondo
            $table->addRow(new clx_report_data('', $styles [CLX_CLASS_DATA]));
            $table->addRow(new clx_report_data(dict('GEN_LBL_OTHER_OPERATIONS'), $styles ['datadesc']));
            $table->addRow(new clx_report_data('', $styles ['datanum']));
            $table->addRow(new clx_report_data('', $styles ['datanum']));
            $table->addRow(new clx_report_data(round(($r ['AVAILABLE_AMT'] - $balance), CLX_NUM_TWO), $styles ['datanum']));
            $balance += ($r ['AVAILABLE_AMT'] - $balance);
            $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
            $table->addRow(new clx_report_data(dict('GEN_LBL_TOTAL_AVAILABLE'), $styles ['datadescboldtopline']));
            $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
            $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
            $table->addRow(new clx_report_data(round($balance, CLX_NUM_TWO), $styles ['datanumboldtopline']));
            $page->addPanel(new clx_report_panel($table));
        }

        /**
         * Informacion del fondo
         *
         * @param obj $page
         * @param obj $styles
         * @param string $beneficiary_code
         */
        private function rep_beneficiary_statement_fund_info(&$page, &$styles, $beneficiary_code) {
            // Adding section title
            $table = new clx_report_object_table ();
            $table->addColumn(new clx_report_data('', $styles ['datadescbold']));
            $table->addRow(new clx_report_data('3. ' . dict('GEN_LBL_FUND_DETAILS'), $styles ['datadescbold']));
            $page->addPanel(new clx_report_panel($table));
            // Adding
            $table = new clx_report_object_table ();
            $table->addColumn(new clx_report_data('', $styles ['tbhead']));
            $table->addColumn(new clx_report_data('', $styles ['tbheaddesc']));
            $table->addColumn(new clx_report_data('', $styles ['tbhead']));
            $table->addColumn(new clx_report_data('', $styles ['tbhead']));
            $table->addColumn(new clx_report_data(dict('GEN_LBL_AMOUNT'), $styles ['tbhead']));
            $sql = 'SELECT TOTAL_AMT TOTAL_FONDO, ROUND(BALANCE_AMT/TOTAL_AMT, 5)*100 PCT_PARTICIPACION, IN_TOTAL_AMT TOTAL_INGRESO, EX_TOTAL_AMT TOTAL_GASTO, ROUND((IN_TOTAL_AMT-EX_TOTAL_AMT)/TOTAL_AMT, 5)*100 RENDIMIENTO, AVAILABLE_AMT AVAILABLE FROM TEMP1_TMP WHERE BENEFICIARY_CODE = ' . singleQuote($beneficiary_code);
            $rs = ClxCommon::$db->getOneRecord($sql);
            if (!empty($rs)) {
                foreach ($rs as $key => $val) {
                    if ($key === 'AVAILABLE') {
                        $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
                        $table->addRow(new clx_report_data(dict('GEN_LBL_' . $key), $styles ['datadescboldtopline']));
                        $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
                        $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
                        $table->addRow(new clx_report_data($val, $styles ['datanumboldtopline']));
                    } else {
                        $table->addRow(new clx_report_data('', $styles [CLX_CLASS_DATA]));
                        $table->addRow(new clx_report_data(dict('GEN_LBL_' . $key), $styles ['datadesc']));
                        $table->addRow(new clx_report_data('', $styles ['datanum']));
                        $table->addRow(new clx_report_data('', $styles ['datanum']));
                        $table->addRow(new clx_report_data($val, $styles ['datanum']));
                    }
                }
            } else {
                $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
                $table->addRow(new clx_report_data('', $styles ['datadescboldtopline']));
                $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
                $table->addRow(new clx_report_data('', $styles ['databoldtopline']));
                $table->addRow(new clx_report_data('', $styles ['datanumboldtopline']));
            }
            $page->addPanel(new clx_report_panel($table));
        }

        /**
         * Used in data warehouse report
         */
        public function rep_data_warehouse_init() {
            if (empty($_SESSION ['paging'] ['CSDW_LIST'] ['qfilter']))
                return;
            $comp_code = $_SESSION ['paging'] ['CSDW_LIST'] ['qfilter']['CSDW_COMP_CODE'];
            $loan_code = $_SESSION ['paging'] ['CSDW_LIST'] ['qfilter']['CSDW_LOAN_CODE'];
            $this->rep_data_warehouse($comp_code, $loan_code);
        }

        /**
         * Data warehouse report
         */
        private function rep_data_warehouse($comp_code, $loan_code = '', $language = 'en') {
			$language=clx_language_lower_upper($language);
           
            // Init Temporary Tables
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('CSDW'); // Clear tmp CRED_DW_REP_TMP CSDW
            $DBTB->buildTemporaryTable('CSBT'); // Clear tmp CRED_STAT_BAL_TMP CSBT
            $sql = 'INSERT INTO ' . $this->csdwname . ' (COMP_CODE, IDNAME, CONTRACT_NUMBER, PRODUCT_CODE, EXT_CLIENT_NO, IDENTIFICATION, LOAN_CODE, LEGAL_TYPE, REGION_CODE, BRANCH, LOAN_STATUS, PROP_ITEM_CLASS, PROP_ITEM_TYPE, LOAN_INTEREST, REQUESTED_AMT, LOAN_AMT, DISBURSED_AMT, PRINCIPAL_BAL, INTEREST_AMT, REFINANCED_AMT, IS_INTEREST, GUARANTEE_01_TYPE, GUARANTEE_02_TYPE, STATE, PARISH, VILLAGE, SIZE_LOT, PAID_PRINCIPAL, PAID_INTEREST, LATE_PRINCIPAL, LATE_INTEREST, OPERATION_DATE, BATCH_ID, REGION_NAME, PRODUCT_NAME, PROP_ITEM_CL_NAME, PROP_ITEM_TP_NAME, GUARANTEE_01_NAME, GUARANTEE_02_NAME, STATE_NAME, PARISH_NAME, VILLAGE_NAME) SELECT FILO.COMP_CODE, FICO.IDNAME, FICO.CONTRACT_NUMBER, FILO.PRODUCT_CODE, ACCO.IBS_CUSCUN EXT_CLIENT_NO, ACCO.IDENTIFICATION, FILO.IDCODE LOAN_CODE, ACCO.LEGAL_TYPE, COLO.REGION_CODE, FILO.BRANCH, FILO.LOAN_STATUS, FILO.PROP_ITEM_CLASS, FILO.PROP_ITEM_TYPE, FILO.LOAN_INTEREST, (FILO.DOWN_PYMT_AMT+FILO.LOAN_AMT) REQUESTED_AMT, FILO.LOAN_AMT, 0 DISBURSED_AMT, FILO.PRINCIPAL_BAL, ROUND(FILO.INTEARNED_ACC-FILO.INTEARNED_AMT, 2) INTEREST_AMT, IF(FILO.IS_REFINANCED, FILO.LOAN_AMT, 0) REFINANCED_AMT, IF(FILO.PRODUCT_CODE = ' . singleQuote('00000023') . ',1,0) IS_INTEREST, FILO.GUARANTEE_01_TYPE, FILO.GUARANTEE_02_TYPE, ACCO.STATE, ACCO.PARISH, ACCO.VILLAGE, FILO.SIZE_LOT, 0 PAID_PRINCIPAL, 0 PAID_INTEREST, IF(FILO.LOAN_STATUS<>' . singleQuote('VIG') . ',FILO.PRINCIPAL_BAL,0) LATE_PRINCIPAL, IF(FILO.LOAN_STATUS<>' . singleQuote('VIG') . ',ROUND(FILO.INTEARNED_ACC-FILO.INTEARNED_AMT, 2),0) LATE_INTEREST, GLCP.OPERATION_DATE, ' . singleQuote($this->batch_id) . ' BATCH_ID, null REGION_NAME, PROD.IDNAME PRODUCT_NAME, CLX_DBLI_ITEM_LABEL(' . singleQuote('CPIC') . ',FILO.PROP_ITEM_CLASS,' . singleQuote(clx_language_lower_upper($language)) . ') PROP_ITEM_CL_NAME, CLX_DBLI_ITEM_LABEL(' . singleQuote('CPIT') . ',FILO.PROP_ITEM_TYPE,' . singleQuote(clx_language_lower_upper($language)) . ') PROP_ITEM_TP_NAME, CLX_DBLI_ITEM_LABEL(' . singleQuote('RETY') . ',FILO.GUARANTEE_01_TYPE,' . singleQuote(clx_language_lower_upper($language)) . ') GUARANTEE_01_NAME, CLX_DBLI_ITEM_LABEL(' . singleQuote('RETY') . ',FILO.GUARANTEE_02_TYPE,' . singleQuote(clx_language_lower_upper($language)) . ') GUARANTEE_02_NAME, CLX_DBLI_ITEM_LABEL(' . singleQuote('STAT') . ',ACCO.STATE,' . singleQuote(clx_language_lower_upper($language)) . ') STATE_NAME, CLX_DBLI_ITEM_LABEL(' . singleQuote('PARI') . ',ACCO.PARISH,' . singleQuote(clx_language_lower_upper($language)) . ') PARISH_NAME, CLX_DBLI_ITEM_LABEL(' . singleQuote('POBL') . ',ACCO.VILLAGE,' . singleQuote(clx_language_lower_upper($language)) . ') VILLAGE_NAME FROM ' . $this->prodname . ' PROD, ' . $this->filoname . ' FILO, ' . $this->coloname . ' COLO, ' . $this->acconame . ' ACCO, ' . $this->ficoname . ' FICO, ' . $this->fiasname . ' FIAS, ' . $this->glcpname . ' GLCP WHERE FIAS.LOAN_CODE = FILO.IDCODE AND FILO.PRODUCT_CODE = PROD.IDCODE AND COLO.IDCODE = FILO.BRANCH AND ACCO.IDCODE = FILO.DEBTOR_CODE AND FICO.IDCODE = FIAS.CONTRACT_CODE AND GLCP.COMP_CODE = FILO.COMP_CODE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code <> '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' ' : '') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE <= NOW())';
            ClxCommon::$db->executeQuery($sql);
            //Update Regions name
            $sql = 'UPDATE ' . $this->csdwname . ' CSDW, BASE_REGIONS_TBL REGI SET CSDW.REGION_NAME = REGI.IDNAME WHERE CSDW.REGION_CODE = REGI.IDCODE';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'INSERT INTO ' . $this->csbtname . ' (LOAN_CODE, GLACCOUNTCODE, LOAN_STATUS, TRANSTBL_CODE, IS_INTEREST, BALANCE_AMT, BATCH_ID) SELECT CSDW.LOAN_CODE, JELN.GLACCOUNTCODE, CSDW.LOAN_STATUS, JEHD.TRANSTBL_CODE, IF(JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE, 0, 1) IS_INTEREST, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->fiasname . ' FIAS, ' . $this->csdwname . ' CSDW, ' . $this->pratname . ' PRAT WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE= CSDW.LOAN_CODE AND PRAT.PRODUCT_CODE = CSDW.PRODUCT_CODE AND JELN.GLACCOUNTCODE IN (PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE) AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND CSDW.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CSDW.LOAN_CODE, JELN.GLACCOUNTCODE, PRAT.PRO_GL_CODE, CSDW.LOAN_STATUS, JEHD.TRANSTBL_CODE HAVING SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) <> 0';
            ClxCommon::$db->executeQuery($sql);
            /* MONTO DESEMBOLSADO */
            $sql = 'UPDATE ' . $this->csdwname . ' CSDW, (SELECT CSBT.LOAN_CODE, SUM(CSBT.BALANCE_AMT) BALANCE_AMT FROM ' . $this->csbtname . ' CSBT WHERE CSBT.TRANSTBL_CODE IN (' . singleQuoteArray(array('SYS_CRED-DISB', 'CRED_REFREO')) . ') AND CSBT.IS_INTEREST = 0 GROUP BY CSBT.LOAN_CODE) B SET CSDW.DISBURSED_AMT = B.BALANCE_AMT WHERE CSDW.LOAN_CODE = B.LOAN_CODE AND CSDW.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* RECUPERACION CAPITAL */
            $sql = 'UPDATE ' . $this->csdwname . ' CSDW, (SELECT CSBT.LOAN_CODE, SUM(CSBT.BALANCE_AMT) BALANCE_AMT FROM ' . $this->csbtname . ' CSBT WHERE CSBT.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND CSBT.IS_INTEREST = 0 GROUP BY CSBT.LOAN_CODE) B SET CSDW.PAID_PRINCIPAL = B.BALANCE_AMT WHERE CSDW.LOAN_CODE = B.LOAN_CODE AND CSDW.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            /* RECUPERACION INTERESES */
            $sql = 'UPDATE ' . $this->csdwname . ' CSDW, (SELECT CSBT.LOAN_CODE, SUM(CSBT.BALANCE_AMT) BALANCE_AMT FROM ' . $this->csbtname . ' CSBT WHERE CSBT.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND CSBT.IS_INTEREST = 1 GROUP BY CSBT.LOAN_CODE) B SET CSDW.PAID_INTEREST = B.BALANCE_AMT WHERE CSDW.LOAN_CODE = B.LOAN_CODE AND CSDW.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
        }

        /**
         * Build Interface File
         */
        public function rep_data_warehouse_send($comp_code, $loan_code = '', $language = 'en') {
			$language=clx_language_lower_upper($language);
            if (companyParameter('IBS_DWH_CRED_ACTIVE', $comp_code) == CLX_NUM_ZERO) {
                return;
            }
            $this->rep_data_warehouse($comp_code, $loan_code, $language);
            $operation_date = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE = ' . singleQuote($comp_code));
            $filename = 'DSWF_' . str_replace('-', '', $operation_date) . '.txt';
            $fullname = kPathToExport . $filename;
            $file = new clx_file($fullname, 'w');
            $file->open();
            $sql = 'SELECT * FROM ' . $this->csdwname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                unset($r['ID'], $r['BATCH_ID']);
                foreach ($r as $key => $val) {
                    $r[$key] = str_replace(array(CLX_CHAR_NL, chr(CLX_NUM_124)), '', $val);
                }
                $line = implode(chr(CLX_NUM_124), $r) . CLX_CHAR_NL;
                $file->write($line);
            }
			ClxCommon::$db->freeResult($rs);
            $file->close();
            //FTP Upload
            $connector_ftp = companyParameter('IBS_DWH_CRED_CNX', $comp_code);
            if ($connector_ftp === true) {
                $SKCO = &getTool('SKCO');
                $cnx_rec = $SKCO->getConnector($connector_ftp);
                if (empty($cnx_rec))
                    return;
                //Set to true to send
                $verbose = false;
                $ftp = new clx_ftp($cnx_rec['IP_ADDRESS'], $cnx_rec['OTHER_USERNAME'], $cnx_rec['OTHER_PASSWORD'], $cnx_rec['PORT_NUMBER'], $verbose);
                $ftp->timeout = $cnx_rec['SOCKET_TIMEOUT'];
                $ftp->connect();
                $ftp->setPasiveMode(false);
                $ftp->change_directory($cnx_rec['CNX_DEFAULT_FOLDER'], false);
                $target_file_name = companyParameter('IBS_DWH_CRED_XFER_FILE_NAME', $comp_code);
                if ($target_file_name === '')
                    $target_file_name = $filename;
                $ftp->upload($fullname, $target_file_name, false);
                $ftp->close();
            }
        }

        /**
         * Build 'Credit Portfolio Stats Detail' Report
         * Genera Reporte de detalle de Estad�sticas de Cartera Cr�dito
         */
        function rep_cred_portfol_stat_detail($selected_report = 'CR01') {
            // 0 Build form and set request here
            $ac = UserRequest::$request ['ac'];
            $to = UserRequest::$request [CLX_PROP_TO];
            $it = UserRequest::$request ['it'];
            /*
             * 64591A42A942DA3106BC3E3C431759AA
             * Credit Portfolio Stats Report
             * Reporte Estad�stico Cartera Cr�dito
             */
            $title = dict('64591A42A942DA3106BC3E3C431759AA');
            $EDIT = &getTool('EDIT');
            $record = array();
            $msg = array();
            $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('CR01') . '');
            $record = UserRequest::$post;
            if (!empty($record ['confirm'])) {
                $EDIT->checkForm2($msg, $formrec);
            } else {
                if (!class_exists('Comp'))
                    includeCodeLib('COMP');
                $comp = new Comp ();
                $comprec = $comp->comp_operation_parameters();
                $record ['CR01_EFFTDATE'] = $comprec ['OPERATION_DATE'];
            }
            $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'pop.php', '', $title, dict('GEN_LBL_DISPLAY'), '_blank');
            $contents = $form->source();
            if (empty($record ['confirm']) || !empty($msg))
                return $contents;
            //e cho debug_dump('record', $record);
            $contents = '';
            // Builds filters
            $criteria = '';
            if (array_key_exists('CR01_DEBTOR_CODE', $record) && $record ['CR01_DEBTOR_CODE'] !== '')
                $criteria .= ' AND FILO.DEBTOR_CODE = ' . singleQuote($record ['CR01_DEBTOR_CODE']);
            if (array_key_exists('CR01_IDENTIFICATION', $record) && $record ['CR01_IDENTIFICATION'] !== '')
                $criteria .= ' AND ACCO.IDENTIFICATION = ' . singleQuote($record ['CR01_IDENTIFICATION']);
            if (array_key_exists('CR01_SEX', $record) && $record ['CR01_SEX'] !== '')
                $criteria .= ' AND ACCO.SEX = ' . singleQuote($record ['CR01_SEX']);
            if (array_key_exists('CR01_LOAN_CODE', $record) && $record ['CR01_LOAN_CODE'] !== '')
                $criteria .= ' AND FILO.IDCODE = ' . singleQuote($record ['CR01_LOAN_CODE']);
            if (array_key_exists('CR01_PROP_ITEM_CLASS', $record) && $record ['CR01_PROP_ITEM_CLASS'] !== '')
                $criteria .= ' AND FILO.PROP_ITEM_CLASS = ' . singleQuote($record ['CR01_PROP_ITEM_CLASS']);
            if (array_key_exists('CR01_PROP_ITEM_TYPE', $record) && $record ['CR01_PROP_ITEM_TYPE'] !== '')
                $criteria .= ' AND FILO.PROP_ITEM_TYPE = ' . singleQuote($record ['CR01_PROP_ITEM_TYPE']);
            if (array_key_exists('CR01_BRANCH', $record) && $record ['CR01_BRANCH'] !== '')
                $criteria .= ' AND FILO.BRANCH = ' . singleQuote($record ['CR01_BRANCH']);
            if (array_key_exists('CR01_REFINANCED', $record) && $record ['CR01_REFINANCED'] !== '')
                $criteria .= ' AND FILO.REFINANCED = ' . singleQuote($record ['CR01_REFINANCED']);
            if (array_key_exists('CR01_CONTRACT_CODE', $record) && $record ['CR01_CONTRACT_CODE'] !== '')
                $criteria .= ' AND FIAS.CONTRACT_CODE = ' . singleQuote($record ['CR01_CONTRACT_CODE']);
            if (array_key_exists('CR01_STATE', $record) && $record ['CR01_STATE'] !== '')
                $criteria .= ' AND ACCO.STATE = ' . singleQuote($record ['CR01_STATE']) . ' ';
            if (array_key_exists('CR01_CITY', $record) && $record ['CR01_CITY'] !== '')
                $criteria .= ' AND ACCO.CITY = ' . singleQuote($record ['CR01_CITY']) . ' ';
            if (array_key_exists('CR01_PARISH', $record) && $record ['CR01_PARISH'] !== '')
                $criteria .= ' AND ACCO.PARISH = ' . singleQuote($record ['CR01_PARISH']) . ' ';
            if (array_key_exists('CR01_VILLAGE', $record) && $record ['CR01_VILLAGE'] !== '')
                $criteria .= ' AND ACCO.VILLAGE = ' . singleQuote($record ['CR01_VILLAGE']) . ' ';
            $efftdate = $record ['CR01_EFFTDATE'];
            $username = $_SESSION['user_record']['username'];
            $cr01name = tableName('CR01');
            $sql = 'DELETE FROM ' . $cr01name . ' WHERE UPPER(USERNAME) = ' . singleQuote(uppercase($username));
            // pre($sql);
            ClxCommon::$db->executeQueryVoid($sql);
            $sql = ' INSERT INTO ' . $cr01name . ' ( USERNAME,  DEBTOR_CODE, IDENTIFICATION, IDNAME, SEX, COUNTRY, STATE, CITY, PARISH, VILLAGE, COTYPE,  REGION_CODE, STATE_02, CITY_02, PARISH_02, VILLAGE_02,  LOAN_CODE, PROP_ITEM_CLASS, PROP_ITEM_TYPE, BRANCH, REFINANCED, LOAN_STATUS, LOAN_AMT,  GUARANTEE_01_TYPE, GUARANTEE_02_TYPE,  EFFTDATE, START_DATE, END_DATE, CLX_AUTH_STATUS, CURRENCY_CODE, PRODUCT_CODE,  PRINCIPAL_BAL, LOAN_PERIOD_TEXT, INTEARNED_AMT, INTPAID_AMT, RESERVE_AMT, LOAN_INTEREST,  CONTRACT_CODE, CONTRACT_NAME,  DISBURSEMENT_DATE, DISBURSEMENT_AMT, PRINCIPAL_PAY, DUE_PAY_DATE, ACTUAL_AMT, LATEPYMNT_AMT, DUE_PRO_AMT, BASE_INTPAID_AMT, INTEREST_BAL_AMT ) SELECT ' . singleQuote($username) . ' USERNAME, FILO.DEBTOR_CODE, ACCO.IDENTIFICATION, ACCO.IDNAME, ACCO.SEX, ACCO.COUNTRY, ACCO.STATE, ACCO.CITY, ACCO.PARISH, ACCO.VILLAGE, ACCO.COTYPE,  COLO.REGION_CODE, COLO.STATE STATE_02, COLO.CITY CITY_02, COLO.PARISH PARISH_02, COLO.VILLAGE VILLAGE_02,  FILO.IDCODE LOAN_CODE, FILO.PROP_ITEM_CLASS, FILO.PROP_ITEM_TYPE, FILO.BRANCH, FILO.REFINANCED, FILO.LOAN_STATUS, FILO.LOAN_AMT,  FILO.GUARANTEE_01_TYPE, FILO.GUARANTEE_02_TYPE,  FILO.CLX_EFFTDATE, FILO.START_DATE, FILO.END_DATE, FILO.CLX_AUTH_STATUS, FILO.CURRENCY_CODE, FILO.PRODUCT_CODE,  /*FILO.PRINCIPAL_BAL,*/ (SELECT SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) BALANCE FROM GL_JOURNAL_DET_VW GDVW WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND GDVW.EFFTDATE<=' . singleQuote($efftdate) . ' AND EXISTS(SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE GDVW.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND FILO.PRODUCT_CODE = PRAT.PRODUCT_CODE) ) PRINCIPAL_BAL, (YEAR(FILO.START_DATE)) LOAN_PERIOD_TEXT, FILO.INTEARNED_AMT, FILO.INTPAID_AMT, FILO.RESERVE_AMT, FILO.LOAN_INTEREST,  FIAS.CONTRACT_CODE, FICO.IDname CONTRACT_NAME,  ( /* Fecha del primer desembolso desde transacciones */ SELECT MIN(FIAT.EFFTDATE) FIAT_EFFTDATE FROM FIDU_TRANSACTIONS FIAT WHERE FIAT.CHART_FIELD03 = FIAS.IDCODE AND FIAT.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-DISB') . ' AND FIAT.TRANS_STATUS = ' . singleQuote('AP') . ' AND FIAT.EFFTDATE<= ' . singleQuote($efftdate) . ' ) DISBURSEMENT_DATE, ( /* Monto de los desembolsos desde transacciones */ SELECT SUM(FIAT.TRANS_AMT) FROM FIDU_TRANSACTIONS FIAT WHERE FIAT.CHART_FIELD03 = FIAS.IDCODE AND FIAT.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-DISB') . ' AND FIAT.TRANS_STATUS = ' . singleQuote('AP') . ' AND FIAT.EFFTDATE<=' . singleQuote($efftdate) . ' ) DISBURSEMENT_AMT, ( /* Total capital recuperado */ SELECT SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT) BALANCE FROM GL_JOURNAL_DET_VW GDVW WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND GDVW.TRANSTBL_CODE = ' . singleQuote('SYS_CRED-PYMT') . ' AND GDVW.EFFTDATE<=' . singleQuote($efftdate) . ' AND EXISTS(SELECT PRAT.ID FROM GL_PROD_PRMTR_TBL PRAT WHERE GDVW.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND FILO.PRODUCT_CODE = PRAT.PRODUCT_CODE) ) PRINCIPAL_PAY,  /* CAMPOS ADICIONALES */ ( /* Fecha_de_Vencimiento, #DE PROXIMA CUOTA */ IFNULL( (SELECT MAX(FILS.DUE_PAY_DATE) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.PERIOD_START_DATE<=' . singleQuote($efftdate) . '), FILO.END_DATE ) ) DUE_PAY_DATE, ( /* Monto_Vigente, Saldo del credito a la fecha */ SELECT SUM(FILS.PRINCIPAL_PAY-FILS.PPAL_PAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE ) ACTUAL_AMT, ( /* Monto_Moroso */ SELECT SUM(FILS.PRINCIPAL_PAY-FILS.PPAL_PAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.DUE_PAY_DATE<=' . singleQuote($efftdate) . ' ) LATEPYMNT_AMT, ( /* Monto_Vencido */ SELECT SUM(FILS.PRINCIPAL_PAY-FILS.PPAL_PAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.DUE_PAY_DATE<=' . singleQuote($efftdate) . ' AND FILS.DUE_PAY_DATE<=FILO.END_DATE ) DUE_PRO_AMT, ( /* Total_Intereses_Cobrados */ SELECT SUM(FILS.INTEREST_PAY) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.DUE_PAY_DATE<=' . singleQuote($efftdate) . ' ) BASE_INTPAID_AMT, ( /* Saldo_Intereses_por_Cobrar */ SELECT SUM(FILS.INTEREST_PAY-FILS.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.DUE_PAY_DATE<=' . singleQuote($efftdate) . ' ) INTEREST_BAL_AMT FROM CRM_ACCOUNTS ACCO, BASE_COMPANY_LOCATIONS COLO, FIDU_ITEMS FIAS, FIDU_CONTRACTS FICO, CRED_CREDITS FILO WHERE ACCO.IDCODE = FILO.DEBTOR_CODE AND  COLO.IDCODE = FILO.BRANCH AND  FILO.IDCODE = FIAS.LOAN_CODE AND  FICO.IDCODE = FIAS.CONTRACT_CODE AND  FILO.START_DATE<= ' . singleQuote($efftdate) . ' AND  FILO.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM CRED_CREDITS X WHERE  X.IDCODE=FILO.IDCODE AND X.START_DATE <= ' . singleQuote($efftdate) . ') ' . $criteria . ' ORDER BY FILO.IDCODE DESC; ';
            ClxCommon::$db->executeQueryVoid($sql);
            $sql = 'UPDATE ' . $cr01name . ' SET LATEPYMNT_AMT = 0 WHERE LATEPYMNT_AMT<0';
            ClxCommon::$db->executeQuery($sql);
            // LAUNCH REPORT
            UserRequest::$request['confirm'] = '';
            $ANRP = &getTool('ANRP');
            //ClxCommon::$db->debug = true;
            $report_id = ClxCommon::$db->getField($ANRP->tablename, 'ID', 'IDCODE=' . singleQuote($selected_report));
            //ClxCommon::$db->debug = false;
            if ($report_id !== '' && !is_null($report_id)) {
                UserRequest::$request['ANRP_ID'] = $report_id;
                $contents = $ANRP->action('REPORT_BUILD', array($report_id));
            } else {
                // No report with this code...
                $contents = 'ERROR: No report with this code [' . $selected_report . ']';
            }
            //salir ( 0 );
            return $contents;
        }

    }

}