<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-29 01:48:37 -0500 (Tue, 29 Jan 2019) $
 * @version        $Rev: 10508 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class gl_accounting_reports {

    var $code = 'GLREP';
    var $modulecode; // Module Code
    var $sdate; //Start Date
    var $edate; //To date
    var $user_sdate; //This userdate
    var $comp; // Company
    var $cont; // Contract
    //Sngle currency on reports, set to true to select from one currency only
    var $single_currency = false;
    var $part = '';
    var $currency_code = 'USD';
    var $glacc; //GL Account Code
    var $period_type; //Period Type
    var $ledg; // Ledger Code
    var $level; // Reporting Level.
    var $summary;   // Summary
    var $url; //Script URL, where script is executed for links. example pop.php, tool.php, etc
    var $balances = array(); // gj code balances
    var $keepLog = false;
    var $debug = false;
    var $datestamp = '';
    var $contents = '';
    var $nolink = false;
    var $daily_closing_schedule = 'DACL';
    var $date_format = 'd/m/Y';
    var $load_fipb = false;
    var $gl_participant_acc = true; //set to false to prevent Participant Distribution balances
    var $enable_participant = true;
    var $include_level = false; // Set true to enable level question
    var $comp_address = '';
    var $rounding = CLX_NUM_FIVE;
    var $paging = false;
    var $page_total_qty = CLX_INIT_ZERO;
    var $page_limit = '';
    var $batch = false;
    var $closing_stats = false;
    var $disable_inve = false;

    /*DACA*/
    var $now;
    var $parameters = array();

    /**
     * Constructor
     */
    function __construct() {
        if (!empty($this->debug))
            echolog('Financial Balance Starting ');
        $this->datestamp = date('YmdHis');
        multiTableName($this, array('FICO', 'FIAI', 'FIPA', 'FIAT', 'INFV', 'FITB', 'FIPD', 'FIDA', 'PROC', 'FILO', 'JACP', 'FIAS', 'ACCL', 'GLAC', 'GLAG', 'DYCL', 'JEHD', 'JELN', 'ACBA', 'ACBC', 'INVO', 'APIN', 'COMP', 'LEDG', 'INFU', 'INAT', 'SETV', 'COLO', 'FIBT', 'TXTB', 'FITL', 'PREX', 'ACCO', 'ACLO', 'FIPB', 'TXRE', 'GLCP', 'IETB', 'INPR', 'FIAC', 'INFF', 'PRSP', 'PRSC', 'PRLO', 'CURR', 'INTT', 'FIBK'));
        $this->page_rpp = (!empty($_SESSION['prefs']['PAGING_RPP'])) ? $_SESSION['prefs']['PAGING_RPP'] : CLX_NUM_HUNDRED;
        $this->page_startat = (empty(UserRequest::$request['startat'])) ? CLX_NUM_ZERO : UserRequest::$request['startat'];
        $this->page_limit = $this->page_startat . ',' . $this->page_rpp;
        if (!empty(UserRequest::$request['SINGLE_CURRENCY'])) {
            $this->single_currency = true;
        }
        if (!empty(UserRequest::$request['_CONTRACT_CODE_prim']) || !empty(UserRequest::$request['_CONTRACT_CODE_prim'])) {
            getLookupValue('_CONTRACT_CODE', 'CONTRACT_CODE', UserRequest::$request);
            UserRequest::$request[$this->code . '_CONT'] = UserRequest::$request['_CONTRACT_CODE'];
        }
        if (!empty(UserRequest::$request['_PARTICIPANT_ID_prim']) || !empty(UserRequest::$request['_PARTICIPANT_ID_prim'])) {
            getLookupValue('_PARTICIPANT_ID', 'PARTICIPANT_ID', UserRequest::$request);
            UserRequest::$request[$this->code . '_PARTICIPANT_ID'] = UserRequest::$request['_PARTICIPANT_ID'];
        }
        if (!empty(UserRequest::$request['_GLACCOUNTCODE_prim']) || !empty(UserRequest::$request['_GLACCOUNTCODE_prim'])) {
            getLookupValue('_GLACCOUNTCODE', 'GLACCOUNTCODE', UserRequest::$request);
            $this->glacc = UserRequest::$request['_GLACCOUNTCODE'];
        }
        if (!empty(UserRequest::$request['CURRENCY_CODE'])) {
            $this->currency_code = UserRequest::$request['CURRENCY_CODE'];
        } else {
            $this->currency_code = ClxCommon::$db->getField($this->compname, 'CURRENCY_CODE');
        }
        if (!empty(UserRequest::$request[$this->code . '_COMP'])) {
            $this->sdate = (array_key_exists($this->code . '_SDATE', UserRequest::$request)) ? adodb_date('Y-m-d', adodb_strtotime(UserRequest::$request[$this->code . '_SDATE'])) : '';
            $this->edate = (array_key_exists($this->code . '_EDATE', UserRequest::$request)) ? adodb_date('Y-m-d', adodb_strtotime(UserRequest::$request[$this->code . '_EDATE'])) : '';
            $this->comp = UserRequest::$request[$this->code . '_COMP'];
            $this->cont = (!empty(UserRequest::$request[$this->code . '_CONT'])) ? UserRequest::$request[$this->code . '_CONT'] : '';
            $this->participant_id = (!empty(UserRequest::$request[$this->code . '_PARTICIPANT_ID'])) ? UserRequest::$request[$this->code . '_PARTICIPANT_ID'] : '';

            $this->period_type = (array_key_exists('CLOSING_PERIOD', UserRequest::$request)) ? UserRequest::$request['CLOSING_PERIOD'] : '';
            $this->level = (array_key_exists('LEVEL', UserRequest::$request)) ? UserRequest::$request['LEVEL'] : CLX_NUM_FIVE;
            if (!array_key_exists($this->code . '_SDATE', UserRequest::$request)) {
                if (!class_exists('Comp'))
                    includeCodeLib('COMP');
                $comp = new Comp();
                $comprec = $comp->comp_operation_parameters($this->comp);
                unset($comp);
                $accounting_date = explode('-', $comprec['OPERATION_DATE']);
                $this->sdate = $accounting_date[CLX_NUM_ZERO] . '-' . $accounting_date[CLX_NUM_ONE] . '-01';
                $this->edate = implode('-', $accounting_date); //xFormat::getNow('Y-m-d');
            }
        } else {
            $this->comp = '';

            $this->cont = '';
            $this->glacc = '';
            $this->ledg = '';
            $this->participant_id = '';
            $this->level = CLX_NUM_FIVE;
            $this->sdate = '';
            $this->edate = '';
            $this->user_sdate = '';
        }
        $this->modulecode = 'GL';
        $this->url = UserRequest::$server['PHP_SELF'];
        $this->print_btn = false;
        $this->maxlevel = CLX_INIT_ZERO;

        /*DACA*/
        $this->now = xformat::getNow('Y-m-d');
        $this->parameters = array(
            "SCHEDULECODE" => "DACA",
            "START_TIME" => $this->now,
            "RUNID" => batch_id(),
            "USERNAME" => $_SESSION['user_record']['username']
        );
    }

    /**
     * Returns source code
     */
    function source() {
        $contents = '';
        if ($this->print_btn) {
            $table = new htmlTable(CLX_WIDTH_ONE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
            $b = new htmlButton(dict('GEN_LBL_PRINT'));
            $b->setProp('onClick', 'javascript:open_div_window(' . singleQuote('div_to_print') . ', ' . singleQuote('Print') . ',' . singleQuote(skinPath() . '/styles.css') . ');');
            $table->addCell($b->source(), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $contents .=$table->source();
        }
        if ($this->paging) {
            $table = new htmlTable(CLX_WIDTH_13);
            $table - setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
            $url = $this->url . '?idlist=' . UserRequest::$request['idlist'] . '&it=' . UserRequest::$request['it'] . '&to=' . UserRequest::$request['to'] . '&ac=' . UserRequest::$request['ac'] . '&' . $this->code . '_SDATE=' . $this->sdate . '&' . $this->code . '_EDATE=' . $this->edate . '&wind=1&confirm=1&' . $this->code . '_COMP=' . $this->comp . '&' . $this->code . '_CONT=' . $this->cont . '&' . $this->code . '&CURRENCY_CODE=' . $this->currency_code . '&_PARTICIPANT_ID=' . $this->participant_id . '&SINGLE_CURRENCY=' . (($this->single_currency) ? CLX_NUM_ONE : CLX_NUM_ZERO);
            $buttons = '';
            if ($this->page_total_qty > $this->page_rpp) {
                if ($this->page_startat > CLX_NUM_ZERO) {
                    $buttons .= getSkinIcon('firstpagen', $url . '&startat=0', 'First Page');
                    $buttons .= getSkinIcon('prevpagen', $url . '&startat=' . max(CLX_NUM_ZERO, $this->page_startat - $this->page_rpp), 'Previous Page');
                } else {
                    $buttons .= getSkinIcon('firstpaged', '', 'First Page');
                    $buttons .= getSkinIcon('prevpaged', '', 'Previous Page');
                }
                if ($this->page_startat + $this->page_rpp < $this->page_total_qty) {
                    $buttons .= getSkinIcon('nextpagen', $url . '&startat=' . ($this->page_startat + $this->page_rpp), 'Next Page');
                    $buttons .= getSkinIcon('lastpagen', $url . '&startat=' . (intval($this->page_total_qty / $this->page_rpp) * $this->page_rpp), 'Last Page');
                } else {
                    $buttons .= getSkinIcon('nextpaged', '', 'Next Page');
                    $buttons .= getSkinIcon('lastpaged', '', 'Last Page');
                }
            } else {
                $buttons = '';
            }
            $headers = '<b>' . dict('GEN_LBL_SHOWING') . ': ' . (($this->page_total_qty > CLX_NUM_ZERO) ? ($this->page_startat + CLX_NUM_ONE) : '0') . ' ' . dict('GEN_LBL_TO') . ' ' . min($this->page_total_qty, $this->page_startat + $this->page_rpp) . ' ' . dict('GEN_LBL_OF') . ' ' . $this->page_total_qty . ' ' . dict('TOOL_UIFM_MSG_FOUNDRECORDS') . '</b>';
            $table->addCell($headers, array(CLX_PROP_ALIGN => CLX_PROP_LEFT, 'valign' => 'bottom'));
            $table->addCell($buttons, array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $contents .=$table->source();
        }
        $contents .= '<div id="div_to_print">' . $this->contents . '</div>';
        return $contents;
    }

    /**
     * Process Runs daily closing from batch without user action.
     * Sample call on batch $>php clxcron.php DACA NOW 'COMP_CODE=GFF'
     * This call should by run by DACA Process
     * @param unknown_type $comp_code
     */
    function close_process_auto() {
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $rs = $comp->list_companies();

        foreach($rs as $company) {
            $msg = array();

            $this->comp = $company;
            $this->sdate = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE = ' . singleQuote($this->comp));
            $this->edate = adodb_next_day($this->sdate);

            if($this->sdate > $this->now)
                continue;

            if (!class_exists('Jeca'))
                includeCodeLib('JECA');
            $jeca = new Jeca();
            $i = CLX_INIT_ZERO;
            while ($jeca->is_holiday($this->comp, $this->edate)) {
                $this->edate = adodb_next_day($this->edate);
                $i++;
                if ($i == CLX_NUM_HUNDRED)
                    break;
            }

            $status = $this->validate_closing($msg, array());
            if (!$status) {/*si hay error en la validación*/
                $m = "";
                foreach($msg as $valor)
                    $m .= $valor . "<br />";

                pre($this->comp);

                $this->dacl_report_exception($m, 'ERRO', 'DACA');
            }else {
                if (!class_exists('Gloq'))
                    includeCodeLib('GLOQ');
                $a = new Gloq();
                $a->pushDacl($this->comp, $this->sdate, $this->edate);
                unset($a);

                /*
                $parameters = array('COMP_CODE' => $this->comp, 'EFFTDATE' => $this->sdate, 'EDATE' => $this->edate);
                runProcess('DACL', $parameters);
                */
            }
        }
    }

    /**
     * Drop process exceptions
     *
     * @param string $msg
     * @param string $status
     * @param string $tablecode
     */
    function dacl_report_exception($msg, $status = 'ERRO', $tablecode = '') {
        /*$msg .= ' ' . dict('GEN_LBL_BATCH_ID') . ' ' . $this->batch_id . '<BR>';
        $msg .= ' ' . dict('GEN_LBL_SCHEDULE') . ' ' . $this->parameters['SCHEDULECODE'] . '<BR>';
        $msg .= ' ' . dict('GEN_LBL_START_DATE') . ': ' . $this->parameters['START_TIME'] . '<BR>';*/

        $PRPR = getTool('PRPR');
        $PRPR->report_exception($this->parameters['SCHEDULECODE'], $this->parameters['START_TIME'], $this->parameters['RUNID'], $msg, $tablecode, $status);
        echoLog($msg);

        //Sending alert to user alerts
        alrt_send($msg, 'now', $this->parameters['USERNAME']);
    }

    /**
     * Process clossing form
     *
     */
    function close_process($test = CLX_NUM_ONE) {
        $msg = array();
        if (!empty(UserRequest::$request['confirm'])) {
            $status = $this->validate_closing($msg, UserRequest::$request);
        } else {
            $status = true;
        }
        if (empty(UserRequest::$request['confirm']) || !$status) {
            if (empty($this->comp)) {
                $this->comp_dialog(dict('GL_CODE_COMPANY'), $msg);
            } else {
                $this->close_dialog(dict('GL_CODE_CLOSING'), $msg, $test);
            }
        } else {
            if (UserRequest::$post['test_closing'] == CLX_NUM_ZERO) {
                $this->daily_closing_schedule = 'DACL';
                if (!class_exists('Gloq'))
                    includeCodeLib('GLOQ');
                $a = new Gloq();
                $a->pushDacl($this->comp, $this->sdate, $this->edate);
                unset($a);
                $this->contents = note('<p aling="left"> ' .
                        dict('GL_CODE_CLOSING') . '<br>' .
                        dict('GEN_LBL_SCHED_ACTIVITY') . '</p>');
            }else {
                $this->contents = note('<p aling="left"> ' .
                        dict('GL_CODE_CLOSING') . '<br>' .
                        dict('GEN_LBL_STATUS') . ' ' . dict('GEN_LBL_OK') . '</p>');
            }
        }
    }

    /**
     * Select Company Code
     */
    function comp_dialog($title, &$msg) {
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF'], CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form->addArgument(CLX_PROP_TO, (array_key_exists(CLX_PROP_TO, UserRequest::$request)) ? UserRequest::$request[CLX_PROP_TO] : '');
        $form->addArgument('ac', (array_key_exists('ac', UserRequest::$request)) ? UserRequest::$request['ac'] : '');
        $form->addArgument('idlist', (array_key_exists('idlist', UserRequest::$request)) ? UserRequest::$request['idlist'] : '');
        $form->addArgument('it', (array_key_exists('it', UserRequest::$request)) ? UserRequest::$request['it'] : '');
        $form->addArgument('wind', '1');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
//Choose the company
        $select = new htmlSelect($this->code . '_COMP');
        $criteria = '';
        if ($_SESSION['user_record']['isadmin'] <> CLX_NUM_ONE) {
            if (!empty($_SESSION['user_record']['ACFS_sec']['COMP_CODE'])) {
                if (count($_SESSION['user_record']['ACFS_sec']['COMP_CODE']) > CLX_NUM_ONE) {
                    $criteria = ' IDCODE IN (' . singleQuote(implode("','", $_SESSION['user_record']['ACFS_sec']['COMP_CODE'])) . ')';
                } elseif (count($_SESSION['user_record']['ACFS_sec']['COMP_CODE']) == CLX_NUM_ONE) {
                    $criteria = 'IDCODE = ' . singleQuote($_SESSION['user_record']['ACFS_sec']['COMP_CODE'][CLX_NUM_ZERO]);
                }
            }
        }
        $companies = ClxCommon::$db->getRecords(tableName('COMP'), $criteria);
        while (($company = ClxCommon::$db->getNextRecord($companies))) {
            $select->addItem($company['IDCODE'] . ',' . $company['IDNAME'], $company['IDCODE'], ($this->comp == $company['IDCODE']));
        }
        $table->addCell(dict(ClxCommon::$db->getField('CLX_DB_FIELDS', 'FIELDFORMLABEL', 'FIELDNAME = ' . singleQuote('COMP_CODE') . '')), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $c = new htmlSubmit(dict('GEN_LBL_CONTINUE'), 'PRINT_DIALOG');
        $buttons = $c->source();
        if (strpos(UserRequest::$server['PHP_SELF'], 'pop.php') !== false) {
            $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
            $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $this->contents = $form->source();
    }

    function approve_clossing($test = CLX_NUM_ONE) {
        $msg = array();
        if (!empty(UserRequest::$request['confirm'])) {
            $status = $this->validate_closing($msg, UserRequest::$request);
        } else {
            $status = true;
        }
        if (empty(UserRequest::$request['confirm']) || !$status) {
            if (empty($this->comp)) {
                $this->comp_dialog_approve_closing(dict('GL_CODE_COMPANY'), $msg);
            } else {
                $this->close_dialog(dict('GL_CODE_CLOSING'), $msg, $test);
            }
        } else {
            if (UserRequest::$post['test_closing'] == CLX_NUM_ZERO) {
                $this->daily_closing_schedule = 'DACL';
                if (!class_exists('Gloq'))
                    includeCodeLib('GLOQ');
                $a = new Gloq();
                $a->pushDacl($this->comp, $this->sdate, $this->edate);
                unset($a);
                $this->contents = note('<p aling="left"> ' .
                        dict('GL_CODE_CLOSING') . '<br>' .
                        dict('GEN_LBL_SCHED_ACTIVITY') . '</p>');
            }else {
                $this->contents = note('<p aling="left"> ' .
                        dict('GL_CODE_CLOSING') . '<br>' .
                        dict('GEN_LBL_STATUS') . ' ' . dict('GEN_LBL_OK') . '</p>');
            }
        }
    }

    /**
     * Prompt period && Client to display on statement
     */
    function close_dialog2($title, &$msg, $test = CLX_NUM_ONE) {
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF'], CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);

        $form->addArgument('it', UserRequest::$request['it']);
        $form->addArgument('wind', '1');
        $form->addArgument('confirm', '1');
        $form->addArgument($this->code . '_COMP', $this->comp);
        $form->addArgument('CLOSING_PERIOD', $this->period_type);
        $form->addArgument('test_closing', $test);
//To date
        $glcprec = ClxCommon::$db->getFields($this->glcpname, 'OPERATION_DATE, CLOSING_MODE', 'COMP_CODE = ' . singleQuote($this->comp));
        $this->sdate = $glcprec['OPERATION_DATE'];
        if (empty($this->sdate)) {
            $this->sdate = xformat::getNow('Y-m-d');
        }
        $this->edate = adodb_next_day($this->sdate);
        if (empty($glcprec['CLOSING_MODE'])) {
//test if holiday
            if (!class_exists('Jeca'))
                includeCodeLib('JECA');
            $jeca = new Jeca();
            $i = CLX_INIT_ZERO;
            while ($jeca->is_holiday($this->comp, $this->edate)) {
                $this->edate = adodb_next_day($this->edate);
                $i++;
                if ($i == CLX_NUM_HUNDRED)
                    break;
            }
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $compname = ClxCommon::$db->getField($this->compname, 'IDNAME', 'IDCODE = ' . singleQuote($this->comp));
        $table->addCell(dict('GEN_LBL_COMPANY') . ': ' . $compname . ' (' . $this->comp . ')', array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
//Choose the Contract
        $form->addArgument($this->code . '_CON', CLX_NUM_ZERO);
        $field = getToolObject('DBFT', 'DATE');
//Adding settlement report
        $sql = 'SELECT COUNT(FICO.ID) FROM ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FICO.COMP_CODE = GLCP.COMP_CODE AND FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FICO.COMP_CODE =' . singleQuote($this->comp);
        $fico_settlements = ClxCommon::$db->getOne($sql);
//Adding settlement report
        $sql = 'SELECT COUNT(FIPA.ID) FROM ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FIPA.CONTRACT_CODE = FICO.IDCODE AND FICO.COMP_CODE = GLCP.COMP_CODE AND ((FIPA.END_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ') OR FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY)) AND FIPA.STATUS = ' . singleQuote('A') . ' AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FICO.COMP_CODE =' . singleQuote($this->comp);
        $fipa_settlements = ClxCommon::$db->getOne($sql);
        /* GEN_LBL_CLOSINGMSG
         * <b>Important Notice:</b><br>Please verify the following<br>
         * <li>Total contract settlements for today closing: ^1</li>
         * <li>Total participant settlements for today closing: ^2</li>
         * <li>Perform backup.</li>
         * <b>Importante:</b><br>Favor verificar los siguientes puntos antes
         * de continuar<br><li>Total de contratos a finiquitar: ^1</li>
         * <li>Total de participantes a finiquitar: ^2</li><li>Realizar
         * respaldo de la base de datos.</li>
         */
        $string = dict('GEN_LBL_CLOSINGMSG', $fico_settlements, $fipa_settlements);
        $table->addCell($string, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
//To date
        $readonly_dates = ($_SESSION['user_record']['isadmin'] == CLX_NUM_ZERO) ? true : false;
        $value = $this->sdate;
        $cell = $field->placeEditFieldObj('theForm', $msg, $value, 'DATE', $this->code . '_SDATE', 'EDATE', 'GEN_LBL_CLOSING_DATE', CLX_NUM_20, CLX_NUM_20, '', '', '', true, false, $readonly_dates);
        $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $value = $this->edate;
        $cell = $field->placeEditFieldObj('theForm', $msg, $value, 'DATE', $this->code . '_EDATE', 'EDATE', 'GEN_LBL_NEXTOPDATE', CLX_NUM_20, CLX_NUM_20, '', '', '', true, false, $readonly_dates);
        $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
//$table->addYesNo(dict('GEN_LBL_TEST'), 'test_closing',$test,0);
        if ($test === true) {
            $table->addCell(dict('GEN_LBL_TEST'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPTREQUIRED));
            $table->addCell(dict('GEN_LBL_YES'), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        }
        $table->addSeparator(CLX_CLASS_DATA);
        $c = new htmlSubmit(dict('GEN_LBL_CONTINUE'), 'PRINT_DIALOG');
        $buttons = $c->source();
        if (strpos(UserRequest::$server['PHP_SELF'], 'pop.php') !== false) {
            $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
            $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addSeparator(CLX_CLASS_DATA);
//List of settlements
        $table->addCell(dict('GEN_LBL_SETTLEMENTS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $tableWidth2 = CLX_NUM_THREE;
        $tb = new htmlTable($tableWidth2);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));

        $total = array();
        $i = CLX_INIT_ZERO;
       
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT DISTINCT FIPA.ID, FICO.CONTRACT_NUMBER, FIPA.ACCOUNTCODE, FIPA.CONTRACT_CODE, FICO.IDNAME CONTRACT_NAME, IF(FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY), 1,0) IS_FICO_SETT, ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) CLOSING_DATE FROM ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FIPA.CONTRACT_CODE = FICO.IDCODE AND FICO.COMP_CODE = GLCP.COMP_CODE AND ((FIPA.END_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ') OR FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY)) AND FIPA.STATUS = ' . singleQuote('A') . ' AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FICO.COMP_CODE =' . singleQuote($this->comp) . ' AND FIPA.ISPRIMARY = 1 LIMIT 500 ';
        
        $rs = ClxCommon::$db->executeQuery($sql);
        $temporary=true;
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if ($temporary) {
                $sql='DROP TEMPORARY TABLE IF EXISTS TEMP_BALANCE;';
                        ClxCommon::$db->executeQuery($sql);
                        $sql='CREATE TEMPORARY TABLE IF NOT EXISTS TEMP_BALANCE AS (
                                        SELECT
                                           ID,
                                          `LEDGER_CODE`,
                                          `FISCAL_PERIOD`,
                                          `GLACCOUNTCODE`,
                                          `GL_TYPE`,
                                          `TRUST_ITEM_TYPE`,
                                           COMP_CODE,
                                          `CHART_FIELD01`,
                                          `CHART_FIELD02`,
                                          `CHART_FIELD03`,
                                          `CHART_FIELD04`,
                                          `CURRENCY_CODE`,
                                          `BALANCE_AMT`,
                                           `BASE_BAL_AMT`,
                                           IF (GL_TYPE<>"AS", 1 , 0 ) NOT_TYPE_AS
                                        FROM `GL_CUR_BALANCE_VW`
                                        )';
                        ClxCommon::$db->executeQuery($sql);
                $temporary=false;
            }
                    // $sql = 'SELECT CURRENCY_CODE, -1*SUM(BALANCE_AMT) BALANCE_AMT FROM GL_CUR_BALANCE_VW WHERE GL_TYPE <> ' . singleQuote('AS') . ' AND CHART_FIELD01 = ' . singleQuote($r['CONTRACT_CODE']) . ' AND CHART_FIELD02 = ' . singleQuote($r['ACCOUNTCODE']);
            $sql = 'SELECT CURRENCY_CODE, -1*SUM(BALANCE_AMT) BALANCE_AMT FROM TEMP_BALANCE WHERE NOT_TYPE_AS=1 AND CHART_FIELD01 = ' . singleQuote($r['CONTRACT_CODE']) . ' AND CHART_FIELD02 = ' . singleQuote($r['ACCOUNTCODE']);
            $requirement = array();
            $rqs = ClxCommon::$db->executeQuery($sql);
            while (($rq = ClxCommon::$db->getNextRecord($rqs))) {
                $requirement[] = $rq['CURRENCY_CODE'] . '. ' . clx_format_currency($rq['BALANCE_AMT']);
                if (!array_key_exists($rq['CURRENCY_CODE'], $total)) {
                    $total[$rq['CURRENCY_CODE']] = (float) CLX_NUM_ZERO;
                }
                $total[$rq['CURRENCY_CODE']] += (float) $rq['BALANCE_AMT'];
            }
			ClxCommon::$db->freeResult($rqs);
            $required = implode('<br>', $requirement);
            $check = new htmlCheckBox('FIPA[]', CLX_NUM_ONE, $r['ID']);
            $lbl = $r['CONTRACT_NAME'] . ' (' . $r['CONTRACT_NUMBER'] . ') ' . dict('GEN_LBL_CLOSING_DATE') . ': ' . $r['CLOSING_DATE'];
            if ($r['IS_FICO_SETT'] == CLX_NUM_ONE) {
                $lbl .= ' * ';
            }
            $lbl .= ', ' . dict('GEN_LBL_CLOSING_DATE') . ': ' . $r['CLOSING_DATE'];
            $tb->addCells(CLX_CLASS_DATA, array($check->source(), $lbl, $required));
        }
		ClxCommon::$db->freeResult($rs);
        $t = '';
        $comma = '';
        foreach ($total as $key => $val) {
            $t = $comma . $key . ' ' . clx_format_currency($val);
            $comma = '<br>';
        }
        $tb->addCells(CLX_CLASS_DATAALT, array(CLX_CHAR_HTML_NBSP, '<b>' . dict('GEN_LBL_TOTAL') . '</b>', '<b>' . $t . '</b>'));
        $table->addCell($tb->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $this->contents = $form->source();
    }
/**
     * Prompt period && Client to display on statement
     */
    function close_dialog($title, &$msg, $test = CLX_NUM_ONE) {
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF'], CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);

        $form->addArgument('it', UserRequest::$request['it']);
        $form->addArgument('wind', '1');
        $form->addArgument('confirm', '1');
        $form->addArgument($this->code . '_COMP', $this->comp);
        $form->addArgument('CLOSING_PERIOD', $this->period_type);
        $form->addArgument('test_closing', $test);
//To date
        $glcprec = ClxCommon::$db->getFields($this->glcpname, 'OPERATION_DATE, CLOSING_MODE', 'COMP_CODE = ' . singleQuote($this->comp));
        $this->sdate = $glcprec['OPERATION_DATE'];
        if (empty($this->sdate)) {
            $this->sdate = xformat::getNow('Y-m-d');
        }
        $this->edate = adodb_next_day($this->sdate);
        if (empty($glcprec['CLOSING_MODE'])) {
//test if holiday
            if (!class_exists('Jeca'))
                includeCodeLib('JECA');
            $jeca = new Jeca();
            $i = CLX_INIT_ZERO;
            while ($jeca->is_holiday($this->comp, $this->edate)) {
                $this->edate = adodb_next_day($this->edate);
                $i++;
                if ($i == CLX_NUM_HUNDRED)
                    break;
            }
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $compname = ClxCommon::$db->getField($this->compname, 'IDNAME', 'IDCODE = ' . singleQuote($this->comp));
        $table->addCell(dict('GEN_LBL_COMPANY') . ': ' . $compname . ' (' . $this->comp . ')', array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
//Choose the Contract
        $form->addArgument($this->code . '_CON', CLX_NUM_ZERO);
        $field = getToolObject('DBFT', 'DATE');
//Adding settlement report
        $sql = 'SELECT COUNT(FICO.ID) FROM ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FICO.COMP_CODE = GLCP.COMP_CODE AND FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FICO.COMP_CODE =' . singleQuote($this->comp);
        $fico_settlements = ClxCommon::$db->getOne($sql);
//Adding settlement report
        $sql = 'SELECT COUNT(FIPA.ID) FROM ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FIPA.CONTRACT_CODE = FICO.IDCODE AND FICO.COMP_CODE = GLCP.COMP_CODE AND ((FIPA.END_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ') OR FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY)) AND FIPA.STATUS = ' . singleQuote('A') . ' AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FICO.COMP_CODE =' . singleQuote($this->comp);
        $fipa_settlements = ClxCommon::$db->getOne($sql);
        /* GEN_LBL_CLOSINGMSG
         * <b>Important Notice:</b><br>Please verify the following<br>
         * <li>Total contract settlements for today closing: ^1</li>
         * <li>Total participant settlements for today closing: ^2</li>
         * <li>Perform backup.</li>
         * <b>Importante:</b><br>Favor verificar los siguientes puntos antes
         * de continuar<br><li>Total de contratos a finiquitar: ^1</li>
         * <li>Total de participantes a finiquitar: ^2</li><li>Realizar
         * respaldo de la base de datos.</li>
         */
        $string = dict('GEN_LBL_CLOSINGMSG', $fico_settlements, $fipa_settlements);
        $table->addCell($string, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
//To date
        $readonly_dates = ($_SESSION['user_record']['isadmin'] == CLX_NUM_ZERO) ? true : false;
        $value = $this->sdate;
        $cell = $field->placeEditFieldObj('theForm', $msg, $value, 'DATE', $this->code . '_SDATE', 'EDATE', 'GEN_LBL_CLOSING_DATE', CLX_NUM_20, CLX_NUM_20, '', '', '', true, false, $readonly_dates);
        $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $value = $this->edate;
        $cell = $field->placeEditFieldObj('theForm', $msg, $value, 'DATE', $this->code . '_EDATE', 'EDATE', 'GEN_LBL_NEXTOPDATE', CLX_NUM_20, CLX_NUM_20, '', '', '', true, false, $readonly_dates);
        $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
//$table->addYesNo(dict('GEN_LBL_TEST'), 'test_closing',$test,0);
        if ($test === true) {
            $table->addCell(dict('GEN_LBL_TEST'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPTREQUIRED));
            $table->addCell(dict('GEN_LBL_YES'), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        }
        $table->addSeparator(CLX_CLASS_DATA);
        $c = new htmlSubmit(dict('GEN_LBL_CONTINUE'), 'PRINT_DIALOG');
        $buttons = $c->source();
        if (strpos(UserRequest::$server['PHP_SELF'], 'pop.php') !== false) {
            $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
            $buttons .= $c->source();
        }
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addSeparator(CLX_CLASS_DATA);
//List of settlements
        $table->addCell(dict('GEN_LBL_SETTLEMENTS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $tableWidth2 = CLX_NUM_THREE;
        $tb = new htmlTable($tableWidth2);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));

        $total = array();
        $i = CLX_INIT_ZERO;
       
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT DISTINCT FIPA.ID, FICO.CONTRACT_NUMBER, FIPA.ACCOUNTCODE, FIPA.CONTRACT_CODE, FICO.IDNAME CONTRACT_NAME, IF(FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY), 1,0) IS_FICO_SETT, ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) CLOSING_DATE FROM ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP WHERE FIPA.CONTRACT_CODE = FICO.IDCODE AND FICO.COMP_CODE = GLCP.COMP_CODE AND ((FIPA.END_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ') OR FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY)) AND FIPA.STATUS = ' . singleQuote('A') . ' AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FICO.COMP_CODE =' . singleQuote($this->comp) . ' AND FIPA.ISPRIMARY = 1 LIMIT 500 ';
        
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (!isset($finiquitos)) {
                    $sql='SELECT CURRENCY_CODE, -1*SUM(BALANCE_AMT) BALANCE_AMT, CHART_FIELD01  ,CHART_FIELD02  FROM
                            (SELECT 
                              0                        AS `ID`,
                              `a`.`LEDGER_CODE`        AS `LEDGER_CODE`,
                              `a`.`FISCAL_PERIOD`      AS `FISCAL_PERIOD`,
                              `a`.`GLACCOUNTCODE`      AS `GLACCOUNTCODE`,
                              `glac`.`GL_TYPE`         AS `GL_TYPE`,
                              `glac`.`TRUST_ITEM_TYPE` AS `TRUST_ITEM_TYPE`,
                              `a`.`COMP_CODE`          AS `COMP_CODE`,
                              `a`.`CHART_FIELD01`      AS `CHART_FIELD01`,
                              `a`.`CHART_FIELD02`      AS `CHART_FIELD02`,
                              `a`.`CHART_FIELD03`      AS `CHART_FIELD03`,
                              `a`.`CHART_FIELD04`      AS `CHART_FIELD04`,
                              `a`.`CURRENCY_CODE`      AS `CURRENCY_CODE`,
                              SUM(`a`.`BALANCE_AMT`)   AS `BALANCE_AMT`,
                              SUM(`a`.`BASE_BAL_AMT`)  AS `BASE_BAL_AMT`
                            FROM `gl_ledgers` `a` 
                                JOIN `gl_codes_tbl` `glac` ON `glac`.`IDCODE` = `a`.`GLACCOUNTCODE`
                                JOIN `gl_parameters_tbl` `glcp` ON  `glac`.`GLGROUP_CODE` = `glcp`.`GLGROUP_CODE` AND `glcp`.`COMP_CODE` = `a`.`COMP_CODE` AND glac.GL_TYPE<>'. singleQuote('AS').' 
                            WHERE EXISTS( 
                            SELECT   1
                            FROM FIDU_PARTICIPANTS FIPA,
                                 FIDU_CONTRACTS FICO, 
                                 GL_PARAMETERS_TBL   GLCP 
                            WHERE FIPA.CONTRACT_CODE = FICO.IDCODE AND FICO.COMP_CODE = GLCP.COMP_CODE 
                                  AND ((FIPA.END_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY) AND FICO.CONTRACT_STATUS = '. singleQuote('ACTI').'  OR 
                                        FICO.CANCEL_DATE = ADDDATE(GLCP.OPERATION_DATE, INTERVAL 1 DAY)) AND FIPA.STATUS = '. singleQuote('A').' 
                                        AND FICO.CONTRACT_STATUS ='. singleQuote('ACTI').' AND FICO.COMP_CODE =' . singleQuote($this->comp) . '
                                        AND FIPA.ISPRIMARY = 1)
                                        AND a.CHART_FIELD01 = FIPA.CONTRACT_CODE  AND a.CHART_FIELD02 = FIPA.ACCOUNTCODE
                            )
                            GROUP BY `a`.`LEDGER_CODE`,`a`.`FISCAL_PERIOD`,`a`.`GLACCOUNTCODE`,`a`.`COMP_CODE`,`a`.`CHART_FIELD01`,`a`.`CHART_FIELD02`,`a`.`CHART_FIELD03`,`a`.`CHART_FIELD04`,`a`.`CURRENCY_CODE`
                        ) A GROUP BY CHART_FIELD01  ,CHART_FIELD02,CURRENCY_CODE';
                    
                    $rqs = ClxCommon::$db->executeQuery($sql);
                while (($rq = ClxCommon::$db->getNextRecord($rqs))) {
                    $finiquitos[$rq['CHART_FIELD01']][$rq['CHART_FIELD02']][] =array('BALANCE_AMT'=>$rq['BALANCE_AMT'],'CURRENCY_CODE'=> $rq['CURRENCY_CODE']);
                }
				ClxCommon::$db->freeResult($rqs);

            }
			ClxCommon::$db->freeResult($rs);
            $requirement = array();
            if(isset($finiquitos) && !empty($finiquitos[$r['CONTRACT_CODE']][$r['ACCOUNTCODE']]))
                $rqs = $finiquitos[$r['CONTRACT_CODE']][$r['ACCOUNTCODE']];
            else
                $rqs = array();
            for ($q=0;$q<count($rqs);$q++){
                $rq=$rqs[$q]; 
                $requirement[] = '<td class="data">'.$rq['CURRENCY_CODE'] . '</td><td class="data" style="font-weight:300;text-align:right;">' .  clx_format_currency($rq['BALANCE_AMT'])."<td>";
                if (!array_key_exists($rq['CURRENCY_CODE'], $total)) {
                    $total[$rq['CURRENCY_CODE']] = (float) CLX_NUM_ZERO;
                }
                $total[$rq['CURRENCY_CODE']] += (float) $rq['BALANCE_AMT'];
            }    
            $required = '<table border=0 CELLSPACING=0 CELLPADDING=0 ><tr>'.implode('</tr><tr>', $requirement)."</table>";
            $check = new htmlCheckBox('FIPA[]', CLX_NUM_ONE, $r['ID']);
            $lbl = $r['CONTRACT_NAME'] . ' (' . $r['CONTRACT_NUMBER'] . ') ' . dict('GEN_LBL_CLOSING_DATE') . ': ' . $r['CLOSING_DATE'];
            if ($r['IS_FICO_SETT'] == CLX_NUM_ONE) {
                $lbl .= ' * ';
            }
            $lbl .= ', ' . dict('GEN_LBL_CLOSING_DATE') . ': ' . $r['CLOSING_DATE'];
            $tb->addCells(CLX_CLASS_DATA, array($check->source(), $lbl, $required));
        }
        $comma = '';
        $tot='';
        foreach ($total as $key => $val) {
            $tot.= '<tr><td class="data" style="font-weight:700;">'.$key . '</td><td class="data" style="font-weight:700;text-align:right;">' .  clx_format_currency($val)."<td></tr>";
        }
        $tb->addCells(CLX_CLASS_DATAALT, array(CLX_CHAR_HTML_NBSP, '<b>' . dict('GEN_LBL_TOTAL') . '</b>', '<table border=0 CELLSPACING=0 CELLPADDING=0 >' . $tot . '</table>'));
        $table->addCell($tb->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $this->contents = $form->source();
    }

    /**
     * Closing Dialog Validation
     */
    function validate_closing(&$msg, $record) {
        if (!class_exists('Infa'))
            includeCodeLib('INFA');
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $oper = $comp->comp_operation_parameters($this->comp);
        //validanto fechas
        if (empty($this->sdate)) {
            $msg[$this->code . '_SDATE'] = smsg('MSG-135');
        }
        $sdate = adodb_strtotime($this->sdate);
        if ($sdate < CLX_NUM_ZERO) {
            $msg[$this->code . '_SDATE'] = smsg('MSG-135');
        }
        if (empty($this->edate)) {
            $msg[$this->code . '_EDATE'] = smsg('MSG-136');
        }
        $edate = adodb_strtotime($this->edate);
        if ($edate < CLX_NUM_ZERO) {
            $msg[$this->code . '_EDATE'] = smsg('MSG-136');
        }

        if ($oper['OPERATION_DATE'] <> xFormat::date($this->sdate, 'Y-m-d')) {
            $msg[$this->code . '_EDATE'] = smsg('MSG-137');
        }

        //Validando renovaciones pendiente por autorizacion
        $sql = 'SELECT FIBN.BANKACT_CODE FROM CD_RENEWALS FIBN, FIDU_BANK_ACCOUNTS FIBK WHERE FIBN.BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIBK.COMP_CODE = ' . singleQuote($this->comp) . ' AND FIBN.CLX_AUTH_STATUS IN ("PEAP","PEND") AND FIBN.CLX_EFFTDATE<=' . singleQuote($oper['OPERATION_DATE']) . ' LIMIT 100';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (empty($msg[$this->code . '_SDATE']))
                $msg[$this->code . '_SDATE'] = '';
            $msg[$this->code . '_SDATE'] .= smsg('MSG-487', $r['BANKACT_CODE']) . '<br>';
        }
		ClxCommon::$db->freeResult($rs);

        //Validando renovaciones pendiente por autorizacion
        $sql = 'SELECT INVR.INVESTMENT_CODE FROM INVE_RENEWALS INVR WHERE INVR.COMP_CODE = ' . singleQuote($this->comp) . ' AND INVR.CLX_AUTH_STATUS IN ("PEAP","PEND") AND INVR.CLX_EFFTDATE<=' . singleQuote($oper['OPERATION_DATE']) . ' LIMIT 100';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (empty($msg[$this->code . '_SDATE']))
                $msg[$this->code . '_SDATE'] = '';
            $msg[$this->code . '_SDATE'] .= smsg('MSG-488', $r['INVESTMENT_CODE']) . '<br>';
        }

        $validate_closing = companyParameter('GL_VALIDATE_EXCHANGE');
        if (!empty($validate_closing)) {
            $sql = 'SELECT A.IDCODE FROM (SELECT DISTINCT IDCODE FROM BASE_CURRENCY_CONVERSIONS WHERE FOREIGN_CURRENCY <> BASE_CURRENCY) A WHERE NOT EXISTS (SELECT CURR.ID FROM BASE_CURRENCY_CONVERSIONS CURR WHERE CURR.IDCODE = A.IDCODE AND CURR.CLX_EFFTDATE = ' . singleQuote($adodb_next_day($oper['OPERATION_DATE'])) . ')';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                if (!array_key_exists($this->code . '_SDATE', $msg))
                    $msg[$this->code . '_SDATE'] = smsg('MSG-464', $r['IDCODE']);
                else
                    $msg[$this->code . '_SDATE'] .= ', ' . smsg('MSG-464', $r['IDCODE']);
            }
			ClxCommon::$db->freeResult($rs);
        }
        $sql = 'SELECT COUNT(ID) FROM GL_OPERATION_QUEUE WHERE REC_STATUS = ' . singleQuote('IDLE') . ' AND GLOQ_TYPE = ' . singleQuote('DACL') . ' AND COMP_CODE = ' . singleQuote($this->comp);
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $msg[$this->code . '_SDATE'] = dict('GEN_LBL_ALREADYEXISTS');
        }
        //validando actividades en status pendiente
        if (empty($this->disable_inve)) {
            $sql = 'SELECT COUNT(INAT.ID) FROM ' . $this->inatname . ' INAT, ' . $this->infuname . ' INFU WHERE INFU.IDCODE = INAT.PORTFOLIO_CODE AND INAT.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND INFU.STATUS = ' . singleQuote('A') . ' AND INFU.COMP_CODE = ' . singleQuote($this->comp) . ' AND INAT.REAL_DATE <= ' . singleQuote($this->sdate);
            $qty = ClxCommon::$db->getOne($sql);
            if ($qty <> CLX_NUM_ZERO) {
                /*
                 * GEN_ERR_STILLPENDINVTRANS
                 * Some investment activities for ^1 are still pending
                 * No puede cerrar con transacciones al ^1 pendientes
                 */
                $msg[$this->code . '_SDATE'] = smsg('MSG-139', $this->sdate, $qty);
                $sql = 'SELECT INAT.IDCODE, INAT.INVEST_ACTIVITY IDNAME, INAT.PORTFOLIO_CODE TRANSTBL_CODE FROM ' . $this->inatname . ' INAT, ' . $this->infuname . ' INFU WHERE INFU.IDCODE = INAT.PORTFOLIO_CODE AND INAT.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND INFU.STATUS = ' . singleQuote('A') . ' AND INFU.COMP_CODE = ' . singleQuote($this->comp) . ' AND INAT.REAL_DATE <= ' . singleQuote($this->sdate);
                $rs = ClxCommon::$db->executeQuery($sql);
                $i = CLX_INIT_ZERO;
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $msg[$this->code . '_SDATE'] .= '<li>' . $r['IDCODE'] . ' - ' . $r['IDNAME'] . ' - ' . $r['TRANSTBL_CODE'] . '</li>';
                    $i++;
                }
				ClxCommon::$db->freeResult($rs);
                if ($i < $qty) {
                    $msg[$this->code . '_SDATE'] .= '<li>...+' . ($qty - $i) . '</li>';
                }
            }
        }
        //Validando faturas por cobrar pendientes por aprobacion
        if (!empty($this->invoname)) {
            //valindando asientos en estado pendiente
            $sql = 'SELECT COUNT(ID) FROM ' . $this->invoname . ' WHERE COMP_CODE = ' . singleQuote($this->comp) . ' AND INVOICEDATE <= ' . singleQuote($this->sdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
            $qty = ClxCommon::$db->getOne($sql);
            if ($qty <> CLX_NUM_ZERO) {
                $msg[$this->code . '_SDATE'] = smsg('MSG-313', $this->sdate, $qty);
                $sql = 'SELECT IDCODE, IDNAME FROM ' . $this->invoname . '  WHERE COMP_CODE = ' . singleQuote($this->comp) . ' AND INVOICEDATE <= ' . singleQuote($this->sdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
                $rs = ClxCommon::$db->executeQuery($sql);
                $i = CLX_INIT_ZERO;
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $msg[$this->code . '_SDATE'] .= '<li>' . $r['IDCODE'] . ' - ' . $r['IDNAME'] . '</li>';
                    $i++;
                }
				ClxCommon::$db->freeResult($rs);
                if ($i < $qty) {
                    $msg[$this->code . '_SDATE'] .= '<li>...+' . ($qty - $i) . '</li>';
                }
            }
        }
        //Validando facturas por pagar
        if (!empty($this->apinname)) {
            //valindando asientos en estado pendiente
            $sql = 'SELECT COUNT(ID) FROM ' . $this->apinname . ' WHERE COMP_CODE = ' . singleQuote($this->comp) . ' AND INVOICEDATE <= ' . singleQuote($this->sdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
            $qty = ClxCommon::$db->getOne($sql);
            if ($qty <> CLX_NUM_ZERO) {
                $msg[$this->code . '_SDATE'] = smsg('MSG-314', $this->sdate, $qty);
                $sql = 'SELECT IDCODE, IDNAME FROM ' . $this->apinname . ' WHERE COMP_CODE = ' . singleQuote($this->comp) . ' AND INVOICEDATE <= ' . singleQuote($this->sdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
                $rs = ClxCommon::$db->executeQuery($sql);
                $i = CLX_INIT_ZERO;
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $msg[$this->code . '_SDATE'] .= '<li>' . $r['IDCODE'] . ' - ' . $r['IDNAME'] . '</li>';
                    $i++;
                }
				ClxCommon::$db->freeResult($rs);
                if ($i < $qty) {
                    $msg[$this->code . '_SDATE'] .= '<li>...+' . ($qty - $i) . '</li>';
                }
            }
        }
        //valindando asientos en estado pendiente
        $sql = 'SELECT COUNT(JEHD.ID) FROM ' . $this->jehdname . ' JEHD WHERE JEHD.JE_STATUS NOT IN (' . singleQuoteArray(array('AP', 'REJ', 'CLOS')) . ')  AND JEHD.JE_SOURCE NOT IN (' . singleQuoteArray(array('GLAR', 'GLCL')) . ') AND JEHD.COMP_CODE = ' . singleQuote($this->comp) . ' AND JEHD.REAL_DATE <= ' . singleQuote($this->sdate);
        $qty = ClxCommon::$db->getOne($sql);
        if ($qty <> CLX_NUM_ZERO) {
            /*
             * GEN_ERR_STILLPENDINVTRANS
             * Some investment activities for ^1 are still pending
             * No puede cerrar con transacciones al ^1 pendientes
             */
            $msg[$this->code . '_SDATE'] = smsg('MSG-140', $this->sdate, $qty);
            $sql = 'SELECT JEHD.IDCODE,JEHD.IDNAME, JEHD.TRANSTBL_CODE FROM ' . $this->jehdname . ' JEHD WHERE JEHD.JE_STATUS NOT IN (' . singleQuoteArray(array('AP', 'REJ', 'CLOS')) . ')  AND JEHD.JE_SOURCE NOT IN (' . singleQuoteArray(array('GLAR', 'GLCL')) . ') AND JEHD.COMP_CODE = ' . singleQuote($this->comp) . ' AND JEHD.REAL_DATE <= ' . singleQuote($this->sdate);
            $rs = ClxCommon::$db->executeQuery($sql);
            $i = CLX_INIT_ZERO;
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $msg[$this->code . '_SDATE'] .= '<li>' . $r['IDCODE'] . ' - ' . $r['IDNAME'] . ' - ' . $r['TRANSTBL_CODE'] . '</li>';
                $i++;
            }
            if ($i < $qty) {
                $msg[$this->code . '_SDATE'] .= '<li>...+' . ($qty - $i) . '</li>';
            }
        }
        //validando operaciones en estatus pendiente
        $sql = 'SELECT COUNT(FIAT.ID) FROM ' . $this->fiatname . ' FIAT, ' . $this->ficoname . ' FICO WHERE FIAT.CHART_FIELD01 = FICO.IDCODE AND FIAT.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FICO.COMP_CODE = ' . singleQuote($this->comp) . ' AND FIAT.REAL_DATE <= ' . singleQuote($this->sdate);
        $qty = ClxCommon::$db->getOne($sql);
        if ($qty > CLX_NUM_ZERO) {
            /**
             * GEN_ERR_STILLPENDTRANS
             * Some transaction as of ^1 are still pending for approval
             * No puede cerrar con transacciones menores al ^1 pendientes
             */
            $msg[$this->code . '_SDATE'] = smsg('MSG-138', $this->sdate, $qty);
            $sql = 'SELECT FIAT.IDCODE, FIAT.IDNAME, FIAT.TRANSTBL_CODE FROM ' . $this->fiatname . ' FIAT, ' . $this->ficoname . ' FICO WHERE FIAT.CHART_FIELD01 = FICO.IDCODE AND FIAT.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND FICO.COMP_CODE = ' . singleQuote($this->comp) . ' AND FIAT.REAL_DATE <= ' . singleQuote($this->sdate) . ' LIMIT 25';
            $rs = ClxCommon::$db->executeQuery($sql);
            $i = CLX_INIT_ZERO;
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $msg[$this->code . '_SDATE'] .= '<li>' . $r['IDCODE'] . ' - ' . $r['IDNAME'] . ' - ' . $r['TRANSTBL_CODE'] . '</li>';
                $i++;
            }
			ClxCommon::$db->freeResult($rs);
            if ($i < $qty) {
                $msg[$this->code . '_SDATE'] .= '<li>...+' . ($qty - $i) . '</li>';
            }
        }
        //Validando faturas por cobrar pendientes por aprobacion
        if (!empty($this->invoname)) {
            //valindando asientos en estado pendiente 
            $sql = 'SELECT COUNT(ID) FROM ' . $this->invoname . ' WHERE COMP_CODE = ' . singleQuote($this->comp) . ' AND INVOICEDATE <= ' . singleQuote($this->sdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
            $qty = ClxCommon::$db->getOne($sql);
            if ($qty <> CLX_NUM_ZERO) {
                $msg[$this->code . '_SDATE'] = smsg('MSG-313', $this->sdate, $qty);
                $sql = 'SELECT IDCODE, IDNAME FROM ' . $this->invoname . ' WHERE COMP_CODE = ' . singleQuote($this->comp) . ' AND INVOICEDATE <= ' . singleQuote($this->sdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
                $rs = ClxCommon::$db->executeQuery($sql);
                $i = CLX_INIT_ZERO;
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $msg[$this->code . '_SDATE'] .= '<li>' . $r['IDCODE'] . ' - ' . $r['IDNAME'] . '</li>';
                    $i++;
                }
				ClxCommon::$db->freeResult($rs);
                if ($i < $qty) {
                    $msg[$this->code . '_SDATE'] .= '<li>...+' . ($qty - $i) . '</li>';
                }
            }
        }
        //Validando facturas por pagar
        if (!empty($this->apinname)) {
            //valindando asientos en estado pendiente
            $sql = 'SELECT COUNT(ID) FROM ' . $this->apinname . ' WHERE COMP_CODE = ' . singleQuote($this->comp) . ' AND INVOICEDATE <= ' . singleQuote($this->sdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
            $qty = ClxCommon::$db->getOne($sql);
            if ($qty <> CLX_NUM_ZERO) {
                if (isset($msg[$this->code . '_SDATE']))
                    $msg[$this->code . '_SDATE'] .= smsg('MSG-314', $this->sdate, $qty);    
                else        
                    $msg[$this->code . '_SDATE'] = smsg('MSG-314', $this->sdate, $qty);
                $sql = 'SELECT IDCODE, IDNAME FROM ' . $this->apinname . ' WHERE COMP_CODE = ' . singleQuote($this->comp) . ' AND INVOICEDATE <= ' . singleQuote($this->sdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
                $rs = ClxCommon::$db->executeQuery($sql);
                $i = CLX_INIT_ZERO;
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    $msg[$this->code . '_SDATE'] .= '<li>' . $r['IDCODE'] . ' - ' . $r['IDNAME'] . '</li>';
                    $i++;
                }
				ClxCommon::$db->freeResult($rs);
                if ($i < $qty) {
                    $msg[$this->code . '_SDATE'] .= '<li>...+' . ($qty - $i) . '</li>';
                }
            }
        }

        //Validacion de parametrizacion.
        //Transaccion de desincorporacion
        $trans = array('SYS_DESIN', 'SYS_PER', 'SYS_CAP', 'SYS_GAS');
        foreach ($trans as $key => $val) {
            if (ClxCommon::$db->oneExistsRecords($this->fitbname, 'IDCODE = ' . singleQuote($val)) == CLX_NUM_ZERO) {
                $msg[$this->code . '_SDATE'] = smsg('MSG-141', $val);
                break;
            }
        }
        //Verificar que exista periodo fiscal
        $last_period = $comp->comp_fiscal_period($this->comp, $this->edate);
        if (empty($last_period)) {
            $msg[$this->code . '_EDATE'] = smsg('MSG-83');
        }
        //Validaciones de desincorporacion
        $settle = (!empty(UserRequest::$post['FICO']) || !empty(UserRequest::$post['FIPA'])) ? true : false;
        if ($settle === true) {
            if (!class_exists('fidu_settlement')) {
                includeCodeLib('SETT');
            }
            $sett = new fidu_settlement();
            $sett->validate($this->comp, $msg);
            unset($sett);
        }
        if (empty($this->disable_inve)) {
            $infa = new Infa();
            $instruments = $infa->has_invalid_gl_for_earnings($this->comp);
            if (!empty($instruments)) {
                $msg[$this->code . '_EDATE'] = smsg('MSG-144', $instruments);
            }
        }//disable inve
        if (!empty($this->filoname)) {
            $sql = 'SELECT COUNT(FILO.IDCODE) FROM ' . $this->filoname . ' FILO WHERE FILO.START_DATE = ' . singleQuote($this->sdate) . ' AND FILO.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.COMP_CODE= FILO.COMP_CODE AND FILOX.CLX_EFFTDATE<=NOW()) AND FILO.COMP_CODE = ' . singleQuote($this->comp);
            $qty = ClxCommon::$db->getOne($sql);
            if ($qty > CLX_NUM_ZERO) {
                $msg[$this->code . '_SDATE'] = smsg('MSG-260', $qty, $this->sdate);
            }
            /*$sql = 'SELECT MAX(FILO.IDCODE) FROM ' . $this->filoname . ' FILO WHERE FILO.START_DATE = ' . singleQuote($this->sdate) . ' AND FILO.LOAN_STATUS NOT IN (' . singleQuote('CAN') . ',' . singleQuote('VOID') . ') AND FILO.LOAN_AMT > FILO.PRINCIPAL_BAL AND FILO.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.COMP_CODE= FILO.COMP_CODE AND FILOX.CLX_EFFTDATE<=NOW()) AND FILO.COMP_CODE = ' . singleQuote($this->comp);
            $qty = ClxCommon::$db->getOne($sql);
            if (!empty($qty)) {
                $msg[$this->code . '_SDATE'] = smsg('MSG-402', $qty, $this->sdate);
            }*/
        }
        return (!empty($msg)) ? false : true;
    }

    /**
     * Daily Closing Process
     */
    function daily_closing($parameters) {
        //Preservando parametros iniciales para interfaz contable. de no existir los valores guardan ya que en llamadas recurrentes se pierde el valor original.
        if (empty($parameters['ORIGINAL_PRMTS'])) {
            $parameters['ORIGINAL_PRMTS'] = $parameters;
        }
        $this->process_parameters = $parameters;
        $schedule_code = $parameters['SCHEDULECODE'];
        $comp_code = $parameters['COMP_CODE'];
        $efftdate = $parameters['EFFTDATE'];
        $edate = $parameters['EDATE'];
        $this->comp = $comp_code;
        $this->run_id = $parameters['RUNID'];
        $this->start_time = microtime_float();
        echoLog('');
        echoLog('------------------------------------------------');
        echoLog('DACL started: ' . $efftdate . '->' . $edate . ' Comp:' . $comp_code);
        echoLog('------------------------------------------------');
        echoLog('');

        if ($this->closing_stats) {
            ClxCommon::$db->buldStats();
            ClxCommon::$db->clearSpool();
            echoLog('Reindexing DB Catalogs: ok. Elapse: ' . $this->getElapseTime());
        }
        echoLog('Clear spool: ok. Elapse: ' . $this->getElapseTime());
        //Clear exceptions and ending any pending job
        $sql = 'UPDATE CLX_PR_PROC_LOGS PRLO SET PRLO.PROC_STATUS = ' . singleQuote('ERRO') . ' WHERE PRLO.PROCESSCODE = ' . singleQuote('DACL') . ' AND PRLO.PROC_STATUS = ' . singleQuote('RUN') . ' AND PRLO.SCHEDULECODE =' . singleQuote($schedule_code) . ' AND PRLO.ID <> ' . $this->run_id;
        ClxCommon::$db->executeQuery($sql);

        $sql = 'DELETE X.* FROM CLX_PR_EXCEPT_LOGS X WHERE X.SCHEDULECODE = ' . singleQuote('DACL') . ' AND EXISTS(SELECT JEHD.ID FROM GL_JOURNAL_HDR JEHD WHERE JEHD.ID = X.RECORDID AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ') ';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE X.* FROM CLX_PR_EXCEPT_LOGS X WHERE X.SCHEDULECODE = ' . singleQuote('DACL') . ' AND NOT EXISTS(SELECT JEHD.ID FROM GL_JOURNAL_HDR JEHD WHERE JEHD.ID = X.RECORDID)';
        ClxCommon::$db->executeQuery($sql);
        echoLog('Clearing logs: ok. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        //Validate Closing Date. is less just stop
        $accounting_date = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE =  ' . singleQuote($comp_code));
        if ($accounting_date <> $efftdate) {
            /*
             * GEN_ERR_INVALIDCLOSING
             * Closing date invalid, please verify
             * Fecha de cierre invalida
             */
            echoLog(dict('GEN_ERR_INVALIDCLOSING') . ' Elapse: ' . $this->getElapseTime());
            return false;
        }
        //Move transaction and activities +1 day in case of pending. to process latter
        $this->move_pending_operations($comp_code, $efftdate);
        //Search for exception before closing
        if (!$this->closing_exceptions($schedule_code, $comp_code, $efftdate)) {
            /*
             * GEN_ERR_EXCEPTIONS
             * Error, verify exceptions
             * Error, favor verificar excepciones
             */
            echoLog(dict('GEN_ERR_EXCEPTIONS') . ' Elapse: ' . $this->getElapseTime());
            return false;
        }
        //Currency Valorizations moved to the beginning of the day
        //Perform all internal sales
        if (empty($this->disable_inve)) {
            if (!class_exists('Inat'))
                includeCodeLib('INAT');
            if (!class_exists('Infa'))
                includeCodeLib('INFA');
            if (!class_exists('Infu'))
                includeCodeLib('INFU');
            $infu = new Infu();
            $infa = new Infa();
            $inat = new Inat();
            echoLog('Start Investment procesing. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            //Calculo de intereses del dia para inversiones(Pendiente)
            $infa->infa_run_interest_by_comp($comp_code);
            echoLog('Inv Interest earning ended: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            //Calculo de amortizaciones diarias(Pendiente)
            //Vencimiento de portafolios
            $infa->infa_run_amortization_by_comp($comp_code);
            echoLog('Inv Amortization ended: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            $infu->infu_set_company_portfolio_prices($comp_code);
            echoLog('Portfolio pricess ended: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            echoLog('End Investment procesing. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            unset($inat, $infu, $infa, $sett);
        }

        //Calculo de intereses de cuentas de banco pre cambio de fecha
        $this->bank_account_earnings($comp_code);
        echoLog('Fibk Interests: ok. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');

        //Calculo de procesos del credito
        if (!class_exists('Filo'))
            includeCodeLib('FILO');
        if (class_exists('Filo')) {
            $filo = new Filo($parameters);
            $filo->display = true;
            $filo->filo_daily_close_cron($comp_code);

            echoLog('Cred Interests: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            unset($filo);
        }
        if (!class_exists('Guar'))
            includeCodeLib('GUAR');
        if (class_exists('Guar')) {
            $guar = new Guar($parameters);
            $guar->run_amortization_cron($comp_code);
            unset($guar);
            echoLog('Garranty Amortization: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }

        //running invoice recurrences
        if (!class_exists('Glre'))
            includeCodeLib('GLRE');
        if (class_exists('Glre')) {
            $glre = new Glre($parameters);
            $glre->glre_run_cron($comp_code);
            unset($glre);
            echoLog('Invoice recurrences: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }

        //Asset Depreciation
        if (!class_exists('Fiae'))
            includeCodeLib('FIAE');
        if (class_exists('Fiae')) {
            $fiae = new Fiae($parameters);
            $fiae->run_depreciation_cron($comp_code);
            unset($fiae);
            echoLog('Asset Depreciation: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }

        //Proceso de alquileres
        if (!class_exists('Aagr'))
            includeCodeLib('Aagr');
        if (class_exists('Aagr')) {
            echoLog('Asset Rental start: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            $aagr = new Aagr($parameters);
            $aagr->account_due_rent_cron($comp_code);
            unset($aagr);
            echoLog('Asset Rental : ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }

        //APIN Account Payable Deferred Income
        if (!class_exists('Invo'))
            includeCodeLib('INVO');
        if (class_exists('Invo')) {
            $invo = new Invo($parameters);
            $invo->run_amortization_cron($comp_code);
            unset($invo);
            echoLog('AR Deferred Income amortization: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }

        //APIN Account Payable Deferred payments
        if (!class_exists('Apin'))
            includeCodeLib('APIN');
        if (class_exists('Apin')) {
            $apin = new Apin($parameters);
            $apin->run_amortization_cron($comp_code);
            unset($apin);
            echoLog('AP Deferred Payment amortization: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }

        //Generacion de comisiones
        $this->closing_fees($comp_code, $efftdate);
        echoLog('Fees Interests: ok. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        //Building Fee Processes
        if (!class_exists('Glpf'))
            includeCodeLib('GLPF');
        if (class_exists('Glpf')) {
            $glpf = new Glpf($parameters);
            $glpf->build_invoices($comp_code);
            unset($glpf);
            echoLog('Product Fees: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }

        //Capitalization and earning payments
        ClxFreeReturn($this->capitalization_and_closing($parameters));
        echoLog('Capitalization and closing End: ok. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        //Accounting - Store balances
        ClxFreeReturn($this->build_balances($comp_code, $efftdate));
        echoLog('Balances End: ok. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');

        //Building Fee Processes
        if (!class_exists('Gltt'))
            includeCodeLib('Gltt');
        if (class_exists('Gltt')) {
            //Generacion de interfaz contable de administradora

            echoLog('Gltt Adm Acc Interface: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            $gltt = new Gltt($parameters);
            $gltt->run_interface_fityp_adm($comp_code, $efftdate);
            unset($gltt);
            echoLog('Product Fees: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }
        //Cambios de fecha de contabilidad
        if (adodb_next_day($efftdate, 'Y-m-d') < $edate) {
            //Set Accounting Date
            $efftdate = adodb_next_day($efftdate, 'Y-m-d');
            echolog('Setting Next Day: ' . $efftdate);
            $this->set_accounting_date($comp_code, $efftdate);
            $parameters['EFFTDATE'] = $efftdate;
            ClxCommon::$db->commit();
            ClxFreeReturn($this->daily_closing($parameters));
            $this->move_pending_operations($comp_code, $efftdate);
        } else {
            $this->set_accounting_date($comp_code, adodb_next_day($efftdate, 'Y-m-d'));
            ClxCommon::$db->commit();
            echoLog('------------------------------------------------');
            echoLog('Building IBS interface file: Started. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            echoLog('Acc Interface: Start:' . $parameters['ORIGINAL_PRMTS']['EFFTDATE'] . ' End:' . $parameters['ORIGINAL_PRMTS']['EDATE']);
            $this->build_ibs_accounting_interfase($comp_code, $parameters['ORIGINAL_PRMTS']['EFFTDATE'], $parameters['ORIGINAL_PRMTS']['EDATE']);
            echoLog('Building IBS interface ended: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            echoLog('------------------------------------------------');
            echoLog('Building SS interface file: Started. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            echoLog('Acc Interface: Start:' . $parameters['ORIGINAL_PRMTS']['EFFTDATE'] . ' End:' . $parameters['ORIGINAL_PRMTS']['EDATE']);
            $this->build_ss_accounting_interfase($comp_code, $parameters['ORIGINAL_PRMTS']['EFFTDATE'], $parameters['ORIGINAL_PRMTS']['EDATE']);
            echoLog('Building SS interface ended: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            if (companyParameter('IBS_DWH_CRED_ACTIVE', $comp_code) <> CLX_NUM_ZERO) {
                echoLog('Sending DHW Interface start. Elapse: ' . $this->getElapseTime());
                echoLog('------------------------------------------------');
                if (!class_exists('FiloReports')) {
                    includeCodeLib('FILOREP');
                }
                $a = new FiloReports();
                $a->rep_data_warehouse_send($comp_code, '', getCurrentLanguage());
                unset($a);
                echoLog('Sending DHW Interface End: ok. Elapse: ' . $this->getElapseTime());
                echoLog('------------------------------------------------');
            }
            echolog('Process ended: $edate Elapse: ' . $this->getElapseTime());
        }

        ClxCommon::$db->clearSpool();
        echoLog('Clear spool post: ok. Elapse: ' . $this->getElapseTime());
        if ($this->closing_stats) {
            ClxCommon::$db->buldStats();
            echoLog('Reindexing DB Catalogs post: ok. Elapse: ' . $this->getElapseTime());
        }
        echoLog('------------------------------------------------');
        echoLog('Closing process ended: ok. Elapse: ' . $this->getElapseTime());
        return true;
    }

    /**
     * Execute ibs accounting interfase. Runs on DACL process
     *
     * @param string $comp_code
     * @param string $sdate
     * @param string $edate
     */
    function build_ibs_accounting_interfase($comp_code, $sdate, $edate) {
        $ibs_acc = companyParameter('EIBS_RUN_ACC_INTERFASE', $comp_code);
        if (!empty($ibs_acc) && $ibs_acc === '1') {
            $accounting_date = adodb_next_day(ClxCommon::$db->getField($this->glcpname, 'ACCOUNTING_DATE', 'COMP_CODE = ' . singleQuote($comp_code)));
            if (!class_exists('ibs_accounting_batch_interface'))
                includeCodeLib('EIBS_JE');
            if ($sdate == $accounting_date) {
                echolog('No se realizo el cierre. No se ejecuta la interfaz contable');
            } else {
                echolog('Ejecutando Interfase Contable: ' . $comp_code . ', ' . $sdate . ' -> ' . $accounting_date);
                $a = new ibs_accounting_batch_interface($comp_code);
                $a->ibs_journal_export($sdate, $accounting_date, $comp_code);
                if (!empty($this->debug))
                    echolog('EIBS_RUN_ACC_INTERFASE EXECUTED');
                unset($a);
            }
        }else {
            echolog('EIBS Accounting Interfase disable, to enable set parameter EIBS_RUN_ACC_INTERFASE = 1');
        }
    }
    /**
     * Execute Smart Stream accounting interfase. Runs on DACL process
     *
     * @param string $comp_code
     * @param string $sdate
     * @param string $edate
     */
    function build_ss_accounting_interfase($comp_code, $sdate, $edate) {
        $ibs_acc = companyParameter('SS_RUN_ACC_INTERFASE', $comp_code);
        if (!empty($ibs_acc) && $ibs_acc === '1') {
            $accounting_date = adodb_next_day(ClxCommon::$db->getField($this->glcpname, 'ACCOUNTING_DATE', 'COMP_CODE = ' . singleQuote($comp_code)));
            if (!class_exists('SS_accounting_batch_interface'))
                includeCodeLib('SS_JE');
            if ($sdate == $accounting_date) {
                echolog('No se realizo el cierre. No se ejecuta la interfaz contable SS (Smart Sctream)');
            } else {
                echolog('Ejecutando Interfase Contable SS (Smart Sctream): ' . $comp_code . ', ' . $sdate . ' -> ' . $accounting_date);
                $a = new ss_accounting_batch_interface($comp_code);
                $a->ss_journal_export($sdate, $accounting_date, $comp_code);
                if (!empty($this->debug))
                    echolog('SS_RUN_ACC_INTERFASE EXECUTED');
                unset($a);
            }
        }else {
            echolog('SS Accounting Interfase disable, to enable set parameter SS_RUN_ACC_INTERFASE = 1');
        }
    }

    /**
     * Closing exception
     *
     * @param string $schedule_code
     * @param string $comp_code
     * @param string $efftdate
     * @return boolean
     */
    function closing_exceptions($schedule_code, $comp_code, $efftdate) {
        $status = true;
        //Report all entries unbalanced
        $PREL = &getTool('PREL');
        $sql = 'INSERT INTO ' . $PREL->tablename . ' (ID,SCHEDULECODE,EFFTDATE,TABLECODE, RECORDID,PROC_STATUS,DESCRIPTION, LOG_RECID) SELECT DISTINCT null,' . singleQuote($schedule_code) . ',' . singleQuote($efftdate) . ',' . singleQuote('JEHD') . ', JEHD.ID,null,0 BALANCE, ' . singleQuote($this->run_id) . ' LOG_RECID FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE JELN.JEHDR_CODE=JEHD.IDCODE AND JEHD.REAL_DATE =' . singleQuote($efftdate) . ' AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_STATUS NOT IN (' . singleQuote('REJ') . ') GROUP BY JEHD.IDCODE, JELN.CHART_FIELD01, JELN.CHART_FIELD02 HAVING SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) <> 0 OR (SUM(JELN.DEBIT_AMT) = 0 AND SUM(JELN.CREDIT_AMT) = 0)';
        ClxCommon::$db->executeQuery($sql);
        //On balance
        $sql = 'INSERT INTO ' . $PREL->tablename . ' (ID,SCHEDULECODE,EFFTDATE,TABLECODE, RECORDID,PROC_STATUS,DESCRIPTION, LOG_RECID) SELECT DISTINCT null,' . singleQuote($schedule_code) . ',' . singleQuote($efftdate) . ',' . singleQuote('JEHD') . ', JEHD.ID,null, 0 BALANCE, ' . singleQuote($this->run_id) . ' LOG_RECID FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE JELN.JEHDR_CODE=JEHD.IDCODE AND JEHD.REAL_DATE =' . singleQuote($efftdate) . ' AND	JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.CLX_AUTH_STATUS =' . singleQuote('PEND');
        ClxCommon::$db->executeQuery($sql);
        //Gl Exists
        $sql = 'INSERT INTO ' . $PREL->tablename . ' (ID,SCHEDULECODE,EFFTDATE,TABLECODE, RECORDID,PROC_STATUS,DESCRIPTION, LOG_RECID) SELECT DISTINCT null,' . singleQuote($schedule_code) . ',' . singleQuote($efftdate) . ',' . singleQuote('JEHD') . ', JEHD.ID,null, JEHD.IDCODE, ' . singleQuote($this->run_id) . ' LOG_RECID FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN WHERE JELN.JEHDR_CODE=JEHD.IDCODE AND JEHD.REAL_DATE =' . singleQuote($efftdate) . ' AND	JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND IFNULL(JELN.GLACCOUNTCODE,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND JEHD.JE_STATUS NOT IN (' . singleQuote('REJ') . ') GROUP BY JEHD.IDCODE';
        ClxCommon::$db->executeQuery($sql);
        //Test if exception exists
        $sql = 'SELECT COUNT(ID) FROM CLX_PR_EXCEPT_LOGS WHERE SCHEDULECODE =' . singleQuote($schedule_code) . ' AND LOG_RECID = ' . singleQuote($this->run_id);
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            if (!empty($this->debug))
                echolog('Verify Exceptions. Error verificar Excepciones');
            $status = false;
        }

        //Test if still pending transactions
        $sql = 'SELECT COUNT(FIAT.ID) FROM ' . $this->fiatname . ' FIAT, ' . $this->ficoname . ' FICO WHERE FIAT.CHART_FIELD01 = FICO.IDCODE AND FIAT.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . '  AND FICO.COMP_CODE = ' . singleQuote($this->comp) . ' AND FIAT.REAL_DATE <= ' . singleQuote($efftdate);
        $qty = ClxCommon::$db->getOne($sql);
        if ($qty <> CLX_NUM_ZERO) {
            echolog(dict('GEN_ERR_STILLPENDTRANS', $efftdate) . ' ' . $qty);
            $status = false;
        }

        if (empty($this->disable_inve)) {
            //Check for pending activities
            $sql = 'SELECT COUNT(INAT.ID) ' . 'FROM ' . $this->inatname . ' INAT, ' . $this->infuname . ' INFU ' . ' WHERE INFU.IDCODE = INAT.PORTFOLIO_CODE ' . 'AND INAT.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' ' . 'AND INFU.STATUS = ' . singleQuote('A') . ' ' . 'AND INFU.COMP_CODE = ' . singleQuote($this->comp) . ' ' . 'AND INAT.REAL_DATE <= ' . singleQuote($efftdate)
            ;
            $qty = ClxCommon::$db->getOne($sql);
            if ($qty <> CLX_NUM_ZERO) {
                echolog(dict('GEN_ERR_STILLPENDINVTRANS', $efftdate) . ' ' . $qty);
                $status = false;
            }
            //Validando que de existir cancelaciones de inversiones no pueda
            //continuar el cierre hasta resolverlas
            if (CLX_NUM_ONE == CLX_NUM_TWO) {
                //implementado proceso de vencimientos. no se require validacion.
                $sql = 'SELECT COUNT(INFV.INVESTMENT_CODE) FROM ' . $this->infuname . ' INFU, ' . $this->inprname . ' INPR, ' . $this->infaname . ' INFV WHERE INFV.INVESTMENT_CODE = INPR.INVESTMENT_CODE AND INFU.IDCODE = INFV.PORTFOLIO_CODE AND INFU.COMP_CODE = ' . singleQuote($this->comp) . ' AND INPR.MATURITY_DATE = ' . singleQuote($efftdate) . ' AND INFV.INVEST_AMT<>0';
                $qty = ClxCommon::$db->getOne($sql);
                if ($qty > CLX_NUM_ZERO) {
                    echolog(smsg('MSG-159', $qty, $this->sdate));
                    $status = false;
                }
            }
        }//not disable inve
        return $status;
    }

    /**
     * Move pending operations to next day. Transactions that are pending must move to complete closing
     * @param unknown_type $comp_code
     * @param unknown_type $efftdate
     */
    private function move_pending_operations($comp_code, $efftdate) {
        echolog('<hr><hr>moving operations from ' . $comp_code . '.' . $efftdate . '<hr><Hr>');
        /* EFFTDATE = ADDDATE('. singleQuote($efftdate).',INTERVAL 1 DAY), */
        $sql = 'UPDATE ' . $this->fiatname . ' SET REAL_DATE = ADDDATE(' . singleQuote($efftdate) . ',INTERVAL 1 DAY), AVAILABILITY_DATE = REAL_DATE WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND TRANS_STATUS = ' . singleQuote('PEND') . ' AND REAL_DATE <= ' . singleQuote($efftdate);
        ClxCommon::$db->executeQuery($sql);
        //Fiscal Period transaction
        $sql = 'UPDATE ' . $this->jacpname . ' JACP, ' . $this->fiatname . ' FIAT SET FIAT.FISCAL_PERIOD = JACP.IDCODE WHERE FIAT.COMP_CODE = JACP.COMP_CODE AND FIAT.EFFTDATE BETWEEN JACP.FROM_DATE AND JACP.TO_DATE AND FIAT.COMP_CODE = ' . singleQuote($comp_code) . ' AND FIAT.FISCAL_PERIOD <> JACP.IDCODE AND FIAT.TRANS_STATUS =' . singleQuote('PEND') . '';
        ClxCommon::$db->executeQuery($sql);
        /* EFFTDATE = ADDDATE('. singleQuote($efftdate).',INTERVAL 1 DAY), */
        $sql = 'UPDATE ' . $this->jehdname . ' SET REAL_DATE = ADDDATE(' . singleQuote($efftdate) . ',INTERVAL 1 DAY) WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND JE_STATUS = ' . singleQuote('PEND') . '  AND JE_SOURCE NOT IN (' . singleQuoteArray(array('GLAR', 'GLCL')) . ') AND REAL_DATE <= ' . singleQuote($efftdate);
        ClxCommon::$db->executeQuery($sql);
        //Fiscal Period
        $sql = 'UPDATE ' . $this->jacpname . ' JACP, ' . $this->jehdname . ' JEHD SET JEHD.FISCAL_PERIOD = JACP.IDCODE WHERE JEHD.COMP_CODE = JACP.COMP_CODE AND JEHD.EFFTDATE BETWEEN JACP.FROM_DATE AND JACP.TO_DATE AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.FISCAL_PERIOD <> JACP.IDCODE AND JEHD.JE_STATUS =' . singleQuote('PEND') . '';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->inatname . ' SET REAL_DATE = ADDDATE(' . singleQuote($efftdate) . ',INTERVAL 1 DAY) WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND REAL_DATE <= ' . singleQuote($efftdate);
        ClxCommon::$db->executeQuery($sql);
        //Validando faturas por cobrar pendientes por aprobacion
        if (!empty($this->invoname)) {
            //valindando asientos en estado pendiente
            $sql = 'UPDATE ' . $this->invoname . ' SET INVOICEDATE = ADDDATE(' . singleQuote($efftdate) . ',INTERVAL 1 DAY) WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND INVOICEDATE <= ' . singleQuote($efftdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
            ClxCommon::$db->executeQuery($sql);
        }
        //Validando facturas por pagar
        if (!empty($this->apinname)) {
            //valindando asientos en estado pendiente
            $sql = 'UPDATE ' . $this->apinname . ' SET INVOICEDATE = ADDDATE(' . $efftdate . ',INTERVAL 1 DAY) WHERE COMP_CODE = ' . singleQuote($comp_code) . ' AND INVOICEDATE <= ' . singleQuote($efftdate) . ' AND CLX_AUTH_STATUS =' . singleQuote('PEND') . '';
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     * Change Contract participant end date to the same as cancelation date
     * string $efftdate
     */
    function set_participant_end_date($efftdate) {
        //Set all participant end date for contract with expiration date = now
        $sql = 'UPDATE ' . $this->fipaname . ' SET END_DATE = ' . singleQuote($efftdate) . ' ' . ' WHERE STATUS = ' . singleQuote('A') . ' AND	PEND_TERMINATION = 0 ' . 'AND (END_DATE <> ' . singleQuote($efftdate) . ' OR END_DATE IS NULL) ' .
                'AND CONTRACT_CODE IN (SELECT IDCODE FROM ' . $this->ficoname . ' WHERE CONTRACT_STATUS = ' . singleQuote('ACTI') . ' ' . 'AND CANCEL_DATE = ' . singleQuote($efftdate) . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Returns elapsed time
     * @return number
     */
    function getElapseTime() {
        return microtime_float() - $this->start_time;
    }

    /**
     * Participant closing Validations
     */
    function validate_participant_closing($schedule_code, $comp_code, $efftdate) {
        $memo = array('SCHEDULECODE' => $schedule_code, 'EFFTDATE' => $efftdate, 'TABLECODE' => 'FIPA', 'RECORDID' => '', 'DESCRIPTION' => 'MEMO');
        $next_date = adodb_next_day($efftdate, 'Y-m-d');
        $status = true;
//Si el contrato no tiene fecha de cancelacion debe quedar por lo menos 1 participante
        $sql = 'SELECT DISTINCT FIPA.CONTRACT_CODE ' . 'FROM ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO ' . ' WHERE FICO.IDCODE = FIPA.CONTRACT_CODE ' . 'AND FIPA.STATUS = ' . singleQuote('A') . ' ' . 'AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' ' . 'AND FIPA.END_DATE = ' . singleQuote($efftdate) . ' AND FICO.CANCEL_DATE IS NULL';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if (ClxCommon::$db->oneExistsRecords($this->fipaname, 'STATUS = ' . singleQuote('A') . ' AND (END_DATE <> ' . singleQuote($efftdate) . ' OR END_DATE IS NULL)') > CLX_NUM_ZERO)
                continue;
            /*
             * GEN_ERR_MUSTBEATLEASTONEFIPA
             * For contracts with no end date, at least one participant must remain. please verify
             * Para contratos sin fecha de cancelacion, por lo menos un participante debe mantenerse.
             */
            $memo['RECORDID'] = ClxCommon::$db->getField($this->fipaname, 'ID', 'CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']), 'END_DATE = ' . singleQuote($efftdate));
            $memo['DESCRIPTION'] = dict('GEN_ERR_MUSTBEATLEASTONEFIPA');
            ClxCommon::$db->createRecord('CLX_PR_EXCEPT_LOGS', $memo, false);
            ClxCommon::$db->updateRecord($this->fipaname, array('END_DATE' => $next_date), array('CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']), 'END_DATE = ' . singleQuote($efftdate)));
            $status = false;
        }
		ClxCommon::$db->freeResult($results);
//Validating availability Capital + (Ganancia � Perdida)  - Pasivo = Disponible
        $sql = 'SELECT JEHD.CONTRACT_CODE, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT ' . 'FROM ' . $this->ficoname . ' FICO, ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->glacname . ' GLAC ' . ' WHERE JEHD.IDCODE = JELN.JEHDR_CODE ' . 'AND GLAC.IDCODE = JELN.GLACCOUNTCODE ' . 'AND FICO.IDCODE = JEHD.CONTRACT_CODE ' . 'AND FICO.CANCEL_DATE = ' . singleQuote($efftdate) . ' AND FICO.CONTRACT_STATUS = ' . singleQuote('ACTI') . ' AND GLAC.COMP_CODE = JEHD.COMP_CODE ' . 'AND JEHD.JE_STATUS IN (' . singleQuoteArray(array('VER', 'CLOS')) . ') ' . 'AND JEHD.CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']) . ' ' . 'AND GLAC.GL_TYPE IN (' . singleQuote('EQ') . ',' . singleQuote('IN') . ',' . singleQuote('EX') . ',' . singleQuote('LI') . ') ' . 'GROUP BY JEHD.CONTRACT_CODE ' . 'HAVING SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT)>0';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $memo['RECORDID'] = ClxCommon::$db->getField($this->fipaname, 'ID', 'CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']), 'END_DATE = ' . singleQuote($efftdate));
            $memo['DESCRIPTION'] = dict('CODE_ERR_NOTSUFFICIENTFUNDSAVAIL');
            ClxCommon::$db->createRecord('CLX_PR_EXCEPT_LOGS', $memo, false);
            ClxCommon::$db->updateRecord($this->fipaname, array('END_DATE' => $next_date), 'CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']) . ' AND END_DATE = ' . singleQuote($efftdate));
            $status = false;
        }
		ClxCommon::$db->freeResult($results);
//Search all participants closing today
        $sql = 'SELECT ID, CONTRACT_CODE, ACCOUNTCODE PARTICIPANT_ID FROM ' . $this->fipaname . ' WHERE END_DATE = ' . singleQuote($efftdate);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
//Validating availability Capital + (Ganancia � Perdida)  - Pasivo = Disponible
            $sql = 'SELECT SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT ' . 'FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->glacname . ' GLAC ' . ' WHERE JEHD.IDCODE = JELN.JEHDR_CODE ' . 'AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.COMP_CODE = JEHD.COMP_CODE AND JEHD.JE_STATUS IN (' . singleQuoteArray(array('VER', 'CLOS')) . ') ' . 'AND JEHD.CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']) . ' ' . 'AND JELN.PARTICIPANT_ID = ' . singleQuote($result['PARTICIPANT_ID']) . ' AND GLAC.GL_TYPE IN (' . singleQuoteArray(array('EQ', 'IN', 'EX', 'LI')) . ')';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $memo['RECORDID'] = $result['ID'];
                $memo['DESCRIPTION'] = dict('CODE_ERR_NOTSUFFICIENTFUNDSAVAIL');
                ClxCommon::$db->createRecord('CLX_PR_EXCEPT_LOGS', $memo, false);
                $status = false;
            }
            if (empty($this->disable_inve)) {
//if investment directed and not = 0 then stop and alert to sell or transfer first
                $sql = 'SELECT SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) FROM ' . $this->infuname . ' INFU, ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->glacname . ' GLAC ' . ' WHERE INFU.IDCODE = JEHD.PORTFOLIO_CODE ' . 'AND JEHD.IDCODE = JELN.JEHDR_CODE ' . 'AND JELN.GLACCOUNTCODE = GLAC.IDCODE ' . 'AND GLAC.COMP_CODE = JEHD.COMP_CODE ' . 'AND GLAC.TRUST_ITEM_TYPE = ' . singleQuote('IN') . ' ' . 'AND GLAC.GL_TYPE = ' . singleQuote('AS') . ' ' . 'AND INFU.DISCRETIONARY_PORT = 0 ' . 'AND JEHD.CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']) . ' ' . 'AND JELN.PARTICIPANT_ID = ' . singleQuote($result['PARTICIPANT_ID']);
                if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                    /* GEN_ERR_INVESTMENTPENDING
                     * Investments must be sell or transfer before participant closing, please sell or transfer investments before continuing
                     * Participante posee inversiones que no pueden ser colocadas automaticamente, Favor resolver inversiones antes de finiquitar.
                     */
                    $memo['RECORDID'] = $result['ID'];
                    $memo['DESCRIPTION'] = dict('GEN_ERR_INVESTMENTPENDING');
                    ClxCommon::$db->createRecord('CLX_PR_EXCEPT_LOGS', $memo, false);
                    $status = false;
                }
//if not investment directed then check availability
//if investment notdirected and available = 0 then stop and alert to sell or transfer first
                $sql = 'SELECT INFU.FIDU_BANKACT_CODE, INFU.CURRENCY_CODE, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) BALANCE_AMT ' . 'FROM ' . $this->infuname . ' INFU, ' . $this->jehdname . ' JEHD, ' . '' . $this->jelnname . ' JELN, ' . $this->glacname . ' GLAC ' . ' WHERE INFU.IDCODE = JEHD.PORTFOLIO_CODE ' . 'AND JEHD.IDCODE = JELN.JEHDR_CODE ' . 'AND JELN.GLACCOUNTCODE = GLAC.IDCODE ' . 'AND GLAC.COMP_CODE = JEHD.COMP_CODE ' . 'AND GLAC.TRUST_ITEM_TYPE = ' . singleQuote('IN') . ' ' . 'AND GLAC.GL_TYPE = ' . singleQuote('AS') . ' ' . 'AND INFU.DISCRETIONARY_PORT = 1 ' . 'AND JEHD.CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']) . ' ' . 'AND JELN.PARTICIPANT_ID = ' . singleQuote($result['PARTICIPANT_ID']) . ' ' . 'GROUP BY INFU.FIDU_BANKACT_CODE, INFU.CURRENCY_CODE';
                $inv_balance = ClxCommon::$db->getOneRecord($sql);
                if (!empty($inv_balance['FIDU_BANKACT_CODE'])) {
                    $sql = 'SELECT (SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT)) BALANCE_AMT ' . 'FROM ' . $this->jehdname . ' JEHD, ' . '' . $this->jelnname . ' JELN, ' . '' . $this->fibkname . ' FIBK, GL_PROD_PRMTR_TBL PRAT ' . ' WHERE JEHD.IDCODE = JELN.JEHDR_CODE ' . 'AND JEHD.JE_STATUS IN(' . singleQuoteArray(array('VER', 'CLOS')) . ') ' . 'AND JEHD.CURRENCY_CODE = ' . singleQuote($inv_balance['CURRENCY_CODE']) . ' ' . 'AND JEHD.CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']) . ' ' . 'AND JELN.PARTICIPANT_ID = ' . singleQuote($result['PARTICIPANT_ID']) . ' ' . 'AND FIBK.BANK_ACCOUNT_NO = ' . singleQuote($inv_balance['FIDU_BANKACT_CODE']) . ' ' . 'AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE AND JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE ';
                    $cash_balance = ClxCommon::$db->getOne($sql);
//Check Availability for comisions
                    if ($cash_balance < $inv_balance['BALANCE_AMT']) {
                        /* GEN_ERR_INVESTMENTPENDING
                         * Investments must be sell or transfer before participant closing, please sell or transfer investments before continuing
                         * Participante posee inversiones que no pueden ser colocadas automaticamente, Favor resolver inversiones antes de finiquitar.
                         */
                        $memo['RECORDID'] = $result['ID'];
                        $memo['DESCRIPTION'] = dict('CODE_ERR_NOTSUFFICIENTFUNDSAVAIL') . ' ' . xFormat::number($cash_balance) . ' VS Req.' . xFormat::number($inv_balance['BALANCE_AMT']);
                        ClxCommon::$db->createRecord('CLX_PR_EXCEPT_LOGS', $memo, false);
                        $status = false;
                    }
                }
            }//end if disable inve
            if (empty($status)) {
                ClxCommon::$db->updateRecord($this->fipaname, array('END_DATE' => $next_date), 'ID = ' . singleQuote($result['ID']));
                ClxCommon::$db->updateRecord($this->ficoname, array('CANCEL_DATE' => $next_date), 'IDCODE = ' . singleQuote($result['CONTRACT_CODE']) . ' AND CANCEL_DATE = ' . singleQuote($efftdate));
            }
        }//end while
		ClxCommon::$db->freeResult($results);
        return $status;
    }

    /**
     * Runs Participant Closing Process
     */
    function participant_closing_start($efftdate) {
        $sql = 'SELECT CONTRACT_CODE, ACCOUNTCODE FROM ' . $this->fipaname . ' WHERE END_DATE = ' . singleQuote($efftdate);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            echolog('Calculating desincorporation transaction for:' .
                    $efftdate . ' ' . $result['CONTRACT_CODE'] . ' ' . $result['ACCOUNTCODE']);
            $this->participant_closing($efftdate, $result['CONTRACT_CODE'], $result['ACCOUNTCODE']);
        }
		ClxCommon::$db->freeResult($results);
    }

    /**
     * Used during testing to close participant from listing button
     */
    function finiquito_btn() {
        $idlist = toString(getIdlist());
        $sql = 'SELECT FIPA.CONTRACT_CODE, FIPA.ACCOUNTCODE PARTICIPANT_ID, COMP.ACCOUNTING_DATE ' . 'FROM ' . $this->fipaname . ' FIPA, ' . $this->ficoname . ' FICO, ' . $this->compname . ' COMP ' . ' WHERE FIPA.CONTRACT_CODE = FICO.IDCODE AND ' . 'FICO.COMP_CODE = COMP.IDCODE AND FIPA.ID IN (' . $idlist . ')';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $result['EFFTDATE'] = adodb_next_day($result['ACCOUNTING_DATE']);
            $this->participant_closing($result['EFFTDATE'], $result['CONTRACT_CODE'], $result['PARTICIPANT_ID']);
        }//end while
		ClxCommon::$db->freeResult($results);
    }

    /**
     * Builds capitalization and payments
     *
     * @param unknown_type $parameters
     * @return unknown
     */
    private function capitalization_and_closing($parameters) {
        if (!class_exists('gl'))
            includeCodeLib('GL');
        $parameters['CONTRACT_CODE'] = '';
        $parameters['PARTICIPANT_ID'] = '';
        $parameters['OPERATION_DATE'] = '';
        $a = new gl();
        $a->closing($parameters);
        $a->capitalization($parameters);
        unset($a);
        return true;
    }

    /**
     * Builds settlement transactions
     *
     * @param unknown_type $parameters
     * @return unknown
     */
    private function settlement($parameters) {
        if (!class_exists('fidu_settlement'))
            includeCodeLib('SETT');
        $a = new fidu_settlement();
        $a->start($parameters);
        unset($a);
        return true;
    }

    /**
     * Bank Account earning calculations
     */
    private function bank_account_earnings($comp_code) {
        $parameters = array('COMP_CODE' => $comp_code);
        if (!class_exists('fibk_utilities')) {
            includeCodeLib('FIBK');
        }
        $fibk = new fibk_utilities();
        $fibk->fibk_earnings_cron($parameters, 0);
        //Ejecutando pagos para cuentas de banco que se detonan a fin de mes
        $fibk->fibk_pay_earnings_cron($parameters);
    }

    /**
     * Runs renewal of cds on bank account
     */
    private function bank_account_renewals($comp_code) {
        $parameters = array('COMP_CODE' => $comp_code);
        if (!class_exists('fibk_utilities')) {
            includeCodeLib('FIBK');
        }
        $fibk = new fibk_utilities();
        $fibk->fibk_pay_earnings_cron($parameters, 1);
        $fibk->fibk_renewals_cron($parameters);
    }

    /**
     * Builds balances jebl
     *
     * @param string $comp_code
     * @param string $efftdate
     * @return boolean
     */
    private function build_balances($comp_code, $efftdate) {
        if (!adodb_month_last_day($efftdate)) {
            return true;
        }

        if (!class_exists('Jebl')) {
            includeCodeLib('JEBL');
        }
        $jebl = new Jebl();
        $status = $jebl->jebl_build($comp_code, $efftdate);
        unset($jebl);
        return $status;
    }

    /**
     * Run Closing Fees
     */
    private function closing_fees($comp_code, $efftdate) {
        $parameters = array('COMP_CODE' => $comp_code,
            'OPERATION_DATE' => $efftdate,
            'CONTRACT_CODE' => '',
            'PARTICIPANT_ID' => '');
        runProcess('DFAG', $parameters);
    }

    /**
     * Set Accounting Date
     */
    function set_accounting_date($comp_code, $date, $run_instructions = true, $ibs_acc_interfase = true) {

		$exvl_exec_order = uppercase(companyParameterDef('EXVL_EXEC_ORDER', 'POST', $comp_code));
		if($exvl_exec_order === 'PRE') {
			//Currency Valorizations - PRE
			echoLog('Start change valuation ['.$exvl_exec_order.']. Elapse: ' . $this->getElapseTime());
			echoLog('------------------------------------------------');
			if (!class_exists('gl')) {
				includeCodeLib('GL');
			}
			$gl = new gl();
			$gl->exchange_valuation_by_comp($comp_code);
			echoLog('End change valuation ['.$exvl_exec_order.']. Elapse: ' . $this->getElapseTime());
			echoLog('------------------------------------------------');
		}

        $last_date = ClxCommon::$db->getOne('SELECT OPERATION_DATE FROM ' . $this->glcpname . ' WHERE COMP_CODE = ' . singleQuote($comp_code));
        //Store Participant Balances prior to instructions
        echolog('Setting Accounting Date, company:' . $comp_code . ', ' . $date);
        ClxCommon::$db->executeQuery('UPDATE ' . $this->glcpname . ' SET ACCOUNTING_DATE= ' . singleQuote($last_date) . ', OPERATION_DATE = ' . singleQuote($date) . ' WHERE COMP_CODE = ' . singleQuote($comp_code));
        ClxCommon::$db->commit();
        //Post closing operations
        //Executing Instructions
        if ($run_instructions === true) {
            echolog('Running Instructions:' . $comp_code . ', ' . $date);
            if (!class_exists('Fiai')) {
                includeCodeLib('FIAI');
            }
            $fiai = new Fiai();
            $fiai->fiai_run_cron($comp_code, $date, $this->process_parameters);
            echolog('Intruction Elapse:' . $this->getElapseTime());
            echoLog('------------------------------------------------');
        }
        //Calculo de procesos del credito
        if (!class_exists('Filo')) {
            includeCodeLib('FILO');
        }
        if (class_exists('Filo')) {
            $filo = new Filo();
            $filo->filo_daily_close_post_cron($comp_code);
            echoLog('Cred Interests: ok. Elapse: ' . $this->getElapseTime());
            echoLog('------------------------------------------------');
            unset($filo);
        }
        //Monetary Indexation
        echoLog('Start monetary indexation. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        if (!class_exists('Glcr')) {
            includeCodeLib('GLCR');
        }
        $glcr = new Glcr();
        $glcr->monetary_indexation_by_comp($comp_code, false);
        echoLog('End monetary indexation. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
		
		if($exvl_exec_order !== 'PRE') {
			//Currency Valorizations - POST (default behavior)
			echoLog('Start change valuation ['.$exvl_exec_order.']. Elapse: ' . $this->getElapseTime());
			echoLog('------------------------------------------------');
			if (!class_exists('gl')) {
				includeCodeLib('GL');
			}
			$gl = new gl();
			$gl->exchange_valuation_by_comp($comp_code);
			echoLog('End change valuation ['.$exvl_exec_order.']. Elapse: ' . $this->getElapseTime());
			echoLog('------------------------------------------------');
		}

		//Executing renewals from CD on fibk table
        $this->bank_account_renewals($comp_code);
        echoLog('Inv Maturity CD Mod off ended: ok. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        if (!class_exists('Infa')) {
            includeCodeLib('INFA');
        }
        $infa = new Infa();
        $infa->infa_run_maturity_by_comp($comp_code);
        echoLog('Inv Maturity off ended: ok. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        echoLog('Start Investment Interest Payment. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        if (!class_exists('Infa'))
            includeCodeLib('INFA');
        $infa = new Infa();
        $infa->infa_run_interest_by_comp($comp_code, true);
        echoLog('End Investment Interest Payment. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        if (!class_exists('Inat'))
            includeCodeLib('INAT');
        $inat = new Inat();
        echoLog('T+ Operations. Elapse: ' . $this->getElapseTime());
        echoLog('------------------------------------------------');
        $inat->inat_build_accounting_tmas($comp_code);

        //Settlement - finiquito
        ClxFreeReturn($this->settlement($this->process_parameters));
        echoLog('Settlement off End: ok. Elapse: ' . $this->getElapseTime());
    }

    /**
     * Process clossing form
     *
     */
    function accounting_closing() {
        global $msg;
        if (!class_exists('gl')) {
            includeCodeLib('GL');
        }
        $contents = '';
        if (!isset($msg))
            $msg = array();
        $record = array_merge(UserRequest::$request, UserRequest::$post);;
        $formcode = 'RTBL_FIS_CLOSNG';
        $title = dict('RTBL_FIS_CLOSNG');
        $ac = UserRequest::$request ['ac'];
        $to = UserRequest::$request [CLX_PROP_TO];
        $it = (!empty($record ['it'])) ? $record ['it'] : '';
        $EDIT = &getTool('EDIT');
        if (empty($record ['confirm'])) {
            $record ['RTBL_COMP_CODE'] = '';
            $record ['RTBL_FISCAL_CLSNG_DATE'] = '';
        }
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
        if (!empty($record ['confirm'])) {
           $EDIT->checkForm2($msg,$formrec);
            $sql='SELECT COUNT(JEHD.ID) QTY FROM GL_JOURNAL_HDR JEHD WHERE JEHD.JE_SOURCE = "GLCL" AND JEHD.REVERSED = 0 AND JEHD.JE_STATUS = "AP" AND JEHD.COMP_CODE = '.singleQuote($record ['RTBL_COMP_CODE']).' AND JEHD.EFFTDATE = '.singleQuote($record['RTBL_FISCAL_CLSNG_DATE']); 
            $result1 = ClxCommon::$db->getOneRecord($sql);   
            if ($result1 ['QTY']>CLX_INIT_ZERO) {
                $msg['RTBL_FISCAL_CLSNG_DATE'] = smsg('MSG-20170621101344');
            }
            $sql='SELECT GLCP.OPERATION_DATE GLCP_OPERATION_DATE,DATEDIFF('.singleQuote($record['RTBL_FISCAL_CLSNG_DATE']).',GLCP.OPERATION_DATE) DIFF FROM GL_PARAMETERS_TBL GLCP WHERE GLCP.COMP_CODE ='.singleQuote($record ['RTBL_COMP_CODE']);
            $result1 = ClxCommon::$db->getOneRecord($sql);
            if ($result1 ['DIFF']>CLX_INIT_ZERO) {
                $msg['RTBL_FISCAL_CLSNG_DATE'] = smsg('MSG-462', singleQuote($record['RTBL_FISCAL_CLSNG_DATE']), $result1['GLCP_OPERATION_DATE']);
            }
            $sql='SELECT COUNT(JEHD.ID) CONT FROM GL_JOURNAL_HDR JEHD WHERE JEHD.COMP_CODE = '.singleQuote($record ['RTBL_COMP_CODE']).'  AND JEHD.EFFTDATE <= '.singleQuote($record['RTBL_FISCAL_CLSNG_DATE']).' AND JEHD.JE_STATUS ='.singleQuote('PEND'); 
            $result2 = ClxCommon::$db->getOneRecord($sql);
            if ($result2 ['CONT']>CLX_INIT_ZERO) {
                $msg ['RTBL_FISCAL_CLSNG_DATE'] = smsg('MSG-20170602152534');
            }
            $sql='SELECT COUNT(JEHD.ID) CONT FROM GL_JOURNAL_HDR JEHD WHERE JEHD.COMP_CODE = '.singleQuote($record ['RTBL_COMP_CODE']).' AND JEHD.EFFTDATE = '.singleQuote($record['RTBL_FISCAL_CLSNG_DATE']).'  AND JEHD.JE_SOURCE IN ('.singleQuote('GLCL').','.singleQuote('GLAR').') AND JEHD.JE_STATUS = '.singleQuote('AP').' AND JEHD.REVERSED = 0';
            $result3 = ClxCommon::$db->getOneRecord($sql);
            if ($result3 ['CONT']>CLX_INIT_ZERO) {
                $msg ['RTBL_FISCAL_CLSNG_DATE'] = smsg('MSG-20170602160221');
            }
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp();
            $comprec = $comp->comp_operation_parameters($record ['RTBL_COMP_CODE']); 
            $bckdtdop=(empty($comprec['BCKDATE_ALLWCE'])) ? CLX_INIT_ZERO :$comprec ['BCKDATE_ALLWCE'];
           // PRE($record['RTBL_FISCAL_CLSNG_DATE']);
           // PRE($result1['GLCP_OPERATION_DATE']);
           // PRE( day_diff($result1['GLCP_OPERATION_DATE'],$record['RTBL_FISCAL_CLSNG_DATE']));
            if (day_diff($result1['GLCP_OPERATION_DATE'],$record['RTBL_FISCAL_CLSNG_DATE']) < $bckdtdop) {
                $msg['RTBL_FISCAL_CLSNG_DATE'] = smsg('MSG-20170602173242', $bckdtdop);
            }
        }
        
        $it = (!empty($record ['it'])) ? $record ['it'] : '';
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
        $contents.=$form->source();
        if (!empty($record ['confirm']) && empty($msg)) {
            if (!class_exists('Gloq')){
                includeCodeLib('GLOQ');
            }
            $a = new Gloq();
            $a->PushQueue('GLAP', $record ['RTBL_COMP_CODE'], $record ['RTBL_FISCAL_CLSNG_DATE'], null, null,batch_id(),  0);
            unset($a);
            $contents = note(dict('UTIL_DBBK_PROC_SCHEDULED'));
        }
        else {
            $sql='SELECT A.*, ( SELECT COUNT(JEHD.ID) QTY  FROM GL_JOURNAL_HDR JEHD WHERE JEHD.JE_SOURCE = "GLCL" AND JEHD.REVERSED = 0 AND JEHD.JE_STATUS = "AP" AND JEHD.COMP_CODE=A.COMP_CODE AND JEHD.EFFTDATE=A.FISCALDATE) APROVE_PERIODO_FISCAL FROM (SELECT GLCP.COMP_CODE, DATE_SUB(DATE_SUB(STR_TO_DATE(CONCAT(DATE_FORMAT(GLCP.OPERATION_DATE,"%Y"),"-",RIGHT(CONCAT("0",IF(FMTH_FISCALYEAR-DATE_FORMAT(GLCP.OPERATION_DATE,"%m")>0,12,0)+FMTH_FISCALYEAR +FLOOR((DATE_FORMAT(GLCP.OPERATION_DATE,"%m")-FMTH_FISCALYEAR)/CLOSING_PERIOD)*CLOSING_PERIOD),2),"-","01"),"%Y-%m-%d"), INTERVAL IF(FMTH_FISCALYEAR-DATE_FORMAT(GLCP.OPERATION_DATE,"%m")>0,12,0) MONTH )   ,  INTERVAL 1 DAY)   FISCALDATE FROM GL_PARAMETERS_TBL GLCP  ) A';
            $rs = ClxCommon::$db->executeQuery($sql);
            $arr=array();
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $arr[$r["COMP_CODE"]]=$r;
            }
			ClxCommon::$db->freeResult($rs);
            $javascript='var periodos=JSON.parse('.singleQuote(json_encode($arr)).');';
            $javascript.='$("#RTBL_COMP_CODE").change(function(e){ 
                if (typeof (Object.values)=="undefined") { 
                    $.each(periodos, function (code, details) {
                       if (code==$("#RTBL_COMP_CODE").val()) {
                            var contar=0;  
                            $.each(details,function (code2,details2) {
                                if (++contar ==2)   
                                    $("#RTBL_FISCAL_CLSNG_DATE").val(details2); 
                            }) 
                        } 
                    });
                }
                else {
                    Object.keys(periodos).forEach(function(key) {
                        if (key==$("#RTBL_COMP_CODE").val())$("#RTBL_FISCAL_CLSNG_DATE").val(Object.values(periodos[key])[1]);
                    });
                }    

            });';
            $contents.=setJavaScriptTag($javascript);
        }
        return $contents;
    }
//------------------------------------------------------------------------------
// R E P O R T S     S E C T I O N
//------------------------------------------------------------------------------

    /*
     * Extracts and returns the company code from a contract
     * record corresponding to the given transaction code
     */
    function comp_get_company_code($s_fiat_idcode) {
        //global $db;
        $comp = NULL;
        $sql = "SELECT
                    FICO.COMP_CODE
                FROM
                    $this->fiatname FIAT
                            LEFT JOIN $this->ficoname FICO
                            ON FICO.IDCODE = FIAT.CONTRACT_CODE
                WHERE
                    FIAT.IDCODE = '$s_fiat_idcode'";
        $records = ClxCommon::$db->executeQuery($sql);
        if ($this->debug)
            echoLog("<b>$sql</b>");
        if (($record = ClxCommon::$db->getNextRecord($records)) == true) {
            $comp = $record['COMP_CODE'];
        }
		ClxCommon::$db->freeResult($records);
        return $comp;
		}

    /**
     * M�todo comun en la impresion de comprobantes de iva, islr
     * y timbres fiscales
     * Devuelve los arrays necesarios para hacer las sustituciones en
     * los varios formatos
     * '$s_tax_form' puede ser:
     * 		ISLR 	Income Tax Witholding
     * 		IVA 	Value Added Tax
     * 		FIST 	Timbre Fiscal
     * 		USW8 	W8
     */
    function comp_generic_routine($s_tax_form) {
        //global $db;

//$this->debug = true;
        // Extracts the transaction code
        $idlist = getIdlist();
        $fiat_idcode = ClxCommon::$db->getField($this->fitlname, "TRANS_CODE", "ID IN ('" . implode("','", $idlist) . "')");
        if ($this->debug)
            echoLog("fiat_idcode=$fiat_idcode");

        // EXtracts company code
        $this->comp = $this->comp_get_company_code($fiat_idcode);

        // Extract txre record, if it doesn't exists, creates it
        $txrename = tableName('TXRE');
        $ar_record_txre = ClxCommon::$db->getRecord($txrename, "TRANS_CODE = '$fiat_idcode' AND TAX_FORM = '$s_tax_form'");
        if ($this->debug) {
            echo ("<br><b>ar_record_txre</B><br>");
            print_r($ar_record_txre);
            echo ("<br>");
        }
        if ($ar_record_txre) {
            $b_error = false;
            $ar_error_msg = array();
        } else {
            // Creates TXRE record from the specified transacion idcode
            $ar_response = $this->create_txre_record($fiat_idcode, $s_tax_form);
            $b_error = $ar_response['error'];
            $ar_error_msg = $ar_response['errormsg'];
            $ar_record_txre = $ar_response['ar_record_txre'];
        }
        if ($b_error == false) {
            // Extract additional data not included in the TXRE table
            switch ($s_tax_form) {
                case 'ISLR':

                    // MONTO ABONADO EN CUENTA	Monto que se le paga al crontibuyente
                    $ar_record_txre['FIAT_LINE_AMT'] = ClxCommon::$db->getField($this->fiatname, "LINE_AMT", "IDCODE='$fiat_idcode'");
                    break;

                case 'FIST':
                    // SQL for transaction lines data retrieval (timbre fiscal only)
                    // Extract IVA data
                    $sql = "SELECT
								FITL.LINE_AMT,
								TXTB.FLAT_RATE,
								TXTB.TAX_TYPE
							FROM
								$this->fitlname FITL
									LEFT JOIN $this->txtbname TXTB ON TXTB.IDCODE = FITL.TAX_CODE,
								$this->fiatname FIAT
							WHERE
								FIAT.IDCODE = '$fiat_idcode'
								AND FITL.TRANS_CODE = FIAT.IDCODE
								AND TXTB.TAX_TYPE = 'IVA'
							";

                    // Transaction lines processing
                    $ar_record_txre['IVA_BASE_LINE_AMT'] = 0; // base imponible del timbre x % de la tarifa
                    $ar_record_txre['IVA_FLAT_RATE'] = 0;  // % DE LA TARIFA del timbre
                    $records = ClxCommon::$db->executeQuery($sql);
                    if ($this->debug)
                        echoLog("<b>CALCULA DATOS ESPEFCIFICOS DE FIST. SQL=$sql</b>");
                    while (($record_1 = ClxCommon::$db->getNextRecord($records)) == true) {
                        $ar_record_txre['IVA_BASE_LINE_AMT'] = bcadd((string) $ar_record_txre['IVA_BASE_LINE_AMT'], (string) $record_1['LINE_AMT']); // base imponible del timbre x % de la tarifa
                        $ar_record_txre['IVA_FLAT_RATE'] = $record_1['FLAT_RATE']; // % DE LA TARIFA del timbre
                    }
					ClxCommon::$db->freeResult($records);
                    break;
            }
        }

        $ar_response = array(
            'error' => $b_error,
            'errormsg' => $ar_error_msg,
            'record' => $ar_record_txre,
        );
        return $ar_response;
    }

// Method End

    /**
     * Set Company Address
     */
    function company_location($comp_code) {
        //global $db;

        // Company data
        $sql = "SELECT COLO.*
				FROM $this->coloname COLO, $this->compname COMP, $this->dyclname DYCL
				WHERE
					DYCL.COMP_CODE = COMP.IDCODE
					AND COLO.IDCODE = DYCL.COMPLOC_CODE
					AND COMP.IDCODE = '" . $comp_code . "'
				ORDER BY COLO.ISPRIMARY DESC
					LIMIT 1";
        $colorec = ClxCommon::$db->getOneRecord($sql);
        if (!$colorec) {
            // No company address found
            $comp_address = '';
        } else {
            $DBLT = getTool("DBLT");
            $colorec['CITY'] = $DBLT->getListItem('loci', $colorec['CITY']);
            $comp_address = $colorec['ADDRESS1'] . ' ' . $colorec['ADDRESS2'] . ', ';
            $comp_address .= ' ' . $colorec['CITY'];
            if (1 == 2)
                $comp_address .=', Telf:' . $colorec['PHONE'] . ' / ' . $colorec['FAX'];
        }

        $this->comp_address = $comp_address;
        return $colorec;
    }

//end method

    /**
     * Payee Address
     */
    function payee_address($accountcode) {
        //global $db;

        $address = '';
        $aclorec = ClxCommon::$db->getRecord($this->acloname, "ACCOUNTCODE = '" . $accountcode . "'");
        // payee default location address
        if (!empty($aclorec)) {
            $DBLT = getTool("DBLT");
            $aclorec['CITY'] = $DBLT->getListItem('LOCI', $aclorec['CITY']);
            $aclorec['STATE'] = $DBLT->getListItem('VZST', $aclorec['STATE']);
            $aclorec['COUNTRY'] = $DBLT->getListItem('COUN', $aclorec['COUNTRY']);
            $address = $aclorec['ADDRESS1'] . '<br>' . $aclorec['ADDRESS2'] . '<br>' . $aclorec['CITY'] . '<br>' . $aclorec['STATE'] . '<br>' . $aclorec['COUNTRY'];
        }
        return $address;
    }



//end method

    /**
     * Generates Tax Receips
     */
    function generate_txre($fiat_code = '') {
        //global $db;

        //$fiat_code = '1624';
        //$trans_status = "'AP', 'CLOS'";
        //$trans_status = "'PEND','AP', 'CLOS'";
        /* $sql = "SELECT
          TXTB.TAX_TYPE,
          TXTB.FLAT_RATE,
          TXTB.IDNAME CONCEPTO,

          COMP.IDCODE COMP_CODE,
          COMP.IDNAME COMP_LEGALNAME,
          COMP.TAXID COMP_TAXID,

          FIAT.EFFTDATE,
          FIAT.IDCODE TRANS_CODE,
          FIAT.APPROVAL_DATE,
          FIAT.PARTICIPANT_ID,  FIAT.TRANS_AMT, FIAT.TRANS_AMT BASE_TRANS_AMT,
          FIAT.LINE_AMT BASE_CASH_LINE_AMT,
          FITL.LINE_AMT BASE_LINE_AMT,

          FIBT.ID FIBT_ID,
          FIBT.BENEFICIARY_NAME FIBT_BENEFICIARY_NAME,
          FIBT.IDENTIFICATION FIBT_IDENTIFICATION,
          FIBT.LEGAL_TYPE FIBT_LEGAL_TYPE,
          FIBT.INVOICE_ITEM,
          FIBT.INVOICE_NO,
          #FIBT.INVOICE_NO_02,
          FIBT.INVOICE_NO INVOICE_NO_02,
          FIAT.EFFTDATE INVOICE_DATE,
          FIBT.OBSERVATION OBSERVACIONES,
          FIBT.ACCOUNTCODE,
          FIBT.ADDRESS FIBT_ADDRESS,
          FIBT.COUNTRY FIBT_COUNTRY,
          FIBT.STATE FIBT_STATE,
          ACCO.IDNAME ACCO_BENEFICIARY_NAME,
          ACCO.IDENTIFICATION ACCO_IDENTIFICATION,
          ACCO.LEGAL_TYPE ACCO_LEGAL_TYPE,
          ACCO.ID_TYPE ACCO_ID_TYPE
          FROM
          $this->fitlname FITL,
          $this->ietbname TXTB,
          $this->ficoname FICO,
          $this->compname COMP,
          $this->fiatname FIAT
          LEFT JOIN $this->fibtname FIBT ON FIBT.TRANS_CODE = FIAT.IDCODE
          LEFT JOIN $this->acconame ACCO ON ACCO.IDCODE = FIBT.ACCOUNTCODE
          LEFT JOIN $this->txrename TXRE ON FIAT.IDCODE = TXRE.TRANS_CODE
          WHERE
          ".(($fiat_code<>'')?"FIAT.IDCODE = '$fiat_code' AND ":"")."
          TXRE.IDCODE IS NULL AND
          TXTB.TAX_TYPE IN ('IVA','RIVA','FIS','ISLR') AND
          FICO.COMP_CODE = COMP.IDCODE AND
          FICO.IDCODE = FIAT.CONTRACT_CODE AND
          TXTB.IDCODE = FITL.INCEXP_CODE AND
          FIAT.TRANS_STATUS IN ($trans_status) AND
          FITL.INCEXP_CODE <> '' AND
          FITL.TRANS_CODE = FIAT.IDCODE AND
          (FIAT.REVTRANS_CODE IS NULL OR FIAT.REVTRANS_CODE <> '') AND
          NOT EXISTS (SELECT IDCODE FROM $this->fiatname B
          WHERE B.REVTRANS_CODE = FIAT.IDCODE
          AND B.TRANS_STATUS IN ('AP','CLOS') LIMIT 1)
          "; */
        $sql = "SELECT
                  GDVW.IDCODE JEHDR_CODE,
                  GDVW.TRANS_CODE,
                  JEIT.TAX_TYPE,
                  JEIT.FLAT_RATE,
                  JEIT.IDNAME CONCEPTO,
                  /*COMPANY*/
                  COMP.IDCODE COMP_CODE,
                  COMP.IDNAME COMP_LEGALNAME,
                  COMP.TAXID COMP_TAXID,
                  /*OPERATION DETAILS*/
                  GDVW.EFFTDATE,
                  FIAT.AVAILABILITY_DATE APPROVAL_DATE,
                  GDVW.CHART_FIELD02 PARTICIPANT_ID,
                  ABS(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT)) TRANS_AMT,
                  0 BASE_TRANS_AMT,
                  0 BASE_LINE_AMT,
                  0 BASE_CASH_LINE_AMT,
                  NULL FIBT_ID,
                  FIAT.BENEFICIARY_NAME FIBT_BENEFICIARY_NAME,
                  FIAT.IDENTIFICATION FIBT_IDENTIFICATION,
                  FIAT.LEGAL_TYPE FIBT_LEGAL_TYPE,
                  FIAT.INVOICE_ITEM,
                  FIAT.INVOICE_NO,
                  NULL INVOICE_NO_02,
                  FIAT.INVOICE_NO INVOICE_NO_02,
                  GDVW.EFFTDATE INVOICE_DATE,
                  NULL OBSERVACIONES,
                  GDVW.CHART_FIELD02 ACCOUNTCODE,
                  FIAT.ADDRESS FIBT_ADDRESS,
                  FIAT.COUNTRY FIBT_COUNTRY,
                  FIAT.STATE FIBT_STATE,
                  ACCO.IDNAME ACCO_BENEFICIARY_NAME,
                  ACCO.IDENTIFICATION ACCO_IDENTIFICATION,
                  ACCO.LEGAL_TYPE ACCO_LEGAL_TYPE,
                  ACCO.ID_TYPE ACCO_ID_TYPE
                FROM
                  BASE_COMPANIES COMP,
                  GL_ITEM_TBL JEIT,
                  CRM_ACCOUNTS ACCO,
                  GL_JOURNAL_DET_VW GDVW
                  LEFT JOIN FIDU_TRANSACTIONS FIAT
                    ON GDVW.TRANS_CODE = FIAT.IDCODE
                WHERE 1=1
                  AND GDVW.COMP_CODE = COMP.IDCODE
                  AND GDVW.ITEM_CODE = JEIT.IDCODE
                  AND GDVW.CHART_FIELD02 = ACCO.IDCODE
                  AND JEIT.TAX_TYPE IN('ISLR','RIVA','IVA') " .
                (($fiat_code <> '') ? " AND GDVW.TRANS_CODE = '$fiat_code'" : "") .
                /* AND COMP.IDCODE = @COMP_CODE */
                "
                  AND JEIT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE)
                			  FROM GL_ITEM_TBL X
                			  WHERE X.IDCODE = JEIT.IDCODE
                			  AND X.CLX_EFFTDATE<=GDVW.EFFTDATE)
                  AND NOT EXISTS(SELECT X.ID FROM GL_TAX_REPORTS X
                  			WHERE X.JEHDR_CODE = GDVW.IDCODE)
                GROUP BY
                  GDVW.IDCODE,
                  GDVW.TRANS_CODE,
                  JEIT.TAX_TYPE,
                  JEIT.FLAT_RATE,
                  JEIT.IDNAME,
                  COMP.IDCODE,
                  COMP.IDNAME,
                  COMP.TAXID,
                  GDVW.EFFTDATE,
                  FIAT.AVAILABILITY_DATE,
                  GDVW.CHART_FIELD02,
                  FIAT.BENEFICIARY_NAME,
                  FIAT.IDENTIFICATION,
                  FIAT.LEGAL_TYPE,
                  FIAT.INVOICE_ITEM,
                  FIAT.INVOICE_NO,
                  FIAT.INVOICE_NO,
                  GDVW.EFFTDATE,
                  FIAT.ADDRESS,
                  FIAT.COUNTRY,
                  FIAT.STATE,
                  ACCO.IDNAME,
                  ACCO.IDENTIFICATION,
                  ACCO.LEGAL_TYPE,
                  ACCO.ID_TYPE";
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs)) == true) {

            $sql = "SELECT ABS(SUM(X.DEBIT_AMT-X.CREDIT_AMT)) BALANCE_AMT
		    		FROM GL_JOURNAL_DET_VW X
		    		WHERE X.IDCODE = '" . $r['JEHDR_CODE'] . "'
		    		AND X.TRUST_ITEM_TYPE = 'CA'";
            $r['BASE_CASH_LINE_AMT'] = ClxCommon::$db->getOne($sql);
            $r['BASE_LINE_AMT'] = $r['BASE_CASH_LINE_AMT'];
            $r['BASE_TRANS_AMT'] = $r['TRANS_AMT'];
            if ($this->validate_txre($r)) {
                $this->create_txre($r);
            }
		}
	}
   /**
     * Perform TXRE Calculations
     */
    function calculate_txre(&$txrerec, $record) {
        //global $db;


        $txrerec['INVOICE_AMT'] = 0;
        $txrerec['TAXABLE_AMT'] = 0;
        $txrerec['TAX_AMT'] = 0;
        $txrerec['TAXWITHOLDING_AMT'] = 0;
        $txrerec['TAX_RATE'] = 0;
        $txrerec['TAXCRED_EXEMPTION'] = 0;
        $txrerec['IVA_RATE'] = 0;
        $txrerec['IVA_AMT'] = 0;
        $txrerec['CASH_LINE_AMT'] = $record['BASE_CASH_LINE_AMT'];
        switch ($txrerec['TAX_TYPE']) {
            // + el Monto del IVAs
            case ($txrerec['TAX_TYPE'] == 'RIVA' || $txrerec['TAX_TYPE'] == 'IVA'):
                $sql = "SELECT
                			ABS(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT)) LINE_AMT,
                			JEIT.FLAT_RATE,
                			NULL FORMULA_CODE
						FROM
							GL_JOURNAL_DET_VW GDVW,
							GL_ITEM_TBL JEIT
						WHERE
							 GDVW.ITEM_CODE = JEIT.IDCODE
							 AND JEIT.TAX_TYPE IN ('IVA', 'RIVA')
							 AND GDVW.IDCODE = '" . $txrerec['JEHDR_CODE'] . "'
							 AND JEIT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE)
                			  FROM GL_ITEM_TBL X
                			  WHERE X.IDCODE = JEIT.IDCODE
                			  AND X.CLX_EFFTDATE<=GDVW.EFFTDATE)
                	    GROUP BY
                	    	JEIT.FLAT_RATE";
                $iva = ClxCommon::$db->getOneRecord($sql);
                if (empty($iva)) {
                    $txrerec['IVA_RATE'] = 0;
                    $txrerec['IVA_AMT'] = 0;
                } else {
                    //echo $record['BASE_TRANS_AMT'].'<br>'.$iva['FLAT_RATE'].'<br>';
                    //echo bcmul($record['BASE_TRANS_AMT'], bcdiv($iva['FLAT_RATE'], '100')).'<hr>';
                    $txrerec['IVA_RATE'] = $iva['FLAT_RATE'];
                    $txrerec['IVA_AMT'] = bcmul($record['BASE_TRANS_AMT'], bcdiv($iva['FLAT_RATE'], '100')); //bcmul($txrerec['TAX_AMT'], bcdiv($txrerec['IVA_RATE'],'100'));
                }
                $txrerec['INVOICE_AMT'] = rounder(bcadd($record['BASE_TRANS_AMT'], $txrerec['IVA_AMT']), 2); //-TOTALCOMPRA- Total Compra incluyendo IVA, debe ser igual al desembolso mas el IVA calculado.
                $txrerec['TAXABLE_AMT'] = $record['BASE_TRANS_AMT']; //-BASEIMPONIBLE- Base imponible es igual al desembolso.
                $txrerec['TAX_AMT'] = $txrerec['IVA_AMT']; //-IMPUESTOIVA- Impuesto IVA, debe ser el monto completo del IVA.
                //$txrerec['TAX_RATE'] 		 = rounder(bcmul(bcdiv($txrerec['TAX_AMT'],$txrerec['TAXABLE_AMT']),'100'),2);//$record['FLAT_RATE']--Verificar si no hay que coloar otro
                $txrerec['TAX_RATE'] = rounder($txrerec['IVA_RATE'], 2); //$record['FLAT_RATE']--Verificar si no hay que coloar otro
                $txrerec['TAXWITHOLDING_AMT'] = bcabs($record['BASE_LINE_AMT']); //-IVARETENIDO- IVA retenido, debe ser la cifra final de IVA retenida.
                $txrerec['TAXCRED_EXEMPTION'] = 0; //-COMPRASINDERECHOIVA- Compra sin derecho a Credito IVA, debe ser igual a cero.
                break;
            // - el timbre fiscal
            case 'FIS':

                $txrerec['TAXABLE_AMT'] = $record['BASE_TRANS_AMT'];
                $txrerec['TAX_AMT'] = bcabs($record['BASE_LINE_AMT']); //$formato = str_replace('-MENOSTIMBRE-',xFormat::number(bcabs($record['TAX_AMT']),2),$formato);
                $txrerec['TAXWITHOLDING_AMT'] = $record['BASE_TRANS_AMT']; //'-RETENCION-'str_replace('-TARIFA_FIS-',xFormat::number($record['TAX_RATE'],2),$formato);
                $txrerec['TAX_RATE'] = rounder(bcmul(bcdiv($txrerec['TAX_AMT'], $txrerec['TAXABLE_AMT']), '100'), 2); //$formato = str_replace('-PORCENTAJE-',xFormat::number(,2),$formato);
                /* $sql = "SELECT FITL.LINE_AMT, TXTB.FLAT_RATE, FORMULA_CODE  FROM
                  $this->fitlname FITL,
                  $this->ietbname TXTB
                  WHERE
                  TXTB.IDCODE = FITL.INCEXP_CODE AND
                  (TXTB.TAX_TYPE = 'IVA' OR TXTB.TAX_TYPE = 'RIVA') AND
                  FITL.TRANS_CODE = '".$txrerec['TRANS_CODE']."'"; */
                $sql = "SELECT
                			ABS(SUM(GDVW.DEBIT_AMT-GDVW.CREDIT_AMT)) LINE_AMT,
                			JEIT.FLAT_RATE,
                			NULL FORMULA_CODE
						FROM
							GL_JOURNAL_DET_VW GDVW,
							GL_ITEM_TBL JEIT
						WHERE
							 GDVW.ITEM_CODE = JEIT.IDCODE
							 AND JEIT.TAX_TYPE IN ('IVA', 'RIVA')
							 AND GDVW.IDCODE = '" . $txrerec['JEHDR_CODE'] . "'
							 AND JEIT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE)
                			  FROM GL_ITEM_TBL X
                			  WHERE X.IDCODE = JEIT.IDCODE
                			  AND X.CLX_EFFTDATE<=GDVW.EFFTDATE)
                	    GROUP BY
                	    	JEIT.FLAT_RATE";
                $iva = ClxCommon::$db->getOneRecord($sql);
                if (empty($iva)) {
                    $txrerec['IVA_RATE'] = 0;
                    $txrerec['IVA_AMT'] = 0;
                } else {
                    //echo $record['BASE_TRANS_AMT'].'<br>'.$iva['FLAT_RATE'].'<br>';
                    //echo bcmul($record['BASE_TRANS_AMT'], bcdiv($iva['FLAT_RATE'], '100')).'<hr>';
                    $txrerec['IVA_RATE'] = $iva['FLAT_RATE'];
                    $txrerec['IVA_AMT'] = bcmul($record['BASE_TRANS_AMT'], bcdiv($iva['FLAT_RATE'], '100')); //bcmul($txrerec['TAX_AMT'], bcdiv($txrerec['IVA_RATE'],'100'));
                }
                break;
            // monto retencion
            /* case 'RIVA':
              //$record['RIVA_BASE_LINE_AMT'] = bcadd((string)$record['RIVA_BASE_LINE_AMT'], (string)$record['BASE_LINE_AMT']); // Monto de la retenci�n
              //$record['RIVA_FLAT_RATE'] = $record['FLAT_RATE'];	// % de la retenci�n
              $txrerec['INVOICE_AMT']		 = $record['BASE_TRANS_AMT'];//-TOTALCOMPRA- Total Compra incluyendo IVA, debe ser igual al desembolso mas el IVA calculado.
              $txrerec['TAXABLE_AMT'] 	 = $record['BASE_CASH_LINE_AMT'];//-BASEIMPONIBLE- Base imponible es igual al desembolso.
              $txrerec['TAX_AMT'] 		 = bcabs($record['BASE_LINE_AMT']);//-IMPUESTOIVA- Impuesto IVA, debe ser el monto completo del IVA.
              $txrerec['TAX_RATE'] 		 = rounder(bcmul(bcdiv($txrerec['TAX_AMT'],$txrerec['TAXABLE_AMT']),'100'),2);//$record['FLAT_RATE']--Verificar si no hay que coloar otro
              $txrerec['TAXWITHOLDING_AMT']= $txrerec['TAX_AMT'];//-IVARETENIDO- IVA retenido, debe ser la cifra final de IVA retenida.
              $txrerec['TAXCRED_EXEMPTION']= 0;//-COMPRASINDERECHOIVA- Compra sin derecho a Credito IVA, debe ser igual a cero.
              break; */
            // impuesto sobre la renta
            case 'ISLR':

                $txrerec['INVOICE_AMT'] = $record['BASE_TRANS_AMT'];
                $txrerec['TAXABLE_AMT'] = $record['BASE_TRANS_AMT'];
                $txrerec['TAX_AMT'] = bcabs($record['BASE_LINE_AMT']); //$formato = str_replace('-MENOSTIMBRE-',xFormat::number(bcabs($record['TAX_AMT']),2),$formato);
                $txrerec['TAXWITHOLDING_AMT'] = $record['BASE_TRANS_AMT']; //'-RETENCION-'str_replace('-TARIFA_FIS-',xFormat::number($record['TAX_RATE'],2),$formato);
                $txrerec['TAX_RATE'] = bcabs($record['FLAT_RATE']); //rounder(bcmul(bcdiv($txrerec['TAX_AMT'],$txrerec['TAXABLE_AMT']),'100'),2);//$formato = str_replace('-PORCENTAJE-',xFormat::number(,2),$formato);

                /* $formato = str_replace('-BASEIMPONIBLE-',xFormat::number(bcabs($record['TAXABLE_AMT']),2),$formato);
                  $formato = str_replace('-PORCENTAJE-',xFormat::number($record['TAX_RATE'],2),$formato);
                  $formato = str_replace('-TOTALFACTURA-',xFormat::number($record['INVOICE_AMT'],2),$formato);
                  $formato = str_replace('-MONTOABONADO-',xFormat::number($record['FIAT_LINE_AMT'],2),$formato);
                  $formato = str_replace('-MONTORETENIDO-',xFormat::number(bcabs($record['TAX_AMT']),2),$formato); */

                //$record['ISLR_BASE_LINE_AMT'] = bcadd((string)$record['ISLR_BASE_LINE_AMT'], (string)$record['BASE_LINE_AMT']); // Monto de la retenci�n
                //$record['ISLR_FLAT_RATE'] = $record['FLAT_RATE'];	// % de la retenci�n
                break;
        }//End switch
    }

//end method

    function validate_txre($record) {
        $status = true;

        return $status;
    }

//end method

    function prepare_beneficiary(&$record) {
        //global $db;
        // Verify the source of the payee data
        if ($record['FIBT_BENEFICIARY_NAME'] != '') {
            // Extracts data from payee record (FIBT Table)
            $record['IDNAME'] = $record['FIBT_BENEFICIARY_NAME'];
            $record['BENEFICIARY_NAME'] = $record['FIBT_BENEFICIARY_NAME'];
            $record['IDENTIFICATION'] = $record['FIBT_IDENTIFICATION'];
            $record['LEGAL_TYPE'] = $record['FIBT_LEGAL_TYPE'];
            /*
             * OJO - DEDUCE EL TIPO DE IDENTIFICACI�N:
             * si es Extranjero, asume pasaporte;
             * si es persona juridica extranjera o nacional, asume RIF;
             * si es venezolano, asume cedula de identidad;
             * de lo contrario deja en blanco
             */
            //$accorec['RIF'] = ($accorec['LEGAL_TYPE']!='E') ? $record['FIBT_IDENTIFICATION'] : '';
            $record['ID_TYPE'] = ($record['FIBT_LEGAL_TYPE'] == 'E') ? 'PAS' : (($record['FIBT_LEGAL_TYPE'] == 'N' || $record['FIBT_LEGAL_TYPE'] == 'J') ? 'RIF' : (($record['FIBT_LEGAL_TYPE'] == 'V') ? 'CIV' : ''));
            $record['PASSPORT_NO'] = ($record['FIBT_LEGAL_TYPE'] == 'E') ? $record['FIBT_IDENTIFICATION'] : '';
            $record['ISINDIVIDUAL'] = (($record['FIBT_LEGAL_TYPE'] == 'E' || $record['FIBT_LEGAL_TYPE'] == 'V') ? 1 : 0);
            $DBLT = getTool("DBLT");
            $aclorec['ADDRESS1'] = $record['FIBT_ADDRESS'];
            $aclorec['ADDRESS2'] = '';
            $aclorec['CITY'] = '';
            $aclorec['STATE'] = $record['FIBT_STATE'];
            $aclorec['COUNTRY'] = $record['FIBT_COUNTRY'];
            //$aclorec['CITY'] 		= $DBLT->getListItem('LOCI', $record['FIBT_CITY']);
            $aclorec['STATE'] = $DBLT->getListItem('VZST', $record['FIBT_STATE']);
            $aclorec['COUNTRY'] = $DBLT->getListItem('COUN', $record['FIBT_COUNTRY']);
            $record['PAYEE_ADDRESS'] = $aclorec['ADDRESS1'] . '<br>' . $aclorec['ADDRESS2'] . '<br>' . $aclorec['CITY'] . '<br>' . $aclorec['STATE'] . '<br>' . $aclorec['COUNTRY'];
        } else {
            $record['BENEFICIARY_NAME'] = $record['ACCO_BENEFICIARY_NAME'];
            $record['ISINDIVIDUAL'] = (($record['ACCO_LEGAL_TYPE'] == 'E' || $record['ACCO_LEGAL_TYPE'] == 'V') ? 1 : 0);
            $record['LEGAL_TYPE'] = $record['ACCO_LEGAL_TYPE'];
            $record['ID_TYPE'] = $record['ACCO_ID_TYPE'];
            $record['IDENTIFICATION'] = $record['ACCO_IDENTIFICATION'];
            $record['PASSPORT_NO'] = (($record['ACCO_LEGAL_TYPE'] == 'E') ? $record['ACCO_IDENTIFICATION'] : '');
            $record['PAYEE_ADDRESS'] = $this->payee_address($record['ACCOUNTCODE']);
        }
    }

//End method

    function comp_logo($comp_code = '') {
        //global $db;

        $OBJS = &getTool("OBJS");
        if ($comp_code <> '')
            $this->comp = $comp_code;
        //$fieldinstance = &$OBJS->getObject("DBFT", 'FILE');
		$fieldinstance = getToolObject("DBFT", 'FILE');
        $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', "FIELDNAME='COMP_LOGO'");
        $comprec = ClxCommon::$db->getRecord($this->compname, "IDCODE = '$this->comp'");
        $return = $fieldinstance->formatField('COMP_LOGO', $fieldrec, $comprec);
        $return .= '<br><font size=3><b>' . $comprec['REP_GERENCIA'] . '</b></font><br>';
        return $return;
    }

    function create_txre($record) {
        //global $db;

        if (empty($this->comp_address))
            $this->company_location($record['COMP_CODE']);
        $this->prepare_beneficiary($record);

        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        $rec = array('IDCODE' => 'AUTO',
            'COMP_CODE' => $record['COMP_CODE'],
            'JEHDR_CODE' => $record['JEHDR_CODE'],
            'TAX_TYPE' => $record['TAX_TYPE'],
            'EFFTDATE' => $record['EFFTDATE'],
            'PER_YEAR' => xFormat::date($record['EFFTDATE'], 'Y'),
            'PER_MONTH' => xFormat::date($record['EFFTDATE'], 'm'),
            'INVOICE_ITEM' => $record['INVOICE_ITEM'],
            'OBSERVATION' => $record['OBSERVACIONES'],
            'COMP_LEGALNAME' => $record['COMP_LEGALNAME'],
            'COMP_TAXID' => $record['COMP_TAXID'],
            'COMP_ADDRESS' => $this->comp_address,
            'BENEFICIARY_NAME' => $record['BENEFICIARY_NAME'],
            'ISINDIVIDUAL' => $record['ISINDIVIDUAL'],
            'LEGAL_TYPE' => $record['LEGAL_TYPE'],
            'ID_TYPE' => $record['ID_TYPE'],
            'IDENTIFICATION' => $record['IDENTIFICATION'],
            'PASSPORT_NO' => $record['PASSPORT_NO'],
            'INVOICE_NO' => $record['INVOICE_NO'],
            'INVOICE_NO_02' => $record['INVOICE_NO_02'],
            'INVOICE_DATE' => $record['INVOICE_DATE'],
            'TRANS_CODE' => $record['TRANS_CODE'],
            'TRANS_DATE' => $record['EFFTDATE'],
            'PAYEE_ADDRESS' => $record['PAYEE_ADDRESS'],
            'OFFICER_FIRSTNAME' => companyParameter('FIDU_FUNCIONARIO_COMPROB_NOMBRE', $record['COMP_CODE']),
            'OFFICER_LASTNAME' => companyParameter('FIDU_FUNCIONARIO_COMPROB_APELLIDO', $record['COMP_CODE']),
            'OFFICER_TITLE' => companyParameter('FIDU_FUNCIONARIO_COMPROB_CARGO', $record['COMP_CODE']),
            'CDATE' => '',
            'MDATE' => '',
            'CREATEDBY' => '',
            'MODIFIEDBY' => ''
        );
        //Perform Calculations
        $this->calculate_txre($rec, $record);
        //Formating Required for IVA
        if ($record['TAX_TYPE'] == 'IVA' || $record['TAX_TYPE'] == 'RIVA') {
            setCreationIdCode($rec, 'TXRE');
            $rec['IDCODE'] = xFormat::date($rec['EFFTDATE'], 'Y-m') . '-' . $rec['IDCODE'];
        } else {
            $rec['IDCODE'] = str_replace('.', '', microtime(true)); //setCreationIdCode($rec, 'TXRE');
        }
        setCreationData($rec);
        $rec['ID'] = ClxCommon::$db->createRecord($this->txrename, $rec);
    }

//end method

    /**
     * Send report to screen
     */
    function comp_report() {
        //global $db;

        $idlist = getIdlist();
        $this->contents = '';
        $results = ClxCommon::$db->getRecords($this->txrename, "ID IN ('" . implode("','", $idlist) . "')");
        while (($result = ClxCommon::$db->getNextRecord($results)) == true) {
            switch ($result['TAX_TYPE']) {
                case ($result['TAX_TYPE'] == 'RIVA' || $result['TAX_TYPE'] == 'IVA'):
                    $this->contents .= $this->comp_formato_generic_replace($this->formato_iva(), $result);
                    break;
                case 'FIS':
                    $this->contents .= $this->comp_formato_generic_replace($this->formato_timbre_fiscal(), $result);
                    break;
                case 'ISLR':
                    $this->contents .= $this->comp_formato_generic_replace($this->formato_islr(), $result);
                    break;
                default:
                    addMessage(dict('GEN_LBL_NOTFORMFOUND'), $result['TAX_TYPE'], $result['ID']);
                    break;
            }//End switch
        }
    }

//End method
    //--------------------------------------------------------------

    /*
     * Creates TXRE record from the specified transacion idcode
     */
    function create_txre_record($fiat_idcode, $s_tax_form) {

        if ($this->debug)
            echoLog("<b>create_txre_record</b>");

        //global $db;

        $DBLT = getTool("DBLT");

        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        //includeCodeLib('GEN_REC_UTIL');


        $txrename = tableName('TXRE');
        $ar_record_txre = array();
        $accorec = array();
        $aclorec = array();
        $b_error = false;
        $ar_error_msg = array();
        $record = array();

        // SQL for transaction lines data retrieval
        $sql = "SELECT
					FIBT.ID FIBT_ID,
					FIBT.BENEFICIARY_NAME,
					FIBT.IDENTIFICATION FIBT_IDENTIFICATION,
					FIBT.LEGAL_TYPE FIBT_LEGAL_TYPE,
					FIBT.INVOICE_ITEM,
					FIBT.INVOICE_NO,
					FIBT.INVOICE_NO_02,
					FIAT.EFFTDATE INVOICE_DATE,
					FIBT.OBSERVATION OBSERVACIONES,
					FIBT.ACCOUNTCODE,
					FIBT.ADDRESS FIBT_ADDRESS,
					FIBT.COUNTRY FIBT_COUNTRY,
					FIBT.STATE FIBT_STATE,

					ACCO.IDNAME ACCO_IDNAME,
					ACCO.IDENTIFICATION ACCO_IDENTIFICATION,
					ACCO.LEGAL_TYPE ACCO_LEGAL_TYPE,
					ACCO.ID_TYPE,

					FITL.LINE_AMT,

					FIAT.IDCODE FIAT_IDCODE,
					FIAT.APPROVAL_DATE,
					FIAT.PARTICIPANT_ID,
					FIAT.EFFTDATE,
					FIAT.TRANS_AMT,

					TXTB.IDNAME CONCEPTO,
					TXTB.FLAT_RATE,
					TXTB.TAX_TYPE,

					FICO.COMP_CODE
				FROM
					$this->fitlname FITL
						LEFT JOIN $this->txtbname TXTB ON TXTB.IDCODE = FITL.INCEXP_CODE,
					$this->fiatname FIAT
						LEFT JOIN $this->ficoname FICO ON FICO.IDCODE = FIAT.CONTRACT_CODE
						LEFT JOIN $this->fibtname FIBT ON FIBT.TRANS_CODE = FIAT.IDCODE
						LEFT JOIN $this->acconame ACCO ON ACCO.IDCODE = FIBT.ACCOUNTCODE
				WHERE
					FIAT.IDCODE = '$fiat_idcode'
					AND FITL.TRANS_CODE = FIAT.IDCODE
					AND	(FIAT.REVTRANS_CODE IS NULL OR FIAT.REVTRANS_CODE = '')
					AND (SELECT IDCODE FROM $this->fiatname B WHERE B.REVTRANS_CODE = FIAT.IDCODE AND B.TRANS_STATUS IN ('AP','CLOS')) IS NULL
					";

        // Transaction lines processing
        $records = ClxCommon::$db->executeQuery($sql);
        if ($this->debug)
            echoLog("<b>$sql</b>");
        while (($record_1 = ClxCommon::$db->getNextRecord($records)) == true) {

            if (!array_key_exists('IVA_BASE_LINE_AMT', $record)) {
                $record = $record_1;
                $record['IVA_BASE_LINE_AMT'] = 0; // Monto del IVA
                $record['IVA_FLAT_RATE'] = 0; // Porcentaje IVA
                $record['FIST_BASE_LINE_AMT'] = 0; // base imponible del timbre x % de la tarifa
                $record['FIST_FLAT_RATE'] = 0; // % DE LA TARIFA del timbre
                $record['RIVA_BASE_LINE_AMT'] = 0; // monto retencion
                $record['RIVA_FLAT_RATE'] = 0; // % de RETENCION �?
                $record['ISLR_BASE_LINE_AMT'] = 0; // monto del ISLR
                $record['ISLR_FLAT_RATE'] = 0; // % ISLR �?
            }
            switch ($record_1['TAX_TYPE']) {
                // + el Monto del IVA
                case 'IVA':
                    $record['IVA_BASE_LINE_AMT'] = bcadd((string) $record['IVA_BASE_LINE_AMT'], (string) $record_1['BASE_LINE_AMT']); // Monto del IVA
                    $record['IVA_FLAT_RATE'] = $record_1['FLAT_RATE']; // Porcentaje IVA
                    break;
                // - el timbre fiscal
                case 'FIS':
                    $record['FIST_BASE_LINE_AMT'] = bcadd((string) $record['FIST_BASE_LINE_AMT'], (string) $record_1['BASE_LINE_AMT']); // base imponible del timbre x % de la tarifa
                    $record['FIST_FLAT_RATE'] = bcabs($record_1['FLAT_RATE'] * 100); // % DE LA TARIFA del timbre
                    break;
                // monto retencion
                case 'RIVA':
                    $record['RIVA_BASE_LINE_AMT'] = bcadd((string) $record['RIVA_BASE_LINE_AMT'], (string) $record_1['BASE_LINE_AMT']); // Monto de la retenci�n
                    $record['RIVA_FLAT_RATE'] = $record_1['FLAT_RATE']; // % de la retenci�n
                    break;
                // impuesto sobre la renta
                case 'ISLR':
                    $record['ISLR_BASE_LINE_AMT'] = bcadd((string) $record['ISLR_BASE_LINE_AMT'], (string) $record_1['BASE_LINE_AMT']); // Monto de la retenci�n
                    $record['ISLR_FLAT_RATE'] = $record_1['FLAT_RATE']; // % de la retenci�n
                    break;
            }
        }
		ClxCommon::$db->freeResult($records);
        if ($this->debug) {
            echoLog("record");
            print_r($record);
            echo "<br>";
        }

        // Verify results of the transaction lines processing
        if (!isset($record['IVA_BASE_LINE_AMT'])) {

            /**
             * CODE_TXRECREA_ERR_01
             * Transaction without lines
             * La transacci�n no tiene l�neas
             */
            $b_error = true;
            $ar_error_msg[] = dict("CODE_TXRECREA_ERR_01");
        } else {

            /*
             * CODE_TXRECREA_ERR_02
             * Payee isn't specified
             * No se especific� el beneficiario
             */
            if ($record['FIBT_ID'] == NULL) {
                $ar_error_msg[] = dict("CODE_TXRECREA_ERR_02");
                $b_error = true;
            }

            if ($s_tax_form == 'IVA') {
                // Especificos del IVA
                if ($record['IVA_BASE_LINE_AMT'] == 0) {
                    /*
                     * CODE_TXRECREA_ERR_03
                     * IVA amount is zero
                     * El monto del IVA est� en cero
                     */
                    $ar_error_msg[] = dict("CODE_TXRECREA_ERR_02");
                    if ($record['FIST_BASE_LINE_AMT'] == 0) {
                        $b_error = true;
                    }
                }
                if ($record['IVA_FLAT_RATE'] == 0) {
                    /*
                     * CODE_TXRECREA_ERR_04
                     * IVA Percent isn't specified
                     * El porcentaje de retenci�n del IVA no fue especificado
                     */
                    $ar_error_msg[] = dict("CODE_TXRECREA_ERR_04");
                    if ($record['FIST_FLAT_RATE'] == 0) {
                        /*
                         * CODE_TXRECREA_ERR_05
                         * Fiscal Stamp percent isn't specified
                         * El porcentaje del Timbre Fiscal no fue especificado
                         */
                        $ar_error_msg[] = dict("CODE_TXRECREA_ERR_05");
                        $b_error = true;
                    }
                }
            }

            if ($s_tax_form == 'FIST') {
                // Fiscal stamp specifics
                if ($record['FIST_BASE_LINE_AMT'] == 0) {
                    /*
                     * CODE_TXRECREA_ERR_06
                     * Fiscal Stamp amount is zero
                     * El monto del Timbre Fiscal est� en cero
                     */
                    $ar_error_msg[] = dict("CODE_TXRECREA_ERR_06");
                    $b_error = true;
                }
            }
        }

        // Prepares data to be printed
        if ($b_error == false) {
            // Base imponible
            // total factura = fiat.TRANS_AMT
            // base imponible = monto del iva / tarifa %
            if ($record['IVA_FLAT_RATE'] != 0) {
                $n_base_imponible = bcdiv((string) $record['IVA_BASE_LINE_AMT'], bcdiv((string) $record['IVA_FLAT_RATE'], "100"));
            } else {
                //$n_base_imponible = $record['FIST_BASE_LINE_AMT'] / ($record['FIST_FLAT_RATE']/100);
                $n_base_imponible = bcdiv((string) $record[$s_tax_form . '_BASE_LINE_AMT'], bcdiv((string) $record[$s_tax_form . '_FLAT_RATE'], "100"));
            }
            $record['n_base_imponible'] = $n_base_imponible;

            // Verify the source of the payee data
            if ($record['BENEFICIARY_NAME'] != '') {
                // Extracts data from payee record (FIBT Table)
                $accorec['IDNAME'] = $record['BENEFICIARY_NAME'];
                $accorec['IDENTIFICATION'] = $record['FIBT_IDENTIFICATION'];
                $accorec['LEGAL_TYPE'] = $record['FIBT_LEGAL_TYPE'];
                /*
                 * OJO - DEDUCE EL TIPO DE IDENTIFICACI�N:
                 * si es Extranjero, asume pasaporte;
                 * si es persona juridica extranjera o nacional, asume RIF;
                 * si es venezolano, asume cedula de identidad;
                 * de lo contrario deja en blanco
                 */
                //$accorec['RIF'] = ($accorec['LEGAL_TYPE']!='E') ? $record['FIBT_IDENTIFICATION'] : '';
                $accorec['ID_TYPE'] = ($accorec['LEGAL_TYPE'] == 'E') ? 'PAS' : (($accorec['LEGAL_TYPE'] == 'N' || $accorec['LEGAL_TYPE'] == 'J') ? 'RIF' : (($accorec['LEGAL_TYPE'] == 'V') ? 'CIV' : ''));

                $accorec['PASAPORTE'] = ($accorec['LEGAL_TYPE'] == 'E') ? $record['FIBT_IDENTIFICATION'] : '';
                $aclorec['ADDRESS1'] = $record['FIBT_ADDRESS'];
                $aclorec['ADDRESS2'] = '';
                $aclorec['CITY'] = '';
                $aclorec['STATE'] = $record['FIBT_STATE'];
                $aclorec['COUNTRY'] = $record['FIBT_COUNTRY'];
            } else {
                // Extracts data from CRM record (ACCO Table)
                $accorec['IDNAME'] = $record['ACCO_IDNAME'];
                $accorec['IDENTIFICATION'] = $record['ACCO_IDENTIFICATION'];
                $accorec['LEGAL_TYPE'] = $record['ACCO_LEGAL_TYPE'];
                //$accorec['RIF'] = ($record['ID_TYPE']=='RIF') ? $record['ACCO_IDENTIFICATION'] : '';
                $accorec['ID_TYPE'] = $record['ID_TYPE'];
                $accorec['PASAPORTE'] = ($record['ID_TYPE'] == 'PAS') ? $record['ACCO_IDENTIFICATION'] : '';
                $aclorec = ClxCommon::$db->getRecord($this->acloname, "ACCOUNTCODE = '" . $record['ACCOUNTCODE'] . "' AND ISPRIMARY = 1");
                // Extracts location address
                if (!$aclorec) {
                    // he/she/it hasn't a main address, so takes the first one
                    $aclorec = ClxCommon::$db->getRecord($this->acloname, "ACCOUNTCODE = '" . $record['ACCOUNTCODE'] . "'");
                }
                if (!$aclorec) {
                    // he/she/it hasn't any address at all
                    $aclorec = NULL;
                }
            }

            // payee default location address
            if ($aclorec == NULL) {
                // No address, assings an empty address
                $aclorec = array();
                $aclorec['ADDRESS1'] = '';
                $aclorec['ADDRESS2'] = '';
                $aclorec['CITY'] = '';
                $aclorec['STATE'] = '';
                $aclorec['COUNTRY'] = '';
            } else {
                // Extracts descriptions from related tables
                if ($aclorec['CITY'] == '') {
                    $ar_error_msg[] = "No se especific� la ciudad";
                } else {
                    $s_city = $DBLT->getListItem('LOCI', $aclorec['CITY']);
                    if ($s_city != '') {
                        $aclorec['CITY'] = $s_city;
                    } else {
                        /*
                         * CODE_TXRECREA_ERR_07
                         * Invalid specified city (^1)
                         * La ciudad especificada (^1) es inv�lida
                         */
                        $ar_error_msg[] = dict("CODE_TXRECREA_ERR_07", $s_city);
                    }
                }
                $s_state = $DBLT->getListItem('VZST', $aclorec['STATE']);
                if ($s_state != '') {
                    $aclorec['STATE'] = $s_state;
                } else {
                    /*
                     * CODE_TXRECREA_ERR_08
                     * Invalid specified state (^1)
                     * El estado especificado (^1) es inv�lido
                     */
                    $ar_error_msg[] = dict("CODE_TXRECREA_ERR_08", $s_state);
                }
                $s_country = $DBLT->getListItem('COUN', $aclorec['COUNTRY']);
                if ($s_country != '') {
                    $aclorec['COUNTRY'] = $s_country;
                } else {
                    /*
                     * CODE_TXRECREA_ERR_09
                     * Invalid specified country (^1)
                     * El pa�s especificado (^1) es inv�lido
                     */
                    $ar_error_msg[] = dict("CODE_TXRECREA_ERR_09", $s_state);
                }
            }
            $record['dir'] = $aclorec['ADDRESS1'] . '<br>' . $aclorec['ADDRESS2'] . '<br>' . $aclorec['CITY'] . '<br>' . $aclorec['STATE'] . '<br>' . $aclorec['COUNTRY'];

            // Company data
            $comprec = ClxCommon::$db->getRecord($this->compname, "IDCODE = '" . $this->comp . "'");
            //$colorec = ClxCommon::$db->getRecord(tableName('COLO'), "COMP_CODE = '".$comprec['IDCODE']."' ORDER BY ISPRIMARY DESC");
            $sql = "SELECT COLO.*
					FROM " . tableName('COLO') . ' COLO, ' . tableName('DYCL') . " DYCL
					WHERE DYCL.COMP_CODE = '" . $comprec['IDCODE'] . "'
							AND DYCL.COMPLOC_CODE = COLO.IDCODE
					ORDER BY COLO.ISPRIMARY DESC ";
            $colorec = ClxCommon::$db->getOneRecord($sql);
            if (!$colorec) {
                // No company address found
                $comp_address = '';
            } else {
                $colorec['CITY'] = $DBLT->getListItem('loci', $colorec['CITY']);
                $comp_address = $colorec['ADDRESS1'] . ' ' . $colorec['ADDRESS2'] . ', ';
                $comp_address .= ' ' . $colorec['CITY'] . ', Telf:' . $colorec['PHONE'] . ' / ' . $colorec['FAX'];
            }
            // If observations are empty, put blank lines to fill the printing space
            if ($record['OBSERVACIONES'] == '')
                $record['OBSERVACIONES'] = "<BR><BR><BR><BR>";

            // Prepares TXRE record data
            $ar_record_txre['TAX_FORM'] = $s_tax_form;          // 	LIST 	1.0.0-1 	Comprobante 	No 	Tax Form
            $ar_record_txre['EFFTDATE'] = getNow('Y-m-d');         // 	DATE 	1.0.0-10 	Fecha Efectiva 	Yes 	Fecha de Generacion del Comprobante
            $ar_record_txre['PER_YEAR'] = adodb_date('Y', adodb_strtotime($record['EFFTDATE']));  // 	INTN 	1.0.0-1 	A�o del Periodo 	No 	Period Year
            $ar_record_txre['PER_MONTH'] = adodb_date('m', adodb_strtotime($record['EFFTDATE']));  // 	INTN 	1.0.0-1 	Mes del Periodo 	No 	Period Month
            $ar_record_txre['COMP_LEGALNAME'] = $comprec['IDNAME'];      // 	CHAR 	1.0.0-1 	Nombre Registrado/Razón Social 	No 	Company Legal Name
            $ar_record_txre['COMP_TAXID'] = $comprec['TAXID'];       // 	CHAR 	1.0.0-1 	Registro de Información (Agente de Retenci�n) 	No 	Company Tax Id
            $ar_record_txre['COMP_ADDRESS'] = $comp_address;        // 	TEXT 	1.0.0-0 	Direcci�n de Compañía 	No 	Company Address
            $ar_record_txre['INVOICE_ITEM'] = $record['INVOICE_ITEM'];     // 	CHAR 	1.0.0-1 	Por Concepto de 	No 	Invoice Item or Service
            $ar_record_txre['BENEFICIARY_NAME'] = $accorec['IDNAME'];      // 	CHAR 	1.0.0-0 	Beneficiario 	No 	Beneficiary Name
            $ar_record_txre['ISINDIVIDUAL'] = ($accorec['LEGAL_TYPE'] == 'E' || $accorec['LEGAL_TYPE'] == 'V') ? 1 : 0; // 	BOOL 	1.0.0-3 	¿Persona Natural/Física ? 	No 	Individual Account Flag
            $ar_record_txre['LEGAL_TYPE'] = $accorec['LEGAL_TYPE'];      // 	LIST 	1.0.0-3 	Tipo de Persona 	No 	Legal Type
            $ar_record_txre['ID_TYPE'] = $accorec['ID_TYPE'];        // 	LIST	1.0.0-9 	Tipo de Identificación 	No 	Id Type
            $ar_record_txre['IDENTIFICATION'] = $accorec['IDENTIFICATION'];    // 	CHAR 	1.0.0-9 	No. de Identificación 	No 	Id Identification
            $ar_record_txre['PASSPORT_NO'] = $accorec['PASAPORTE'];      // 	CHAR 	1.0.0-0 	Passport Number 	No 	Passport Number
            $ar_record_txre['PAYEE_ADDRESS'] = $record['dir'];        // 	TEXT 	1.0.0-1 	Dirección del Contribuyente/Beneficiario 	No 	Payee Address
            $ar_record_txre['INVOICE_NO'] = $record['INVOICE_NO'];       // 	CHAR 	1.0.0-0 	Invoice No. 	No 	Invoice Number
            $ar_record_txre['INVOICE_NO_02'] = $record['INVOICE_NO_02'];     // 	CHAR 	1.0.0-0 	Invoice No. 	No 	NUMERO DE CONTROL 2005/12/22
            $ar_record_txre['INVOICE_DATE'] = $record['INVOICE_DATE'];      // 	DATE 	1.0.0-0 	Fecha de la Factura 	No 	Invoice Date
            $ar_record_txre['TRANS_CODE'] = $fiat_idcode;         // 	LOOK 	1.0.0-1 	C�digo de Transacción 	No 	Transaction Code
            $ar_record_txre['TRANS_DATE'] = $record['EFFTDATE'];       // 	DATE 	1.0.0-0 	Transaction Date 	No 	Transaction Date
            $ar_record_txre['INVOICE_AMT'] = $record['BASE_TRANS_AMT'];     // 	DECN 	1.0.0-1 	Monto de la Factura 	No 	Invoice Amount
            $ar_record_txre['TAXABLE_AMT'] = $record['n_base_imponible'];     // 	DECN 	1.0.0-1 	Base Imponible 	No 	Taxable Amount
            $ar_record_txre['TAX_AMT'] = $record[$s_tax_form . '_BASE_LINE_AMT'];       // 	DECN 	1.0.0-3 	Impuesto 	No 	Tax Amount
            $ar_record_txre['TAXWITHOLDING_AMT'] = $record['RIVA_BASE_LINE_AMT'];       // 	DECN 	1.0.0-1 	Monto de Retención 	No 	Tax Witholding Amount
            $ar_record_txre['TAX_RATE'] = $record[$s_tax_form . '_FLAT_RATE'];        // 	DECN 	1.0.0-1 	Tarifa / Tasa de Retención 	No 	Tax Rate
            $ar_record_txre['TAXCRED_EXEMPTION'] = $record['TRANS_AMT'] - $record['n_base_imponible']; // 	DECN 	1.0.0-1 	Monto que no puede usar de Credito IVA 	No 	Tax Credit Exemption
            $ar_record_txre['OBSERVATION'] = $record['OBSERVACIONES'];          // 	TEXT 	1.0.0-0 	Observaci�n 	No 	Observation
            $ar_record_txre['IDCODE'] = 'AUTO';               // 	CHAR 	1.0.0-8 	Código 	Yes 	Numero del Comprobante (Unique record code)

            $ar_record_txre = setCreationIdCode($ar_record_txre, 'TXRE');
            $s_id = ClxCommon::$db->createRecord($txrename, $ar_record_txre);
            $ar_record_txre['ID'] = $s_id;
        }

        if ($this->debug) {
            echoLog("ar_record_txre");
            print_r($ar_record_txre);
            echo "<br>";
        }
        if ($this->debug) {
            echoLog("ar_error_msg");
            print_r($ar_error_msg);
            echo "<br>";
        }
        $ar_response = array(
            'error' => $b_error,
            'errormsg' => $ar_error_msg,
            'ar_record_txre' => $ar_record_txre
        );

        return $ar_response;
    }

// Method End

    /*
     * returns tax form signer data
     */

    function get_tf_signer_data($record = NULL) {
        if ($record == NULL) {
            $record = array(
                'record' => array(),
                'errormsg' => array(),
            );
        }
        $s_par_funcionario_nombre = 'FIDU_FUNCIONARIO_COMPROB_NOMBRE';
        $s_par_funcionario_apellido = 'FIDU_FUNCIONARIO_COMPROB_APELLIDO';
        $s_par_funcionario_cargo = 'FIDU_FUNCIONARIO_COMPROB_CARGO';

        $s_funcionario_nombre = companyParameter($s_par_funcionario_nombre, $this->comp); // Nombre del funcionario que firma los comprobantes
        if ($s_funcionario_nombre == '') {
            $s_funcionario_nombre = '???';
            /*
             * CODE_TXRECREA_ERR_10
             * Agent name ins't specified (^1 company parameter)
             * No se especific� el nombre del funcionario (par�metro de la compa��a ^1)
             */
            $record['errormsg'][] = dict("CODE_TXRECREA_ERR_10", $s_par_funcionario_nombre);
        }
        $s_funcionario_apellido = companyParameter($s_par_funcionario_apellido, $this->comp); // Apellido del funcionario que firma los comprobantes
        if ($s_funcionario_apellido == '') {
            $s_funcionario_apellido = '???';
            /*
             * CODE_TXRECREA_ERR_11
             * Agent lastname ins't specified (^1 company parameter)
             * No se especific� el apellido del funcionario (par�metro de la compa��a ^1)
             */
            $record['errormsg'][] = dict("CODE_TXRECREA_ERR_11", $s_par_funcionario_apellido);
        }
        $s_funcionario_cargo = companyParameter($s_par_funcionario_cargo, $this->comp); // Cargo del funcionario que firma los comprobantes
        if ($s_funcionario_cargo == '') {
            $s_funcionario_cargo = '???';
            /*
             * CODE_TXRECREA_ERR_12
             * Agent position ins't specified (^1 company parameter)
             * No se especific� el cargo del funcionario (par�metro de la compa��a ^1)
             */
            $record['errormsg'][] = dict("CODE_TXRECREA_ERR_12", $s_par_funcionario_cargo);
        }

        $record['record']['s_funcionario_nombre'] = $s_funcionario_nombre;
        $record['record']['s_funcionario_apellido'] = $s_funcionario_apellido;
        $record['record']['s_funcionario_cargo'] = $s_funcionario_cargo;

        return $record;
    }

// Method End

    /*
     * Devuelve un string con el reporte de errores que se
     * encontraron el la impresion del comprobante
     */

    function comp_error_report($s_pre_content, $s_fiat_idcode, $ar_error_msg) {
        // Reporta errores y advertencias
        if (count($ar_error_msg) > 0) {
            /*
             * CODE_TXRECREA_ERR_TRANHASERRORTITLE
             * Warning: transaction # ^1 has the following errors:
             * Atenci�n: la transacci�n # ^1 tiene los siguientes errores:
             */
            $s_pre_content .=
                    dict("CODE_TXRECREA_ERR_TRANHASERRORTITLE", $s_fiat_idcode) . "<br>" .
                    '<li>' . implode('</li><li>', $ar_error_msg) . '</li>' .
                    "<br><br>";
        }

        return $s_pre_content;
    }

// Method End

    /*
     * Base replacement of format fields
     */

    function comp_formato_generic_replace($formato, &$ar_record) {

        if ($this->debug) {
            echo "<BR>comp_formato_generic_replace ANTES<BR>";
            print_r($ar_record);
            echo "<br>";
        }
        // Add the data of agent who sign the document
        $ar_response = $this->get_tf_signer_data($ar_record);
        $ar_record['record'] = (!empty($ar_response['errormsg'])) ? $ar_response['record'] : '';
        $ar_record['errormsg'] = (!empty($ar_response['errormsg'])) ? $ar_response['errormsg'] : '';
        $record = $ar_record['record'];
        $record = $ar_record;

        //Set Company Code for comp logo
        $this->comp = $record['COMP_CODE'];

        if ($this->debug) {
            echo "<BR>DESPUES comp_formato_generic_replace<BR>";
            print_r($record);
            echo"<br>";
        }

        $s_mes = uppercase(dict('UICA_LBL_MONTH_' . substr('00' . $record['PER_MONTH'], -2)));
        $s_ano = uppercase($record['PER_YEAR']);

        $formato = str_replace('-COMP_LOGO-', $this->comp_logo(), $formato);
        $formato = str_replace('-AGENT_RET_NOMBRE-', $record['COMP_LEGALNAME'], $formato);
        $formato = str_replace('-AGENT_RET_IDENTIFICACION-', $record['COMP_TAXID'], $formato);
        $formato = str_replace('-AGENT_RET_NOMBRE_DIREC-', $record['COMP_ADDRESS'], $formato);
        $formato = str_replace('-NOCOMPROBANTE-', $record['IDCODE'], $formato);
        $formato = str_replace('-MES-', $s_mes, $formato);
        $formato = str_replace('-ANO-', $s_ano, $formato);
        $formato = str_replace('-CONCEPTO-', $record['INVOICE_ITEM'], $formato);
        $formato = str_replace('-CONTRIBUYENTE-', $record['BENEFICIARY_NAME'], $formato);
        $formato = str_replace('-IDENTIFICACION-', $record['IDENTIFICATION'], $formato);
        $formato = str_replace('-NATURAL-', ($record['ISINDIVIDUAL'] == 1) ? 'X' : '', $formato);
        $formato = str_replace('-JURIDICA-', ($record['ISINDIVIDUAL'] == 0) ? 'X' : '', $formato);
        $formato = str_replace('-VENEZOLANA-', ($record['LEGAL_TYPE'] == 'V') ? 'X' : '', $formato);
        $formato = str_replace('-EXTRANJERA-', ($record['LEGAL_TYPE'] == 'E') ? 'X' : '', $formato);
        $formato = str_replace('-RIF-', ($record['ID_TYPE'] == 'RIF') ? $record['IDENTIFICATION'] : '', $formato);
        $formato = str_replace('-PASAPORTE-', $record['PASSPORT_NO'], $formato);
        $formato = str_replace('-FACTURA-', $record['INVOICE_NO'], $formato);
        $formato = str_replace('-NUMERO_CONTROL_FACTURA-', $record['INVOICE_NO_02'], $formato);

        $formato = str_replace('-FECHAFACTURA-', xFormat::date($record['INVOICE_DATE'], 'd/m/Y'), $formato);
        $formato = str_replace('-FECHAREGISTRO-', xFormat::date($record['EFFTDATE'], 'd/m/Y'), $formato);


        switch ($record['TAX_TYPE']) {
            // Impuesto al valor agregado
            case ($record['TAX_TYPE'] == 'IVA' || $record['TAX_TYPE'] == 'RIVA'):
                $formato = str_replace('-BASEIMPONIBLE-', xFormat::number(bcabs($record['TAXABLE_AMT']), 2), $formato);
                $formato = str_replace('-PERIODOFISCAL-', "$s_mes DE $s_ano", $formato);
                $formato = str_replace('-TOTALCOMPRA-', xFormat::number($record['INVOICE_AMT'], 2), $formato);
                $formato = str_replace('-PORCENTAJEALICUOTA-', xFormat::number($record['TAX_RATE'], 2), $formato);
                $formato = str_replace('-IMPUESTOIVA-', xFormat::number($record['TAX_AMT'], 2), $formato);
                $formato = str_replace('-IVARETENIDO-', xFormat::number($record['TAXWITHOLDING_AMT'], 2), $formato);
                $formato = str_replace('-COMPRASINDERECHOIVA-', xFormat::number($record['TAXCRED_EXEMPTION'], 2), $formato);
                break;
            // Timbre fiscal
            case 'FIS':
                $formato = str_replace('-BASEIMPONIBLE-', xFormat::number(bcabs($record['TAXABLE_AMT']), 2), $formato);
                $formato = str_replace('-RETENCION-', xFormat::number(bcabs($record['TAXWITHOLDING_AMT']), 2), $formato);
                $formato = str_replace('-PORCENTAJE-', xFormat::number($record['TAX_RATE'], 2), $formato);
                //$formato = str_replace('-MASIVA-',xFormat::number(bcadd($record['TAX_AMT'], $record['IVA_AMT']),2),$formato);
                $formato = str_replace('-MASIVA-', xFormat::number($record['IVA_AMT'], 2), $formato);
                $formato = str_replace('-IVA-', xFormat::number($record['IVA_RATE'], 2), $formato);
                $formato = str_replace('-MENOSTIMBRE-', xFormat::number(bcabs($record['TAX_AMT']), 2), $formato);

                break;
            // Impuesto sobre la renta
            case 'ISLR':
                $formato = str_replace('-BASEIMPONIBLE-', xFormat::number(bcabs($record['INVOICE_AMT']), 2), $formato);
                $formato = str_replace('-PORCENTAJE-', xFormat::number($record['TAX_RATE'], 2), $formato);
                $formato = str_replace('-TOTALFACTURA-', xFormat::number($record['INVOICE_AMT'], 2), $formato);
                //$formato = str_replace('-MONTOABONADO-',xFormat::number($record['FIAT_LINE_AMT'],2),$formato);
                $formato = str_replace('-MONTOABONADO-', xFormat::number($record['CASH_LINE_AMT'], 2), $formato);
                $formato = str_replace('-MONTORETENIDO-', xFormat::number(bcabs($record['TAX_AMT']), 2), $formato);
                break;
        }//End swith

        $formato = str_replace('-DIRECCION-', $record['PAYEE_ADDRESS'], $formato);
        $formato = str_replace('-OBSERVACIONES-', $record['OBSERVATION'], $formato);
        $formato = str_replace('-NOMBRE-', $record['OFFICER_FIRSTNAME'], $formato);
        $formato = str_replace('-APELLIDO-', $record['OFFICER_LASTNAME'], $formato);
        $formato = str_replace('-CARGO-', $record['OFFICER_TITLE'], $formato);

        return $formato;
    }

// Method End

    /*
     * --------------------------------------------
     * Comprobante de Retencion de Timbres Fiscales
     * --------------------------------------------
     */

    function comp_timbre_fiscal() {
        $formato = $this->formato_timbre_fiscal();
        $ar_response = $this->comp_generic_routine('FIST');
        $formato = $this->comp_formato_generic_replace($formato, $ar_response);
        $this->contents = $this->comp_error_report('', $ar_response['record']['TRANS_CODE'], $ar_response['errormsg']) . $formato;
    }

// Method End


    /*
     * -----------------------------------------------------------
     * Comprobante de Retencion del Impuesto Sobre La Renta (ISLR)
     * -----------------------------------------------------------
     */

    function comp_islr() {
        $formato = $this->formato_islr();
        $ar_response = $this->comp_generic_routine('ISLR');
        $formato = $this->comp_formato_generic_replace($formato, $ar_response);
        $this->contents = $this->comp_error_report('', $ar_response['record']['TRANS_CODE'], $ar_response['errormsg']) . $formato;
    }

// Method End

    /*
     * -------------------------------------------------------------
     * Comprobante de Retencion del Impuesto al Valor Agregado (IVA)
     * -------------------------------------------------------------
     */

    function comp_iva() {
        $formato = $this->formato_iva();
        $ar_response = $this->comp_generic_routine('IVA');
        $formato = $this->comp_formato_generic_replace($formato, $ar_response);
        $this->contents = $this->comp_error_report('', $ar_response['record']['TRANS_CODE'], $ar_response['errormsg']) . $formato;
    }

// Method End

    function comp_moneda_extranjera() {
        //global $db;

        /*

          $idlist = getIdlist();
          $sql = "SELECT
          FITL.BASE_LINE_AMT, FIAT.DISBURSEMENT_REF_NO, FIAT.PARTICIPANT_ID, FIAT.EFFTDATE, TXTB.IDNAME CONCEPTO, FICO.COMP_CODE
          FROM
          $this->txtbname TXTB,
          $this->fitlname FITL,
          $this->fiatname FIAT LEFT JOIN $this->ficoname FICO on FIAT.CONTRACT_CODE = FICO.IDCODE
          WHERE FIAT.IDCODE = FITL.TRANS_CODE AND
          TXTB.IDCODE = FITL.TAX_CODE AND
          FITL.ID IN ('".implode(',', $idlist)."')";
          $records = ClxCommon::$db->executeQuery($sql);
          $record = ClxCommon::$db->getNextRecord($records);
		  ClxCommon::$db->freeResult($records);*/
        $this->comp = 'BAV';
        $formato = $this->formato_moneda_extranjera();
        //$accorec = ClxCommon::$db->getRecord($this->acconame, "IDCODE = '".$record['PARTICIPANT_ID']."'");
        //$aclorec = ClxCommon::$db->getRecord($this->acloname, "ACCOUNTCODE = '".$record['PARTICIPANT_ID']."'");
        $record['EFFTDATE'] = '';
        $record['CONCEPTO'] = '';
        $accorec['IDNAME'] = '';
        $accorec['IDENTIFICATION'] = '';
        $record['BASE_LINE_AMT'] = '';
        $accorec['LEGAL_TYPE'] = '';
        $accorec['ID_TYPE'] = '';
        $record['DISBURSEMENT_REF_NO'] = '';
        $aclorec['ADDRESS1'] = '';
        $aclorec['ADDRESS2'] = '';
        $aclorec['CITY'] = '';
        $aclorec['STATE'] = '';
        $aclorec['COUNTRY'] = '';
        $formato = str_replace('-COMP_LOGO-', /* $this->comp_logo() */ '', $formato);
        $formato = str_replace('-MES-', dict('UICA_LBL_MONTH_' . adodb_date('m', adodb_strtotime($record['EFFTDATE']))), $formato);
        $formato = str_replace('-ANO-', uppercase(adodb_date('Y', adodb_adodb_strtotime($record['EFFTDATE']))), $formato);
        $formato = str_replace('-CONCEPTO-', $record['CONCEPTO'], $formato);
        $formato = str_replace('-CONTRIBUYENTE-', $accorec['IDNAME'], $formato);
        //$formato = str_replace('-IDENTIFICACION-',$accorec['LEGAL_TYPE'].'-'.$accorec['IDENTIFICATION'],$formato);
        $formato = str_replace('-IDENTIFICACION-', $accorec['IDENTIFICATION'], $formato);
        $formato = str_replace('-NATURAL-', ($accorec['LEGAL_TYPE'] == 'E' || $accorec['LEGAL_TYPE'] == 'V') ? 'X' : '', $formato);
        $formato = str_replace('-JURIDICA-', ($accorec['LEGAL_TYPE'] == 'N' || $accorec['LEGAL_TYPE'] == 'J') ? 'X' : '', $formato);
        $formato = str_replace('-VENEZOLANA-', ($accorec['LEGAL_TYPE'] == 'V') ? 'X' : '', $formato);
        $formato = str_replace('-EXTRANJERA-', ($accorec['LEGAL_TYPE'] == 'E') ? 'X' : '', $formato);
        $formato = str_replace('-RIF-', ($accorec['ID_TYPE'] == 'A') ? $accorec['IDENTIFICATION'] : '', $formato);
        $formato = str_replace('-PASAPORTE-', ($accorec['ID_TYPE'] == 'P') ? $accorec['IDENTIFICATION'] : '', $formato);
        $formato = str_replace('-FACTURA-', $record['DISBURSEMENT_REF_NO'], $formato);
        $formato = str_replace('-FECHAFACTURA-', adodb_date('d/m/Y', adodb_strtotime($record['EFFTDATE'])), $formato);
        $formato = str_replace('-FECHAREGISTRO-', adodb_date('d/m/Y', adodb_strtotime($record['EFFTDATE'])), $formato);
        $formato = str_replace('-BASEIMPONIBLE-', xFormat::number($record['BASE_LINE_AMT'], 2), $formato);
        //$formato = str_replace('-MASIVA-',xFormat::number($record['BASE_LINE_AMT'],2),$formato);
        //$formato = str_replace('-MENOSTIMBRE-',xFormat::number($record['BASE_LINE_AMT'],2),$formato);
        $formato = str_replace('-MASIVA-', xFormat::number(0, 2), $formato);
        $formato = str_replace('-MENOSTIMBRE-', xFormat::number(0, 2), $formato);


        $dir = $aclorec['ADDRESS1'] . '<br>' . $aclorec['ADDRESS2'] . '<br>' . $aclorec['CITY'] . '<br>' . $aclorec['STATE'] . '<br>' . $aclorec['COUNTRY'];
        $formato = str_replace('-DIRECCION-', $dir, $formato);

        $this->contents = $formato;
    }

    function formato_iva() {
        return '<div id="div_to_print">
  <table border="0" cellspacing="0" cellpadding="0" class="form" align="width" 100%="center">
    <tr>
      <td width="364" rowspan="1" align="left" valign="top" class="title">-COMP_LOGO-</td>
      <td width="600" colspan="5" rowspan="1" align="center" valign="middle" class="title"><strong></strong></td>
    </tr>
    <tr>
      <td colspan="3" rowspan="1" valign="top" class="title" align="center"><p>&nbsp;</p>
          <p><center><strong>COMPROBANTE DE IVA </strong></center></p>
        </td>
    </tr>
    <tr>
      <td colspan="3" rowspan="1" valign="top" align="center"><table width="100%" border="1" cellpadding="2" cellspacing="0" bordercolor="#000000" class="form">
          <tr>
            <td colspan="3" rowspan="1" valign="top"><CENTER class="style11">POR MEDIO DE LA PRESENTE HACEMOS CONTAR QUE DURANTE EL MES -MES- DEL EJERCICIO FISCAL -ANO-, EL ORGANISMO LE HIZO RETENCIONES DE IMPUESTO AL VALOR AGREGADO (IVA)</CENTER>
                <span ><BR>
                </span>
                <table width="100%" border="0" cellpadding="3">
                  <tr align="center" valign="middle">
                    <td><span >      </span>
                      <table width="90%" border="0">
                        <tr>
                          <td align="center"><span ><b>No. DE COMPROBANTE</b></span></td>
                        </tr>
                        <tr>
                          <td align="center">-NOCOMPROBANTE-</td>
                        </tr>
                      </table></td>
                    <td><table width="90%" border="0">
                      <tr>
                        <td align="center"><span ><b>FECHA</b></span></td>
                      </tr>
                      <tr>
                        <td align="center"><span >-FECHAREGISTRO-</span></td>
                      </tr>
                    </table></td>
                    <td><table width="90%" border="0">
                      <tr>
                        <td align="center"><span ><b>PERIODO FISCAL</b></span></td>
                      </tr>
                      <tr>
                        <td align="center">-PERIODOFISCAL-</td>
                      </tr>
                    </table></td>
                  </tr>
                </table>
                <br>
                <table width="100%" border="0">
                  <tr>
                    <td width="50%" valign="top"><span ><b>NOMBRE O RAZON SOCIAL DEL AGENTE DE RETENCION:</b><br>
-AGENT_RET_NOMBRE- <br>
</span></td>
                    <td><span ><b>REGISTRO DE INFORMACION FISCAL DEL AGENTE DE RETENCION:</b> <br>
                    -AGENT_RET_IDENTIFICACION- <br>
                    </span></td>
                  </tr>
                </table>
            </td>
          </tr>
          <tr>
            <td colspan="3" valign="top"><b>DIRECCION FISCAL DEL AGENTE DE RETENCION:</b> <br>
  -AGENT_RET_NOMBRE_DIREC-
            <p >&nbsp;</p></td>
          </tr>
          <tr>
            <td colspan="3" valign="top"><table width="100%" border="0">
              <tr>
                <td width="50%" valign="top"><span ><b>NOMBRE O RAZON SOCIAL DEL SUJETO RETENIDO:</b><br>
      -CONTRIBUYENTE- <br>
                </span></td>
                <td><span ><b>REGISTRO DE INFORMACION FISCAL DEL SUJETO RETENIDO:</b> <br>
      -IDENTIFICACION- <br>
                </span></td>
              </tr>
            </table></td>
          </tr>
          <!--tr>
            <td colspan="3" valign="top"><span ><b>DIRECCION FISCAL DEL SUJETO RETENIDO:</b> <br>
-DIRECCION- <br>
            </span></td>
          </tr-->
          <tr>
            <td colspan="3" valign="top"><table width="100%" border="0">
              <tr align="center" valign="top">
                <td width="33%"><span ><b>FECHA DE FACTURA </b><br>
      -FECHAFACTURA- <br>
                </span></td>
                <td width="33%"><span ><b>NUMERO DE FACTURA</b><br>
      -FACTURA- <br>
                </span></td>

                <td width="33%"><span ><b>No. CONTROL DE FACTURA </b><br>
-NUMERO_CONTROL_FACTURA-<br>
                </span></td>
              </tr>
            </table></td>
          </tr>
          <tr>
            <td colspan="3" valign="top">&nbsp;</td>
          </tr>
          <tr>
            <td colspan="3" rowspan="1" valign="top" align="center"><table width="91%" border="0">
                <!--tr>
                  <td width="14%" nowrap ><strong>No. FACTURA: </strong></td>
                  <td width="18%"><span class="style10">FECHA FACTURA :</span></td>
                  <td width="23%" class="style10">FECHA DE REGISTRO </td>
                  <td width="17%" >-FECHAREGISTRO-</td>
                </tr>
                <tr>
                  <td >-FACTURA-</td>
                  <td > -FECHAFACTURA-</td>
                  <td >&nbsp;</td>
                  <td >&nbsp;</td>
                </tr-->
                <tr>
                  <!--td ><span class="style10">TARIFA(%)</span></td-->
                  <td width="50%" align="right" class="style10">TOTAL COMPRAS INCLUYENDO I.V.A </td>
                  <td align="right" >-TOTALCOMPRA-</td>
                </tr>
                <tr>
                  <td align="right" class="style10">BASE IMPONIBLE </td>
                  <td align="right" >-BASEIMPONIBLE-</td>
                </tr>
                <tr>
                  <td align="right" class="style10">%  ALICUOTA</td>
                  <td align="right" >-PORCENTAJEALICUOTA-</td>
                </tr>
                <tr>
                  <td align="right" class="style10">IMPUESTO I.V.A. </td>
                  <td align="right" >-IMPUESTOIVA-</td>
                </tr>
                <tr>
                  <td align="right" class="style10">I.V.A RETENIDO </td>
                  <td align="right" >-IVARETENIDO-</td>
                </tr>
                <tr>
                  <td align="right" class="style10">COMPRA SIN DERECHO A CREDITO I.V.A </td>
                  <td align="right" >-COMPRASINDERECHOIVA-</td>
                </tr>
            </table></td>
          </tr>
          <!--tr align="left">
            <td colspan="3" rowspan="1"><span > <strong>OBSERVACIONES:</strong><br>
                  <br>
                  <br>
                  <br>
                  <br>
            </span></td>
          </tr-->
          <tr>
            <td colspan="1" rowspan="1" valign="top" align="center"><span class="style10">ENCARGADO DE RETENCION </span></td>
            <td colspan="1" rowspan="1" valign="top" align="center"><span class="style10">RECIBI CONFORME<br>
              NOMBRE Y APELLIDO </span></td>
            <td colspan="1" rowspan="1" valign="top" align="center"><span class="style10">FIRMA</span></td>
          </tr>
          <tr>
            <td colspan="1" rowspan="1" valign="top" align="center"><p >&nbsp;</p>
               <center> <p></p>
                <p>&nbsp;</p>
                <br>-NOMBRE- -APELLIDO-<br>
                -CARGO- </center></td>
            <td colspan="1" rowspan="1" valign="top" align="center">&nbsp;</td>
            <td colspan="1" rowspan="1" valign="top" align="center">&nbsp;</td>
          </tr>
      </table></td>
    </tr>
    <tr>
      <td colspan="3" rowspan="1" valign="top" class="footer">
    </tr>
  </table>
  </div>';
    }

    function formato_timbre_fiscal() {
        return '<div id="div_to_print"><table width="846" border="0" align="center" cellpadding="0" cellspacing="1" class="form" 100%="center">
<tr><td width="364" rowspan="1" align="left" valign="top" class="title">-COMP_LOGO-</td>
  <td width="600" colspan="5" rowspan="1" align="center" valign="middle" class="title" 2=""><strong><U>TIMBRE FISCAL</U></strong></td>
</tr>
<tr><td colspan="3" rowspan="1" valign="top" class="title" align="center"><p>&nbsp;</p>
  <p><strong><center>COMPROBANTE DE RETENCION DEL TIMBRE FISCAL </center></strong></p></td>
</tr>
<tr><td colspan="3" rowspan="1" valign="top" align="center"><table width="100%" border="1" cellpadding="2" cellspacing="0" bordercolor="#000000" class="form">
<tr><td colspan="3" rowspan="1" valign="top"><CENTER >
  POR MEDIO DE LA PRESENTE HACEMOS CONSTAR QUE
							DURANTE EL MES -MES- DEL EJERCICIO FISCAL
							-ANO-, EL ORGANISMO LE HIZO RETENCIONES DE TIMBRE FISCAL
</CENTER>
    <span ><BR>
    <BR>
							<B>POR CONCEPTO DE:</B> -CONCEPTO- <BR>
							<B>AL CONTRIBUYENTE:</B> -CONTRIBUYENTE- <BR>
							<B>CEDULA DE IDENTIDAD:</B> -IDENTIFICACION- <BR>
    </span></td>

</tr>
<tr><td colspan="3" rowspan="1" valign="top" align="center"><table width="100%" border="0">
  <tr>
    <td width="25%"><strong>PERSONALIDAD</strong></td>
    <td width="25%"><strong>NACIONALIDAD</strong></td>
    <td width="25%"><strong>RIF</strong></td>
    <td width="25%"><strong>PASAPORTE</strong></td>
  </tr>
  <tr>
    <td ><strong>NATURAL:</strong>      -NATURAL-</td>
    <td ><strong>VENEZOLANA:</strong>      -VENEZOLANA-
      </td>
    <td >-RIF-</td>
    <td ><strong>N�</strong> -PASAPORTE-</td>
  </tr>
  <tr>
    <td ><strong>JURIDICA:</strong>      -JURIDICA-</td>
    <td ><strong>EXTRANJERA:</strong>      -EXTRANJERA-</td>
    <td >&nbsp;</td>
    <td >&nbsp;</td>
  </tr>
  <tr>
    <td >&nbsp;</td>
    <td >&nbsp;</td>
    <td >&nbsp;</td>
    <td >&nbsp;</td>
  </tr>
  <tr>
    <td colspan="4" ><strong>DIRECCION:<br>
    </strong> -DIRECCION-</td>
    </tr>
</table></td>
</tr>
<tr><td colspan="3" rowspan="1" valign="top" align="center"><table width="100%" border="0">
  <tr valign="top">
    <td width="28%" nowrap ><strong>N� FACTURA:
      </strong>-FACTURA-    </td>
    <td width="25%" nowrap ><strong>FECHA DE FACTURA: </strong>-FECHAFACTURA-</td>
    <td colspan="2" align="center" nowrap><strong>FECHA DE REGISTRO: </strong>-FECHAREGISTRO-<strong><br>
    </strong></td>
    </tr>
  <tr>
    <td align="left" nowrap ><strong>TARIFA(%):</strong> -PORCENTAJE-</td>
    <td align="right" >&nbsp;</td>
    <td width="25%" align="right"><strong>BASE IMPONIBLE: </strong></td>
    <td width="22%" align="right" >-BASEIMPONIBLE-</td>
    </tr>
  <tr>
    <td align="right" >&nbsp;</td>
    <td >&nbsp;</td>
    <td align="right"><strong>MAS -IVA-% I.V.A: </strong></td>
    <td align="right" >-MASIVA-</td>
    </tr>
  <tr>
    <td align="right" >&nbsp;</td>
    <td >&nbsp;</td>
    <td align="right"><strong>MENOS TIMBRE FISCAL:</strong></td>
    <td align="right" >-MENOSTIMBRE-</td>
    </tr>
</table></td>
</tr>
<tr align="left">
  <td colspan="3" rowspan="1"><span >    <strong>OBSERVACIONES:</strong><br>
    -OBSERVACIONES-
  </span></td>
</tr>
<tr>
  <td colspan="1" rowspan="1" valign="top" align="center"><strong>ENCARGADO DE LA RETENCION </strong></td>
<td colspan="1" rowspan="1" valign="top" align="center"><strong>RECIBI CONFORME<br>
  NOMBRE Y APELLIDO </strong></td>
<td colspan="1" rowspan="1" valign="top" align="center"><strong>FIRMA</strong></td>
</tr>
<tr>
  <td colspan="1" rowspan="1" valign="top" align="center"><p >&nbsp;</p>
    <p >&nbsp;</p>
    <p >&nbsp;</p>
    <strong>-NOMBRE- -APELLIDO-<br>
            -CARGO- </strong></td>
<td colspan="1" rowspan="1" valign="top" align="center">&nbsp;</td>
<td colspan="1" rowspan="1" valign="top" align="center">&nbsp;</td>
</tr>
</table>

</td>
</tr>
<tr><td colspan="3" rowspan="1" valign="top" class="footer"></tr>
</table>
</div>';
    }

    function formato_moneda_extranjera() {
        return '<style type="text/css">
<!--
.style9 {
	font-size: 9px;
	font-family: Arial, Helvetica, sans-serif;
}
.style10 {font-size: 9px}
.style14 {font-size: 10px; font-family: Arial, Helvetica, sans-serif; font-weight: bold; }
.style19 {font-size: 10; font-family: Arial, Helvetica, sans-serif; }
.style20 {font-size: 10}
.style22 {
	font-size: 12px;
	font-family: Arial, Helvetica, sans-serif;
	font-weight: bold;
}
-->
</style>
</head>
<body bgcolor="#FFFFFF">
<br>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#000000">
  <tr>
    <td colspan="25" align="left" valign="top"><span class="style9"> </span>
      <span class="title">-COMP_LOGO-</span></td>
  </tr>
  <tr>
    <td colspan="25" align="center"><span class="style22">CONFORMACI&Oacute;N DE LAS INVERSIONES EN TITULOS VALORES CON RECURSOS PROVENIENTES DE LOS FIDEICOMISOSAL CIERRE DEL MES DE 2006</span></td>
  </tr>
  <tr>
    <td colspan="21"><span class="style14">CODIGO Y NOMBRE DEL INSTITUTO:</span></td>
    <td colspan="4"><span class="style9">FECHA DE ELABORACION:</span></td>
  </tr>
  <tr>
    <td colspan="21"><span class="style14">UNIDAD QUE REPORTA:</span></td>
    <td colspan="2"><span class="style9">TELEFONO (S)0212/210-1086-90</span></td>
    <td colspan="2"><span class="style9">FAX:
    0212-210-1088</span></td>
  </tr>
  <tr align="center">
    <td><span class="style14">NOMINA DE LOS FIDEICOMITENTES</span></td>
    <td><span class="style14"> CONTRATO FECHA APERTURA </span></td>
    <td><span class="style14">VCTO.</span></td>
    <td><span class="style14">SUBCUENTA</span></td>
    <td><span class="style14">CODIGO DE IDENTIFICACI&Oacute;N DEL INSTRUMENTO</span></td>
    <td><span class="style14">SISTEMA DE  IDENTIFICACION DEL INSTRUMENTO</span></td>
    <td><span class="style14">NOMBRE DE LA EMPRESA O INSTITUTO EMISOR</span></td>
    <td><span class="style14">PAIS DE RESIDENCIA DEL EMISOR</span></td>
    <td><span class="style14">CLASE DE INSTRUMENTO</span></td>
    <td><span class="style14">CLASE MONEDA DE DENOMINACION</span></td>
    <td><span class="style14">CANTIDAD</span></td>
    <td><span class="style14">ADQUISICION</span></td>
    <td><span class="style14">F E C H AEMISION</span></td>
    <td><span class="style14">VCTO.</span></td>
    <td><span class="style14">VALOR NOMINAL</span></td>
    <td><span class="style14">COSTO DE ADQUISICI&Oacute;N</span></td>
    <td><span class="style14">VALOR DE  MERCADO</span></td>
    <td><span class="style14">PRESENTE</span></td>
    <td><span class="style14">TIPO DE CAMBIO UTILIZADO</span></td>
    <td><span class="style14">GANANCIA O P&Eacute;RDIDA NO REALIZADA</span></td>
    <td><span class="style14">COSTO AMORTIZADO</span></td>
    <td><span class="style14">VALOR TOTAL REGISTRADO EN LIBROS(EN Bs.)</span></td>
    <td><span class="style14">TASA DE INTERES UTILIZADOPARA EL CALCULO DEL VALOR PRESENTE</span></td>
    <td><span class="style14"> PORCENTAJE (%) DEPARTICIPACION EN RELACIONAL CAPITAL DE LA EMPESA</span></td>
    <td><span class="style14">PROVISION ESPECIFICA SUB CUENTA  MONTO (MILES)</span></td>
  </tr>
  <tr>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
  </tr>
  <tr>
    <td><span class="style10">&nbsp;  </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
  </tr>
  <tr>
    <td><span class="style10">&nbsp;  </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
  </tr>
  <tr>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
  </tr>
  <tr>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
  </tr>
  <tr>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
  </tr>
  <tr>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
  </tr>
  <tr>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td> <td><span class="style10">&nbsp;</span></td> <td><span class="style10">&nbsp;</span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; </span></td>
    <td><span class="style10">&nbsp; &nbsp; </span></td>
  </tr>
  <tr>
    <td><span class="style9">TOTALES</span></td>
    <td><span class="style9">&nbsp; </span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td align="right"><span class="style9">0.00</span></td>
    <td align="right"><span class="style9">0.00</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td align="right"><span class="style9">0.00</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td><span class="style9">&nbsp;</span></td>
    <td align="right"><span class="style9">0.00</span></td>
    <td align="right"><span class="style9">0.00</span></td>
    <td><span class="style9">&nbsp; </span></td>
    <td><span class="style20"><span class="style9">&nbsp; </span></span></td>
    <td><span class="style9">&nbsp;</span></td>
  </tr>
  <tr>
    <td colspan="15"><span class="style9">NOMBRE Y C.I. DEL FUNCIONARIO</span></td>
    <td colspan="7"><span class="style9">FIRMA AUTORIZADA</span></td>
    <td colspan="3"><span class="style19">(Nota: Estas Inversiones son generales para todos los Fideicomisos no hay cartera detallada)</span></td>
  </tr>
  <tr>
    <td colspan="25"><span class="style9">PMB-SBIF-008/07/1999(2)</span></td>
  </tr>
</table>
';
        // echo 'aca';
    }

    function formato_islr() {
        return '<div id="div_to_print">
  <table width="919" border="0" align="center" cellpadding="0" cellspacing="1" class="form" 100%="center">
    <tr>
      <td width="364" rowspan="1" align="left" valign="top" class="title">-COMP_LOGO-</td>
      <td width="600" colspan="5" rowspan="1" align="center" valign="middle" class="title" 2=""><strong></strong></td>
    </tr>
    <tr>
      <td colspan="3" rowspan="1" valign="top" class="title" align="center"><p>&nbsp;</p>
          <p><center><strong>COMPROBANTE DE RETENCION DEL I.S.L.R</strong></center><br>
        </p></td>
    </tr>
    <tr>
      <td colspan="3" rowspan="1" valign="top" align="center"><table width="100%" border="1" cellpadding="2" cellspacing="0" bordercolor="#000000" class="form">
          <tr>
            <td colspan="3" rowspan="1" valign="top"><CENTER class="style11">
                POR MEDIO DE LA PRESENTE HACEMOS CONSTAR QUE DURANTE EL MES -MES- DEL EJERCICIO FISCAL -ANO-, EL ORGANISMO LE HIZO RETENCIONES DE IMPUESTO SOBRE LA RENTA (I.S.L.R)
            </CENTER>
                <span ><BR>
                <BR>
                <B>POR CONCEPTO DE:</B> -CONCEPTO- <BR>
                <B>AL CONTRIBUYENTE:</B> -CONTRIBUYENTE- <BR>
                <B>CEDULA DE IDENTIDAD:</B> -IDENTIFICACION- <BR>
              </span></td>
          </tr>
          <tr>
            <td colspan="3" rowspan="1" valign="top" align="center"><table width="100%" border="0">
                <tr>
                  <td width="25%" ><strong>PERSONALIDAD</strong></td>
                  <td width="25%" ><strong>NACIONALIDAD</strong></td>
                  <td width="25%" ><strong>RIF</strong></td>
                  <td width="25%" ><strong>PASAPORTE</strong></td>
                </tr>
                <tr>
                  <td nowrap ><strong>NATURAL:</strong> -NATURAL-</td>
                  <td nowrap ><strong>VENEZOLANA:</strong> -VENEZOLANA- </td>
                  <td >-RIF-</td>
                  <td nowrap ><strong>N�</strong> -PASAPORTE-</td>
                </tr>
                <tr>
                  <td nowrap ><strong>JURIDICA:</strong> -JURIDICA-</td>
                  <td nowrap ><strong>EXTRANJERA:</strong> -EXTRANJERA-</td>
                  <td >&nbsp;</td>
                  <td >&nbsp;</td>
                </tr>
                <tr>
                  <td >&nbsp;</td>
                  <td >&nbsp;</td>
                  <td >&nbsp;</td>
                  <td >&nbsp;</td>
                </tr>
                <tr>
                  <td colspan="4" ><strong>DIRECCION:<br>
                  </strong> -DIRECCION-</td>
                </tr>
            </table></td>
          </tr>
          <tr>
            <td colspan="3" rowspan="1" valign="top" align="center"><table width="100%" border="0">
                <tr>
                  <td nowrap ><strong>No. FACTURA: </strong>-FACTURA-</td>
                  <td align="center" nowrap ><span ><strong>FECHA FACTURA:</strong> -FECHAFACTURA-</td>
                  <td colspan="2" align="center" nowrap ><strong>FECHA DE REGISTRO: </strong>-FECHAREGISTRO-</td>
                </tr>
                <tr>
                  <td nowrap ><strong>TARIFA(%): </strong>-PORCENTAJE-</td>
                  <td align="right" nowrap ><strong>TOTAL FACTURA: </strong></td>
                  <td align="right" nowrap >-TOTALFACTURA-</td>
                  <td align="right" >&nbsp;</td>
                </tr>
                <tr>
                  <td >&nbsp;</td>
                  <td align="right" ><strong>MONTO ABONADO EN CUENTA: </strong></td>
                  <td align="right" >-MONTOABONADO-</td>
                  <td align="right" >&nbsp;</td>
                </tr>
                <tr>
                  <td >&nbsp;</td>
                  <td align="right" ><strong>BASE IMPONIBLE: </strong></td>
                  <td align="right" >-BASEIMPONIBLE-</td>
                  <td align="right" >&nbsp;</td>
                </tr>
                <tr>
                  <td >&nbsp;</td>
                  <td align="right" ><strong>MONTO RETENIDO EN BOLIVARES: </strong></td>
                  <td align="right" >-MONTORETENIDO-</td>
                  <td align="right" >&nbsp;</td>
                </tr>
            </table></td>
          </tr>
          <tr align="left">
            <td colspan="3" rowspan="1"><span > <strong>OBSERVACIONES:</strong><br>
                  -OBSERVACIONES-<br>

            </span></td>
          </tr>
          <tr>
            <td colspan="1" rowspan="1" valign="top" align="center"><strong>ENCARGADO DE RETENCION </strong></td>
            <td colspan="1" rowspan="1" valign="top" align="center"><strong>RECIBI CONFORME<br>
              NOMBRE Y APELLIDO </strong></td>
            <td colspan="1" rowspan="1" valign="top" align="center"><strong>FIRMA</strong></td>
          </tr>
          <tr>
            <td colspan="1" rowspan="1" valign="top" align="center"><p >&nbsp;</p>
                <p >&nbsp;</p>
                <p >&nbsp;</p>
                <p ><center>
                  <strong>-NOMBRE- -APELLIDO-<br>
                -CARGO- </strong>
                </center></p></td>
            <td colspan="1" rowspan="1" valign="top" align="center">&nbsp;</td>
            <td colspan="1" rowspan="1" valign="top" align="center">&nbsp;</td>
          </tr>
      </table></td>
    </tr>
    <tr>
      <td colspan="3" rowspan="1" valign="top" class="footer">
    </tr>
  </table>
</div>';
    }

}

//End class

